MadGraph5_aMC@NLO (MadEvent)
arXiv:1405.0301


http://madgraph.phys.ucl.ac.be/
http://madgraph.hep.uiuc.edu/

Information on the process to be generated is found in the file
index.html in this directory, which should be viewed using your web
browser. If the file index.html is missing, you need to generate a
process. Please refer to the README file one directory above this
(MadGraph5_vx_x_x/) for instructions on how to generate a process.

This README includes information on how 
A) generate events
B) how to run in cluster/multi-core mode
C) how to launch sequential run (called multi-run)
D) How to launch Pythia/PGS/Delphes
E) How to prevent automatic opening of html pages
F) How to link to lhapdf 
G) How to run in gridpack mode

A) To generate events:
-------------------

1) Specify the model parameters. The model parameters include masses
and widths for the particles and coupling constants. They are given by
the file param_card.dat in the Cards directory. Although it is
possible to edit this file manually, this is not recommended since
there are dependencies among the parameters which need to be taken
into account. Instead the param_card.dat should be generated using one
of the Calculators found on the MG/ME homepages (stated above).  Click
Calculators, choose model and follow the instructions. Place the
resulting param_card.dat in the Cards directory.

2) Specify the run parameters. The run parameters includes collider
type and energy, choice of parton distribution functions and scales.
They are given by the file run_card.dat in the Cards directory. This
file should be edited manually, following the syntax given in the
example file.
**Warning!** For several reasons, avoid running more than 100,000
events per run. Instead perform several runs to reach the luminosity
you need, e.g. using the multi_run describe below. Subsequent runs
automatically update the random seed, so the results from different
runs are statistically independent.

3) Run bin/generate_events to generate the events and calculate the
cross-section.

4) Follow the generation and look at the results in the file
HTML/crossx.html, using your web browser.

5) If you want to run Pythia and/or PGS/Delphes on the events.
You first need to install it. For this launch MG5 ($MG5PATH/bin/mg5)
and type `install pythia-pgs`/ `install Delphes`.
If they are detected, the first question asked when launching ./bin/generate_events
should be something like:
Which programs do you want to run?
  0 / auto    : running existing card
  1 / parton  :  Madevent
  2 / pythia  : MadEvent + Pythia.
  3 / pgs     : MadEvent + Pythia + PGS.
 [0, 1, 2, 3, auto, parton, pythia, pgs][20s to answer] 
if this is not that means that you need to specify the path of the new program
in the file Cards/me5_configuration.txt . By default they are 
installed in the MG5 directory.

If you need to run one of those programs on some events which are already generated
please see instructions below.


B) Running in cluster or multicore mode:
----------------------------------------

In order to automatically run in cluster or multicore mode, please set
the flag run_mode in the Cards/me5_configuration.txt file (or in the
input/mg5_configuration.txt file before you generate your process):

# Default Running mode 
# 0: single machine/ 1: cluster / 2: multicore
run_mode = 0

You can also specify the cluster type (for cluster mode) or your
preferred number of CPUs (for multicore mode - note that by default,
the maximum number of cores is used) by setting cluster_type and
nb_core.


C) Launch sequential runs for generation of large number of events:
-------------------------------------------------------------------

For various reason, we recommend not to generate more than 100k events
per run. In order to simplify generating large numbers of events,
we have created a special command 'multi_run', which is equivalent to
running generate_events multiple times (ensuring that the random seed is
different for each run), and also automatically combines the resulting
lhe files into a single file.
This command can be launched via the madevent user interface
./bin/madevent using the following command:
multi_run NBRUN [RUN_NAME] [options]
For more information about this command (valid options), you can type
`help multi_run` inside the interface.

Note that you can also launch a command whithout entering the interactive mode:
./bin/madevent multi_run NBRUN 


D) Launching pythia/pgs/delphes on a (previously) generated sample:
-------------------------------------------------------------------

In this section, I will presupose that the corresponding package is
already installed and configured properly. (See section how to generate 
events if this is not the case)

In order to launch pythia/pgs/delphes on a sample, you need first to
launch the interactive session of madevent `./bin/madevent`
and then you can enter of the following command
pythia RUN [--run_options]
pgs RUN [--run_options]
delphes RUN [--run_options]
where RUN is the run_name of the run. One of the convenient options is
--tag=XXXX
which allow to specify the tag name in case of multiple runs with
the same program. Note that by default, a unique run tag is generated 
for each time you run.

E) How to prevent automatic opening of the crossx.html page:
------------------------------------------------------------

Edit the file ./Cards/me5_configuration.txt and set
the option automatic_html_opening to `False`.
You can also edit the MG5 configuration card
input/mg5_configuration.txt
in order to have this value on False by default for all subsequently 
generated processes.


F) How to run with a LHAPDF set
-------------------------------

1) Install lhapdf on your computer
2) If not install globally, modify the file input/mg5_configuration.txt
and specify the path to the script lhpadfconfig.
3) in the run_card use the following parameter
 'lhapdf'    = pdlabel     ! PDF set
 10042       = lhaid       ! PDF number used ONLY for LHAPDF
4) RUN as usual


G) How to run in gridpack mode
------------------------------

The gridpackage is meant to be sent over to the cluster or grid
nodes. It's completely frozen, meaning that you cannot change any
parameters or run options, apart from the # of event and the rnd
number.

Using the option " .true.  = gridpack " in the run_card.dat will generate a gridpack.tar.gz.

When you unpack it you get:
run.sh
madevent/
The first is a script which accepts two numbers (the number of events
and the rnd number).

For more information on the options please refer to 
https://cp3.irmp.ucl.ac.be/projects/madgraph/wiki/GridDevelopment

to know the technical details please read:
https://cp3.irmp.ucl.ac.be/projects/madgraph/wiki/IntroGrid

C###############################################################################
C
C Copyright (c) 2010 The ALOHA Development team and Contributors
C
C This file is a part of the MadGraph5_aMC@NLO project, an application which
C automatically generates Feynman diagrams and matrix elements for arbitrary
C high-energy processes in the Standard Model and beyond.
C
C It is subject to the ALOHA license which should accompany this
C distribution.
C
C###############################################################################
      subroutine ixxxxx(p, fmass, nhel, nsf ,fi)
c
c This subroutine computes a fermion wavefunction with the flowing-IN
c fermion number.
c
c input:
c       real    p(0:3)         : four-momentum of fermion
c       real    fmass          : mass          of fermion
c       integer nhel = -1 or 1 : helicity      of fermion
c       integer nsf  = -1 or 1 : +1 for particle, -1 for anti-particle
c
c output:
c       complex fi(6)          : fermion wavefunction               |fi>
c
      implicit none
      double complex fi(6),chi(2)
      double precision p(0:3),sf(2),sfomeg(2),omega(2),fmass,
     &     pp,pp3,sqp0p3,sqm(0:1)
      integer nhel,nsf,ip,im,nh

      double precision rZero, rHalf, rTwo
      parameter( rZero = 0.0d0, rHalf = 0.5d0, rTwo = 2.0d0 )

c#ifdef HELAS_CHECK
c      double precision p2
c      double precision epsi
c      parameter( epsi = 2.0d-5 )
c      integer stdo
c      parameter( stdo = 6 )
c#endif
c
c#ifdef HELAS_CHECK
c      pp = sqrt(p(1)**2+p(2)**2+p(3)**2)
c      if ( abs(p(0))+pp.eq.rZero ) then
c         write(stdo,*)
c     &        ' helas-error : p(0:3) in ixxxxx is zero momentum'
c      endif
c      if ( p(0).le.rZero ) then
c         write(stdo,*)
c     &        ' helas-error : p(0:3) in ixxxxx has non-positive energy'
c         write(stdo,*)
c     &        '             : p(0) = ',p(0)
c      endif
c      p2 = (p(0)-pp)*(p(0)+pp)
c      if ( abs(p2-fmass**2).gt.p(0)**2*epsi ) then
c         write(stdo,*)
c     &        ' helas-error : p(0:3) in ixxxxx has inappropriate mass'
c         write(stdo,*)
c     &        '             : p**2 = ',p2,' : fmass**2 = ',fmass**2
c      endif
c      if (abs(nhel).ne.1) then
c         write(stdo,*) ' helas-error : nhel in ixxxxx is not -1,1'
c         write(stdo,*) '             : nhel = ',nhel
c      endif
c      if (abs(nsf).ne.1) then
c         write(stdo,*) ' helas-error : nsf in ixxxxx is not -1,1'
c         write(stdo,*) '             : nsf = ',nsf
c      endif
c#endif

      fi(1) = dcmplx(p(0),p(3))*nsf*-1
      fi(2) = dcmplx(p(1),p(2))*nsf*-1

      nh = nhel*nsf

      if ( fmass.ne.rZero ) then

         pp = min(p(0),dsqrt(p(1)**2+p(2)**2+p(3)**2))

         if ( pp.eq.rZero ) then

            sqm(0) = dsqrt(abs(fmass)) ! possibility of negative fermion masses
            sqm(1) = sign(sqm(0),fmass) ! possibility of negative fermion masses
            ip = (1+nh)/2
            im = (1-nh)/2

            fi(3) = ip     * sqm(ip)
            fi(4) = im*nsf * sqm(ip)
            fi(5) = ip*nsf * sqm(im)
            fi(6) = im     * sqm(im)

         else

            sf(1) = dble(1+nsf+(1-nsf)*nh)*rHalf
            sf(2) = dble(1+nsf-(1-nsf)*nh)*rHalf
            omega(1) = dsqrt(p(0)+pp)
            omega(2) = fmass/omega(1)
            ip = (3+nh)/2
            im = (3-nh)/2
            sfomeg(1) = sf(1)*omega(ip)
            sfomeg(2) = sf(2)*omega(im)
            pp3 = max(pp+p(3),rZero)
            chi(1) = dcmplx( dsqrt(pp3*rHalf/pp) )
            if ( pp3.eq.rZero ) then
               chi(2) = dcmplx(-nh )
            else
               chi(2) = dcmplx( nh*p(1) , p(2) )/dsqrt(rTwo*pp*pp3)
            endif

            fi(3) = sfomeg(1)*chi(im)
            fi(4) = sfomeg(1)*chi(ip)
            fi(5) = sfomeg(2)*chi(im)
            fi(6) = sfomeg(2)*chi(ip)

         endif

      else

         if(p(1).eq.0d0.and.p(2).eq.0d0.and.p(3).lt.0d0) then
            sqp0p3 = 0d0
         else
            sqp0p3 = dsqrt(max(p(0)+p(3),rZero))*nsf
         end if
         chi(1) = dcmplx( sqp0p3 )
         if ( sqp0p3.eq.rZero ) then
            chi(2) = dcmplx(-nhel )*dsqrt(rTwo*p(0))
         else
            chi(2) = dcmplx( nh*p(1), p(2) )/sqp0p3
         endif
         if ( nh.eq.1 ) then
            fi(3) = dcmplx( rZero )
            fi(4) = dcmplx( rZero )
            fi(5) = chi(1)
            fi(6) = chi(2)
         else
            fi(3) = chi(2)
            fi(4) = chi(1)
            fi(5) = dcmplx( rZero )
            fi(6) = dcmplx( rZero )
         endif
      endif
c
      return
      end


      subroutine ixxxso(p, fmass, nhel, nsf ,fi)
c Identical to ixxxxx, except that fi returns only the spinor (without the momentum)
      implicit none
      double complex fi(4),chi(2)
      double precision p(0:3),sf(2),sfomeg(2),omega(2),fmass,
     &     pp,pp3,sqp0p3,sqm(0:1)
      integer nhel,nsf,ip,im,nh

      double precision rZero, rHalf, rTwo
      parameter( rZero = 0.0d0, rHalf = 0.5d0, rTwo = 2.0d0 )

c#ifdef HELAS_CHECK
c      double precision p2
c      double precision epsi
c      parameter( epsi = 2.0d-5 )
c      integer stdo
c      parameter( stdo = 6 )
c#endif
c
c#ifdef HELAS_CHECK
c      pp = sqrt(p(1)**2+p(2)**2+p(3)**2)
c      if ( abs(p(0))+pp.eq.rZero ) then
c         write(stdo,*)
c     &        ' helas-error : p(0:3) in ixxxxx is zero momentum'
c      endif
c      if ( p(0).le.rZero ) then
c         write(stdo,*)
c     &        ' helas-error : p(0:3) in ixxxxx has non-positive energy'
c         write(stdo,*)
c     &        '             : p(0) = ',p(0)
c      endif
c      p2 = (p(0)-pp)*(p(0)+pp)
c      if ( abs(p2-fmass**2).gt.p(0)**2*epsi ) then
c         write(stdo,*)
c     &        ' helas-error : p(0:3) in ixxxxx has inappropriate mass'
c         write(stdo,*)
c     &        '             : p**2 = ',p2,' : fmass**2 = ',fmass**2
c      endif
c      if (abs(nhel).ne.1) then
c         write(stdo,*) ' helas-error : nhel in ixxxxx is not -1,1'
c         write(stdo,*) '             : nhel = ',nhel
c      endif
c      if (abs(nsf).ne.1) then
c         write(stdo,*) ' helas-error : nsf in ixxxxx is not -1,1'
c         write(stdo,*) '             : nsf = ',nsf
c      endif
c#endif

c$$$      fi(1) = dcmplx(p(0),p(3))*nsf*-1
c$$$      fi(2) = dcmplx(p(1),p(2))*nsf*-1

      nh = nhel*nsf

      if ( fmass.ne.rZero ) then

         pp = min(p(0),dsqrt(p(1)**2+p(2)**2+p(3)**2))

         if ( pp.eq.rZero ) then

            sqm(0) = dsqrt(abs(fmass)) ! possibility of negative fermion masses
            sqm(1) = sign(sqm(0),fmass) ! possibility of negative fermion masses
            ip = (1+nh)/2
            im = (1-nh)/2

            fi(1) = ip     * sqm(ip)
            fi(2) = im*nsf * sqm(ip)
            fi(3) = ip*nsf * sqm(im)
            fi(4) = im     * sqm(im)

         else

            sf(1) = dble(1+nsf+(1-nsf)*nh)*rHalf
            sf(2) = dble(1+nsf-(1-nsf)*nh)*rHalf
            omega(1) = dsqrt(p(0)+pp)
            omega(2) = fmass/omega(1)
            ip = (3+nh)/2
            im = (3-nh)/2
            sfomeg(1) = sf(1)*omega(ip)
            sfomeg(2) = sf(2)*omega(im)
            pp3 = max(pp+p(3),rZero)
            chi(1) = dcmplx( dsqrt(pp3*rHalf/pp) )
            if ( pp3.eq.rZero ) then
               chi(2) = dcmplx(-nh )
            else
               chi(2) = dcmplx( nh*p(1) , p(2) )/dsqrt(rTwo*pp*pp3)
            endif

            fi(1) = sfomeg(1)*chi(im)
            fi(2) = sfomeg(1)*chi(ip)
            fi(3) = sfomeg(2)*chi(im)
            fi(4) = sfomeg(2)*chi(ip)

         endif

      else

         if(p(1).eq.0d0.and.p(2).eq.0d0.and.p(3).lt.0d0) then
            sqp0p3 = 0d0
         else
            sqp0p3 = dsqrt(max(p(0)+p(3),rZero))*nsf
         end if
         chi(1) = dcmplx( sqp0p3 )
         if ( sqp0p3.eq.rZero ) then
            chi(2) = dcmplx(-nhel )*dsqrt(rTwo*p(0))
         else
            chi(2) = dcmplx( nh*p(1), p(2) )/sqp0p3
         endif
         if ( nh.eq.1 ) then
            fi(1) = dcmplx( rZero )
            fi(2) = dcmplx( rZero )
            fi(3) = chi(1)
            fi(4) = chi(2)
         else
            fi(1) = chi(2)
            fi(2) = chi(1)
            fi(3) = dcmplx( rZero )
            fi(4) = dcmplx( rZero )
         endif
      endif
c
      return
      end


      subroutine oxxxxx(p,fmass,nhel,nsf , fo)
c
c This subroutine computes a fermion wavefunction with the flowing-OUT
c fermion number.
c
c input:
c       real    p(0:3)         : four-momentum of fermion
c       real    fmass          : mass          of fermion
c       integer nhel = -1 or 1 : helicity      of fermion
c       integer nsf  = -1 or 1 : +1 for particle, -1 for anti-particle
c
c output:
c       complex fo(6)          : fermion wavefunction               <fo|
c
      implicit none
      double complex fo(6),chi(2)
      double precision p(0:3),sf(2),sfomeg(2),omega(2),fmass,
     &     pp,pp3,sqp0p3,sqm(0:1)
      integer nhel,nsf,nh,ip,im

      double precision rZero, rHalf, rTwo
      parameter( rZero = 0.0d0, rHalf = 0.5d0, rTwo = 2.0d0 )

c#ifdef HELAS_CHECK
c      double precision p2
c      double precision epsi
c      parameter( epsi = 2.0d-5 )
c      integer stdo
c      parameter( stdo = 6 )
c#endif
c
c#ifdef HELAS_CHECK
c      pp = sqrt(p(1)**2+p(2)**2+p(3)**2)
c      if ( abs(p(0))+pp.eq.rZero ) then
c         write(stdo,*)
c     &        ' helas-error : p(0:3) in oxxxxx is zero momentum'
c      endif
c      if ( p(0).le.rZero ) then
c         write(stdo,*)
c     &        ' helas-error : p(0:3) in oxxxxx has non-positive energy'
c         write(stdo,*)
c     &        '         : p(0) = ',p(0)
c      endif
c      p2 = (p(0)-pp)*(p(0)+pp)
c      if ( abs(p2-fmass**2).gt.p(0)**2*epsi ) then
c         write(stdo,*)
c     &        ' helas-error : p(0:3) in oxxxxx has inappropriate mass'
c         write(stdo,*)
c     &        '             : p**2 = ',p2,' : fmass**2 = ',fmass**2
c      endif
c      if ( abs(nhel).ne.1 ) then
c         write(stdo,*) ' helas-error : nhel in oxxxxx is not -1,1'
c         write(stdo,*) '             : nhel = ',nhel
c      endif
c      if ( abs(nsf).ne.1 ) then
c         write(stdo,*) ' helas-error : nsf in oxxxxx is not -1,1'
c         write(stdo,*) '             : nsf = ',nsf
c      endif
c#endif

      fo(1) = dcmplx(p(0),p(3))*nsf
      fo(2) = dcmplx(p(1),p(2))*nsf

      nh = nhel*nsf

      if ( fmass.ne.rZero ) then

         pp = min(p(0),dsqrt(p(1)**2+p(2)**2+p(3)**2))

         if ( pp.eq.rZero ) then

            sqm(0) = dsqrt(abs(fmass)) ! possibility of negative fermion masses
            sqm(1) = sign(sqm(0),fmass) ! possibility of negative fermion masses
            im = nhel * (1+nh)/2
            ip = nhel * -1 * ((1-nh)/2)
            fo(3) = im     * sqm(abs(ip))
            fo(4) = ip*nsf * sqm(abs(ip))
            fo(5) = im*nsf * sqm(abs(im))
            fo(6) = ip     * sqm(abs(im))
         else

            pp = min(p(0),dsqrt(p(1)**2+p(2)**2+p(3)**2))
            sf(1) = dble(1+nsf+(1-nsf)*nh)*rHalf
            sf(2) = dble(1+nsf-(1-nsf)*nh)*rHalf
            omega(1) = dsqrt(p(0)+pp)
            omega(2) = fmass/omega(1)
            ip = (3+nh)/2
            im = (3-nh)/2
            sfomeg(1) = sf(1)*omega(ip)
            sfomeg(2) = sf(2)*omega(im)
            pp3 = max(pp+p(3),rZero)
            chi(1) = dcmplx( dsqrt(pp3*rHalf/pp) )
            if ( pp3.eq.rZero ) then
               chi(2) = dcmplx(-nh )
            else
               chi(2) = dcmplx( nh*p(1) , -p(2) )/dsqrt(rTwo*pp*pp3)
            endif

            fo(3) = sfomeg(2)*chi(im)
            fo(4) = sfomeg(2)*chi(ip)
            fo(5) = sfomeg(1)*chi(im)
            fo(6) = sfomeg(1)*chi(ip)

         endif

      else

         if(p(1).eq.0d0.and.p(2).eq.0d0.and.p(3).lt.0d0) then
            sqp0p3 = 0d0
         else
            sqp0p3 = dsqrt(max(p(0)+p(3),rZero))*nsf
         end if
         chi(1) = dcmplx( sqp0p3 )
         if ( sqp0p3.eq.rZero ) then
            chi(2) = dcmplx(-nhel )*dsqrt(rTwo*p(0))
         else
            chi(2) = dcmplx( nh*p(1), -p(2) )/sqp0p3
         endif
         if ( nh.eq.1 ) then
            fo(3) = chi(1)
            fo(4) = chi(2)
            fo(5) = dcmplx( rZero )
            fo(6) = dcmplx( rZero )
         else
            fo(3) = dcmplx( rZero )
            fo(4) = dcmplx( rZero )
            fo(5) = chi(2)
            fo(6) = chi(1)
         endif

      endif
c
      return
      end

      subroutine oxxxso(p,fmass,nhel,nsf , fo)
c Identical to oxxxxx, except that fo returns only the spinor (without the momentum)
      implicit none
      double complex fo(4),chi(2)
      double precision p(0:3),sf(2),sfomeg(2),omega(2),fmass,
     &     pp,pp3,sqp0p3,sqm(0:1)
      integer nhel,nsf,nh,ip,im

      double precision rZero, rHalf, rTwo
      parameter( rZero = 0.0d0, rHalf = 0.5d0, rTwo = 2.0d0 )

c#ifdef HELAS_CHECK
c      double precision p2
c      double precision epsi
c      parameter( epsi = 2.0d-5 )
c      integer stdo
c      parameter( stdo = 6 )
c#endif
c
c#ifdef HELAS_CHECK
c      pp = sqrt(p(1)**2+p(2)**2+p(3)**2)
c      if ( abs(p(0))+pp.eq.rZero ) then
c         write(stdo,*)
c     &        ' helas-error : p(0:3) in oxxxxx is zero momentum'
c      endif
c      if ( p(0).le.rZero ) then
c         write(stdo,*)
c     &        ' helas-error : p(0:3) in oxxxxx has non-positive energy'
c         write(stdo,*)
c     &        '         : p(0) = ',p(0)
c      endif
c      p2 = (p(0)-pp)*(p(0)+pp)
c      if ( abs(p2-fmass**2).gt.p(0)**2*epsi ) then
c         write(stdo,*)
c     &        ' helas-error : p(0:3) in oxxxxx has inappropriate mass'
c         write(stdo,*)
c     &        '             : p**2 = ',p2,' : fmass**2 = ',fmass**2
c      endif
c      if ( abs(nhel).ne.1 ) then
c         write(stdo,*) ' helas-error : nhel in oxxxxx is not -1,1'
c         write(stdo,*) '             : nhel = ',nhel
c      endif
c      if ( abs(nsf).ne.1 ) then
c         write(stdo,*) ' helas-error : nsf in oxxxxx is not -1,1'
c         write(stdo,*) '             : nsf = ',nsf
c      endif
c#endif

c$$$      fo(1) = dcmplx(p(0),p(3))*nsf
c$$$      fo(2) = dcmplx(p(1),p(2))*nsf

      nh = nhel*nsf

      if ( fmass.ne.rZero ) then

         pp = min(p(0),dsqrt(p(1)**2+p(2)**2+p(3)**2))

         if ( pp.eq.rZero ) then

            sqm(0) = dsqrt(abs(fmass)) ! possibility of negative fermion masses
            sqm(1) = sign(sqm(0),fmass) ! possibility of negative fermion masses
            ip = -((1+nh)/2)
            im =  (1-nh)/2

            fo(1) = im     * sqm(im)
            fo(2) = ip*nsf * sqm(im)
            fo(3) = im*nsf * sqm(-ip)
            fo(4) = ip     * sqm(-ip)

         else

            pp = min(p(0),dsqrt(p(1)**2+p(2)**2+p(3)**2))
            sf(1) = dble(1+nsf+(1-nsf)*nh)*rHalf
            sf(2) = dble(1+nsf-(1-nsf)*nh)*rHalf
            omega(1) = dsqrt(p(0)+pp)
            omega(2) = fmass/omega(1)
            ip = (3+nh)/2
            im = (3-nh)/2
            sfomeg(1) = sf(1)*omega(ip)
            sfomeg(2) = sf(2)*omega(im)
            pp3 = max(pp+p(3),rZero)
            chi(1) = dcmplx( dsqrt(pp3*rHalf/pp) )
            if ( pp3.eq.rZero ) then
               chi(2) = dcmplx(-nh )
            else
               chi(2) = dcmplx( nh*p(1) , -p(2) )/dsqrt(rTwo*pp*pp3)
            endif

            fo(1) = sfomeg(2)*chi(im)
            fo(2) = sfomeg(2)*chi(ip)
            fo(3) = sfomeg(1)*chi(im)
            fo(4) = sfomeg(1)*chi(ip)

         endif

      else

         if(p(1).eq.0d0.and.p(2).eq.0d0.and.p(3).lt.0d0) then
            sqp0p3 = 0d0
         else
            sqp0p3 = dsqrt(max(p(0)+p(3),rZero))*nsf
         end if
         chi(1) = dcmplx( sqp0p3 )
         if ( sqp0p3.eq.rZero ) then
            chi(2) = dcmplx(-nhel )*dsqrt(rTwo*p(0))
         else
            chi(2) = dcmplx( nh*p(1), -p(2) )/sqp0p3
         endif
         if ( nh.eq.1 ) then
            fo(1) = chi(1)
            fo(2) = chi(2)
            fo(3) = dcmplx( rZero )
            fo(4) = dcmplx( rZero )
         else
            fo(1) = dcmplx( rZero )
            fo(2) = dcmplx( rZero )
            fo(3) = chi(2)
            fo(4) = chi(1)
         endif

      endif
c
      return
      end

      subroutine pxxxxx(p,tmass,nhel,nst , tc)

c    CP3 2009.NOV

c This subroutine computes a PSEUDOR wavefunction.
c
c input:
c       real    p(0:3)         : four-momentum of tensor boson
c       real    tmass          : mass          of tensor boson
c       integer nhel           : helicity      of tensor boson
c                = -2,-1,0,1,2 : (0 is forbidden if tmass=0.0)
c       integer nst  = -1 or 1 : +1 for final, -1 for initial
c
c output:
c       complex tc(18)         : PSEUDOR  wavefunction    epsilon^mu^nu(t)
c
      implicit none
      double precision p(0:3), tmass
      integer nhel, nst
      double complex tc(18)

      double complex ft(6,4), ep(4), em(4), e0(4)
      double precision pt, pt2, pp, pzpt, emp, sqh, sqs
      integer i, j

      double precision rZero, rHalf, rOne, rTwo
      parameter( rZero = 0.0d0, rHalf = 0.5d0 )
      parameter( rOne = 1.0d0, rTwo = 2.0d0 )


      tc(3)=NHEL
      tc(1) = dcmplx(p(0),p(3))*nst
      tc(2) = dcmplx(p(1),p(2))*nst

      return
      end

      subroutine sxxxxx(p,nss , sc)
c
c This subroutine computes a complex SCALAR wavefunction.
c
c input:
c       real    p(0:3)         : four-momentum of scalar boson
c       integer nss  = -1 or 1 : +1 for final, -1 for initial
c
c output:
c       complex sc(3)          : scalar wavefunction                   s
c
      implicit none
      double complex sc(3)
      double precision p(0:3)
      integer nss

      double precision rOne
      parameter( rOne = 1.0d0 )

c#ifdef HELAS_CHECK
c      double precision p2
c      double precision epsi
c      parameter( epsi = 2.0d-5 )
c      double precision rZero
c      parameter( rZero = 0.0d0 )
c      integer stdo
c      parameter( stdo = 6 )
c#endif
c
c#ifdef HELAS_CHECK
c      if ( abs(p(0))+abs(p(1))+abs(p(2))+abs(p(3)).eq.rZero ) then
c         write(stdo,*)
c     &        ' helas-error : p(0:3) in sxxxxx is zero momentum'
c      endif
c      if ( p(0).le.rZero ) then
c         write(stdo,*)
c     &        ' helas-error : p(0:3) in sxxxxx has non-positive energy'
c         write(stdo,*)
c     &        '             : p(0) = ',p(0)
c      endif
c      p2 = p(0)**2-(p(1)**2+p(2)**2+p(3)**2)
c      if ( p2.lt.-p(0)**2*epsi ) then
c         write(stdo,*) ' helas-error : p(0:3) in sxxxxx is spacelike'
c         write(stdo,*) '             : p**2 = ',p2
c      endif
c      if ( abs(nss).ne.1 ) then
c         write(stdo,*) ' helas-error : nss in sxxxxx is not -1,1'
c         write(stdo,*) '             : nss = ',nss
c      endif
c#endif

      sc(3) = dcmplx( rOne )
      sc(1) = dcmplx(p(0),p(3))*nss
      sc(2) = dcmplx(p(1),p(2))*nss
c
      return
      end

      subroutine txxxxx(p,tmass,nhel,nst , tc)
c
c This subroutine computes a TENSOR wavefunction.
c
c input:
c       real    p(0:3)         : four-momentum of tensor boson
c       real    tmass          : mass          of tensor boson
c       integer nhel           : helicity      of tensor boson
c                = -2,-1,0,1,2 : (0 is forbidden if tmass=0.0)
c       integer nst  = -1 or 1 : +1 for final, -1 for initial
c
c output:
c       complex tc(18)         : tensor wavefunction    epsilon^mu^nu(t)
c
      implicit none
      double precision p(0:3), tmass
      integer nhel, nst
      double complex tc(18)

      double complex ft(6,4), ep(4), em(4), e0(4)
      double precision pt, pt2, pp, pzpt, emp, sqh, sqs
      integer i, j

      double precision rZero, rHalf, rOne, rTwo
      parameter( rZero = 0.0d0, rHalf = 0.5d0 )
      parameter( rOne = 1.0d0, rTwo = 2.0d0 )

      integer stdo
      parameter( stdo = 6 )

      sqh = sqrt(rHalf)
      sqs = sqrt(rHalf/3.d0)

      pt2 = p(1)**2 + p(2)**2
      pp = min(p(0),sqrt(pt2+p(3)**2))
      pt = min(pp,sqrt(pt2))

      ft(5,1) = dcmplx(p(0),p(3))*nst
      ft(6,1) = dcmplx(p(1),p(2))*nst

      if ( nhel.ge.0 ) then
c construct eps+
         if ( pp.eq.rZero ) then
            ep(1) = dcmplx( rZero )
            ep(2) = dcmplx( -sqh )
            ep(3) = dcmplx( rZero , nst*sqh )
            ep(4) = dcmplx( rZero )
         else
            ep(1) = dcmplx( rZero )
            ep(4) = dcmplx( pt/pp*sqh )
            if ( pt.ne.rZero ) then
               pzpt = p(3)/(pp*pt)*sqh
               ep(2) = dcmplx( -p(1)*pzpt , -nst*p(2)/pt*sqh )
               ep(3) = dcmplx( -p(2)*pzpt ,  nst*p(1)/pt*sqh )
            else
               ep(2) = dcmplx( -sqh )
               ep(3) = dcmplx( rZero , nst*sign(sqh,p(3)) )
            endif
         endif
      end if

      if ( nhel.le.0 ) then
c construct eps-
         if ( pp.eq.rZero ) then
            em(1) = dcmplx( rZero )
            em(2) = dcmplx( sqh )
            em(3) = dcmplx( rZero , nst*sqh )
            em(4) = dcmplx( rZero )
         else
            em(1) = dcmplx( rZero )
            em(4) = dcmplx( -pt/pp*sqh )
            if ( pt.ne.rZero ) then
               pzpt = -p(3)/(pp*pt)*sqh
               em(2) = dcmplx( -p(1)*pzpt , -nst*p(2)/pt*sqh )
               em(3) = dcmplx( -p(2)*pzpt ,  nst*p(1)/pt*sqh )
            else
               em(2) = dcmplx( sqh )
               em(3) = dcmplx( rZero , nst*sign(sqh,p(3)) )
            endif
         endif
      end if

      if ( abs(nhel).le.1 ) then
c construct eps0
         if ( pp.eq.rZero ) then
            e0(1) = dcmplx( rZero )
            e0(2) = dcmplx( rZero )
            e0(3) = dcmplx( rZero )
            e0(4) = dcmplx( rOne )
         else
            emp = p(0)/(tmass*pp)
            e0(1) = dcmplx( pp/tmass )
            e0(4) = dcmplx( p(3)*emp )
            if ( pt.ne.rZero ) then
               e0(2) = dcmplx( p(1)*emp )
               e0(3) = dcmplx( p(2)*emp )
            else
               e0(2) = dcmplx( rZero )
               e0(3) = dcmplx( rZero )
            endif
         end if
      end if

      if ( nhel.eq.2 ) then
         do j = 1,4
            do i = 1,4
               ft(i,j) = ep(i)*ep(j)
            end do
         end do
      else if ( nhel.eq.-2 ) then
         do j = 1,4
            do i = 1,4
               ft(i,j) = em(i)*em(j)
            end do
         end do
      else if (tmass.eq.0) then
         do j = 1,4
            do i = 1,4
               ft(i,j) = 0
            end do
         end do
      else if (tmass.ne.0) then
        if  ( nhel.eq.1 ) then
           do j = 1,4
              do i = 1,4
                 ft(i,j) = sqh*( ep(i)*e0(j) + e0(i)*ep(j) )
              end do
           end do
        else if ( nhel.eq.0 ) then
           do j = 1,4
              do i = 1,4
                 ft(i,j) = sqs*( ep(i)*em(j) + em(i)*ep(j)
     &                                + rTwo*e0(i)*e0(j) )
              end do
           end do
        else if ( nhel.eq.-1 ) then
           do j = 1,4
              do i = 1,4
                 ft(i,j) = sqh*( em(i)*e0(j) + e0(i)*em(j) )
              end do
           end do
        else
           write(stdo,*) 'invalid helicity in TXXXXX'
           stop
        end if
      end if

      tc(3) = ft(1,1)
      tc(4) = ft(1,2)
      tc(5) = ft(1,3)
      tc(6) = ft(1,4)
      tc(7) = ft(2,1)
      tc(8) = ft(2,2)
      tc(9) = ft(2,3)
      tc(10) = ft(2,4)
      tc(11) = ft(3,1)
      tc(12) = ft(3,2)
      tc(13) = ft(3,3)
      tc(14) = ft(3,4)
      tc(15) = ft(4,1)
      tc(16) = ft(4,2)
      tc(17) = ft(4,3)
      tc(18) = ft(4,4)
      tc(1) = ft(5,1)
      tc(2) = ft(6,1)

      return
      end


      subroutine vxxxxx(p,vmass,nhel,nsv , vc)
c
c This subroutine computes a VECTOR wavefunction.
c
c input:
c       real    p(0:3)         : four-momentum of vector boson
c       real    vmass          : mass          of vector boson
c       integer nhel = -1, 0, 1: helicity      of vector boson
c                                (0 is forbidden if vmass=0.0)
c       integer nsv  = -1 or 1 : +1 for final, -1 for initial
c
c output:
c       complex vc(6)          : vector wavefunction       epsilon^mu(v)
c
      implicit none
      double complex vc(6)
      double precision p(0:3),vmass,hel,hel0,pt,pt2,pp,pzpt,emp,sqh
      integer nhel,nsv,nsvahl

      double precision rZero, rHalf, rOne, rTwo
      parameter( rZero = 0.0d0, rHalf = 0.5d0 )
      parameter( rOne = 1.0d0, rTwo = 2.0d0 )

c#ifdef HELAS_CHECK
c      double precision p2
c      double precision epsi
c      parameter( epsi = 2.0d-5 )
c      integer stdo
c      parameter( stdo = 6 )
c#endif
c
c#ifdef HELAS_CHECK
c      pp = sqrt(p(1)**2+p(2)**2+p(3)**2)
c      if ( abs(p(0))+pp.eq.rZero ) then
c         write(stdo,*)
c     &        ' helas-error : p(0:3) in vxxxxx is zero momentum'
c      endif
c      if ( p(0).le.rZero ) then
c         write(stdo,*)
c     &        ' helas-error : p(0:3) in vxxxxx has non-positive energy'
c         write(stdo,*)
c     &        '             : p(0) = ',p(0)
c      endif
c      p2 = (p(0)+pp)*(p(0)-pp)
c      if ( abs(p2-vmass**2).gt.p(0)**2*2.e-5 ) then
c         write(stdo,*)
c     &        ' helas-error : p(0:3) in vxxxxx has inappropriate mass'
c         write(stdo,*)
c     &        '             : p**2 = ',p2,' : vmass**2 = ',vmass**2
c      endif
c      if ( vmass.ne.rZero ) then
c         if ( abs(nhel).gt.1 ) then
c            write(stdo,*) ' helas-error : nhel in vxxxxx is not -1,0,1'
c            write(stdo,*) '             : nhel = ',nhel
c         endif
c      else
c         if ( abs(nhel).ne.1 ) then
c            write(stdo,*) ' helas-error : nhel in vxxxxx is not -1,1'
c            write(stdo,*) '             : nhel = ',nhel
c         endif
c      endif
c      if ( abs(nsv).ne.1 ) then
c         write(stdo,*) ' helas-error : nsv in vmxxxx is not -1,1'
c         write(stdo,*) '             : nsv = ',nsv
c      endif
c#endif

      sqh = dsqrt(rHalf)
      hel = dble(nhel)
      nsvahl = nsv*dabs(hel)
      pt2 = p(1)**2+p(2)**2
      pp = min(p(0),dsqrt(pt2+p(3)**2))
      pt = min(pp,dsqrt(pt2))

      vc(1) = dcmplx(p(0),p(3))*nsv
      vc(2) = dcmplx(p(1),p(2))*nsv

c#ifdef HELAS_CHECK
c nhel=4 option for scalar polarization
c      if( nhel.eq.4 ) then
c         if( vmass.eq.rZero ) then
c            vc(1) = rOne
c            vc(2) = p(1)/p(0)
c            vc(3) = p(2)/p(0)
c            vc(4) = p(3)/p(0)
c         else
c            vc(1) = p(0)/vmass
c            vc(2) = p(1)/vmass
c            vc(3) = p(2)/vmass
c            vc(4) = p(3)/vmass
c         endif
c         return
c      endif
c#endif

      if ( vmass.ne.rZero ) then

         hel0 = rOne-dabs(hel)

         if ( pp.eq.rZero ) then

            vc(3) = dcmplx( rZero )
            vc(4) = dcmplx(-hel*sqh )
            vc(5) = dcmplx( rZero , nsvahl*sqh )
            vc(6) = dcmplx( hel0 )

         else

            emp = p(0)/(vmass*pp)
            vc(3) = dcmplx( hel0*pp/vmass )
            vc(6) = dcmplx( hel0*p(3)*emp+hel*pt/pp*sqh )
            if ( pt.ne.rZero ) then
               pzpt = p(3)/(pp*pt)*sqh*hel
               vc(4) = dcmplx( hel0*p(1)*emp-p(1)*pzpt ,
     &                         -nsvahl*p(2)/pt*sqh       )
               vc(5) = dcmplx( hel0*p(2)*emp-p(2)*pzpt ,
     &                          nsvahl*p(1)/pt*sqh       )
            else
               vc(4) = dcmplx( -hel*sqh )
               vc(5) = dcmplx( rZero , nsvahl*sign(sqh,p(3)) )
            endif

         endif

      else

         pp = p(0)
         pt = sqrt(p(1)**2+p(2)**2)
         vc(3) = dcmplx( rZero )
         vc(6) = dcmplx( hel*pt/pp*sqh )
         if ( pt.ne.rZero ) then
            pzpt = p(3)/(pp*pt)*sqh*hel
            vc(4) = dcmplx( -p(1)*pzpt , -nsv*p(2)/pt*sqh )
            vc(5) = dcmplx( -p(2)*pzpt ,  nsv*p(1)/pt*sqh )
         else
            vc(4) = dcmplx( -hel*sqh )
            vc(5) = dcmplx( rZero , nsv*sign(sqh,p(3)) )
         endif

      endif
c
      return
      end

      subroutine boostx(p,q , pboost)
c
c This subroutine performs the Lorentz boost of a four-momentum.  The
c momentum p is assumed to be given in the rest frame of q.  pboost is
c the momentum p boosted to the frame in which q is given.  q must be a
c timelike momentum.
c
c input:
c       real    p(0:3)         : four-momentum p in the q rest  frame
c       real    q(0:3)         : four-momentum q in the boosted frame
c
c output:
c       real    pboost(0:3)    : four-momentum p in the boosted frame
c
      implicit none
      double precision p(0:3),q(0:3),pboost(0:3),pq,qq,m,lf

      double precision rZero
      parameter( rZero = 0.0d0 )

c#ifdef HELAS_CHECK
c      integer stdo
c      parameter( stdo = 6 )
c      double precision pp
c#endif
c
      qq = q(1)**2+q(2)**2+q(3)**2

c#ifdef HELAS_CHECK
c      if (abs(p(0))+abs(p(1))+abs(p(2))+abs(p(3)).eq.rZero) then
c         write(stdo,*)
c     &        ' helas-error : p(0:3) in boostx is zero momentum'
c      endif
c      if (abs(q(0))+qq.eq.rZero) then
c         write(stdo,*)
c     &        ' helas-error : q(0:3) in boostx is zero momentum'
c      endif
c      if (p(0).le.rZero) then
c         write(stdo,*)
c     &        ' helas-warn  : p(0:3) in boostx has not positive energy'
c         write(stdo,*)
c     &        '             : p(0) = ',p(0)
c      endif
c      if (q(0).le.rZero) then
c         write(stdo,*)
c     &        ' helas-error : q(0:3) in boostx has not positive energy'
c         write(stdo,*)
c     &        '             : q(0) = ',q(0)
c      endif
c      pp=p(0)**2-p(1)**2-p(2)**2-p(3)**2
c      if (pp.lt.rZero) then
c         write(stdo,*)
c     &        ' helas-warn  : p(0:3) in boostx is spacelike'
c         write(stdo,*)
c     &        '             : p**2 = ',pp
c      endif
c      if (q(0)**2-qq.le.rZero) then
c         write(stdo,*)
c     &        ' helas-error : q(0:3) in boostx is not timelike'
c         write(stdo,*)
c     &        '             : q**2 = ',q(0)**2-qq
c      endif
c      if (qq.eq.rZero) then
c         write(stdo,*)
c     &   ' helas-warn  : q(0:3) in boostx has zero spacial components'
c      endif
c#endif

      if ( qq.ne.rZero ) then
         pq = p(1)*q(1)+p(2)*q(2)+p(3)*q(3)
         m = sqrt(max(q(0)**2-qq,1d-99))
         lf = ((q(0)-m)*pq/qq+p(0))/m
         pboost(0) = (p(0)*q(0)+pq)/m
         pboost(1) =  p(1)+q(1)*lf
         pboost(2) =  p(2)+q(2)*lf
         pboost(3) =  p(3)+q(3)*lf
      else
         pboost(0) = p(0)
         pboost(1) = p(1)
         pboost(2) = p(2)
         pboost(3) = p(3)
      endif
c
      return
      end

      subroutine boostm(p,q,m, pboost)
c
c This subroutine performs the Lorentz boost of a four-momentum.  The
c momentum p is assumed to be given in the rest frame of q.  pboost is
c the momentum p boosted to the frame in which q is given.  q must be a
c timelike momentum.
c
c input:
c       real    p(0:3)         : four-momentum p in the q rest  frame
c       real    q(0:3)         : four-momentum q in the boosted frame
c       real    m        : mass of q (for numerical stability)
c
c output:
c       real    pboost(0:3)    : four-momentum p in the boosted frame
c
      implicit none
      double precision p(0:3),q(0:3),pboost(0:3),pq,qq,m,lf

      double precision rZero
      parameter( rZero = 0.0d0 )

c#ifdef HELAS_CHECK
c      integer stdo
c      parameter( stdo = 6 )
c      double precision pp
c#endif
c
      qq = q(1)**2+q(2)**2+q(3)**2

c#ifdef HELAS_CHECK
c      if (abs(p(0))+abs(p(1))+abs(p(2))+abs(p(3)).eq.rZero) then
c         write(stdo,*)
c     &        ' helas-error : p(0:3) in boostx is zero momentum'
c      endif
c      if (abs(q(0))+qq.eq.rZero) then
c         write(stdo,*)
c     &        ' helas-error : q(0:3) in boostx is zero momentum'
c      endif
c      if (p(0).le.rZero) then
c         write(stdo,*)
c     &        ' helas-warn  : p(0:3) in boostx has not positive energy'
c         write(stdo,*)
c     &        '             : p(0) = ',p(0)
c      endif
c      if (q(0).le.rZero) then
c         write(stdo,*)
c     &        ' helas-error : q(0:3) in boostx has not positive energy'
c         write(stdo,*)
c     &        '             : q(0) = ',q(0)
c      endif
c      pp=p(0)**2-p(1)**2-p(2)**2-p(3)**2
c      if (pp.lt.rZero) then
c         write(stdo,*)
c     &        ' helas-warn  : p(0:3) in boostx is spacelike'
c         write(stdo,*)
c     &        '             : p**2 = ',pp
c      endif
c      if (q(0)**2-qq.le.rZero) then
c         write(stdo,*)
c     &        ' helas-error : q(0:3) in boostx is not timelike'
c         write(stdo,*)
c     &        '             : q**2 = ',q(0)**2-qq
c      endif
c      if (qq.eq.rZero) then
c         write(stdo,*)
c     &   ' helas-warn  : q(0:3) in boostx has zero spacial components'
c      endif
c#endif

      if ( qq.ne.rZero ) then
         pq = p(1)*q(1)+p(2)*q(2)+p(3)*q(3)
         lf = ((q(0)-m)*pq/qq+p(0))/m
         pboost(0) = (p(0)*q(0)+pq)/m
         pboost(1) =  p(1)+q(1)*lf
         pboost(2) =  p(2)+q(2)*lf
         pboost(3) =  p(3)+q(3)*lf
      else
         pboost(0) = p(0)
         pboost(1) = p(1)
         pboost(2) = p(2)
         pboost(3) = p(3)
      endif
c
      return
      end

      subroutine momntx(energy,mass,costh,phi , p)
c
c This subroutine sets up a four-momentum from the four inputs.
c
c input:
c       real    energy         : energy
c       real    mass           : mass
c       real    costh          : cos(theta)
c       real    phi            : azimuthal angle
c
c output:
c       real    p(0:3)         : four-momentum
c
      implicit none
      double precision p(0:3),energy,mass,costh,phi,pp,sinth

      double precision rZero, rOne
      parameter( rZero = 0.0d0, rOne = 1.0d0 )

c#ifdef HELAS_CHECK
c      double precision rPi, rTwo
c      parameter( rPi = 3.14159265358979323846d0, rTwo = 2.d0 )
c      integer stdo
c      parameter( stdo = 6 )
c#endif
c
c#ifdef HELAS_CHECK
c      if (energy.lt.mass) then
c         write(stdo,*)
c     &        ' helas-error : energy in momntx is less than mass'
c         write(stdo,*)
c     &        '             : energy = ',energy,' : mass = ',mass
c      endif
c      if (mass.lt.rZero) then
c         write(stdo,*) ' helas-error : mass in momntx is negative'
c         write(stdo,*) '             : mass = ',mass
c      endif
c      if (abs(costh).gt.rOne) then
c         write(stdo,*) ' helas-error : costh in momntx is improper'
c         write(stdo,*) '             : costh = ',costh
c      endif
c      if (phi.lt.rZero .or. phi.gt.rTwo*rPi) then
c         write(stdo,*)
c     &   ' helas-warn  : phi in momntx does not lie on 0.0 thru 2.0*pi'
c         write(stdo,*)
c     &   '             : phi = ',phi
c      endif
c#endif

      p(0) = energy

      if ( energy.eq.mass ) then

         p(1) = rZero
         p(2) = rZero
         p(3) = rZero

      else

         pp = sqrt((energy-mass)*(energy+mass))
         sinth = sqrt((rOne-costh)*(rOne+costh))
         p(3) = pp*costh
         if ( phi.eq.rZero ) then
            p(1) = pp*sinth
            p(2) = rZero
         else
            p(1) = pp*sinth*cos(phi)
            p(2) = pp*sinth*sin(phi)
         endif

      endif
c
      return
      end
      subroutine rotxxx(p,q , prot)
c
c This subroutine performs the spacial rotation of a four-momentum.
c the momentum p is assumed to be given in the frame where the spacial
c component of q points the positive z-axis.  prot is the momentum p
c rotated to the frame where q is given.
c
c input:
c       real    p(0:3)         : four-momentum p in q(1)=q(2)=0 frame
c       real    q(0:3)         : four-momentum q in the rotated frame
c
c output:
c       real    prot(0:3)      : four-momentum p in the rotated frame
c
      implicit none
      double precision p(0:3),q(0:3),prot(0:3),qt2,qt,psgn,qq,p1

      double precision rZero, rOne
      parameter( rZero = 0.0d0, rOne = 1.0d0 )

c#ifdef HELAS_CHECK
c      integer stdo
c      parameter( stdo = 6 )
c#endif
c
      prot(0) = p(0)

      qt2 = q(1)**2 + q(2)**2

c#ifdef HELAS_CHECK
c      if (abs(p(0))+abs(p(1))+abs(p(2))+abs(p(3)).eq.rZero) then
c         write(stdo,*)
c     &        ' helas-error : p(0:3) in rotxxx is zero momentum'
c      endif
c      if (abs(q(0))+abs(q(3))+qt2.eq.rZero) then
c         write(stdo,*)
c     &        ' helas-error : q(0:3) in rotxxx is zero momentum'
c      endif
c      if (qt2+abs(q(3)).eq.rZero) then
c         write(stdo,*)
c     &   ' helas-warn  : q(0:3) in rotxxx has zero spacial momentum'
c      endif
c#endif

      if ( qt2.eq.rZero ) then
          if ( q(3).eq.rZero ) then
             prot(1) = p(1)
             prot(2) = p(2)
             prot(3) = p(3)
          else
             psgn = dsign(rOne,q(3))
             prot(1) = p(1)*psgn
             prot(2) = p(2)*psgn
             prot(3) = p(3)*psgn
          endif
      else
          qq = sqrt(qt2+q(3)**2)
          qt = sqrt(qt2)
          p1 = p(1)
          prot(1) = q(1)*q(3)/qq/qt*p1 -q(2)/qt*p(2) +q(1)/qq*p(3)
          prot(2) = q(2)*q(3)/qq/qt*p1 +q(1)/qt*p(2) +q(2)/qq*p(3)
          prot(3) =          -qt/qq*p1               +q(3)/qq*p(3)
      endif
c
      return
      end

      subroutine mom2cx(esum,mass1,mass2,costh1,phi1 , p1,p2)
c
c This subroutine sets up two four-momenta in the two particle rest
c frame.
c
c input:
c       real    esum           : energy sum of particle 1 and 2
c       real    mass1          : mass            of particle 1
c       real    mass2          : mass            of particle 2
c       real    costh1         : cos(theta)      of particle 1
c       real    phi1           : azimuthal angle of particle 1
c
c output:
c       real    p1(0:3)        : four-momentum of particle 1
c       real    p2(0:3)        : four-momentum of particle 2
c     
      implicit none
      double precision p1(0:3),p2(0:3),
     &     esum,mass1,mass2,costh1,phi1,md2,ed,pp,sinth1

      double precision rZero, rHalf, rOne, rTwo
      parameter( rZero = 0.0d0, rHalf = 0.5d0 )
      parameter( rOne = 1.0d0, rTwo = 2.0d0 )

c#ifdef HELAS_CHECK
c      double precision rPi
c      parameter( rPi = 3.14159265358979323846d0 )
c      integer stdo
c      parameter( stdo = 6 )
c#endif
cc
c#ifdef HELAS_CHECK
c      if (esum.lt.mass1+mass2) then
c         write(stdo,*)
c     &        ' helas-error : esum in mom2cx is less than mass1+mass2'
c         write(stdo,*)
c     &        '             : esum = ',esum,
c     &        ' : mass1+mass2 = ',mass1,mass2
c      endif
c      if (mass1.lt.rZero) then
c         write(stdo,*) ' helas-error : mass1 in mom2cx is negative'
c         write(stdo,*) '             : mass1 = ',mass1
c      endif
c      if (mass2.lt.rZero) then
c         write(stdo,*) ' helas-error : mass2 in mom2cx is negative'
c         write(stdo,*) '             : mass2 = ',mass2
c      endif
c      if (abs(costh1).gt.1.) then
c         write(stdo,*) ' helas-error : costh1 in mom2cx is improper'
c         write(stdo,*) '             : costh1 = ',costh1
c      endif
c      if (phi1.lt.rZero .or. phi1.gt.rTwo*rPi) then
c         write(stdo,*)
c     &   ' helas-warn  : phi1 in mom2cx does not lie on 0.0 thru 2.0*pi'
c         write(stdo,*) 
c     &   '             : phi1 = ',phi1
c      endif
c#endif

      md2 = (mass1-mass2)*(mass1+mass2)
      ed = md2/esum
      if ( mass1*mass2.eq.rZero ) then
         pp = (esum-abs(ed))*rHalf
      else
         pp = sqrt(max((md2/esum)**2-rTwo*(mass1**2+mass2**2)+esum**2,1d-99))*rHalf
      endif
      sinth1 = sqrt((rOne-costh1)*(rOne+costh1))

      p1(0) = max((esum+ed)*rHalf,rZero)
      p1(1) = pp*sinth1*cos(phi1)
      p1(2) = pp*sinth1*sin(phi1)
      p1(3) = pp*costh1

      p2(0) = max((esum-ed)*rHalf,rZero)
      p2(1) = -p1(1)
      p2(2) = -p1(2)
      p2(3) = -p1(3)
c
      return
      end
      subroutine irxxxx(p,rmass,nhel,nsr , ri)
c
c This subroutine computes a Rarita-Schwinger wavefunction of spin-3/2
c fermion with the flowing-IN fermion number.
c
c input:
c       real    p(0:3)           : four-momentum of RS fermion
c       real    rmass            : mass          of RS fermion
c       integer nhel = -3,-1,1,3 : helicity      of RS fermion
c                                  (1- and 1 is forbidden if rmass = 0)
c       integer nsr  = -1 or 1   : +1 for particle, -1 for anti-particle
c
c output:
c       complex ri(18)           : RS fermion wavefunction         |ri>v   
c     
c- by K.Mawatari - 2008/02/26
c
      implicit none
      double precision p(0:3),rmass
      integer nhel,nsr
      double complex ri(18)

      double complex rc(6,4),ep(4),em(4),e0(4),fip(4),fim(4),chi(2)
      double precision pp,pt2,pt,pzpt,emp, sf(2),sfomeg(2),omega(2),pp3,
     &                 sqp0p3,sqm      
      integer i,j,nsv,ip,im,nh

      double precision rZero, rHalf, rOne, rTwo, rThree, sqh,sq2,sq3
      parameter( rZero = 0.0d0, rHalf = 0.5d0 )
      parameter( rOne = 1.0d0, rTwo = 2.0d0, rThree = 3.0d0 )

c#ifdef HELAS_CHECK
c      double precision p2
c      double precision epsi
c      parameter( epsi = 2.0d-5 )
c      integer stdo
c      parameter( stdo = 6 )
c#endif
c
c#ifdef HELAS_CHECK
c      pp = sqrt(p(1)**2+p(2)**2+p(3)**2)
c      if ( abs(p(0))+pp.eq.rZero ) then
c         write(stdo,*)
c     &        ' helas-error : p(0:3) in irxxxx is zero momentum'
c      endif
c      if ( p(0).le.rZero ) then
c         write(stdo,*)
c     &        ' helas-error : p(0:3) in irxxxx has non-positive energy'
c         write(stdo,*)
c     &        '             : p(0) = ',p(0)
c      endif
c      p2 = (p(0)-pp)*(p(0)+pp)
c      if ( abs(p2-rmass**2).gt.p(0)**2*epsi ) then
c         write(stdo,*)
c     &        ' helas-error : p(0:3) in irxxxx has inappropriate mass'
c         write(stdo,*)
c     &        '             : p**2 = ',p2,' : rmass**2 = ',rmass**2
c      endif
c      if (abs(nhel).gt.3 .or. abs(nhel).eq.2 .or. abs(nhel).eq.0 ) then
c         write(stdo,*) ' helas-error : nhel in irxxxx is not -3,-1,1,3'
c         write(stdo,*) '             : nhel = ',nhel
c      endif
c      if (abs(nsr).ne.1) then
c         write(stdo,*) ' helas-error : nsr in irxxxx is not -1,1'
c         write(stdo,*) '             : nsr = ',nsr
c      endif
c#endif

      sqh = sqrt(rHalf)
      sq2 = sqrt(rTwo)
      sq3 = sqrt(rThree)

      pt2 = p(1)**2 + p(2)**2
      pp = min(p(0),sqrt(pt2+p(3)**2))
      pt = min(pp,sqrt(pt2))

      rc(5,1) = -1*dcmplx(p(0),p(3))*nsr
      rc(6,1) = -1*dcmplx(p(1),p(2))*nsr

      nsv = -nsr ! nsv=+1 for final, -1 for initial

      if ( nhel.ge.1 ) then 
c construct eps+
         if ( pp.eq.rZero ) then
            ep(1) = dcmplx( rZero )
            ep(2) = dcmplx( -sqh )
            ep(3) = dcmplx( rZero , nsv*sqh )
            ep(4) = dcmplx( rZero )
         else
            ep(1) = dcmplx( rZero )
            ep(4) = dcmplx( pt/pp*sqh )
            if ( pt.ne.rZero ) then
               pzpt = p(3)/(pp*pt)*sqh
               ep(2) = dcmplx( -p(1)*pzpt , -nsv*p(2)/pt*sqh )
               ep(3) = dcmplx( -p(2)*pzpt ,  nsv*p(1)/pt*sqh )
            else
               ep(2) = dcmplx( -sqh )
               ep(3) = dcmplx( rZero , nsv*sign(sqh,p(3)) )
            endif
         endif
      end if

      if ( nhel.le.-1 ) then 
c construct eps-
         if ( pp.eq.rZero ) then
            em(1) = dcmplx( rZero )
            em(2) = dcmplx( sqh )
            em(3) = dcmplx( rZero , nsv*sqh )
            em(4) = dcmplx( rZero )
         else
            em(1) = dcmplx( rZero )
            em(4) = dcmplx( -pt/pp*sqh )
            if ( pt.ne.rZero ) then
               pzpt = -p(3)/(pp*pt)*sqh
               em(2) = dcmplx( -p(1)*pzpt , -nsv*p(2)/pt*sqh )
               em(3) = dcmplx( -p(2)*pzpt ,  nsv*p(1)/pt*sqh )
            else
               em(2) = dcmplx( sqh )
               em(3) = dcmplx( rZero , nsv*sign(sqh,p(3)) )
            endif
         endif
      end if

      if ( abs(nhel).le.1 ) then  
c construct eps0
         if ( pp.eq.rZero ) then
            e0(1) = dcmplx( rZero )
            e0(2) = dcmplx( rZero )
            e0(3) = dcmplx( rZero )
            e0(4) = dcmplx( rOne )
         else
            emp = p(0)/(rmass*pp)
            e0(1) = dcmplx( pp/rmass )
            e0(4) = dcmplx( p(3)*emp )
            if ( pt.ne.rZero ) then
               e0(2) = dcmplx( p(1)*emp )
               e0(3) = dcmplx( p(2)*emp )
            else
               e0(2) = dcmplx( rZero )
               e0(3) = dcmplx( rZero )
            endif
         end if
      end if

      if ( nhel.ge.-1 ) then
c constract spinor+ 
       nh = nsr
       if ( rmass.ne.rZero ) then
         pp = min(p(0),dsqrt(p(1)**2+p(2)**2+p(3)**2))
         if ( pp.eq.rZero ) then
            sqm = dsqrt(rmass)
            ip = (1+nh)/2
            im = (1-nh)/2
              fip(1) = ip     * sqm
              fip(2) = im*nsr * sqm
              fip(3) = ip*nsr * sqm
              fip(4) = im     * sqm
         else
            sf(1) = dble(1+nsr+(1-nsr)*nh)*rHalf
            sf(2) = dble(1+nsr-(1-nsr)*nh)*rHalf
            omega(1) = dsqrt(p(0)+pp)
            omega(2) = rmass/omega(1)
            ip = (3+nh)/2
            im = (3-nh)/2
            sfomeg(1) = sf(1)*omega(ip)
            sfomeg(2) = sf(2)*omega(im)
            pp3 = max(pp+p(3),rZero)
            chi(1) = dcmplx( dsqrt(pp3*rHalf/pp) )
            if ( pp3.eq.rZero ) then
               chi(2) = dcmplx(-nh )
            else
               chi(2) = dcmplx( nh*p(1) , p(2) )/dsqrt(rTwo*pp*pp3)
            endif
              fip(1) = sfomeg(1)*chi(im)
              fip(2) = sfomeg(1)*chi(ip)
              fip(3) = sfomeg(2)*chi(im)
              fip(4) = sfomeg(2)*chi(ip)
         endif
       else
         sqp0p3 = dsqrt(max(p(0)+p(3),rZero))*nsr
         chi(1) = dcmplx( sqp0p3 )
         if ( sqp0p3.eq.rZero ) then
            chi(2) = dcmplx(-nhel )*dsqrt(rTwo*p(0))
         else
            chi(2) = dcmplx( nh*p(1), p(2) )/sqp0p3
         endif
         if ( nh.eq.1 ) then
            fip(1) = dcmplx( rZero )
            fip(2) = dcmplx( rZero )
            fip(3) = chi(1)
            fip(4) = chi(2)
         else
            fip(1) = chi(2)
            fip(2) = chi(1)
            fip(3) = dcmplx( rZero )
            fip(4) = dcmplx( rZero )
         endif
       endif
      end if

      if ( nhel.le.1 ) then
c constract spinor-
       nh = -nsr
       if ( rmass.ne.rZero ) then
         pp = min(p(0),dsqrt(p(1)**2+p(2)**2+p(3)**2))
         if ( pp.eq.rZero ) then
            sqm = dsqrt(rmass)
            ip = (1+nh)/2
            im = (1-nh)/2
              fim(1) = ip     * sqm
              fim(2) = im*nsr * sqm
              fim(3) = ip*nsr * sqm
              fim(4) = im     * sqm
         else
            sf(1) = dble(1+nsr+(1-nsr)*nh)*rHalf
            sf(2) = dble(1+nsr-(1-nsr)*nh)*rHalf
            omega(1) = dsqrt(p(0)+pp)
            omega(2) = rmass/omega(1)
            ip = (3+nh)/2
            im = (3-nh)/2
            sfomeg(1) = sf(1)*omega(ip)
            sfomeg(2) = sf(2)*omega(im)
            pp3 = max(pp+p(3),rZero)
            chi(1) = dcmplx( dsqrt(pp3*rHalf/pp) )
            if ( pp3.eq.rZero ) then
               chi(2) = dcmplx(-nh )
            else
               chi(2) = dcmplx( nh*p(1) , p(2) )/dsqrt(rTwo*pp*pp3)
            endif
              fim(1) = sfomeg(1)*chi(im)
              fim(2) = sfomeg(1)*chi(ip)
              fim(3) = sfomeg(2)*chi(im)
              fim(4) = sfomeg(2)*chi(ip)
         endif
       else
         sqp0p3 = dsqrt(max(p(0)+p(3),rZero))*nsr
         chi(1) = dcmplx( sqp0p3 )
         if ( sqp0p3.eq.rZero ) then
            chi(2) = dcmplx(-nhel )*dsqrt(rTwo*p(0))
         else
            chi(2) = dcmplx( nh*p(1), p(2) )/sqp0p3
         endif
         if ( nh.eq.1 ) then
            fim(1) = dcmplx( rZero )
            fim(2) = dcmplx( rZero )
            fim(3) = chi(1)
            fim(4) = chi(2)
         else
            fim(1) = chi(2)
            fim(2) = chi(1)
            fim(3) = dcmplx( rZero )
            fim(4) = dcmplx( rZero )
         endif
       endif
      end if

c spin-3/2 fermion wavefunction
      if ( nhel.eq.3 ) then
         do j = 1,4
            do i = 1,4
               rc(i,j) = ep(i)*fip(j)
            end do
         end do
      else if ( nhel.eq.1 ) then
         do j = 1,4
            do i = 1,4
              if     ( pt.eq.rZero .and. p(3).ge.0d0 ) then 
               rc(i,j) =  sq2/sq3*e0(i)*fip(j) +rOne/sq3*ep(i)*fim(j)
              elseif ( pt.eq.rZero .and. p(3).lt.0d0 ) then 
               rc(i,j) =  sq2/sq3*e0(i)*fip(j) -rOne/sq3*ep(i)*fim(j)
              else
               rc(i,j) =  sq2/sq3*e0(i)*fip(j) 
     &                  +rOne/sq3*ep(i)*fim(j) *dcmplx(P(1),nsr*P(2))/pt  
              endif
            end do
         end do
      else if ( nhel.eq.-1 ) then
         do j = 1,4
            do i = 1,4
              if     ( pt.eq.rZero .and.p(3).ge.0d0 ) then 
               rc(i,j) = rOne/sq3*em(i)*fip(j) +sq2/sq3*e0(i)*fim(j)
              elseif ( pt.eq.rZero .and.p(3).lt.0d0 ) then 
               rc(i,j) = rOne/sq3*em(i)*fip(j) -sq2/sq3*e0(i)*fim(j)
              else
               rc(i,j) = rOne/sq3*em(i)*fip(j) 
     &                  + sq2/sq3*e0(i)*fim(j) *dcmplx(P(1),nsr*P(2))/pt  
              endif
            end do
         end do
      else
         do j = 1,4
            do i = 1,4
              if     ( pt.eq.rZero .and. p(3).ge.0d0 ) then 
               rc(i,j) =  em(i)*fim(j)
              elseif ( pt.eq.rZero .and. p(3).lt.0d0 ) then 
               rc(i,j) = -em(i)*fim(j)
              else
               rc(i,j) =  em(i)*fim(j) *dcmplx(P(1),nsr*P(2))/pt  
              endif
            end do
         end do
      end if

      ri(3) = rc(1,1)
      ri(4) = rc(1,2)
      ri(5) = rc(1,3)
      ri(6) = rc(1,4)
      ri(7) = rc(2,1)
      ri(8) = rc(2,2)
      ri(9) = rc(2,3)
      ri(10) = rc(2,4)
      ri(11) = rc(3,1)
      ri(12) = rc(3,2)
      ri(13) = rc(3,3)
      ri(14) = rc(3,4)
      ri(15) = rc(4,1)
      ri(16) = rc(4,2)
      ri(17) = rc(4,3)
      ri(18) = rc(4,4)
      ri(1) = rc(5,1)
      ri(2) = rc(6,1)

      return
      end
      subroutine orxxxx(p,rmass,nhel,nsr , ro)
c
c This subroutine computes a Rarita-Schwinger wavefunction of spin-3/2
c fermion with the flowing-IN fermion number.
c
c input:
c       real    p(0:3)           : four-momentum of RS fermion
c       real    rmass            : mass          of RS fermion
c       integer nhel = -3,-1,1,3 : helicity      of RS fermion
c                                  (1- and 1 is forbidden if rmass = 0)
c       integer nsr  = -1 or 1   : +1 for particle, -1 for anti-particle
c
c output:
c       complex ro(18)           : RS fermion wavefunction         |ro>v   
c     
c- by Y.Takaesu - 2011/01/11
c
      implicit none
      double precision p(0:3),rmass
      integer nhel,nsr
      double complex ro(18),fipp(4),fimm(4)

      double complex rc(6,4),ep(4),em(4),e0(4),fop(4),fom(4),chi(2)
      double precision pp,pt2,pt,pzpt,emp, sf(2),sfomeg(2),omega(2),pp3,
     &                 sqp0p3,sqm(0:1)      
      integer i,j,nsv,ip,im,nh

      double precision rZero, rHalf, rOne, rTwo, rThree, sqh,sq2,sq3
      parameter( rZero = 0.0d0, rHalf = 0.5d0 )
      parameter( rOne = 1.0d0, rTwo = 2.0d0, rThree = 3.0d0 )

c#ifdef HELAS_CHECK
c      double precision p2
c      double precision epsi
c      parameter( epsi = 2.0d-5 )
c      integer stdo
c      parameter( stdo = 6 )
c#endif
c
c#ifdef HELAS_CHECK
c      pp = sqrt(p(1)**2+p(2)**2+p(3)**2)
c      if ( abs(p(0))+pp.eq.rZero ) then
c         write(stdo,*)
c     &        ' helas-error : p(0:3) in orxxxx is zero momentum'
c      endif
c      if ( p(0).le.rZero ) then
c         write(stdo,*)
c     &        ' helas-error : p(0:3) in orxxxx has non-positive energy'
c         write(stdo,*)
c     &        '             : p(0) = ',p(0)
c      endif
c      p2 = (p(0)-pp)*(p(0)+pp)
c      if ( abs(p2-rmass**2).gt.p(0)**2*epsi ) then
c         write(stdo,*)
c     &        ' helas-error : p(0:3) in orxxxx has inappropriate mass'
c         write(stdo,*)
c     &        '             : p**2 = ',p2,' : rmass**2 = ',rmass**2
c      endif
c      if (abs(nhel).gt.3 .or. abs(nhel).eq.2 .or. abs(nhel).eq.0 ) then
c         write(stdo,*) ' helas-error : nhel in orxxxx is not -3,-1,1,3'
c         write(stdo,*) '             : nhel = ',nhel
c      endif
c      if (abs(nsr).ne.1) then
c         write(stdo,*) ' helas-error : nsr in orxxxx is not -1,1'
c         write(stdo,*) '             : nsr = ',nsr
c      endif
c#endif

      sqh = sqrt(rHalf)
      sq2 = sqrt(rTwo)
      sq3 = sqrt(rThree)

      pt2 = p(1)**2 + p(2)**2
      pp = min(p(0),sqrt(pt2+p(3)**2))
      pt = min(pp,sqrt(pt2))

      rc(5,1) = dcmplx(p(0),p(3))*nsr
      rc(6,1) = dcmplx(p(1),p(2))*nsr

      nsv = nsr ! nsv=+1 for final, -1 for initial

      if ( nhel.ge.1 ) then 
c construct eps+
         if ( pp.eq.rZero ) then
            ep(1) = dcmplx( rZero )
            ep(2) = dcmplx( -sqh )
            ep(3) = dcmplx( rZero , nsv*sqh )
            ep(4) = dcmplx( rZero )
         else
            ep(1) = dcmplx( rZero )
            ep(4) = dcmplx( pt/pp*sqh )
            if ( pt.ne.rZero ) then
               pzpt = p(3)/(pp*pt)*sqh
               ep(2) = dcmplx( -p(1)*pzpt , -nsv*p(2)/pt*sqh )
               ep(3) = dcmplx( -p(2)*pzpt ,  nsv*p(1)/pt*sqh )
            else
               ep(2) = dcmplx( -sqh )
               ep(3) = dcmplx( rZero , nsv*sign(sqh,p(3)) )
            endif
         endif
      end if

      if ( nhel.le.-1 ) then 
c construct eps-
         if ( pp.eq.rZero ) then
            em(1) = dcmplx( rZero )
            em(2) = dcmplx( sqh )
            em(3) = dcmplx( rZero , nsv*sqh )
            em(4) = dcmplx( rZero )
         else
            em(1) = dcmplx( rZero )
            em(4) = dcmplx( -pt/pp*sqh )
            if ( pt.ne.rZero ) then
               pzpt = -p(3)/(pp*pt)*sqh
               em(2) = dcmplx( -p(1)*pzpt , -nsv*p(2)/pt*sqh )
               em(3) = dcmplx( -p(2)*pzpt ,  nsv*p(1)/pt*sqh )
            else
               em(2) = dcmplx( sqh )
               em(3) = dcmplx( rZero , nsv*sign(sqh,p(3)) )
            endif
         endif
      end if

      if ( abs(nhel).le.1 ) then  
c construct eps0
         if ( pp.eq.rZero ) then
            e0(1) = dcmplx( rZero )
            e0(2) = dcmplx( rZero )
            e0(3) = dcmplx( rZero )
            e0(4) = dcmplx( rOne )
         else
            emp = p(0)/(rmass*pp)
            e0(1) = dcmplx( pp/rmass )
            e0(4) = dcmplx( p(3)*emp )
            if ( pt.ne.rZero ) then
               e0(2) = dcmplx( p(1)*emp )
               e0(3) = dcmplx( p(2)*emp )
            else
               e0(2) = dcmplx( rZero )
               e0(3) = dcmplx( rZero )
            endif
         end if
      end if

      if ( nhel.ge.-1 ) then
c constract spinor+ 
       nh = nsr

       if ( rmass.ne.rZero ) then

         pp = min(p(0),dsqrt(p(1)**2+p(2)**2+p(3)**2))

         if ( pp.eq.rZero ) then
            
            sqm(0) = dsqrt(abs(rmass)) ! possibility of negative fermion masses
            sqm(1) = sign(sqm(0),rmass) ! possibility of negative fermion masses
            ip = -((1+nh)/2)
            im =  (1-nh)/2
            
            fop(1) = im     * sqm(im)
            fop(2) = ip*nsr * sqm(im)
            fop(3) = im*nsr * sqm(-ip)
            fop(4) = ip     * sqm(-ip)
            
         else
            
            pp = min(p(0),dsqrt(p(1)**2+p(2)**2+p(3)**2))
            sf(1) = dble(1+nsr+(1-nsr)*nh)*rHalf
            sf(2) = dble(1+nsr-(1-nsr)*nh)*rHalf
            omega(1) = dsqrt(p(0)+pp)
            omega(2) = rmass/omega(1)
            ip = (3+nh)/2
            im = (3-nh)/2
            sfomeg(1) = sf(1)*omega(ip)
            sfomeg(2) = sf(2)*omega(im)
            pp3 = max(pp+p(3),rZero)
            chi(1) = dcmplx( dsqrt(pp3*rHalf/pp) )
            if ( pp3.eq.rZero ) then
               chi(2) = dcmplx(-nh )
            else
               chi(2) = dcmplx( nh*p(1) , -p(2) )/dsqrt(rTwo*pp*pp3)
            endif
            
            fop(1) = sfomeg(2)*chi(im)
            fop(2) = sfomeg(2)*chi(ip)
            fop(3) = sfomeg(1)*chi(im)
            fop(4) = sfomeg(1)*chi(ip)

         endif
         
      else
         
         if(p(1).eq.0d0.and.p(2).eq.0d0.and.p(3).lt.0d0) then
            sqp0p3 = 0d0
         else
            sqp0p3 = dsqrt(max(p(0)+p(3),rZero))*nsr
         end if
         chi(1) = dcmplx( sqp0p3 )
         if ( sqp0p3.eq.rZero ) then
            chi(2) = dcmplx(-nhel )*dsqrt(rTwo*p(0))
         else
            chi(2) = dcmplx( nh*p(1), -p(2) )/sqp0p3
         endif
         if ( nh.eq.1 ) then
            fop(1) = chi(1)
            fop(2) = chi(2)
            fop(3) = dcmplx( rZero )
            fop(4) = dcmplx( rZero )
         else
            fop(1) = dcmplx( rZero )
            fop(2) = dcmplx( rZero )
            fop(3) = chi(2)
            fop(4) = chi(1)
         endif
       endif
      endif

      if ( nhel.le.1 ) then
c constract spinor+ 
       nh = -nsr

      if ( rmass.ne.rZero ) then

         pp = min(p(0),dsqrt(p(1)**2+p(2)**2+p(3)**2))

         if ( pp.eq.rZero ) then
            
            sqm(0) = dsqrt(abs(rmass)) ! possibility of negative fermion masses
            sqm(1) = sign(sqm(0),rmass) ! possibility of negative fermion masses
            ip = -((1+nh)/2)
            im =  (1-nh)/2
            
            fom(1) = im     * sqm(im)
            fom(2) = ip*nsr * sqm(im)
            fom(3) = im*nsr * sqm(-ip)
            fom(4) = ip     * sqm(-ip)
            
         else
            
            pp = min(p(0),dsqrt(p(1)**2+p(2)**2+p(3)**2))
            sf(1) = dble(1+nsr+(1-nsr)*nh)*rHalf
            sf(2) = dble(1+nsr-(1-nsr)*nh)*rHalf
            omega(1) = dsqrt(p(0)+pp)
            omega(2) = rmass/omega(1)
            ip = (3+nh)/2
            im = (3-nh)/2
            sfomeg(1) = sf(1)*omega(ip)
            sfomeg(2) = sf(2)*omega(im)
            pp3 = max(pp+p(3),rZero)
            chi(1) = dcmplx( dsqrt(pp3*rHalf/pp) )
            if ( pp3.eq.rZero ) then
               chi(2) = dcmplx(-nh )
            else
               chi(2) = dcmplx( nh*p(1) , -p(2) )/dsqrt(rTwo*pp*pp3)
            endif
            
            fom(1) = sfomeg(2)*chi(im)
            fom(2) = sfomeg(2)*chi(ip)
            fom(3) = sfomeg(1)*chi(im)
            fom(4) = sfomeg(1)*chi(ip)

         endif
         
      else
         
         if(p(1).eq.0d0.and.p(2).eq.0d0.and.p(3).lt.0d0) then
            sqp0p3 = 0d0
         else
            sqp0p3 = dsqrt(max(p(0)+p(3),rZero))*nsr
         end if
         chi(1) = dcmplx( sqp0p3 )
         if ( sqp0p3.eq.rZero ) then
            chi(2) = dcmplx(-nhel )*dsqrt(rTwo*p(0))
         else
            chi(2) = dcmplx( nh*p(1), -p(2) )/sqp0p3
         endif
         if ( nh.eq.1 ) then
            fom(1) = chi(1)
            fom(2) = chi(2)
            fom(3) = dcmplx( rZero )
            fom(4) = dcmplx( rZero )
         else
            fom(1) = dcmplx( rZero )
            fom(2) = dcmplx( rZero )
            fom(3) = chi(2)
            fom(4) = chi(1)
         endif
       endif 
      endif
      
c spin-3/2 fermion wavefunction
      if ( nhel.eq.3 ) then
         do j = 1,4
            do i = 1,4
               rc(i,j) = ep(i)*fop(j)
            end do
         end do
      else if ( nhel.eq.1 ) then
         do j = 1,4
            do i = 1,4
              if     ( pt.eq.rZero .and. p(3).ge.0d0 ) then 
               rc(i,j) =  sq2/sq3*e0(i)*fop(j)
     &                    +rOne/sq3*ep(i)*fom(j)
              elseif ( pt.eq.rZero .and. p(3).lt.0d0 ) then 
               rc(i,j) =  sq2/sq3*e0(i)*fop(j)
     &                    -rOne/sq3*ep(i)*fom(j)
              else
               rc(i,j) =  sq2/sq3*e0(i)*fop(j) 
     &                  +rOne/sq3*ep(i)*fom(j)
     &                   *dcmplx(P(1),-nsr*P(2))/pt  
              endif
            end do
         end do
      else if ( nhel.eq.-1 ) then
         do j = 1,4
            do i = 1,4
              if     ( pt.eq.rZero .and.p(3).ge.0d0 ) then 
               rc(i,j) = rOne/sq3*em(i)*fop(j)
     &                   +sq2/sq3*e0(i)*fom(j)
              elseif ( pt.eq.rZero .and.p(3).lt.0d0 ) then 
               rc(i,j) = rOne/sq3*em(i)*fop(j)
     &                   -sq2/sq3*e0(i)*fom(j)
              else
               rc(i,j) = rOne/sq3*em(i)*fop(j) 
     &                  + sq2/sq3*e0(i)*fom(j)
     &                   *dcmplx(P(1),-nsr*P(2))/pt  
              endif
            end do
         end do
      else
         do j = 1,4
            do i = 1,4
              if     ( pt.eq.rZero .and. p(3).ge.0d0 ) then 
               rc(i,j) =  em(i)*fom(j)
              elseif ( pt.eq.rZero .and. p(3).lt.0d0 ) then 
               rc(i,j) = -em(i)*fom(j)
              else
               rc(i,j) =  em(i)*fom(j)*dcmplx(P(1),-nsr*P(2))/pt  
              endif
            end do
         end do
      end if

      ro(3) = rc(1,1)
      ro(4) = rc(1,2)
      ro(5) = rc(1,3)
      ro(6) = rc(1,4)
      ro(7) = rc(2,1)
      ro(8) = rc(2,2)
      ro(9) = rc(2,3)
      ro(10) = rc(2,4)
      ro(11) = rc(3,1)
      ro(12) = rc(3,2)
      ro(13) = rc(3,3)
      ro(14) = rc(3,4)
      ro(15) = rc(4,1)
      ro(16) = rc(4,2)
      ro(17) = rc(4,3)
      ro(18) = rc(4,4)
      ro(1) = rc(5,1)
      ro(2) = rc(6,1)

      return
      end


      complex*16 function THETA_FUNCTION(cond, out_true, out_false)

      double precision cond
      complex*16 out_true, out_false

      if (cond.ge.0d0) then
        THETA_FUNCTION = out_true
      else
        THETA_FUNCTION = out_false
      endif

      return
      end

C     This File is Automatically generated by ALOHA 
C     The process calculated in this file is: 
C     Gamma(-1,2,-2)*Gamma(-1,4,-3)*ProjM(-3,3)*ProjM(-2,1)
C     
      SUBROUTINE FFFF18_0(F1, F2, F3, F4, COUP,VERTEX)
      IMPLICIT NONE
      COMPLEX*16 CI
      PARAMETER (CI=(0D0,1D0))
      COMPLEX*16 COUP
      COMPLEX*16 F1(*)
      COMPLEX*16 F2(*)
      COMPLEX*16 F3(*)
      COMPLEX*16 F4(*)
      COMPLEX*16 TMP0
      COMPLEX*16 VERTEX
      TMP0 = (F1(3)*F3(4)*(F4(6)*F2(5)-F4(5)*F2(6))+F1(4)*F3(3)*(-F4(6)
     $ *F2(5)+F4(5)*F2(6)))
      VERTEX = COUP*(-2D0 * CI * TMP0)
      END


C     This File is Automatically generated by ALOHA 
C     The process calculated in this file is: 
C     Gamma(-1,2,-2)*Gamma(-1,4,-3)*ProjM(-3,3)*ProjM(-2,1)
C     
      SUBROUTINE FFFF18_24_28_29_0(F1, F2, F3, F4, COUP1, COUP2, COUP3
     $ , COUP4,VERTEX)
      IMPLICIT NONE
      COMPLEX*16 CI
      PARAMETER (CI=(0D0,1D0))
      COMPLEX*16 COUP1
      COMPLEX*16 COUP2
      COMPLEX*16 COUP3
      COMPLEX*16 COUP4
      COMPLEX*16 F1(*)
      COMPLEX*16 F2(*)
      COMPLEX*16 F3(*)
      COMPLEX*16 F4(*)
      COMPLEX*16 TMP
      COMPLEX*16 VERTEX
      CALL FFFF18_0(F1,F2,F3,F4,COUP1,VERTEX)
      CALL FFFF24_0(F1,F2,F3,F4,COUP2,TMP)
      VERTEX = VERTEX + TMP
      CALL FFFF28_0(F1,F2,F3,F4,COUP3,TMP)
      VERTEX = VERTEX + TMP
      CALL FFFF29_0(F1,F2,F3,F4,COUP4,TMP)
      VERTEX = VERTEX + TMP
      END

c************************************************************************
c**                                                                    **
c**           MadGraph/MadEvent Interface to FeynRules                 **
c**                                                                    **
c**          C. Duhr (Louvain U.) - M. Herquet (NIKHEF)                **
c**                                                                    **
c************************************************************************

c *************************************************************************
c **                                                                     **
c **                    LHA format reading routines                      **
c **                                                                     **
c *************************************************************************


c +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c ++
c ++ LHA_islatin -> islatin=true if letter is a latin letter
c ++
c +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      subroutine LHA_islatin(letter,islatin)
      implicit none

      logical islatin
      character letter
      integer i

      islatin=.false.
      i=ichar(letter)
      if(i.ge.65.and.i.le. 90) islatin=.true.
      if(i.ge.97.and.i.le.122) islatin=.true.

      end

c +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c ++
c ++ LHA_isnum -> isnum=true if letter is a number
c ++
c +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      subroutine LHA_isnum(letter,isnum)
      implicit none

      logical isnum
      character letter
      character*10 ref
      integer i

      isnum=.false.
      ref='1234567890'

      do i=1,10
        if(letter .eq. ref(i:i)) isnum=.true.
      end do

      end

c +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c ++
c ++ LHA_firststring -> first is the first "word" of string
c ++ Warning: string is returned with first REMOVED!
c ++
c +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      subroutine LHA_firststring(first,string)

      implicit none
      character*(*) string
      character*(*) first
      
      if(len_trim(string).le.0) return
      
      do while(string(1:1) .eq. ' ' .or. string(1:1) .eq. CHAR(9)) 
        string=string(2:len(string))
      end do
      if (index(string,' ').gt.1) then
         first=string(1:index(string,' ')-1)
         string=string(index(string,' '):len(string))
      else 
         first=string
      end if

      end


      subroutine LHA_case_trap(name)
c +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c ++
c ++ LHA_case_trap -> change string to lower case
c ++
c +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      implicit none
      
      character*20 name
      integer i,k

      do i=1,20
         k=ichar(name(i:i))
         if(k.ge.65.and.k.le.90) then  !upper case A-Z
            k=ichar(name(i:i))+32
            name(i:i)=char(k)
         endif
      enddo

      return
      end

c +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c ++
c ++ LHA_blockread -> read a LHA line and return parameter name (evntually found in 
c ++ a ref file) and value
c ++
c +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      subroutine LHA_blockread(blockname,buff,par,val,found)

      implicit none
      character*132 buff,buffer,curr_ref,curr_buff
      character*20 blockname,val,par,temp,first_ref,first_line
      logical fopened
      integer ref_file
      logical islast,isnum,found
      character*20 temp_val


c     *********************************************************************
c     Try to find a correspondance in ident_card
c
      ref_file = 20
      call LHA_open_file(ref_file,'ident_card.dat',fopened)
      if(.not. fopened) goto 99 ! If the file does not exist -> no matter, use default!
        
      islast=.false.
      found=.false.
      do while(.not. found)!run over reference file
      

        ! read a line
        read(ref_file,'(a132)',end=98,err=98) buffer
        
        ! Seek a corresponding blockname
        call LHA_firststring(temp,buffer)
        call LHA_case_trap(temp)
        
        if(temp .eq. blockname) then
             ! Seek for a corresponding LHA code
             curr_ref=buffer
             curr_buff=buff
             first_ref=''
             first_line=''
             
             do while((.not. islast).and.(first_ref .eq. first_line))
                 call LHA_firststring(first_ref,curr_ref)
                 call LHA_firststring(first_line,curr_buff)
                 call LHA_islatin(first_ref(1:1),islast)
                 if (islast) then
                   par=first_ref
                   val=first_line ! If found set param name & value
                   found=.true.
                 end if
             end do
        end if
                     
      end do
98    close(ref_file)
99    return    
      end


c +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c ++
c ++ LHA_loadcard -> Open a LHA file and load all model param in a table
c ++
c +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      subroutine LHA_loadcard(param_name,npara,param,value)

      implicit none

      integer maxpara
      parameter (maxpara=1000)
      character*20 param(maxpara),value(maxpara),val,par
      character*20 blockname
      integer npara
      logical fopened,found
      integer iunit,GL,logfile
      character*20 ctemp
      character*132 buff
      character*20 tag
      character*132 temp
      character*(*) param_name
      data iunit/21/
      data logfile/22/

      logical WriteParamLog
      common/IOcontrol/WriteParamLog

      GL=0
      npara=1

      param(1)=' '
      value(1)=' '
      ! Try to open param-card file
      call LHA_open_file(iunit,param_name,fopened)
      if(.not.fopened) then
         write(*,*) 'Error: Could not open file',param_name
         write(*,*) 'Exiting'
         stop
      endif
      
      ! Try to open log file
      if (WriteParamLog) then
        open (unit = logfile, file = "param.log")
      endif
      
      ! Scan the data file
      do while(.true.)  
      
         read(iunit,'(a132)',end=99,err=99) buff
         
         if(buff .ne. '' .and. buff(1:1) .ne.'#') then ! Skip comments and empty lines

             tag=buff(1:5)
             call LHA_case_trap(tag) ! Select decay/block tag
             if(tag .eq. 'block') then ! If we are in a block, get the blockname
                 temp=buff(7:132)
                 call LHA_firststring(blockname,temp)
                 call LHA_case_trap(blockname)
             else if (tag .eq. 'decay') then ! If we are in a decay, directly try to get back the correct name/value pair
                 blockname='decay'
                 temp=buff(7:132)
                 call LHA_blockread(blockname,temp,par,val,found)
                 if(found) GL=1
             else if ((tag .eq. 'qnumbers').or.(blockname.eq.'')) then! if qnumbers or empty tag do nothing
                 blockname=''
             else ! If we are in valid block, try to get back a name/value pair
                 call LHA_blockread(blockname,buff,par,val,found)
                 if(found) GL=1
             end if

             !if LHA_blockread has been called, record name and value

             if(GL .eq. 1) then
                  value(npara)=val
                  ctemp=par
                  call LHA_case_trap(ctemp)
                  param(npara)=ctemp
                  npara=npara+1
                  GL=0
                  if (WriteParamLog) then
                    write (logfile,*) 'Parameter ',ctemp,
     &                                  ' has been read with value ',val
                  endif
             endif

         endif
      enddo
      
      npara=npara-1
99      close(iunit)
      if (WriteParamLog) then
        close(logfile)
      endif

      return
 
      end



      subroutine LHA_get_real_silent(npara,param,value,name,var,def_value_num)
c----------------------------------------------------------------------------------
c     finds the parameter named "name" in param and associate to "value" in value
c----------------------------------------------------------------------------------
      implicit none

c
c     parameters
c
      integer maxpara
      parameter (maxpara=1000)
c
c     arguments
c
      integer npara
      character*20 param(maxpara),value(maxpara)
      character*(*)  name
      real*8 var,def_value_num
      character*20 c_param,c_name,ctemp
      character*19 def_value
c
c     local
c
      logical found, log
      integer i
c
c     start
c
      log = .false.
      goto 10
      
      entry LHA_get_real(npara,param,value,name,var,def_value_num)
      log = .true.
      
 10   i=1
      found=.false.
      do while(.not.found.and.i.le.npara)
         ctemp=param(i)
         call LHA_firststring(c_param,ctemp)
         ctemp=name
         call LHA_firststring(c_name,ctemp)
         call LHA_case_trap(c_name)
         call LHA_case_trap(c_param)
         found = (c_param .eq. c_name)
         if (found) then
             read(value(i),*) var
         end if
         i=i+1
      enddo
      if (.not.found) then
         if (log) then
            write (*,*) "Warning: parameter ",name," not found"
            write (*,*) "         setting it to default value ",
     &           def_value_num
         endif
         var=def_value_num
      endif
      return

      end
c

      subroutine LHA_open_file(lun,filename,fopened)
c***********************************************************************
c     opens file input-card.dat in current directory or above
c***********************************************************************
      implicit none
c
c     Arguments
c
      integer lun
      logical fopened
      character*(*) filename
      character*90  tempname
      integer fine
      integer dirup,i

      character*90 lastopen
      save lastopen
      data lastopen /''/
      integer sindex
      
c-----
c     Begin Code
c-----
c
c     first check that we will end in the main directory
c
      open(unit=lun,file=filename,status='old',ERR=20)
c      write(*,*) 'read model file ',filename
      sindex = INDEX(filename, '/' , .true.)
      if (sindex.ne.0)then
         lastopen = filename(1:sindex)
      endif
      fopened=.true.
      return

 20   if (lastopen(1:2).ne.' ')then
         fine=index(lastopen,' ')
         if (fine.ne.0) then
            tempname = lastopen(1:fine-1)//filename
         else
            tempname = lastopen//filename
         endif
         open(unit=lun,file=tempname,status='old',ERR=30)
         fopened=.true.
         return
      endif
      
30    tempname=filename
      fine=index(tempname,' ')
      if(fine.eq.0) fine=len(tempname)
      tempname=tempname(1:fine)
c
c     if I have to read a card
c
      if(index(filename,"_card").gt.0) then
        tempname='./Cards/'//tempname
      endif

      fopened=.false.
      do i=0,5
        open(unit=lun,file=tempname,status='old',ERR=40)
        fopened=.true.
c        write(*,*) 'read model file ',tempname
        exit
40      tempname='../'//tempname
        if (i.eq.5)then
           write(*,*) 'Warning: file ',filename,
     &                           ' not found in the parent directories!(lha_read)'
           stop
        endif
      enddo

      return
      end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c      written by the UFO converter
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      SUBROUTINE COUP()

      IMPLICIT NONE
      DOUBLE PRECISION PI, ZERO
      LOGICAL READLHA
      PARAMETER  (PI=3.141592653589793D0)
      PARAMETER  (ZERO=0D0)
      INCLUDE 'model_functions.inc'
      INCLUDE 'input.inc'
      INCLUDE 'coupl.inc'
      READLHA = .TRUE.
      INCLUDE 'intparam_definition.inc'
      CALL COUP1()
C     
couplings needed to be evaluated points by points
C     
      CALL COUP2()

      RETURN
      END

      SUBROUTINE UPDATE_AS_PARAM()

      IMPLICIT NONE
      DOUBLE PRECISION PI, ZERO
      LOGICAL READLHA
      PARAMETER  (PI=3.141592653589793D0)
      PARAMETER  (ZERO=0D0)
      INCLUDE 'model_functions.inc'
      INCLUDE 'input.inc'
      INCLUDE 'coupl.inc'
      READLHA = .FALSE.

      INCLUDE 'intparam_definition.inc'


C     
couplings needed to be evaluated points by points
C     
      CALL COUP2()

      RETURN
      END

      SUBROUTINE UPDATE_AS_PARAM2(MU_R2,AS2)

      IMPLICIT NONE
      DOUBLE PRECISION PI
      PARAMETER  (PI=3.141592653589793D0)
      DOUBLE PRECISION MU_R2, AS2
      INCLUDE 'model_functions.inc'
      INCLUDE 'input.inc'
      INCLUDE 'coupl.inc'

      IF (MU_R2.GT.0D0) MU_R = MU_R2
      G = SQRT(4.0D0*PI*AS2)
      AS = AS2

      CALL UPDATE_AS_PARAM()


      RETURN
      END

      subroutine read_event(lun,P,wgt,nexternal,ic,ievent,sscale,
     $                      aqcd,aqed,buff,u_syst,s_buff,nclus,buffclus,
     $                      done)
c********************************************************************
c     Reads one event from data file #lun
c     ic(*,1) = Particle ID
c     ic(*,2) = Mothup(1)
c     ic(*,3) = Mothup(2)
c     ic(*,4) = ICOLUP(1)
c     ic(*,5) = ICOLUP(2)
c     ic(*,6) = ISTUP   -1=initial state +1=final  +2=decayed
c     ic(*,7) = Helicity
c********************************************************************
      implicit none
      include 'maxparticles.inc'
      include 'run_config.inc'
      include 'run.inc'
      double precision pi
      parameter (pi = 3.1415926d0)
c
c     Arguments
c      
      integer lun
      integer nexternal, ic(7,*)
      logical done
      double precision P(0:4,*),wgt,aqcd,aqed,sscale
      integer ievent
      character*(*) buff
      logical u_syst
      character*(s_bufflen) s_buff(*)
      integer nclus
      character*(clus_bufflen) buffclus(*)
c
c     Local
c
      integer i,j,k
      character*(s_bufflen) buftmp
      double precision xdum1,xdum2
c
c     Global
c
      logical banner_open
      integer lun_ban
      common/to_banner/banner_open, lun_ban

      data lun_ban/37/
      data banner_open/.false./

      double precision bias_weight
      logical impact_xsec
      common/bias/bias_weight,impact_xsec
c-----
c  Begin Code
c-----     
      buff=' '
      done=.false.
      if (.not. banner_open) then
         open (unit=lun_ban, status='scratch')
         banner_open=.true.
      endif
 11   read(lun,'(a300)',end=99,err=99) buftmp
      do while(index(buftmp,"<event") .eq. 0)
         write(lun_ban,'(a)') buftmp
         read(lun,'(a300)',end=99,err=99) buftmp
      enddo
      read(lun,*,err=11, end=11) nexternal,ievent,wgt,sscale,aqed,aqcd
      do i=1,nexternal
         read(lun,*,err=99,end=99) ic(1,i),ic(6,i),(ic(j,i),j=2,5),
     $     (p(j,i),j=1,3),p(0,i),p(4,i),xdum1,xdum2
         ic(7,i)=xdum2
      enddo
      
c     Clustering scales
      read(lun,'(a)',end=99,err=99) buff
      if (lhe_version.lt.3d0)then
        if(buff(1:1).ne.'#') then
         backspace(lun)
         buff=''
        endif
      else
        if(buff(1:7).ne.'<scales') then
         backspace(lun)
         buff=''
        endif
      endif

c     Reading the bias weight (if present)
      read(lun,'(a300)',end=99,err=99) buftmp
      if(buftmp(1:6).ne.'<rwgt>') then
         backspace(lun)
         bias_weight = 1.0d0
      else
         do while(buftmp(1:7).ne.'</rwgt>')
           read(lun,'(a300)',end=99,err=99) buftmp
           if (buftmp(1:16).eq."<wgt id='bias'> ") then
              read(buftmp(17:31),'(1e15.7)') bias_weight
           endif
         enddo
      endif

c     Systematics info
      read(lun,'(a)',end=99,err=99) s_buff(1)
      if(s_buff(1).ne.'<mgrwt>') then
         s_buff(1)=' '
         backspace(lun)
         u_syst=.false.
      else
         i=1
         do while(s_buff(i).ne.'</mgrwt>')
            i=i+1
            read(lun,'(a)',end=99,err=99) s_buff(i)
         enddo
         u_syst=.true.
      endif
c     Clustering info
      read(lun,'(a)',end=99,err=99) buffclus(1)
      if(buffclus(1).ne.'<clustering>') then
         buffclus(1)=' '
         backspace(lun)
         nclus=0
      else
         i=1
         do while(buffclus(i).ne.'</clustering>')
            i=i+1
            read(lun,'(a)',end=99,err=99) buffclus(i)
         enddo
         nclus=i
      endif
      return
 99   done=.true.
      return
 55   format(i3,5e19.11)         
      end

      subroutine write_event_to_stream(evt_record,P,wgt,nexternal,ic,
     &     ievent,scale,aqcd, aqed,buff,u_syst,s_buff,nclus,buffclus)
c********************************************************************
C     This an *exact* copy of write_event, except that it writes it 
C     to a character array argument as opposed to an I/O stream.
c********************************************************************
      implicit none

      include 'maxparticles.inc'
      include 'run_config.inc'
c
c     parameters
c
      double precision pi
      parameter (pi = 3.1415926d0)
c
c     Arguments
c      
      character*(maxEventLength) evt_record
      integer ievent
      integer nexternal, ic(7,*)
      double precision P(0:4,*),wgt
      double precision aqcd, aqed, scale
      character*1000 buff
      logical u_syst
      character*(s_bufflen) s_buff(*)
      integer nclus
      character*(clus_bufflen) buffclus(*)
c
c     Local
c
      integer i,j,k
      character*(maxEventLength) largeBuff
c
c     Global
c
      double precision bias_weight
      logical impact_xsec
      common/bias/bias_weight,impact_xsec

c-----
c  Begin Code
c-----     
c      aqed= gal(1)*gal(1)/4d0/pi
c      aqcd = g*g/4d0/pi
      write(largeBuff,'(a)') '<event>'
      evt_record=trim(evt_record)//trim(largeBuff)
      write(largeBuff,'(i2,i5,e16.7e3,3e15.7)') nexternal,ievent,wgt,scale,
     $                                   aqed,aqcd
      evt_record=trim(evt_record)//CHAR(13)//CHAR(10)//trim(largeBuff)
      do i=1,nexternal
         write(largeBuff,51) ic(1,i),ic(6,i),(ic(j,i),j=2,5),
     $     (p(j,i),j=1,3),p(0,i),p(4,i),0.,real(ic(7,i))
         evt_record=trim(evt_record)//CHAR(13)//CHAR(10)//trim(largeBuff)
      enddo
      if(buff(1:7).eq.'<scales') then
        write(largeBuff,'(a)') buff(1:len_trim(buff))
        evt_record=trim(evt_record)//CHAR(13)//CHAR(10)//trim(largeBuff)
      endif
      if(buff(1:1).eq.'#') then
        write(largeBuff,'(a)') buff(1:len_trim(buff))
        evt_record=trim(evt_record)//CHAR(13)//CHAR(10)//trim(largeBuff)
      endif
      if(.not.impact_xsec) then
          write(largeBuff,'(a)') '<rwgt>'
          evt_record=trim(evt_record)//CHAR(13)//CHAR(10)//trim(largeBuff)
          write(largeBuff,'(a16,1e15.7,a6)') "<wgt id='bias'> ",
     $                                              bias_weight,"</wgt>"
          evt_record=trim(evt_record)//CHAR(13)//CHAR(10)//trim(largeBuff)
          write(largeBuff,'(a)') '</rwgt>'
          evt_record=trim(evt_record)//CHAR(13)//CHAR(10)//trim(largeBuff)
      endif 
      if(u_syst)then
         do i=1,7
            write(largeBuff,'(a)') s_buff(i)(1:len_trim(s_buff(i)))
            evt_record=trim(evt_record)//CHAR(13)//CHAR(10)//trim(largeBuff)
         enddo
      endif
      do i=1,nclus
         write(largeBuff,'(a)') buffclus(i)(1:len_trim(buffclus(i)))
         evt_record=trim(evt_record)//CHAR(13)//CHAR(10)//trim(largeBuff)
      enddo
      write(largeBuff,'(a)') '</event>'
      evt_record=trim(evt_record)//CHAR(13)//CHAR(10)//trim(largeBuff)
      return
 51   format(i11,5i5,5e19.11,f3.0,f4.0)
      end


      subroutine write_event(lun,P,wgt,nexternal,ic,ievent,scale,aqcd,
     $     aqed,buff,u_syst,s_buff,nclus,buffclus)
c********************************************************************
c
c /!\ When making changes to this subroutine, make sure to accordingly
c     update write_event_to_stream
c
c********************************************************************
c     Writes one event from data file #lun according to LesHouches
c     ic(1,*) = Particle ID
c     ic(2.*) = Mothup(1)
c     ic(3,*) = Mothup(2)
c     ic(4,*) = ICOLUP(1)
c     ic(5,*) = ICOLUP(2)
c     ic(6,*) = ISTUP   -1=initial state +1=final  +2=decayed
c     ic(7,*) = Helicity
c********************************************************************
      implicit none

      include 'maxparticles.inc'
      include 'run_config.inc'
c
c     parameters
c
      double precision pi
      parameter (pi = 3.1415926d0)
c
c     Arguments
c      
      integer lun, ievent
      integer nexternal, ic(7,*)
      double precision P(0:4,*),wgt
      double precision aqcd, aqed, scale
      character*1000 buff
      logical u_syst
      character*(s_bufflen) s_buff(*)
      integer nclus
      character*(clus_bufflen) buffclus(*)
c
c     Local
c
      integer i,j,k
c
c     Global
c
      double precision bias_weight
      logical impact_xsec
      common/bias/bias_weight,impact_xsec

c-----
c  Begin Code
c-----     
c      aqed= gal(1)*gal(1)/4d0/pi
c      aqcd = g*g/4d0/pi

      write(lun,'(a)') '<event>'
      write(lun,'(i2,i5,e16.7e3,3e15.7)') nexternal,ievent,wgt,scale,aqed,aqcd
      do i=1,nexternal
         write(lun,51) ic(1,i),ic(6,i),(ic(j,i),j=2,5),
     $     (p(j,i),j=1,3),p(0,i),p(4,i),0.,real(ic(7,i))
      enddo
      if(buff(1:7).eq.'<scales') write(lun,'(a)') buff(1:len_trim(buff))
      if(buff(1:1).eq.'#') write(lun,'(a)') buff(1:len_trim(buff))      
      if(.not.impact_xsec) then
          write(lun,'(a)') '<rwgt>'
          write(lun,'(a16,1e15.7,a6)') "<wgt id='bias'> ",bias_weight,
     $                                                          "</wgt>"
          write(lun,'(a)') '</rwgt>'
      endif 
      if(u_syst)then
         do i=1,7
            write(lun,'(a)') s_buff(i)(1:len_trim(s_buff(i)))
         enddo
      endif
      do i=1,nclus
         write(lun,'(a)') buffclus(i)(1:len_trim(buffclus(i)))
      enddo
      write(lun,'(a)') '</event>'
      return
 51   format(i11,5i5,5e19.11,f3.0,f4.0)
      end

      subroutine write_comments(lun)
c********************************************************************
c     Outputs all of the banner comment lines back at the top of
c     the file lun.
c********************************************************************
      implicit none
c
c     Arguments
c
      integer lun
c
c     Local
c
      character*(200) buff
c
c     Global
c
      logical banner_open
      integer lun_ban
      common/to_banner/banner_open, lun_ban

c-----
c  Begin Code
c-----     
c      write(*,*) 'Writing comments'
      if (banner_open) then
         rewind(lun_ban)
         do while (.true.) 
            read(lun_ban,'(a)',end=99,err=99) buff
            write(lun,'(a)') buff
c            write(*,*) buff
         enddo
 99      close(lun_ban)
         banner_open = .false.
      endif
      end

      subroutine open_file(lun,filename,fopened)
c***********************************************************************
c     opens file input-card.dat in current directory or above
c***********************************************************************
      implicit none
c
c     Arguments
c
      integer lun
      logical fopened
      character*(*) filename
      character*300  tempname
      character*300  tempname2
      character*300 path ! path of the executable
      character*30  upname ! sequence of ../
      integer fine,fine2
      integer i, pos
      
c-----
c  Begin Code
c-----
c      
c     getting the path of the executable
c
      call getarg(0,path) !path is the PATH to the madevent executable (either global or from launching directory)
      pos = index(path,'/',.true.)
      path = path(:pos)
c
c     first check that we will end in the main directory
c

c
c 	  if I have to read a card
c

      tempname=filename 	 
      fine=index(tempname,' ') 	 
      fine2=index(path,' ')-1	 
      if(fine.eq.0) fine=len(tempname)
      open(unit=lun,file=tempname,status='old',ERR=20)
      fopened=.true.
      return
c
c     check path from the executable
c
 20   if(index(filename,"_card").gt.0) then
         tempname='Cards/'//tempname(1:fine)
         fine=fine+6
      endif
      tempname2 = path//tempname

      fopened=.false.
      upname='../../../../../../../'
      do i=0,6
         open(unit=lun,file=tempname2,status='old',ERR=30)
         fopened=.true.
         exit
 30      tempname2=path(:fine2)//upname(:3*i)//tempname
         if (i.eq.6)then
            write(*,*) 'Warning: file ',filename,' not found'
         endif
      enddo
      end

C ************************************************************
C Source for the library implementing a bias function that 
C populates the large pt tale of the leading jet. 
C
C The two options of this subroutine, that can be set in
C the run card are:
C    > (double precision) ptj_bias_target_ptj : target ptj value
C    > (double precision) ptj_bias_enhancement_power : exponent
C
C Schematically, the functional form of the enhancement is
C    bias_wgt = [ptj(evt)/mean_ptj]^enhancement_power
C ************************************************************
C
C The following lines are read by MG5aMC to set what are the 
C relevant parameters for this bias module.
C
C  parameters = {'ptj_bias_target_ptj': 1000.0,
C               'ptj_bias_enhancement_power': 4.0}
C

      subroutine bias_wgt(p, original_weight, bias_weight)
          implicit none
C
C Parameters
C
          include '../../maxparticles.inc'          
          include '../../nexternal.inc'

C
C Arguments
C
          double precision p(0:3,nexternal)
          double precision original_weight, bias_weight
C
C local variables
C
          integer i
          double precision ptj(nexternal)
          double precision max_ptj
c
c local variables defined in the run_card
c
          double precision ptj_bias_target_ptj
          double precision ptj_bias_enhancement_power
C
C Global variables
C
C
C Mandatory common block to be defined in bias modules
C
          double precision stored_bias_weight
          data stored_bias_weight/1.0d0/          
          logical impact_xsec, requires_full_event_info
C         We only want to bias distributions, but not impact the xsec. 
          data impact_xsec/.False./
C         Of course this module does not require the full event
C         information (color, resonances, helicities, etc..)
          data requires_full_event_info/.False./ 
          common/bias/stored_bias_weight,impact_xsec,
     &                requires_full_event_info
C
C Accessingt the details of the event
C
          logical is_a_j(nexternal),is_a_l(nexternal),
     &            is_a_b(nexternal),is_a_a(nexternal),
     &            is_a_onium(nexternal),is_a_nu(nexternal),
     &            is_heavy(nexternal),do_cuts(nexternal)
          common/to_specisa/is_a_j,is_a_a,is_a_l,is_a_b,is_a_nu,
     &                      is_heavy,is_a_onium,do_cuts

C
C    Setup the value of the parameters from the run_card    
C
      include '../bias.inc'

C --------------------
C BEGIN IMPLEMENTATION
C --------------------
          
          do i=1,nexternal
            ptj(i)=-1.0d0
            if (is_a_j(i)) then
              ptj(i)=sqrt(p(1,i)**2+p(2,i)**2)
            endif
          enddo

          max_ptj=-1.0d0
          do i=1,nexternal
            max_ptj = max(max_ptj,ptj(i))
          enddo
          if (max_ptj.lt.0.0d0) then
            bias_weight = 1.0d0
            return
          endif

          bias_weight = (max_ptj/ptj_bias_target_ptj)
     &                                      **ptj_bias_enhancement_power

          return

      end subroutine bias_wgt

      subroutine ntuple(x,a,b,ii,jconfig)
c-------------------------------------------------------
c     Front to ranmar which allows user to easily
c     choose the seed.
c------------------------------------------------------
      implicit none
c
c     Arguments
c
      double precision x,a,b
      integer ii,jconfig
c
c     Local
c
      integer init, ioffset, joffset
      integer     ij, kl, iseed1,iseed2

c
c     Global
c
c-------
c     18/6/2012 tjs promoted to integer*8 to avoid overflow for iseed > 60K
c------
      integer*8       iseed
      common /to_seed/iseed
c
c     Data
c
      data init /1/
      save ij, kl
c-----
c  Begin Code
c-----
      if (init .eq. 1) then
         init = 0
         call get_offset(ioffset)
         if (iseed .eq. 0) call get_base(iseed)
c
c     TJS 3/13/2008
c     Modified to allow for more sequences 
c     iseed can be between 0 and 30081*30081
c     before pattern repeats
c
c
c     TJS 12/3/2010
c     multipied iseed to give larger values more likely to make change
c     get offset for multiple runs of single process
c
c
c     TJS 18/6/2012
c     Updated to better divide iseed among ij and kl seeds
c     Note it may still be possible to get identical ij,kl for
c     different iseed, if have exactly compensating joffset, ioffset, jconfig
c
         call get_moffset(joffset)
         joffset = joffset * 3157
         iseed = iseed * 31300       
         ij=1802+jconfig + mod(iseed,30081)
         kl=9373+(iseed/30081)+ioffset + joffset     !Switched to 30081  20/6/12 to avoid dupes in range 30082-31328
         write(*,'(a,i6,a3,i6)') 'Using random seed offsets',jconfig," : ",ioffset
         write(*,*) ' with seed', iseed/31300
         do while (ij .gt. 31328)
            ij = ij - 31328
         enddo
         do while (kl .gt. 30081)
            kl = kl - 30081
         enddo
        call rmarin(ij,kl)         
      endif
      call ranmar(x)
      do while (x .lt. 1d-16)
         call ranmar(x)
      enddo
      x = a+x*(b-a)
      end

      subroutine get_base(iseed)
c-------------------------------------------------------
c     Looks for file iproc.dat to offset random number gen
c------------------------------------------------------
      implicit none
c
c     Constants
c
      integer    lun
      parameter (lun=22)
c
c     Arguments
c
      integer*8 iseed
c
c     Local
c
      character*60 fname
      logical done
      integer i,level
c-----
c  Begin Code
c-----

      fname = 'randinit'
      done = .false.
      level = 1
      do while(.not. done .and. level .lt. 5)
         open(unit=lun,file=fname,status='old',err=15)
         done = .true.
 15      level = level+1
         fname = '../' // fname
         i=index(fname,' ')
         if (i .gt. 0) fname=fname(1:i-1)
      enddo
      if (done) then
         read(lun,'(a)',end=24,err=24) fname
         i = index(fname,'=')
         if (i .gt. 0) fname=fname(i+1:)
         read(fname,*,err=26,end=26) iseed
 24      close(lun)
c         write(*,*) 'Read iseed from randinit ',iseed
         return
 26      close(lun)
      endif
 25   iseed = 0
c      write(*,*) 'No base found using iseed=0'
      end

      subroutine get_offset(iseed)
c-------------------------------------------------------
c     Looks for file iproc.dat to offset random number gen
c------------------------------------------------------
      implicit none
c
c     Constants
c
      integer    lun
      parameter (lun=22)
c
c     Arguments
c
      integer iseed
c
c     Local
c
c-----
c  Begin Code
c-----

      open(unit=lun,file='./iproc.dat',status='old',err=15)
         read(lun,*,err=14) iseed
         close(lun)
         return
 14   close(lun)
 15   open(unit=lun,file='../iproc.dat',status='old',err=25)
         read(lun,*,err=24) iseed
         close(lun)
         return
 24   close(lun)
 25   iseed = 0
      end

      subroutine get_moffset(iseed)
c-------------------------------------------------------
c     Looks for file moffset.dat to offset random number gen
c------------------------------------------------------
      implicit none
c
c     Constants
c
      integer    lun
      parameter (lun=22)
c
c     Arguments
c
      integer iseed
c
c     Local
c
c-----
c  Begin Code
c-----

      open(unit=lun,file='./moffset.dat',status='old',err=25)
         read(lun,*,err=14) iseed
         write(*,*) "Got moffset",iseed
         close(lun)
         return
 14   close(lun)
 25   iseed = 0
      end

      subroutine ranmar(rvec)
*     -----------------
* universal random number generator proposed by marsaglia and zaman
* in report fsu-scri-87-50
* in this version rvec is a double precision variable.
      implicit real*8(a-h,o-z)
      common/ raset1 / ranu(97),ranc,rancd,rancm
      common/ raset2 / iranmr,jranmr
      save /raset1/,/raset2/
      uni = ranu(iranmr) - ranu(jranmr)
      if(uni .lt. 0d0) uni = uni + 1d0
      ranu(iranmr) = uni
      iranmr = iranmr - 1
      jranmr = jranmr - 1
      if(iranmr .eq. 0) iranmr = 97
      if(jranmr .eq. 0) jranmr = 97
      ranc = ranc - rancd
      if(ranc .lt. 0d0) ranc = ranc + rancm
      uni = uni - ranc
      if(uni .lt. 0d0) uni = uni + 1d0
      rvec = uni
      end
 
      subroutine rmarin(ij,kl)
*     -----------------
* initializing routine for ranmar, must be called before generating
* any pseudorandom numbers with ranmar. the input values should be in
* the ranges 0<=ij<=31328 ; 0<=kl<=30081
      implicit real*8(a-h,o-z)
      character*30 filename
      logical file_exists
      common/ raset1 / ranu(97),ranc,rancd,rancm
      common/ raset2 / iranmr,jranmr
      save /raset1/,/raset2/
* this shows correspondence between the simplified input seeds ij, kl
* and the original marsaglia-zaman seeds i,j,k,l.
* to get the standard values in the marsaglia-zaman paper (i=12,j=34
* k=56,l=78) put ij=1802, kl=9373
      write(*,*) "Ranmar initialization seeds",ij,kl
c
c    18/6/2012 TJS  Added check to ensure ij and kl are in range
c      
      if (ij .lt. 0 .or. ij .gt. 31328 .or.
     $     kl .lt. 0 .or. kl .gt. 30081) then
         filename='../../error'
         INQUIRE(FILE="../../RunWeb", EXIST=file_exists)
         if(.not.file_exists) filename = '../' // filename
         open(unit=26,file=filename,status='unknown')
         if (ij .lt. 0 .or. ij .gt. 31328) then
            write(26,*) 'Bad initialization value of ij in rmarin ', ij
            write(*,*) 'Bad initialization value of ij in rmarin ', ij
         elseif (kl .lt. 0 .or. kl .gt. 30081) then
            write(26,*) 'Bad initialization value of kl in rmarin ', kl
            write(*,*) 'Bad initialization value of kl in rmarin ', kl
         endif
         stop
      endif

      i = mod( ij/177 , 177 ) + 2
      j = mod( ij     , 177 ) + 2
      k = mod( kl/169 , 178 ) + 1
      l = mod( kl     , 169 )
      do 300 ii = 1 , 97
        s =  0d0
        t = .5d0
        do 200 jj = 1 , 24
          m = mod( mod(i*j,179)*k , 179 )
          i = j
          j = k
          k = m
          l = mod( 53*l+1 , 169 )
          if(mod(l*m,64) .ge. 32) s = s + t
          t = .5d0*t
  200   continue
        ranu(ii) = s
  300 continue
      ranc  =   362436d0 / 16777216d0
      rancd =  7654321d0 / 16777216d0
      rancm = 16777213d0 / 16777216d0
      iranmr = 97
      jranmr = 33
      end

c/* ********************************************************* */
c/*  Equivalent photon approximation structure function.   * */
c/*   V.M.Budnev et al., Phys.Rep. 15C (1975) 181          * */
c/*     Improved Weizsaecker-Williams formula              * */
c/*     http://inspirehep.net/record/359425                * */  
c/* ********************************************************* */
c   provided by Tomasz Pierzchala - UCL

      real*8 function epa_lepton(x,q2max, mode)
      implicit none
      integer i, mode, imode
c     mode is +3/-3  for electron and +4/-4 for muon      
      real*8 x,phi_f
      real*8 xin(3:4)
      real*8 alpha
      real*8 f, q2min,q2max
      real*8 PI
      data PI/3.14159265358979323846/

      data xin/0.511d-3, 0.105658d0/ !electron mass in GeV

      alpha = .0072992701
      imode = abs(mode)
      
C     // x = omega/E = (E-E')/E
      if (x.lt.1) then
         q2min= xin(imode)*xin(imode)*x*x/(1-x)
         if(q2min.lt.q2max) then 
             f = alpha/2d0/PI*
     &           (2d0*xin(imode)*xin(imode)*x*(-1/q2min+1/q2max)+
     &           (2-2d0*x+x*x)/x*dlog(q2max/q2min))
            
         else
           f = 0. 
         endif
      else
         f= 0.
      endif
c      write (*,*) x,dsqrt(q2min),dsqrt(q2max),f
      if (f .lt. 0) f = 0
      epa_lepton = f

      end

      real*8 function epa_proton(x,q2max,beamid)
      integer i
      integer beamid
      real*8 x,phi_f
      real*8 xin
      real*8 alpha,qz
      real*8 f, qmi,qma, q2max
      real*8 PI
    
      integer nb_proton(2), nb_neutron(2)
      common/to_heavyion_pdg/ nb_proton, nb_neutron
      double precision mass_ion(2)
      common/to_heavyion_mass/mass_ion

      data PI/3.14159265358979323846/

      data xin/0.938/ ! proton mass in GeV

      alpha = .0072992701
      qz = 0.71

      if (nb_proton(beamid).ne.1.or.nb_neutron(beamid).ne.0)then
         xin = mass_ion(beamid)
         alpha = alpha * nb_proton(beamid)
      endif
    
C     // x = omega/E = (E-E')/E
      if (x.lt.1) then
         qmi= xin*xin*x*x/(1-x)
         if(qmi.lt.q2max) then          
            f = alpha/PI*(phi_f(x,q2max/qz)-phi_f(x,qmi/qz))*(1-x)/x
         else
            f=0.
         endif
      else
         f= 0.
      endif
      if (f .lt. 0) f = 0
      epa_proton= f
      end

      real*8 function phi_f(x,qq)
      real*8 x, qq
      real*8 y,qq1,f
      real*8 a,b,c

       a = 7.16
       b = -3.96
       c = .028

      qq1=1+qq
      y= x*x/(1-x)
      f=(1+a*y)*(-log(qq1/qq)+1/qq1+1/(2*qq1*qq1)+1/(3*qq1*qq1*qq1))
      f=f + (1-b)*y/(4*qq*qq1*qq1*qq1);
      f=f+ c*(1+y/4)*(log((qq1-b)/qq1)+b/qq1+b*b/(2*qq1*qq1)+
     $b*b*b/(3*qq1*qq1*qq1))
      phi_f= f
      end
  
      double precision function get_ion_pdf(pdf, pdg, nb_proton, nb_neutron)
C***********************************************************************
C     computing (heavy) ion contribution from proton PDF
C***********************************************************************      
      double precision pdf(-7:7)
      double precision tmppdf(-2:2)
      integer pdg
      integer nb_proton
      integer nb_neutron
      double precision tmp1, tmp2
 
      if (nb_proton.eq.1.and.nb_neutron.eq.0)then
         get_ion_pdf = pdf(pdg)
         return
      endif
      
      if (pdg.eq.1.or.pdg.eq.2) then
         tmp1 = pdf(1)
         tmp2 = pdf(2)
         tmppdf(1) = nb_proton * tmp1 + nb_neutron * tmp2
         tmppdf(2) = nb_proton * tmp2 + nb_neutron * tmp1
         get_ion_pdf = tmppdf(pdg)
      else if (pdg.eq.-1.or.pdg.eq.-2) then
         tmp1 = pdf(-1)
         tmp2 = pdf(-2)
         tmppdf(-1) = nb_proton * tmp1 + nb_neutron * tmp2
         tmppdf(-2) = nb_proton * tmp2 + nb_neutron * tmp1
         get_ion_pdf = tmppdf(pdg)
      else 
         get_ion_pdf = pdf(pdg)*(nb_proton+nb_neutron)
      endif
      
C     set correct PDF normalisation
      get_ion_pdf = get_ion_pdf * (nb_proton+nb_neutron)
      return
      end

C
C-----------------------------------------------------------------------------
C
      double precision function alfa(alfa0,qsq )
C
C-----------------------------------------------------------------------------
C
C	This function returns the 1-loop value of alpha.
C
C	INPUT: 
C		qsq   = Q^2
C
C-----------------------------------------------------------------------------
C
      implicit none
      double precision  qsq,alfa0
c
c constants
c
      double precision  One, Three, Pi,zmass
      parameter( One = 1.0d0, Three = 3.0d0 )
      parameter( Pi = 3.14159265358979323846d0 )
      parameter( zmass = 91.188d0 )
cc
      alfa = alfa0 / ( 1.0d0 - alfa0*dlog( qsq/zmass**2 ) /Three /Pi )
ccc
      return
      end

C
C-----------------------------------------------------------------------------
C
      double precision function alfaw(alfaw0,qsq,nh )
C
C-----------------------------------------------------------------------------
C
C	This function returns the 1-loop value of alpha_w.
C
C	INPUT: 
C		qsq = Q^2
C               nh  = # of Higgs doublets
C
C-----------------------------------------------------------------------------
C
      implicit none
      double precision  qsq, alphaw, dum,alfaw0
      integer  nh, nq
c
c	  include
c
	  
c
c constants
c
      double precision  Two, Four, Pi, Twpi, zmass,tmass
      parameter( Two = 2.0d0, Four = 4.0d0 )
      parameter( Pi = 3.14159265358979323846d0 )
      parameter( Twpi = 3.0d0*Four*Pi )
      parameter( zmass = 91.188d0,tmass=174d0 )
cc
      if ( qsq.ge.tmass**2 ) then
         nq = 6
      else
         nq = 5
      end if
      dum = ( 22.0d0 - Four*nq - nh/Two ) / Twpi
      alfaw = alfaw0 / ( 1.0d0 + dum*alfaw0*dlog( qsq/zmass**2 ) )
ccc
      return
      end

C-----------------------------------------------------------------------------
C
      DOUBLE PRECISION FUNCTION ALPHAS(Q)
c
c     Evaluation of strong coupling constant alpha_S
c     Author: R.K. Ellis
c
c     q -- scale at which alpha_s is to be evaluated
c
c-- common block alfas.inc
c     asmz -- value of alpha_s at the mass of the Z-boson
c     nloop -- the number of loops (1,2, or 3) at which beta 
c
c     function is evaluated to determine running.
c     the values of the cmass and the bmass should be set
c     in common block qmass.
C-----------------------------------------------------------------------------

      IMPLICIT NONE
c
      include 'alfas.inc'
      DOUBLE PRECISION Q,T,AMZ0,AMB,AMC
      DOUBLE PRECISION AS_OUT
      INTEGER NLOOP0,NF3,NF4,NF5
      PARAMETER(NF5=5,NF4=4,NF3=3)
C
      REAL*8       CMASS,BMASS
      COMMON/QMASS/CMASS,BMASS
      DATA CMASS,BMASS/1.42D0,4.7D0/  ! HEAVY QUARK MASSES FOR THRESHOLDS
C
      REAL*8 ZMASS
      DATA ZMASS/91.188D0/
C
      SAVE AMZ0,NLOOP0,AMB,AMC
      DATA AMZ0,NLOOP0/0D0,0/
      IF (Q .LE. 0D0) THEN 
         WRITE(6,*) 'q .le. 0 in alphas'
         WRITE(6,*) 'q= ',Q
         STOP
      ENDIF
      IF (asmz .LE. 0D0) THEN 
         WRITE(6,*) 'asmz .le. 0 in alphas',asmz
c         WRITE(6,*) 'continue with asmz=0.1185'
         STOP
         asmz=0.1185D0
      ENDIF
      IF (CMASS .LE. 0.3D0) THEN 
         WRITE(6,*) 'cmass .le. 0.3GeV in alphas',CMASS
c         WRITE(6,*) 'continue with cmass=1.5GeV?'
         STOP
         CMASS=1.42D0
      ENDIF
      IF (BMASS .LE. 0D0) THEN 
         WRITE(6,*) 'bmass .le. 0 in alphas',BMASS
         WRITE(6,*) 'COMMON/QMASS/CMASS,BMASS'
         STOP
         BMASS=4.7D0
      ENDIF
c--- establish value of coupling at b- and c-mass and save
      IF ((asmz .NE. AMZ0) .OR. (NLOOP .NE. NLOOP0)) THEN
         AMZ0=asmz
         NLOOP0=NLOOP
         T=2D0*DLOG(BMASS/ZMASS)
         CALL NEWTON1(T,asmz,AMB,NLOOP,NF5)
         T=2D0*DLOG(CMASS/BMASS)
         CALL NEWTON1(T,AMB,AMC,NLOOP,NF4)
      ENDIF

c--- evaluate strong coupling at scale q
      IF (Q  .LT. BMASS) THEN
           IF (Q  .LT. CMASS) THEN
             T=2D0*DLOG(Q/CMASS)
             CALL NEWTON1(T,AMC,AS_OUT,NLOOP,NF3)
           ELSE
             T=2D0*DLOG(Q/BMASS)
             CALL NEWTON1(T,AMB,AS_OUT,NLOOP,NF4)
           ENDIF
      ELSE
      T=2D0*DLOG(Q/ZMASS)
      CALL NEWTON1(T,asmz,AS_OUT,NLOOP,NF5)
      ENDIF
      ALPHAS=AS_OUT
      RETURN
      END


      SUBROUTINE NEWTON1(T,A_IN,A_OUT,NLOOP,NF)
C     Author: R.K. Ellis

c---  calculate a_out using nloop beta-function evolution 
c---  with nf flavours, given starting value as-in
c---  given as_in and logarithmic separation between 
c---  input scale and output scale t.
c---  Evolution is performed using Newton's method,
c---  with a precision given by tol.

      IMPLICIT NONE
      INTEGER NLOOP,NF
      REAL*8 T,A_IN,A_OUT,AS,TOL,F2,F3,F,FP,DELTA
      REAL*8 B0(3:5),C1(3:5),C2(3:5),DEL(3:5)
      PARAMETER(TOL=5.D-4)
C---     B0=(11.-2.*NF/3.)/4./PI
      DATA B0/0.716197243913527D0,0.66314559621623D0,0.61009394851893D0/
C---     C1=(102.D0-38.D0/3.D0*NF)/4.D0/PI/(11.D0-2.D0/3.D0*NF)
      DATA C1/.565884242104515D0,0.49019722472304D0,0.40134724779695D0/
C---     C2=(2857.D0/2.D0-5033*NF/18.D0+325*NF**2/54)
C---     /16.D0/PI**2/(11.D0-2.D0/3.D0*NF)
      DATA C2/0.453013579178645D0,0.30879037953664D0,0.14942733137107D0/
C---     DEL=SQRT(4*C2-C1**2)
      DATA DEL/1.22140465909230D0,0.99743079911360D0,0.66077962451190D0/
      F2(AS)=1D0/AS+C1(NF)*LOG((C1(NF)*AS)/(1D0+C1(NF)*AS))
      F3(AS)=1D0/AS+0.5D0*C1(NF)
     & *LOG((C2(NF)*AS**2)/(1D0+C1(NF)*AS+C2(NF)*AS**2))
     & -(C1(NF)**2-2D0*C2(NF))/DEL(NF)
     & *ATAN((2D0*C2(NF)*AS+C1(NF))/DEL(NF))

           
      A_OUT=A_IN/(1D0+A_IN*B0(NF)*T)
      IF (NLOOP .EQ. 1) RETURN
      A_OUT=A_IN/(1D0+B0(NF)*A_IN*T+C1(NF)*A_IN*LOG(1D0+A_IN*B0(NF)*T))
      IF (A_OUT .LT. 0D0) AS=0.3D0
 30   AS=A_OUT

      IF (NLOOP .EQ. 2) THEN
      F=B0(NF)*T+F2(A_IN)-F2(AS)
      FP=1D0/(AS**2*(1D0+C1(NF)*AS))
      ENDIF
      IF (NLOOP .EQ. 3) THEN
      F=B0(NF)*T+F3(A_IN)-F3(AS)
      FP=1D0/(AS**2*(1D0+C1(NF)*AS+C2(NF)*AS**2))
      ENDIF
      A_OUT=AS-F/FP
      DELTA=ABS(F/FP/AS)
      IF (DELTA .GT. TOL) GO TO 30
      RETURN
      END


C-----------------------------------------------------------------------------
C
      double precision function mfrun(mf,scale,asmz,nloop)
C
C-----------------------------------------------------------------------------
C
C	This function returns the 2-loop value of a MSbar fermion mass
C       at a given scale.
C
C	INPUT: mf    = MSbar mass of fermion at MSbar fermion mass scale 
C	       scale = scale at which the running mass is evaluated
C	       asmz  = AS(MZ) : this is passed to alphas(scale,asmz,nloop)
C              nloop = # of loops in the evolution
C       
C
C
C	EXTERNAL:      double precision alphas(scale,asmz,nloop)
C                      
C-----------------------------------------------------------------------------
C
      implicit none
C
C     ARGUMENTS
C
      double precision  mf,scale,asmz
      integer           nloop
C
C     LOCAL
C
      double precision  beta0, beta1,gamma0,gamma1
      double precision  A1,as,asmf,l2
      integer  nf
C
C     EXTERNAL
C
      double precision  alphas
      external          alphas
c
c     CONSTANTS
c
      double precision  One, Two, Three, Pi
      parameter( One = 1.0d0, Two = 2.0d0, Three = 3.0d0 )
      parameter( Pi = 3.14159265358979323846d0) 
      double precision tmass
      parameter(tmass=174d0)
cc
C
C
      if ( mf.gt.tmass ) then
         nf = 6
      else
         nf = 5
      end if

      beta0 = ( 11.0d0 - Two/Three *nf )/4d0
      beta1 = ( 102d0  - 38d0/Three*nf )/16d0
      gamma0= 1d0
      gamma1= ( 202d0/3d0  - 20d0/9d0*nf )/16d0
      A1    = -beta1*gamma0/beta0**2+gamma1/beta0
      as    = alphas(scale)
      asmf  = alphas(mf)
      l2    = (1+ A1*as/Pi)/(1+ A1*asmf/Pi)
      
      
      mfrun = mf * (as/asmf)**(gamma0/beta0)

      if(nloop.eq.2) mfrun =mfrun*l2
ccc
      return
      end

C     This File is Automatically generated by ALOHA 
C     The process calculated in this file is: 
C     Gamma(-1,2,-2)*Gamma(-1,4,-3)*ProjP(-3,1)*ProjP(-2,3)
C     
      SUBROUTINE FFFF26_0(F1, F2, F3, F4, COUP,VERTEX)
      IMPLICIT NONE
      COMPLEX*16 CI
      PARAMETER (CI=(0D0,1D0))
      COMPLEX*16 COUP
      COMPLEX*16 F1(*)
      COMPLEX*16 F2(*)
      COMPLEX*16 F3(*)
      COMPLEX*16 F4(*)
      COMPLEX*16 TMP11
      COMPLEX*16 VERTEX
      TMP11 = (F1(5)*F3(6)*(-F4(4)*F2(3)+F4(3)*F2(4))+F1(6)*F3(5)
     $ *(F4(4)*F2(3)-F4(3)*F2(4)))
      VERTEX = COUP*(-2D0 * CI * TMP11)
      END

      subroutine set_invarients(nfinal,ninvar)
c***************************************************************************
c     Calculates all of the invarients for a 2->n process
c***************************************************************************
      implicit none
c     
c     Constants
c
      include 'genps.inc'
c
c     Arguments
c
      integer nfinal,ninvar
c
c     Local
c     
      integer ip1,ip2,ipstart,ipstop,np,i
      integer ncycle
      character*10 buff
c
c     Global
c
      integer              imom(maxinvar),ninvarients
      common/to_invarients/imom          ,ninvarients
c-----
c  Begin Code
c-----

      do i=1,nfinal
         imom(i)=i
      enddo
      ipstart=1
      ipstop =nfinal
      np     =nfinal
c
c     First do all the s-channel
c
      do ncycle=2,nfinal-1
         do ip1 = ipstart,ipstop-1
            do ip2=int((real(imom(ip1))/10.-imom(ip1)/10)*10+.1)+1,
     $           nfinal
               np=np+1
               if (np .gt. maxinvar) then
                  print*,'Sorry too many invarients',np,ip1,ip2,ncycle
                  stop
               endif
               imom(np)=imom(ip1)*10+imom(ip2)
               if (imom(np) .lt. 10) then
                  write(buff,'(a2,i1)') 'S?',imom(np)
               elseif (imom(np) .lt. 100) then
                  write(buff,'(a2,i2)') 'S?',imom(np)
               elseif (imom(np) .lt. 1000) then
                  write(buff,'(a2,i3)') 'S?',imom(np)
               elseif (imom(np) .lt. 10000) then
                  write(buff,'(a2,i4)') 'S?',imom(np)
               elseif (imom(np) .lt. 100000) then
                  write(buff,'(a2,i5)') 'S?',imom(np)
               else
                  write(buff,'(a2,i6)') 'S?',imom(ip1)
               endif
c               call hbook1(100+np-nfinal,buff,100,0.,1.,0.)
c               write(*,'(i4,i6)') np-nfinal,imom(np)
               write(*,'(i4,a1,a6)') np-nfinal,'=',buff
               if ((np-nfinal)/7 .eq. real(np-nfinal)/7.) write(*,*)' '
            enddo
         enddo
         ipstart=ipstop+1
         ipstop = np
      enddo
c
c     Now do the t-channel
c
      ipstop = np
      do ip1 = 1,ipstop
c         write(*,'(i4,a2,i6)') np-nfinal+ip1,'a-',imom(ip1)
         if (imom(ip1) .lt. 10) then
            write(buff,'(a2,i1)') 'T?',imom(ip1)
         elseif (imom(ip1) .lt. 100) then
            write(buff,'(a2,i2)') 'T?',imom(ip1)
         elseif (imom(ip1) .lt. 1000) then
            write(buff,'(a2,i3)') 'T?',imom(ip1)
         elseif (imom(ip1) .lt. 10000) then
            write(buff,'(a2,i4)') 'T?',imom(ip1)
         elseif (imom(ip1) .lt. 100000) then
            write(buff,'(a2,i5)') 'T?',imom(ip1)
         else
            write(buff,'(a2,i6)') 'T?',imom(ip1)
         endif
c         call hbook1(100+np-nfinal+ip1,buff,100,0.,1.,0.)
c         write(*,*) np-nfinal+ip1,buff
         write(*,'(i4,a1,a6)') np-nfinal+ip1,'=',buff
         if ((np-nfinal+ip1)/7 .eq. real(np-nfinal+ip1)/7.) write(*,*)
      enddo
      write(*,*)
      print*,'Particles, Invarients',nfinal,np-nfinal+np
      ninvarients=np-nfinal+np
      ninvar=ninvarients
      if (ninvarients .gt. maxinvar) then
         print*,'Error too many invarients to map'
c         stop
      endif
      end


      subroutine fill_invarients(nfinal,p1,s,xx)
c***************************************************************************
c     Calculates all of the invarients for a 2->n process
c***************************************************************************
      implicit none
c     
c     Constants
c     
      include 'genps.inc'
c
c     Arguments
c
      integer nfinal
      double precision p1(0:3,nfinal+2),s,xx(55)
c
c     Local
c     
      integer ip1,ip2,ipstart,ipstop,np,i,j
      integer imom(maxinvar)
      integer ncycle
      character*10 buff
      double precision p(0:3,maxinvar),ptemp(0:3)
c
c     External
c
      double precision dot
      external         dot
c-----
c  Begin Code
c-----

      do i=1,nfinal
         imom(i) = i
         do j=0,3
            p(j,i)=p1(j,i+2)
         enddo
c         write(*,'(i3,4f17.8)') i,(p(j,i),j=0,3)
      enddo
      ipstart=1
      ipstop =nfinal
      np     =nfinal
c
c     First do all the s-channel
c
      do ncycle=2,nfinal-1
         do ip1 = ipstart,ipstop-1
            do ip2=int((real(imom(ip1))/10.-imom(ip1)/10)*10+.1)+1
     $           ,nfinal
               np=np+1
               if (np .gt. maxinvar) then
                  print*,'Sorry too many invarients',np,ip1,ip2,ncycle
                  stop
               endif
               imom(np)=imom(ip1)*10+imom(ip2)
               do j=0,3
                  p(j,np) = p(j,ip1)+p(j,ip2)
               enddo
               xx(np-nfinal) = dot(p(0,np),p(0,np))/s
c               call hfill(100+np-nfinal,
c     &              real(dot(p(0,np),p(0,np))/s),0.,wgt)
c               write(*,'(i4,3f20.8)') np-nfinal,
c     &              real(dot(p(0,np),p(0,np))/s)
            enddo
         enddo
         ipstart=ipstop+1
         ipstop = np
      enddo
c
c     Now do the t-channel
c
      ipstop = np
      do ip1 = 1,ipstop
         do j = 0,3
            ptemp(j)=p1(j,1)-p(j,ip1)
         enddo
         xx(np-nfinal+ip1)= .5d0*(dot(ptemp,ptemp)/s+1d0)
c         call hfill(100+np-nfinal+ip1,real(-dot(ptemp,ptemp)/s),0.,wgt)
c         write(*,'(i4,3f20.8)') np-nfinal+ip1,
c     &         real(-dot(ptemp,ptemp)/s)
      enddo
      end


      subroutine map_invarients(Minvar,nconfigs,ninvar,mincfig,maxcfig,nexternal,nincoming)
c****************************************************************************
c     Determines mappings for each structure of invarients onto integration
c     variables.  Input: Ninvar, iforest.  Output: Minvar, ninvar
c****************************************************************************
      implicit none
c
c     Constants
c
      include 'genps.inc'
      include 'maxconfigs.inc'
c
c     Arguments
c
      integer Minvar(maxdim,lmaxconfigs),nconfigs,ninvar,nexternal,nincoming
      integer mincfig,maxcfig
c
c     Local
c
      integer iconfig, jgrid,j, nbranch
      logical found,tchannel
c
c     Global
c
      integer              imom(maxinvar),ninvarients
      common/to_invarients/imom          ,ninvarients
      integer iforest(2,-max_branch:-1,lmaxconfigs)
      common/to_forest/ iforest

c-----
c  Begin Code
c----

      nbranch = nexternal-2
      jgrid=0
c
c     
c     Try simple mapping if nconfigs = 1
c

      if (nconfigs .eq. 1) then
c         do j=1,3*nbranch-4+2
         do j=1,maxdim
            minvar(j,mincfig)=j
         enddo
         jgrid=j-1
      else
c      if (ep) jgrid=1
c      if (pp) jgrid=2
      do iconfig=mincfig,maxcfig
         tchannel = .false.         
         do j=1,nbranch-1
            if (iforest(1,-j,iconfig) .eq. 1) then
               tchannel=.true.
            endif
            jgrid=jgrid+1
            minvar(j,iconfig) = jgrid
            if (tchannel .and. j .lt. nbranch-1) then
               jgrid=jgrid+1            
               minvar(nbranch-1+2*j,iconfig)=jgrid
            endif
         enddo             !Each Branch
         if (.not. tchannel .and. nincoming.eq.2) then          !Don't need last s-channel
            jgrid=jgrid-1
            minvar(nbranch-1,iconfig)=0
         endif
c         if (pp) then
c            jgrid=jgrid+1
c            minvar(3*nbranch-3,iconfig)=jgrid
c            jgrid=jgrid+1
c            minvar(3*nbranch-2,iconfig)=jgrid
c         elseif (ep) then
c            jgrid=jgrid+1
c            minvar(3*nbranch-3,iconfig)=jgrid
c         endif
      enddo  !Each configurations
      endif
      ninvar = jgrid
      end

      subroutine sortint(n,ra)
      integer ra(n)
      l=n/2+1
      ir=n
10    continue
        if(l.gt.1)then
          l=l-1
          rra=ra(l)
        else
          rra=ra(ir)
          ra(ir)=ra(1)
          ir=ir-1
          if(ir.eq.1)then
            ra(1)=rra
            return
          endif
        endif
        i=l
        j=l+l
20      if(j.le.ir)then
          if(j.lt.ir)then
            if(ra(j).lt.ra(j+1))j=j+1
          endif
          if(rra.lt.ra(j))then
            ra(i)=ra(j)
            i=j
            j=j+j
          else
            j=ir+1
          endif
        go to 20
        endif
        ra(i)=rra
      go to 10
      end

*
* $Id: lenocc.f,v 1.1 2009/07/30 22:46:16 madgraph Exp $
*
* $Log: lenocc.f,v $
* Revision 1.1  2009/07/30 22:46:16  madgraph
* JA: Implemented CKKW-style matching with Pythia pT-ordered showers
*
* Revision 1.1.1.1  1996/02/15 17:49:49  mclareni
* Kernlib
*
*
      FUNCTION LENOCC (CHV)
C
C CERN PROGLIB# M507    LENOCC          .VERSION KERNFOR  4.21  890323
C ORIG. March 85, A.Petrilli, re-write 21/02/89, JZ
C
C-    Find last non-blank character in CHV

      CHARACTER    CHV*(*)

      N = LEN(CHV)

      DO 17  JJ= N,1,-1
      IF (CHV(JJ:JJ).NE.' ') GO TO 99
   17 CONTINUE
      JJ = 0

   99 LENOCC = JJ
      RETURN
      END

      subroutine Zoom_Event(wgt,p)
C**************************************************************************
C     Determines if region needs to be investigated in case of large
c     weight events.
C**************************************************************************
      IMPLICIT NONE
c
c     Constant
c
      integer    max_zoom
      parameter (max_zoom=2000)
      include 'genps.inc'
      include 'nexternal.inc'

c
c     Arguments
c
      double precision wgt, p(0:3,nexternal)
c
c     Local
c
      double precision xstore(2),gstore,qstore(2)
      double precision trunc_wgt, xsum, wstore,pstore(0:3,nexternal)
      integer ix, i,j

C     
C     GLOBAL
C
      double precision twgt, maxwgt,swgt(maxevents)
      integer                             lun, nw, itmin
      common/to_unwgt/twgt, maxwgt, swgt, lun, nw, itmin
      integer nzoom
      double precision  tx(1:3,maxinvar)
      common/to_xpoints/tx, nzoom
      double precision xzoomfact
      common/to_zoom/  xzoomfact
      include 'run.inc'
      include 'coupl.inc'
c
c     DATA
c
      data trunc_wgt /-1d0/
      data xsum/0d0/
      data wstore /0d0/
      save ix, pstore, wstore, xstore, gstore, qstore
c-----
c  Begin Code
c-----
      if (trunc_Wgt .lt. 0d0 .and. twgt .gt. 0d0) then
         write(*,*) 'Selecting zoom level', twgt*500, wgt
      endif
      if (twgt .lt. 0d0) then
         write(*,*) 'Resetting zoom iteration', twgt
         twgt = -twgt
         trunc_wgt = twgt * 500d0
      endif
      if (nw .eq. 0) then
         trunc_wgt = twgt * 500d0
      endif
      trunc_wgt=max(trunc_wgt, twgt*500d0)
      if (nzoom .eq. 0 .and. trunc_wgt .gt. 0d0 ) then
         if (wgt .gt. trunc_wgt) then
            write(*,*) 'Zooming on large event ',wgt / trunc_wgt
            wstore=wgt
            do i=1,nexternal
               do j=0,3
                  pstore(j,i) = p(j,i)
               enddo
            enddo
            do i=1,2
               xstore(i)=xbk(i)
               qstore(i)=q2fact(i)
            enddo
            gstore=g
            xsum = wgt
            nzoom = max_zoom
            wgt=0d0
            ix = 1
         endif
      elseif (trunc_wgt .gt. 0 .and. wgt .gt. 0d0) then
         xsum = xsum + wgt
         if (nzoom .gt. 1) wgt = 0d0
         ix = ix + 1
      endif
      if (xsum .ne. 0d0 .and. nzoom .le. 1) then
         if (wgt .gt. 0d0) then
c            xzoomfact = xsum/real(max_zoom) / wgt !Store avg wgt
            xzoomfact = wstore / wgt  !Store large wgt
         else
            xzoomfact = -xsum/real(max_zoom)
         endif
         wgt = max(xsum/real(max_zoom),trunc_wgt)  !Don't make smaller then truncated wgt
         do i=1,nexternal
            do j=0,3
               p(j,i) = pstore(j,i)
            enddo
         enddo
         do i=1,2
            xbk(i)=xstore(i)
            q2fact(i)=qstore(i)
         enddo
         g=gstore
         write(*,'(a,2e15.3,2f15.3, i8)') 'Stored wgt ',
     $            wgt/trunc_wgt, wstore, wstore/wgt, real(ix)/max_zoom, ix
         trunc_wgt = max(trunc_wgt, wgt)
         xsum = 0d0
         nzoom = 0
      endif
      end

      subroutine clear_events
c-------------------------------------------------------------------
c     delete all events thus far, start from scratch
c------------------------------------------------------------------
      implicit none
c
c     Constants
c
      include 'genps.inc'
      include 'nexternal.inc'
c
c     Global
c
      integer iseed, nover, nstore
C     
C     GLOBAL
C
      double precision twgt, maxwgt,swgt(maxevents)
      integer                             lun, nw, itmin
      common/to_unwgt/twgt, maxwgt, swgt, lun, nw, itmin

c-----
c  Begin Code
c-----
c      write(*,*) 'storing Events'
      call store_events(-1d0, .True.)
      rewind(lun)
      nw = 0
      maxwgt = 0d0
      end
C**************************************************************************
C      HELPING ROUTINE FOR PERFORMING THE Z BOOST OF THE EVENTS
C**************************************************************************
      double precision function get_betaz(pin,pout)
C     compute the boost for the requested transformation
      implicit none
      double precision pin(0:3), pout(0:3)
      double precision denom, control

      denom = pin(0)*pout(0) - pin(3)*pout(3)
      if (denom.ne.0d0) then
         control = pin(0)*pout(0) + pin(3)*pout(3)
         if (denom/control.gt.1d-12)then
            get_betaz = (pin(3) * pout(0) - pout(3) * pin(0)) / denom
c        pass in massless case
         else if (abs(pin(0)+pin(3)).gt.abs(pin(0))) then
            get_betaz = (pin(0)**2 - pout(0)**2)/(pin(0)**2 + pout(0)**2)
         else
            get_betaz = (pout(0)**2 - pin(0)**2)/(pin(0)**2 + pout(0)**2)
         endif
         get_betaz = (pin(3) * pout(0) - pout(3) * pin(0)) / denom
      else if (pin(0).eq.pin(3)) then
         get_betaz = (pin(0)**2 - pout(0)**2)/(pin(0)**2 + pout(0)**2)
      else if (pin(0).eq.abs(pin(3))) then
         get_betaz = (pout(0)**2 - pin(0)**2)/(pin(0)**2 + pout(0)**2)
      else
         get_betaz = 0d0
      endif
      return
      end

      subroutine zboost_with_beta(pin, beta, pout)
c     apply the boost
      implicit none
      double precision pin(0:3), pout(0:3)
      double precision beta, gamma

      gamma = 1d0/DSQRT(1-beta**2)
      pout(0) = gamma * pin(0) - gamma * beta * pin(3)
      pout(1) = pin(1)
      pout(2) = pin(2)
      pout(3) = - gamma * beta * pin(0) + gamma * pin(3)
      return
      end


      SUBROUTINE unwgt(px,wgt,numproc)
C**************************************************************************
C     Determines if event should be written based on its weight
C**************************************************************************
      IMPLICIT NONE
c
c     Constants
c
      include 'genps.inc'
      include 'nexternal.inc'
c
c     Arguments
c
      double precision px(0:3,nexternal),wgt
      integer numproc
c
c     Local
c
      integer idum, i,j
      double precision uwgt,yran,fudge, p(0:3,nexternal), xwgt
C     
C     GLOBAL
C
      double precision twgt, maxwgt,swgt(maxevents)
      integer                             lun, nw, itmin
      common/to_unwgt/twgt, maxwgt, swgt, lun, nw, itmin

      double precision    matrix
      common/to_maxmatrix/matrix

      logical               zooming
      common /to_zoomchoice/zooming

c
c     External
c
      real xran1
      external xran1
c
c     Data
c
      data idum/-1/
      data yran/1d0/
      data fudge/10d0/
C-----
C  BEGIN CODE
C-----
      if (twgt .ge. 0d0) then
         do i=1,nexternal
            do j=0,3
               p(j,i)=px(j,i)
            enddo
         enddo
         xwgt = abs(wgt)
         if (zooming) call zoom_event(xwgt,P)
         if (xwgt .eq. 0d0) return
         yran = xran1(idum)
         if (xwgt .gt. twgt*fudge*yran) then
            uwgt = max(xwgt,twgt*fudge)
c           Set sign of uwgt to sign of wgt
            uwgt = dsign(uwgt,wgt)
            if (twgt .gt. 0) uwgt=uwgt/twgt/fudge
c            call write_event(p,uwgt)
c            write(29,'(2e15.5)') matrix,wgt
c $B$ S-COMMENT_C $B$
            call write_leshouche(p,uwgt,numproc,.True.)
         elseif (xwgt .gt. 0d0 .and. nw .lt. 5) then
            call write_leshouche(p,wgt/twgt*1d-6,numproc,.True.)
c $E$ S-COMMENT_C $E$
         endif
         maxwgt=max(maxwgt,xwgt)
      endif
      end

      subroutine store_events(force_max_wgt, scale_to_xsec)
C**************************************************************************
C     Takes events from scratch file (lun) and writes them to a permanent
c     file  events.dat
c     if force_max_weight =-1, then get it automatically (for a given truncation)
c     if xscale=0 then the sum of the weight will be reweighted to the cross-section.
c     computed from the last 3 iteration. otherwise the weight of each event
c     will be multiply by that value.
C**************************************************************************
      IMPLICIT NONE
c
c     Constants
c
      include 'genps.inc'
      include 'nexternal.inc'
      include 'run_config.inc'
c
c     Arguments
c
      double precision force_max_wgt 
      logical scale_to_xsec
c
c     Local
c
      integer i, lunw, ic(7,2*nexternal-3), n, j
      logical done
      double precision wgt,p(0:4,2*nexternal-3)
      double precision xsec,xsecabs,xerr,xtot
      double precision xsum, xover, target_wgt
      double precision orig_Wgt(maxevents)
      double precision xscale
      logical store_event(maxevents)
      integer iseed, nover, nstore
      double precision scale,aqcd,aqed
      double precision random
      integer ievent
      character*1000 buff
      logical u_syst
      character*(s_bufflen) s_buff(7)
      integer nclus
      character*(clus_bufflen) buffclus(nexternal)
C     
C     GLOBAL
C
      double precision twgt, maxwgt,swgt(maxevents)
      integer                             lun, nw, itmin
      common/to_unwgt/twgt, maxwgt, swgt, lun, nw, itmin

      integer                   neventswritten
      common /to_eventswritten/ neventswritten
      
      integer th_nunwgt
      double precision th_maxwgt
      common/theoretical_unwgt_max/th_maxwgt, th_nunwgt

c      save neventswritten

      integer ngroup
      common/to_group/ngroup

c
c     external
c
      real xran1

      data iseed/0/
      data neventswritten/0/
C-----
C  BEGIN CODE
C-----
c
c     First scale all of the events to the total cross section
c

      if (nw .le. 0) return
      if (scale_to_xsec) then
         call sample_result(xsecabs,xsec,xerr,itmin)
         if (xsecabs .le. 0) return !Fix by TS 12/3/2010
      else
         xscale = nw*twgt
      endif
      xtot=0
      call dsort(nw, swgt)
      do i=1,nw
         xtot=xtot+dabs(swgt(i))
      enddo
c
c     Determine minimum target weight given truncation parameter
c
      xsum = 0d0
      i = nw
      do while (xsum-dabs(swgt(i))*(nw-i) .lt. xtot*trunc_max
     $ .and. i .gt. 2)
         xsum = xsum + dabs(swgt(i))
         i = i-1
      enddo
      if (i .lt. nw) i=i+1
      th_maxwgt = dabs(swgt(i))
      if ( force_max_wgt.lt.0)then
         target_wgt = dabs(swgt(i))
      else if (.not.scale_to_xsec) then
         target_wgt = force_max_wgt / xscale
      else
         stop 1
      endif
c
c     Select events which will be written
c
      xsum = 0d0
      nstore = 0
      th_nunwgt = 0
      rewind(lun)
      done = .false. 
      do i=1,nw
         if (.not. done) then
            call read_event(lun,P,wgt,n,ic,ievent,scale,aqcd,aqed,buff,
     $           u_syst,s_buff,nclus,buffclus,done)
         else
            wgt = 0d0
         endif
         random = xran1(iseed)
         if (dabs(wgt) .gt. target_wgt*random) then
            xsum=xsum+max(dabs(wgt),target_Wgt)
            store_event(i)=.true.
            nstore=nstore+1
         else
            store_event(i) = .false.
         endif
c           we use the same seed for the two evaluation of the unweighting efficiency
         if (dabs(wgt) .gt. th_maxwgt*random) then
            th_nunwgt = th_nunwgt +1
         endif
      enddo
      if (scale_to_xsec)then
         xscale = xsecabs/xsum
      endif
      target_wgt = target_wgt*xscale
      th_maxwgt = th_maxwgt*xscale

      rewind(lun)
c     JA 8/17/2011 Don't check for previously stored events
c      if (nstore .le. neventswritten) then
c         write(*,*) 'No improvement in events',nstore, neventswritten
c         return
c      endif
      lunw = 25
      open(unit = lunw, file='events.lhe', status='unknown')
      done = .false.
      i=0      
      xtot = 0
      xover = 0
      nover = 0
      do j=1,nw
         if (.not. done) then
            call read_event(lun,P,wgt,n,ic,ievent,scale,aqcd,aqed,buff,
     $           u_syst,s_buff,nclus,buffclus,done)
         else
            write(*,*) 'Error done early',j,nw
         endif
         if (store_event(j) .and. .not. done) then
            wgt=wgt*xscale
            wgt = dsign(max(dabs(wgt), target_wgt),wgt)
            if (dabs(wgt) .gt. target_wgt) then
               xover = xover + dabs(wgt) - target_wgt
               nover = nover+1
            endif
            xtot = xtot + dabs(wgt)
            i=i+1
            call write_Event(lunw,p,wgt,n,ic,ngroup,scale,aqcd,aqed,
     $           buff,u_syst,s_buff,nclus,buffclus)
         endif
      enddo
      write(*,*) 'Found ',nw,' events.'
      write(*,*) 'Wrote ',i ,' events.'
      if (scale_to_xsec)then
         write(*,*) 'Actual xsec ',xsec
         write(*,*) 'Correct abs xsec ',xsecabs
         write(*,*) 'Event xsec ', xtot
      endif
      write(*,*) 'Events wgts > 1: ', nover
      write(*,*) '% Cross section > 1: ',xover, xover/xtot*100.
      neventswritten = i
      maxwgt = target_wgt
      if (force_max_wgt.lt.0)then
         th_maxwgt = target_wgt
         th_nunwgt = neventswritten
      endif

 99   close(lunw)
      
c      close(lun)
      end

      SUBROUTINE write_leshouche(p,wgt,numproc,do_write_events)
C**************************************************************************
C     Writes out information for event
C**************************************************************************
      IMPLICIT NONE
c
c     Constants
c
      double precision zero
      parameter       (ZERO = 0d0)
      include 'genps.inc'
      include 'nexternal.inc'
      include 'maxamps.inc'
      include 'message.inc'
      include 'cluster.inc'
      include 'run.inc'
      include 'run_config.inc'

c
c     Arguments
c
      double precision p(0:3,nexternal),wgt
      integer numproc
      logical do_write_events
c
c     Local
c
      integer i,j,k,iini,ifin
      double precision sum_wgt,sum_wgt2, xtarget,targetamp(maxflow)
      integer ip, np, ic, nc
      integer ida(2),ito(-nexternal+3:nexternal),ns,nres,ires,icloop
      integer iseed
      double precision pboost(0:3)
      double precision beta, get_betaz
      double precision ebi(0:3), ebo(0:3)
      double precision ptcltmp(nexternal), pdum(0:3)
      integer beam_number
      
      integer idup(nexternal,maxproc,maxsproc)
      integer mothup(2,nexternal)
      integer icolup(2,nexternal,maxflow,maxsproc)

      integer nsym

      integer ievent
      logical flip

      real ran1
      external ran1

      character*40 cfmt
C     
C     GLOBAL
C
      double precision twgt, maxwgt,swgt(maxevents)
      integer                             lun, nw, itmin
      common/to_unwgt/twgt, maxwgt, swgt, lun, nw, itmin

      integer          IPSEL
      COMMON /SubProc/ IPSEL

      Double Precision amp2(maxamps), jamp2(0:maxflow)
      common/to_amps/  amp2,       jamp2

      character*101       hel_buf
      common/to_helicity/hel_buf

      integer           mincfig, maxcfig
      common/to_configs/mincfig, maxcfig

      double precision stot,m1,m2
      common/to_stot/stot,m1,m2

      INTEGER IMIRROR
      INTEGER IPROC
      COMMON/TO_MIRROR/IMIRROR, IPROC
c
c     Data
c
      include 'leshouche.inc'
      data iseed /0/

      double precision pmass(nexternal), tmp
      common/to_mass/  pmass

c      integer ncols,ncolflow(maxamps),ncolalt(maxamps)
c      common/to_colstats/ncols,ncolflow,ncolalt,ic
c      data ncolflow/maxamps*0/
c      data ncolalt/maxamps*0/

      include 'coupl.inc'

      include 'lhe_event_infos.inc'
      data AlreadySetInBiasModule/.False./

      include 'symswap.inc'
C-----
C  BEGIN CODE
C-----
      
      if ((nw .ge. maxevents).and.do_write_events) return

C     if all the necessary inputs to write the events have already been
C     computed in the bias module, then directly jump to write_events
      if (AlreadySetInBiasModule) then
        goto 1123
      endif

c
c     In case of identical particles symmetry, choose assignment
c
      xtarget = ran1(iseed)*nsym
      jsym = 1
      do while (xtarget .gt. jsym .and. jsym .lt. nsym)
         jsym = jsym+1
      enddo
c
c     Fill jpart color and particle info
c
      do i=1,nexternal
         jpart(1,isym(i,jsym)) = idup(i,ipsel,numproc)
         jpart(2,isym(i,jsym)) = mothup(1,i)
         jpart(3,isym(i,jsym)) = mothup(2,i)
c        Color info is filled in mothup
         jpart(4,isym(i,jsym)) = 0
         jpart(5,isym(i,jsym)) = 0
         jpart(6,isym(i,jsym)) = 1
      enddo
      do i=1,nincoming
         jpart(6,isym(i,jsym))=-1
      enddo

c   Set helicities
c      write(*,*) 'Getting helicity',hel_buf(1:50)
      read(hel_buf,'(20i5)') (jpart(7,isym(i, jsym)),i=1,nexternal)
c      write(*,*) 'ihel',jpart(7,1),jpart(7,2)

c   Fix ordering of ptclus
      do i=1,nexternal
        ptcltmp(isym(i,jsym)) = ptclus(i)
      enddo
      do i=1,nexternal
        ptclus(i) = ptcltmp(i)
      enddo

c     Check if we have flipped particle 1 and 2, and flip back
      flip = .false.
      if (p(3,1).lt.0) then
         do j=0,3
            pdum(j)=p(j,1)
            p(j,1)=p(j,2)
            p(j,2)=pdum(j)
         enddo
         flip = .true.
      endif

c
c     Boost momentum to lab frame
c
      pboost(0)=1d0
      pboost(1)=0d0
      pboost(2)=0d0
      pboost(3)=0d0
      if (nincoming.eq.2) then
         if (xbk(1) .gt. 0d0 .and. xbk(1) .le. 1d0 .and.
     $       xbk(2) .gt. 0d0 .and. xbk(2) .le. 1d0) then
            if(lpp(2).ne.0.and.(xbk(1).eq.1d0.or.pmass(1).eq.0d0)) then
               ! construct the beam momenta in each frame and compute the related (z)boost
               ebi(0) = p(0,1)/xbk(1) ! this assumes that particle 1 is massless or mass equal to beam
               ebi(1) = 0
               ebi(2) = 0
               ebi(3) = DSQRT(ebi(0)**2-m1**2)
               ebo(0) = ebeam(1)
               ebo(1) = 0
               ebo(2) = 0
               ebo(3) = DSQRT(ebo(0)**2-m1**2)
               beta = get_betaz(ebi, ebo)
            else
               ebi(0) = p(0,2)/xbk(2) ! this assumes that particle 2 is massless or mass equal to beam
               ebi(1) = 0
               ebi(2) = 0
               ebi(3) = -1d0*DSQRT(ebi(0)**2-m2**2)
               ebo(0) = ebeam(2)
               ebo(1) = 0
               ebo(2) = 0
               ebo(3) = -1d0*DSQRT(ebo(0)**2-m2**2)
               beta = get_betaz(ebi, ebo)
               ! wrong boost if both parton are massive!
            endif
         else
            write(*,*) 'Warning bad x1 or x2 in write_leshouche',
     $           xbk(1),xbk(2)
         endif
         do j=1,nexternal
            call zboost_with_beta(p(0,j),beta,pb(0,isym(j,jsym)))
            pb(4,isym(j,jsym))=pmass(j)
         enddo
      else
         do j=1,nexternal
            call boostx(p(0,j),pboost,pb(0,isym(j,jsym)))
            ! Add mass information in pb(4)
            pb(4,isym(j,jsym))=pmass(j)
         enddo
      endif

      if (IMIRROR.eq.2.and.pmass(1).ne.pmass(2)) then
c        Note that in this context isym(1,jsym) should never be "2" since the mass differ 
         pb(4,isym(1,jsym))=pmass(2)
         pb(4,isym(2,jsym))=pmass(1)
      endif

c
c     Add info on resonant mothers
c
      call addmothers(ipsel,jpart,pb,isym,jsym,sscale,aaqcd,aaqed,buff,
     $                npart,numproc,flip)

      if (nincoming.eq.1)then
        do i=-nexternal+3,2*nexternal-3
            if (jpart(2,i).eq.1)then
                 jpart(3,i) = 0
            endif
        enddo
      endif
c
c     Write events to lun
c
      if(q2fact(1).gt.0.and.q2fact(2).gt.0)then
         sscale = sqrt(max(q2fact(1),q2fact(2)))
      else if(q2fact(1).gt.0)then
         sscale = sqrt(q2fact(1))
      else if(q2fact(2).gt.0)then
         sscale = sqrt(q2fact(2))
      else
         sscale = 0d0
      endif
      aaqcd = g*g/4d0/3.1415926d0
      aaqed = gal(1)*gal(1)/4d0/3.1415926d0

      if (btest(mlevel,3)) then
        write(*,*)' write_leshouche: SCALUP to: ',sscale
      endif
      
c     Write out buffer for systematics studies
      ifin=1
      if(use_syst)then
c         print *,'Systematics:'
c         print *,'s_scale: ',s_scale
c         print *,'n_qcd,n_alpsem: ',n_qcd,n_alpsem
c         print *,'s_qalps: ',(s_qalps(I),I=1,n_alpsem) 
c         print *,'n_pdfrw: ',n_pdfrw
c         print *,'i_pdgpdf: ',((i_pdgpdf(i,j),i=1,n_pdfrw(j)),j=1,2)
c         print *,'s_xpdf: ',((s_xpdf(i,j),i=1,n_pdfrw(j)),j=1,2)
c         print *,'s_qpdf: ',((s_qpdf(i,j),i=1,n_pdfrw(j)),j=1,2)
         s_buff(1) = '<mgrwt>'
         write(s_buff(2), '(a,I3,E15.8,a)') '<rscale>',n_qcd-n_alpsem,
     $        s_scale,'</rscale>'
         if(n_alpsem.gt.0) then
            write(cfmt,'(a,I1,a)') '(a,I3,',n_alpsem,'E15.8,a)'
            write(s_buff(3), cfmt) '<asrwt>',n_alpsem,
     $           (s_qalps(I),I=1,n_alpsem) ,'</asrwt>'
         else
            write(s_buff(3), '(a)') '<asrwt>0</asrwt>'
         endif
         beam_number = 1
         if (flip) then
            beam_number =2
         endif
         
         if(n_pdfrw(1).gt.0.and.abs(lpp(1)).eq.1)then
            if(2*n_pdfrw(1).lt.10) then
               write(cfmt,'(a,I1,a,I1,a)') '(a,I1,a,I3,',
     $              n_pdfrw(1),'I9,',2*n_pdfrw(1),'E15.8,a)'
            else
               write(cfmt,'(a,I1,a,I2,a)') '(a,I1,a,I3,',
     $              n_pdfrw(1),'I9,',2*n_pdfrw(1),'E15.8,a)'
            endif
            
            write(s_buff(4), cfmt) '<pdfrwt beam="', beam_number, '">',
     $           n_pdfrw(1),(i_pdgpdf(i,1),i=1,n_pdfrw(1)),
     $           (s_xpdf(i,1),i=1,n_pdfrw(1)),
     $           (s_qpdf(i,1),i=1,n_pdfrw(1)),
     $           '</pdfrwt>'
         else
            write(s_buff(4), '(a,I1,a)') '<pdfrwt beam="',
     $       beam_number,'">0</pdfrwt>'
         endif
         beam_number = 2
         if (flip) then
            beam_number	= 1
         endif
         if(n_pdfrw(2).gt.0.and.abs(lpp(2)).eq.1)then
            if(2*n_pdfrw(2).lt.10) then
               write(cfmt,'(a,I1,a,I1,a)') '(a,I1,a,I3,',
     $              n_pdfrw(2),'I9,',2*n_pdfrw(2),'E15.8,a)'
            else
               write(cfmt,'(a,I1,a,I2,a)') '(a,I1,a,I3,',
     $              n_pdfrw(2),'I9,',2*n_pdfrw(2),'E15.8,a)'
            endif
            write(s_buff(5), cfmt) '<pdfrwt beam="',beam_number,'">',
     $           n_pdfrw(2),(i_pdgpdf(i,2),i=1,n_pdfrw(2)),
     $           (s_xpdf(i,2),i=1,n_pdfrw(2)),
     $           (s_qpdf(i,2),i=1,n_pdfrw(2)),
     $           '</pdfrwt>'
         else
            write(s_buff(5), '(a)') '<pdfrwt beam="2">0</pdfrwt>'
         endif
         write(s_buff(6), '(a,E15.8,a)') '<totfact>',s_rwfact,
     $        '</totfact>'
         s_buff(7) = '</mgrwt>'
      endif

c     Write out buffers for clustering info
      nclus=0
      if(icluster(1,1).ne.0 .and. ickkw.ne.0 .and. clusinfo)then
         nclus=nexternal
         write(buffclus(1),'(a)')'<clustering>'
         do i=1,nexternal-2
            write(buffclus(i+1),'(a13,f9.3,a2,4I3,a7)') '<clus scale="',
     $           dsqrt(pt2ijcl(i)),'">',(icluster(j,i),j=1,4),'</clus>'
         enddo
         write(buffclus(nexternal),'(a)')'</clustering>'
      endif

C     If the arguments of write_event have already been set in the
C     bias module, then the beginning of the routine will directly
C     jump here.

 1123 continue
      if (.not.do_write_events) then
        return
      endif

c     Store weight for event
      nw = nw+1
      swgt(nw)=wgt

      call write_event(lun,pb(0,1),wgt,npart,jpart(1,1),ngroup,
     &   sscale,aaqcd,aaqed,buff,use_syst,s_buff,nclus,buffclus)
      if(btest(mlevel,1))
     &   call write_event(6,pb(0,1),wgt,npart,jpart(1,1),ngroup,
     &   sscale,aaqcd,aaqed,buff,use_syst,s_buff,nclus,buffclus)

      end
      
      integer function n_unwgted()
c************************************************************************
c     Determines the number of unweighted events which have been written
c************************************************************************
      implicit none
c
c     Parameter
c
      include 'genps.inc'
      include 'nexternal.inc'
c
c     Local
c
      integer i
      double precision xtot, sum
C     
C     GLOBAL
C
      double precision twgt, maxwgt,swgt(maxevents)
      integer                             lun, nw, itmin
      common/to_unwgt/twgt, maxwgt, swgt, lun, nw, itmin
c-----
c  Begin Code
c-----

c      write(*,*) 'Sorting ',nw
      if (nw .gt. 1) call dsort(nw,swgt)
      sum = 0d0
      do i=1,nw
         sum=sum+swgt(i)
      enddo
      xtot = 0d0
      i = nw
      do while (xtot .lt. sum/100d0 .and. i .gt. 2)    !Allow for 1% accuracy
         xtot = xtot + swgt(i)
         i=i-1
      enddo
      if (i .lt. nw) i = i+1
c      write(*,*) 'Found ',nw,' events'
c      write(*,*) 'Integrated weight',sum
c      write(*,*) 'Maximum wgt',swgt(nw), swgt(i)
c      write(*,*) 'Average wgt', sum/nw
c      write(*,*) 'Unweight Efficiency', (sum/nw)/swgt(i)
      n_unwgted = sum/swgt(i)
c      write(*,*) 'Number unweighted ',sum/swgt(i), nw
      if (nw .ge. maxevents) n_unwgted = -sum/swgt(i)
      end


      subroutine dsort(n,ra)
      integer n
      double precision ra(n),rra

      l=n/2+1
      ir=n
10    continue
        if(l.gt.1)then
          l=l-1
          rra=ra(l)
        else
          rra=ra(ir)
          ra(ir)=ra(1)
          ir=ir-1
          if(ir.eq.1)then
            ra(1)=rra
            return
          endif
        endif
        i=l
        j=l+l
20      if(j.le.ir)then
          if(j.lt.ir)then
            if(dabs(ra(j)).lt.dabs(ra(j+1))) j=j+1
          endif
          if(dabs(rra).lt.dabs(ra(j)))then
            ra(i)=ra(j)
            i=j
            j=j+j
          else
            j=ir+1
          endif
        go to 20
        endif
        ra(i)=rra
      go to 10
      end

      subroutine pftopdg(ih,x,q,pdf)
c***************************************************************************
c     Wrapper for calling the pdf of MCFM
c***************************************************************************
      implicit none
c
c     Arguments
c
      DOUBLE  PRECISION x,q,pdf(-7:7)
      INTEGER IH
C
C     Include
C
      include 'pdf.inc'
C      
      call fdist(ih,x, q, pdf)

      return	
      end


      subroutine fdist(ih,x,xmu,fx)
C***********************************************************************
C     MCFM PDF CALLING ROUTINE
C***********************************************************************
      implicit none
      integer ih,i
      double precision fx(-7:7),x,xmu,nnfx(-6:7)
      double precision u_val,d_val,u_sea,d_sea,s_sea,c_sea,b_sea,gluon
      double precision Ctq3df,Ctq4Fn,Ctq5Pdf,Ctq6Pdf,Ctq5L
      double precision q2max
      double precision epa_lepton,epa_proton
      include 'pdf.inc'

      integer mode,Iprtn,Irt

      do Iprtn=-7,7
         fx(Iprtn)=0d0
      enddo
C---  set to zero if x out of range
      if (x .ge. 1d0) then
         return
      endif
      if (pdlabel(1:4) .eq. 'nn23') then
         call NNevolvePDF(x,xmu,nnfx)
         do i=-5,5
            fx(i)=nnfx(i)/x
         enddo
         fx(7)=nnfx(7)/x
c      elseif     ((pdlabel(1:3) .eq. 'mrs')
c     .   .or. (pdlabel(2:4) .eq. 'mrs')) then
c
c             if     (pdlabel .eq. 'mrs02nl') then
c             mode=1
c             call mrst2002(x,xmu,mode,u_val,d_val,u_sea,d_sea,
c     &                          s_sea,c_sea,b_sea,gluon)
c             elseif     (pdlabel .eq. 'mrs02nn') then
c             mode=2
c             call mrst2002(x,xmu,mode,u_val,d_val,u_sea,d_sea,
c     &                          s_sea,c_sea,b_sea,gluon)
c             elseif     (pdlabel .eq. 'mrs0119') then
c             mode=1
c             call mrst2001(x,xmu,mode,u_val,d_val,u_sea,d_sea,
c     &                          s_sea,c_sea,b_sea,gluon)
c             elseif (pdlabel .eq. 'mrs0117') then
c             mode=2
c             call mrst2001(x,xmu,mode,u_val,d_val,u_sea,d_sea,
c     &                          s_sea,c_sea,b_sea,gluon)
c             elseif (pdlabel .eq. 'mrs0121') then
c             mode=3
c             call mrst2001(x,xmu,mode,u_val,d_val,u_sea,d_sea,
c     &                          s_sea,c_sea,b_sea,gluon)
c             elseif (pdlabel .eq. 'mrs01_j') then
c             mode=4
c             call mrst2001(x,xmu,mode,u_val,d_val,u_sea,d_sea,
c     &                          s_sea,c_sea,b_sea,gluon)
c             elseif     (pdlabel .eq. 'mrs99_1') then
c             mode=1
c             call mrs99(x,xmu,mode,u_val,d_val,u_sea,d_sea,
c     &                          s_sea,c_sea,b_sea,gluon)
c             elseif (pdlabel .eq. 'mrs99_2') then
c             mode=2
c             call mrs99(x,xmu,mode,u_val,d_val,u_sea,d_sea,
c     &                          s_sea,c_sea,b_sea,gluon)
c             elseif (pdlabel .eq. 'mrs99_3') then
c             mode=3
c             call mrs99(x,xmu,mode,u_val,d_val,u_sea,d_sea,
c     &                          s_sea,c_sea,b_sea,gluon)
c             elseif (pdlabel .eq. 'mrs99_4') then
c             mode=4
c             call mrs99(x,xmu,mode,u_val,d_val,u_sea,d_sea,
c     &                          s_sea,c_sea,b_sea,gluon)
c             elseif (pdlabel .eq. 'mrs99_5') then
c             mode=5
c             call mrs99(x,xmu,mode,u_val,d_val,u_sea,d_sea,
c     &                          s_sea,c_sea,b_sea,gluon)
c             elseif (pdlabel .eq. 'mrs99_6') then
c             mode=6
c             call mrs99(x,xmu,mode,u_val,d_val,u_sea,d_sea,
c     &                          s_sea,c_sea,b_sea,gluon)
c             elseif (pdlabel .eq. 'mrs99_7') then
c             mode=7
c             call mrs99(x,xmu,mode,u_val,d_val,u_sea,d_sea,
c     &                          s_sea,c_sea,b_sea,gluon)
c             elseif (pdlabel .eq. 'mrs99_8') then
c             mode=8
c             call mrs99(x,xmu,mode,u_val,d_val,u_sea,d_sea,
c     &                          s_sea,c_sea,b_sea,gluon)
c             elseif (pdlabel .eq. 'mrs99_9') then
c             mode=9
c             call mrs99(x,xmu,mode,u_val,d_val,u_sea,d_sea,
c     &                          s_sea,c_sea,b_sea,gluon)
c             elseif (pdlabel .eq. 'mrs9910') then
c             mode=10
c             call mrs99(x,xmu,mode,u_val,d_val,u_sea,d_sea,
c     &                          s_sea,c_sea,b_sea,gluon)
c             elseif (pdlabel .eq. 'mrs9911') then
c             mode=11
c             call mrs99(x,xmu,mode,u_val,d_val,u_sea,d_sea,
c     &                          s_sea,c_sea,b_sea,gluon)
c             elseif (pdlabel .eq. 'mrs9912') then
c             mode=12
c             call mrs99(x,xmu,mode,u_val,d_val,u_sea,d_sea,
c     &                          s_sea,c_sea,b_sea,gluon)
c             elseif (pdlabel .eq. 'mrs98z1') then
c             mode=1
c             call mrs98(x,xmu,mode,u_val,d_val,u_sea,d_sea,
c     &                          s_sea,c_sea,b_sea,gluon)
c             elseif (pdlabel .eq. 'mrs98z2') then
c             mode=2 
c             call mrs98(x,xmu,mode,u_val,d_val,u_sea,d_sea,
c     &                          s_sea,c_sea,b_sea,gluon)
c             elseif (pdlabel .eq. 'mrs98z3') then
c             mode=3
c             call mrs98(x,xmu,mode,u_val,d_val,u_sea,d_sea,
c     &                          s_sea,c_sea,b_sea,gluon)
c             elseif (pdlabel .eq. 'mrs98z4') then
c             mode=4
c             call mrs98(x,xmu,mode,u_val,d_val,u_sea,d_sea,
c     &                          s_sea,c_sea,b_sea,gluon)
c             elseif (pdlabel .eq. 'mrs98z5') then
c             mode=5
c             call mrs98(x,xmu,mode,u_val,d_val,u_sea,d_sea,
c     &                          s_sea,c_sea,b_sea,gluon)
c             elseif (pdlabel .eq. 'mrs98l1') then
c             mode=1
c             call mrs98lo(x,xmu,mode,u_val,d_val,u_sea,d_sea,
c     &                          s_sea,c_sea,b_sea,gluon)
c             elseif (pdlabel .eq. 'mrs98l2') then
c             mode=2 
c             call mrs98lo(x,xmu,mode,u_val,d_val,u_sea,d_sea,
c     &                          s_sea,c_sea,b_sea,gluon)
c             elseif (pdlabel .eq. 'mrs98l3') then
c             mode=3
c             call mrs98lo(x,xmu,mode,u_val,d_val,u_sea,d_sea,
c     &                          s_sea,c_sea,b_sea,gluon)
c             elseif (pdlabel .eq. 'mrs98l4') then
c             mode=4
c             call mrs98lo(x,xmu,mode,u_val,d_val,u_sea,d_sea,
c     &                          s_sea,c_sea,b_sea,gluon)
c             elseif (pdlabel .eq. 'mrs98l5') then
c             mode=5
c             call mrs98lo(x,xmu,mode,u_val,d_val,u_sea,d_sea,
c     &                          s_sea,c_sea,b_sea,gluon)
c             elseif (pdlabel .eq. 'mrs98ht') then
c             mode=1
c             call mrs98ht(x,xmu,mode,u_val,d_val,u_sea,d_sea,
c     &                          s_sea,c_sea,b_sea,gluon)
c             endif
c-----assign mrs to standard grid
c            fx(-5)=b_sea/x
c            fx(-4)=c_sea/x
c            fx(-3)=s_sea/x
c            fx( 0)=gluon/x
c            fx(+3)=fx(-3)
c            fx(+4)=fx(-4)
c            fx(+5)=fx(-5)
c               fx(1)=(d_val+d_sea)/x
c               fx(2)=(u_val+u_sea)/x
c               fx(-1)=d_sea/x
c               fx(-2)=u_sea/x
C
c      elseif (pdlabel(1:5) .eq. 'cteq3') then
C     
c         if (pdlabel .eq. 'cteq3_m') then
c            mode=1
c         elseif (pdlabel .eq. 'cteq3_l') then
c            mode=2
c         elseif (pdlabel .eq. 'cteq3_d') then
c            mode=3
c         endif
c         fx(-5)=Ctq3df(mode,-5,x,xmu,Irt)/x
c         fx(-4)=Ctq3df(mode,-4,x,xmu,Irt)/x
c         fx(-3)=Ctq3df(mode,-3,x,xmu,Irt)/x
c         
c         fx(0)=Ctq3df(mode,0,x,xmu,Irt)/x
c         
c         fx(+3)=Ctq3df(mode,+3,x,xmu,Irt)/x
c         fx(+4)=Ctq3df(mode,+4,x,xmu,Irt)/x
c         fx(+5)=Ctq3df(mode,+5,x,xmu,Irt)/x
c            fx(-1)=Ctq3df(mode,-2,x,xmu,Irt)/x
c            fx(-2)=Ctq3df(mode,-1,x,xmu,Irt)/x
c            fx(1)=Ctq3df(mode,+2,x,xmu,Irt)/x+fx(-1)
c            fx(2)=Ctq3df(mode,+1,x,xmu,Irt)/x+fx(-2)
C     
c      elseif (pdlabel(1:5) .eq. 'cteq4') then
C     
c         if (pdlabel .eq. 'cteq4_m') then
c            mode=1
c         elseif (pdlabel .eq. 'cteq4_d') then
c            mode=2
c         elseif (pdlabel .eq. 'cteq4_l') then
c            mode=3
c         elseif (pdlabel .eq. 'cteq4a1') then
c            mode=4
c         elseif (pdlabel .eq. 'cteq4a2') then
c            mode=5
c         elseif (pdlabel .eq. 'cteq4a3') then
c            mode=6
c         elseif (pdlabel .eq. 'cteq4a4') then
c            mode=7
c         elseif (pdlabel .eq. 'cteq4a5') then
c            mode=8
c         elseif (pdlabel .eq. 'cteq4hj') then
c            mode=9
c         elseif (pdlabel .eq. 'cteq4lq') then
c            mode=10
c         endif
c         
c         fx(-5)=Ctq4Fn(mode,-5,x,xmu)
c         fx(-4)=Ctq4Fn(mode,-4,x,xmu)
c         fx(-3)=Ctq4Fn(mode,-3,x,xmu)
c         
c         fx(0)=Ctq4Fn(mode,0,x,xmu)
c         
c         fx(+3)=Ctq4Fn(mode,+3,x,xmu)
c         fx(+4)=Ctq4Fn(mode,+4,x,xmu)
c         fx(+5)=Ctq4Fn(mode,+5,x,xmu)
c            fx(1)=Ctq4Fn(mode,+2,x,xmu)
c            fx(2)=Ctq4Fn(mode,+1,x,xmu)
c            fx(-1)=Ctq4Fn(mode,-2,x,xmu)
c            fx(-2)=Ctq4Fn(mode,-1,x,xmu)
C
c      elseif (pdlabel .eq. 'cteq5l1') then
C
c         fx(-5)=Ctq5L(-5,x,xmu)
c         fx(-4)=Ctq5L(-4,x,xmu)
c         fx(-3)=Ctq5L(-3,x,xmu)
c         
c         fx(0)=Ctq5L(0,x,xmu)
c         
c         fx(+3)=Ctq5L(+3,x,xmu)
c         fx(+4)=Ctq5L(+4,x,xmu)
c         fx(+5)=Ctq5L(+5,x,xmu)
c         
c            fx(1)=Ctq5L(+2,x,xmu)
c            fx(2)=Ctq5L(+1,x,xmu)
c            fx(-1)=Ctq5L(-2,x,xmu)
c            fx(-2)=Ctq5L(-1,x,xmu)
C         
c      elseif ((pdlabel(1:5) .eq. 'cteq5') .or. 
c     .        (pdlabel(1:4) .eq. 'ctq5')) then
C         
c         fx(-5)=Ctq5Pdf(-5,x,xmu)
c         fx(-4)=Ctq5Pdf(-4,x,xmu)
c         fx(-3)=Ctq5Pdf(-3,x,xmu)
c         
c         fx(0)=Ctq5Pdf(0,x,xmu)
c         
c         fx(+3)=Ctq5Pdf(+3,x,xmu)
c         fx(+4)=Ctq5Pdf(+4,x,xmu)
c         fx(+5)=Ctq5Pdf(+5,x,xmu)
c         
c            fx(1)=Ctq5Pdf(+2,x,xmu)
c            fx(2)=Ctq5Pdf(+1,x,xmu)
c            fx(-1)=Ctq5Pdf(-2,x,xmu)
c            fx(-2)=Ctq5Pdf(-1,x,xmu)
C                  
      elseif (pdlabel(1:5) .eq. 'cteq6') then
C         
         fx(-5)=Ctq6Pdf(-5,x,xmu)
         fx(-4)=Ctq6Pdf(-4,x,xmu)
         fx(-3)=Ctq6Pdf(-3,x,xmu)
         
         fx(0)=Ctq6Pdf(0,x,xmu)
         
         fx(+3)=Ctq6Pdf(+3,x,xmu)
         fx(+4)=Ctq6Pdf(+4,x,xmu)
         fx(+5)=Ctq6Pdf(+5,x,xmu)
         
            fx(1)=Ctq6Pdf(+2,x,xmu)
            fx(2)=Ctq6Pdf(+1,x,xmu)
            fx(-1)=Ctq6Pdf(-2,x,xmu)
            fx(-2)=Ctq6Pdf(-1,x,xmu)
      endif      
c
c  a "diffractive" photon
c      
      q2max=xmu*xmu
      if(abs(ih) .eq. 3.or.abs(ih) .eq. 4) then  !from the electron
          fx(7)=epa_lepton(x,q2max, ih)
      elseif(ih .eq. 2) then  !from a proton without breaking
          fx(7)=epa_proton(x,q2max)
      endif      
      
      return
      end
      
  

        subroutine hbook2(id,inlabel,nx,xmin,xmax,ny,ymin,ymax,zinitial)
C
C               id = integer used to identify histogram to HFILL
C               inlabel = label to be written on the output by the plotting
C                               program (character of len <=40)
C               nx = number of x bins (integer)
C               xmin = min x value (real)
C               xmax = max x value (real)
C               ny,ymin,ymax = same for y values
C               zinitial = initial value for each bin (real)
C
        include 'hbook.inc'
        character*(*) inlabel

        if (nhist .eq. nhistmax) then
                print*,' Maximum number of histograms exceeded'
        else
                nhist = nhist+1
                label(nhist) = inlabel
                id number(nhist) = id
                single dim(nhist) = .false.
                k=pointer(nhist)
                pointer(nhist+1) = nx*ny+6+k
                data(k)=nx
                data(k+1)=xmin
                data(k+2)=xmax
                data(k+3)=ny
                data(k+4)=ymin
                data(k+5)=ymax
                do i=k+6,pointer(nhist+1)-1
                        data(i)=zinitial
                        end do
                end if
        return
        end

      integer function f_get_nargs(ndim)
c**************************************************************************
c     Returns number of arguments which come from x_to_f_arg
c**************************************************************************
      implicit none
      include 'nexternal.inc'
      integer ndim
      f_get_nargs=4*nexternal+2      !All 4-momentum and x1,x2
      end

      subroutine x_to_f_arg(ndim,iconfig,mincfig,maxcfig,invar,wgt,x,p)
c**************************************************************************
c     This is a routine called from sample to transform the integration
c     variables into the arguments of the function. Often these will be
c     4 momentum, but it could also be a trivial 1->1 mapping.
c
c     INPUTS:  ndim     == number of dimensions
c              iconfig  == configuration working on
c              mincfig  == First configuration to include
c              maxcfig  == Last configuration to include
c              invar    == Number of invarients we are mapping (ndim*maxcfig)
c              wgt      == wgt for choosing point thus far. 1/npnts*iter
c     OUTPUTS: wgt      == updated weight after choosing points
c              x        == points choosen from sample grid
c              p        == transformed points call is f(p(x))
c     COMMON:
c           hel_picked  == Modified integer in gen_ps.inc to pass the
c                          chosen helicity configuration to matrix<i>.f
c
c**************************************************************************
      implicit none
c
c     Constants
c
      include 'genps.inc'
c
c     Arguments
c
      integer ndim                             !Number of dimensions(input)
      integer iconfig                          !Configuration (input)
      integer mincfig,maxcfig                  !Range of configurations
      integer invar
      double precision wgt                     !(input and output)
      double precision x(*),p(*)     !x,p (output) [p(0:3,nexternal)]
c
c     Local
c
c
c     External
c     
c
c     Global
c
      INTEGER                    ISUM_HEL
      LOGICAL                    MULTI_CHANNEL
      COMMON/TO_MATRIX/ISUM_HEL, MULTI_CHANNEL
c-----
c  Begin Code
c-----
      call gen_mom(iconfig,mincfig,maxcfig,invar,wgt,x,p)
C     Pick the helicity configuration from the DiscreteSampler if user
C     decided to perform MC over helicity configurations.
      if(ISUM_HEL.ne.0) then
        call sample_get_discrete_x(wgt,hel_picked,iconfig,'Helicity')
      endif
      end

      subroutine gen_mom(iconfig,mincfig,maxcfig,invar,wgt,x,p1)
c**************************************************************************
c
c     Routine to generate 4 momentum based on tree-level decomposition
c     using generalized s,t,u variables as integration variables. Need to
c     describe different configurations using variable iforest.
c     
c     INPUTS:    iconfig   == Current configuration working on
c                mincfig   == First configuration to include
c                maxcfig   == Last configuration to include
c                wgt       == wgt for choosing x's so far.
c     OUTPUTS:   wgt       == updated wgt including all configs
c                x()       == Integration variabls for all configs
c                p1(0:3,n) == 4 momentum of external particles
c
c     REQUIRES: IFOREST() set in data statement (see configs.inc)
c               NEXTERNAL set in data statement (see genps.inc)
c
c     Note regarding integration variables mapping to invarients
c     the first nbranch variables go for the masses of branches -1,-2,..
c     For each t-channel invarient x(ndim-1), x(ndim-3), .... are used
c     in place of the cos(theta) variable used in s-channel.
c     x(ndim), x(ndim-2),.... are the phi angles.
c**************************************************************************
      implicit none
c
c     Constants
c
      include 'genps.inc'
      include 'maxconfigs.inc'
      include 'nexternal.inc'
      include 'maxamps.inc'
      double precision pi
      parameter       (pi=3.1415926d0)
c
c     Arguments
c
      integer iconfig,mincfig,maxcfig,invar
      double precision p1(0:3,nexternal+1)
      double precision x(*)
      double precision wgt
c
c     Local
c
      integer nbranch,ndim
      integer i,j,jconfig,n,ipole
      double precision P(0:3,-max_branch:max_particles),xx(maxinvar)
      double precision M(-max_branch:max_particles)
      double precision s(-max_branch:0), pole_type
      integer nparticles,nfinal
      double precision jac,sjac,pswgt,pwgt(maxconfigs),flux
      double precision tprb, mtot
      double precision xtau, dum
      double precision pi1(0:3),pi2(0:3),p0,p3
      save m

      integer sprop(maxsproc,-max_branch:-1,lmaxconfigs)
      integer tprid(-max_branch:-1,lmaxconfigs)
      common/to_sprop/sprop,tprid
      logical firsttime

      double precision xprop(3,nexternal),tprop(3,nexternal)
      double precision maxwgt
      integer imatch
      save maxwgt

      integer ninvar
      
c
c     External
c
      double precision lambda,dot,dsig
      logical passcuts
c
c     Global
c
      integer          lwgt(0:maxconfigs,maxinvar)
      common/to_lwgt/lwgt

      double precision pmass(nexternal)
      common/to_mass/  pmass

      double precision SMIN
      common/to_smin/ smin

      integer           Minvar(maxdim,lmaxconfigs)
      common /to_invar/ Minvar
      double precision   prb(maxconfigs,maxpoints,maxplace)
      double precision   fprb(maxinvar,maxpoints,maxplace)
      integer                      jpnt,jplace
      common/to_mconfig1/prb ,fprb,jpnt,jplace
      double precision   psect(maxconfigs),alpha(maxconfigs)
      common/to_mconfig2/psect            ,alpha

      include 'run.inc'


      integer iforest(2,-max_branch:-1,lmaxconfigs)
      common/to_forest/ iforest

      integer            mapconfig(0:lmaxconfigs), this_config
      common/to_mconfigs/mapconfig, this_config

      double precision      spole(maxinvar),swidth(maxinvar),bwjac
      common/to_brietwigner/spole          ,swidth          ,bwjac

      double precision stot,m1,m2
      common/to_stot/stot,m1,m2

      save ndim,nfinal,nbranch,nparticles

      integer jfig,k

      double precision cm_rap
      logical set_cm_rap
      common/to_cm_rap/set_cm_rap,cm_rap      

c     External function
      double precision SumDot
      external SumDot
      logical dummy_boostframe
      external dummy_boostframe
c
c     data
c
      include 'configs.inc'
      data firsttime/.true./
      data jfig/1/
c-----
c  Begin Code
c----
      this_config = iconfig             !Pass iconfig to amplitude routine
c      write(*,*) 'using iconfig',iconfig
      if (firsttime) then
         firsttime=.false.
         call configure_integral(this_config,mincfig, maxcfig, invar,maxwgt)
         nparticles   = nexternal
         nfinal       = nparticles-nincoming
         nbranch      = nparticles-2
         ndim         = 3*nfinal-4
         if (ndim .lt. 0) ndim = 0   !For 2->1 processes  tjs 5/24/2010
         if (abs(lpp(1)) .ge. 1) ndim=ndim+1
         if (abs(lpp(2)) .ge. 1) ndim=ndim+1
         do i=1,nexternal
            m(i)=pmass(i)
         enddo
         write(*,'(a,12e10.3)') ' Masses:',(m(i),i=1,nparticles)
      endif                          !First_time

      this_config = iconfig             !Pass iconfig to amplitude routine
C
C     Get fraction of beam energy if pdf's are used
c
      xbk(1)   = 1d0
      xbk(2)   = 1d0
      sjac = 1d0
      if (abs(lpp(1)) .ge. 1 .and. abs(lpp(2)) .ge. 1) then
         if (abs(lpp(1)).eq.9.or.abs(lpp(2)).eq.9)then
            call sample_get_x(sjac,x(ndim),ndim,mincfig,0d0,1d0)
            call sample_get_x(sjac,x(ndim-1),ndim-1,mincfig,0d0,1d0)
            call get_dummy_x1_x2(sjac, Xbk(1), x(ndim-1),pi1, pi2, stot, s(-nbranch))
            if (.not.set_cm_rap)then
               cm_rap=.5d0*dlog(xbk(1)*ebeam(1)/(xbk(2)*ebeam(2)))
               set_cm_rap=.true.
            endif
         else
            call sample_get_x(sjac,x(ndim-1),ndim-1,mincfig,0d0,1d0)
c-----
c tjs 5/24/2010 for 2->1 process
c-------
            xtau = x(ndim-1)
            if(nexternal .eq. 3) then
               x(ndim-1) = pmass(3)*pmass(3)/stot
               sjac=1 / stot    !for delta function in d_tau
            endif

            call sample_get_x(sjac,x(ndim),ndim,mincfig,0d0,1d0)
            CALL GENCMS(STOT,Xbk(1),Xbk(2),X(ndim-1), SMIN,SJAC)
            x(ndim-1) = xtau    !Fix for 2->1 process
c           Set CM rapidity for use in the rap() function
            cm_rap=.5d0*dlog(xbk(1)*ebeam(1)/(xbk(2)*ebeam(2)))
            set_cm_rap=.true.
c           Set shat
            s(-nbranch) = xbk(1)*xbk(2)*stot
         endif

      elseif (lpp(1).eq.9.or.lpp(2).eq.9) then 
         call sample_get_x(sjac,x(ndim),ndim,mincfig,0d0,1d0)
         if (lpp(1).eq.9)then
            call get_dummy_x1(sjac, xbk(1), x(ndim), pi1, pi2, stot, s(-nbranch))
            xbk(2) = 1d0
         else
            call get_dummy_x1(sjac, xbk(2), x(ndim), pi1, pi2, stot, s(-nbranch))
            xbk(1) = 1d0
         endif
         if (.not.set_cm_rap)then
            cm_rap=.5d0*dlog(xbk(1)*ebeam(1)/(xbk(2)*ebeam(2)))
            set_cm_rap=.true.
         endif
      elseif (abs(lpp(1)) .ge. 1) then
         call sample_get_x(sjac,x(ndim),ndim,mincfig,0d0,1d0)
         xbk(1) = x(ndim)
c        Set CM rapidity for use in the rap() function
         p0=xbk(1)*ebeam(1)+ebeam(2)
         p3=xbk(1)*ebeam(1)-sqrt(ebeam(2)**2-m2**2)
         cm_rap=.5d0*dlog((p0+p3)/(p0-p3))
         set_cm_rap=.true.
c        Set shat
         s(-nbranch) = x(ndim)*stot         
      elseif (abs(lpp(2)) .ge. 1) then
         call sample_get_x(sjac,x(ndim),ndim,mincfig,0d0,1d0)
         xbk(2) = x(ndim)

c        Set CM rapidity for use in the rap() function
         p0=ebeam(1)+xbk(2)*ebeam(2)
         p3=sqrt(ebeam(1)**2-m1**2)-xbk(2)*ebeam(2)
         cm_rap=.5d0*dlog((p0+p3)/(p0-p3))
         set_cm_rap=.true.
c        Set shat
         s(-nbranch) =  x(ndim)*stot         
      else
c        Set CM rapidity for use in the rap() function
         p0=ebeam(1) + ebeam(2)
         p3=sqrt(ebeam(1)**2-m1**2)-sqrt(ebeam(2)**2-m2**2)
         cm_rap=.5d0*dlog((p0+p3)/(p0-p3))
         set_cm_rap=.true.
c        Set shat
         s(-nbranch) = stot
      endif
c      write(*,*) "shat=",sqrt(s(-nbranch))
      m(-nbranch)  = sqrt(s(-nbranch))
      p(0,-nbranch)= m(-nbranch)
      p(1,-nbranch)= 0d0
      p(2,-nbranch)= 0d0
      p(3,-nbranch)= 0d0

c
c     First Generate Momentum for initial state particles
c
      if (lpp(1).eq.9.or.lpp(2).eq.9)then
         if (dummy_boostframe())then
            call mom2cx(m(-nbranch),m(1),m(2),1d0,0d0,p(0,1),p(0,2))
         else
            p(:,1) = pi1(:)
            p(:,2) = pi2(:)
         endif
      else if(nincoming.eq.2) then
        call mom2cx(m(-nbranch),m(1),m(2),1d0,0d0,p(0,1),p(0,2))
      else
        do i=0,3
          p(i,1)=p(i,-nbranch)
        enddo
        p(3,1)=1e-14 ! For HELAS routine ixxxxx for neg. mass
      endif
      pswgt = 1d0
      jac   = 1d0
      call one_tree(iforest(1,-max_branch,iconfig),mincfig,
     &     nbranch,P,M,S,X,jac,pswgt)
c
c     Add what I think are the essentials
c
         if (jac .gt. 0d0 ) then
            if(nincoming.eq.2)then
               flux  = 1d0 /(2.D0*SQRT(LAMBDA(s(-nbranch),m(1)**2,m(2)**2)))
            else ! Decays
               flux = 1d0/(2d0*sqrt(stot))
            endif
            flux  = flux / (2d0*pi)**(3 * nfinal - 4)
            pwgt(1)=max(sjac*jac*pswgt*wgt,1d-99)
            wgt = pwgt(1)*flux
            do i=1,nparticles
               do j=0,3
                  p1(j,i) = p(j,i)
               enddo
c               write(*,'(i3,4f15.5)') i,(p(j,i),j=0,3)
            enddo
            p1(0,nparticles+1)=xbk(1)
            p1(1,nparticles+1)=xbk(2)
         else
            p1(0,1)=-99
         endif

c
c     comment out everything else
c
      if (.false.) then

      if (jac .gt. 0d0) then
         do i=1,nparticles
            do j=0,3
               p1(j,i) = p(j,i)
            enddo
c            write(*,'(i2,4e15.5)') i,(p(j,i),j=0,3)
         enddo
c         call fill_invarients(nfinal,p1,stot,xx)
         if (abs(lpp(1)) .ge. 1 .and. abs(lpp(1)) .ge. 1) then
            xx(invar)=x(ndim)
            xx(invar-1)=x(ndim-1)
         elseif (abs(lpp(1)) .ge. 1 .or. abs(lpp(1)) .ge. 1) then
            xx(invar)=x(ndim)
         endif
c
c     The next lines take care of redetermining the wgt based on all
c     allowed configurations
c
c         if (passcuts(p(0,1))) then
         if (.true.) then
c            write(*,'(A,5e14.4)') 'Orig',jac,pswgt,wgt,jac*pswgt*wgt

            tprb=0d0
c            write(*,'(a,12f6.2)') 'orig',(x(i),i=1,ndim)

            do jconfig=mincfig,maxcfig

c
c     I'll skip this if there is only one configuration
c

               if (jac .lt. 0) then
                  write(*,*) 'Error did not find wgt ',jconfig,jac
               endif

c               write(*,'(a,12f6.2)') 'final',(x(i),i=1,ndim)

c
c     Now need to set up the x(i)'s
c
               do i=1,ndim
                  if (minvar(i,jconfig) .ne. 0) then
c                    write(*,*)'filling',minvar(i,jconfig),i,jconfig,x(i)
                     xx(minvar(i,jconfig))=x(i)
                  endif
               enddo
c
c     Here is where we put in something for pp etc. Now lets just use 1
c
c               if (pp) then
c                  xx(3*nbranch-3,jconfig)= x


               if (maxcfig-mincfig .gt. 0) then
               
                  pwgt(jconfig)=max(sjac*jac*pswgt*wgt,1d-99)
                  prb(jconfig,jpnt,jplace)=1d0/pwgt(jconfig)
                  tprb = tprb + prb(jconfig,jpnt,jplace)*alpha(jconfig)
               else
                  pwgt(1)=max(sjac*jac*pswgt*wgt,1d-99)
                  prb(1,jpnt,jplace)=1d0/pwgt(1)
                  tprb = tprb + prb(1,jpnt,jplace)
               endif
c               write(*,'(A,5e14.4)') 'Finl',jac,pswgt,wgt,jac*pswgt*wgt



            enddo

            pswgt=1d0
            jac  =1d0/tprb

         else
            jac=-1d0              !Didn't pass the cuts.
         endif
         if (jac .lt. 0) then
            p1(0,1) = -999
            return
         endif
c
c     Flux factor and pi's from delta functions
c
         flux  = 1d0 /(2.D0*SQRT(LAMBDA(s(-nbranch),m(1)**2,m(2)**2)))
         flux  = flux / (2d0*pi)**(3 * nfinal - 4)
c
c     Make sure all the invarients are reasonable
c         

         do i=1,invar
            x(i)=xx(i)
            if (x(i) .gt. 1d0) then
               write(*,'(a,i6,e15.4)') 'Error x>1',i,x(i)
            endif
            fprb(i,jpnt,jplace)=0d0
         enddo

c
c     Determine fractional probs from the different configs this
c     allows me to only include points which were contributed
c     by the projection onto that invarient.
c
c
c     Now normalize fprb
c
         do i=1,invar
c            if (fprb(i,jpnt,jplace) .eq. 0d0) then
            if (tprb .eq. 0d0) then
               fprb(i,jpnt,jplace)=1d0
            else
               fprb(i,jpnt,jplace)=fprb(i,jpnt,jplace)/tprb
            endif
         enddo
         
         
c         write(123,'(2i6,1e15.5)') jpnt,jplace
c         write(123,'(5e15.9)') (fprb(i,jpnt,jplace),i=1,invar) 
c         write(123,'(5e15.9)') (prb(i,jpnt,jplace),i=1,maxcfig) 

c
c     Return the 4 momentum if things worked.
c

c         write(*,'(11f7.4)')(x(i),i=1,invar)

         if (jac .gt. 0d0 ) then
            wgt = jac*flux
            do i=1,nparticles
               do j=0,3
                  p1(j,i) = p(j,i)
               enddo
            enddo
            p1(0,nparticles+1)=xbk(1)
            p1(1,nparticles+1)=xbk(2)
         else
            p1(0,1)=-99
         endif
      else                    !Failed cuts
c         write(*,*) 'Failed cuts'
         p1(0,1)=-99           
      endif
c
c     comment out everything funny here
c
      endif
      end


      subroutine configure_integral(iconfig,mincfig,maxcfig,invar,maxwgt)
c**************************************************************************
c     inputs  iconfig   == Current configuration working on
c     output  m
c**************************************************************************

      implicit none

      include 'genps.inc'
      include 'maxconfigs.inc'
      include 'nexternal.inc'
      include 'maxamps.inc'
      include 'run.inc'

c     local
      double precision pi1(0:3),pi2(0:3),p0,p3
      double precision dum
      integer i,j,ipole,n
      integer nbranch,ndim,nconfigs
      integer ninvar
      integer nparticles,nfinal


c
c     Arguments
c
      integer iconfig,mincfig,maxcfig,invar
      double precision maxwgt
c
c     External
c
      double precision lambda,dot,dsig
      logical passcuts


      logical firsttime
      data firsttime/.true./
      save firsttime
c
c     global
c
      double precision M(-max_branch:max_particles)

      double precision pmass(nexternal)
      common/to_mass/  pmass

      double precision stot,m1,m2
      common/to_stot/stot,m1,m2

      integer            mapconfig(0:lmaxconfigs), this_config
      common/to_mconfigs/mapconfig, this_config

      integer           Minvar(maxdim,lmaxconfigs)
      common /to_invar/ Minvar

      integer          lwgt(0:maxconfigs,maxinvar)
      common/to_lwgt/lwgt

      if (firsttime)then
         firsttime=.false.
         do i=1,nexternal
            m(i)=pmass(i)
         enddo
c        Set stot
         if (nincoming.eq.1) then
            stot=m(1)**2
         else
            m1=m(1)
            m2=m(2)
            if (abs(lpp(1)) .eq. 1 .or. abs(lpp(1)) .eq. 2) m1 = 0.938d0
            if (abs(lpp(2)) .eq. 1 .or. abs(lpp(2)) .eq. 2) m2 = 0.938d0
            if (abs(lpp(1)) .eq. 3) m1 = 0.000511d0
            if (abs(lpp(2)) .eq. 3) m2 = 0.000511d0
            if (abs(lpp(1)) .eq. 4) m1 = 0.105658d0
            if (abs(lpp(2)) .eq. 4) m2 = 0.105658d0
            if (mass_ion(1).ge.0d0) m1 = mass_ion(1)
            if (mass_ion(2).ge.0d0) m2 = mass_ion(2)
            if(ebeam(1).lt.m1.and.lpp(1).ne.9) ebeam(1)=m1
            if(ebeam(2).lt.m2.and.lpp(2).ne.9) ebeam(2)=m2
            pi1(0)=ebeam(1)
            pi1(3)=sqrt(max(ebeam(1)**2-m1**2, 0d0))
            pi2(0)=ebeam(2)
            pi2(3)=-sqrt(max(ebeam(2)**2-m2**2, 0d0))
            stot=m1**2+m2**2+2*(pi1(0)*pi2(0)-pi1(3)*pi2(3))
         endif
         write(*,'(x,a,f13.2)') 'Set CM energy to ',sqrt(stot)
         endif
c        Start graph mapping
         do i=1,mapconfig(0)
            if (mapconfig(i) .eq. iconfig) this_config=i
         enddo
         write(*,*) 'Mapping Graph',iconfig,' to config',this_config
         iconfig = this_config
         nconfigs = 1
         mincfig=iconfig
         maxcfig=iconfig
         call map_invarients(minvar,nconfigs,ninvar,mincfig,maxcfig,nexternal,nincoming)
         maxwgt=0d0
         nparticles   = nexternal
         nfinal       = nparticles-nincoming
         nbranch      = nparticles-2
         ndim         = 3*nfinal-4
         if (ndim .lt. 0) ndim = 0   !For 2->1 processes  tjs 5/24/2010
         if (abs(lpp(1)) .ge. 1) ndim=ndim+1
         if (abs(lpp(2)) .ge. 1) ndim=ndim+1
         call set_peaks
         do j=1,invar
            lwgt(0,j)=0
         enddo
c
c     Here we set up which diagrams contribute to each variable
c     in principle more than 1 diagram can contribute to a variable
c     if we believe they will have identical structure.
c
c         do i=1,mapconfig(0)
         do i=mincfig,maxcfig
            write(*,'(15i4)') i,(minvar(j,i),j=1,ndim)
            do j=1,ndim
               ipole = minvar(j,i)
               if (ipole .ne. 0) then
                  n = lwgt(0,ipole)+1
                  lwgt(n,ipole)=mapconfig(i)
                  lwgt(0,ipole)=n
               endif
            enddo
         enddo

c     Initialize dsig (needed for subprocess group running mode)
         dum=dsig(0,0,1)

      return
      end

      subroutine one_tree(itree,iconfig,nbranch,P,M,S,X,jac,pswgt)
c************************************************************************
c     Calculates the momentum for everything below in the tree until
c     it reaches the end.
c     Note that the tree structure must have at least one t channel
c     part to it, and that the t-channel propagators must always appear
c     as the first element, that is itree(1,i)
c************************************************************************
      implicit none
c
c     Constants
c      
      include 'genps.inc'
      include 'nexternal.inc'
      double precision pi            , one
      parameter       (pi=3.1415926d0, one=1d0)
c
c     Arguments
c
      integer itree(2,-max_branch:-1) !Structure of configuration
      integer iconfig                 !Which configuration working on
      double precision P(0:3,-max_branch:max_particles)
      double precision M(-max_branch:max_particles)
      double precision S(-max_branch:0)
c      double precision spole(-max_branch:0),swidth(-max_branch:0)
      double precision jac,pswgt
      integer nbranch
      double precision x(*) ! ja 3/2/11 21->40 after strange segfault
c
c     Local
c
      logical pass
      integer ibranch,i,ns_channel,nt_channel,ix  !,nerr
c      data nerr/0/
      double precision smin,smax,totmass,totmassin,xa2,xb2,wgt
      double precision costh,phi,tmin,tmax,t
      double precision ma2,mb2,m12,mn2,s1, mi2
      double precision tmass(-max_branch:-1)
c
c     External
c
      double precision lambda,dot
c
c     Global
c
      double precision stot,m1,m2
      common/to_stot/stot,m1,m2

      include 'run.inc'

c-----
c  Begin Code
c-----
      jac   = 1d0
      pswgt = 1d0
      wgt   = 1d0
      pass = .true.
c-----------
c     Trap for trivial case 2->1
c----------
      if (nexternal .eq. 3 .and. nincoming.ne.1) then
         do i=0,3
            p(i,3) = p(i,1)+p(i,2)
         enddo
         return
      endif
c
c     Determine number of s channel branches, this doesn't count
c     the s channel p1+p2
c
      ns_channel=1
      do while(itree(1,-ns_channel) .ne. 1 .and.ns_channel.lt.nbranch)
         m(-ns_channel)=0d0                 
         ns_channel=ns_channel+1         
      enddo
      ns_channel=ns_channel - 1
      nt_channel=nbranch-ns_channel-1

      if (nt_channel .eq. 0 .and. nincoming .eq. 2) then
         ns_channel=ns_channel-1
      endif

c
c     Determine masses for all intermediate states.  Starting
c     from outer most (real particle) states
c
c
c     Make sure have enough mass for external particls
c
      totmassin=0d0
      do ibranch=3-nincoming,2
         totmassin=totmassin+m(ibranch)
      enddo
      totmass=0d0
      do ibranch=3,nbranch+2
         totmass=totmass+m(ibranch)
      enddo
      if (sqrt(s(-nbranch)) .lt. max(totmass,totmassin)) then
         pass=.false.
         jac = -5d0
         return
      endif

      do ibranch = -1,-ns_channel,-1
         smin = (m(itree(1,ibranch))+m(itree(2,ibranch)))**2
         smax = min((dsqrt(s(-nbranch))-totmass+sqrt(smin))**2, stot)
c     Check for NAN - ja 3/11
         if (smax/stot.eq.smax/stot+1d0) then
            print *,'got NaN: ',smax/stot
            jac = -2
            return
         endif


c         write(*,*) ibranch,sqrt(smin),sqrt(smax)
c
c        Choose the appropriate s given our constraints smin,smax
c     
         call sample_get_x(wgt,x(-ibranch),-ibranch,iconfig,
     &        smin/stot,smax/stot)
         s(ibranch) = x(-ibranch)*stot

c         write(*,*) 'using s',-ibranch

         jac = jac*stot
         if (jac .lt. 0d0 .or. .not. pass) then
            jac = -6
            return
         endif
         if (s(ibranch) .lt. smin) then
            jac=-5
            return
         endif
c
c     Check that s is ok, and fill masses, update totmass
c
         m(ibranch) = sqrt(s(ibranch))
         totmass=totmass+m(ibranch)-
     &        m(itree(1,ibranch))-m(itree(2,ibranch))
         if (totmass .gt. M(-nbranch)) then
            jac = -4
            return
         endif
         if (.not. pass) then
            jac=-9
            return
         endif
      enddo

      if (nt_channel .eq. 0 .and. nincoming .eq. 2) then
         s(-nbranch+1)=s(-nbranch) 
         m(-nbranch+1)=m(-nbranch)      !Basic s-channel has s_hat 
         p(0,-nbranch+1) = m(-nbranch+1)!and 0 momentum
         p(1,-nbranch+1) = 0d0
         p(2,-nbranch+1) = 0d0
         p(3,-nbranch+1) = 0d0
      endif

c
c     Next do the T-channel branchings
c
c
c     First we need to determine the energy of the remaining particles
c     this is essentially in place of the cos(theta) degree of freedom
c     we have with the s channel decay sequence
c


      if (nt_channel .gt. 0) then               !t-channel stuff exists

      totmass=0d0
      do ibranch = -ns_channel-1,-nbranch,-1
         totmass=totmass+m(itree(2,ibranch))
      enddo
      m(-ns_channel-1) = dsqrt(S(-nbranch))
      do ibranch = -ns_channel-1,-nbranch+2,-1    !Choose invarient mass
         totmass=totmass-m(itree(2,ibranch))      !for remaining particles
         smin = totmass**2                        !This affects t_min/max
         smax = (m(ibranch) - m(itree(2,ibranch)))**2

         if (smin .gt. smax) then
            jac=-3d0
            return
         endif
         call sample_get_x(wgt,x(nbranch-1+(-ibranch)*2),
     &        nbranch-1+(-ibranch)*2,iconfig,
     &        smin/stot,smax/stot)

         m(ibranch-1)=dsqrt(max(stot*x(nbranch-1+(-ibranch)*2), 0d0))
c         write(*,*) 'Using s',nbranch-1+(-ibranch)*2

         if (m(ibranch-1)**2.lt.smin.or.m(ibranch-1)**2.gt.smax
     $        .or.m(ibranch-1).ne.m(ibranch-1)) then
            jac=-1d0
            return
         endif
         jac = jac * stot
      enddo
      m(-nbranch) = m(itree(2,-nbranch))
c
c     Now perform the t-channel decay sequence. Most of this comes from: 
c     Particle Kinematics Chapter 6 section 3 page 166
c
c     From here, on we can just pretend this is a 2->2 scattering with
c     Pa                    + Pb     -> P1          + P2
c     p(0,itree(ibranch,1)) + p(0,2) -> p(0,ibranch)+ p(0,itree(ibranch,2))
c     M(ibranch) is the total mass available (Pa+Pb)^2
c     M(ibranch-1) is the mass of P2  (all the remaining particles)
c
      do ibranch=-ns_channel-1,-nbranch+1,-1
         s1  = m(ibranch)**2                        !Total mass available
         ma2 = m(2)**2
         mb2 = dot(P(0,itree(1,ibranch)),P(0,itree(1,ibranch)))
         m12 = m(itree(2,ibranch))**2
         mn2 = m(ibranch-1)**2
c         write(*,*) 'Enertering yminmax',sqrt(s1),sqrt(m12),sqrt(mn2)
         call yminmax(s1,0d0,m12,ma2,mb2,mn2,tmin,tmax)
c
c     Call for 0<x<1
c
c         call sample_get_x(wgt,x(-ibranch),-ibranch,iconfig,
c     &        .5d0*(tmin/stot+1d0),
c     &        .5d0*(tmax/stot+1d0))
c         t   = Stot*(x(-ibranch)*2d0-1d0)
c
c     call for -1<x<1
c

c         write(*,*) 'tmin, tmax',tmin,tmax

      if (tmax.gt.-0.01.and.tmin.lt.-0.02)then
c         set tmax to 0. The idea is to be sure to be able to hit zero
c         and not to be block by numerical inacuracy
c         tmax = max(tmax,0d0) !This line if want really t freedom
         call sample_get_x(wgt,x(-ibranch),-ibranch,iconfig,
     $        0d0, -tmin/stot)
         t = stot*(-x(-ibranch))

      else
         call sample_get_x(wgt,x(-ibranch),-ibranch,iconfig,
     $        -tmax/stot, -tmin/stot)
         t = stot*(-x(-ibranch))
      endif

         if (t .lt. tmin .or. t .gt. tmax) then
            jac=-3d0
            return
         endif
c
c     tmin and tmax set to -s,+s for jacobian because part of jacobian
c     was determined from choosing the point x from the grid based on
c     tmin and tmax.  (ie wgt contains some of the jacobian)
c
         tmin=-stot
         tmax= stot
         call sample_get_x(wgt,x(nbranch+(-ibranch-1)*2),
     &        nbranch+(-ibranch-1)*2,iconfig,0d0,1d0)
         phi = 2d0*pi*x(nbranch+(-ibranch-1)*2)
         jac = jac*(tmax-tmin)*2d0*pi /2d0              ! I need /2d0 if -1<x<1
c
c     Finally generate the momentum. The call is of the form
c     pa+pb -> p1+ p2; t=(pa-p1)**2;   pr = pa-p1
c     gentcms(pa,pb,t,phi,m1,m2,p1,pr) 
c

         if (itree(1,ibranch).gt.-ns_channel-1)then
            mi2 = m(itree(1,ibranch))**2
         else
            mi2 = tmass(itree(1,ibranch))
         endif
         tmass(ibranch) = t
         call gentcms(p(0,itree(1,ibranch)),p(0,2),t,phi, mi2,
     &        m(itree(2,ibranch)),m(ibranch-1),p(0,itree(2,ibranch)),
     &        p(0,ibranch),jac)

         if (jac .lt. 0d0) then
c            nerr=nerr+1
c            if(nerr.le.5)
c     $           write(*,*) 'Failed gentcms',iconfig,ibranch
            return              !Failed, probably due to negative x
         endif

         pswgt = pswgt/(4d0*dsqrt(lambda(s1,ma2,mb2)))
      enddo
c
c     We need to get the momentum of the last external particle.
c     This should just be the sum of p(0,2) and the remaining
c     momentum from our last t channel 2->2
c
      do i=0,3
         p(i,itree(2,-nbranch)) = p(i,-nbranch+1)+p(i,2)
      enddo


      endif                     !t-channel stuff


c
c     Now generate momentum for all intermediate and final states
c     being careful to calculate from more massive to less massive states
c     so the last states done are the final particle states.
c
c      do i = -ns_channel,-1      
c      ix=0
c      if (nt_channel .eq. 0) ix=-1
      do i = -nbranch+nt_channel+(nincoming-1),-1         !Loop over all s-channel poles
         ix = nbranch+(-i-1)*2+(2-nincoming)
         if (nt_channel .eq. 0) ix=ix-1

c         write(*,*) 'using costh,phi',ix,ix+1

         call sample_get_x(wgt,x(ix),ix,iconfig,0d0,1d0)
         costh= 2d0*x(ix)-1d0
         call sample_get_x(wgt,x(ix+1),ix+1,iconfig,0d0,1d0)
         phi  = 2d0*pi*x(ix+1)
         jac = jac * 4d0*pi
         xa2 = m(itree(1,i))*m(itree(1,i))/(s(i)+1d-99)
         xb2 = m(itree(2,i))*m(itree(2,i))/(s(i)+1d-99)
         if (m(itree(1,i))+m(itree(2,i)) .ge. m(i)) then
            jac=-8
            return
         endif
         pswgt = pswgt*.5D0*PI*SQRT(MAX(LAMBDA(ONE,XA2,XB2),0d0))/(4.D0*PI)
         call mom2cx(m(i),m(itree(1,i)),m(itree(2,i)),costh,phi,
     &        p(0,itree(1,i)),p(0,itree(2,i)))
         call boostm(p(0,itree(1,i)),p(0,i),m(i),p(0,itree(1,i)))
         call boostm(p(0,itree(2,i)),p(0,i),m(i),p(0,itree(2,i)))
      enddo
      jac = jac*wgt
      if (.not. pass) jac = -99
      end

         
      subroutine gen_s(x,smin,smax,spole,swidth,s,jac,pass)
c*************************************************************************
c     Given a random number x, the limits smin and smax and also
c     any pole spole with swidth, returns s ans jac the jacobian
c     for the transformation.  The jacobian is just multiplied by the
c     new jacobian so if jac=0 on entry jac=0 on exit
c*************************************************************************
      implicit none
c
c     Arguments
c
      double precision smin,smax,spole,swidth,s,jac
      double precision x
      logical pass
c
c     Local
c     
      logical warned0
c
c     Data
c
      data warned0 /.false./
c-----
c  Begin Code
c-----
      pass=.true.
      if (jac .eq. 0 .and. .not. warned0) then
         print*,'Input jacobian 0 in genps'
         warned0 = .true.
      endif
      if (spole .eq. 0d0) then
         s = (smax-smin)*x + smin
         jac = jac*(smax-smin)
      else
         if (spole*spole .lt. smax) then
            CALL TRANSPOLE(spole*spole/smax,spole*swidth/smax,x,s,jac)
            s = s*smax
            jac = jac*smax
         else
            pass=.false.
         endif
      endif
      if (s .gt. smax .or. s .lt. smin) then
         pass = .false.
      endif
      end

      subroutine gentcms(pa,pb,t,phi,ma2,m1,m2,p1,pr,jac)
c*************************************************************************
c     Generates 4 momentum for particle 1, and remainder pr
c     given the values t, and phi
c     Assuming incoming particles with momenta pa, pb
c     And outgoing particles with mass m1,m2
c     s = (pa+pb)^2  t=(pa-p1)^2
c*************************************************************************
      implicit none
c
c     Arguments
c
      double precision t,phi,m1,m2               !inputs
      double precision pa(0:3),pb(0:3),jac
      double precision p1(0:3),pr(0:3)           !outputs
c
c     local
c
      double precision ptot(0:3),E_acms,p_acms,pa_cms(0:3)
      double precision esum,ed,pp,md2,ma2,pt,ptotm(0:3)
      integer i
c
c     External
c
      double precision dot
c-----
c  Begin Code
c-----
      do i=0,3
         ptot(i)  = pa(i)+pb(i)
         if (i .gt. 0) then
            ptotm(i) = -ptot(i)
         else
            ptotm(i) = ptot(i)
         endif
      enddo
c
c     determine magnitude of p1 in cms frame (from dhelas routine mom2cx)
c
      ESUM = sqrt(max(0d0,dot(ptot,ptot)))
      if (esum .eq. 0d0) then
         jac=-8d0             !Failed esum must be > 0
         return
      endif
      MD2=(M1-M2)*(M1+M2)
      ED=MD2/ESUM
      IF (M1*M2.EQ.0.) THEN
         PP=(ESUM-ABS(ED))*0.5d0
      ELSE
         PP=(MD2/ESUM)**2-2.0d0*(M1**2+M2**2)+ESUM**2
         if (pp .gt. 0) then
            PP=SQRT(pp)*0.5d0
         else
            write(*,*) 'Error gentcms',pp, M1,m2,MD2, ESUM
            jac=-1
            return
         endif
      ENDIF
c
c     Energy of pa in pa+pb cms system
c
      call boostx(pa,ptotm,pa_cms)
      E_acms = pa_cms(0)
      p_acms = dsqrt(pa_cms(1)**2+pa_cms(2)**2+pa_cms(3)**2)

      p1(0) = MAX((ESUM+ED)*0.5d0,0.d0)
      p1(3) = -(m1*m1+ma2-t-2d0*p1(0)*E_acms)/(2d0*p_acms)
      pt = dsqrt(max(pp*pp-p1(3)*p1(3),0d0))
      p1(1) = pt*cos(phi)
      p1(2) = pt*sin(phi)

      call rotxxx(p1,pa_cms,p1)          !Rotate back to pa_cms frame
      call boostx(p1,ptot,p1)            !boost back to lab fram
      do i=0,3
         pr(i)=pa(i)-p1(i)               !Return remainder of momentum
      enddo
      end



      DOUBLE PRECISION FUNCTION LAMBDA(S,MA2,MB2)
      IMPLICIT NONE
C****************************************************************************
C     THIS IS THE LAMBDA FUNCTION FROM VERNONS BOOK COLLIDER PHYSICS P 662
C     MA2 AND MB2 ARE THE MASS SQUARED OF THE FINAL STATE PARTICLES
C     2-D PHASE SPACE = .5*PI*SQRT(1.,MA2/S^2,MB2/S^2)*(D(OMEGA)/4PI)
C****************************************************************************
      DOUBLE PRECISION MA2,MB2,S
      LAMBDA=S**2+MA2**2+MB2**2-2d0*S*MA2-2d0*MA2*MB2-2d0*S*MB2
      RETURN
      END


      DOUBLE PRECISION FUNCTION G(X,Y,Z,U,V,W)
C**************************************************************************
C     This is the G function from Particle Kinematics by
C     E. Byckling and K. Kajantie, Chapter 4 p. 89 eqs 5.23
C     It is used to determine if a set of invarients are physical or not
C**************************************************************************
      implicit none
c
c     Arguments
c
      Double precision x,y,z,u,v,w
c-----
c  Begin Code
c-----
      G = X*Y*(X+Y-Z-U-V-W)+Z*U*(Z+U-X-Y-V-W)+V*W*(V+W-X-Y-Z-U)
     &     +X*Z*W +X*U*V +Y*Z*W +Y*U*W
      end

      SUBROUTINE YMINMAX(X,Y,Z,U,V,W,YMIN,YMAX)
C**************************************************************************
C     This is the G function from Particle Kinematics by
C     E. Byckling and K. Kajantie, Chapter 4 p. 91 eqs 5.28
C     It is used to determine physical limits for Y based on inputs
C     Y is not used in this formula (called with dummy value)
C**************************************************************************
      implicit none
c
c     Constant
c
      double precision tiny
      parameter       (tiny=1d-199)
c
c     Arguments
c
      Double precision x,y,z,u,v,w              !inputs  y is dummy
      Double precision ymin,ymax                !output
c
c     Local
c
      double precision y1,y2,yr,ysqr
c     
c     External
c
      double precision lambda
c-----
c  Begin Code
c-----
      ysqr = lambda(x,u,v)*lambda(x,w,z)
      if (ysqr .ge. tiny) then
         yr = dsqrt(ysqr)
      else
c        Probably a problem with negative x selection
c         print*,'Error in yminymax sqrt(-x)',lambda(x,u,v),lambda(x,w,z)
         yr = tiny
      endif
      y1 = u+w -.5d0* ((x+u-v)*(x+w-z) - yr)/(x+tiny)
      y2 = u+w -.5d0* ((x+u-v)*(x+w-z) + yr)/(x+tiny)
      ymin = min(y1,y2)
      ymax = max(y1,y2)
      end

      subroutine ungen_s(x,smin,smax,spole,swidth,s,jac,pass)
c*************************************************************************
c     Given s, the limits smin and smax and also
c     any pole spole with swidth, returns x and jac the jacobian
c     for the transformation.  The jacobian is just multiplied by the
c     new jacobian so if jac=0 on entry jac=0 on exit
c*************************************************************************
      implicit none
c
c     Arguments
c
      double precision smin,smax,spole,swidth,s,jac,x
      logical pass
c
c     Local
c     
      logical warned0
c
c     Data
c
      data warned0 /.false./
c-----
c  Begin Code
c-----
      pass=.true.
      if (jac .eq. 0 .and. .not. warned0) then
         print*,'Input jacobian 0 in genps'
         warned0 = .true.
      endif
      if (spole .eq. 0d0) then
         x = (s-smin)/(smax-smin)
         jac = jac*(smax-smin)
      else
         if (spole*spole .lt. smax) then
            s = s/smax
            CALL UNTRANSPOLE(spole*spole/smax,spole*swidth/smax,x,s,jac)
            s = s*smax
            jac = jac*smax
         else
            pass=.false.
            print*,'Skipping BW pole pass=',pass,spole*spole,smax
         endif
      endif
      if (s .gt. smax .or. s .lt. smin) then
         pass = .false.
      endif
      end


      SUBROUTINE GENCMS(S,X1,X2,X,SMIN,SJACOBI)
C***********************************************************************
C     PICKS PARTON MOMENTUM FRACTIONS X1 AND X2 BY CHOOSING ETA AND TAU
C     X(1) --> TAU = X1*X2
C     X(2) --> ETA = .5*LOG(X1/X2)
C***********************************************************************
      IMPLICIT NONE

C     ARGUMENTS

      DOUBLE PRECISION X1,X2,S,SMIN,SJACOBI
      DOUBLE PRECISION X(2)

C     LOCAL

      DOUBLE PRECISION TAU,TAUMIN,TAUMAX
      DOUBLE PRECISION ETA,ETAMIN,ETAMAX
      logical warned
      data warned/.false./

C------------
C  BEGIN CODE
C------------

      IF (S .LT. SMIN) THEN
         PRINT*,'ERROR CMS ENERGY LESS THAN MINIMUM CMS ENERGY',S,SMIN
         RETURN
      ENDIF

C     TO FLATTEN BRIET WIGNER POLE AT WMASS WITH WWIDTH USE BELOW:
C      CALL TRANSPOLE(REAL(WMASS**2/S),REAL(WMASS*WWIDTH/S),
C     &     X(1),TAU,SJACOBI)

C     IF THERE IS NO S CHANNEL POLE USE BELOW:

      TAUMIN = 0d0 !SMIN/S !keep scale fix
      TAUMAX = 1D0
      TAU    = (TAUMAX-TAUMIN)*X(1)+TAUMIN
      SJACOBI=  sjacobi*(TAUMAX-TAUMIN)

C     FROM HERE ON SAME WITH OR WITHOUT POLE
      ETAMIN = .5d0*LOG(TAU)
      ETAMAX = -ETAMIN
      ETA    = (ETAMAX-ETAMIN)*X(2)+ETAMIN
c      if (.not. warned) then
c         write(*,*) 'Fixing eta = 0'
c         warned=.true.
c      endif
c      eta = 0d0

      SJACOBI = SJACOBI*(ETAMAX-ETAMIN)

      X1 = SQRT(TAU)*EXP(ETA)
      X2 = SQRT(TAU)*EXP(-ETA)

      END
      

C     -----------------------------------------
C     Subroutine to return momenta in a dedicated frame
C     frame_id is the tag of the particle to put at rest
C     frame_id follow the convention of cluster.f (sum 2**(N-1))
C     -----------------------------------------

      subroutine boost_to_frame(P1, frame_id, P2)

      implicit none

      include 'nexternal.inc'

      DOUBLE PRECISION P1(0:3,NEXTERNAL)
      DOUBLE PRECISION P2(0:3,NEXTERNAL)
      DOUBLE PRECISION PBOOST(0:3)
      integer frame_id

      integer ids(nexternal)
      integer i,j

c     uncompress
      call mapid(frame_id, ids)
      pboost(:) = 0d0
      p2(:,:) = 0d0
c     find the boost momenta --sum of particles--
      do i=1,nexternal
       if (ids(i).eq.1)then
            do j=0,3
	           Pboost(j) = Pboost(j) + P1(j,i)
            enddo
         endif
      enddo
      do j=1,3	
          Pboost(j) = -1 * Pboost(j)
      enddo	    
      do i=1, nexternal
         call boostx(p1(0,i), pboost, p2(0,i))
      enddo   
      return
      end

C     This File is Automatically generated by ALOHA 
C     The process calculated in this file is: 
C     Gamma(-1,2,-2)*Gamma(-1,4,-3)*ProjM(-3,1)*ProjM(-2,3)
C     
      SUBROUTINE FFFF17_2(F1, F3, F4, COUP, M2, W2,F2)
      IMPLICIT NONE
      COMPLEX*16 CI
      PARAMETER (CI=(0D0,1D0))
      COMPLEX*16 COUP
      COMPLEX*16 F1(*)
      COMPLEX*16 F2(6)
      COMPLEX*16 F3(*)
      COMPLEX*16 F4(*)
      REAL*8 M2
      REAL*8 P2(0:3)
      REAL*8 W2
      COMPLEX*16 DENOM
      F2(1) = +F1(1)+F3(1)+F4(1)
      F2(2) = +F1(2)+F3(2)+F4(2)
      P2(0) = -DBLE(F2(1))
      P2(1) = -DBLE(F2(2))
      P2(2) = -DIMAG(F2(2))
      P2(3) = -DIMAG(F2(1))
      DENOM = COUP/(P2(0)**2-P2(1)**2-P2(2)**2-P2(3)**2 - M2 * (M2 -CI
     $ * W2))
      F2(3)= DENOM*2D0 * CI*(F4(5)*(F1(3)*F3(4)*(-P2(1)+CI*(P2(2)))
     $ +F1(4)*F3(3)*(P2(1)-CI*(P2(2))))+F4(6)*(F1(3)*F3(4)*(-P2(0)
     $ +P2(3))+F1(4)*F3(3)*(P2(0)-P2(3))))
      F2(4)= DENOM*2D0 * CI*(F4(5)*(F1(3)*F3(4)*(P2(0)+P2(3))-F1(4)
     $ *F3(3)*(P2(0)+P2(3)))+F4(6)*(F1(3)*F3(4)*(P2(1)+CI*(P2(2)))
     $ -F1(4)*F3(3)*(P2(1)+CI*(P2(2)))))
      F2(5)= DENOM*2D0 * CI * F4(6)*M2*(-F1(3)*F3(4)+F1(4)*F3(3))
      F2(6)= DENOM*2D0 * CI * F4(5)*M2*(F1(3)*F3(4)-F1(4)*F3(3))
      END


C     This File is Automatically generated by ALOHA 
C     The process calculated in this file is: 
C     Gamma(-1,2,-2)*Gamma(-1,4,-3)*ProjM(-3,1)*ProjM(-2,3)
C     
      SUBROUTINE FFFF17_25_26_27_2(F1, F3, F4, COUP1, COUP2, COUP3,
     $  COUP4, M2, W2,F2)
      IMPLICIT NONE
      COMPLEX*16 CI
      PARAMETER (CI=(0D0,1D0))
      COMPLEX*16 COUP1
      COMPLEX*16 COUP2
      COMPLEX*16 COUP3
      COMPLEX*16 COUP4
      COMPLEX*16 F1(*)
      COMPLEX*16 F2(6)
      COMPLEX*16 F3(*)
      COMPLEX*16 F4(*)
      COMPLEX*16 FTMP(6)
      REAL*8 M2
      REAL*8 P2(0:3)
      REAL*8 W2
      COMPLEX*16 DENOM
      INTEGER*4 I
      CALL FFFF17_2(F1,F3,F4,COUP1,M2,W2,F2)
      CALL FFFF25_2(F1,F3,F4,COUP2,M2,W2,FTMP)
      DO I = 3, 6
        F2(I) = F2(I) + FTMP(I)
      ENDDO
      CALL FFFF26_2(F1,F3,F4,COUP3,M2,W2,FTMP)
      DO I = 3, 6
        F2(I) = F2(I) + FTMP(I)
      ENDDO
      CALL FFFF27_2(F1,F3,F4,COUP4,M2,W2,FTMP)
      DO I = 3, 6
        F2(I) = F2(I) + FTMP(I)
      ENDDO
      END


C     This File is Automatically generated by ALOHA 
C     The process calculated in this file is: 
C     Gamma(-1,2,-2)*Gamma(-1,4,-3)*ProjM(-3,1)*ProjM(-2,3)
C     
      SUBROUTINE FFFF17_212_2(F1, F3, F4, COUP1, COUP2, M2, W2,F2)
      IMPLICIT NONE
      COMPLEX*16 CI
      PARAMETER (CI=(0D0,1D0))
      COMPLEX*16 COUP1
      COMPLEX*16 COUP2
      COMPLEX*16 COUP3
      COMPLEX*16 COUP4
      COMPLEX*16 F1(*)
      COMPLEX*16 F2(6)
      COMPLEX*16 F3(*)
      COMPLEX*16 F4(*)
      COMPLEX*16 FTMP(6)
      REAL*8 M2
      REAL*8 P2(0:3)
      REAL*8 W2
      COMPLEX*16 DENOM
      INTEGER*4 I
      CALL FFFF17_2(F1,F3,F4,COUP1,M2,W2,F2)
      CALL FFFF212_2(F1,F3,F4,COUP2,M2,W2,FTMP)
      DO I = 3, 6
        F2(I) = F2(I) + FTMP(I)
      ENDDO
      END

      INTEGER FUNCTION NEXTUNOPEN()
C     *****************************************************************
C     ***
C     Returns an unallocated FORTRAN i/o unit.
C     *****************************************************************
C     ***

      LOGICAL EX
C     
      DO 10 N = 10, 300
      INQUIRE (UNIT=N, OPENED=EX)
      IF (.NOT. EX) THEN
        NEXTUNOPEN = N
        RETURN
      ENDIF
 10   CONTINUE
      STOP ' There is no available I/O unit. '
C     *************************
      END



      SUBROUTINE OPENDATA(TABLEFILE)
C     *****************************************************************
C     ***
C     generic subroutine to open the table files in the right
C      directories
C     *****************************************************************
C     ***
      IMPLICIT NONE
C     
      CHARACTER TABLEFILE*(*),UP*3,LIB*4,DIR*8,TEMPNAME*100
      DATA UP,LIB,DIR/'../','lib/','Pdfdata/'/
      INTEGER IU,NEXTUNOPEN,I
      EXTERNAL NEXTUNOPEN
      COMMON/IU/IU
      CHARACTER*300 TEMPNAME2, PATH
      CHARACTER*25 UPBUFF
      INTEGER POS, FINE2
C     
C     --   start
C     
      IU=NEXTUNOPEN()

C     First try system wide (for cluster if define)


C     Then try in the current directory (for cluster use)
 5    TEMPNAME=TABLEFILE
      OPEN(IU,FILE=TEMPNAME,STATUS='old',ERR=10)
      RETURN

 10   TEMPNAME=UP//TABLEFILE
      OPEN(IU,FILE=TEMPNAME,STATUS='old',ERR=20)
      RETURN

C     then try PdfData directory
 20   TEMPNAME=DIR//TABLEFILE
      OPEN(IU,FILE=TEMPNAME,STATUS='old',ERR=30)
      RETURN

 30   TEMPNAME=LIB//TEMPNAME
      OPEN(IU,FILE=TEMPNAME,STATUS='old',ERR=40)

 40   CONTINUE
      DO I=0,6
        OPEN(IU,FILE=TEMPNAME,STATUS='old',ERR=50)
        RETURN
 50     TEMPNAME=UP//TEMPNAME
      ENDDO

C     try to find the path from the executable
C     
      CALL GETARG(0,PATH)  !path is the PATH to the madevent executable (either global or from launching directory)
      POS = INDEX(PATH,'/', .TRUE.)
      PATH = PATH(:POS)
      FINE2 = INDEX(PATH, ' ')-1
      UPBUFF = '../../../../../../../'
      TEMPNAME = TABLEFILE
      DO I=0,6
        TEMPNAME2= PATH(:FINE2)//UPBUFF(:3*I)//DIR//TEMPNAME
        OPEN(IU,FILE=TEMPNAME2,STATUS='old',ERR=60)
        RETURN
 60     TEMPNAME2= PATH(:FINE2)//UPBUFF(:3*I)//LIB//DIR//TEMPNAME
        OPEN(IU,FILE=TEMPNAME2,STATUS='old',ERR=70)
        RETURN
 70     IF (I.EQ.6)THEN
          WRITE(*,*) 'Error: PDF file ',TABLEFILE,' not found'
          STOP
        ENDIF
      ENDDO


      PRINT*,'table for the pdf NOT found  !!!'

      RETURN
      END

      Program DRIVER
c**************************************************************************
c     This is the driver for the whole calulation
c**************************************************************************
      implicit none
C
C     CONSTANTS
C
      double precision zero
      parameter       (ZERO = 0d0)
      include 'genps.inc'
      data HEL_PICKED/-1/
      data hel_jacobian/1.0d0/
      include 'maxconfigs.inc'
      include 'nexternal.inc'
      INTEGER    ITMAX, ITMIN, NCALL
C
C     LOCAL
C
      integer i,ninvar,nconfigs,j,l,l1,l2,ndim,idum
      double precision dsig,tot,mean,sigma,xdum
      integer npoints,lunsud
      double precision x,y,jac,s1,s2,xmin
      external dsig
      character*130 buf
      integer NextUnopen
      external NextUnopen
      double precision t_before
      logical fopened
c
c     Global
c
      integer                                      nsteps
      character*40          result_file,where_file
      common /sample_status/result_file,where_file,nsteps
      integer           Minvar(maxdim,lmaxconfigs)
      common /to_invar/ Minvar
      integer ngroup
      common/to_group/ngroup
      data ngroup/0/

      DOUBLE PRECISION CUMULATED_TIMING
      COMMON/GENERAL_STATS/CUMULATED_TIMING

c
c     PARAM_CARD
c
      character*30 param_card_name
      common/to_param_card_name/param_card_name
cc
      include 'run.inc'
      
      integer           mincfig, maxcfig
      common/to_configs/mincfig, maxcfig


      double precision twgt, maxwgt,swgt(maxevents)
      integer                             lun, nw
      common/to_unwgt/twgt, maxwgt, swgt, lun, nw

c--masses
      double precision pmass(nexternal)
      common/to_mass/  pmass
      double precision qmass(2)
      common/to_qmass/  qmass

c     $B$ new_def $E$  this is a tag for MadWeigth, Don't edit this line

c      double precision xsec,xerr
c      integer ncols,ncolflow(maxamps),ncolalt(maxamps),ic
c      common/to_colstats/ncols,ncolflow,ncolalt,ic

      include 'coupl.inc'

C-----
C  BEGIN CODE
C----- 
      call cpu_time(t_before)
      CUMULATED_TIMING = t_before
c
c     Read process number
c
      call open_file(lun+1, 'dname.mg', fopened)
      if (.not.fopened)then
         goto 11
      endif
c      open (unit=lun+1,file='../dname.mg',status='unknown',err=11)
      read (lun+1,'(a130)',err=11,end=11) buf
      l1=index(buf,'P')
      l2=index(buf,'_')
      if(l1.ne.0.and.l2.ne.0.and.l1.lt.l2-1)
     $     read(buf(l1+1:l2-1),*,err=11) ngroup
 11   print *,'Process in group number ',ngroup

c     Read weight from results.dat if present, to allow event generation
c     in first iteration for gridpacks
      call open_file_local(lun+1, 'results.dat', fopened)
      if (.not.fopened)then
         goto 13
      endif
c      open (unit=lun+1,file='results.dat',status='unknown',err=13)
      read (lun+1,'(a130)',err=12,end=12) buf
      close (lun+1)
      read(buf,'(3e12.5,2i9,i5,i9,e10.3,e12.5)',err=13) xdum,xdum,xdum,
     $     idum,idum,idum,idum,xdum,twgt
      goto 14
 12   close (lun+1)
 13   twgt = -2d0               !determine wgt after first iteration
 14   continue
      lun = 27

      open(unit=lun,status='scratch')
      nsteps=2
      param_card_name = 'param_card.dat'
      call setrun                !Sets up run parameters
      call setpara(param_card_name )   !Sets up couplings and masses
      include 'pmass.inc'        !Sets up particle masses
      call setcuts               !Sets up cuts 
      call printout              !Prints out a summary of paramaters
      call run_printout          !Prints out a summary of the run settings
      nconfigs = 1

c   If CKKW-type matching, read IS Sudakov grid
      if(ickkw.eq.2 .and. (lpp(1).ne.0.or.lpp(2).ne.0))then
        lunsud=NextUnopen()
        open(unit=lunsud,file=issgridfile,status='old',ERR=20)
        goto 40
 20     issgridfile='lib/'//issgridfile
        do i=1,5
          open(unit=lunsud,file=issgridfile,status='old',ERR=30)          
          exit
 30       issgridfile='../'//issgridfile
          if(i.eq.5)then
            print *,'ERROR: No Sudakov grid file found in lib with ickkw=2'
            stop
          endif
        enddo
        print *,'Reading Sudakov grid file ',issgridfile
 40     call readgrid(lunsud)
        print *,'Done reading IS Sudakovs'
      endif
        
      if(ickkw.eq.2)then
        hmult=.false.
        if(ngroup.ge.nhmult) hmult=.true.
        if(hmult)then
          print *,'Running CKKW as highest mult sample'
        else
          print *,'Running CKKW as lower mult sample'
        endif
      endif

c     
c     Get user input
c
      write(*,*) "getting user params"
      call init_good_hel()
      call get_user_params(ncall,itmax,itmin,mincfig)
      maxcfig=mincfig
      minvar(1,1) = 0              !This tells it to map things invarients
      write(*,*) 'Attempting mappinvarients',nconfigs,nexternal
      call map_invarients(minvar,nconfigs,ninvar,mincfig,maxcfig,nexternal,nincoming)
      write(*,*) "Completed mapping",nexternal
      ndim = 3*(nexternal-nincoming)-4
      if (nincoming.gt.1.and.abs(lpp(1)) .ge. 1) ndim=ndim+1
      if (nincoming.gt.1.and.abs(lpp(2)) .ge. 1) ndim=ndim+1
      ninvar = ndim
      do j=mincfig,maxcfig
         if (abs(lpp(1)) .ge. 1 .and. abs(lpp(1)) .ge. 1) then
            if(ndim.gt.1) minvar(ndim-1,j)=ninvar-1
            minvar(ndim,j) = ninvar
         elseif (abs(lpp(1)) .ge. 1 .or. abs(lpp(1)) .ge. 1) then
            minvar(ndim,j) = ninvar
         endif
      enddo
      write(*,*) "about to integrate ", ndim,ncall,itmax,itmin,ninvar,nconfigs
      call sample_full(ndim,ncall,itmax,itmin,dsig,ninvar,nconfigs)

c
c     Now write out events to permanent file
c
      if (twgt .gt. 0d0) maxwgt=maxwgt/twgt
      write(lun,'(a,f20.5)') 'Summary', maxwgt
      

c      write(*,'(a34,20I7)'),'Color flows originally chosen:   ',
c     &     (ncolflow(i),i=1,ncols)
c      write(*,'(a34,20I7)'),'Color flows according to diagram:',
c     &     (ncolalt(i),i=1,ncols)
c
c      call sample_result(xsec,xerr)
c      write(*,*) 'Final xsec: ',xsec

      rewind(lun)

      close(lun)
      end

c     $B$ get_user_params $B$ ! tag for MadWeight
c     change this routine to read the input in a file
c
      subroutine get_user_params(ncall,itmax,itmin,iconfig)
c**********************************************************************
c     Routine to get user specified parameters for run
c**********************************************************************
      use DiscreteSampler

      implicit none
c
c     Constants
c
      include 'nexternal.inc'
      include 'maxparticles.inc'
      integer NCOMB
      parameter (NCOMB=64)
c
c     Arguments
c
      integer ncall,itmax,itmin,iconfig, diag_number
      common/to_diag_number/diag_number
c
c     Local
c
      integer i, j, jconfig, ncode
      double precision dconfig
c
c     Global
c
      integer           isum_hel
      logical                   multi_channel
      common/to_matrix/isum_hel, multi_channel
      double precision    accur
      common /to_accuracy/accur
      integer           use_cut
      common /to_weight/use_cut

      integer        lbw(0:nexternal)  !Use of B.W.
      common /to_BW/ lbw

c-----
c  Begin Code
c-----
      write(*,'(a)') 'Enter number of events and max and min iterations: '
      read(*,*) ncall,itmax,itmin
      write(*,*) 'Number of events and iterations ',ncall,itmax,itmin
      write(*,'(a)') 'Enter desired fractional accuracy: '
      read(*,*) accur
      write(*,*) 'Desired fractional accuracy: ',accur

      write(*,'(a)') 'Enter 0 for fixed, 2 for adjustable grid: '
      read(*,*) use_cut
      if (use_cut .lt. 0 .or. use_cut .gt. 2) then
         if (use_cut.ne.-2) then
            write(*,*) 'Bad choice, using 2',use_cut
            use_cut = 2
         else if (use_cut.eq.-2)then
            itmax= 1
            itmin=1
         endif

      endif

      write(*,10) 'Suppress amplitude (0 no, 1 yes)? '
      read(*,*) i
      if (i .eq. 1) then
         multi_channel = .true.
         write(*,*) 'Using suppressed amplitude.'
      else
         multi_channel = .false.
         write(*,*) 'Using full amplitude.'
      endif

      write(*,10) 'Exact helicity sum (0 yes, n = number/event)? '
      read(*,*) i
      if (i .eq. 0) then
         isum_hel = 0
         write(*,*) 'Explicitly summing over helicities'
      else
         isum_hel= i
         write(*,*) 'Monte-Carlo over helicities'
c        initialize the discrete sampler module
         call DS_register_dimension('Helicity',NCOMB)
c        Also set the minimum number of points for which each helicity
c        should be probed before the grid is used for sampling.
C        Typically 10 * n_matrix<i>
         call DS_set_min_points(80,'Helicity')
      endif

      write(*,10) 'Enter Configuration Number: '
      read(*,*) dconfig
c     ncode is number of digits needed for the BW code
      ncode=int(dlog10(3d0)*(max_particles-3))+1
      iconfig = int(dconfig*(1+10**(-ncode)))
      write(*,12) 'Running Configuration Number: ',iconfig
      diag_number = iconfig
c
c     Here I want to set up with B.W. we map and which we don't
c
      dconfig = dconfig-iconfig
      if (dconfig .eq. 0) then
         write(*,*) 'Not subdividing B.W.'
         lbw(0)=0
      else
         lbw(0)=1
         jconfig=dconfig*(10**ncode + 0.1)
         write(*,*) 'Using dconfig=',jconfig
         call DeCode(jconfig,lbw(1),3,nexternal)
         write(*,*) 'BW Setting ', (lbw(j),j=1,nexternal-2)
c         do i=nexternal-3,0,-1
c            if (jconfig .ge. 2**i) then
c               lbw(i+1)=1
c               jconfig=jconfig-2**i
c            else
c               lbw(i+1)=0
c            endif 
c            write(*,*) i+1, lbw(i+1)
c         enddo
      endif
 10   format( a)
 12   format( a,i4)
      end
c     $E$ get_user_params $E$ ! tag for MadWeight
c     change this routine to read the input in a file
c

      subroutine open_file_local(lun,filename,fopened)
c***********************************************************************
c     opens file input-card.dat in current directory or above
c***********************************************************************
      implicit none
      include 'nexternal.inc'
c
c     Arguments
c
      integer lun
      logical fopened
      character*(*) filename
      character*300  tempname
      character*300  tempname2
      character*300 path ! path of the executable
      character*30  upname ! sequence of ../
      character*30 buffer,buffer2
      integer fine,fine2
      integer i, pos

      integer           mincfig, maxcfig
      common/to_configs/mincfig, maxcfig

      integer        lbw(0:nexternal)  !Use of B.W.
      common /to_BW/ lbw
      integer jconfig
c-----
c  Begin Code
c-----
c
c     first check that we will end in the main directory
c

c
cv    check local file
c
      fopened=.false.
      tempname=filename 	 
      fine=index(tempname,' ') 	 
      fine2=index(path,' ')-1	 
      if(fine.eq.0) fine=len(tempname)
      open(unit=lun,file=tempname,status='old',ERR=20)
      fopened=.true.
      return

c      
c     getting the path of the executable
c
 20   call getarg(0,path) !path is the PATH to the madevent executable (either global or from launching directory)
      pos = index(path,'/', .true.)
      path = path(:pos)
      fine2 = index(path, ' ')-1
c
c     getting the name of the directory
c
      if (lbw(0).eq.0)then
         ! No BW separation
         write(buffer,*) mincfig 
         path = path(:fine2)//'G'//adjustl(buffer)
         fine2 = index(path, ' ') -1
      else
         ! BW separation
         call Encode(jconfig,lbw(1),3,nexternal)
         write(buffer,*) mincfig
         buffer = adjustl(buffer)
         fine = index(buffer, ' ')-1
         write(buffer2,*) jconfig
         buffer2=adjustl(buffer2)
         path = path(:fine2)//'G'//buffer(:fine)//'.'//buffer2
         fine2 = index(path, ' ')-1
      endif
      tempname = path(:fine2)//filename
      open(unit=lun,file=tempname,status='old',ERR=30)
      fopened = .true.
      
 30    return
       end

C ************************************************************
C Source for the library implementing a dummt bias function 
C always returns one
C ************************************************************
      
      subroutine bias_wgt(p, original_weight, bias_weight)
          implicit none
C
C Parameters
C
          include '../../nexternal.inc'
C
C Arguments
C
          double precision p(0:3,nexternal)
          double precision original_weight, bias_weight
C
C local variables
C
C
C Global variables
C
C Mandatory common block to be defined in bias modules
C
          double precision stored_bias_weight
          data stored_bias_weight/1.0d0/          
          logical impact_xsec, requires_full_event_info
C         Not impacting the xsec since the bias is 1.0. Therefore
C         bias_wgt will not be written in the lhe event file.
C         Setting it to .True. makes sure that it will not be written.
          data impact_xsec/.True./
C         Of course this module does not require the full event
C         information (color, resonances, helicities, etc..)
          data requires_full_event_info/.False./ 
          common/bias/stored_bias_weight,impact_xsec,
     &                requires_full_event_info

C --------------------
C BEGIN IMPLEMENTATION
C --------------------

          bias_weight = 1.0d0

      end subroutine bias_wgt

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c      written by the UFO converter
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      DOUBLE COMPLEX FUNCTION COND(CONDITION,TRUECASE,FALSECASE)
      IMPLICIT NONE
      DOUBLE COMPLEX CONDITION,TRUECASE,FALSECASE
      IF(CONDITION.EQ.(0.0D0,0.0D0)) THEN
        COND=TRUECASE
      ELSE
        COND=FALSECASE
      ENDIF
      END

      DOUBLE COMPLEX FUNCTION CONDIF(CONDITION,TRUECASE,FALSECASE)
      IMPLICIT NONE
      LOGICAL CONDITION
      DOUBLE COMPLEX TRUECASE,FALSECASE
      IF(CONDITION) THEN
        CONDIF=TRUECASE
      ELSE
        CONDIF=FALSECASE
      ENDIF
      END

      DOUBLE COMPLEX FUNCTION RECMS(CONDITION,EXPR)
      IMPLICIT NONE
      LOGICAL CONDITION
      DOUBLE COMPLEX EXPR
      IF(CONDITION)THEN
        RECMS=EXPR
      ELSE
        RECMS=DCMPLX(DBLE(EXPR))
      ENDIF
      END

      DOUBLE COMPLEX FUNCTION REGLOG(ARG)
      IMPLICIT NONE
      DOUBLE COMPLEX TWOPII
      PARAMETER (TWOPII=2.0D0*3.1415926535897932D0*(0.0D0,1.0D0))
      DOUBLE COMPLEX ARG
      IF(ARG.EQ.(0.0D0,0.0D0)) THEN
        REGLOG=(0.0D0,0.0D0)
      ELSE
        REGLOG=LOG(ARG)
      ENDIF
      END

      DOUBLE COMPLEX FUNCTION REGLOGP(ARG)
      IMPLICIT NONE
      DOUBLE COMPLEX TWOPII
      PARAMETER (TWOPII=2.0D0*3.1415926535897932D0*(0.0D0,1.0D0))
      DOUBLE COMPLEX ARG
      IF(ARG.EQ.(0.0D0,0.0D0))THEN
        REGLOGP=(0.0D0,0.0D0)
      ELSE
        IF(DBLE(ARG).LT.0.0D0.AND.DIMAG(ARG).LT.0.0D0)THEN
          REGLOGP=LOG(ARG) + TWOPII
        ELSE
          REGLOGP=LOG(ARG)
        ENDIF
      ENDIF
      END

      DOUBLE COMPLEX FUNCTION REGLOGM(ARG)
      IMPLICIT NONE
      DOUBLE COMPLEX TWOPII
      PARAMETER (TWOPII=2.0D0*3.1415926535897932D0*(0.0D0,1.0D0))
      DOUBLE COMPLEX ARG
      IF(ARG.EQ.(0.0D0,0.0D0))THEN
        REGLOGM=(0.0D0,0.0D0)
      ELSE
        IF(DBLE(ARG).LT.0.0D0.AND.DIMAG(ARG).GT.0.0D0)THEN
          REGLOGM=LOG(ARG) - TWOPII
        ELSE
          REGLOGM=LOG(ARG)
        ENDIF
      ENDIF
      END

      DOUBLE COMPLEX FUNCTION REGSQRT(ARG_IN)
      IMPLICIT NONE
      DOUBLE COMPLEX ARG_IN
      DOUBLE COMPLEX ARG
      ARG=ARG_IN
      IF(DABS(DIMAG(ARG)).EQ.0.0D0)THEN
        ARG=DCMPLX(DBLE(ARG),0.0D0)
      ENDIF
      IF(DABS(DBLE(ARG)).EQ.0.0D0)THEN
        ARG=DCMPLX(0.0D0,DIMAG(ARG))
      ENDIF
      REGSQRT=SQRT(ARG)
      END

      DOUBLE COMPLEX FUNCTION GRREGLOG(LOGSW,EXPR1_IN,EXPR2_IN)
      IMPLICIT NONE
      DOUBLE COMPLEX TWOPII
      PARAMETER (TWOPII=2.0D0*3.1415926535897932D0*(0.0D0,1.0D0))
      DOUBLE COMPLEX EXPR1_IN,EXPR2_IN
      DOUBLE COMPLEX EXPR1,EXPR2
      DOUBLE PRECISION LOGSW
      DOUBLE PRECISION IMAGEXPR
      LOGICAL FIRSTSHEET
      EXPR1=EXPR1_IN
      EXPR2=EXPR2_IN
      IF(DABS(DIMAG(EXPR1)).EQ.0.0D0)THEN
        EXPR1=DCMPLX(DBLE(EXPR1),0.0D0)
      ENDIF
      IF(DABS(DBLE(EXPR1)).EQ.0.0D0)THEN
        EXPR1=DCMPLX(0.0D0,DIMAG(EXPR1))
      ENDIF
      IF(DABS(DIMAG(EXPR2)).EQ.0.0D0)THEN
        EXPR2=DCMPLX(DBLE(EXPR2),0.0D0)
      ENDIF
      IF(DABS(DBLE(EXPR2)).EQ.0.0D0)THEN
        EXPR2=DCMPLX(0.0D0,DIMAG(EXPR2))
      ENDIF
      IF(EXPR1.EQ.(0.0D0,0.0D0))THEN
        GRREGLOG=(0.0D0,0.0D0)
      ELSE
        IMAGEXPR=DIMAG(EXPR1)*DIMAG(EXPR2)
        FIRSTSHEET=IMAGEXPR.GE.0.0D0
        FIRSTSHEET=FIRSTSHEET.OR.DBLE(EXPR1).GE.0.0D0
        FIRSTSHEET=FIRSTSHEET.OR.DBLE(EXPR2).GE.0.0D0
        IF(FIRSTSHEET)THEN
          GRREGLOG=LOG(EXPR1)
        ELSE
          IF(DIMAG(EXPR1).GT.0.0D0)THEN
            GRREGLOG=LOG(EXPR1) - LOGSW*TWOPII
          ELSE
            GRREGLOG=LOG(EXPR1) + LOGSW*TWOPII
          ENDIF
        ENDIF
      ENDIF
      END

      DOUBLE COMPLEX FUNCTION ARG(COMNUM)
      IMPLICIT NONE
      DOUBLE COMPLEX COMNUM
      DOUBLE COMPLEX IIM
      IIM = (0.0D0,1.0D0)
      IF(COMNUM.EQ.(0.0D0,0.0D0)) THEN
        ARG=(0.0D0,0.0D0)
      ELSE
        ARG=LOG(COMNUM/ABS(COMNUM))/IIM
      ENDIF
      END

      DOUBLE COMPLEX FUNCTION COT(Z)
      IMPLICIT NONE
      DOUBLE COMPLEX Z

      COT = 1.000000D+00/TAN(DBLE(DBLE(Z)))

      RETURN
      END

C...READGRID reads the IS Sudakov grid for all flavors from a file
      subroutine readgrid(lun)
      implicit none

c...global variables
      include 'sudgrid.inc'
      include 'pdf.inc'
      include 'maxparticles.inc'
      include 'run.inc'

c...arguments
      integer lun

c...local variables
      integer i,j,ipt2,ix1,ix2,kfl,ipoints
      data kfl,ipoints/-1,1/
      logical opened

c   integer nbins(3)
c   data nbins/npt2,nx1,nx2/
      character*100 buf
      character*7 pdgrid
      double precision ebeam1,ebeam2

c   Check that the file lun is opened
      inquire(unit=lun,opened=opened)
      if(.not.opened)then
        write(*,*) 'readgrid: Error, unit ',lun,' not opened'
        stop
      endif
      
      ebeam1=0
      ebeam2=0
      
c...Check that the grid is correct
      read(lun,'(a)',ERR=999,END=999) buf
      do while(buf(1:1).eq.'#'.or.buf.eq.'')
        if(index(buf,'pdlabel').ne.0)then
          call getfirst(pdgrid,buf(2:))
          if(pdgrid .ne. pdlabel)then
            write(*,*)'Error: ',
     $         'Different pdf labels in Sudakov grid and run_card.'
            write(*,*)'Please regenerate grid file issudgrid.dat ',
     $         'or use pdlabel ',pdgrid
            stop
          endif
        endif
        if(index(buf,'ebeam1').ne.0)then
          read(buf(2:index(buf,'=')-1),*)ebeam1
        endif
        if(index(buf,'ebeam2').ne.0)then
          read(buf(2:index(buf,'=')-1),*)ebeam2
        endif
        if(ebeam1.ne.0.and.ebeam2.ne.0)then
          if(abs(ebeam1-ebeam(1))/ebeam(1).gt.1d-3.or.
     $       abs(ebeam2-ebeam(2))/ebeam(2).gt.1d-3)then
            write(*,*)'Fatal error: ',
     $         'Different beam energies in Sudakov grid and run_card.'
            write(*,*)'Please regenerate grid file issudgrid.dat ',
     $         'or use beam energies'
            write(*,*) ebeam1,ebeam2
            stop
          endif
        endif
        read(lun,'(a)',ERR=999,END=999) buf
      enddo
      rewind(lun)

c...read grid points
      do i=-2,5
      read(lun,'(a)',ERR=999,END=999) buf
      do while(buf(1:1).eq.'#'.or.buf.eq.'')
        if(index(buf,'kfl').ne.0)then
          read(buf(2:index(buf,'=')),*) kfl
          if(kfl.eq.21) kfl=0
          if(i.ne.kfl)
     $       write(*,'(''#'',a,i3)')
     $       'Warning! Expecting flavor ',i,' but read ',kfl
          if(kfl.lt.-2.or.kfl.gt.5)then
            write(*,*) 'Error! Only partons between -2 and 5 allowed'
            write(*,*) ' (gluon is 0 or 21)'
            stop
          endif
          if(iabs(kfl).eq.5) then 
            ipoints=2
          else
            ipoints=1
          endif
        endif
        read(lun,'(a)',ERR=999,END=999) buf
      enddo
      do ix2=1,nx2
        do ix1=1,nx1
          do ipt2=1,npt2
            read(buf,*,ERR=900,END=900)
     $         points(ix2,ipoints),points(nx2+ix1,ipoints),
     $         points(nx2+nx1+ipt2,ipoints),sudgrid(ix2,ix1,ipt2,kfl)
            points(ix2,ipoints)=log(points(ix2,ipoints))
            points(nx2+nx1+ipt2,ipoints)=
     $         2*log(points(nx2+nx1+ipt2,ipoints))
            if(ix2.lt.nx2.or.ix1.lt.nx1.or.ipt2.lt.npt2)
     $         read(lun,'(a)',ERR=900,END=900) buf
          enddo
        enddo
      enddo
      enddo

      write(*,'(''#'',a)') 'Done reading IS Sudakov grid'
      return

 900  write(*,*) 'Error reading IS Sudakov grid!'
      write(*,*) 'kfl=',kfl,' ix2=',ix2,' ix1=',ix1,'ipt2=',ipt2
      stop

 999  write(*,'(''#'',a,a,i2,a)') 'Warning: Failed to read IS ',
     $   'Sudakov grid for flavor ',i,' and up'
      return

      end


      subroutine getfirst(first,string)

      implicit none
      character*(*) string
      character*20 first
      character*20 temp

      temp=string
      do while(temp(1:1) .eq. ' '.or.temp(1:1).eq.'''') 
	temp=temp(2:len(temp))
      end do
      first=temp(1:index(temp,' ')-1)
      if(index(first,'''').gt.0) first=first(1:index(first,'''')-1)

      end

      subroutine read_event(lun,P,wgt,nexternal,ic,ievent,scale,aqcd,aqed,done)
c********************************************************************
c     Reads one event from data file #lun
c     ic(*,1) = Particle ID
c     ic(*,2) = Mothup(1)
c     ic(*,3) = Mothup(2)
c     ic(*,4) = ICOLUP(1)
c     ic(*,5) = ICOLUP(2)
c     ic(*,6) = ISTUP   -1=initial state +1=final  +2=decayed
c     ic(*,7) = Helicity
c********************************************************************
      implicit none
c
c     parameters
c
      integer    MaxParticles
      parameter (MaxParticles=15)
      double precision pi
      parameter (pi = 3.1415926d0)
c
c     Arguments
c      
      integer lun
      integer nexternal, ic(7,MaxParticles)
      logical done
      double precision P(0:3,MaxParticles),wgt,aqcd,aqed,scale
      integer ievent
c
c     Local
c
      integer i,j,k
      character*(132) buff
c
c     Global
c
c      include 'coupl.inc'
c      real*8          scale
c      logical               fixed_ren_scale,fixed_fac_scale
c      common/to_scale/scale,fixed_ren_scale,fixed_fac_scale

      logical banner_open
      integer lun_ban
      common/to_banner/banner_open, lun_ban

      data lun_ban/37/
      data banner_open/.false./
c-----
c  Begin Code
c-----     
      done=.false.
      if (.not. banner_open) then
         open (unit=lun_ban, status='scratch')
         banner_open=.true.
      endif
 11   read(lun,'(a132)',end=99,err=99) buff
      do while(index(buff,"#") .ne. 0)
         write(lun_ban,'(a)') buff
         read(lun,'(a132)',end=99,err=99) buff
      enddo
      read(buff,*,err=11, end=11) nexternal,k,wgt,scale,aqed,aqcd
      do j=1,7
         read(lun,*,err=99,end=99) (ic(j,i),i=1,nexternal)!This is info
      enddo      
      do j=1,nexternal
         read(lun,55,err=99,end=99) k,(p(i,j),i=0,3)
      enddo
c      gal(1) = sqrt(4d0*pi*aqed)
c      g      = sqrt(4d0*pi*aqcd)
      return
 99   done=.true.
      return
 55   format(i3,4e19.11)         
      end

      subroutine write_event(lun,P,wgt,nexternal,ic,ievent,scale,aqcd,aqed)
c********************************************************************
c     Writes one event from data file #lun according to LesHouches
c     ic(*,1) = Particle ID
c     ic(*,2) = Mothup(1)
c     ic(*,3) = Mothup(2)
c     ic(*,4) = ICOLUP(1)
c     ic(*,5) = ICOLUP(2)
c     ic(*,6) = ISTUP   -1=initial state +1=final  +2=decayed
c     ic(*,7) = Helicity
c********************************************************************
      implicit none
c
c     parameters
c
      integer    MaxParticles
      parameter (MaxParticles=15)
      double precision pi
      parameter (pi = 3.1415926d0)
c
c     Arguments
c      
      integer lun, ievent
      integer nexternal, ic(7,MaxParticles)
      double precision P(0:3,MaxParticles),wgt
      double precision aqcd, aqed, scale
c
c     Local
c
      integer i,j,k
c
c     Global
c

c-----
c  Begin Code
c-----     
c      aqed= gal(1)*gal(1)/4d0/pi
c      aqcd = g*g/4d0/pi
      write(lun,'(2i8,4e15.7)') nexternal,ievent,wgt,scale,aqed,aqcd
      do j=1,7
         write(lun,51) (ic(j,i),i=1,nexternal)  !This is info
      enddo
      do j=1,nexternal
         write(lun,55) j,(p(i,j),i=0,3)
      enddo
      return
 51   format(19i5)
 55   format(i3,4e19.11)         
      end

      subroutine write_comments(lun)
c********************************************************************
c     Outputs all of the banner comment lines back at the top of
c     the file lun.
c********************************************************************
      implicit none
c
c     Arguments
c
      integer lun
c
c     Local
c
      character*(80) buff
c
c     Global
c
      logical banner_open
      integer lun_ban
      common/to_banner/banner_open, lun_ban

c-----
c  Begin Code
c-----     
c      write(*,*) 'Writing comments'
      if (banner_open) then
         rewind(lun_ban)
         do while (.true.) 
            read(lun_ban,'(a79)',end=99,err=99) buff
            write(lun,'(a79)') buff
c            write(*,*) buff
         enddo
 99      close(lun_ban)
         banner_open = .false.
      endif
      end

      SUBROUTINE SETCUTS
C**************************************************************************
C     SET THE CUTS 
C**************************************************************************
      IMPLICIT NONE
c
c     INCLUDE
c
      include 'genps.inc'
      include 'nexternal.inc'
      include 'coupl.inc'
      include 'run.inc'
      include 'cuts.inc'
c
c     Constants
c
      double precision zero
      parameter       (ZERO = 0d0)
      real*8 Pi
      parameter( Pi = 3.14159265358979323846d0 )
      integer    lun
      parameter (lun=22)
c
c     LOCAL
c
      integer i,j,k
      integer icollider,detail_level
      integer ncheck
      logical done,fopened
      logical from_decay(-(nexternal+3):nexternal)
C     
C     GLOBAL
C
c--masses and poles
      double precision pmass(nexternal)
      common/to_mass/  pmass
      DOUBLE PRECISION       qmass(2)
      COMMON/to_qmass/qmass
      double precision      spole(maxinvar),swidth(maxinvar),bwjac
      common/to_brietwigner/spole          ,swidth          ,bwjac

      double precision Smin
      common/to_smin/ Smin
c--cuts
      double precision etmin(nincoming+1:nexternal)
      double precision etamax(nincoming+1:nexternal)
      double precision emin(nincoming+1:nexternal)
      double precision r2min(nincoming+1:nexternal,nincoming+1:nexternal)
      double precision s_min(nexternal,nexternal)
      double precision etmax(nincoming+1:nexternal)
      double precision etamin(nincoming+1:nexternal)
      double precision emax(nincoming+1:nexternal)
      double precision r2max(nincoming+1:nexternal,nincoming+1:nexternal)
      double precision s_max(nexternal,nexternal)
      double precision ptll_min(nexternal,nexternal),ptll_max(nexternal,nexternal)
      double precision inclHtmin,inclHtmax
      common/to_cuts/  etmin, emin, etamax, r2min, s_min,
     $     etmax, emax, etamin, r2max, s_max, ptll_min, ptll_max, inclHtmin,inclHtmax

      double precision ptjmin4(4),ptjmax4(4),htjmin4(2:4),htjmax4(2:4)
      logical jetor
      common/to_jet_cuts/ ptjmin4,ptjmax4,htjmin4,htjmax4,jetor

      double precision ptlmin4(4),ptlmax4(4)
      common/to_lepton_cuts/ ptlmin4,ptlmax4

      double precision xqcutij(nexternal,nexternal),xqcuti(nexternal)
      common/to_xqcuts/xqcutij,xqcuti
c
c     les houches accord stuff to identify neutrinos
c
      include 'maxamps.inc'
      integer idup(nexternal,maxproc,maxsproc)
      integer mothup(2,nexternal)
      integer icolup(2,nexternal,maxflow,maxsproc)
      include 'leshouche.inc'
C
      LOGICAL  IS_A_J(NEXTERNAL),IS_A_L(NEXTERNAL)
      LOGICAL  IS_A_B(NEXTERNAL),IS_A_A(NEXTERNAL),IS_A_ONIUM(NEXTERNAL)
      LOGICAL  IS_A_NU(NEXTERNAL),IS_HEAVY(NEXTERNAL)
      logical  do_cuts(nexternal)
      COMMON /TO_SPECISA/IS_A_J,IS_A_A,IS_A_L,IS_A_B,IS_A_NU,IS_HEAVY,
     . IS_A_ONIUM, do_cuts 

c     Store which external particles undergo the ktdurham and ptlund cuts.
      LOGICAL  is_pdg_for_merging_cut(NEXTERNAL)
      COMMON /TO_MERGE_CUTS/is_pdg_for_merging_cut, from_decay

c
c
c     reading parameters
      include 'run_config.inc'
      character*20 param(maxpara),value(maxpara)
      integer npara
c For checking the consistency of the grouping and the cuts defined here
      integer iproc
      character*20 fail_reason
      LOGICAL  IS_A_J_SAVE(NEXTERNAL),IS_A_L_SAVE(NEXTERNAL)
     $     ,IS_A_B_SAVE(NEXTERNAL),IS_A_A_SAVE(NEXTERNAL)
     $     ,IS_A_ONIUM_SAVE(NEXTERNAL),IS_A_NU_SAVE(NEXTERNAL)
     $     ,IS_HEAVY_SAVE(NEXTERNAL),DO_CUTS_SAVE(NEXTERNAL)
      double precision r2min_save(nexternal,nexternal)
     $     ,r2max_save(nexternal,nexternal),s_min_save(nexternal
     $     ,nexternal),s_max_save(nexternal,nexternal)
     $     ,ptll_min_save(nexternal,nexternal),ptll_max_save(nexternal
     $     ,nexternal),etmin_save(nexternal),etmax_save(nexternal)
     $     ,emin_save(nexternal) ,emax_save(nexternal)
     $     ,etamin_save(nexternal),etamax_save(nexternal)
      save  IS_A_J_SAVE,IS_A_L_SAVE,IS_A_B_SAVE,IS_A_A_SAVE
     $     ,IS_A_ONIUM_SAVE,IS_A_NU_SAVE,IS_HEAVY_SAVE
     $     ,r2min_save,r2max_save,s_min_save,s_max_save,ptll_min_save
     $     ,ptll_max_save,etmin_save,etmax_save,emin_save,emax_save
     $     ,etamin_save,etamax_save
c
c     count the number of j/bjet/photon/lepton
c
      integer nb_j, nb_b, nb_a, nb_l, nb_nocut,nb_pdg
      double precision smin_p, smin_m ! local variable to compute smin
c
c     setup masses for the final-state particles
c
      include 'pmass.inc'

C-----
C  BEGIN CODE
C-----
c
c     read the cuts from the run_card.dat - this should already be done in main program
c
c      call setrun

c
c     No pdfs for decay processes - set here since here we know the nincoming
c     Also set stot here, and use mass of incoming particle for ren scale
c
         if(nincoming.eq.1)then
            lpp(1)=0
            lpp(2)=0
            ebeam(1)=pmass(1)/2d0
            ebeam(2)=pmass(1)/2d0
            if (.not.fixed_ren_scale)then
               scale=pmass(1)
               fixed_ren_scale=.true.
            endif
            fixed_fac_scale=.true.
            use_syst=.false.
         endif


c
c     set ptj and s_min if xqcut and ktscheme = 1, to improve
c     integration speed, and set drjj and drjl to 0.
c
        if(xqcut.gt.0) then
           if(auto_ptj_mjj.and.ptj.ge.0d0.and.ktscheme.eq.1)then
            ptj=xqcut
            write(*,*) 'Warning! ptj set to xqcut=',xqcut,
     $            ' to improve integration efficiency'
            write(*,*) 'Note that this might affect non-radiated jets,'
            write(*,*) 'e.g. from decays. Use cut_decays=F in run_card.'
          else if(ptj.gt.xqcut)then
            ptj=0d0
            write(*,*) 'Warning! ptj set to 0 since xqcut > 0 and'
            write(*,*) '         auto_ptj_mjj = F or ktscheme > 1'
          endif
          if(auto_ptj_mjj.and.mmjj.ge.0d0)then
            mmjj=xqcut
            write(*,*) 'Warning! mmjj set to xqcut=',xqcut,
     $            ' to improve integration efficiency'
            write(*,*) 'Note that this might affect non-radiated jets,'
            write(*,*) 'e.g. from decays. Use cut_decays=F in run_card.'
          else if(mmjj.gt.xqcut)then
c           In principle this should never happen since the banner.py
c           is expected to correct this already.
            mmjj=0d0
            write(*,*) 'Warning! mmjj set to 0 since xqcut > 0 and'
            write(*,*) '         auto_ptj_mjj = F'
          endif
          if(drjj.gt.0d0) then
            write(*,*) 'Warning! drjj > 0 with xqcut > 0, set to 0'
            drjj = 0d0
          endif
          if(drjl.gt.0d0) then
            write(*,*) 'Warning! drjl > 0 with xqcut > 0, set to 0'
            drjl = 0d0
          endif
        endif

c     Check which particles come from decays
      if(.not.cut_decays)
     $       call check_decay(from_decay)


      do iproc=1,maxsproc

c
c     check if I have to apply cuts on the particles
c
      do i=nincoming+1,nexternal
         do_cuts(i)=.true.
         if(.not.cut_decays.and.from_decay(i)) do_cuts(i)=.false.
         is_a_j(i)=.false.
         is_a_l(i)=.false.
         is_a_b(i)=.false.
         is_a_a(i)=.false.
         is_a_nu(i)=.false.


c-do not apply cuts to these. CAREFULL: PDG_CUT do not consider do_cuts (they simply check the cut_decays)
         if (pmass(i).gt.20d0)     do_cuts(i)=.false.  ! no cuts on top,W,Z,H
         if (abs(idup(i,1,iproc)).eq.12) do_cuts(i)=.false.  ! no cuts on ve ve~
         if (abs(idup(i,1,iproc)).eq.14) do_cuts(i)=.false.  ! no cuts on vm vm~
         if (abs(idup(i,1,iproc)).eq.16) do_cuts(i)=.false.  ! no cuts on vt vt~
c-flavor-jets
         if (abs(idup(i,1,iproc)).le.min(maxjetflavor,6)) then
              is_a_j(i)=.true.
c              write(*,*)'jet:ithe pdg is ',abs(idup(i,1,iproc)),' maxflavor=',maxjetflavor
         else if (abs(idup(i,1,iproc)).ge.maxjetflavor+1 .and. abs(idup(i,1,iproc)).le.5) then
              is_a_b(i)=.true.
c              write(*,*)'bjet:the pdg is ',abs(idup(i,1,iproc)),' maxflavor=',maxjetflavor
         endif

         if (abs(idup(i,1,iproc)).eq.21)  is_a_j(i)=.true. ! gluon is a jet
c-charged-leptons
         if (abs(idup(i,1,iproc)).eq.11)  is_a_l(i)=.true. ! e+  e-
         if (abs(idup(i,1,iproc)).eq.13)  is_a_l(i)=.true. ! mu+ mu-
         if (abs(idup(i,1,iproc)).eq.15)  is_a_l(i)=.true. ! ta+ ta-
c-b-quarks
c         if (abs(idup(i,1,iproc)).eq.5)   is_a_b(i)=.true. ! b b~
c-photon
         if (idup(i,1,iproc).eq.22)   is_a_a(i)=.true. ! photon
c-neutrino's for missing et
         if (abs(idup(i,1,iproc)).eq.12) is_a_nu(i)=.true.  ! no cuts on ve ve~
         if (abs(idup(i,1,iproc)).eq.14) is_a_nu(i)=.true.  ! no cuts on vm vm~
         if (abs(idup(i,1,iproc)).eq.16) is_a_nu(i)=.true.  ! no cuts on vt vt~
         if (pmass(i).gt.10d0)     is_heavy(i)=.true. ! heavy fs particle
c-onium

c        Remember mergeable particles
         do j=1,pdgs_for_merging_cut(0)
           if (    pdgs_for_merging_cut(j) .ne. 0
     $       .and. abs(idup(i,1,iproc)) .eq.pdgs_for_merging_cut(j)
     $       .and..not.from_decay(i) ) then
             is_pdg_for_merging_cut(i)=.true.
             exit
            endif
         enddo

      enddo




c
c     et and eta cuts
c
      do i=nincoming+1,nexternal
         etmin(i)  = 0d0
         etmax(i)  = -1

         emin(i)   = 0d0
         emax(i)   = -1

         etamin(i) = 0d0
         etamax(i) = -1

         if(do_cuts(i)) then

c        JET
            if(is_a_j(i))then
                 etmin(i)=ptj
                 etmax(i)=ptjmax
                 emin(i)=ej
                 emax(i)=ejmax
                 etamax(i)=etaj
                 etamin(i)=etajmin
            endif
c        LEPTON
            if(is_a_l(i))then
                 etmin(i)=ptl
                 etmax(i)=ptlmax
                 emin(i)=el
                 emax(i)=elmax
                 etamax(i)=etal
                 etamin(i)=etalmin
            endif
c        BJET
            if(is_a_b(i))then
                 etmin(i)=ptb
                 etmax(i)=ptbmax
                 emin(i)=eb
                 emax(i)=ebmax
                 etamax(i)=etab
                 etamin(i)=etabmin
            endif
c        PHOTON
            if(is_a_a(i))then
                 etmin(i) = max(pta, ptgmin)
                 etmax(i)=ptamax
                 emin(i)=ea
                 emax(i)=eamax
                 etamax(i)=etaa
                 etamin(i)=etaamin
            endif
c        QUARKONIUM
c            if(is_a_onium(i))then
c                 etmin(i)=ptonium
c                 SMIN = SMIN + max(0d0,ptonium**2
c                 etamax(i)=etaonium
c            endif
         endif
      enddo
c
c     check for pdg specific cut
c
      if (pdg_cut(1).ne.0)then

         do j=1,pdg_cut(0)
            do i=nincoming+1, nexternal
               if(.not.cut_decays.and.from_decay(i))then
                  cycle
               endif
               if (abs(idup(i, 1, iproc)).eq.pdg_cut(j))then
                  etmin(i) = ptmin4pdg(j)
                  etmax(i)= ptmax4pdg(j)
                  emin(i)= Emin4pdg(j)
                  emax(i)= Emax4pdg(j)
                  etamin(i)= etamin4pdg(j)
                  etamax(i)= etamax4pdg(j)
               endif
            enddo
         enddo
      endif

c
c     delta r cut
c
      do i=nincoming+1,nexternal-1
         do j=i+1,nexternal
            r2min(j,i)=0d0
            r2max(j,i)=-1
            if(do_cuts(i).and.do_cuts(j)) then

               if(is_a_j(i).and.is_a_j(j)) r2min(j,i)=drjj
               if(is_a_b(i).and.is_a_b(j)) r2min(j,i)=drbb
               if(is_a_l(i).and.is_a_l(j)) r2min(j,i)=drll
               if(is_a_a(i).and.is_a_a(j)) r2min(j,i)=draa

               if((is_a_b(i).and.is_a_j(j)).or.
     &           (is_a_j(i).and.is_a_b(j))) r2min(j,i)=drbj
               if((is_a_a(i).and.is_a_j(j)).or.
     &           (is_a_j(i).and.is_a_a(j))) r2min(j,i)=draj
               if((is_a_l(i).and.is_a_j(j)).or.
     &           (is_a_j(i).and.is_a_l(j))) r2min(j,i)=drjl
               if((is_a_b(i).and.is_a_a(j)).or.
     &           (is_a_a(i).and.is_a_b(j))) r2min(j,i)=drab
               if((is_a_b(i).and.is_a_l(j)).or.
     &           (is_a_l(i).and.is_a_b(j))) r2min(j,i)=drbl
               if((is_a_l(i).and.is_a_a(j)).or.
     &           (is_a_a(i).and.is_a_l(j))) r2min(j,i)=dral

               if(is_a_j(i).and.is_a_j(j)) r2max(j,i)=drjjmax
               if(is_a_b(i).and.is_a_b(j)) r2max(j,i)=drbbmax
               if(is_a_l(i).and.is_a_l(j)) r2max(j,i)=drllmax
               if(is_a_a(i).and.is_a_a(j)) r2max(j,i)=draamax

               if((is_a_b(i).and.is_a_j(j)).or.
     &           (is_a_j(i).and.is_a_b(j))) r2max(j,i)=drbjmax
               if((is_a_a(i).and.is_a_j(j)).or.
     &           (is_a_j(i).and.is_a_a(j))) r2max(j,i)=drajmax
               if((is_a_l(i).and.is_a_j(j)).or.
     &           (is_a_j(i).and.is_a_l(j))) r2max(j,i)=drjlmax
               if((is_a_b(i).and.is_a_a(j)).or.
     &           (is_a_a(i).and.is_a_b(j))) r2max(j,i)=drabmax
               if((is_a_b(i).and.is_a_l(j)).or.
     &           (is_a_l(i).and.is_a_b(j))) r2max(j,i)=drblmax
               if((is_a_l(i).and.is_a_a(j)).or.
     &           (is_a_a(i).and.is_a_l(j))) r2max(j,i)=dralmax
 
            endif
         enddo
      enddo
c     
c     smin cut
c
      do i=nincoming+1,nexternal-1
         do j=i+1,nexternal
            s_min(j,i)=0.0d0**2
            s_max(j,i)=-1
            if(do_cuts(i).and.do_cuts(j)) then
               if(is_a_j(i).and.is_a_j(j)) s_min(j,i)=mmjj*dabs(mmjj)   
               if(is_a_a(i).and.is_a_a(j)) s_min(j,i)=mmaa*dabs(mmaa)  
               if( is_a_b(i).and.is_a_b(j) ) s_min(j,i)=mmbb*dabs(mmbb)     
               if((is_a_l(i).and.is_a_l(j)).and.
     &            (abs(idup(i,1,iproc)).eq.abs(idup(j,1,iproc))).and.
     &            (idup(i,1,iproc)*idup(j,1,iproc).lt.0)) 
     &            s_min(j,i)=mmll*dabs(mmll)  !only on l+l- pairs (same flavour) 

               if(is_a_j(i).and.is_a_j(j)) s_max(j,i)=mmjjmax*dabs(mmjjmax)   
               if(is_a_a(i).and.is_a_a(j)) s_max(j,i)=mmaamax*dabs(mmaamax)  
               if( is_a_b(i).and.is_a_b(j) ) s_max(j,i)=mmbbmax*dabs(mmbbmax)     
               if((is_a_l(i).and.is_a_l(j)).and.
     &            (abs(idup(i,1,iproc)).eq.abs(idup(j,1,iproc))).and.
     &            (idup(i,1,iproc)*idup(j,1,iproc).lt.0)) 
     &            s_max(j,i)=mmllmax*dabs(mmllmax)  !only on l+l- pairs (same flavour)
            endif
         enddo
      enddo      
c
c     smin cut from PDG cut 
c
      if (pdg_cut(1).ne.0)then
         do k=1,pdg_cut(0)
            do i=nincoming+1, nexternal
               if(.not.cut_decays.and.from_decay(i))then
                  cycle
               endif
               if (abs(idup(i, 1, iproc)).ne.pdg_cut(k))then
                  cycle
               endif
               do j = i+1,nexternal
                  if(.not.cut_decays.and.from_decay(j))then
                     cycle
                  endif
                  if (mxxpart_antipart(k))then
                     if  (idup(j, 1, iproc).eq.-1*idup(i, 1, iproc))then
                        s_min(j,i) = mxxmin4pdg(k)**2
                     endif
                  else
                     if  (abs(idup(j, 1, iproc)).eq.pdg_cut(k))then
                        s_min(j,i) = mxxmin4pdg(k)**2
                     endif
                  endif
               enddo
            enddo
         enddo
      endif      

c     
c     ptll cut (min and max)
c

      do i=nincoming+1,nexternal-1
         do j=i+1,nexternal
            ptll_min(j,i)=0.0d0**2
            ptll_max(j,i)=-1
            if(((is_a_l(i).and.is_a_l(j)).and.
     &           (abs(idup(i,1,iproc)).eq.abs(idup(j,1,iproc))).and.
     &           (idup(i,1,iproc)*idup(j,1,iproc).lt.0)) ! Leptons from same flavor but different charge
     &           .or.(is_a_nu(i).and.is_a_l(j))
     &           .or.(is_a_l(i).and.is_a_nu(j)) !a lepton and a neutrino
     &           .or.(is_a_nu(i).and.is_a_nu(j))) then ! two neutrinos 
               ptll_min(j,i)=ptllmin*dabs(ptllmin)
               ptll_max(j,i)=ptllmax*dabs(ptllmax)
            endif
         enddo
      enddo

c
c   EXTRA JET CUTS
c
      ptjmin4(1)=ptj1min
      ptjmin4(2)=ptj2min
      ptjmin4(3)=ptj3min
      ptjmin4(4)=ptj4min

      ptjmax4(1)=ptj1max
      ptjmax4(2)=ptj2max
      ptjmax4(3)=ptj3max
      ptjmax4(4)=ptj4max

      Htjmin4(2)=ht2min
      htjmin4(3)=ht3min
      htjmin4(4)=ht4min

      htjmax4(2)=ht2max
      htjmax4(3)=ht3max
      htjmax4(4)=ht4max
   
      inclHtmin=ihtmin
      inclHtmax=ihtmax

      jetor = cutuse.eq.0

c
c   EXTRA LEPTON CUTS
c
      ptlmin4(1)=ptl1min
      ptlmin4(2)=ptl2min
      ptlmin4(3)=ptl3min
      ptlmin4(4)=ptl4min

      ptlmax4(1)=ptl1max
      ptlmax4(2)=ptl2max
      ptlmax4(3)=ptl3max
      ptlmax4(4)=ptl4max


c
c     Compute Smin (for efficiency purpose)
c
      smin = 0d0
c     check for the jet
      smin_m = 0d0
      smin_p = 0d0
      nb_j = 0
      nb_nocut = 0
      do i=nincoming+1,nexternal
          if (is_a_j(i)) then
              nb_j = nb_j + 1
              smin_m = smin_m - pmass(i)**2
              if (do_cuts(i))then
                 if (nb_j.eq.1) then
                  smin_p = smin_p + max(ej,ptj,xptj,0d0,
     &                                    max(ptj1min,ptj2min,ptj3min,ptj4min))
                 elseif(nb_j.eq.2) then
                  smin_p = max(ht2min, smin_p + max(ej,ptj,0d0,
     &                                            max(ptj2min,ptj3min,ptj4min)))
                 elseif(nb_j.eq.3) then
                  smin_p = max(ht3min, smin_p + max(ej,ptj,0d0,
     &                                                    max(ptj3min,ptj4min)))
                 elseif(nb_j.eq.4) then
                  smin_p = max(ht4min, smin_p + max(ej,ptj,ptj4min,0d0))
                 else
                  smin_p = smin_p + max(ej,ptj,0d0)
                 endif
              else
                 nb_nocut = nb_nocut + 1
                 if (nb_j.eq.1) then
                  smin_p = smin_p + max(0d0,ptj1min,ptj2min,ptj3min,ptj4min)
                 elseif(nb_j.eq.2) then
                  smin_p = max(ht2min, smin_p + max(ptj2min,ptj3min,ptj4min,0d0))
                 elseif(nb_j.eq.3) then
                  smin_p = max(ht3min, smin_p + max(0d0,ptj3min,ptj4min))
                 elseif(nb_j.eq.4) then
                  smin_p = max(ht4min, smin_p + max(ptj4min,0d0))
                 endif
              endif
          endif
        enddo
      if (nb_j.gt.0)then
         if ((nb_j-nb_nocut).gt.0)then
            smin_m = smin_m + (nb_j-nb_nocut)*(nb_j-nb_nocut-1)/2d0*mmjj**2
         endif
        smin = smin + max(smin_p**2, smin_m, htjmin**2)
      endif
c     check for the bjet
      smin_m = 0d0
      smin_p = 0d0
      nb_b = 0
      nb_nocut = 0
      do i=nincoming+1,nexternal
          if (is_a_b(i).and.do_cuts(i)) then
              nb_b = nb_b + 1
              smin_m = smin_m - pmass(i)**2
              if (do_cuts(i)) then
                 if (nb_b.eq.1) then
                    smin_p = smin_p + max(eb,ptb,xptb,0d0)
                 else
                    smin_p = smin_p + max(eb,ptb,0d0)
                 endif
              else
                 nb_nocut = nb_nocut +1
                 if (nb_b.eq.1) then
                    smin_p = smin_p + max(xptb,0d0)
                 endif
              endif
          endif
      enddo
      if (nb_b.gt.0)then
         if ((nb_b-nb_nocut).gt.0) then
            smin_m = smin_m + (nb_b-nb_nocut)*(nb_b-nb_nocut-1)/2d0*mmbb**2
         endif
         smin = smin + max(smin_p**2, smin_m, (ihtmin**2-htjmin**2))
      endif
c     check for the photon
      smin_m = 0d0
      smin_p = 0d0
      nb_a = 0
      nb_nocut = 0
      do i=nincoming+1,nexternal
         if (is_a_a(i))then
            nb_a = nb_a + 1
            if (do_cuts(i))then
               if (ptgmin.eq.0d0) then
                  if (nb_a.eq.1) then
                     smin_p = smin_p + max(ea,pta,xpta,0d0)
                  else
                     smin_p = smin_p + max(ea,pta,0d0)
                  endif
               endif
            else
               nb_nocut = nb_nocut + 1
               if(ptgmin.eq.0d0)then
                  if (nb_a.eq.1) then
                     smin_p = smin_p + max(xpta,0d0)
                  endif
               endif
            endif
         endif
      enddo
      if (nb_a.gt.0) then
         if ((nb_a-nb_nocut).gt.0)then
            smin_m = (nb_a-nb_nocut)*(nb_a-nb_nocut-1)/2d0*mmaa**2
         endif
        smin = smin + max(smin_p**2, smin_m)
      endif
c     check for lepton
      smin_m = 0d0
      smin_p = 0d0
      nb_l = 0
      nb_nocut = 0
      do i=nincoming+1,nexternal-1
         if (is_a_l(i))then
            nb_l = nb_l + 1
            smin_m = smin_m - pmass(i)**2
            if (do_cuts(i))then 
               if (nb_l.eq.1) then
                  smin_p = smin_p + max(el,ptl,xptl,0d0,
     &                 max(ptl1min,ptl2min,ptl3min,ptl4min))
               elseif(nb_l.eq.2) then
                  smin_p = smin_p + max(el,ptl,0d0,max(ptl2min,ptl3min,ptl4min))
               elseif(nb_l.eq.3) then
                  smin_p = smin_p + max(el,ptl,0d0, max(ptl3min,ptl4min))
               elseif(nb_l.eq.4) then
                  smin_p = smin_p + max(el,ptl,ptl4min,0d0)
               else
                  smin_p = smin_p + max(el,ptl,0d0)
               endif
            else
               nb_nocut = nb_nocut + 1
               if (nb_l.eq.1) then
                  smin_p = smin_p + max(xptl,0d0,
     &                 max(ptl1min,ptl2min,ptl3min,ptl4min))
               elseif(nb_l.eq.2) then
                  smin_p = smin_p + max(0d0,ptl2min,ptl3min,ptl4min)
               elseif(nb_l.eq.3) then
                  smin_p = smin_p + max(0d0,ptl3min,ptl4min)
               elseif(nb_l.eq.4) then
                  smin_p = smin_p + max(ptl4min,0d0)
               endif
            endif
         endif
      enddo
      if (nb_l.gt.0)then
         if ((nb_l-nb_nocut).gt.0)then
            smin_m = smin_m + (nb_l-nb_nocut)*((nb_l-nb_nocut)-1)/2d0*mmll**2
         endif
        smin = smin + max(smin_p**2, smin_m, mmnl**2, ptllmin**2, misset**2)
      endif
c  check for other PDG particle
      do i = 1,pdg_cut(0)
         nb_pdg=0
         do j=nincoming, nexternal
            if (abs(idup(i,1,iproc)).eq.pdg_cut(i))then
               k = j ! use to get the mass
               if(do_cuts(i)) nb_pdg = nb_pdg + 1
            endif
         enddo
         if (nb_pdg.gt.0)then
            smin_p = nb_pdg *(pmass(k)**2 + ptmin4pdg(i)**2)
            smin_m = nb_pdg*((2-nb_pdg)*pmass(k)**2 + (nb_pdg-1)/2.*mxxmin4pdg(i)**2)
            smin = smin + max(smin_p, smin_m)
         endif
      enddo

c     ensure symmetry of s_min(i,j) + mass effect
      do i=nincoming+1,nexternal-1
        do j=nincoming+1,nexternal-1
           if(j.lt.i)then
               s_min(i,j) = max(s_min(j,i), s_min(i,j), (pmass(i)+pmass(j))**2)
            endif
        enddo
      enddo

c     ensure that smin is bigger than mass threshold
      smin_p = 0d0
      do i=nincoming+1, nexternal
         smin_p = smin_p + pmass(i)
      enddo
      smin = max(smin, smin_p**2)
      write(*,*) "Define smin to", smin

c Check that results are consistent among all the grouped subprocesses

      if (iproc.eq.1) then
         do i=nincoming+1,nexternal
            do_cuts_save(i)=do_cuts(i)
            is_a_j_save(i)=is_a_j(i)
            is_a_b_save(i)=is_a_b(i)
            is_a_l_save(i)=is_a_l(i)
            is_a_a_save(i)=is_a_a(i)
            is_a_nu_save(i)=is_a_nu(i)
            is_a_onium_save(i)=is_a_onium(i)
            is_heavy_save(i)=is_heavy(i) 
            etmin_save(i)=etmin(i)
            etmax_save(i)=etmax(i)
            emin_save(i)=emin(i)
            emax_save(i)=emax(i)
            etamin_save(i)=etamin(i)
            etamax_save(i)=etamax(i)
            if (i.eq.nexternal) cycle
            do j=i+1,nexternal
               r2min_save(j,i) = r2min(j,i)
               r2max_save(j,i) = r2max(j,i)
               s_min_save(j,i) = s_min(j,i)
               s_max_save(j,i) = s_max(j,i)
               ptll_min_save(j,i) = ptll_min(j,i)
               ptll_max_save(j,i) = ptll_max(j,i)
            enddo
         enddo
      else
         fail_reason = ''
         do i=nincoming+1,nexternal
            if (do_cuts_save(i).neqv.do_cuts(i)) fail_reason = 'do_cuts'
            if (is_a_j_save(i).neqv.is_a_j(i)) then
               if (ptjmin4(1).gt.0d0 .or. ptjmax4(1).ge.0d0) fail_reason = 'ptjmin4(1)' 
               if (ptjmin4(2).gt.0d0 .or. ptjmax4(2).ge.0d0) fail_reason = 'ptjmin4(2)' 
               if (ptjmin4(3).gt.0d0 .or. ptjmax4(3).ge.0d0) fail_reason = 'ptjmin4(3)' 
               if (ptjmin4(4).gt.0d0 .or. ptjmax4(4).ge.0d0) fail_reason = 'ptjmin4(4)' 
               if (Htjmin4(2).gt.0d0 .or. Htjmax4(2).ge.0d0) fail_reason = 'Htjmin4(2)' 
               if (Htjmin4(3).gt.0d0 .or. Htjmax4(3).ge.0d0) fail_reason = 'Htjmin4(3)' 
               if (Htjmin4(4).gt.0d0 .or. Htjmax4(4).ge.0d0) fail_reason = 'Htjmin4(4)' 
               if (inclHtmin.gt.0d0 .or. inclHtmax.ge.0d0) fail_reason = 'inclHT' 
               if (htjmin.gt.0d0 .or. htjmax.ge.0d0) fail_reason = 'htj' 
               if (xptj.gt.0d0) fail_reason = 'xptj' 
               if (xetamin.gt.0d0 .or. deltaeta.gt.0d0) 
     &              fail_reason = 'xetamin' 
               if (ptgmin.ne.0d0) fail_reason = 'ptgmin' 
               if (kt_durham.gt.0d0) fail_reason = 'ktdurham' 
            endif
            if (is_a_b_save(i).neqv.is_a_b(i)) then
               if (inclHtmin.gt.0d0 .or. inclHtmax.ge.0d0) fail_reason = 'Htmin'
               if (xptb.gt.0d0) fail_reason = 'xptb' 
            endif
            if (is_a_a_save(i).neqv.is_a_a(i)) then
               if (xpta.gt.0d0) fail_reason = 'xpta' 
               if (ptgmin.ne.0d0) fail_reason = 'ptgmin'
            endif
            if (is_a_l_save(i).neqv.is_a_l(i)) then
               if (ptlmin4(1).gt.0d0 .or. ptlmax4(1).ge.0d0) fail_reason = 'ptlmin4(1)' 
               if (ptlmin4(2).gt.0d0 .or. ptlmax4(2).ge.0d0) fail_reason = 'ptlmin4(2)' 
               if (ptlmin4(3).gt.0d0 .or. ptlmax4(3).ge.0d0) fail_reason = 'ptlmin4(3)' 
               if (ptlmin4(4).gt.0d0 .or. ptlmax4(4).ge.0d0) fail_reason = 'ptlmin4(4)' 
               if (mmnl.gt.0d0 .or. mmnlmax.ge.0d0) fail_reason = 'mmnl' 
               if (xptl.gt.0d0) fail_reason = 'xptl' 
               if (ptgmin.ne.0d0 .and. isoEM) fail_reason = 'ptgmin+iso' 
            endif
            if (is_a_nu_save(i).neqv.is_a_nu(i)) then
               if (misset.gt.0d0 .or. missetmax.ge.0d0) 
     &              fail_reason = 'misset' 
               if (mmnl.gt.0d0 .or. mmnlmax.ge.0d0) fail_reason = 'mmnl' 
            endif
            if (is_heavy_save(i).neqv.is_heavy(i)) then
               if (ptheavy.gt.0d0) fail_reason = 'ptheavy' 
            endif
            if (etmin_save(i).ne.etmin(i)) fail_reason = 'etmin' 
            if (etmax_save(i).ne.etmax(i)) fail_reason = 'etmax' 
            if (emin_save(i).ne.emin(i)) fail_reason = 'emin' 
            if (emax_save(i).ne.emax(i)) fail_reason = 'emax' 
            if (etamin_save(i).ne.etamin(i)) fail_reason = 'etamin' 
            if (etamax_save(i).ne.etamax(i)) fail_reason = 'etamax' 
            if (i.eq.nexternal) cycle
            do j=i+1,nexternal
               if (r2min_save(j,i).ne.r2min(j,i)) fail_reason = 'r2min'
               if (r2max_save(j,i).ne.r2max(j,i)) fail_reason = 'r2max'
               if (s_min_save(j,i).ne.s_min(j,i)) fail_reason = 's_min'
               if (s_max_save(j,i).ne.s_max(j,i)) fail_reason = 's_max'
               if (ptll_min_save(j,i).ne.ptll_min(j,i)) fail_reason = 'ptll_min' 
               if (ptll_max_save(j,i).ne.ptll_max(j,i)) fail_reason = 'ptll_max' 
            enddo
         enddo
         if (fail_reason.ne.'') then
            write (*,*) 'Grouping of subprocesses not'/
     $           /' consistent with setcuts.f. Either change'/
     $           /' your cuts and/or turn grouping of subprocesses off:',
     $           fail_reason
            open(unit=26,file='../../../error',status='unknown')
            write(26,*) 'Error: grouping of subprocesses not'/
     $           /' consistent with setcuts.f. Either change'/
     $           /' your cuts and/or turn grouping of subprocesses off.'
            stop 1
         endif
      endif
      enddo




c
c    ERROR TRAPS 
c
        do i=nincoming+1,nexternal
           if(is_a_j(i).and.etmin(i).eq.0.and.emin(i).eq.0) then
              write (*,*) "Warning: pt or E min of a jet should in general be >0"
           endif
           if(is_a_a(i).and.etmin(i).eq.0.and.emin(i).eq.0) then
              write (*,*) "Warning: pt or E min of a gamma should in general be >0"
           endif
        enddo

c    count number of jets to see if special cuts are applicable or not

        ncheck=0
        do i=nincoming+1,nexternal
           if(is_a_j(i)) ncheck=ncheck+1
        enddo

        if(ncheck.eq.0.and. xptj .gt. 0d0) then
           write (*,*) "Warning: cuts on the jet will be ignored"
           xptj = 0d0
        endif

        if(ncheck.lt.2.and. xetamin .gt. 0 .and. deltaeta .gt.0) then
           write (*,*) "Warning: WBF cuts not will be ignored"
           xetamin = 0d0
           deltaeta =0d0
        endif

c    count number of photons to see if special cuts are applicable or not

        ncheck=0
        do i=nincoming+1,nexternal
           if(is_a_a(i)) ncheck=ncheck+1
        enddo

        if(ncheck.eq.0.and. xpta .gt. 0d0) then
           write (*,*) "Warning: cuts on the photon will be ignored"
           xpta =0d0
        endif

c    count number of b-quarks to see if special cuts are applicable or not

        Ncheck=0
        do i=nincoming+1,nexternal
           if(is_a_b(i)) ncheck=ncheck+1
        enddo

        if(ncheck.eq.0.and. xptb .gt. 0d0) then
           write (*,*) "Warning: cuts on the b-quarks will be ignored"
           xptb = 0d0
        endif

c    count number of leptons to see if special cuts are applicable or not

        ncheck=0
        do i=nincoming+1,nexternal
           if(is_a_l(i)) ncheck=ncheck+1
        enddo

        if(ncheck.eq.0.and. xptl .gt. 0d0) then
           write (*,*) "Warning: cuts on the lepton will be ignored"
           xptl = 0d0
        endif

c     set possible xqcut combinations (for better grid preparation)
        if(xqcut.gt.0)
     $       call setxqcuts(do_cuts)

c      call write_cuts()
      RETURN

      END


      subroutine setxqcuts(do_cuts)
c**************************************************
c     Set xqcuti and xqcutij between all particles
c     to allow for grid preparation based on xqcut
c**************************************************
      implicit none
      include 'genps.inc'
      include 'maxconfigs.inc'
      include 'nexternal.inc'
      include 'cuts.inc'

      logical  do_cuts(nexternal)

      double precision pmass(nexternal)
      common/to_mass/  pmass
      integer iforest(2,-max_branch:-1,lmaxconfigs)
      common/to_forest/ iforest
      integer mapconfig(0:lmaxconfigs), this_config
      common/to_mconfigs/mapconfig, this_config

      double precision xqcutij(nexternal,nexternal),xqcuti(nexternal)
      common/to_xqcuts/xqcutij,xqcuti

      
      integer i,j,k
      logical foundpartner
      include 'maxamps.inc'
      integer idup(nexternal,maxproc,maxsproc)
      integer mothup(2,nexternal)
      integer icolup(2,nexternal,maxflow,maxsproc)
      include 'leshouche.inc'

      do i=3,nexternal
         xqcuti(i)=0d0
         do j=3,nexternal
            xqcutij(i,j)=0d0
         enddo
      enddo

      do i=3,nexternal
         do j=1,mapconfig(0)
            foundpartner=.false.
            do k=-1,-(nexternal-3),-1
               if(iforest(1,k,j).eq.i.and.iforest(2,k,j).gt.2.or.
     $              iforest(2,k,j).eq.i.and.iforest(1,k,j).gt.2)then
                  foundpartner=.true.
                  if(iabs(idup(iforest(2,k,j),1,1)).le.maxjetflavor.or.
     $                 idup(iforest(2,k,j),1,1).eq.21.or.
     $                 iabs(idup(iforest(2,k,j),1,1)).le.maxjetflavor.or.
     $                 idup(iforest(2,k,j),1,1).eq.21)then
                     if (do_cuts(iforest(2,k,j)).and. do_cuts(iforest(1,k,j)))then
                        xqcutij(iforest(2,k,j),iforest(1,k,j))=xqcut
                        xqcutij(iforest(1,k,j),iforest(2,k,j))=xqcut
                     endif
                  endif
               endif
            enddo
            if(.not.foundpartner.and.(iabs(idup(i,1,1)).le.maxjetflavor.or.
     $           idup(i,1,1).eq.21).and.do_cuts(i)) xqcuti(i)=max(0d0,sqrt(xqcut**2-pmass(i)**2))
         enddo
      enddo

      end


c************************************************************************
c     Subroutine to check which external particles are from decays
c************************************************************************
      subroutine check_decay(from_decay)
      implicit none

      include 'nexternal.inc'
      include 'maxconfigs.inc'
      include 'genps.inc'
      include 'maxamps.inc'
c
c    Arguments
c
      logical from_decay(-(nexternal+3):nexternal)
c
c     Global
c
      integer iforest(2,-max_branch:-1,lmaxconfigs)
      common/to_forest/ iforest
      integer sprop(maxsproc,-max_branch:-1,lmaxconfigs)
      integer tprid(-max_branch:-1,lmaxconfigs)
      common/to_sprop/sprop,tprid
      integer gForceBW(-max_branch:-1,lmaxconfigs)  ! Forced BW
      include 'decayBW.inc'

c
c     Local
c
      integer i,j

      do i=-(nexternal-3),nexternal
         from_decay(i)=.false.
      enddo

c     Set who comes from decay based on forced BW
      do i=-(nexternal-3),-1
         if(tprid(i,1).eq.0.and.gForceBW(i,1).eq.1.or.
     $        from_decay(i)) then
            from_decay(i)=.true.
            from_decay(iforest(1,i,1))=.true.
            from_decay(iforest(2,i,1))=.true.
         endif
      enddo

      end

***
*
* NNPDF Fortran Driver
*
* Stefano Carrazza for the NNPDF Collaboration
* email: stefano.carrazza@mi.infn.it
*
* February 2013
*
* Usage:
*
*  NNPDFDriver("gridname.LHgrid");
*
*  NNinitPDF(0); // select replica [0,Mem]
*
*  NNevolvePDF(x,Q,pdf); // -> returns double array (-6,7)
*     
      subroutine NNPDFDriver(gridfilename)
      implicit none
      
      integer nfl,nx,nq2,mem,rep
      double precision alphas
      double precision xgrid(100),logxgrid(100)
      double precision q2grid(60),logq2grid(60)
      double precision pdfgrid(0:100,14,100,60)
      logical hasphoton
      common /nnpdf/nfl,nx,nq2,mem,rep,hasphoton,alphas,xgrid,logxgrid,
     1     q2grid,logq2grid,pdfgrid

      character*(*) gridfilename
*
      nfl = 13
      nx = 100
      nq2 = 60
      mem = 1
      rep = 0
      alphas = 0
*
*     Logo
      write(6,*) " ****************************************"
      write(6,*) ""
      write(6,*) "      NNPDFDriver version 1.0.3"
      write(6,*) "  Grid: ", gridfilename
      write(6,*) " ****************************************"

      call readPDFSet(gridfilename)
      
      end subroutine

      subroutine NNinitPDF(irep)
      implicit none
      integer irep

      integer nfl,nx,nq2,mem,rep
      double precision alphas
      double precision xgrid(100),logxgrid(100)
      double precision q2grid(60),logq2grid(60)
      double precision pdfgrid(0:100,14,100,60)
      logical hasphoton
      common /nnpdf/nfl,nx,nq2,mem,rep,hasphoton,alphas,xgrid,logxgrid,
     1     q2grid,logq2grid,pdfgrid

      if (irep.gt.mem.or.irep.lt.0d0) then
         write(6,*) "Error: replica out of range [0,",mem,"]"
      else
         rep = irep
      endif
      
      end subroutine

      subroutine readPDFSet(gridfilename)
      implicit none
      
      integer i,ix,iq,fl,imem
      character*(*) gridfilename
      character*100 line
*
      integer nfl,nx,nq2,mem,rep
      double precision alphas
      double precision xgrid(100),logxgrid(100)
      double precision q2grid(60),logq2grid(60)
      double precision pdfgrid(0:100,14,100,60)
      logical hasphoton
      common /nnpdf/nfl,nx,nq2,mem,rep,hasphoton,alphas,xgrid,logxgrid,
     1     q2grid,logq2grid,pdfgrid
      integer IU
      common/IU/IU

*

      call OpenData(gridfilename)

*     Read header
      do i=1,1000
         read(IU,*) line
         if (line(1:14).eq.'Parameterlist:') then
            read(IU,*) line, mem, line, alphas                        
            exit
         endif
      enddo

*     Select driver
      do i=1,1000
         read(IU,*) line
         if (line(1:13).eq.'NNPDF20intqed') then
            hasphoton = .true.
            nfl = nfl + 1   
            read(IU,*) line,line            
            exit
         endif
         if (line(1:13).eq.'NNPDF20int') then
            hasphoton = .false.            
            read(IU,*) line,line            
            exit
         endif
      enddo
*
      read(IU,*) nx
      do ix=1,nx
         read(IU,*) xgrid(ix)
         logxgrid(ix) = dlog(xgrid(ix))
      enddo
*
      read(IU,*) nq2
      read(IU,*) line
      do iq=1,nq2
         read(IU,*) q2grid(iq)
         logq2grid(iq) = dlog(q2grid(iq))
      enddo
*            
      read(IU,*) line      
      do imem=0,mem
         do ix=1,nx
            do iq=1,nq2               
               read(IU,*) ( pdfgrid(imem,fl,ix,iq), fl=1,nfl,1)            
            enddo
         enddo
      enddo

      close(IU)
      
      end subroutine

      subroutine NNevolvePDF(x,Q,xpdf)
      implicit none
      
      integer i,j,ix,iq2,M,N,ipdf,fmax
      integer minx,maxx,midx
      integer minq,maxq,midq
      double precision x,Q,xpdf(-6:7),Q2
      double precision xmingrid,xch,x2,x1,dy,y
      parameter (M=4, N=2)
      parameter (xmingrid=1d-7, xch=1d-1) 

      integer nmax,mmax 
      parameter(nmax=1e3,mmax=1e3)            
      integer ix1a(mmax), ix2a(nmax)
      double precision x1a(mmax), x2a(nmax)
      double precision ya(mmax,nmax)

      integer nfl,nx,nq2,mem,rep
      double precision alphas
      double precision xgrid(100),logxgrid(100)
      double precision q2grid(60),logq2grid(60)
      double precision pdfgrid(0:100,14,100,60)
      logical hasphoton
      common /nnpdf/nfl,nx,nq2,mem,rep,hasphoton,alphas,xgrid,logxgrid,
     1     q2grid,logq2grid,pdfgrid
      

      Q2 = Q*Q
*     check bounds
      if (x.lt.xmingrid.or.x.lt.xgrid(1).or.x.gt.xgrid(nx)) then
c$$$         write(6,*) "Parton interpolation: x out of range -- freezed"
         if (x.lt.xgrid(1)) x = xgrid(1)
*         if (x.lt.xmingrid) x = xmingrid
         if (x.gt.xgrid(nx))x = xgrid(nx)
      endif
      if (Q2.lt.q2grid(1).or.Q2.gt.q2grid(nq2)) then
c$$$         write(6,*) "Parton interpolation: Q2 out of range -- freezed"
c$$$         write(6,*) "Q2 = ",Q2, " GeV2", q2grid(1)
         if (Q2.lt.q2grid(1)) Q2 = q2grid(1)
         if (Q2.gt.q2grid(nq2)) Q2 = q2grid(nq2)
      endif

      minx = 1
      maxx = NX+1
 10   continue
      midx = (minx+maxx)/2
      if (x.lt.xgrid(midx)) then
         maxx=midx
      else
         minx=midx
      endif
      if ((maxx-minx).gt.1) go to 10
      ix = minx

      minq = 1
      maxq = nq2+1
 20   continue
      midq = (minq+maxq)/2
      if (Q2.lt.q2grid(midq)) then
         maxq=midq
      else
         minq=midq
      endif 
      if ((maxq-minq).gt.1) go to 20
      iq2 = minq

*     Assign grid for interpolation. M, N -> order of polyN interpolation      
      do I=1,M
         if(IX.ge.M/2.and.IX.le.(NX-M/2)) IX1A(I) = IX - M/2 + I
         if(IX.lt.M/2) IX1A(I) = I
         if(IX.gt.(NX-M/2)) IX1A(I) = (NX - M) + I
         
*     Check grids
         if(IX1A(I).le.0.or.IX1A(I).gt.NX) then
            write(6,*) "Error in grids! "
            write(6,*) "I, IXIA(I) = ",I, IX1A(I)
            call exit(-10)
         endif
      enddo

      do J=1,N
         if(IQ2.ge.N/2.and.IQ2.le.(NQ2-N/2)) IX2A(J) = IQ2 - N/2 + J
         if(IQ2.lt.N/2) IX2A(J) = J
         if(IQ2.gt.(NQ2-N/2)) IX2A(J) = (NQ2 - N) + J
*     Check grids
         if(IX2A(J).le.0.or.IX2A(J).gt.NQ2) then
            write(6,*) "Error in grids! "
            write(6,*) "J, IXIA(J) = ",J,IX2A(J)
            call exit(-10)
         endif
      enddo
            
*     Define points where to evaluate interpolation
*     Choose between linear or logarithmic (x,Q2) interpolation

      IF(X.LT.XCH)THEN
         X1=dlog(X)          
      ELSE
         X1=X
      ENDIF
      X2=dlog(Q2)

*     initialize output vector
      do i=-6,7 
         xpdf(i) = 0
      enddo
            
      fmax = 6
      if (nfl.eq.14) fmax=7

      DO IPDF = -6,fmax,1                 
*     Choose between linear or logarithmic (x,Q2) interpolation        
         DO I=1,M
            IF(X.LT.XCH)THEN
               X1A(I)= logxgrid(IX1A(I))
            ELSE
               X1A(I)= xgrid(IX1A(I))
            ENDIF
            DO J=1,N
               X2A(J) = logq2grid(IX2A(J))
               YA(I,J) = pdfgrid(REP,IPDF+7,IX1A(I),IX2A(J))               
            enddo
         enddo
         
!     2D polynomial interpolation
         call lh_polin2(x1a,x2a,ya,m,n,x1,x2,y,dy)
         XPDF(IPDF) = y
      enddo                 

      end subroutine

      subroutine lh_polin2(x1a,x2a,ya,m,n,x1,x2,y,dy) 
      implicit none 
!                                                                       
      integer m,n,nmax,mmax 
      integer j,k 
      parameter(nmax=1e3,mmax=1e3) 
                                                                        
      real*8 dy,x1,x2,y,x1a(mmax),x2a(nmax),ya(mmax,nmax) 
      real*8 ymtmp(nmax),yntmp(nmax) 
                                                                        
      do j=1,m 
         do k=1,n 
            yntmp(k)=ya(j,k) 
         enddo 
         call lh_polint(x2a,yntmp,n,x2,ymtmp(j),dy) 
      enddo 
      call lh_polint(x1a,ymtmp,m,x1,y,dy) 
!                                                                       
      return 
      END                                           

      subroutine lh_polint(xa,ya,n,x,y,dy) 
      implicit none 
!                                                                       
      integer n,NMAX 
!     Largest anticipated value of n                                    
      parameter(nmax=1e3) 
      real*8 dy,x,y,xa(nmax),ya(nmax) 
      integer i,m,ns 
      real*8 den,dif,dift,ho,hp,w,c(nmax),d(nmax) 
      ns=1 
      dif=abs(x-xa(1)) 
      do 11 i=1,n 
         dift=abs(x-xa(i)) 
         if(dift.lt.dif) then 
            ns=i 
            dif=dift 
         endif 
         c(i)=ya(i) 
         d(i)=ya(i) 
   11 enddo 
      y=ya(ns) 
      ns=ns-1 
      do m=1,n-1 
         do i=1,n-m 
            ho=xa(i)-x 
            hp=xa(i+m)-x 
            w=c(i+1)-d(i) 
            den=ho-hp 
            if(den.eq.0) then 
               write(*,*)'failure in polint' 
               stop 
            endif 
            den=w/den 
            d(i)=hp*den 
            c(i)=ho*den 
         enddo 
         if(2*ns.lt.(n-m)) then 
            dy=c(ns+1) 
         else 
            dy=d(ns) 
            ns=ns-1 
         endif 
         y=y+dy 
      enddo 
                                                                        
      return 
      END

      subroutine sample_full(ndim,ncall,itmax,itmin,dsig,ninvar,nconfigs)
c**************************************************************************
c     Driver for sample which does complete integration
c     This is done in double precision, and should be told the
c     number of possible phasespace choices.
c     Arguments:
c     ndim       Number of dimensions for integral(number or random #'s/point)
c     ncall      Number of times to evaluate the function/iteration
c     itmax      Max number of iterations
c     itmin      Min number of iterations
c     ninvar     Number of invarients to keep grids on (s,t,u, s',t' etc)
c     nconfigs   Number of different pole configurations 
c     dsig       Function to be integrated
c**************************************************************************
      implicit none
      include 'genps.inc'
c
c Arguments
c
      integer ndim,ncall,itmax,itmin,ninvar,nconfigs
      external         dsig
      double precision dsig
c
c Local
c
      double precision x(maxinvar),wgt,p(4*maxdim/3+14)
      double precision tdem, chi2, dum
      integer ievent,kevent,nwrite,iter,nun,luntmp,itsum
      integer jmax,i,j,ipole
      integer itmax_adjust
c
c     External
c
      integer  n_unwgted
      external n_unwgted
c
c Global
c
      integer                                      nsteps
      character*40          result_file,where_file
      common /sample_status/result_file,where_file,nsteps
      double precision fx
      common /to_fx/   fx

      integer           mincfig, maxcfig
      common/to_configs/mincfig, maxcfig

      double precision     xmean(99),xsigma(99),xwmax(99),xeff(99), xrmean(99)
      common/to_iterations/xmean,    xsigma,    xwmax,    xeff,     xrmean

      double precision    accur
      common /to_accuracy/accur

      double precision twgt, maxwgt,swgt(maxevents)
      integer                             lun, nw, itminx
      common/to_unwgt/twgt, maxwgt, swgt, lun, nw, itminx

      integer nzoom
      double precision  tx(1:3,maxinvar)
      common/to_xpoints/tx, nzoom

      double precision xzoomfact
      common/to_zoom/  xzoomfact

      double precision tmean, trmean, tsigma
      integer             dim, events, itm, kn, cur_it, invar, configs
      common /sample_common/
     .     tmean, trmean, tsigma, dim, events, itm, kn, cur_it, invar, configs

      integer           use_cut
      common /to_weight/use_cut

      integer              icor
      common/to_correlated/icor

      integer                   neventswritten
      common /to_eventswritten/ neventswritten

      integer th_nunwgt
      double precision th_maxwgt
      common/theoretical_unwgt_max/th_maxwgt, th_nunwgt

c
c     External
c
      logical pass_point
      integer NEXTUNOPEN
c
c     Data
c
      data result_file,where_file,nsteps/'SAMPLE','WHERE.AMI',100/
      data accur/-1d0/
      data mincfig /1/
      data maxcfig /1/
      data twgt/-1d0/              !Dont write out events
      data lun/27/                 !Unit number for events
      data maxwgt/0d0/
      data nw/0/                   !Number of events written
      

c-----
c Begin Code
c-----
      ievent = 0
      kevent = 0
      nzoom = 0
      xzoomfact = 1d0
      itminx = itmin
      if (nsteps .lt. 1) nsteps=1
      nwrite = itmax*ncall/nsteps

C     Fix for 2>1 process where ndim is 2 and not 1
      ninvar = max(2,ninvar)

      call sample_init(ndim,ncall,itmax,ninvar,nconfigs)
      call graph_init
      do i=1,itmax
         xmean(i)=0d0
         xsigma(i)=0d0
      enddo
c      mincfig=1
c      maxcfig=nconfigs
      wgt = 0d0
c
c     Main Integration Loop
c
      iter = 1
      do while(iter .le. itmax)
c
c     Get integration point
c
         call sample_get_config(wgt,iter,ipole)
         if (iter .le. itmax) then
            ievent=ievent+1
            call x_to_f_arg(ndim,ipole,mincfig,maxcfig,ninvar,wgt,x,p)
            if (pass_point(p)) then
               fx = dsig(p,wgt,0) !Evaluate function
               wgt = wgt*fx
               if (wgt .ne. 0d0) call graph_point(p,wgt) !Update graphs
            else
               fx =0d0
               wgt=0d0
            endif
            call sample_put_point(wgt,x(1),iter,ipole) !Store result
         endif
         if (wgt .ne. 0d0) kevent=kevent+1    
c
c     Write out progress/histograms
c
         if (kevent .ge. nwrite) then
            nwrite = nwrite+ncall*itmax/nsteps
            nwrite = min(nwrite,ncall*itmax)
            call graph_store
         endif
 99   enddo
c
c     All done
c
      tmean = 0d0
      trmean = 0d0
      tsigma = 0d0
      tdem = 0d0
      open(unit=66,file='results.dat',status='unknown')
      i=1
      do while(xmean(i) .ne. 0 .and. i .lt. cur_it)
         i=i+1
      enddo
      cur_it = i
c     Use the last 3 iterations or cur_it-1 if cur_it-1 >= itmin but < 3
      itsum = min(max(itmin,cur_it-1),3)
      i = cur_it - itsum
      if (i .gt. 0) then
      tmean = 0d0
      trmean = 0d0
      tsigma = 0d0
      tdem = 0d0
      do while (xmean(i) .ne. 0 .and. i .lt. cur_it)
         tmean = tmean+xmean(i)*xmean(i)**2/xsigma(i)**2
         trmean = trmean+xrmean(i)*xmean(i)**2/xsigma(i)**2
         tdem = tdem+xmean(i)**2/xsigma(i)**2
         tsigma = tsigma + xmean(i)**2/ xsigma(i)**2
         i=i+1
      enddo
      tmean = tmean/tsigma
      trmean = trmean/tsigma
      tsigma= tmean/sqrt(tsigma)
c      nun = n_unwgted()

      nun = neventswritten

      chi2 = 0d0
      do i = cur_it-itsum,cur_it-1
         chi2 = chi2+(xmean(i)-tmean)**2/xsigma(i)**2
      enddo
      chi2 = chi2/2d0   !Since using only last 3, n-1=2
      write(*,'(a)') '-------------------------------------------------'
      write(*,'(a)') '---------------------------'
      write(*,'(a,i3,a,e12.4)') ' Results Last ',itsum,
     $     ' iters: Integral = ',trmean
      write(*,'(21x,a,e12.4)') 'Abs integral = ',tmean
      write(*,'(26x,a,e12.4)') 'Std dev = ',tsigma
      write(*,'(18x,a,f12.4)') 'Chi**2 per DoF. =',chi2
      write(*,'(a)') '-------------------------------------------------'
      write(*,'(a)') '---------------------------'

      if (nun .lt. 0) nun=-nun   !Case when wrote maximun number allowed
      if (chi2 .gt. 1) tsigma=tsigma*sqrt(chi2)
c     JA 02/2011 Added twgt to results.dat to allow event generation in
c     first iteration for gridpack runs
C     OM 02/2015 Added maxwgt (target of the secondary unweight) to allow splitted
C        generation of event.
      if (icor .eq. 0) then
         write(66,'(3e12.5,2i9,i5,i9,e10.3,e12.5,3e13.5,i9)')tmean,tsigma, 0.0,
     &     kevent, nw, cur_it-1, nun, nun/max(tmean,1d-99), twgt, trmean, 
     &     maxwgt, th_maxwgt, th_nunwgt
      else
         write(66,'(3e12.5,2i9,i5,i9,e10.3,e12.5,3e13.5,i9)')tmean,0.0,tsigma,
     &     kevent, nw, cur_it-1, nun, nun/max(tmean,1d-99), twgt, trmean, 
     &     maxwgt, th_maxwgt, th_nunwgt
      endif
c      do i=1,cur_it-1
      do i=cur_it-itsum,cur_it-1
         write(66,'(i4,5e15.5)') i,xmean(i),xsigma(i),xeff(i),xwmax(i),xrmean(i)
      enddo
c     Write out MadLoop statistics, if any
      call output_run_statistics(66)
      flush(66)
      close(66, status='KEEP')
      else
         open(unit=66,file='results.dat',status='unknown')
         write(66,'(3e12.5,2i9,i5,i9,5e10.3,i9)')0.,0.,0.,kevent,nw,
     &     1,0,0.,0.,0.,0.,0.,0
         write(66,'(i4,5e15.5)') 1,0.,0.,0.,0.,0.
c        Write out MadLoop statistics, if any
         call output_run_statistics(66)
         flush(66)
         close(66, status='KEEP')

      endif
c
c     Now let's check to see if we got all of the events we needed
c     if not, will give it another try with 5 iterations to set
c     the grid, and 4 more to try and get the appropriate number of 
c     unweighted events.
c
      write(*,*) "Status",accur, cur_it, itmax
      if (accur .ge. 0d0 .or. cur_it .gt. itmax+3) then
        return
      endif
c     Check for neventswritten and chi2 (JA 8/17/11 lumi*mean xsec)
      if (neventswritten .gt. -accur*tmean .and. chi2 .lt. 10d0) then
         write(*,*) "We found enough events",neventswritten, -accur*tmean
         return
      endif
      
c
c     Need to start from scratch. This is clunky but I'll just
c     remove the grid, so we are clean
c
      write(*,*) "Trying w/ fresh grid"
      open(unit=25,file='ftn25',status='unknown',err=102)
      write(25,*) ' '
 102  close(25)

c
c     First few iterations will allow the grid to adjust
c
c
c     Reset counters
c
      ievent = 0
      kevent = 0
      nzoom = 0
      xzoomfact = 1d0

      ncall = ncall*4 ! / 2**(itmax-2)
      write(*,*) "Starting w/ ncall = ", ncall
      itmax = 8
      call sample_init(ndim,ncall,itmax,ninvar,nconfigs)
      do i=1,itmax
         xmean(i)=0d0
         xsigma(i)=0d0
      enddo
      wgt = 0d0
      call clear_events
      call set_peaks
c
c     Main Integration Loop
c
      iter = 1
c      itmax = 8
      itmax_adjust = 5
      use_cut = 2  !Start adjusting grid
      do while(iter .le. itmax)
         if (iter .gt. itmax_adjust .and. use_cut .ne. 0) then
            use_cut=0           !Fix grid
            write(*,*) 'Fixing grid'
         endif
c
c     Get integration point
c
         call sample_get_config(wgt,iter,ipole)
         if (iter .le. itmax) then
            ievent=ievent+1
            call x_to_f_arg(ndim,ipole,mincfig,maxcfig,ninvar,wgt,x,p)
            if (pass_point(p)) then
               xzoomfact = 1d0
               fx = dsig(p,wgt,0) !Evaluate function
               if (xzoomfact .gt. 0d0) then
                  wgt = wgt*fx*xzoomfact
               else
                  wgt = -xzoomfact
               endif
               if (wgt .gt. 0d0) call graph_point(p,wgt) !Update graphs
            else
               fx =0d0
               wgt=0d0
            endif
            
            if (nzoom .le. 0) then
               call sample_put_point(wgt,x(1),iter,ipole) !Store result
            else
               nzoom = nzoom -1
               ievent=ievent-1
            endif
         endif
         if (wgt .gt. 0d0) kevent=kevent+1    
199   enddo
c
c     All done
c
      open(unit=66,file='results.dat',status='unknown')
      i=1
      do while(xmean(i) .ne. 0 .and. i .lt. cur_it)
         i=i+1
      enddo
      cur_it = i
c     Use the last 3 iterations or cur_it-1 if cur_it-1 >= itmin
      itsum = min(max(itmin,cur_it-1),3)
      i = cur_it - itsum
      if (i .gt. 0) then
      tmean = 0d0
      trmean = 0d0
      tsigma = 0d0
      tdem = 0d0
      do while (xmean(i) .ne. 0 .and. i .lt. cur_it)
         tmean = tmean+xmean(i)*xmean(i)**2/xsigma(i)**2
         trmean = trmean+xrmean(i)*xmean(i)**2/xsigma(i)**2
         tdem = tdem+xmean(i)**2/xsigma(i)**2
         tsigma = tsigma + xmean(i)**2/ xsigma(i)**2
         i=i+1
      enddo
      tmean = tmean/tsigma
      trmean = trmean/tsigma
      tsigma= tmean/sqrt(tsigma)
c      nun = n_unwgted()
c
c     tjs 8/7/2007
c
      nun = neventswritten

      chi2 = 0d0
      do i = cur_it-itsum,cur_it-1
         chi2 = chi2+(xmean(i)-tmean)**2/xsigma(i)**2
      enddo
      chi2 = chi2/2d0   !Since using only last 3, n-1=2
      write(*,'(a)') '-------------------------------------------------'
      write(*,'(a)') '---------------------------'
      write(*,'(a,i3,a,e12.4)') ' Results Last ',itsum,
     $     ' iters: Integral = ',trmean
      write(*,'(21x,a,e12.4)') 'Abs integral = ',tmean
      write(*,'(25x,a,e12.4)') 'Std dev = ',tsigma
      write(*,'(17x,a,f12.4)') 'Chi**2 per DoF. =',chi2
      write(*,'(a)') '-------------------------------------------------'
      write(*,'(a)') '---------------------------'

      if (nun .lt. 0) nun=-nun   !Case when wrote maximun number allowed
      if (chi2 .gt. 1) tsigma=tsigma*sqrt(chi2)
c     JA 02/2011 Added twgt to results.dat to allow event generation in
c     first iteration for gridpack runs +02/2015 maxwgt 
      if (icor .eq. 0) then
         write(66,'(3e12.5,2i9,i5,i9,e10.3,e12.5,3e13.5, i9)')tmean,tsigma,0.0,
     &     kevent, nw, cur_it-1, nun, nun/max(tmean,1d-99), twgt,trmean, 
     &    maxwgt, th_maxwgt, th_nunwgt
      else
         write(66,'(3e12.5,2i9,i5,i9,e10.3,e12.5,3e13.5,i9)')tmean,0.0,tsigma,
     &     kevent, nw, cur_it-1, nun, nun/max(tmean,1d-99), twgt,trmean,
     &    maxwgt, th_maxwgt, th_nunwgt
      endif
c      do i=1,cur_it-1
      do i=cur_it-itsum,cur_it-1
         write(66,'(i4,5e15.5)') i,xmean(i),xsigma(i),xeff(i),xwmax(i),xrmean(i)
      enddo
c     Write out MadLoop statistics, if any
      call output_run_statistics(66)      
      flush(66)
      close(66, status='KEEP')
      else
         open(unit=66,file='results.dat',status='unknown')
         write(66,'(3e12.5,2i9,i5,i9,5e10.3,i9)')0.,0.,0.,kevent,nw,
     &     1,0,0.,0.,0.,0.,0.,0
         write(66,'(i4,5e15.5)') 1,0.,0.,0.,0.,0.
c        Write out MadLoop statistics, if any
         call output_run_statistics(66)
         flush(66)
         close(66, status='KEEP')

      endif      

      end

      subroutine output_run_statistics(outUnit)
c***********************************************************************
c     Writes out the madloop runtime statistics to the unit in argument
c***********************************************************************
      use StringCast
      implicit none
c
c     Arguments
c
      integer outUnit
C
C     Local
C
      double precision t_after
c
c     Global
c
      INTEGER U_RETURN_CODES(0:9)
      INTEGER T_RETURN_CODES(0:9)
      INTEGER H_RETURN_CODES(0:9)
      DOUBLE PRECISION AVG_TIMING
      DOUBLE PRECISION MAX_PREC, MIN_PREC
      INTEGER N_EVALS
      DATA U_RETURN_CODES/10*0/
      DATA T_RETURN_CODES/10*0/
      DATA H_RETURN_CODES/10*0/
      DATA MAX_PREC /-1.0d0/
      DATA MIN_PREC /1.0d99/
      DATA AVG_TIMING/0.0d0/
      DATA N_EVALS/0/
      COMMON/MADLOOPSTATS/AVG_TIMING,MAX_PREC,MIN_PREC,N_EVALS,
     &       U_RETURN_CODES,T_RETURN_CODES,H_RETURN_CODES

      DOUBLE PRECISION CUMULATED_TIMING
      DATA CUMULATED_TIMING/0.0d0/
      COMMON/GENERAL_STATS/CUMULATED_TIMING

c-----
c  Begin Code
c-----
      call cpu_time(t_after)
      CUMULATED_TIMING = t_after - CUMULATED_TIMING

      if (N_EVALS.eq.0) then
         write(outUnit,*) '<lo_statistics> '
         write(outUnit,*) '<cumulated_time>'//trim(toStr_real(CUMULATED_TIMING))
     &        //'</cumulated_time>'
         write(outUnit,*) '</lo_statistics>'
        return
      endif
      
      write(outUnit,*) '<run_statistics> '
      write(outUnit,33) '<u_return_code>',U_RETURN_CODES,'</u_return_code>'
      write(outUnit,33) '<t_return_code>',T_RETURN_CODES,'</t_return_code>'
      write(outUnit,33) '<h_return_code>',H_RETURN_CODES,'</h_return_code>'
      write(outUnit,*) '<average_time>'//trim(toStr_real(AVG_TIMING))
     & //'</average_time>'
      write(outUnit,*) '<cumulated_time>'//trim(toStr_real(CUMULATED_TIMING))
     & //'</cumulated_time>'
      write(outUnit,*) '<max_prec>'//trim(toStr_real(MAX_PREC))//'</max_prec>'
      write(outUnit,*) '<min_prec>'//trim(toStr_real(MIN_PREC))//'</min_prec>'
      write(outUnit,*) '<n_evals>'//trim(toStr_int(N_EVALS))//'</n_evals>'   
      write(outUnit,*) '</run_statistics>'
      
33    FORMAT( a15,i12,',',i12',',i12',',i12',',i12',
     &        ',i12',',i12',',i12',',i12',',i12,a16)

      end subroutine

      subroutine sample_writehtm()
c***********************************************************************
c     Writes out results of run in html format
c***********************************************************************
      implicit none
c
c     Constants
c
      character*(*) htmfile
      parameter (htmfile='results.html')
      integer    lun
      parameter (lun=26)
c
c     Local
c
      character*4 cpref
      double precision scale
      integer i
c
c     Global
c
      double precision     xmean(99),xsigma(99),xwmax(99),xeff(99), xrmean(99)
      common/to_iterations/xmean,    xsigma,    xwmax,    xeff,     xrmean

c-----
c  Begin Code
c-----
      return
c
c     Here we determine the appropriate units. Assuming the results 
c     were written in picobarns
c
      if (xmean(1) .ge. 1e4) then         !Use nano barns
         scale=1d-3
         cpref='(nb)'
      elseif (xmean(1) .ge. 1e1) then     !Use pico barns
         scale=1d0
         cpref='(pb)'
      else                               !Use fempto
         scale=1d+3
         cpref='(fb)'
      endif
      open(unit=lun,file=htmfile,status='unknown',err=999)      
      write(lun,50) '<head><title>Results_head</title></head>'
      write(lun,50) '<body><h2>Results for Process</h2>'
      write(lun,50) '<table border>'
      write(lun,50) '<Caption> Caption Results'
      write(lun,49) '<tr><th>Iteration</th>'
      write(lun,48)'<th>Cross Sect',cpref,'</th><th>Error',cpref,'</th>' 
      write(lun,49) '<th>Events (K)</th><th>Eff</th>'
      write(lun,50) '<th>Wrote</th><th>Unwgt</th></tr>'

c      write(lun,60) '<tr><th>AVG</th><th>',xtot*scale
c     $     ,'</th><th>',errtot*scale,'</th><th align=right>',
c     $     ntot/1000,'</th><th align=right>',teff,'</th></tr>'
      i=1
      do while(xmean(i) .gt. 0d0)
         write(lun,'(a)') '<tr>'
         write(lun,45) '<td align=right>',i,'</tr>'
         write(lun,46) '<td align=right>',xmean(i)*scale,'</td>'
         write(lun,46) '<td align=right>',xsigma(i)*scale,'</td>'
         write(lun,46) '<td align=right>',xeff(i)*scale,'</td>'
         write(lun,'(a)') '</tr>'
         i=i+1
      enddo
      write(lun,50) '</table></body>'
 999  close(lun)
 45   format(a,i4,a)
 46   format(a,f12.3,a)
 48   format(a,a,a,a)
 49   format(a)
 50   format(a)
      end



      subroutine sample_init(p1, p2, p3, p4, p5)
c************************************************************************
c     Initialize grid and random number generators
c************************************************************************
      implicit none
c
c     Constants
c
      include 'genps.inc'
      include 'maxconfigs.inc'
      include 'run.inc'
c
c     Arguments
c
      integer p1, p2, p3, p4, p5

c
c     Local
c
      integer i, j
      integer get_maxsproc
      logical fopened
c
c     Global
c
      double precision force_max_wgt
      common/unwgt_secondary_max/force_max_wgt

      integer                                      nsteps
      character*40          result_file,where_file
      common /sample_status/result_file,where_file,nsteps

      double precision tmean, trmean, tsigma
      integer             dim, events, itm, kn, cur_it, invar, configs
      common /sample_common/
     .     tmean, trmean, tsigma, dim, events, itm, kn, cur_it, invar, configs

      double precision   grid(2, ng, 0:maxinvar)
      common /data_grid/ grid
      integer           Minvar(maxdim,lmaxconfigs)
      common /to_invar/ Minvar
      double precision   psect(maxconfigs),alpha(maxconfigs)
      common/to_mconfig2/psect          ,alpha
      logical first_time
      common/to_first/first_time
      integer           use_cut
      common /to_weight/use_cut
      integer           ituple
      common /to_random/ituple

      logical            flat_grid
      common/to_readgrid/flat_grid                !Tells if grid read from file

      double precision twgt, maxwgt,swgt(maxevents)
      integer                             lun, nw, itminx
      common/to_unwgt/twgt, maxwgt, swgt, lun, nw, itminx
      
      integer              icor
      common/to_correlated/icor

      logical               zooming
      common /to_zoomchoice/zooming

      logical read_grid_file
      data read_grid_file/.False./
      common/read_grid_file/read_grid_file

      data use_cut/2/            !Grid: 0=fixed , 1=standard, 2=non-zero
      data ituple/1/             !1=htuple, 2=sobel 
      data Minvar(1,1)/-1/       !No special variable mapping

c-----
c  Begin Code
c-----
      icor = 0
      If (use_cut .eq. 0) then
         icor = 1          !Assume correlated unless grid read
         print*,'Keeping grid fixed.'
      elseif(use_cut .eq. 1) then
         print*,'Using standard SAMPLE grid deformation.'
      elseif(use_cut .eq. 2) then
         print*,'Using non-zero grid deformation.'
      elseif(use_cut .eq. 3) then
         print*,'Using fluctuation for grid deformation.'
      elseif(use_cut .eq. 4) then
         print*,'Generating unweighted event shape.'
      elseif(use_cut .eq. 5) then
         print*,'Using constant plus linear grid deformation.'
      elseif(use_cut .eq. 6) then
         print*,'Using power law grid deformation.'
      else
         print*,'Using unknown grid deformation:',use_cut
      endif
c      open(unit=22,file=result_file,status='unknown')
c      write(22,*) 'Sample Status ',p2,p3,nsteps
c      close(22)
c      open(unit=22,file=where_file,status='unknown')
c      write(22,*) 'Sample Progress ',p2,p3,nsteps
c      close(22)

      dim      = p1
      events   = p2
      itm     = p3
      invar    = p4
      configs  = p5
      first_time = .true.

      if (dim .gt. maxdim) then
         write(*,*) 'Too many dimensions requested from Sample()'
         stop
      endif
c      if (dim .gt. invar) then
c         write(*,*) 'Too many dimensions dim > invar',dim,invar
c         stop
c      endif
      if (p4 .gt. maxinvar) then
         write(*,*) 'Too many invarients requested from Sample()',p4
         stop
      endif
      if (p5 .gt. maxconfigs) then
         write(*,*) 'Too many configs requested from Sample()',p5
         stop
      endif

      write(*,'(i3,a,i7,a,i3,a,i3,a,i3,a)') dim, ' dimensions', events,
     &     ' events',p4,' invarients',itm, ' iterations',
     &     p5,' config(s),  (0.99)'

      if (ituple .eq. 1) then
         print*,'Using h-tuple random number sequence.'
      elseif (ituple .eq. 2) then
         print*,'Using Sobel quasi-random number sequence.'
         write(*,*) 'Sorry cant use sobel'
         stop
c         call isobel(dim)
      else
         print*,'Unknown random number generator',ituple
      endif
c
c     See if need mapping between dimensions in different configurations
c     (ie using s,t,u type invarients)
c
      if (Minvar(1,1) .eq. -1) then
         print*,'No invarient mapping defined, using 1 to 1.'
         do i=1,configs
            do j=1,dim
               Minvar(j,i) = j+(i-1)*dim
            enddo
         enddo
      endif
c
c     Reset counters
c
      tmean = 0d0
      trmean = 0d0
      tsigma = 0d0
      nb_pass_cuts = 0
      kn = 0
      cur_it = 1
      do j=1,ng
         grid(2,j,0) = xgmin+(xgmax-xgmin)*j/dble(ng)
      enddo
c
c     Try to read grid from file
c
      flat_grid=.true.
      call open_file_local(25, 'ftn25', fopened)
      if (.not.fopened)then
         goto 102
      endif
!      open(unit=25,file='ftn25',status='unknown',err=102)
      read(25,*, err=1011, end=1012)
     .     ((grid(2,i,j),i=1,ng),j=1,invar)
      read(25,*) twgt, force_max_wgt
      call read_discrete_grids(25)
      write(*,*) 'Grid read from file'
      read_grid_file=.true.
      flat_grid=.false.
      close(25)
c
c     Determine weighting for each configuration
c      
      if (.not. flat_grid) icor = 0 !0 = not correlated 
      zooming = (.not. flat_grid .and. use_cut .eq. 0) !only zoom if grid already adjusted and not changing more
c
c   tjs 5/22/07 turn off zooming
c
      zooming = .false.
      if (configs .eq. 1) then
         do i=1,maxconfigs
            alpha(i) = 1
         enddo
      else
         write(*,*) 'Using uniform alpha',alpha(1)
c         tot=0d0
c         do i=1,configs
c            tot=tot+alpha(i)
c         enddo
         do i=1,maxconfigs
            if(i .le. configs) then
               alpha(i)=1d0/dble(configs)
            else
               alpha(i)=0d0
            endif
         enddo
      endif
      goto 103
 1011  write(*,*) 'fail to open file'
       goto 101
 1012  write(*,*) 'fail to read data'
       goto 101
 101  close(25)
c      write(*,*) 'Tried reading it',i,j
 102  write(*,*) 'Error opening grid'

c
c     Unable to read grid, using uniform grid and equal points in
c     each configuration
c
      read_grid_file=.false.
      write(*,*) 'Using Uniform Grid!', maxinvar
      force_max_wgt = -1d0
      do j = 1, maxinvar
         do i = 1, ng
            grid(2, i, j) = xgmin+ (xgmax-xgmin)*(i / dble(ng))**1
         end do
      end do
      do j=1,maxconfigs
         if (j .le. configs) then
            alpha(j)=1d0/dble(configs)
         else
            alpha(j)=0d0
         endif
      enddo
      write(*,*) 'Using uniform alpha',alpha(1)
c      write(*,*) 'Forwarding random number generator'

 103  write(*,*) 'Grid defined OK'

C     sanity check that we have a minimal number of event      
      if ( MC_GROUPED_SUBPROC )then
         events = max(events, maxtries)
      else 
         events = max(events, 2*maxtries*get_maxsproc())
      endif

      end

      subroutine setgrid(j,xo,a,itype)
c*************************************************************************
c     Presets the grid for a 1/(x-a)^itype distribution down to xo
c*************************************************************************
      implicit none
c
c     Constants
c
      include 'genps.inc'
c
c     Arguments
c
      integer j, itype                !grid number
      double precision  xo            !minimum value
      double precision  a             !offset for peak
c
c     Local
c
      integer i,k
      integer ngu, ngd
c
c     Global
c
      double precision   grid(2, ng, 0:maxinvar)
      common /data_grid/ grid

      logical            flat_grid
      common/to_readgrid/flat_grid                !Tells if grid read from file

c----- 
c  Begin Code
c-----
      if (flat_grid) then
         if (itype.gt.1) then
            write(*,'(a,i4,2e15.5,i4)') 'Setting grid',j,xo,a,itype
            if (a .ge. xo) then
               write(*,*) 'Can not integrate over singularity'
               write(*,*) 'Set grid',j,xo,a
               return
            endif
         else
            write(*,'(a,i4,1e15.5,i4)') 'Setting grid',j,xo,itype            
         endif
c     grid(2,1,j) = xo
         grid(2,ng,j)=xgmax
         if (itype .eq. 1) then
c
c     We'll use most for the peak, but save some for going down
c
            ngu = ng *0.9
            ngd = ng-ngu

            do i=1,ngu-1
c-------------------
c     tjs 6/30/2009; tjs & ja 2/25/2011
c     New form for setgrid
c-------------------
c               grid(2,i+ngd,j)=((1d0-a)/(xo-a))**(1d0-dble(i)/dble(ngu))
c               grid(2,i+ngd,j)=1d0/grid(2,i+ngd,j)+a
c               grid(2,i+ngd,j) = xo + ((dble(i)+xo-a)/(dble(ngu)+xo-a))**2
               grid(2,i+ngd,j) = xo**(1-dble(i)/dble(ngu))

            enddo
c
c     Now lets go down the other side
c
            grid(2,ngd,j) =  xo
            do i=1,ngd-1
c               grid(2,i,j) = ((1d0-a)/(xo-a))**(1d0-dble(i)/dble(ngd))
               grid(2,ngd-i,j) = xo-(grid(2,ngd+i,j)-xo)
               if (grid(2,ngd-i,j) .lt. -1d0) then
                  write(*,*) 'Error grid set too low',grid(2,ngd-i,j)
                  do k=1,ng
                     write(*,*) k,grid(2,k,j)
                  enddo
                  stop
               endif
            enddo
c
c     tjs, ja 2/25/11
c     Make sure sample all the way down to zero only if minimum positive
c     
            if (grid(2,1,j) .gt. 0) grid(2,1,j) = 0d0
c            write(*,*) "Adjusted bin 1 to zero"

         elseif (itype .eq. 2) then
            do i=2,ng-1
               grid(2,i,j)=(1d0/(xo-a))*(1d0-dble(i)/dble(ng))+
     $              (dble(i)/dble(ng))*(1d0/(1d0-a))
               grid(2,i,j)=1d0/grid(2,i,j)+a
            enddo         
         else
            write(*,*) 'No modification in setgrid',itype
         endif
         do i=1,ng
c             write(*,*) j,i,grid(2,i,j)
         enddo
         call sample_write_g(j,'_0')
      else
         write(*,*) 'No modification is setgrid, grid read from file'
      endif
      end

      subroutine sample_get_config(wgt, iteration, iconfig)
c************************************************************************
c     
c     INPUTS:
c
c     OUTPUTS:   wgt       == 1/nevents*niterations
c                iteration == Current iteration
c                iconfig   == configuration to use
c
c************************************************************************
      implicit none
c
c     Constants
c
      include 'genps.inc'
c
c     Arguments
c
      double precision wgt
      integer iteration, iconfig
c
c     Local
c
      integer idum
      real xrnd
      double precision tot
c
c     External
c
      real ran1
c
c     Global
c
      double precision tmean, trmean, tsigma
      integer             dim, events, itm, kn, cur_it, invar, configs
      common /sample_common/
     .     tmean, trmean, tsigma, dim, events, itm, kn, cur_it, invar, configs
      double precision   psect(maxconfigs),alpha(maxconfigs)
      common/to_mconfig2/psect            ,alpha
      data idum/0/

      integer           mincfig, maxcfig
      common/to_configs/mincfig, maxcfig

c-----
c  Begin Code
c-----
      iteration = cur_it
      if (cur_it .gt. itm) then
         wgt = -1d0
      else
         wgt = 1d0 / (dble(events) * dble(itm))
c
c     Choose configuration
c
         if (configs .gt. 1) then
            xrnd = ran1(idum)
            iconfig=1
            tot = alpha(iconfig)
            do while (tot .lt. xrnd .and. iconfig .lt. configs)
               iconfig=iconfig+1
               tot = tot+alpha(iconfig)
            enddo
         else
            iconfig=mincfig
         endif
      endif
      end

      subroutine write_discrete_grids(stream_id, grid_type)
c************************************************************************
c     Write out the grid using the DiscreteSampler module
c************************************************************************
      use DiscreteSampler          
      implicit none
      integer, intent(in)                           :: stream_id
      character(len=*)                              :: grid_type
      logical MC_grouped_subproc
      common/to_MC_grouped_subproc/MC_grouped_subproc
      INTEGER                    ISUM_HEL
      LOGICAL                    MULTI_CHANNEL
      COMMON/TO_MATRIX/ISUM_HEL, MULTI_CHANNEL
c
c     Begin code
c

      if (ISUM_HEL.ne.0.and.DS_get_dim_status('Helicity').ge.1) then
        call DS_write_grid(stream_id, dim_name='Helicity', 
     &                                              grid_type=grid_type)
      elseif(ISUM_HEL.eq.0)then
        call write_good_hel(stream_id)  
      endif
      


      if(MC_grouped_subproc.and.
     &             DS_get_dim_status('grouped_processes').ge.1) then
        call DS_write_grid(stream_id, dim_name='grouped_processes', 
     &                                              grid_type=grid_type)
      endif

      end subroutine write_discrete_grids

      subroutine write_grid(name)
c************************************************************************
c     Write out the grid
c************************************************************************
      implicit none

      character*(*) name

      include 'genps.inc'

      double precision tmean, trmean, tsigma
      integer             dim, events, itm, kn, cur_it, invar, configs
      common /sample_common/
     .     tmean, trmean, tsigma, dim, events, itm, kn, cur_it, invar, configs

      double precision twgt, maxwgt,swgt(maxevents)
      integer                             lun, nw, itmin
      common/to_unwgt/twgt, maxwgt, swgt, lun, nw, itmin

      double precision    grid(2, ng, 0:maxinvar)
      common /data_grid/ grid

      double precision force_max_wgt
      common/unwgt_secondary_max/force_max_wgt

      integer i,j

      open(26, file=name, status='unknown')
      write(26,fmt='(4f21.17)') ((grid(2,i,j),i=1,ng),j=1,invar)
      write(26,*) twgt, force_max_wgt
c                  write(26,fmt='(4f21.16)') (alpha(i),i=1,maxconfigs)
      call write_discrete_grids(26,'ref')
      close(26)
      return
      end


      subroutine read_discrete_grids(stream_id)
c************************************************************************
c     Write out the grid using the DiscreteSampler module
c************************************************************************
      use DiscreteSampler          
      implicit none
      integer, intent(in)                           :: stream_id
      INTEGER                    ISUM_HEL
      LOGICAL                    MULTI_CHANNEL
      COMMON/TO_MATRIX/ISUM_HEL, MULTI_CHANNEL
      
      if (ISUM_HEL.eq.0)then
         call read_good_hel(stream_id)
      endif
      call DS_load_grid(stream_id)

      end subroutine read_discrete_grids

      subroutine sample_get_discrete_x(wgt,picked_bin,iconfig,dim_name)
c************************************************************************
c     Returns maxdim random numbers between 0 and 1, and the wgt
c     associated with this set of points, and the iteration number
c     This routine chooses the point within the range specified by
c     xmin and xmax for dimension j in configuration ipole
c************************************************************************
      use DiscreteSampler

      implicit none
      include 'genps.inc'
C     Subroutine arguments
      integer picked_bin
      character(len=*) dim_name
      real*8 wgt
C     This variable iconfig is what corresponds to ipole in sample_get_x
C     and is used for random number generation
      integer iconfig
C     Local variables
      real*8 jacobian
      real*8 rdm
      integer dummy
c     
c      Begin code
c
C     Fetch a random number bewteen 0.0 and 1.0
c     The fourth argument is not used and therefore a dummy
      dummy = 0
      call ntuple(rdm,0.0d0,1.0d0,dummy,iconfig)
C     Pick a point using the DiscreteSampler module
      CALL DS_get_point(dim_name, rdm, picked_bin, jacobian, 'norm') 
C     Store the helicity sampling jacobian so that it can be divided out
c     of wgt later when adding an entry to the DiscreteSampler helicity
c      grid. Also we don't want to multiply wgt by it yet since this is
c     taken care of at the level of matrix<i> already.
      hel_jacobian = jacobian
      
      end subroutine sample_get_discrete_x

      subroutine sample_get_x(wgt, x, j, ipole, xmin, xmax)
c************************************************************************
c     Returns maxdim random numbers between 0 and 1, and the wgt
c     associated with this set of points, and the iteration number
c     This routine chooses the point within the range specified by
c     xmin and xmax for dimension j in configuration ipole
c************************************************************************
      implicit none
c
c     Constants
c
      include 'genps.inc'
      include 'maxconfigs.inc'
c
c     Arguments
c
      double precision wgt, x, xmin, xmax
      integer j, ipole
c
c     Local
c
      integer  im, ip,ij,icount,it_warned
      double precision xbin_min,xbin_max,ddum(maxdim),xo,y
c
c     External
c
      double precision xbin
      external         xbin
c
c     Global
c
      double precision tmean, trmean, tsigma
      integer             dim, events, itm, kn, cur_it, invar, configs
      common /sample_common/
     .     tmean, trmean, tsigma, dim, events, itm, kn, cur_it, invar, configs

      double precision    grid(2, ng, 0:maxinvar)
      common /data_grid/ grid
      integer           Minvar(maxdim,lmaxconfigs)
      common /to_invar/ Minvar

      integer           ituple
      common /to_random/ituple

      double precision      spole(maxinvar),swidth(maxinvar),bwjac
      common/to_brietwigner/spole        ,swidth        ,bwjac

      integer nzoom
      double precision  tx(1:3,maxinvar)
      common/to_xpoints/tx, nzoom

      data ddum/maxdim*0d0/
      data icount/0/
      data it_warned/0/

      integer            lastbin(maxdim)
      common /to_lastbin/lastbin

c-----
c  Begin Code
c-----
      if (it_warned .ne. cur_it) then
         icount=0
         it_warned = cur_it
      endif
      if (ituple .eq. 2) then   !Sobel generator
         print*,'Sorry Sobel generator disabled'
         stop
c         call sobel(ddum)
c         write(*,'(7f11.5)')(ddum(j)*real(ng),j=1,dim)
      endif
      if (ituple .eq. 1) then
c         write(*,*) 'Getting variable',ipole,j,minvar(j,ipole)
         xbin_min = xbin(xmin,minvar(j,ipole))
         xbin_max = xbin(xmax,minvar(j,ipole))
         if (xbin_min .gt. xbin_max-1) then
c            write(*,'(a,4e15.4)') 'Bad limits',xbin_min,xbin_max,
c     &           xmin,xmax
c            xbin_max=xbin_min+1d-10
            xbin_max = xbin(xmax,minvar(j,ipole))
            xbin_min = min(xbin(xmin,minvar(j,ipole)), xbin_max)
         endif
c
c     Line which allows us to keep choosing same x
c
c         if (swidth(j) .ge. 0) then
         if (nzoom .le. 0) then
            call ntuple(ddum(j), xbin_min,xbin_max, j, ipole)
         else
c            write(*,*) 'Reusing num',j,nzoom,tx(2,j)

            call ntuple(ddum(j),max(xbin_min,dble(int(tx(2,j)))),
     $           min(xbin_max,dble(int(tx(2,j))+1)),j,ipole)

            if(max(xbin_min,dble(int(tx(2,j)))).gt.
     $           min(xbin_max,dble(int(tx(2,j))+1))) then
c               write(*,*) 'not good'
            endif

c            write(*,'(2i6,4e15.5)') nzoom,j,ddum(j),tx(2,j),
c     $           max(xbin_min,dble(int(tx(2,j)))),
c     $           min(xbin_max,dble(int(tx(2,j))+1))

c            ddum(j) = tx(2,j)                 !Use last value


         endif
         tx(1,j) = xbin_min
         tx(2,j) = ddum(j)
         tx(3,j) = xbin_max
      elseif (ituple .eq. 2) then
         if (ipole .gt. 1) then
            print*,'Sorry Sobel not configured for multi-pole.'
            stop
         endif
         ddum(j)=ddum(j)*dble(ng)
      else
         print*,'Error unknown random number generator.',ituple
         stop
      endif

      im = ddum(j)
      if (im.ge.ng)then
         im = ng -1
         ddum(j) = ng
      endif
      if (im.lt.0) im = 0
      ip = im + 1
      ij = Minvar(j,ipole)
c------
c     tjs 3/5/2011  save bin used to avoid looking up when storing wgt
c------
      lastbin(j) = ip
c
c     New method of choosing x from bins
c
      if (ip .eq. 1) then         !This is in the first bin
         xo = grid(2, ip, ij)-xgmin
         x = grid(2, ip, ij) - xo * (dble(ip) - ddum(j))
      else           
         xo = grid(2, ip, ij)-grid(2,im,ij)
         x = grid(2, ip, ij) - xo * (dble(ip) - ddum(j))
      endif
c
c     Now we transform x if there is a B.W., S, or T  pole
c
      if (ij .gt. 0) then
c         write(*,*) "pole, width",ij,spole(ij),swidth(ij)
         if (swidth(ij) .gt. 0d0) then
c            write(*,*) 'Tranpole called',ij,swidth(ij)
            y = x                             !Takes uniform y and returns
            call transpole(spole(ij),swidth(ij),y,x,wgt) !x on BW pole or 1/x 
         endif
      endif
c
c     Simple checks to see if we got the right point note 1e-3 corresponds
c     to the fact that the grids are required to be separated by 1e-14. Since
c     double precision is about 18 digits, we expect things to agree to
c     3 digit accuracy.
c
      if (abs(ddum(j)-xbin(x,ij))/(ddum(j)+1d-22) .gt. 1e-3) then
         if (icount .lt. 5) then
            write(*,'(a,i4,2e14.6,1e12.4)')
     &           'Warning xbin not returning correct x', ij,
     &           ddum(j),xbin(x,ij),xo
         elseif (icount .eq. 5) then
            write(*,'(a,a)')'Warning xbin still not working well. ',
     &           'Last message this iteration.'
         endif
         icount=icount+1
      endif
      if (x .lt. xmin .or. x .gt. xmax) then
c         write(*,'(a,4i4,2f24.16,1e10.2)') 'Bad x',ij,int(xbin_min),ip,
c     &        int(xbin_max),xmin,x,xmax-xmin
      endif

      wgt = wgt * xo * dble(xbin_max-xbin_min)
c      print*,'Returning x',ij,ipole,j,x
      end

      subroutine sample_get_wgt(wgt, x, j, ipole, xmin, xmax)
c************************************************************************
c     Returns the wgt for a point x in grid j of configuration
c     ipole between xmin and xmax
c************************************************************************
      implicit none
c
c     Constants
c
      include 'genps.inc'
      include 'maxconfigs.inc'
c
c     Arguments
c
      double precision wgt, x, xmin, xmax
      integer j, ipole
c
c     Local
c
      integer  im, ip,ij
      double precision xbin_min,xbin_max,xbin2
      double precision xo
c
c     External
c
      double precision xbin
      external         xbin
c
c     Global
c
      double precision tmean, trmean, tsigma
      integer             dim, events, itm, kn, cur_it, invar, configs
      common /sample_common/
     .     tmean, trmean, tsigma, dim, events, itm, kn, cur_it, invar, configs

      double precision    grid(2, ng, 0:maxinvar)
      common /data_grid/ grid
      integer           Minvar(maxdim,lmaxconfigs)
      common /to_invar/ Minvar
      integer           ituple
      common /to_random/ituple
      double precision      spole(maxinvar),swidth(maxinvar),bwjac
      common/to_brietwigner/spole        ,swidth        ,bwjac

c-----
c  Begin Code
c-----
      if (xmin .gt. x) then
         if (xmin-x .lt. 1d-13) then
            x=xmin
         else
            write(*,'(a,2i4,4e10.4)') 'Error x out of range in get_wgt',
     $           j,minvar(j,ipole),xmin,x,xmax,x-xmin
            return
         endif
      endif
      if (xmax .lt. x) then
         if (x-xmax .lt. 1d-13) then
            x=xmax
         else
            write(*,'(a,2i4,4f8.4)') 'Error x out of range in get_wgt',
     $           j,minvar(j,ipole),xmin,x,xmax,x-xmin
            return
         endif
      endif
      if (ituple .eq. 1) then
         xbin_min = xbin(xmin,minvar(j,ipole))
         xbin_max = xbin(xmax,minvar(j,ipole))
         xbin2    = xbin(x,minvar(j,ipole))  !This must be last one for bwjac
         if (xbin_min .gt. xbin_max) then
            write(*,'(a,2e15.3,i6,2e15.3)') 'Error xbinmin>xbinmax'
     &           ,xbin_min,
     &           xbin_max,minvar(j,ipole),xmin,xmax
         endif
      else
         print*,'Error unknown random number generator.',ituple
         stop
      endif
      im = xbin2
      ip = im + 1
      ij = Minvar(j,ipole)
c
c     New method for finding bin
c
      if (ip .eq. 1) then
         xo=grid(2,ip,ij)-xgmin
      else
         xo=grid(2,ip,ij)-grid(2,im,ij)
      endif
      wgt = wgt * xo * dble(xbin_max-xbin_min)*bwjac
      if (wgt .le. 0d0) then
c         write(*,'(a,3i4,2f6.1,3e15.3)') 'Error wgt<0',j,ij,ip,
c     &        xbin_min,xbin_max,xo,xmin,xmax
c         write(*,'(2e25.15)') grid(2, ip, ij),grid(2, im, ij)
c         write(*,'(a,5e15.5)') 'Wgt',wgt,xo,
c     &        dble(xbin_max-xbin_min),bwjac
      endif
      end

      subroutine sample_result(mean, rmean, sigma, itmin)
      implicit none
      double precision mean, rmean, sigma
      integer i,cur_it,itmin,itsum
      double precision tsigma,tmean,trmean,tsig,tdem

      double precision     xmean(99),xsigma(99),xwmax(99),xeff(99), xrmean(99)
      common/to_iterations/xmean,    xsigma,    xwmax,    xeff,     xrmean


      i=1
      do while(xmean(i) .ne. 0 .and. i .lt. 99)
         i=i+1
      enddo
      cur_it = i
c     Use the last 3 iterations or cur_it-1 if cur_it-1 >= itmin
      itsum = min(max(itmin,cur_it-1),3)
      i = cur_it - itsum
      tmean = 0d0
      trmean = 0d0
      tsigma = 0d0
      if (i .gt. 0) then
      tdem = 0d0
      do while (xmean(i) .ne. 0 .and. i .lt. cur_it)
         tmean = tmean+xmean(i)*xmean(i)**2/xsigma(i)**2
         trmean = trmean+xrmean(i)*xmean(i)**2/xsigma(i)**2
         tdem = tdem+xmean(i)**2/xsigma(i)**2
         tsigma = tsigma + xmean(i)**2/ xsigma(i)**2
         i=i+1
      enddo
      tmean = tmean/tsigma
      trmean = trmean/tsigma
      tsigma= tmean/sqrt(tsigma)
      endif

      mean = tmean
      rmean = trmean
      sigma = tsigma

      end

C
C     Subroutine to take care of the update of the discrete grids
C     (used for helicity and the matrix<i> choice in the grouped case
C     as implented in the DiscreteSampler module.
C
      subroutine add_entry_to_discrete_dimensions(wgt)
      use DiscreteSampler
      implicit none
c
c     Constants
c
      include 'genps.inc'
c
c     Arguments
c
      double precision wgt
c
c     Local
c
c
c     Global
c
      INTEGER                    ISUM_HEL
      LOGICAL                    MULTI_CHANNEL
      COMMON/TO_MATRIX/ISUM_HEL, MULTI_CHANNEL
      logical cutsdone, cutspassed
      COMMON/TO_CUTSDONE/CUTSDONE,CUTSPASSED
c
c     Begin code
c
c       It is important to divide the wgt stored in the grid by the 
c       corresponding jacobian otherwise it flattens the sampled
c       distribution.
C       Also, if HEL_PICKED is equal to -1, it means that MadEvent
C       is in the initialization stage where all helicity were probed
c       and added individually to the grid directly by matrix<i>.f so
c       that they shouldn't be added here.
        if(ISUM_HEL.ne.0.and.HEL_PICKED.ne.-1.and.
     &                            (.NOT.CUTSDONE.or.CUTSPASSED)) then
          call DS_add_entry('Helicity',HEL_PICKED,(wgt/hel_jacobian))
        endif

      end subroutine add_entry_to_discrete_dimensions

C
C     Subroutine to take care of the update of the discrete grids
C     (used for helicity and the matrix<i> choice in the grouped case
C     as implented in the DiscreteSampler module.
C
      subroutine update_discrete_dimensions()
      use DiscreteSampler
      implicit none
c
c     Constants
c
      include 'genps.inc'
c
c     Arguments
c
c
c     Local
c
      type(SampledDimension) tmp_dim      
c
c     Global
c
      INTEGER                    ISUM_HEL
      LOGICAL                    MULTI_CHANNEL
      COMMON/TO_MATRIX/ISUM_HEL, MULTI_CHANNEL
      logical MC_grouped_subproc
      common/to_MC_grouped_subproc/MC_grouped_subproc
c
c     Begin code
c
      if(ISUM_HEL.ne.0) then
        call DS_update_grid('Helicity', filterZeros=.True.)
        tmp_dim = DS_get_dimension(ref_grid,'Helicity')
C       Security in case of all helicity vanishing (G1 of gg > qq )
        if (size(tmp_dim%bins).eq.0) then
          call none_pass(-1)
        endif
      endif
      if(MC_grouped_subproc.and.DS_get_dim_status('grouped_processes').ne.-1) then
        call DS_update_grid('grouped_processes', filterZeros=.True.)
      endif

      end subroutine update_discrete_dimensions

      subroutine sample_put_point(wgt, point, iteration,ipole)
c**************************************************************************
c     Given point(maxinvar),wgt and iteration, updates the grid.
c     If at the end of an iteration, reforms the grid as necessary
c     and outputs current results
c**************************************************************************
      implicit none
c
c     Constants
c
      include 'genps.inc'
      integer    max_events
      parameter (max_events=5000000) !Maximum # events before get non_zero
c
c     Arguments
c
      integer iteration,ipole
      double precision wgt, point(maxinvar)
c
c     Local
c
      integer i, j, k, knt, nun,itsum
      double precision vol,xnmin,xnmax,tot,xdum,tmp1,chi2tmp
      double precision rc, dr, xo, xn, x(maxinvar), dum(ng-1)
      save vol,knt
      double precision  chi2
      save chi2
      double precision wmax1,ddumb
      save wmax1
      double precision twgt1,xchi2,xxmean,tmeant,tsigmat
      integer iavg,navg
      save twgt1,iavg,navg
c
c     External
c
      double precision binwidth,xbin,dsig
      logical rebin
      integer n_unwgted
      external binwidth,xbin,dsig,rebin,n_unwgted
c
c     Global
c
      integer th_nunwgt
      double precision th_maxwgt
      common/theoretical_unwgt_max/th_maxwgt, th_nunwgt

      double precision force_max_wgt
      common/unwgt_secondary_max/force_max_wgt

      double precision    accur
      common /to_accuracy/accur

      double precision     xmean(99),xsigma(99),xwmax(99),xeff(99), xrmean(99)
      common/to_iterations/xmean,    xsigma,    xwmax,    xeff,     xrmean

      double precision mean,rmean,sigma
      common/to_result/mean,rmean,sigma

      double precision grid2(0:ng,maxinvar)
      integer               inon_zero(ng,maxinvar), non_zero
      common/to_grid2/grid2,inon_zero,non_zero

      double precision tmean, trmean, tsigma
      integer             dim, events, itm, kn, cur_it, invar, configs
      common /sample_common/
     .     tmean, trmean, tsigma, dim, events, itm, kn, cur_it, invar, configs

      double precision    grid(2, ng, 0:maxinvar)
      common /data_grid/ grid
      integer                                      nsteps
      character*40          result_file,where_file
      common /sample_status/result_file,where_file,nsteps
      logical         first_time
      common/to_first/first_time
      integer           use_cut
      common /to_weight/use_cut
      double precision   xmin(maxinvar),xmax(maxinvar)
      common /to_extreme/xmin        ,xmax
      double precision reliable(ng,maxdim)
      common /to_error/reliable

      double precision twgt, maxwgt,swgt(maxevents)
      integer                             lun, nw, itmin
      common/to_unwgt/twgt, maxwgt, swgt, lun, nw, itmin


      real*8             wmax                 !This is redundant
      common/to_unweight/wmax

      double precision fx
      common /to_fx/   fx
      double precision   prb(maxconfigs,maxpoints,maxplace)
      double precision   fprb(maxinvar,maxpoints,maxplace)
      integer                      jpnt,jplace
      common/to_mconfig1/prb ,fprb,jpnt,jplace
      double precision   psect(maxconfigs),alpha(maxconfigs)
      common/to_mconfig2/psect          ,alpha
      double precision      spole(maxinvar),swidth(maxinvar),bwjac
      common/to_brietwigner/spole        ,swidth        ,bwjac
      
      integer                   neventswritten
      common /to_eventswritten/ neventswritten

      integer            lastbin(maxdim)
      common /to_lastbin/lastbin

      data prb/maxprb*1d0/
      data fprb/maxfprb*1d0/
      data jpnt,jplace /1,1/

c-----
c  Begin Code
c-----

      if (first_time) then
         first_time = .false.
         twgt1 = 0d0       !
         iavg = 0         !Vars for averging to increase err estimate
         navg = 1      !
         wmax1= 99d99
         wmax = -1d0
         mean = 0d0
         rmean = 0d0
         sigma = 0d0
         chi2 = 0d0
         non_zero = 0
         vol = 1d0 / dble(events * itm)
         knt = events

         do i=1,maxconfigs
            psect(i)=0d0
         enddo
         do i=1,invar
            xmin(i) = xgmax
            xmax(i) = xgmin
            do j=1,ng
               inon_zero(j,i)=0
               grid(1,j,i)   =0d0
               grid2(j,i)    =0d0
            enddo
         enddo
      endif

      if (iteration .eq. cur_it) then
c        Add the current point to the DiscreteSamplerGrid
         call add_entry_to_discrete_dimensions(wgt)
         if (kn.eq.0.and.(iteration.eq.1.or.use_cut.eq.-2)) then
            ! ensure that all cumulative variable are at zero (usefull for reset)
            twgt1 = 0d0         !
            iavg = 0            !Vars for averging to increase err estimate
            navg = 1            !
            wmax1= 99d99
            wmax = -1d0
            mean = 0d0
            rmean = 0d0
            sigma = 0d0
            chi2 = 0d0
            non_zero = 0
            vol = 1d0 / dble(events * itm)
            knt = events
            do i=1,maxconfigs
               psect(i)=0d0
            enddo
         endif

         kn = kn + 1
         if (.true.) then       !Average points to increase error estimate
            twgt1=twgt1+dabs(wgt)     !This doesn't change anything should remove
            iavg = iavg+1
            if (iavg .ge. navg) then
               sigma=sigma+twgt1**2
               iavg = 0
               twgt1=0d0
            endif
         else
            sigma = sigma + wgt**2
         endif
         if (wgt .ne. 0.) then
            if (dabs(wgt)*itm*events .gt. wmax) then
               wmax=dabs(wgt)*itm*events
            endif
            non_zero = non_zero + 1
            mean = mean + dabs(wgt)
            rmean = rmean + wgt
            if (.true. ) then
c               psect(ipole)=psect(ipole)+wgt*wgt/alpha(ipole)  !Ohl 
c               psect(ipole)=1d0                 !Not doing multi_config
            else
               tot = 0d0
               do i=1,configs
                  tot=tot+prb(i,jpnt,jplace)*alpha(i)
               enddo
               do i=1,configs
                  if (tot .gt. 0d0) then !Pittau hep-ph/9405257
                     psect(i)=psect(i)+wgt*wgt*prb(i,jpnt,jplace)/tot
                  else
                     psect(i)=psect(i)+wgt*wgt*alpha(i) !prb not set....
                  endif
               enddo
            endif
c            write(123,'(2i6,1e15.5)') 1,1,wgt
c            write(123,'(5e15.9)') (fprb(i,jpnt,jplace),i=1,invar) 
c            write(123,'(5e15.9)') (prb(i,jpnt,jplace),i=1,configs) 
            do j = 1, invar
c               i = int(xbin(point(j),j))+1    
c--------------
c     tjs 3/5/2011  use stored value for last bin
c--------------
               i = lastbin(j)
c               write(*,*) 'bin choice',j,i,lastbin(j)
               if (i .gt. ng) then
                  print*,'error i>ng',i,j,ng,point(j)
                  i=ng
               endif
               grid(1, i, j) = grid(1, i, j) + abs(wgt)
               grid2(i, j) = grid2(i, j) + wgt**2
c
c     Lines below are for multiconfiguration
c
c               grid(1, i, j) = grid(1, i, j) +
c     &                          (abs(wgt)**2)*fprb(j,jpnt,jplace)
c               grid2(i, j) = grid2(i, j) + wgt**4*fprb(j,jpnt,jplace)
               if (abs(wgt) .gt. 0) inon_zero(i,j) = inon_zero(i,j)+1
c
c     Here we need to look out for point(j) which has been transformed
c     for Briet-Wigner pole
c
               if (j .gt. 0) then
                  if (swidth(j) .gt. 0d0) then
                     ddumb=0d0
                     call untranspole(spole(j),swidth(j),
     &                    point(j),point(j),ddumb)
                     if (point(j) .lt. 0d0) then
                        print*,'Warning point<0',j,point(j)
                     endif
                  endif
               endif
               if (abs(wgt) .gt. 0) xmin(j)=min(xmin(j),point(j))
               if (abs(wgt) .gt. 0) xmax(j)=max(xmax(j),point(j))
               if (xmin(j) .lt. xgmin) then
                  print*,'Warning xmin<0',j,xmin(j),point(j)
               endif
               xmin(j)=max(xmin(j),xgmin)
            end do
         endif
c
c     Now if done with an iteration, print out stats, rebin, reset
c         
c         if (kn .eq. events) then
         if (kn .ge. max_events .and. non_zero .le. 5) then
            call none_pass(max_events)
         endif
         if (iteration.eq.1) then
           if (nb_pass_cuts.ge.1000 .and. non_zero.eq.0) then
              call none_pass(1000)
           endif
         endif
         if (non_zero .ge. events .or. (kn .gt. 200*events .and.
     $        non_zero .gt. 5)) then

c          # special mode where we store information to combine them
           if(use_cut.eq.-2)then
                open(unit=22, file="grid_information")
                write(22,*) non_zero, ng, invar
                write(22,*) ((grid(1,i,j),i=1,ng),j=1,invar)
                write(22,*) ((grid(2,i,j),i=1,ng),j=1,invar)
                write(22,*) ((inon_zero(i,j),i=1,ng),j=1,invar)
                write(22,*) (xmin(j), j=1,invar)
                write(22,*) (xmax(j), j=1,invar)
                write(22,*) mean, rmean, sigma, wmax, kn,events, force_max_wgt
c               In order not to write out the reference grid but just
c               the points which were added for this last iteration,
c               we write out the discrete 'running' grids before the
c               update of the reference grid.
                call write_discrete_grids(22,'all')
                close(22)
           endif

C
C    Now updated the discrete dimensions of the DiscreteSampler module
C    used for sampling helicity configurations and matrix<i> config
C    choice in the grouped case.
C
           call update_discrete_dimensions()

            mean=mean*dble(events)/dble(non_zero)
            rmean=rmean*dble(events)/dble(non_zero)
            twgt1=twgt1*dble(events)/dble(non_zero)
            sigma=sigma+twgt1**2    !This line for averaging over points
            if (non_zero .eq. 0) then
               write(*,*) 'Error no points passed the cuts.'
               write(*,*) 'Try running with more points or looser cuts.'
               stop
            endif
c            mean = mean * itm                 !Used if don't have non_zero
            if (.true.) then
               mean = mean * itm *dble(non_zero)/dble(kn)
               rmean = rmean * itm *dble(non_zero)/dble(kn)
               knt = kn
            endif
c
c     Need to fix this if averaging over navg events
c
c        write(*,*) (sigma/vol/vol-knt*mean*mean)/dble(knt-1)/dble(knt),
c     &        (sigma/vol/vol-knt*mean*mean*navg)/dble(knt-1)/ dble(knt)

            if (.true.) then
c               vol = 1d0/(knt*itm)
               sigma = DABS((sigma/vol/vol-non_zero*mean*mean*navg)  ! knt replaced by non_zero
     .              / dble(knt-1) / dble(knt))                       ! DABS is to catch numerical error
            else

               sigma = (sigma/vol/vol - knt*mean*mean)
     .              / dble(knt-1) / dble(knt)
            endif

            tmean = tmean + mean * (mean**2 / sigma)
            trmean = trmean + rmean * (mean**2 / sigma)
            tsigma = tsigma + mean**2 / sigma
            chi2 = chi2 + mean**2 * (mean**2 / sigma)
            sigma = sqrt(abs(sigma))

            if (cur_it .lt. 100) then
               xmean(cur_it) = mean
               xrmean(cur_it) = rmean
               xsigma(cur_it) = sigma
               xwmax(cur_it)= wmax*dble(non_zero)/dble(kn)
               xeff(cur_it)= sigma*sqrt(dble(non_zero))/mean
c               call sample_writehtm()
            endif
            write(*,222) 'Iteration',cur_it,'Mean: ',rmean,
     &           ' Abs mean: ',mean, '  Fluctuation: ',sigma,
     &           wmax*(dble(non_zero)/dble(kn)),
     &           dble(non_zero)/dble(kn)*100.,'%'
 222        format(a10,I3,3x,a6,e10.4,a11,e10.4,a16,e10.3,e12.3,3x,f5.1,a1)

            write(*,223) cur_it, rmean, mean,' +- ', sigma,
     &           sigma*sqrt(dble(non_zero))/mean
 223        format( i3,3x,2e11.4,a,e10.4,f10.2)
            tot=0d0
            do i=1,configs
               tot=tot+psect(i)
            enddo
            if (configs .gt. 1)
     &           write(*,'(8f10.5)') (psect(i)/tot, i=1,configs)
c
c     Now set things up for generating unweighted events
c
            if (twgt .eq. -2d0) then               
               twgt = mean *kn/ (dble(itm)*dble(events)*dble(events))
c
c     now scale twgt, in case have large fluctuations
c

c               twgt = twgt * max(1d0, xeff(cur_it))

c
c     For small number of events only write about 1% of events
c
c               if (events .le. 2500) then
c                  twgt = mean *kn*100 /
c     $                 (dble(itm)*dble(events)*dble(events)) 
c               endif
c               twgt = max(twgt, maxwgt/10d0)
               write(*,*) 'Writing out events',twgt, xeff(cur_it)
c               write(*,*) mean, kn, itm, events
            endif
c
c     This tells it to write out a file for unweighted events
c
c            if(wmax*(dble(non_zero)/dble(kn)) .lt. wmax1) then
            if(sigma/(mean+1d-99) .lt. wmax1 .and. use_cut .ne. 0) then
c               wmax1 = wmax*(dble(non_zero)/dble(kn))
               wmax1 = sigma/(mean+1d-99)
c               open(26, file='ftn99',status='unknown')
c               write(26,fmt='(4f20.17)')
c     $              ((grid(2,i,j),i=1,ng),j=1,maxinvar)
c               write(26,fmt='(4f20.17)') (alpha(i),i=1,maxconfigs)
c               close(26)
            endif
            tot=0d0
            if (use_cut .ne. 0) then
c              write(*,*) 'Keeping alpha fixed'
               if (configs .gt. 1) then
                  do i=1,configs
                     alpha(i)=alpha(i)*sqrt(sqrt(psect(i))) !Pittau
                     tot = tot+alpha(i)
                     psect(i)=0d0
                  enddo
                  do i=1,configs
                     alpha(i)=alpha(i)/tot
                  enddo
                  write(*,'(A)') 'Configs:'
                  write(*,'(8f10.5)') (alpha(i),i=1,configs)
               endif
            endif
c            open(unit=22,file=result_file,status='old',access='append',
c     &           err=23)
c            write(22,222) 'Iteration',cur_it,'Mean: ',mean,
c     &           '  Fluctuation: ',sigma,
c     &           wmax*(dble(non_zero)/dble(kn)),
c     &           dble(non_zero)/dble(kn)*100.,'%'
c            close(22)

c------
c    Here we will double the number of events requested for the next run
c-----
 23         events = 2 * events
            vol = 1d0/dble(events*itm)
            knt = events
            if (use_cut.ne.-2) then
              twgt = mean / (dble(itm)*dble(events))
            endif
c            write(*,*) 'New number of events',events,twgt

            mean = 0d0
            rmean = 0d0
            sigma = 0d0
            cur_it = cur_it + 1
            kn = 0
            wmax = -1d0

c
c     do so adjusting of weights according to number of events in bin
c
            do j=1,invar
               do i = 1, ng
                  if (abs(use_cut) .ne. 2 .and.
     &                use_cut .ne. 3 .and. use_cut .ne. 5)
     $                 inon_zero(i,j) = 0
                  if (use_cut .eq. 3) grid(1,i,j)=grid2(i,j)
                  if (inon_zero(i,j) .ne. 0) then
                     grid(1,i,j) = grid(1,i,j)
     &                 *dble(min((real(non_zero)/real(inon_zero(i,j))),
     $                    10000.))
                     grid2(i,j) = grid2(i,j)
     &                 *dble(min((real(non_zero)/real(inon_zero(i,j))),
     $                    10000.))**2
                     if (real(non_zero)/real(inon_zero(i,j))
     &                    .gt. 100000) then
c                        if (j .eq. 1) then
                           print*,'Exceeded boost',j,i,
     &                          real(non_zero)/real(inon_zero(i,j))
c                        endif
                     endif
                     inon_zero(i,j) = 0
                  endif
                  if (use_cut .eq. 4)
     &                 reliable(i,j)=dsqrt(grid2(i,j))/grid(1,i,j)
               enddo
            enddo
            if (use_cut .eq. 4) then
               use_cut=0
            endif
            do j = 1, invar
               k=1
c
c              special routines to deal with xmin cutoff
c
               do while(grid(1,k,j) .le. 0d0 .and. k+1 .lt. ng)
                  k=k+1
               enddo

c               if (j .eq. 1) then
c                  open(unit=22,file='x1.dat',status='unknown')
c                  do i=1,ng
c                     write(22,'(i6,2e20.8)') i,grid(1,i,j),
c     $                    dsqrt(grid2(i,j))
c                  enddo
c                  close(22)
c               endif

               x(j)=0d0
               do i=1,ng
                  x(j)=x(j)+grid(1,i,j)
               enddo

               call average_grid(j,k,grid,grid2,x)

c               if (j .eq. 1 .and. .true.) then
c               open(unit=22,file='x1avg.dat',status='unknown')
c               do i=1,ng
c                  write(22,'(i6,2e20.8)') i,grid(1,i,1),
c     $                 dsqrt(grid2(i,1))
c               enddo
c               close(22)
c               endif

c
c     Now take logs to help the rebinning converge quicker
c
               rc = 0d0
               do i= k, ng
                  xo = (1.0d-14) + grid(1, i, j) / x(j)
                  grid(1, i, j) = ((xo - 1d0) / log(xo))**1.5 !this is 1.5
                  rc = rc + grid(1, i, j)
c                  write(*,*) i,rc
               end do      
               rc = rc / dble(ng)
               k = 0
               xn = xgmin
               dr = 0d0
               i = 0
c
c     Special lines to deal with xmin .ne. 0 cutoffs
c               
c
c     These assume one endpoints are xgmin and xgmax
c     
c

               xnmin = xgmin              !Endpoints for grid usually 0d0
               xnmax = xgmax              !Endpoint for grid usually 1d0
               if (xmin(j)-xgmin .gt. (grid(2,2,j)-grid(2,1,j)))then
                  xnmin = xmin(j)-(grid(2,2,j)-grid(2,1,j))/5d0
                  i = 1
                  dum(i)= xnmin
                  xn = xnmin
                  rc = rc * dble(ng)/dble(ng-i)
               endif
               dum(ng-1) = -1d0
               if (xgmax-xmax(j).gt.(grid(2,ng-1,j)-grid(2,ng-2,j)))then
                  xnmax = xmax(j)+(grid(2,ng-1,j)-grid(2,ng-2,j))/5d0
                  dum(ng-1)= xnmax
                  rc = rc * dble(ng-i)/dble(ng-i-1)
c                  print*,'xmax',j,xmax(j),dum(ng-1)
               endif
               
 25            k = k + 1
               dr = dr + grid(1, k, j)
               xo = xn
               xn = max(grid(2, k, j),xnmin)
               xn = min(xn,xnmax)
 26            if (rc .gt. dr) goto 25

               i = i + 1
               dr = dr - rc
               dum(i) = xn - (xn - xo) * dr / grid(1, k, j)
c
c     Put in check for 0 width bin NEED TO FIX THIS
c
               if (dum(ng-1) .eq. -1) then
                  if (i .lt. ng - 1 ) goto 26
               else
                  if (i .lt. ng - 2 ) goto 26
               endif
c
c     Here is another fix for 0 width bins
c
               do i=1,ng-2
                  if (dum(i+1)-dum(i) .le. 1d-14) then
c                     write(*,'(a,2i4,2f24.17,1e10.3)') 'Bin too small',
c     &                    j,i,dum(i),dum(i+1),dum(i+1)-dum(i)
                     dum(i+1)=dum(i)+1d-14
                     if (dum(i+1) .gt. xgmax) then
                        write(*,*) 'Error in rebin',i,dum(i),dum(i+1)
                     endif
                  endif
               enddo
c
c     Now reset counters and set new grid as necessary
c
               do i = 1, ng - 1
                  grid(1, i, j) = 0d0
                  grid2(i,j) = 0d0
                  if (use_cut .ne. 0 .and. j .gt. 0)
     $                 grid(2, i, j) = dum(i)
               end do
               grid(1, ng, J) = 0d0
               grid(2, ng, J) = xgmax
               grid2(ng,j)  = 0d0
               non_zero = 0

               call sample_write_g(j,'_1')

            end do
c            write(*,*) (irebin(j),j=1,dim)
c            open(unit=26,file='grid.dat',status='unknown')
c            do j=1,maxinvar
c               do i=1,ng
c                  write(26,*) grid(2,i,j),j,i
c               enddo
c            enddo
c            close(26)

c     Update weights in dsig (needed for subprocess group mode)
            xdum=dsig(0,0,2)
c
c     Add test to see if we have achieved desired accuracy 
c     Allow minimum itmin iterations
c
            if (tsigma .gt. 0d0 .and. cur_it .gt. itmin .and. accur .gt. 0d0) then

               xxmean = tmean/tsigma
               if (cur_it.ne.2)then
                  xchi2 = dabs(chi2/xxmean/xxmean-tsigma)/dble(cur_it-2)               
               else
                  xchi2 = 0d0
               endif
               write(*,'(a,4f8.3)') ' Accuracy: ',sqrt(xchi2/tsigma),
     &              accur,1/sqrt(tsigma),xchi2
c               write(*,*) 'We got it',1d0/sqrt(tsigma), accur
c               if (1d0/sqrt(tsigma) .lt. accur) then
               if (sqrt(xchi2/tsigma) .lt. accur) then
                  write(*,*) 'Finished due to accuracy ',sqrt(xchi2/tsigma), accur
                  tmean = tmean / tsigma
                  trmean = trmean / tsigma
                  if (cur_it .gt. 2) then
                     chi2 = (chi2/tmean/tmean-tsigma)/dble(cur_it-2)
                  else
                     chi2=0d0
                  endif
                  tsigma = tmean / sqrt(tsigma)
                  write(*, 80) real(tmean), real(tsigma), real(trmean), real(chi2)
                  if (use_cut .ne. 0) then
                  open(26, file='ftn26',status='unknown')
                  write(26,fmt='(4f21.17)')
     $                 ((grid(2,i,j),i=1,ng),j=1,invar)
                  write(26,*) twgt, force_max_wgt
c                  write(26,fmt='(4f21.16)') (alpha(i),i=1,maxconfigs)
                  call write_discrete_grids(26,'ref')
                  close(26)                  
                  endif
                  call sample_writehtm()
c                  open(unit=22,file=result_file,status='old',
c     $                 access='append',err=122)
c                  write(22, 80) real(tmean), real(tsigma), real(chi2)
c 122              close(22)
                  tsigma = tsigma*sqrt(chi2)  !This gives the 68% confidence cross section
                  if (use_cut.eq.-2)then
                    call store_events(force_max_wgt, .False.)
                  else
                     call store_events(-1d0, .True.)
                  endif
                  cur_it = itm+2
                  return
               endif
            endif                  
c
c New check to see if we need to keep integrating this one or not.
c
            if (cur_it .gt. itmin .and. accur .lt. 0d0) then  !Check luminocity
c
c             Lets get the actual number instead 
c             tjs 5/22/2007
c
c               nun = n_unwgted()
c               write(*,*) 'Estimated events',nun, accur
               if (use_cut.eq.-2) then
                  call store_events(force_max_wgt, .False.)
               else
                  call store_events(-1d0, .True.)
               endif

               nun = neventswritten
c               tmp1 = tmean / tsigma
c               chi2tmp = (chi2/tmp1/tmp1-tsigma)/dble(cur_it-2)
c     Calculate chi2 for last few iterations (ja 03/11)
               tmeant = 0d0
               tsigmat = 0d0
c     Use the last 3 iterations or cur_it-1 if cur_it-1 >= itmin but < 3
               itsum = min(max(itmin,cur_it-1),3)
               do i=cur_it-itsum,cur_it-1
                  tmeant = tmeant+xmean(i)*xmean(i)**2/xsigma(i)**2
                  tsigmat = tsigmat + xmean(i)**2/ xsigma(i)**2
               enddo
               tmeant = tmeant/tsigmat
               chi2tmp = 0d0
               do i = cur_it-itsum,cur_it-1
                  chi2tmp = chi2tmp+(xmean(i)-tmeant)**2/xsigma(i)**2
               enddo
               chi2tmp = chi2tmp/2d0  !Since using only last 3, n-1=2
c     JA 8/17/2011 Redefined -accur as lumi, so nevents is -accur*cross section
               write(*,*) "Checking number of events",-accur*tmeant,nun,' chi2: ',chi2tmp
c     Check nun and chi2 (ja 03/11)
               if (nun .gt. -accur*tmeant .and. chi2tmp .lt. 10d0)then   
                  tmean = tmean / tsigma
                  if (cur_it .gt. 2) then
                     chi2 = (chi2/tmean/tmean-tsigma)/dble(cur_it-2)
                  else
                     chi2=0d0
                  endif
                  tsigma = tmean / sqrt(tsigma)
                  write(*, 80) real(tmean), real(tsigma), real(chi2)
                  if (use_cut .ne. 0) then
                  open(26, file='ftn26',status='unknown')
                  write(26,fmt='(4f21.17)')
     $                 ((grid(2,i,j),i=1,ng),j=1,invar)
                  write(26,*) twgt, force_max_wgt
c                  write(26,fmt='(4f21.17)') (alpha(i),i=1,maxconfigs)
                  call write_discrete_grids(26,'ref')
                  close(26)
                  endif
                  call sample_writehtm()

c                  open(unit=22,file=result_file,status='old',
c     $                 access='append',err=129)
c                  write(22, 80) real(tmean), real(tsigma), real(chi2)
c 129              close(22)
                  tsigma = tsigma*sqrt(max(0d0,chi2)) !This gives the 68% confidence cross section
                  cur_it = itm+20
                  return
               endif
            endif                     


            if (cur_it .gt. itm) then               
               if (use_cut.eq.-2)then
                  call store_events(force_max_wgt, .False.)
               else
                  call store_events(-1d0, .True.)
               endif
               tmean = tmean / tsigma
               trmean = trmean / tsigma
               chi2 = dabs(chi2 / tmean / tmean - tsigma) / dble(itm - 1)
               tsigma = tmean / sqrt(tsigma)
               write(*, 80) real(tmean), real(tsigma), real(trmean), real(chi2)
 80            format(/1X,79(1H-)/1X,23HAccumulated results:   ,
     .              10HIntegral =,e12.4/24X,10HStd dev  =,e12.4
     .              /23X,11HCross sec =,e12.4/
     .              13X,21HChi**2 per DoF.     =,f12.4/1X,79(1H-))
               if (use_cut .ne. 0) then
                   call write_grid('ftn26')
               endif
               call sample_writehtm()
c               open(unit=22,file=result_file,status='old',
c     $              access='append',err=123)
c               write(22, 80) real(tmean), real(tsigma), real(chi2)
c 123           close(22)
               tsigma = tsigma*sqrt(chi2) !This gives the 68% confidence cross section
            else
c
c              Starting new iteration, should clean out stored events 
c              and start fresh
c
c                  nun = n_unwgted()
c                  write(*,*) 'Estimated unweighted events ', nun
              call clear_Events
            endif
         endif
      else
      endif
      end

      subroutine none_pass(max_events)
c*************************************************************************
c      Special break to handle case where no events are passing cuts
c     We'll set the cross section to zero here.
c*************************************************************************
      implicit none
c
c     Constants
c
      include 'genps.inc'
c
c     Arguments
c
      integer max_events
c
c     Global
c
      integer                                      nsteps
      character*40          result_file,where_file
      common /sample_status/result_file,where_file,nsteps

c----
c  Begin Code
c----
      if (1000.eq.max_events) then
         write(*,*) nb_pass_cuts, 
     &    ' points passed the cut but all returned zero'
         write(*,*) 'therefore considering this contribution as zero'
      else if (nb_pass_cuts.gt.0.and.nb_pass_cuts.lt.1000)then
         write(*,*) 'only', nb_pass_cuts, 
     &    ' points passed the cut and they all returned zero'
         write(*,*) 'therefore considering this contribution as zero'
         write(*,*) 'Loosen cuts or increase max_events if you believe this is not zero'
      else
         write(*,*) 'No points passed cuts!'
         write(*,*) 'Loosen cuts or increase max_events',max_events
      endif

c      open(unit=22,file=result_file,status='old',access='append',
c     &           err=23)
c      write(22,222) 'Iteration',0,'Mean: ',0d0,
c     &     '  Fluctuation: ',0d0,
c     &     0d0,
c     &     0d0,'%'
c 23   close(22)
 222  format(a10,I3,3x,a6,e10.4,a16,e10.3,e12.3,3x,f5.1,a1)

      open(unit=66,file='results.dat',status='unknown')
      write(66,'(3e12.5,2i9,i5,i9,5e10.3,i9)')0.,0.,0.,0,0,
     &     0,1,0.,0.,0.,0.,0.,0
      write(66,'(i4,5e15.5)') 1,0.,0.,0.,0.,0.
c     Write out MadLoop statistics, if any
      call output_run_statistics(66)
      flush(66)
      close(66, status='KEEP')

c     Remove file events.lhe (otherwise event combination gets screwed up)
      write(*,*) 'Deleting file events.lhe'
      open(unit=67,file='events.lhe',status='unknown')
      write(67,*)
      close(67)

      open(unit=67, file='grid_information')
      write(67,*) ''
      close(67)

      stop
      end
            
      subroutine average_grid(j,k,grid,grid2,x)
c**************************************************************************
c     Special routine to deal with averaging over the grid bins
c     This routine starts averaging at bin k rather than bin 1 so that
c     one can accommodate cutoffs.  With k=1 this should give the
c     standard sample/vegas/bases averaging results.
c
c     Also stops averaging when reaches maximum value
c
c**************************************************************************
      implicit none
c
c     Constants
c
      include 'genps.inc'
c
c     Arguments
c
      integer j,k
      double precision grid(2,ng,0:maxinvar),grid2(0:ng,maxinvar)
      double precision x(maxinvar)
c
c     Local
c
      integer i,kmax
      double precision xo,xn
c-----
c  Begin Code
c-----
      kmax=k
      do i=k+1,ng
         if (grid(1,i,j) .gt. 0d0) kmax=i
      enddo
      xo = grid(1,k,j)
      xn = grid(1,k+1,j)
      grid(1,k,j) = (xo+xn)/2d0
      x(j) = grid(1,k,j)
c      do i=k+1,ng-1                      !Original without kmax stuff
      do i=k+1,kmax-1
         grid(1, i, j) = xo + xn
         xo = xn
         xn = grid(1, i+1, j)
         grid(1, i, j) = (grid(1, i, j) + xn) / 3d0
         x(j) = x(j) + grid(1, i, j)
      end do
c      grid(1, ng, j) = (xn + xo) / 2d0  !Original without kmax stuff
      grid(1, kmax, j) = (xn + xo) / 2d0
      x(j) = x(j) + grid(1, kmax, j)
      end

      double precision function xbin(y,j)
c**************************************************************************
c     Subroutine to determine which value y  will map to give you the
c     value of x when put through grid j.  That is what random number
c     do you need to be given to get the value x out of grid j and will be
c     between 0 < x < ng.
c**************************************************************************
      implicit none
c
c     Constants
c
      include 'genps.inc'
      double precision tol
      parameter       (tol=1d-12)
c
c     Arguments
c      
      double precision y
      integer j
c
c     Local
c
      integer i,jl,ju
      double precision x,xo
c
c     Global
c
      double precision    grid(2, ng, 0:maxinvar)
      common /data_grid/ grid
      double precision      spole(maxinvar),swidth(maxinvar),bwjac
      common/to_brietwigner/spole        ,swidth        ,bwjac
c
c     Data
c
      data spole,swidth/maxinvar*0d0,maxinvar*0d0/
c-----
c  Begin Code
c-----
      bwjac = 1d0
      if (j .gt. 0) then
         if (swidth(j) .gt. 0d0) then
            call  untranspole(spole(j),swidth(j),x,y,bwjac)
         else
            x=y
         endif
      else
         x=y
      endif
      if (x .eq. xgmax) then
         i=ng
         xbin = dble(ng)
      elseif (x .eq. xgmin) then
         xbin=0d0
      elseif(x .le. grid(2,1,j)) then
         i=1
         xo = grid(2,i,j)-xgmin
         xbin = dble(i)+(x-grid(2,i,j))/xo
      else
         jl = 1
         ju = ng
         do while (ju-jl .gt. 1)                    !Binary search
            i = (ju-jl)/2+jl
            if (grid(2,i,j) .le. x) then
               jl=i
            else
               ju=i
            endif
         enddo
         i=ju
         xo = grid(2,i,j)-grid(2,i-1,j)
         xbin = dble(i)+(x-grid(2,i,j))/xo
      endif
c      jbin=i
c      x = 
c      if (x+tol .gt. grid(2,i,j) .and. i .ne. ng) then
c         write(*,'(a,2e23.16,e9.2)') 'Warning in DSAMPLE:JBIN ',
c     &                x,grid(2,i,j),tol
c         x=2d0*grid(2,i,j)-x
c         jbin=i+1
c      endif
      end


      subroutine sample_write_g(idim,cpost)
c**************************************************************************
c     Writes out grid in function form for dimension i with extension cpost
c     
c**************************************************************************
      implicit none
c
c     Constants
c
      include 'genps.inc'
c
c     Arguments
c
      integer idim
      character*(*) cpost
c
c     Local
c
      character*60 fname
      integer i
      double precision xo,yo
c
c     Global
c
      double precision   grid(2, ng, 0:maxinvar)
      common /data_grid/ grid

c-----
c  Begin Code
c-----
      return
      if (idim .lt. 1 .or. idim .gt.maxinvar) then
         write(*,*) 'Error invalid dimension in sample_write_f',idim
         return
      endif
      if (idim .lt. 10) then
         write(fname,'(a,i1,a,a)') 'g_',idim,cpost,'.dat'
      elseif (idim .lt. 100) then
         write(fname,'(a,i2,a,a)') 'g_',idim,cpost,'.dat'
      endif
      open(unit=21,file=fname,status='unknown',err=99)
      do i=1,ng-1
         xo = (grid(2,i,idim)+grid(2,i+1,idim))/2d0
         yo =1d0/(-grid(2,i,idim)+grid(2,i+1,idim))
         write(21,*) xo,yo
      enddo
      close(21)
      return
 99   write(*,*) 'Error opening file ',fname
      end

      function ran1(idum)
      dimension r(97)
      parameter (m1=259200,ia1=7141,ic1=54773,rm1=3.8580247e-6)
      parameter (m2=134456,ia2=8121,ic2=28411,rm2=7.4373773e-6)
      parameter (m3=243000,ia3=4561,ic3=51349)
      data iff /0/
      save r, ix1, ix2, ix3
      if (idum.lt.0.or.iff.eq.0) then
        iff=1
        ix1=mod(ic1-idum,m1)
        ix1=mod(ia1*ix1+ic1,m1)
        ix2=mod(ix1,m2)
        ix1=mod(ia1*ix1+ic1,m1)
        ix3=mod(ix1,m3)
        do 11 j=1,97
          ix1=mod(ia1*ix1+ic1,m1)
          ix2=mod(ia2*ix2+ic2,m2)
          r(j)=(float(ix1)+float(ix2)*rm2)*rm1
11      continue
        idum=1
      endif
      ix1=mod(ia1*ix1+ic1,m1)
      ix2=mod(ia2*ix2+ic2,m2)
      ix3=mod(ia3*ix3+ic3,m3)
      j=1+(97*ix3)/m3
      if(j.gt.97.or.j.lt.1) stop
      ran1=r(j)
      r(j)=(float(ix1)+float(ix2)*rm2)*rm1
      return
      end

      subroutine reset_cumulative_variable()
C       Reset to zero all the variable which evaluates the cross-section.
C       grid information for the current-grid/non-zero entry/...
C       This is used to avoid the (small) bias introduce in the first iteration
C       Due to the initialization of the helicity sum.
      implicit none
      include 'genps.inc'

      double precision grid2(0:ng,maxinvar)
      integer               inon_zero(ng,maxinvar), non_zero
      common/to_grid2/grid2,inon_zero, non_zero
      double precision    grid(2, ng, 0:maxinvar)
      common /data_grid/ grid

      double precision tmean, trmean, tsigma
      integer             dim, events, itm, kn, cur_it, invar, configs
      common /sample_common/
     .     tmean, trmean, tsigma, dim, events, itm, kn, cur_it, invar, configs


C     LOCAL
      integer i,j

      write(*,*) "RESET CUMULATIVE VARIABLE"
      non_zero = 0
      nb_pass_cuts = 0
      do j=1,maxinvar
         do i=1,ng -1
            inon_zero = 0
            grid2(i,j) = 0
            grid(1,i,j) = 0
         enddo
      enddo
      tmean = 0.0
      trmean = 0.0
      tsigma = 0.0
      kn = 0
      return 
      end

C----------------------------------------------
C
C		Routine to add zincrement to a bin in a histogram
C
	subroutine hfill(id,x,y,zincrement)
C
C		id = integer associated with the histogram
C		x  = x value to locate bin (real)
C		y  = y value to locate bin (real) [ignored for 1-dim histo]
C		zincrement = value to be added to bin specified by (x,y)
C
	include 'hbook.inc'
	data nhist/0/,pointer(1)/1/

	do i=1,nhist
		if (id number(i) .eq. id) go to 10
		end do
	print*,' id number ',id,' does not belong to a current histogram'
	return
10	continue
	k = pointer(i)
	nx=data(k)+.1
	ixoff = (x-data(k+1))/(data(k+2)-data(k+1))*data(k)+1
	if (ixoff .le. 0 .or. ixoff .gt. nx) return
	if (single dim(i)) then
		data(k+2+ixoff)=data(k+2+ixoff)+zincrement
		error(k+2+ixoff)=error(k+2+ixoff)+zincrement**2
		npoints(k+2+ixoff)=npoints(k+2+ixoff)+1.
	else
		ny=data(k+3)+.1
		iyoff = (y-data(k+4))/(data(k+5)-data(k+4))*data(k+3)+1
		if (iyoff .le. 0 .or. iyoff .gt. ny) return
		ioff = nx*(iyoff-1)+ixoff
		data(k+5+ioff)=data(k+5+ioff)+zincrement
		end if
	return
	end

      program test
c*****************************************************************
c     tests traversing directories to find all events
c****************************************************************
      implicit none
c
c     Constants
c
      include 'maxparticles.inc'
      include 'run_config.inc'
      include 'run.inc'
      include 'cuts.inc'
      integer    maxsubprocesses
      parameter (maxsubprocesses=9999)
      integer    cmax_events
      parameter (cmax_events=5000000)
      integer    sfnum
      parameter (sfnum=17)   !Unit number for scratch file
      integer    maxexternal
      parameter (maxexternal=2*max_particles-3)
c
c     for the run_card
c
      real*8 sf1,sf2,pb1,pb2,D
      integer lhaid
      character*7 pdlabel
c     
c     Local
c
      character*300 subname(maxsubprocesses)
      character*310 pathsubname(maxsubprocesses)         !needed for MadWeight
      character*80 down_path                           !needed for MadWeight
      character*40 filename                         !needed for MadWeight
      character*4  card_number                         !needed for MadWeight
      character*20 run_name                            !needed for MadWeight
      integer pos1,pos2,pos3                           ! needed for MadWeight
      integer i,j,m,ns,nreq,ievent
      integer kevent,revent,iarray(cmax_events)
      double precision sum, xsec, xerr, goal_wgt,xarray(cmax_events)
      double precision xdum,rxsec
      integer i4,r8,record_length
      integer jseed,iseed
      real xran1
      double precision wgt,maxwgt
      double precision p(0:4,maxexternal)
      integer ic(7,maxexternal),n
      double precision sscale,aqcd,aqed
      character*20 param(maxpara),value(maxpara)
      integer npara,nunwgt
      double precision xtrunc, min_goal,max_goal
      logical keep(cmax_events),done
      integer ntry
      logical gridrun,gridpack
c
c     PARAM_CARD
c
      character*30 param_card_name
      common/to_param_card_name/param_card_name

      character*1000 buff
      logical u_syst, has_negative
      character*(s_bufflen) s_buff(7)
      integer nclus
      character*(clus_bufflen) buffclus(max_particles)
      data s_buff/7*''/
      data jseed/-1/
      data buffclus/max_particles*' '/
      double precision bias_weight
      logical impact_xsec
      common/bias/bias_weight,impact_xsec
c-----
c  Begin Code
c-----
c
c     Get requested number of events
c
      include 'run_card.inc'

      has_negative = .false.
      if (gridpack) then
c        load the gridpack file
         call load_gridpack_para(npara,param,value)
         call get_logical(npara,param,value," gridrun ",gridrun,.false.)
      endif

      if (gridrun.and.gridpack) then
        call get_integer(npara,param,value," gevents "  ,nreq  ,2000   )
      else
        nreq = nevents
      endif
c   Get information for the <init> block
      param_card_name = 'param_card.dat'
      call setrun

c      nreq = 10000
c
c     Get total cross section
c
      xsec = 0d0
      xerr = 0d0
c $B$ input_file $B$
      filename='results.dat'
c $E$ input_file $E$

      open(unit=15,file=filename,status='old',err=21)
      read(15,*,err=20) xsec,xerr,xdum,xdum,xdum,xdum,xdum,xdum,xdum,rxsec
      write(*,*) "Results.dat xsec = ",rxsec," abs xsec = ",xsec
 20   close(15)
 21   if (nreq .gt. 0 .and. xsec .ne. 0) then
         goal_wgt = xsec/nreq/4d0   !Extra factor of 4 for weighted events
      else
         goal_wgt = 0d0    !Write out everything
      endif
c
c     Get list of subprocesses
c
      call get_subprocess(subname,ns)

c
c     Create scratch file to hold events
c
      I4 = 4
      R8 = 8
      record_length = 4*I4+maxexternal*I4*7+maxexternal*5*R8+4*R8+
     &   1000+7*s_bufflen+max_particles*clus_bufflen
C $B$ scratch_name $B$ !this is tag for automatic modification by MW
      filename='scratch'
C $E$ scratch_name $E$ !this is tag for automatic modification by MW
      open(unit=sfnum,access='direct',file=filename,err=999,
     &     recl=record_length)
c
c     Loop through subprocesses filling up scratch file with events
c
      sum=0d0
      kevent=0
      revent=0
      maxwgt=0d0
      write(*,*) 'SubProcess/Channel     kept   read   xsec '

C $B$ down_path $B$ !this is tag for automatic modification by MW
      down_path=''
c $E$ down_path $E$ !this is tag for automatic modification by MW
      do i=1,ns
c         write(*,*) 'Subprocess: ',subname(ns)
         pos3=index(subname(i),' ')
         pathsubname(i)=subname(i)(1:pos3-1)//down_path
         call read_channels(pathsubname(i),sum,kevent,revent,goal_wgt,maxwgt)
      enddo 
c
c     Get Random order for events
c
      do i=1,kevent
         iarray(i)=i
         xarray(i)=xran1(jseed)
      enddo
      call sortO3(xarray,iarray,kevent)
c
c     Write out the events in iarray order
c
C $B$ output_file1 $B$ !this is tag for automatic modification by MW
      filename='../Events/events.lhe'
C $E$ output_file1 $E$ !this is tag for automatic modification by MW

      open(unit=15,file=filename,status='unknown',err=98)
      call writebanner(15,kevent,rxsec,maxwgt,xsec/kevent,xerr)
      do i=1,kevent
            read(sfnum,rec=iarray(i)) wgt,n,
     &           ((ic(m,j),j=1,maxexternal),m=1,7),ievent,
     &           ((p(m,j),m=0,4),j=1,maxexternal),sscale,aqcd,aqed,
     &           buff,(s_buff(j),j=1,7),(buffclus(j),j=1,max_particles),
     &           bias_weight
            if(bias_weight.ne.1d0) impact_xsec=.false.
c     Systematics info on/off
         if(s_buff(1)(1:7).eq.'<mgrwt>') then
            u_syst=.true.
         else
            u_syst=.false.
         endif
c        Find nclus
         nclus=max_particles
         do j=1,max_particles
            if(buffclus(j).eq.' ')then
               nclus=j-1
               exit
            elseif(buffclus(j).eq.'</clustering>') then
               nclus=j
               exit
            endif
         enddo
         call write_event(15,P,wgt,n,ic,ievent,sscale,aqcd,aqed,buff,
     $        u_syst,s_buff,nclus,buffclus)
      enddo
      close(15)
c
c     Now select unweighted events.
c
      goal_wgt = sum/(nreq*1.03)
      min_goal = goal_wgt/5d0
      max_goal = goal_wgt*5d0
      ntry = 1
c
c     Loop to refine guess for goal_wgt while keeping xtrunc<0.01
c
      done=.false.
      do while(.not. done)
         done=.true.
         nunwgt=0
         xtrunc=0d0
         do i=1,kevent
            read(sfnum,rec=iarray(i)) wgt,n,
     &           ((ic(m,j),j=1,maxexternal),m=1,7),ievent,
     &           ((p(m,j),m=0,4),j=1,maxexternal),sscale,aqcd,aqed,
     &        buff       
            if (dabs(wgt) .gt. goal_wgt*xran1(jseed)) then
               keep(i) = .true.
               if (wgt.lt.0d0) has_negative = .true.
               nunwgt=nunwgt+1
               if (dabs(wgt) .gt. goal_wgt) then
                  xtrunc=xtrunc+dabs(wgt)-goal_wgt
               endif
            else
               keep(i)=.false.
            endif
         enddo
         if (xtrunc .gt. 0.01d0*sum) then
            done=.false.
            min_goal = max(goal_wgt,min_goal)
            goal_wgt = goal_wgt*1.3d0            
            write(*,*) 'Iteration ',ntry, ' too large truncation ',xtrunc/sum,nunwgt
c            write(*,*) min_goal,goal_wgt,max_goal
         elseif (nunwgt .lt. nreq) then
            done=.false.
            max_goal = min(goal_wgt,max_goal)
            goal_wgt = goal_wgt*0.95d0
            write(*,*) 'Iteration ',ntry, ' too few events ',xtrunc/sum,nunwgt
c            write(*,*) min_goal,goal_wgt,max_goal
            if (goal_wgt .lt. min_goal) then
               done=.true.
               write(*,*) 'Failed to find requested number ',
     $              'of unweighted events',nreq,nunwgt
            endif
         endif
         ntry=ntry+1
         if (ntry .gt. 20) done=.true.
      enddo
      if (nunwgt .lt. nreq) then
         write(*,*) 'Unable to get ',nreq,' events. Writing ',nunwgt
         nreq = nunwgt
      else
         write(*,*) 'Found ',nunwgt,' events writing first ',nreq
      endif
      write(*,*) 'Unweighting selected ',nreq, ' events.'
      write(*,'(a,f5.2,a)') 'Truncated ',xtrunc*100./sum,
     $     '% of cross section'

C $B$ output_file2 $B$ !this is tag for automatic modification by MW
      filename='../Events/unweighted_events.lhe'
C $E$ output_file2 $E$ !this is tag for automatic modification by MW

      open(unit=15,file=filename,status='unknown',err=99)
      call writebanner_u(15,nreq,rxsec,xtrunc,xsec/nreq,xerr, has_negative)
      ntry = 0
      do i=1,kevent
         if (keep(i) .and. ntry .lt. nreq) then
            read(sfnum,rec=iarray(i)) wgt,n,
     &           ((ic(m,j),j=1,maxexternal),m=1,7),ievent,
     &           ((p(m,j),m=0,4),j=1,maxexternal),sscale,aqcd,aqed,
     &           buff,(s_buff(j),j=1,7),(buffclus(j),j=1,max_particles),
     &           bias_weight
            wgt=dsign(xsec/nreq,wgt)
c     Systematics info on/off
            if(s_buff(1)(1:7).eq.'<mgrwt>') then
               u_syst=.true.
            else
               u_syst=.false.
            endif
c        Find nclus
            do j=1,max_particles
               if(buffclus(j).eq.' ')then
                  nclus=j-1
                  exit
               elseif(buffclus(j).eq.'</clustering>') then
                  nclus=j
                  exit
               endif
            enddo
            call write_event(15,P,wgt,n,ic,ievent,sscale,aqcd,aqed,
     $           buff,u_syst,s_buff,nclus,buffclus)
            ntry=ntry+1
         endif
      enddo
      close(15)
      close(sfnum)
      goto 1000
 98   write(*,*) 'Error writing events.dat' 
      goto 1000
 99   write(*,*) 'Error writing unweighted_events.dat' 
      goto 1000
 999  write(*,*) 'Error opening scratch file'
 1000 continue
      end


      subroutine writebanner(lunw,nevent,sum,maxwgt,wgt,xerr)
c**************************************************************************************
c     Writes out banner information at top of event file
c**************************************************************************************
      implicit none
c
c     Arguments
c     
      integer lunw,nevent
      double precision sum,maxwgt,wgt,xerr
c
c     Local
c
      integer i,j

c
c     Information required for 1>N processes
c
      include 'nexternal.inc'

c
c     Les Houches init block (for the <init> info)
c
      integer maxpup
      parameter(maxpup=2)
      integer idbmup,pdfgup,pdfsup,idwtup,nprup,lprup
      double precision ebmup,xsecup,xerrup,xmaxup
      common /heprup/ idbmup(2),ebmup(2),pdfgup(2),pdfsup(2),
     &     idwtup,nprup,xsecup(maxpup),xerrup(maxpup),
     &     xmaxup(maxpup),lprup(maxpup)

c
c     Global
c
c      double precision etmin(3:nexternal),etamax(3:nexternal)
c      double precision                    r2min(3:nexternal,3:nexternal)
c      double precision s_min(nexternal,nexternal)
c      common/to_cuts/  etmin     ,etamax     , r2min, s_min

c-----
c  Begin Code
c-----
c
c     gather the info
c
c      call setpara('param_card.dat')
c      call setcuts
c
c     write it out
c
c      call write_para(lunw)
c      write(lunw,'(a70)') '##                                                                    '
c      write(lunw,'(a70)') '##-------------------                                                 '
c      write(lunw,'(a70)') '## Run-time options                                                   '
c      write(lunw,'(a70)') '##-------------------                                                 '
c      write(lunw,'(a70)') '##                                                                    '
c     write(lunw,'(a70)') '##********************************************************************'     
c     write(lunw,'(a70)') '## Standard Cuts                                                     *'
c     write(lunw,'(a70)') '##********************************************************************'    
c      write(lunw,'(a13,8i8)')   '## Particle  ',(i,i=3,nexternal)
c      write(lunw,'(a13,8f8.1)') '## Et       >',(etmin(i),i=3,nexternal)
c      write(lunw,'(a13,8f8.1)') '## Eta      <',(etamax(i),i=3,nexternal)
c      do j=3,nexternal-1
c         write(lunw,'(a,i2,a,8f8.1)') '## d R #',j,'  >',(-0.0,i=3,j),
c     &        (r2min(i,j),i=j+1,nexternal)
c         do i=j+1,nexternal
c            r2min(i,j)=r2min(i,j)**2 !Since r2 returns distance squared
c         enddo
c      enddo
c      do j=3,nexternal-1
c         write(lunw,'(a,i2,a,8f8.1)') '## s min #',j,'>',
c     &        (s_min(i,j),i=3,nexternal)
c      enddo
c      write(lunw,'(a70)') '#********************************************************************'    
c
c     Now write out specific information on the event set
c
c
      write(lunw,'(a)') '<MGGenerationInfo>'
      write(lunw,'(a30,i11)')   '#  Number of Events        :  ',nevent
      write(lunw,'(a30,e11.5)') '#  Integrated weight (pb)  :  ',sum
      write(lunw,'(a30,e11.5)') '#  Max wgt                 :  ',maxwgt
      write(lunw,'(a30,e11.5)') '#  Average wgt             :  ',wgt
      write(lunw,'(a)') '</MGGenerationInfo>'

   
    

C   Write out compulsory init info
      write(lunw,'(a)') '</header>'
      write(lunw,'(a)') '<init>'
      if(nincoming.eq.2)then

          write(lunw,90) (idbmup(i),i=1,2),(ebmup(i),i=1,2),(pdfgup(i),i=1,2),
     $                   (pdfsup(i),i=1,2),2,nprup
         do i=1,nprup
             write(lunw,91) xsecup(i),xerr*xsecup(i)/sum,maxwgt,lprup(i) ! FACTOR OF nevts for maxwgt and wgt? error?
         enddo
      elseif(nincoming.eq.1)then
          write(lunw,90) (idbmup(i),i=1,2),(ebmup(i),i=1,2),-1,-1,
     $   -1,-1,2,nprup
          do i=1,nprup
             write(lunw,91) xsecup(i),xerr*xsecup(i)/sum,maxwgt,lprup(i) ! FACTOR OF nevts for maxwgt and wgt? error?
          enddo
      endif
      write(lunw,'(a)') '</init>'
 90   FORMAT(2i9,2e19.11,2i2,2i8,i2,i4)
 91   FORMAT(3e19.11,i4)
      end


      subroutine writebanner_u(lunw,nevent,sum,maxwgt,wgt,xerr,has_negative)
c**************************************************************************************
c     Writes out banner information at top of event file
c**************************************************************************************
      implicit none
c
c     Arguments
c     
      integer lunw,nevent
      double precision sum,maxwgt,wgt,xerr
      logical has_negative
c
c     Local
c
      integer i,j
      double precision tmpsum
      integer lhastrategy
c
c     Les Houches init block (for the <init> info)
c
      integer maxpup
      parameter(maxpup=2)
      integer idbmup,pdfgup,pdfsup,idwtup,nprup,lprup
      double precision ebmup,xsecup,xerrup,xmaxup
      common /heprup/ idbmup(2),ebmup(2),pdfgup(2),pdfsup(2),
     &     idwtup,nprup,xsecup(maxpup),xerrup(maxpup),
     &     xmaxup(maxpup),lprup(maxpup)

c
c     Flag on how to write the LHE events
c     Include <clustering> tag for Pythia 8 CKKW-L matching
c
      logical clusinfo
      double precision lhe_version
      COMMON/TO_LHEFORMAT/lhe_version,clusinfo
c
c     Global
c
c      double precision etmin(3:nexternal),etamax(3:nexternal)
c      double precision                    r2min(3:nexternal,3:nexternal)
c      double precision s_min(nexternal,nexternal)
c      common/to_cuts/  etmin     ,etamax     , r2min, s_min

c-----
c  Begin Code
c-----
c
c     gather the info
c
c      call setpara('param_card.dat')
c      call setcuts
c
c     write it out
c
c      call write_para(lunw)
c      write(lunw,'(a70)') '##                                                                    '
c      write(lunw,'(a70)') '##-------------------                                                 '
c      write(lunw,'(a70)') '## Run-time options                                                   '
c      write(lunw,'(a70)') '##-------------------                                                 '
c      write(lunw,'(a70)') '##                                                                    '
c     write(lunw,'(a70)') '##********************************************************************'     
c     write(lunw,'(a70)') '## Standard Cuts                                                     *'
c     write(lunw,'(a70)') '##********************************************************************'    
c      write(lunw,'(a13,8i8)')   '## Particle  ',(i,i=3,nexternal)
c      write(lunw,'(a13,8f8.1)') '## Et       >',(etmin(i),i=3,nexternal)
c      write(lunw,'(a13,8f8.1)') '## Eta      <',(etamax(i),i=3,nexternal)
c      do j=3,nexternal-1
c         write(lunw,'(a,i2,a,8f8.1)') '## d R #',j,'  >',(-0.0,i=3,j),
c     &        (r2min(i,j),i=j+1,nexternal)
c         do i=j+1,nexternal
c            r2min(i,j)=r2min(i,j)**2 !Since r2 returns distance squared
c         enddo
c      enddo
c      do j=3,nexternal-1
c         write(lunw,'(a,i2,a,8f8.1)') '## s min #',j,'>',
c     &        (s_min(i,j),i=3,nexternal)
c      enddo
c      write(lunw,'(a70)') '##********************************************************************'    
c
c     Now write out specific information on the event set
c

      write(lunw,'(a)') '<MGGenerationInfo>'
      write(lunw,'(a30,i11)')   '#  Number of Events        :  ',nevent
      write(lunw,'(a30,e11.5)') '#  Integrated weight (pb)  :  ',sum
      write(lunw,'(a30,e11.5)') '#  Truncated wgt (pb)      :  ',maxwgt
      write(lunw,'(a30,e11.5)') '#  Unit wgt                :  ',wgt
      write(lunw,'(a)') '</MGGenerationInfo>'

      if (has_negative) then
        lhastrategy = -3
      else
        lhastrategy = 3
      endif

C   Write out compulsory init info
      write(lunw,'(a)') '</header>'
      write(lunw,'(a)') '<init>'
      write(lunw,90) (idbmup(i),i=1,2),(ebmup(i),i=1,2),(pdfgup(i),i=1,2),
     $   (pdfsup(i),i=1,2),lhastrategy,nprup
      do i=1,nprup
         write(lunw,91) xsecup(i),xerr*xsecup(i)/sum,sum/nevent,lprup(i) ! FACTOR OF nevts for maxwgt and wgt? error?
      enddo
      if (lhe_version.ge.3) then
        write(lunw,'(a)') "<generator name='MadGraph5_aMC@NLO' version='X.X.X'>           "
        write(lunw,'(a)') "please cite 1405.0301 </generator>"
      endif
      write(lunw,'(a)') '</init>'
 90   FORMAT(2i9,2e19.11,2i2,2i8,i3,i4)
 91   FORMAT(3e19.11,i4)

      end


      subroutine read_channels(dir,sum,kevent,revent,goal_wgt,maxwgt)
c*****************************************************************
c     tests traversing directories to find all events
c****************************************************************
      implicit none
c
c     Constants
c
      character*(*) symfile
      parameter (symfile='symfact.dat')
      include 'maxparticles.inc'
c
c     Arguments
c
      character*(*) dir
      integer kevent,revent
      double precision sum,goal_wgt,maxwgt
c
c     Local
c
      integer i,j, k, ip
      double precision xi
      character*300 dirname,dname,channame
      integer ncode,npos
      character*20 formstr
c-----
c  Begin Code
c-----
      i = index(dir," ")
c     ncode is number of digits needed for the bw coding
      ncode=int(dlog10(3d0)*(max_particles-3))+1
      dname = dir(1:i-1)// "/" // symfile
      open(unit=35, file=dname ,status='old',err=59)
      do while (.true.)
         read(35,*,err=99,end=99) xi,j
         if (j .gt. 0) then
            j=1 ! symmetry factor already read in auto_dsig.f
            k = int(xi*(1+10**(-ncode)))
            npos=int(dlog10(dble(k)))+1
            if ( (xi-k) .eq. 0) then
c              Write with correct number of digits
               write(formstr,'(a,i1,a)') '(a,i',npos,',a)'
               write(dirname, formstr) 'G',k,'/'
            else if(npos+ncode+1.lt.10) then               !Handle B.W.
c              Write with correct number of digits
               write(formstr,'(a,i1,a,i1,a)') '(a,f',npos+ncode+1,
     $                 '.',ncode,',a)'
               write(dirname,formstr)  'G',xi,'/'
            else               !Handle B.W.
c              Write with correct number of digits
               write(formstr,'(a,i2,a,i1,a)') '(a,f',npos+ncode+1,
     $                 '.',ncode,',a)'
               write(dirname,formstr)  'G',xi,'/'
            endif     
            ip = index(dirname,'/')
            channame = dname(1:i-1)// "/" //dirname(1:ip)
            call read_dir_events(channame(1:i+ip),j,kevent,revent,sum,goal_wgt,maxwgt)
            write(*,'(a,2i8,e10.3)') channame(1:i+ip),kevent,revent,sum
         endif
 98   enddo
 99   close(35)
      return
c
c     Come here if there isn't a symfact file. Means we will work on
c     this file alone
c
 59   dirname="./"
      j = 1
      ip = 2
      channame = dirname(1:ip)
      call read_dir_events(channame,j,kevent,revent,sum,goal_wgt,maxwgt)
      write(*,'(a30,i8,e10.3)') channame(1:i+ip),kevent,sum
      return
      end

      subroutine read_dir_events(channame,nj,kevent,revent,sum,goal_wgt,maxwgt)
c********************************************************************
c********************************************************************
      implicit none
c
c     parameters
c     
      integer    sfnum
      parameter (sfnum=17)   !Unit number for scratch file
      character*(*) scaled_file
      parameter (scaled_file='events.lhe')
      include 'maxparticles.inc'
      integer    maxexternal
      parameter (maxexternal=2*max_particles-3)
      include 'run_config.inc'
      include 'run.inc'
      integer    max_read
      parameter (max_read = 5000000)
c
c     Arguments
c
      character*(*) channame
      integer nj,kevent,revent
      double precision sum,goal_wgt,maxwgt
c
c     Local
c
      double precision wgt
      double precision p(0:4,maxexternal)
      double precision gsfact
      real xwgt(max_read),xtot
      integer i,j,k,m, ic(7,maxexternal),n
      double precision sscale,aqcd,aqed,tmpsum
      integer ievent,jseed
      logical done,found
      character*1000 buff
      logical u_syst
      character*(s_bufflen) s_buff(7)
      character*300 fullname
      integer nclus
      character*(clus_bufflen) buffclus(max_particles)
      data buffclus/max_particles*' '/
c
      double precision bias_weight
      logical impact_xsec
      common/bias/bias_weight,impact_xsec
c
c     Les Houches init block (for the <init> info)
c
      integer maxpup
      parameter(maxpup=2)
      integer idbmup,pdfgup,pdfsup,idwtup,nprup,lprup
      double precision ebmup,xsecup,xerrup,xmaxup
      common /heprup/ idbmup(2),ebmup(2),pdfgup(2),pdfsup(2),
     &     idwtup,nprup,xsecup(maxpup),xerrup(maxpup),
     &     xmaxup(maxpup),lprup(maxpup)
      data nprup/0/
      data xsecup/maxpup*0d0/
c
c     external
c
      real xran1
c
c     data
c
      data jseed/-1/
c-----
c  Begin Code
c-----     
      fullname = channame // "gscalefact.dat"
      gsfact = 1d0
      open (unit=15,file=fullname,status='old',err=12)
      read(15,*) gsfact    !Scale factor for grid runs that only use some channels
 12   close(15)
      if (gsfact .eq. 0d0) return
      fullname = channame // scaled_file      
      open(unit=15,file=fullname, status='old',err=999)
      done=.false.
c
c     Start by initializing all event variables to zero (not really necessary)
c
      do j=1,maxexternal
         do i=1,7
            ic(i,j)=0
         enddo
         do i=0,4
            p(i,j) = 0d0
         enddo
      enddo
c
c     Now loop through events
c
      do while (.not. done)
         call read_event(15,P,wgt,n,ic,ievent,sscale,aqcd,aqed,buff,
     $        u_syst,s_buff,nclus,buffclus,done)
         if (.not. done) then
            revent = revent+1
            wgt = wgt*nj*gsfact                 !symmetry factor * grid factor
            if (dabs(wgt) .gt. maxwgt) maxwgt=dabs(wgt)
            if (dabs(wgt) .ge. goal_wgt*xran1(jseed)) then
               kevent=kevent+1
               if (dabs(wgt) .lt. goal_wgt) wgt = dsign(goal_wgt,wgt)
               write(sfnum,rec=kevent) wgt,n,
     &           ((ic(m,j),j=1,maxexternal),m=1,7),ievent,
     &           ((p(m,j),m=0,4),j=1,maxexternal),sscale,aqcd,aqed,
     &           buff,(s_buff(j),j=1,7),(buffclus(j),j=1,max_particles),
     &           bias_weight
               sum=sum+dabs(wgt)
               found=.false.
               do i=1,nprup
                  if(ievent.eq.lprup(i))then
                     xsecup(i)=xsecup(i)+wgt
                     found=.true.
                  endif
               enddo
               if(.not.found)then
                  nprup=nprup+1
                  lprup(nprup)=ievent
                  xsecup(nprup)=wgt
               endif
            endif
         endif
         if (kevent .ge. max_read) then
            write(*,*) 'Error too many events to read in combine_events',
     $           kevent
            write(*,*) 'Increase cmax_events and max_read in ',
     $                 'Source/combine_events.f'
            stop
         endif
      enddo
 99   close(15)
 55   format(i3,4e19.11)         
c      write(*,*) 'Found ',kevent,' events'
c      write(*,*) 'Integrated weight',sum
      return
 999  write(*,*) 'Error opening file ',channame,scaled_file

      end



      subroutine get_subprocess(subname,ns)
c*****************************************************************
c     tests traversing directories to find all events
c****************************************************************
      implicit none
c
c     Constants
c
      character*(*) plist
      parameter (plist='subproc.mg')
c
c     Arguments
c
      character*300 subname(*)
      integer ns
c-----
c  Begin Code
c-----
      ns = 1
      open(unit=15, file=plist,status='old',err=99)
      do while (.true.)
         read(15,*,err=999,end=999) subname(ns)
         ns=ns+1
      enddo
 99   subname(ns) = './'
      write(*,*) "Did not find ", plist
      return
 999  ns = ns-1
      write(*,*) "Found ", ns," subprocesses"
      close(15)
      end


      function xran1(idum)
      dimension r(97)
      parameter (m1=259200,ia1=7141,ic1=54773,rm1=3.8580247e-6)
      parameter (m2=134456,ia2=8121,ic2=28411,rm2=7.4373773e-6)
      parameter (m3=243000,ia3=4561,ic3=51349)
      data iff /0/
      save r, ix1,ix2,ix3
      if (idum.lt.0.or.iff.eq.0) then
        iff=1
        ix1=mod(ic1-idum,m1)
        ix1=mod(ia1*ix1+ic1,m1)
        ix2=mod(ix1,m2)
        ix1=mod(ia1*ix1+ic1,m1)
        ix3=mod(ix1,m3)
        do 11 j=1,97
          ix1=mod(ia1*ix1+ic1,m1)
          ix2=mod(ia2*ix2+ic2,m2)
          r(j)=(float(ix1)+float(ix2)*rm2)*rm1
11      continue
        idum=1
      endif
      ix1=mod(ia1*ix1+ic1,m1)
      ix2=mod(ia2*ix2+ic2,m2)
      ix3=mod(ia3*ix3+ic3,m3)
      j=1+(97*ix3)/m3
      if(j.gt.97.or.j.lt.1)then
         write(*,*) 'j is bad in ran1.f',j, 97d0*ix3/m3
         STOP
      endif
      xran1=r(j)
      r(j)=(float(ix1)+float(ix2)*rm2)*rm1
      return
      end


      subroutine sort2(array,aux1,n)
      implicit none
! Arguments
      integer n
      integer aux1(n)
      double precision array(n)
!  Local Variables
      integer i,k
      double precision temp
      logical done

!-----------
! Begin Code
!-----------
      do i=n-1,1,-1
         done = .true.
         do k=1,i
            if (array(k) .lt. array(k+1)) then
               temp = array(k)
               array(k) = array(k+1)
               array(k+1) = temp
               temp = aux1(k)
               aux1(k) = aux1(k+1)
               aux1(k+1) = temp
               done = .false.
            end if
         end do
         if (done) return
      end do
      end 

      subroutine sortO3(array,aux1,n)

c   O-Sort Version 3, Sorting routine by Erik Oosterwal
c   http://www.geocities.com/oosterwal/computer/sortroutines.html

      implicit none

! Arguments
      integer n
      integer aux1(n)
      double precision array(n)
!  Local Variables
      integer step,i,itemp
      double precision SngPhi,SngFib

      SngPhi = 0.78             ! Define phi value
      SngFib = n * SngPhi       ! Set initial real step size
      step = int(SngFib)        ! set initial integer step size

      do while (step > 0)
        do i = 1,n-step         ! Set the range of the lower search cells
          if (array(aux1(i))<array(aux1(i+step))) then ! Compare cells
            itemp = aux1(i)     !                       \
            aux1(i) = aux1(i+step) !                     | Swap cells
            aux1(i+step) = itemp !                      /
          end if
        enddo
        
        SngFib = SngFib * SngPhi ! Decrease the Real step size
        Step = Int(SngFib)      ! Set the integer step value

      enddo

      end

      program gen_ximprove
c*****************************************************************************
c     Program to combine results from all of the different sub amplitudes 
c     and given total  cross section and error.
c*****************************************************************************
      implicit none
c
c     Constants
c
      character*(*) rfile
      parameter (rfile='results.dat')
      character*(*) symfile
      parameter (symfile='symfact.dat')

      include 'maxparticles.inc'
      include 'run_config.inc'
      include 'maxconfigs.inc'
c
c     global
c
      integer max_np,min_iter
      common/max_np/max_np,min_iter

c
c     local
c
      double precision xsec(lmaxconfigs), xerr(lmaxconfigs)
      double precision xerru(lmaxconfigs),xerrc(lmaxconfigs)
      double precision xmax(lmaxconfigs), eff(lmaxconfigs)
      double precision xlum(lmaxconfigs)
      double precision ysec, yerr, yeff, ymax
      double precision tsec, terr, teff, tmax, xi
      integer nw(lmaxconfigs), nevents(lmaxconfigs), maxit
      integer nunwgt(lmaxconfigs)
      character*80 fname, gname(lmaxconfigs)
      integer i,j,k,l,n,ipp
      double precision xtot,errtot,err_goal
      double precision errtotu,errtotc
      integer mfact(lmaxconfigs)
      logical parallel, gen_events
      character*20 param(maxpara),value(maxpara)
      integer npara, nreq, ngran, nhel_refine
      integer ij, kl, ioffset
      integer*8 iseed     !tjs 20/6/2012 to avoid integer overflow
      logical Gridpack,gridrun
      logical split_channels
      common /to_split/split_channels
      integer ncode,npos
      character*20 formstr
      logical file_exists
      character*30 filename

c-----
c  Begin Code
c-----
      call load_para(npara,param,value)
      call get_logical(npara,param,value," gridpack ",gridpack,.false.)
      call get_integer(npara,param,value," nhel ",nhel_refine,0)
c     If different card options set for nhel_refine and nhel_survey:
      call get_integer(npara,param,value," nhel_refine ",nhel_refine,
     $     1*nhel_refine)
      if (.not. Gridpack) then
         write(*,'(a,a)')'Enter fractional accuracy (<1)',
     &        ', or number events (>1), max processes per job',
     &        ', and whether to split channels (T/F)'
         read(5,*) err_goal, max_np, split_channels
         min_iter=3
         parallel = .false.
         if (err_goal .lt. 1) then
            write(*,'(a,f8.2,a)') 'Running for accuracy of ',
     $           err_goal*100,'%'
            gen_events=.false.         
         elseif (err_goal .gt. 1) then
            write(*,'(a,f9.0,a)') 'Generating ',err_goal,
     &           ' unweighted events.'
            gen_events=.true.         
            err_goal = err_goal * 1.2 !Extra factor to ensure works
         else
            write(*,*) 'Error, need non_zero goal'
            stop
         endif
      else
         gen_events=.true.
         split_channels=.false.
c        Allow all the way down to a single iteration for gridruns
         min_iter=1
         call get_integer(npara,param,value," gevents "  ,nreq  ,2000   )
         err_goal = 1.2*nreq ! extra factor to ensure works
         call get_int8(npara,param,value," gseed "  ,iseed  ,4321   )
         call get_integer(npara,param,value," ngran "  ,ngran  , -1)
         if (ngran.eq.-1) ngran = 1
         write(*,*) "Running on Grid to generate ",nreq," events"
         write(*,*) "   with granularity equal to ",ngran
c
c     TJS 3/13/2008
c     Modified to allow for more sequences
c     iseed can be between 0 and 30081*30081
c     before patern repeats
c     JA 11/2/2011: Check for ioffset, as in ntuple (ranmar.f)
c     TJS  20/6/2012 changed mod value to 30081 to avoid duplicate sequences
c
         call get_offset(ioffset)
         iseed = iseed * 31300       
         ij=1802 + mod(iseed,30081)      
         kl=9373 + (iseed/30081) + ioffset
         write(*,'($a,i6,a3,i6)') 'Using random seed offset: ',ioffset
         write(*,*) ' with seed', iseed
         do while (ij .gt. 31328)
            ij = ij - 31328
         enddo
         do while (kl .gt. 30081)
            kl = kl - 30081
         enddo
         write(*,*) "Using random seeds",ij,kl
        call rmarin(ij,kl)
      endif
      open(unit=15,file=symfile,status='old',err=999)
      errtot=0d0
      errtotu=0d0
      errtotc=0d0
      xtot = 0d0
      i = 0
c     ncode is number of digits needed for the bw coding
      ncode=int(dlog10(3d0)*(max_particles-3))+1
      do while (.true.)
         read(15,*,err=99,end=99) xi,j
         if (j .gt. 0) then
            i = i+1
            k = int(xi*(1+10**(-ncode)))
            npos=int(dlog10(dble(k)))+1
            if ( (xi-k) .eq. 0) then
c              Write with correct number of digits
               write(formstr,'(a,i1,a)') '(a,i',npos,',a,a)'
               write(fname, formstr) 'G',k,'/',rfile
            else               !Handle B.W.
c              Write with correct number of digits
               write(formstr,'(a,i1,a,i1,a)') '(a,f',npos+ncode+1,
     $                 '.',ncode,',a,a)'
               write(fname, formstr) 'G',xi,'/',rfile
            endif
c              write(*,*) 'log name ',fname
         endif
         if (j .gt. 0) then
            gname(i)=fname
            nevents(i)=0d0
            xsec(i)=0d0
            xerr(i)=0d0
            nw(i)  =0d0
            mfact(i)=j

c
c     Read in integration data from run
c
            open(unit=25,file=fname,status='old',err=95)
            read(25,*,err=94,end=94) xsec(i),xerru(i),xerrc(i),nevents(i),nw(i),maxit,
     &           nunwgt(i),xlum(i)
            if (xsec(i) .eq. 0d0) xlum(i)=1d99     !zero cross section
            xlum(i) = xlum(i)/1000   !convert to fb^-1 
            xerr(i)=sqrt(xerru(i)**2+xerrc(i)**2)
            if (.false.) then
c            maxit = 2
               tmax = -1d0
               terr = 0d0
               teff = 0d0
               tsec = 0d0
               do k=1,maxit
                  read(25,*,err=92) l,ysec,yerr,yeff,ymax
                  if (k .gt. 1) tmax = max(tmax,ymax)
                  tsec = tsec + ysec
                  terr = terr +yerr**2
                  teff = teff + yeff
               enddo
 92            maxit = k-1      !In case of error reading file
               xsec(i)=tsec/maxit
               xerr(i)=sqrt(terr)/maxit
               xmax(i)=tmax/xsec(i)
            endif
c            tmax
            xmax(i) = -1d0
            xsec(i) = xsec(i)*mfact(i)
            xerr(i) = xerr(i)*mfact(i)
            xerru(i) = xerru(i)*mfact(i)
            xerrc(i) = xerrc(i)*mfact(i)
            xlum(i) = xlum(i)/mfact(i)
            xtot = xtot+ xsec(i)
            eff(i)= xerr(i)*sqrt(real(nevents(i)))/(xsec(i)+1d-99)
            errtotu = errtotu+(xerru(i))**2
            errtotc = errtotc+(xerrc(i))
c            xtot = xtot+ xsec(i)*mfact(i)
c            eff(i)= xerr(i)*sqrt(real(nevents(i)))/xsec(i)
c            errtot = errtot+(mfact(i)*xerr(i))**2
            goto 95
 94         continue
c        There was an error reading an existing results.dat file
c        Stop generation with error message
            filename='../../error'
            INQUIRE(FILE="../../RunWeb", EXIST=file_exists)
            if(.not.file_exists) filename = '../' // filename
            open(unit=26,file=filename,status='unknown')
            write(26,*) 'Bad results.dat file for channel ',xi
 95         close(25)
c            write(*,*) i,maxit,xsec(i), eff(i)
         else
c            i=i-1   !This is for case w/ B.W. and optimization
         endif
      enddo
 99   close(15)
      errtot=sqrt(errtotc**2+errtotu)
      if ( .not. gen_events) then
         call write_bash(xsec,xerru,xerrc,xtot,mfact,err_goal,
     $        i,nevents,gname,nhel_refine)
      else
         open(unit=25,file='../results.dat',status='old',err=199)
         read(25,*) xtot
         write(*,'(a,e12.3)') 'Reading total xsection ',xtot
 199     close(25)
         if (gridpack) then
            call write_gen_grid(err_goal,dble(ngran),i,nevents,gname,
     $           xlum,xtot,mfact,xsec,nhel_refine)
         else
            call write_gen(err_goal,i,nevents,gname,xlum,xtot,mfact,
     $           xsec,xerr,nhel_refine)
         endif
      endif
      stop
 999  write(*,*) 'error'
      end


      subroutine write_bash(xsec,xerru,xerrc,xtot,
     $     mfact,err_goal,ng,jpoints,gn,nhel_refine)
c*****************************************************************************
c     Writes out bash commands for running each channel as needed.
c*****************************************************************************
      implicit none
c
c     Constants
c
      include 'maxparticles.inc'
      include 'run_config.inc'
      include 'maxconfigs.inc'

c      integer    max_np
c      parameter (max_np = 30)
c
c     global
c
      integer max_np,min_iter
      common/max_np/max_np,min_iter
c
c     Arguments
c
      double precision xsec(lmaxconfigs), xerru(lmaxconfigs),xerrc(lmaxconfigs)
      double precision err_goal,xtot
      integer mfact(lmaxconfigs),jpoints(lmaxconfigs),nhel_refine
      integer ng
      character*(80) gn(lmaxconfigs)
c
c     Local
c
      integer i,j,k, io(lmaxconfigs), npoints, ip, np
      double precision xt(lmaxconfigs),elimit
      double precision yerr,ysec,rerr
      logical fopened

c-----
c  Begin Code
c-----
      fopened = .false.
      k=0
      do j=1,ng
         if (mfact(j) .gt. 0) k=k+1
         io(j) = j
         xt(j)= sqrt((xerru(j)+xerrc(j)**2)*mfact(j))     !sort by error
      enddo
c
c     Let's redetermine err_goal based on luminosity
c
      write(*,*) 'Cross section pb',xtot
      write(*,*) 'Desired Goal',err_goal      
      write(*,*) 'Total Error',err_goal
c      elimit = err_goal*xtot/sqrt(real(k)) !Equal contributions from each
      elimit = err_goal*xtot/real(k) !Equal contributions from each

      call sort2(xt,io,ng)
      k=1
      xt(ng+1) = 0
      do while( xt(k) .gt. abs(elimit))  !abs is just in case elimit<0 by mistake
         k=k+1
      enddo
      k=k-1
      rerr=0d0
      do j=k+1,ng
c         rerr = rerr+xt(j)**2
         rerr = rerr+xt(j)
      enddo
      rerr=rerr**2
c      write(*,*) 'Number of diagrams to fix',k
c
c     Now readjust because most don't contribute
c
      elimit = sqrt((err_goal*xtot)**2 - rerr)/sqrt(real(k))

      
      np = max_np
      do i=1,k

c         yerr = xerr(io(i))*mfact(io(i))
         yerr = xt(i)
c         write(*,*) i,xt(i),elimit
         if (yerr .gt. elimit) then

         ysec = xsec(io(i)) + yerr
         npoints=(0.2d0)*jpoints(io(i))*(yerr/elimit)**2
         npoints = max(npoints,min_events)
         npoints = min(npoints,max_events)
c         np = np + 3*npoints
         np = np +1
         if (np .gt. max_np) then
            if (fopened) then
               call close_bash_file(26)
            endif
            fopened=.true.
            call open_bash_file(26)
c            np = 3*npoints
            np = 1
         endif

         ip = index(gn(io(i)),'/')
         write(*,*) 'Channel ',gn(io(i))(2:ip-1),
     $        yerr, jpoints(io(i)),npoints

         ip = index(gn(io(i)),'/')
         write(26,'(2a)') 'j=',gn(io(i))(1:ip-1)
c
c     Determine estimates for getting the desired accuracy
c

c
c     Now write the commands
c      
         write(26,20) 'if [[ ! -e $j ]]; then'
         write(26,25) 'mkdir $j'
         write(26,20) 'fi'
         write(26,20) 'cd $j'
         write(26,20) 'rm -f $k'
c         write(26,20) 'rm -f moffset.dat'

         write(26,'(5x,a,3i8,a)') 'echo "',npoints,max_iter,min_iter,
     $        '" >& input_sg.txt' 
         write(26,'(5x,a,f8.3,a)') 'echo "',max(elimit/ysec,0.001d0),
     $        '" >> input_sg.txt'
         write(26,'(5x,a)') 'echo "2" >> input_sg.txt'  !Grid
         write(26,'(5x,a)') 'echo "1" >> input_sg.txt'  !Suppress
         write(26,'(5x,a,i4,a)') 'echo "',nhel_refine,
     &        '"  >> input_sg.txt' !Helicity 
         write(26,'(5x,3a)')'echo "',gn(io(i))(2:ip-1),
     $        '" >>input_sg.txt'
      write(26,20) 'for((try=1;try<=16;try+=1)); '
      write(26,20) 'do'
         write(26,20) '../madevent >> $k <input_sg.txt'
         write(26,25) 'if [ -s $k ]'
         write(26,25) 'then'
         write(26,25) '    break'
         write(26,25) 'else'
         write(26,25) '    echo $try > fail.log '
         write(26,25) 'fi'
         write(26,25) 'done'
         write(26,20) 'rm ftn25 ftn26'
         write(26,20) 'cat $k >> log.txt'
         write(26,20) 'echo "" >> $k; echo "ls status:" >> $k; ls >> $k'
         write(26,20) 'cd ../'
      endif
      enddo  !Loop over diagrams
      if (fopened) then
         call close_bash_file(26)
      endif
      fopened=.false.
 15   format(a)
 20   format(5x,a)
 25   format(10x,a)
 999  close(26)
      end


      subroutine open_bash_file(lun)
c***********************************************************************
c     Opens bash file for looping including standard header info
c     which can be used with pbs, or stand alone
c***********************************************************************
      implicit none
c
c     Constants
c
      include 'maxparticles.inc'
      include 'run_config.inc'
c
c     Arguments
c
      integer lun
c
c     local
c
      character*30 fname
      integer ic, npos
      character*10 formstr

      data ic/0/
c-----
c  Begin Code
c-----
      ic=ic+1
      fname='ajob'
c     Write ic with correct number of digits
      npos=int(dlog10(dble(ic)))+1
      write(formstr,'(a,i1,a)') '(I',npos,')'
      write(fname(5:(5+npos-1)),formstr) ic

      write(*,*) 'Opening file ',fname
      open (unit=26, file = fname, status='unknown')
      write(26,15) '#!/bin/bash'
c      write(26,15) '#PBS -q ' // PBS_QUE
c      write(26,15) '#PBS -o /dev/null'
c      write(26,15) '#PBS -e /dev/null'
c      write(26,15) 'if [[ "$PBS_O_WORKDIR" != "" ]]; then' 
c      write(26,15) '    cd $PBS_O_WORKDIR'
c      write(26,15) 'fi'
      write(26,15) 'if [[ -e MadLoop5_resources.tar.gz && ! -e MadLoop5_resources ]]; then'
      write(26,15) 'tar -xzf MadLoop5_resources.tar.gz'
      write(26,15) 'fi'

      write(26,15) 'k=run1_app.log'
      write(lun,15) 'script=' // fname
c      write(lun,15) 'rm -f wait.$script >& /dev/null'
c      write(lun,15) 'touch run.$script'
 15   format(a)
      end

      subroutine close_bash_file(lun)
c***********************************************************************
c     Closes bash file
c***********************************************************************
      implicit none
c
c     Constants
c
c
c     Arguments
c
      integer lun
c
c     local
c
      character*30 fname
      integer ic

      data ic/0/
c-----
c  Begin Code
c-----

c      write(lun,'(a)') ')'
c
c     Now write the commands
c      
c      write(lun,20) 'j=G$i'
c      write(lun,20) 'if (! -e $j) then'
c      write(lun,25) 'mkdir $j'
c      write(lun,20) 'endif'
c      write(lun,20) 'cd $j'
c      write(lun,20) 'rm -f ftn25 ftn99'
c      write(lun,20) 'rm -f $k'
c      write(lun,20) 'cat ../input_app.txt >& input_app.txt'
c      write(lun,20) 'echo $i >> input_app.txt'
c      if (.false.) then
c         write(lun,20) 'cp ../../public.sh .'
c         write(lun,20) 'qsub -N $1$i public.sh >> ../../running_jobs'
c      else
c         write(lun,20) '../madevent > $k <input_app.txt'
c         write(lun,20) 'rm -f ftn25 ftn99'
c         write(lun,20) 'cp $k log.txt'
c      endif
c      write(lun,20) 'cd ../'
c      write(lun,15) 'end'
c      write(lun,15) 'rm -f run.$script >&/dev/null'
c      write(lun,15) 'touch done.$script >&/dev/null'
 15   format(a)
 20   format(5x,a)
 25   format(10x,a)
      close(lun)
      end



      subroutine write_gen(goal_lum,ng,jpoints,gn,xlum,xtot,mfact,xsec,
     $     xerr,nhel_refine)
c*****************************************************************************
c     Writes out scripts for achieving unweighted event goals
c*****************************************************************************
      implicit none
c
c     Constants
c
      include 'maxparticles.inc'
      include 'run_config.inc'
      include 'maxconfigs.inc'
c
c     global
c
      integer max_np,min_iter
      common/max_np/max_np,min_iter
c      integer    max_np     !now set in run_config.inc
c      parameter (max_np = 5)  !number of channels/job

c
c     Arguments
c
      double precision goal_lum, xlum(lmaxconfigs), xsec(lmaxconfigs),xtot
      double precision xerr(lmaxconfigs)
      integer jpoints(lmaxconfigs), mfact(lmaxconfigs)
      integer ng, np, nhel_refine
      character*(80) gn(lmaxconfigs)
c
c     Local
c
      integer i,j,k,kk, io(lmaxconfigs), npoints, ip, nfiles,ifile,npfile
      double precision xt(lmaxconfigs+1),elimit
      double precision yerr,ysec,rerr
      logical fopened
      character*26 cjobs
      integer mjobs,ijob,jc
      character*150 fname

      logical split_channels
      common /to_split/split_channels

      data cjobs/"abcdefghijklmnopqrstuvwxyz"/

c-----
c  Begin Code
c-----
      fopened=.false.
      write(*,*) 'Working on creating ', goal_lum, ' events.'
      goal_lum = goal_lum/(xtot*1000) !Goal luminosity in fb^-1
      write(*,*) 'Effective Luminosity', goal_lum, ' fb^-1.'
      k=0
      do j=1,ng
         io(j) = j
         xt(j)= goal_lum/(xlum(j)+1d-99)       !sort by events_needed/have.
         write(*,*) j,xlum(j),xt(j)
      enddo
c      write(*,*) 'Number of channels',ng,k

c    Reset multijob.dat for all channels
      do j=1,ng
        jc = index(gn(j),"/")
        fname = gn(j)(1:jc)// "multijob.dat"
        write(*,*) 'Resetting ' // fname
        open(unit=15,file=fname,status="unknown",err=10)
        write(15,*) 0
 10     close(15)
      enddo
c
c     Let's redetermine err_goal based on luminosity
c
      elimit = 1d0
      call sort2(xt,io,ng)
      k=1
      xt(ng+1) = 0
      do while( xt(k) .gt. abs(elimit)) !elimit should be >0
         write(*,*) 'Improving ',k,gn(io(k)),xt(k)
         k=k+1
      enddo
      kk=k
c     Check error for the rest of the channels - rerun if 
c     bigger than channel xsec and bigger than 1% of largest channel
      do while( kk .le. ng)
         if (xerr(io(kk)).gt.max(xsec(io(kk)),0.01*xsec(io(1)))) then
            write(*,*) 'Improving for error ',kk,gn(io(kk)),xt(kk),xsec(io(kk)),xerr(io(kk))
            io(k)=io(kk)
            xt(k)=xt(kk)
            k=k+1
         endif
         kk=kk+1
      enddo
      k=k-1
      write(*,*) 'Number of diagrams to fix',k
c
c     Now readjust because most don't contribute
c

c      np = max_np

c
c     Want to write channels so that heaviest one (with largest error)
c     gets grouped with least heavy channels. Complicated ordering for this
c     follows. np is the present process number.
c
      nfiles = k/max_np
      if(mod(k,max_np).gt.0) nfiles=nfiles+1
      ifile  = 0
      npfile = 0
      np = 1
      

      do i=1,k
         yerr = xt(np)
         npoints=0.2*jpoints(io(np))*(yerr/elimit)
         npoints = max(npoints,min_events)
         npoints = min(npoints,max_events)

         npfile=npfile+1
c         np = nfiles*npfile+1-ifile   !Fancy order for combining channels removed 12/6/2010 by tjs
         np = i
c
c     tjs 12/5/2010
c     Add loop to allow for multiple jobs on a single channel
c
         mjobs = (goal_lum*xsec(io(np))*1000 / MaxEventsPerJob + 0.9)
c         write(*,*) "Working on Channel ",i,io(np),xt(np), goal_lum*xsec(io(np))*1000 /maxeventsperjob
         if (mjobs .gt. 130)  then
            write(*,*) 'Error in gen_ximprove.f, too many events requested ',mjobs*maxeventsperjob
            mjobs=130
         endif
         if (mjobs .lt. 1 .or. .not. split_channels)  mjobs=1
c
c        write multijob.dat file for combine_runs.f 
c
         jc = index(gn(io(np)),"/")
         fname = gn(io(np))(1:jc)// "multijob.dat"
c            write(*,*) "Writing file ", fname
         open(unit=15,file=fname,status="unknown",err=11)
         if (mjobs .gt. 1) then
           write(15,*) mjobs
         else
           write(15,*) 0
         endif
 11      close(15)
         do ijob = 1, mjobs
c---
c tjs
c---
         if (npfile .gt. max_np .or. ifile.eq.0 .or. mjobs .gt. 1) then
            if (fopened) then
               call close_bash_file(26)
            endif
            fopened=.true.
            call open_bash_file(26)
            ifile=ifile+1
            npfile=1
c            if (ijob .eq. 1)  np = ifile !Only increment once / source channel
         endif
         ip = index(gn(io(np)),'/')
         write(*,*) 'Channel ',gn(io(np))(2:ip-1),
     $        yerr, jpoints(io(np)),npoints

         ip = index(gn(io(np)),'/')
         if (mjobs .gt. 1) then

            if (ip.eq.3) then
                write(26,'(a2,a2,a,i1)') 'j=',gn(io(np))(1:ip-1),cjobs(MODULO(ijob-1,26)+1:MODULO(ijob-1,26)+1),
     &                                              ijob/26
            else if(ip.eq.4) then
                write(26,'(a2,a3,a,i1)') 'j=',gn(io(np))(1:ip-1),cjobs(MODULO(ijob-1,26)+1:MODULO(ijob-1,26)+1),
     &                                              ijob/26
            else if(ip.eq.5) then
               write(26,'(a2,a4,a,i1)') 'j=',gn(io(np))(1:ip-1),cjobs(MODULO(ijob-1,26)+1:MODULO(ijob-1,26)+1),
     &                                              ijob/26
            else if(ip.eq.6) then
               write(26,'(a2,a5,a,i1)') 'j=',gn(io(np))(1:ip-1),cjobs(MODULO(ijob-1,26)+1:MODULO(ijob-1,26)+1),
     &                                              ijob/26
           else
               stop 1
           endif
         else
             write(26,'(3a)') 'j=',gn(io(np))(1:ip-1)
         endif
c
c     Now write the commands
c      
         write(26,20) 'if [[ ! -e $j ]]; then'
         write(26,25) 'mkdir $j'
         write(26,20) 'fi'
         write(26,20) 'cd $j'
         write(26,20) 'rm -f $k'
         write(26,20) 'rm -f moffset.dat >& /dev/null'
         write(26,*) '     echo ',ijob, ' > moffset.dat'

c
c     
c
c
c     Now I'll add a check to make sure the grid has been
c     adjusted  (ftn99 or ftn25 exist)
c
         write(26,20) 'if  [[ -e ftn26 ]]; then'
         write(26,25) 'cp ftn26 ftn25'
         write(26,20) 'fi'

         write(26,20) 'if [[ ! -e ftn25 ]]; then'


         write(26,'(9x,a,3i8,a)') 'echo "',npoints,max_iter,min_iter,
     $        '" >& input_sg.txt' 
c
c     tjs 8/7/2007-JA 8/17/11 Allow stop when have enough luminocity
c
         write(*,*) "Cross section",i,io(np),xsec(io(np)),mfact(io(np))
         write(26,'(9x,a,e13.5,a)') 'echo "',-goal_lum*1000/mjobs,
     $        '" >> input_sg.txt'                       !Luminocity
         write(26,'(9x,a)') 'echo "2" >> input_sg.txt'  !Grid Adjustment
         write(26,'(9x,a)') 'echo "1" >> input_sg.txt'  !Suppression
         write(26,'(9x,a,i4,a)') 'echo "',nhel_refine,
     &        ' " >> input_sg.txt' !Helicity 0=exact
         write(26,'(9x,3a)')'echo "',gn(io(np))(2:ip-1),
     $        '" >>input_sg.txt'
         write(26,25) 'for((try=1;try<=16;try+=1)); '
         write(26,25) 'do'
         write(26,25) '../madevent >> $k <input_sg.txt'
         write(26,25) 'if [ -s $k ]'
         write(26,25) 'then'
         write(26,25) '    break'
         write(26,25) 'else'
         write(26,25) '    echo $try > fail.log '
         write(26,25) 'fi'
         write(26,25) 'done'
         write(26,20) 'echo "" >> $k; echo "ls status:" >> $k; ls >> $k'
         write(26,25) 'cat $k >> log.txt'
         write(26,25) 'if [[ -e ftn26 ]]; then'
         write(26,25) '     cp ftn26 ftn25'
         write(26,25) 'fi'
         write(26,20) 'else'

         write(26,25) 'rm -f $k'

         write(26,'(9x,a,3i8,a)') 'echo "',npoints,max_iter,min_iter,
     $        '" >& input_sg.txt' 
c
c tjs 8/7/2007-JA 8/17/11    Change to request luminocity not accuracy
c
         write(26,'(9x,a,e13.5,a)') 'echo "',-goal_lum*1000/mjobs,
     $        '" >> input_sg.txt'                       !Luminocity
c         write(26,'(9x,a,e12.3,a)') 'echo "',-goal_lum*mfact(io(np)),
c     $        '" >> input_sg.txt'
         write(26,'(9x,a)') 'echo "0" >> input_sg.txt'
         write(26,'(9x,a)') 'echo "1" >> input_sg.txt'

         write(26,'(9x,a,i4,a)') 'echo "',nhel_refine,
     &        ' " >> input_sg.txt' !Helicity 0=exact

         write(26,'(9x,3a)')'echo "',gn(io(np))(2:ip-1),
     $        '" >>input_sg.txt'


c         write(26,'(9x,a)') 'echo "1" >> input_sg.txt' !Helicity 0=exact

c         write(26,'(5x,3a)')'echo "',gn(io(np))(2:ip-1),
c     $        '" >>input_sg.txt'
c         write(26,20) 'cp ../../public_sg.sh .'
c         write(26,20) 'qsub -N $1$j public_sg.sh >> ../../running_jobs'
         write(26,25) 'if [[ -e ftn26 ]]; then'
         write(26,25) '     cp ftn26 ftn25'
         write(26,25) 'fi'
                  write(26,25) 'for((try=1;try<=16;try+=1)); '
         write(26,25) 'do'
         write(26,25) '../madevent >> $k <input_sg.txt'
         write(26,25) 'if [ -s $k ]'
         write(26,25) 'then'
         write(26,25) '    break'
         write(26,25) 'else'
         write(26,25) '    echo $try > fail.log '
         write(26,25) 'fi'
         write(26,25) 'done'
         write(26,20) 'echo "" >> $k; echo "ls status:" >> $k; ls >> $k'
         write(26,25) 'cat $k >> log.txt'
         write(26,20) 'fi'
         write(26,20) 'cd ../'
c------
c  tjs  end loop over split process   
c------
      enddo  !(ijob, split channel)         

      enddo !(k  each channel)
      if (fopened) then
         call close_bash_file(26)
      endif
c      write(26,15) 'end'
 15   format(a)
 20   format(5x,a)
 25   format(10x,a)
 999  close(26)
      end


      subroutine write_gen_grid(goal_lum,ngran,ng,jpoints,gn,xlum,xtot,mfact,xsec,nhel_refine)
c*****************************************************************************
c     Writes out scripts for achieving unweighted event goals
c*****************************************************************************
      implicit none
c
c     Constants
c
      include 'maxparticles.inc'
      include 'run_config.inc'
      include 'maxconfigs.inc'
c
c   global
c
      integer max_np,min_iter
      common/max_np/max_np,min_iter
c
c     Arguments
c
      double precision goal_lum, xlum(lmaxconfigs), xsec(lmaxconfigs),xtot
      double precision ngran   !Granularity.... min # points from channel
      integer jpoints(lmaxconfigs), mfact(lmaxconfigs)
      integer ng, np, nhel_refine
      character*(80) gn(lmaxconfigs)
c
c     Local
c
      integer i,j,k, npoints, ip
      double precision xt(lmaxconfigs),elimit
      double precision yerr,ysec,rerr
      character*72 fname
      logical fopened
      double precision rvec
c-----
c  Begin Code
c-----

c      data ngran /10/
      fopened=.false.
c
c     These random #'s should be changed w/ run
c
c      ij=2134
c      kl = 4321
      rvec=0d0
      write(*,*) 'Working on creating ', goal_lum, ' events.'
      max_np = 1
      np = max_np   !Flag to open csh file
      do i=1,ng
         call ranmar(rvec)
         ip = index(gn(i),'/')
         fname = gn(i)(1:ip) // 'gscalefact.dat'
         open(unit=27,file=fname,status='unknown',err=91)
         if (goal_lum * xsec(i)/xtot  .ge. rvec*ngran ) then !need events
            write(*,*) 'Requesting events from ',gn(i)(1:ip-1),xsec(i),xtot/goal_lum
            if (xsec(i) .gt. xtot*ngran/goal_lum) then
               write(27,*) 1d0
            else
               write(27,*) xtot*ngran/xsec(i)/goal_lum
            endif
            npoints = goal_lum * xsec(i) / xtot
            if (npoints .lt. ngran) npoints = ngran
            np = np+1
            if (np .gt. max_np) then
               if (fopened) then
                  call close_bash_file(26)
               endif
               fopened=.true.
               call open_bash_file(26)
               np = 1
            endif
            ip = index(gn(i),'/')
            write(*,*) 'Channel ',gn(i)(2:ip-1), goal_lum * xsec(i) / xtot,
     $           npoints

            ip = index(gn(i),'/')
            write(26,'(2a)') 'j=',gn(i)(1:ip-1)
c
c           Now write the commands
c      
            write(26,20) 'if [[ ! -e $j ]]; then'
            write(26,25) 'mkdir $j'
            write(26,20) 'fi'
            write(26,20) 'cd $j'
            write(26,20) 'rm -f $k'
c
c     Now I'll add a check to make sure the grid has been
c     adjusted  (ftn99 or ftn25 exist)
c
            write(26,20) 'if  [[ -e ftn26 ]]; then'
            write(26,25) 'cp ftn26 ftn25'
            write(26,20) 'fi'

            write(26,20) 'if [[ ! -e ftn25 ]]; then'


            write(26,'(9x,a,3i8,a)') 'echo "',max(npoints,min_events),
     $           max_iter,min_iter,'" >& input_sg.txt' 
c
c     tjs 8/7/2007  Allow stop when have enough events
c
            write(*,*) "Cross section",i,xsec(i),mfact(i)
            write(26,'(9x,a,e13.5,a)') 'echo "',-npoints/xsec(i),
     $        '" >> input_sg.txt'                       !Luminocity
            write(26,'(9x,a)') 'echo "2" >> input_sg.txt' !Grid Adjustment
            write(26,'(9x,a)') 'echo "1" >> input_sg.txt' !Suppression
            write(26,'(9x,a,i4,a)') 'echo "',nhel_refine,
     &           ' " >> input_sg.txt' !Helicity 0=exact
            write(26,'(9x,3a)')'echo "',gn(i)(2:ip-1),
     $           '" >>input_sg.txt'
                  write(26,25) 'for((try=1;try<=16;try+=1)); '
         write(26,25) 'do'
            write(26,25) '../madevent >> $k <input_sg.txt'
         write(26,25) 'if [ -s $k ]'
         write(26,25) 'then'
         write(26,25) '    break'
         write(26,25) 'else'
         write(26,25) '    echo $try > fail.log '
         write(26,25) 'fi'
         write(26,25) 'done'
            write(26,20) 'echo "" >> $k; echo "ls status:" >> $k; ls >> $k'
            write(26,25) 'cat $k >> log.txt'
            write(26,25) 'if [[ -e ftn26 ]]; then'
            write(26,25) '     cp ftn26 ftn25'
            write(26,25) 'fi'
            write(26,20) 'else'

            write(26,25) 'rm -f $k'
            
            write(26,'(9x,a,3i8,a)') 'echo "',max(npoints,min_events),
     $           max_iter,min_iter,'" >& input_sg.txt' 
c
c tjs 8/7/2007    Change to request events not accuracy
c
            write(26,'(9x,a,e13.5,a)') 'echo "',-npoints / xsec(i),
     $           '" >> input_sg.txt' ! Luminocity
            write(26,'(9x,a)') 'echo "0" >> input_sg.txt'
            write(26,'(9x,a)') 'echo "1" >> input_sg.txt'

            write(26,'(9x,a,i4,a)') 'echo "',nhel_refine,
     &           ' " >> input_sg.txt' !Helicity 0=exact

            write(26,'(9x,3a)')'echo "',gn(i)(2:ip-1),
     $           '" >>input_sg.txt'

            write(26,25) 'if [[ -e ftn26 ]]; then'
            write(26,25) '     cp ftn26 ftn25'
            write(26,25) 'fi'
            write(26,25) 'for((try=1;try<=16;try+=1)); '
         write(26,25) 'do'
            write(26,25) '../madevent >> $k <input_sg.txt'
                     write(26,25) 'if [ -s $k ]'
         write(26,25) 'then'
         write(26,25) '    break'
         write(26,25) 'else'
         write(26,25) '    echo $try > fail.log '
         write(26,25) 'fi'
         write(26,25) 'done'
            write(26,20) 'echo "" >> $k; echo "ls status:" >> $k; ls >> $k'
            write(26,25) 'cat $k >> log.txt'
            write(26,20) 'fi'
            write(26,20) 'cd ../'
         else    !No events from this channel
            write(*,*) 'Skipping channel:',gn(i)(1:ip-1),xsec(i)*goal_lum/xtot,rvec
            write(27,*) 0d0
         endif
         close(27)
 91      cycle
      enddo
      call close_bash_file(26)
 15   format(a)
 20   format(5x,a)
 25   format(10x,a)
 999  close(26)
      close(27)
      end


      subroutine sort2(array,aux1,n)
      implicit none
! Arguments
      integer n
      integer aux1(n)
      double precision array(n)
!  Local Variables
      integer i,k
      double precision temp
      logical done

!-----------
! Begin Code
!-----------
      do i=n-1,1,-1
         done = .true.
         do k=1,i
            if (array(k) .lt. array(k+1)) then
               temp = array(k)
               array(k) = array(k+1)
               array(k+1) = temp
               temp = aux1(k)
               aux1(k) = aux1(k+1)
               aux1(k+1) = temp
               done = .false.
            end if
         end do
         if (done) return
      end do
      end 


      subroutine get_xsec_log(xsec,xerr,eff,xmax)
c*********************************************************************
c     Reads from output file, gets cross section and maxwgt from
c     first two iterations
c*********************************************************************
      implicit none
c
c     Arguments
c
      double precision xsec(2),xerr(2),eff(2),xmax(2)
c
c     Local
c     
      character*78 buff
      integer i
c-----
c  Begin Code
c-----
      xsec(1) = 0d0
      xerr(1) = 0d0
      xmax(1) = 0d0
      do while (.true.)
         read(25,'(a80)',err=99) buff
         if (buff(1:4) .eq. 'Iter') then
            read(buff(11:16),'(i5)') i
            if (i .eq. 1 .or. i .eq. 2) then
               read(buff(61:70),*) xmax(i)
               read(buff(21:33),*) xsec(i)
               xmax(i)=xmax(i)/xsec(i)
c               read(buff(48:59),*) xerr(i)
c               read(buff(48:59),*) xmax(i)
            endif
            read(25,'(a80)',err=99) buff
            read(buff(1:6),'(i5)') i
            if (i .eq. 1 .or. i .eq. 2) then
               read(buff(6:17),*) xsec(i)
               read(buff(20:31),*) xerr(i)
               read(buff(34:40),*) eff(i)               
            endif
            write(*,'(i4,4f12.3)') i,xsec(i),xerr(i),eff(i),xmax(i)
         endif
      enddo
 99   end

      logical function pass_point(p)
c************************************************************************
c     This function is called from sample to see if it needs to 
c     bother calculating the weight from all the different conficurations
c     You can either just return true, or have it call passcuts
c************************************************************************
      implicit none
c
c     Arguments
c
      double precision p
c
c     External
c
      logical passcuts
      external passcuts
c-----
c  Begin Code
c-----
      pass_point = .true.
c      pass_point = passcuts(p)
      end
C 
      LOGICAL FUNCTION PASSCUTS(P)
C**************************************************************************
C     INPUT:
C            P(0:3,1)           MOMENTUM OF INCOMING PARTON
C            P(0:3,2)           MOMENTUM OF INCOMING PARTON
C            P(0:3,3)           MOMENTUM OF ...
C            ALL MOMENTA ARE IN THE REST FRAME!!
C            COMMON/JETCUTS/   CUTS ON JETS
C     OUTPUT:
C            TRUE IF EVENTS PASSES ALL CUTS LISTED
C**************************************************************************
      IMPLICIT NONE
c
c     Constants
c
      include 'genps.inc'
      include 'nexternal.inc'
C
C     ARGUMENTS
C
      REAL*8 P(0:3,nexternal)

C
C     LOCAL
C
      LOGICAL FIRSTTIME,FIRSTTIME2,pass_bw,notgood,good,foundheavy
      LOGICAL DEBUG
      integer i,j,njets,nheavyjets,nleptons,hardj1,hardj2
      REAL*8 XVAR,ptmax1,ptmax2,htj,tmp,inclht
      real*8 ptemp(0:3), ptemp2(0:3)
      character*20 formstr
C
C     PARAMETERS
C
      real*8 PI
      parameter( PI = 3.14159265358979323846d0 )
C
C     EXTERNAL
C
      REAL*8 R2,DOT,ET,RAP,DJ,SumDot,pt,ALPHAS,PtDot
      logical cut_bw,setclscales,dummy_cuts
      external R2,DOT,ET,RAP,DJ,SumDot,pt,ALPHAS,cut_bw,setclscales,PtDot
      external dummy_cuts
C
C     GLOBAL
C
      include 'run.inc'
      include 'cuts.inc'

      double precision ptjet(nexternal)
      double precision ptheavyjet(nexternal)
      double precision ptlepton(nexternal)
      double precision temp

C     VARIABLES TO SPECIFY JETS
      DOUBLE PRECISION PJET(NEXTERNAL,0:3)
      DOUBLE PRECISION PTMIN
      DOUBLE PRECISION PT1,PT2

C     INTEGERS FOR COUNTING.
      INTEGER K,L,J1,J2

C VARIABLES FOR KT CUT
      DOUBLE PRECISION PTNOW,COSTH,PABS1,PABS2
      DOUBLE PRECISION ETA1,ETA2,COSH_DETA,COS_DPHI,KT1SQ,KT2SQ, DPHI

      double precision etmin(nincoming+1:nexternal),etamax(nincoming+1:nexternal)
      double precision emin(nincoming+1:nexternal)
      double precision                    r2min(nincoming+1:nexternal,nincoming+1:nexternal)
      double precision s_min(nexternal,nexternal)
      double precision etmax(nincoming+1:nexternal),etamin(nincoming+1:nexternal)
      double precision emax(nincoming+1:nexternal)
      double precision r2max(nincoming+1:nexternal,nincoming+1:nexternal)
      double precision s_max(nexternal,nexternal)
      double precision ptll_min(nexternal,nexternal),ptll_max(nexternal,nexternal)
      double precision inclHtmin,inclHtmax
      common/to_cuts/  etmin, emin, etamax, r2min, s_min,
     $     etmax, emax, etamin, r2max, s_max, ptll_min, ptll_max, inclHtmin,inclHtmax

      double precision ptjmin4(4),ptjmax4(4),htjmin4(2:4),htjmax4(2:4)
      logical jetor
      common/to_jet_cuts/ ptjmin4,ptjmax4,htjmin4,htjmax4,jetor

      double precision ptlmin4(4),ptlmax4(4)
      common/to_lepton_cuts/ ptlmin4,ptlmax4

c
c     Special cuts
c

      integer        lbw(0:nexternal)  !Use of B.W.
      common /to_BW/ lbw
C
C     SPECIAL CUTS
C
      LOGICAL  IS_A_J(NEXTERNAL),IS_A_L(NEXTERNAL)
      LOGICAL  IS_A_B(NEXTERNAL),IS_A_A(NEXTERNAL),IS_A_ONIUM(NEXTERNAL)
      LOGICAL  IS_A_NU(NEXTERNAL),IS_HEAVY(NEXTERNAL)
      logical  do_cuts(nexternal)
      COMMON /TO_SPECISA/IS_A_J,IS_A_A,IS_A_L,IS_A_B,IS_A_NU,IS_HEAVY,
     . IS_A_ONIUM, do_cuts

C
C     MERGING SCALE CUT
C
C     Retrieve which external particles undergo the ktdurham and ptlund cuts.
      LOGICAL  is_pdg_for_merging_cut(NEXTERNAL)
      logical from_decay(-(nexternal+3):nexternal)
      COMMON /TO_MERGE_CUTS/is_pdg_for_merging_cut, from_decay

C
C     ADDITIONAL VARIABLES FOR PTLUND CUT
C
      INTEGER NMASSLESS
      DOUBLE PRECISION PINC(NINCOMING,0:3)
      DOUBLE PRECISION PRADTEMP(0:3), PRECTEMP(0:3), PEMTTEMP(0:3)
      DOUBLE PRECISION PTMINSAVE, RHOPYTHIA
      EXTERNAL RHOPYTHIA
C
C     FLAVOUR INFORMATION NECESSARY TO RECONSTRUCT PTLUND
C
      INTEGER JETFLAVOUR(NEXTERNAL), INCFLAVOUR(NINCOMING)
      include 'maxamps.inc'
      integer idup(nexternal,maxproc,maxsproc)
      integer mothup(2,nexternal)
      integer icolup(2,nexternal,maxflow,maxsproc)
      include 'leshouche.inc'

C
C     Keep track of whether cuts already calculated for this event
C
      LOGICAL CUTSDONE,CUTSPASSED
      COMMON/TO_CUTSDONE/CUTSDONE,CUTSPASSED
      DATA CUTSDONE,CUTSPASSED/.FALSE.,.FALSE./

C $B$ MW_NEW_DEF $E$ !this is a tag for MadWeight

      double precision xqcutij(nexternal,nexternal),xqcuti(nexternal)
      common/to_xqcuts/xqcutij,xqcuti

c jet cluster algorithm
      integer nQCD !,NJET,JET(nexternal)
c      double precision plab(0:3, nexternal)
      double precision pQCD(0:3,nexternal)!,PJET(0:3,nexternal)
c      double precision rfj,sycut,palg,fastjetdmerge
c      integer njet_eta
c     Photon isolation
      integer nph,nem,nin
      double precision ptg,chi_gamma_iso,iso_getdrv40
      double precision Etsum(0:nexternal)
      real drlist(nexternal)
      double precision pgamma(0:3,nexternal),pem(0:3,nexternal)
      logical alliso
C     Sort array of results: ismode>0 for real, isway=0 for ascending order
      integer ismode,isway,izero,isorted(nexternal)
      parameter (ismode=1)
      parameter (isway=0)
      parameter (izero=0)

      include 'coupl.inc'

C
C
c
      DATA FIRSTTIME,FIRSTTIME2/.TRUE.,.TRUE./

c put momenta in common block for couplings.f
      double precision pp(0:3,max_particles)
      common /momenta_pp/pp

      DATA DEBUG/.FALSE./

C-----
C  BEGIN CODE
C-----



      PASSCUTS=.TRUE.             !EVENT IS OK UNLESS OTHERWISE CHANGED
      IF (FIRSTTIME) THEN
         FIRSTTIME=.FALSE.
c      Preparation for reweighting by setting up clustering by diagrams
         call initcluster()
c
c
         write(formstr,'(a,i2.2,a)')'(a10,',nexternal,'i8)'
         write(*,formstr) 'Particle',(i,i=nincoming+1,nexternal)
         write(formstr,'(a,i2.2,a)')'(a10,',nexternal,'f8.1)'
         write(*,formstr) 'Et >',(etmin(i),i=nincoming+1,nexternal)
         write(*,formstr) 'E >',(emin(i),i=nincoming+1,nexternal)
         write(*,formstr) 'Eta <',(etamax(i),i=nincoming+1,nexternal)
         write(*,formstr) 'xqcut: ',(xqcuti(i),i=nincoming+1,nexternal)
         write(formstr,'(a,i2.2,a)')'(a,i2,a,',nexternal,'f8.1)'
         do j=nincoming+1,nexternal-1
            write(*,formstr) 'd R #',j,'  >',(-0.0,i=nincoming+1,j),
     &           (r2min(i,j),i=j+1,nexternal)
            do i=j+1,nexternal
               r2min(i,j)=r2min(i,j)*dabs(r2min(i,j))    !Since r2 returns distance squared
               r2max(i,j)=r2max(i,j)*dabs(r2max(i,j))
            enddo
         enddo
         do j=nincoming+1,nexternal-1
            write(*,formstr) 's min #',j,'>',
     &           (s_min(i,j),i=nincoming+1,nexternal)
         enddo
         do j=nincoming+1,nexternal-1
            write(*,formstr) 'xqcutij #',j,'>',
     &           (xqcutij(i,j),i=nincoming+1,nexternal)
         enddo

cc
cc     Set the strong coupling
cc
c         call set_ren_scale(P,scale)
c
cc     Check that the user funtions for setting the scales
cc     have been edited if the choice of an event-by-event
cc     scale choice has been made 
c
c         if(.not.fixed_ren_scale) then
c            if(scale.eq.0d0) then
c               write(6,*) 
c               write(6,*) '* >>>>>>>>>ERROR<<<<<<<<<<<<<<<<<<<<<<<*'
c               write(6,*) ' Dynamical renormalization scale choice '
c               write(6,*) ' selected but user subroutine' 
c               write(6,*) ' set_ren_scale not edited in file:setpara.f'
c               write(6,*) ' Switching to a fixed_ren_scale choice'
c               write(6,*) ' with scale=zmass'
c               scale=91.2d0
c               write(6,*) 'scale=',scale
c               fixed_ren_scale=.true.
c               call set_ren_scale(P,scale)
c            endif
c         endif
         
c         if(.not.fixed_fac_scale) then
c            call set_fac_scale(P,q2fact)
c            if(q2fact(1).eq.0d0.or.q2fact(2).eq.0d0) then
c               write(6,*) 
c               write(6,*) '* >>>>>>>>>ERROR<<<<<<<<<<<<<<<<<<<<<<<*'
c               write(6,*) ' Dynamical renormalization scale choice '
c               write(6,*) ' selected but user subroutine' 
c               write(6,*) ' set_fac_scale not edited in file:setpara.f'
c               write(6,*) ' Switching to a fixed_fac_scale choice'
c               write(6,*) ' with q2fact(i)=zmass**2'
c               fixed_fac_scale=.true.
c               q2fact(1)=91.2d0**2
c               q2fact(2)=91.2d0**2
c               write(6,*) 'scales=',q2fact(1),q2fact(2)
c            endif
c         endif

         if(fixed_ren_scale) then
            G = SQRT(4d0*PI*ALPHAS(scale))
            call update_as_param()
         endif

c     Put momenta in the common block to zero to start
         do i=0,3
            do j=1,max_particles
               pp(i,j) = 0d0
            enddo
         enddo
         
      ENDIF ! IF FIRSTTIME

      IF (CUTSDONE) THEN
         PASSCUTS=CUTSPASSED
         RETURN
      ENDIF
      CUTSDONE=.TRUE.
c      CUTSPASSED=.FALSE.

c
c     Make sure have reasonable 4-momenta
c
      if (p(0,1) .le. 0d0) then
         passcuts=.false.
         return
      endif

c     Also make sure there's no INF or NAN
      do i=1,nexternal
         do j=0,3
            if(p(j,i).gt.1d32.or.p(j,i).ne.p(j,i))then
               passcuts=.false.
               return
            endif
         enddo
      enddo
      
c
c     Limit S_hat
c
c      if (x1*x2*stot .gt. 500**2) then
c         passcuts=.false.
c         return
c      endif

C $B$ DESACTIVATE_CUT $E$ !This is a tag for MadWeight

      if(debug) write (*,*) '============================='
      if(debug) write (*,*) ' EVENT STARTS TO BE CHECKED  '
      if(debug) write (*,*) '============================='
c     
c     p_t min & max cuts
c     
      do i=nincoming+1,nexternal
         if(debug) write (*,*) 'pt(',i,')=',pt(p(0,i)),'   ',etmin(i),
     $        ':',etmax(i)
         notgood=(pt(p(0,i)) .lt. etmin(i)).or.
     &        (etmax(i).ge.0d0.and.pt(p(0,i)) .gt. etmax(i))
         if (notgood) then
            if(debug) write (*,*) i,' -> fails'
            passcuts=.false.
            return
         endif
      enddo
c
c    missing ET min & max cut + Invariant mass of leptons and neutrino 
c    nb: missing Et defined as the vector sum over the neutrino's pt
c
c-- reset ptemp(0:3)
      do j=0,3
         ptemp(j)=0 ! for the neutrino
         ptemp2(j)=0 ! for the leptons
      enddo
c-  sum over the momenta
      do i=nincoming+1,nexternal
         if(is_a_nu(i)) then            
         if(debug) write (*,*) i,' -> neutrino '
            do j=0,3
               ptemp(j)=ptemp(j)+p(j,i)
            enddo
         elseif(is_a_l(i)) then            
         if(debug) write (*,*) i,' -> lepton '
            do j=0,3
               ptemp2(j)=ptemp2(j)+p(j,i)
            enddo
         endif

      enddo
c-  check the et
      if(debug.and.ptemp(0).eq.0d0) write (*,*) 'No et miss in event'
      if(debug.and.ptemp(0).gt.0d0) write (*,*) 'Et miss =',pt(ptemp(0)),'   ',misset,':',missetmax
      if(debug.and.ptemp2(0).eq.0d0) write (*,*) 'No leptons in event'
      if(debug.and.ptemp(0).gt.0d0) write (*,*) 'Energy of leptons =',pt(ptemp2(0))
      if(ptemp(0).gt.0d0) then
         notgood=(pt(ptemp(0)) .lt. misset).or.
     &        (missetmax.ge.0d0.and.pt(ptemp(0)) .gt. missetmax)
         if (notgood) then
            if(debug) write (*,*) ' missing et cut -> fails'
            passcuts=.false.
            return
         endif
      endif
      if (mmnl.gt.0d0.or.mmnlmax.ge.0d0)then
         if(dsqrt(SumDot(ptemp,ptemp2,1d0)).lt.mmnl.or.mmnlmax.ge.0d0.and.dsqrt(SumDot(ptemp, ptemp2,1d0)).gt.mmnlmax) then
            if(debug) write (*,*) 'lepton invariant mass -> fails'
            passcuts=.false.
            return
         endif
      endif
c
c     pt cut on heavy particles
c     gives min(pt) for (at least) one heavy particle
c
      if(ptheavy.gt.0d0)then
         passcuts=.false.
         foundheavy=.false.
         do i=nincoming+1,nexternal
            if(is_heavy(i)) then            
               if(debug) write (*,*) i,' -> heavy '
               foundheavy=.true.
               if(pt(p(0,i)).gt.ptheavy) passcuts=.true.
            endif
         enddo
         
         if(.not.passcuts.and.foundheavy)then
            if(debug) write (*,*) ' heavy particle cut -> fails'
            return
         else
            passcuts=.true.
         endif
      endif
c     
c     E min & max cuts
c     
      do i=nincoming+1,nexternal
         if(debug) write (*,*) 'p(0,',i,')=',p(0,i),'   ',emin(i),':',emax(i)
         notgood=(p(0,i) .le. emin(i)).or.
     &        (emax(i).ge.0d0 .and. p(0,i) .gt. emax(i))
         if (notgood) then
            if(debug) write (*,*) i,' -> fails'
            passcuts=.false.
            return
         endif
      enddo
c     
c     Rapidity  min & max cuts
c     
      do i=nincoming+1,nexternal
         if(debug) write (*,*) 'abs(rap(',i,'))=',abs(rap(p(0,i))),'   ',etamin(i),':',etamax(i)
         notgood=(etamax(i).ge.0.and.abs(rap(p(0,i))) .gt. etamax(i)).or.
     &        (abs(rap(p(0,i))) .lt. etamin(i))
         if (notgood) then
            if(debug) write (*,*) i,' -> fails'
            passcuts=.false.
            return
         endif
      enddo
c     
c     DeltaR min & max cuts
c     
      do i=nincoming+1,nexternal-1
         do j=i+1,nexternal
            if(debug) write (*,*) 'r2(',i, ',' ,j,')=',dsqrt(r2(p(0,i),p(0,j)))
            if(debug) write (*,*) dsqrt(r2min(j,i)),dsqrt(r2max(j,i))
            if(r2min(j,i).gt.0.or.r2max(j,i).ge.0d0) then
               tmp=r2(p(0,i),p(0,j))
               notgood=(tmp .lt. r2min(j,i)).or.
     $              (r2max(j,i).ge.0d0 .and. tmp .gt. r2max(j,i))
               if (notgood) then
                  if(debug) write (*,*) i,j,' -> fails'
                  passcuts=.false.
                  return
               endif
            endif
         enddo
      enddo


c     s-channel min & max pt of sum of 4-momenta
c     
      do i=nincoming+1,nexternal-1
         do j=i+1,nexternal
            if(debug)write (*,*) 'ptll(',i,',',j,')=',PtDot(p(0,i),p(0,j))
            if(debug)write (*,*) ptll_min(j,i),ptll_max(j,i)
            if(ptll_min(j,i).gt.0.or.ptll_max(j,i).ge.0d0) then
               tmp=PtDot(p(0,i),p(0,j))
               notgood=(tmp .lt. ptll_min(j,i).or.
     $              ptll_max(j,i).ge.0d0 .and. tmp.gt.ptll_max(j,i))
               if (notgood) then
                  if(debug) write (*,*) i,j,' -> fails'
                  passcuts=.false.
                  return
               endif
            endif
         enddo
      enddo




c     
c     s-channel min & max invariant mass cuts
c     
      do i=nincoming+1,nexternal-1
         do j=i+1,nexternal
            if(debug) write (*,*) 's(',i,',',j,')=',Sumdot(p(0,i),p(0,j),+1d0)
            if(debug) write (*,*) s_min(j,i),s_max(j,i)
            if(s_min(j,i).gt.0.or.s_max(j,i).ge.0d0) then
               tmp=SumDot(p(0,i),p(0,j),+1d0)
               if(s_min(j,i).le.s_max(j,i) .or. s_max(j,i).lt.0d0)then
                  notgood=(tmp .lt. s_min(j,i).or.
     $                 s_max(j,i).ge.0d0 .and. tmp .gt. s_max(j,i)) 
                  if (notgood) then
                     if(debug) write (*,*) i,j,' -> fails'
                     passcuts=.false.
                     return
                  endif
               else
                  notgood=(tmp .lt. s_min(j,i).and.tmp .gt. s_max(j,i)) 
                  if (notgood) then
                     if(debug) write (*,*) i,j,' -> fails'
                     passcuts=.false.
                     return
                  endif
               endif
            endif
         enddo
      enddo
C     $B$DESACTIVATE_BW_CUT$B$ This is a Tag for MadWeight
c     
c     B.W. phase space cuts
c     
      pass_bw=cut_bw(p)
c     JA 4/8/11 always check pass_bw
      if ( pass_bw.and..not.CUTSPASSED) then
         passcuts=.false.
         if(debug) write (*,*) ' pass_bw -> fails'
         return
      endif
C     $E$DESACTIVATE_BW_CUT$E$ This is a Tag for MadWeight
        CUTSPASSED=.FALSE.
C     
C     maximal and minimal pt of the jets sorted by pt
c     
      njets=0
      nheavyjets=0

c- fill ptjet with the pt's of the jets.
      do i=nincoming+1,nexternal
         if(is_a_j(i)) then
            njets=njets+1
            ptjet(njets)=pt(p(0,i))
         endif
         if(is_a_b(i)) then
            nheavyjets=nheavyjets+1
            ptheavyjet(nheavyjets)=pt(p(0,i))
         endif

      enddo
      if(debug) write (*,*) 'not yet ordered ',njets,'   ',ptjet

C----------------------------------------------------------------------------
C     DURHAM_KT CUT
C----------------------------------------------------------------------------

      IF ( KT_DURHAM .GT. 0D0) THEN

C       RESET JET MOMENTA
        njets=0
        DO I=1,NEXTERNAL
          DO J=0,3
            PJET(I,J) = 0D0
          ENDDO
        ENDDO

        do i=nincoming+1,nexternal
           if(is_pdg_for_merging_cut(i) .and. .not. from_decay(I) ) then
             njets=njets+1
             DO J=0,3
               PJET(NJETS,J) = P(J,I)
             ENDDO
           endif
        enddo

C       COUNT NUMBER OF MASSLESS OUTGOING PARTICLES, SINCE WE DO NOT WANT
C       TO APPLY A CUT FOR JUST A SINGLE MASSIVE PARTICLE IN THE FINAL STATE.
        NMASSLESS = 0
        DO I=NINCOMING+1,NEXTERNAL
          if(is_pdg_for_merging_cut(i) .and. .not. from_decay(I) .and.
     &                        is_a_j(i).or.is_a_b(i)) then
            NMASSLESS = NMASSLESS + 1
          ENDIF
        ENDDO

C       DURHAM KT SEPARATION CUT
        IF(NJETS.GT.0 .AND. NMASSLESS .GT. 0) THEN

        PTMIN = EBEAM(1) + EBEAM(2)

        DO I=1,NJETS

C         PT WITH RESPECT TO Z AXIS FOR HADRONIC COLLISIONS
          IF ( (LPP(1).NE.0) .OR. (LPP(2).NE.0)) THEN
            PT1 = DSQRT(PJET(I,1)**2 + PJET(I,2)**2)
            PTMIN = MIN( PTMIN, PT1 )
          ENDIF

          DO J=I+1,NJETS
C           GET ANGLE BETWEEN JETS
            PABS1 = DSQRT(PJET(I,1)**2 + PJET(I,2)**2 + PJET(I,3)**2)
            PABS2 = DSQRT(PJET(J,1)**2 + PJET(J,2)**2 + PJET(J,3)**2)
C           CHECK IF 3-MOMENTA DO NOT VANISH
            IF(PABS1*PABS2 .NE. 0D0) THEN
              COSTH = ( PJET(I,1)*PJET(J,1) + PJET(I,2)*PJET(J,2) + PJET(I,3)*PJET(J,3) )/(PABS1*PABS2)
            ELSE
C           IF 3-MOMENTA VANISH, MAKE JET COSTH = 1D0 SO THAT JET MEASURE VANISHES
              COSTH = 1D0
            ENDIF
C           GET PT AND ETA OF JETS
            PT2 = DSQRT(PJET(J,1)**2 + PJET(J,2)**2)
            ETA1 = 0.5D0*LOG( (PJET(I,0) + PJET(I,3)) / (PJET(I,0) - PJET(I,3)) )
            ETA2 = 0.5D0*LOG( (PJET(J,0) + PJET(J,3)) / (PJET(J,0) - PJET(J,3)) )
C           GET COSH OF DELTA ETA, COS OF DELTA PHI
            COSH_DETA = DCOSH( ETA1 - ETA2 )
            COS_DPHI = ( PJET(I,1)*PJET(J,1) + PJET(I,2)*PJET(J,2) ) / (PT1*PT2)
            DPHI = DACOS( COS_DPHI )
            IF ( (LPP(1).EQ.0) .AND. (LPP(2).EQ.0)) THEN
C             KT FOR E+E- COLLISION
              PTNOW = DSQRT( 2D0*MIN(PJET(I,0)**2,PJET(J,0)**2)*( 1D0-COSTH ) )
             ELSE
C             HADRONIC KT, FASTJET DEFINITION
              PTNOW = DSQRT( MIN(PT1**2,PT2**2)*( (ETA1 - ETA2 )**2 + DPHI**2 )/(D_PARAMETER**2) )
            ENDIF

            PTMIN = MIN( PTMIN, PTNOW )

          ENDDO ! LOOP OVER NJET

        ENDDO ! LOOP OVER NJET

C       CHECK COMPATIBILITY WITH CUT
        IF( (PTMIN .LT. KT_DURHAM)) THEN
          PASSCUTS = .FALSE.
          RETURN
        ENDIF

        ENDIF ! IF NJETS.GT. 0

      ENDIF ! KT_DURHAM .GT. 0D0

C----------------------------------------------------------------------------
C     PTLUND CUT
C----------------------------------------------------------------------------

      IF(PT_LUND .GT. 0D0 ) THEN

C       Reset jet momenta
        NJETS=0
        DO I=1,NEXTERNAL
          JETFLAVOUR(I) = 0
          DO J=0,3
            PJET(I,J) = 0D0
          ENDDO
        ENDDO

C       Fill incoming particle momenta
        DO I=1,NINCOMING
          INCFLAVOUR(I) = IDUP(I,1,1)
          DO J=0,3
            PINC(I,J) = P(J,I)
          ENDDO
        ENDDO

C       Fill final jet momenta
        DO I=NINCOMING+1,NEXTERNAL
          if(is_pdg_for_merging_cut(i) .and. .not. from_decay(I) ) then
            NJETS=NJETS+1
            JETFLAVOUR(NJETS) = IDUP(I,1,1)
            DO J=0,3
              PJET(NJETS,J) = P(J,I)
            ENDDO
          ENDIF
        ENDDO

C       PROCESS WITH EXACTLY TWO MASSLESS OUTGOING PARTICLES IS SPECIAL
C       BECAUSE AN ENERGY-SHARING VARIABLE LIKE "Z" DOES NOT MAKE SENSE.
C       IN THIS CASE, ONLY APPLY MINIMAL pT W.R.T BEAM CUT.
C       THIS CUT WILL ONLY APPLY TO THE TWO-MASSLESS PARTICLE STATE.
        NMASSLESS = 0
        DO I=NINCOMING+1,NEXTERNAL
          if(is_pdg_for_merging_cut(i) .and. .not. from_decay(I) .and. 
     &                          is_a_j(i).or.is_a_b(i)) THEN
            NMASSLESS = NMASSLESS + 1
          ENDIF
        ENDDO
        IF (NMASSLESS .EQ. 2 .AND. NJETS .EQ. 2 .AND.
     &                                     NEXTERNAL-NINCOMING .EQ. 2) THEN
          PTMINSAVE = EBEAM(1) + EBEAM(2)
          DO I=NINCOMING+1,NEXTERNAL
            if( .not. from_decay(I) ) then  
              PTMINSAVE = MIN(PTMINSAVE, PT(p(0,i)))
            ENDIF
          ENDDO
C         CHECK COMPATIBILITY WITH CUT
          IF ( ((LPP(1).NE.0) .OR. (LPP(2).NE.0)) .AND.
     &                                         PTMINSAVE .LT. PT_LUND) THEN
            PASSCUTS = .FALSE.
            RETURN
          ENDIF
C         RESET NJETS TO AVOID FURTHER MERGING SCALE CUT.
          NJETS=0
        ENDIF

C       PYTHIA PT SEPARATION CUT
        IF(NJETS.GT.0 .AND. NMASSLESS .GT. 0) THEN

        PTMINSAVE = EBEAM(1) + EBEAM(2)

        DO I=1,NJETS

          PTMIN = EBEAM(1) + EBEAM(2)
          PTMINSAVE = MIN(PTMIN,PTMINSAVE)

C         Compute pythia ISR separation between i-jet and incoming.
C         Only SM-like emissions off the beam are possible.
          IF ( ( (LPP(1).NE.0) .OR. (LPP(2).NE.0)) .AND. 
     &                               ABS(JETFLAVOUR(I)) .LT. 30 ) THEN
C           Check separation to first incoming particle
            DO L=0,3
              PRADTEMP(L) = PINC(1,L)
              PEMTTEMP(L) = PJET(I,L)
              PRECTEMP(L) = PINC(2,L)
            ENDDO
            PT1 = RHOPYTHIA(PRADTEMP, PEMTTEMP, PRECTEMP, INCFLAVOUR(1),
     &                                            JETFLAVOUR(I), -1, -1)
            PTMIN = MIN( PTMIN, PT1 )
C           Check separation to second incoming particle
            DO L=0,3
              PRADTEMP(L) = PINC(2,L)
              PEMTTEMP(L) = PJET(I,L)
              PRECTEMP(L) = PINC(1,L)
            ENDDO
            PT2 = RHOPYTHIA(PRADTEMP, PEMTTEMP, PRECTEMP, INCFLAVOUR(2),
     &                                            JETFLAVOUR(I), -1, -1)
            PTMIN = MIN( PTMIN, PT2 )
          ENDIF

C         Compute pythia FSR separation between two jets,
C         without any knowledge of colour connections
          DO J=1,NJETS
            DO K=1,NJETS
              IF ( I .NE. J .AND. I .NE. K .AND. J .NE. K ) THEN

C               Check separation between final partons i and j, with k as spectator
                DO L=0,3
                  PRADTEMP(L) = PJET(J,L)
                  PEMTTEMP(L) = PJET(I,L)
                  PRECTEMP(L) = PJET(K,L)
                ENDDO

                TEMP = RHOPYTHIA( PRADTEMP, PEMTTEMP, PRECTEMP,
     &                               JETFLAVOUR(J), JETFLAVOUR(I), 1, 1)
C               Only SM-like emissions off the beam are possible, no additional
C               BSM particles will be produced as as shower emissions.
                IF ( ABS(JETFLAVOUR(I)) .LT. 30 ) THEN
                  PTMIN = MIN(PTMIN, TEMP);
                ENDIF

                TEMP = RHOPYTHIA( PEMTTEMP, PRADTEMP, PRECTEMP,
     &                               JETFLAVOUR(I), JETFLAVOUR(J), 1, 1)
C               Only SM-like emissions off the beam are possible, no additional
C               BSM particles will be produced as as shower emissions.
                IF ( ABS(JETFLAVOUR(J)) .LT. 30 ) THEN
                  PTMIN = MIN(PTMIN, TEMP);
                ENDIF

              ENDIF

            ENDDO ! LOOP OVER NJET
          ENDDO ! LOOP OVER NJET

C         Compute pythia FSR separation between two jets, with initial spectator
          IF ( (LPP(1).NE.0) .OR. (LPP(2).NE.0)) THEN
            DO J=1,NJETS

C             BSM particles can only be radiators, and will not be produced
C             as shower emissions.
              IF ( ABS(JETFLAVOUR(I)) .GT. 1000000 ) THEN
                EXIT
              ENDIF

C             Allow both initial partons as recoiler
              IF ( I .NE. J ) THEN

C               Check with first initial as recoiler
                DO L=0,3
                  PRADTEMP(L) = PJET(J,L)
                  PEMTTEMP(L) = PJET(I,L)
                  PRECTEMP(L) = PINC(1,L)
                ENDDO
                TEMP = RHOPYTHIA( PRADTEMP, PEMTTEMP, PRECTEMP, 
     &                             JETFLAVOUR(J), JETFLAVOUR(I), 1, -1);
                IF ( LPP(1) .NE. 0 ) THEN
                  PTMIN = MIN(PTMIN, TEMP);
                ENDIF
                DO L=0,3
                  PRADTEMP(L) = PJET(J,L)
                  PEMTTEMP(L) = PJET(I,L)
                  PRECTEMP(L) = PINC(2,L)
                ENDDO
                TEMP = RHOPYTHIA( PRADTEMP, PEMTTEMP, PRECTEMP,
     &                             JETFLAVOUR(J), JETFLAVOUR(I), 1, -1);
                IF ( LPP(2) .NE. 0 ) THEN
                  PTMIN = MIN(PTMIN, TEMP);
                ENDIF
              ENDIF
            ENDDO ! LOOP OVER NJET
          ENDIF

          PTMINSAVE = MIN(PTMIN,PTMINSAVE)

        ENDDO ! LOOP OVER NJET

C       CHECK COMPATIBILITY WITH CUT
        IF (PTMINSAVE .LT. PT_LUND) THEN
          PASSCUTS = .FALSE.
          RETURN
        ENDIF
 
        ENDIF ! IF NJETS.GT. 0 

      ENDIF ! PT_LUND .GT. 0D0 

C----------------------------------------------------------------------------
C----------------------------------------------------------------------------




c- check existance of jets if jet cuts are on
      if(njets.lt.1.and.(htjmin.gt.0.or.ptj1min.gt.0).or.
     $     njets.lt.2.and.ptj2min.gt.0.or.
     $     njets.lt.3.and.ptj3min.gt.0.or.
     $     njets.lt.4.and.ptj4min.gt.0)then
         if(debug) write (*,*) i, ' too few jets -> fails'
         passcuts=.false.
         return
      endif

c - sort jet pts
      do i=1,njets-1
         do j=i+1,njets
            if(ptjet(j).gt.ptjet(i)) then
               temp=ptjet(i)
               ptjet(i)=ptjet(j)
               ptjet(j)=temp
            endif
         enddo
      enddo
      if(debug) write (*,*) 'ordered ',njets,'   ',ptjet
c
c     Use "and" or "or" prescriptions 
c     
      inclht=0

      if(njets.gt.0) then

       notgood=.not.jetor
       if(debug) write (*,*) 'jetor :',jetor  
       if(debug) write (*,*) '0',notgood   
      
      do i=1,min(njets,4)
            if(debug) write (*,*) i,ptjet(i), '   ',ptjmin4(i),
     $        ':',ptjmax4(i)
         if(jetor) then     
c---  if one of the jets does not pass, the event is rejected
            notgood=notgood.or.(ptjmax4(i).ge.0d0 .and.
     $           ptjet(i).gt.ptjmax4(i)) .or.
     $           (ptjet(i).lt.ptjmin4(i))
            if(debug) write (*,*) i,' notgood total:', notgood   
         else
c---  all cuts must fail to reject the event
            notgood=notgood.and.(ptjmax4(i).ge.0d0 .and.
     $              ptjet(i).gt.ptjmax4(i) .or.
     $              (ptjet(i).lt.ptjmin4(i)))
            if(debug) write (*,*) i,' notgood total:', notgood   
         endif
      enddo


      if (notgood) then
         if(debug) write (*,*) i, ' multiple pt -> fails'
         passcuts=.false.
         return
      endif

c---------------------------
c      Ht cuts
C---------------------------
      htj=ptjet(1)

      do i=2,njets
         htj=htj+ptjet(i)
         if(debug) write (*,*) i, 'htj ',htj
         if(debug.and.i.le.4) write (*,*) 'htmin ',i,' ', htjmin4(i),':',htjmax4(i)
         if(i.le.4)then
            if(htj.lt.htjmin4(i) .or.
     $        htjmax4(i).ge.0d0.and.htj.gt.htjmax4(i)) then
            if(debug) write (*,*) i, ' ht -> fails'
            passcuts=.false.
            return
            endif
         endif
      enddo

      if(htj.lt.htjmin.or.htjmax.ge.0d0.and.htj.gt.htjmax)then
         if(debug) write (*,*) i, ' htj -> fails'
         passcuts=.false.
         return
      endif

      inclht=htj

      endif !if there are jets 

      if(nheavyjets.gt.0) then
         do i=1,nheavyjets
            inclht=inclht+ptheavyjet(i)
         enddo
      endif !if there are heavyjets

      if(inclht.lt.inclHtmin.or.
     $     inclHtmax.ge.0d0.and.inclht.gt.inclHtmax)then
         if(debug) write (*,*) ' inclhtmin=',inclHtmin,' -> fails'
         passcuts=.false.
         return
      endif

C     
C     maximal and minimal pt of the leptons sorted by pt
c     
      nleptons=0

      if(ptl1min.gt.0.or.ptl2min.gt.0.or.ptl3min.gt.0.or.ptl4min.gt.0.or.
     $     ptl1max.ge.0d0.or.ptl2max.ge.0d0.or.
     $     ptl3max.ge.0d0.or.ptl4max.ge.0d0) then

c     - fill ptlepton with the pt's of the leptons.
         do i=nincoming+1,nexternal
            if(is_a_l(i)) then
               nleptons=nleptons+1
               ptlepton(nleptons)=pt(p(0,i))
            endif
         enddo
         if(debug) write (*,*) 'not yet ordered ',njets,'   ',ptjet

c     - check existance of leptons if lepton cuts are on
         if(nleptons.lt.1.and.ptl1min.gt.0.or.
     $        nleptons.lt.2.and.ptl2min.gt.0.or.
     $        nleptons.lt.3.and.ptl3min.gt.0.or.
     $        nleptons.lt.4.and.ptl4min.gt.0)then
            if(debug) write (*,*) i, ' too few leptons -> fails'
            passcuts=.false.
            return
         endif

c     - sort lepton pts
         do i=1,nleptons-1
            do j=i+1,nleptons
               if(ptlepton(j).gt.ptlepton(i)) then
                  temp=ptlepton(i)
                  ptlepton(i)=ptlepton(j)
                  ptlepton(j)=temp
               endif
            enddo
         enddo
         if(debug) write (*,*) 'ordered ',nleptons,'   ',ptlepton

         if(nleptons.gt.0) then

            notgood = .false.
            do i=1,min(nleptons,4)
               if(debug) write (*,*) i,ptlepton(i), '   ',ptlmin4(i),':',ptlmax4(i)
c---  if one of the leptons does not pass, the event is rejected
               notgood=notgood.or.
     $              (ptlmax4(i).ge.0d0.and.ptlepton(i).gt.ptlmax4(i)).or.
     $              (ptlepton(i).lt.ptlmin4(i))
               if(debug) write (*,*) i,' notgood total:', notgood   
            enddo


            if (notgood) then
               if(debug) write (*,*) i, ' multiple pt -> fails'
               passcuts=.false.
               return
            endif
         endif
      endif
C>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>     
C     SPECIAL CUTS
C<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

C     REQUIRE AT LEAST ONE JET WITH PT>XPTJ
         
         IF(xptj.gt.0d0) THEN
            xvar=0
            do i=nincoming+1,nexternal
               if(is_a_j(i)) xvar=max(xvar,pt(p(0,i)))
            enddo
            if (xvar .lt. xptj) then
               passcuts=.false.
               return
            endif
         ENDIF

C     REQUIRE AT LEAST ONE PHOTON WITH PT>XPTA
         
         IF(xpta.gt.0d0) THEN
            xvar=0
            do i=nincoming+1,nexternal
               if(is_a_a(i)) xvar=max(xvar,pt(p(0,i)))
            enddo
            if (xvar .lt. xpta) then
               passcuts=.false.
               return
            endif
         ENDIF

C     REQUIRE AT LEAST ONE B  WITH PT>XPTB
         
         IF(xptb.gt.0d0) THEN
            xvar=0
            do i=nincoming+1,nexternal
               if(is_a_b(i)) xvar=max(xvar,pt(p(0,i)))
            enddo
            if (xvar .lt. xptb) then
               passcuts=.false.
               return
            endif
         ENDIF

C     REQUIRE AT LEAST ONE LEPTON  WITH PT>XPTL
         
         IF(xptl.gt.0d0) THEN
            xvar=0
            do i=nincoming+1,nexternal
               if(is_a_l(i)) xvar=max(xvar,pt(p(0,i)))
            enddo
            if (xvar .lt. xptl) then
               passcuts=.false.
               if(debug) write (*,*) ' xptl -> fails'
               return
            endif
         ENDIF
C
C     WBF CUTS: TWO TYPES
C    
C     FIRST TYPE:  implemented by FM
C
C     1. FIND THE 2 HARDEST JETS
C     2. REQUIRE |RAP(J)|>XETAMIN
C     3. REQUIRE RAP(J1)*ETA(J2)<0
C
C     SECOND TYPE : added by Simon de Visscher 1-08-2007
C
C     1. FIND THE 2 HARDEST JETS
C     2. REQUIRE |RAP(J1)-RAP(J2)|>DELTAETA
C     3. REQUIRE RAP(J1)*RAP(J2)<0
C
C
         hardj1=0
         hardj2=0
         ptmax1=0d0
         ptmax2=0d0

C-- START IF AT LEAST ONE OF THE CUTS IS ACTIVATED
         
         IF(XETAMIN.GT.0D0.OR.DELTAETA.GT.0D0) THEN
            
C-- FIND THE HARDEST JETS

            do i=nincoming+1,nexternal
               if(is_a_j(i)) then
c                  write (*,*) i,pt(p(0,i))
                  if(pt(p(0,i)).gt.ptmax1) then
                     hardj2=hardj1
                     ptmax2=ptmax1
                     hardj1=i
                     ptmax1=pt(p(0,i))
                  elseif(pt(p(0,i)).gt.ptmax2) then
                     hardj2=i
                     ptmax2=pt(p(0,i))
                  endif
c                  write (*,*) hardj1,hardj2,ptmax1,ptmax2
               endif
            enddo
            
            if (hardj2.eq.0) goto 21 ! bypass vbf cut since not enough jets

C-- NOW APPLY THE CUT I            

            if (abs(rap(p(0,hardj1))) .lt. xetamin
     &       .or.abs(rap(p(0,hardj2))) .lt. xetamin
     &       .or.rap(p(0,hardj1))*rap(p(0,hardj2)) .gt.0d0) then
             passcuts=.false.
             return
            endif

            
C-- NOW APPLY THE CUT II
            
            if (abs(rap(p(0,hardj1))-rap(p(0,hardj2))) .lt. deltaeta) then
             passcuts=.false.
             return
            endif
         
c            write (*,*) hardj1,hardj2,rap(p(0,hardj1)),rap(p(0,hardj2))
         
         ENDIF

c Begin photon isolation
c NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE
c     Use is made of parton cm frame momenta. If this must be
c     changed, pQCD used below must be redefined
c NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE
c If we do not require a mimimum jet energy, there's no need to apply
c jet clustering and all that.
      if (ptgmin.ne.0d0) then

c Put all (light) QCD partons in momentum array for jet clustering.
c From the run_card.dat, maxjetflavor defines if b quark should be
c considered here (via the logical variable 'is_a_jet').  nQCD becomes
c the number of (light) QCD partons at the real-emission level (i.e. one
c more than the Born).

      nQCD=0
      do j=nincoming+1,nexternal
         if (is_a_j(j)) then
            nQCD=nQCD+1
            do i=0,3
               pQCD(i,nQCD)=p(i,j) ! Use C.o.M. frame momenta
            enddo
         endif
      enddo

        nph=0
        do j=nincoming+1,nexternal
          if (is_a_a(j)) then
            nph=nph+1
            do i=0,3
              pgamma(i,nph)=p(i,j) ! Use C.o.M. frame momenta
            enddo
          endif
        enddo
        if(nph.eq.0) goto 444

        if(isoEM)then
          nem=nph
          do k=1,nem
            do i=0,3
              pem(i,k)=pgamma(i,k)
            enddo
          enddo
          do j=nincoming+1,nexternal
            if (is_a_l(j)) then
              nem=nem+1
              do i=0,3
                pem(i,nem)=p(i,j) ! Use C.o.M. frame momenta
              enddo
            endif
          enddo
        endif

        alliso=.true.

        j=0
        dowhile(j.lt.nph.and.alliso)
c Loop over all photons
          j=j+1

          ptg=pt(pgamma(0,j))
          if(ptg.lt.ptgmin)then
            passcuts=.false.
            return
          endif

c Isolate from hadronic energy
          do i=1,nQCD
            drlist(i)=sngl(iso_getdrv40(pgamma(0,j),pQCD(0,i)))
          enddo
          call sortzv(drlist,isorted,nQCD,ismode,isway,izero)
          Etsum(0)=0.d0
          nin=0
          do i=1,nQCD
            if(dble(drlist(isorted(i))).le.R0gamma)then
              nin=nin+1
              Etsum(nin)=Etsum(nin-1)+pt(pQCD(0,isorted(i)))
            endif
          enddo
          do i=1,nin
            alliso=alliso .and.
     #        Etsum(i).le.chi_gamma_iso(dble(drlist(isorted(i))),
     #                                  R0gamma,xn,epsgamma,ptg)
          enddo

c Isolate from EM energy
          if(isoEM.and.nem.gt.1)then
            do i=1,nem
              drlist(i)=sngl(iso_getdrv40(pgamma(0,j),pem(0,i)))
            enddo
            call sortzv(drlist,isorted,nem,ismode,isway,izero)
c First of list must be the photon: check this, and drop it
            if(isorted(1).ne.j.or.drlist(isorted(1)).gt.1.e-4)then
              write(*,*)'Error #1 in photon isolation'
              write(*,*)j,isorted(1),drlist(isorted(1))
              stop
            endif
            Etsum(0)=0.d0
            nin=0
            do i=2,nem
              if(dble(drlist(isorted(i))).le.R0gamma)then
                nin=nin+1
                Etsum(nin)=Etsum(nin-1)+pt(pem(0,isorted(i)))
              endif
            enddo
            do i=1,nin
              alliso=alliso .and.
     #          Etsum(i).le.chi_gamma_iso(dble(drlist(isorted(i))),
     #                                    R0gamma,xn,epsgamma,ptg)
            enddo

          endif

c End of loop over photons
        enddo

        if(.not.alliso)then
          passcuts=.false.
          return
        endif
      endif

 444    continue
c End photon isolation

c
c   call the dummy_cuts function to check plugin/user defined cuts
c

      if(.not.dummy_cuts(P))then
         passcuts=.false.
         return
      endif


C...Set couplings if event passed cuts

 21   if(.not.fixed_ren_scale) then
         call set_ren_scale(P,scale)
         if(scale.gt.0) G = SQRT(4d0*PI*ALPHAS(scale))
      endif

      if(.not.fixed_fac_scale) then
         call set_fac_scale(P,q2fact)
      endif

c
c     Here we cluster event and reset factorization and renormalization
c     scales on an event-by-event basis, as well as check xqcut for jets
c
c     Note the following condition is the first line of setclscales
c      if(xqcut.gt.0d0.or.ickkw.gt.0.or.scale.eq.0.or.q2fact(1).eq.0)then
c     Do not duplicate it since some variable are set for syscalc in the fct
        if(.not.setclscales(p,.false.))then
           cutsdone=.false.
           cutspassed=.false.
           passcuts = .false.
           if(debug) write (*,*) 'setclscales -> fails'
           return
       endif
c      endif

c     Set couplings in model files
      if(.not.fixed_ren_scale.or..not.fixed_couplings) then
         if (.not.fixed_couplings)then
            do i=0,3
               do j=1,nexternal
                  pp(i,j)=p(i,j)
               enddo
            enddo
         endif
         call update_as_param()
      endif

      IF (FIRSTTIME2) THEN
        FIRSTTIME2=.FALSE.
        write(6,*) 'alpha_s for scale ',scale,' is ', G**2/(16d0*atan(1d0))
      ENDIF

      if(debug) write (*,*) '============================='
      if(debug) write (*,*) ' EVENT PASSED THE CUTS       '
      if(debug) write (*,*) '============================='

      CUTSPASSED=.TRUE.

      RETURN
      END


C
C     FUNCTION FOR ISOLATION
C

      function iso_getdrv40(p1,p2)
      implicit none
      real*8 iso_getdrv40,p1(0:3),p2(0:3)
      real*8 iso_getdr
c
      iso_getdrv40=iso_getdr(p1(0),p1(1),p1(2),p1(3),
     #                       p2(0),p2(1),p2(2),p2(3))
      return
      end


      function iso_getdr(en1,ptx1,pty1,pl1,en2,ptx2,pty2,pl2)
      implicit none
      real*8 iso_getdr,en1,ptx1,pty1,pl1,en2,ptx2,pty2,pl2,deta,dphi,
     # iso_getpseudorap,iso_getdelphi
c
      deta=iso_getpseudorap(en1,ptx1,pty1,pl1)-
     #     iso_getpseudorap(en2,ptx2,pty2,pl2)
      dphi=iso_getdelphi(ptx1,pty1,ptx2,pty2)
      iso_getdr=sqrt(dphi**2+deta**2)
      return
      end


      function iso_getpseudorap(en,ptx,pty,pl)
      implicit none
      real*8 iso_getpseudorap,en,ptx,pty,pl,tiny,pt,eta,th
      parameter (tiny=1.d-5)
c
      pt=sqrt(ptx**2+pty**2)
      if(pt.lt.tiny.and.abs(pl).lt.tiny)then
        eta=sign(1.d0,pl)*1.d8
      else
        th=atan2(pt,pl)
        eta=-log(tan(th/2.d0))
      endif
      iso_getpseudorap=eta
      return
      end


      function iso_getdelphi(ptx1,pty1,ptx2,pty2)
      implicit none
      real*8 iso_getdelphi,ptx1,pty1,ptx2,pty2,tiny,pt1,pt2,tmp
      parameter (tiny=1.d-5)
c
      pt1=sqrt(ptx1**2+pty1**2)
      pt2=sqrt(ptx2**2+pty2**2)
      if(pt1.ne.0.d0.and.pt2.ne.0.d0)then
        tmp=ptx1*ptx2+pty1*pty2
        tmp=tmp/(pt1*pt2)
        if(abs(tmp).gt.1.d0+tiny)then
          write(*,*)'Cosine larger than 1'
          stop
        elseif(abs(tmp).ge.1.d0)then
          tmp=sign(1.d0,tmp)
        endif
        tmp=acos(tmp)
      else
        tmp=1.d8
      endif
      iso_getdelphi=tmp
      return
      end

      function chi_gamma_iso(dr,R0,xn,epsgamma,pTgamma)
c Eq.(3.4) of Phys.Lett. B429 (1998) 369-374 [hep-ph/9801442]
      implicit none
      real*8 chi_gamma_iso,dr,R0,xn,epsgamma,pTgamma
      real*8 tmp,axn
c
      axn=abs(xn)
      tmp=epsgamma*pTgamma
      if(axn.ne.0.d0)then
        tmp=tmp*( (1-cos(dr))/(1-cos(R0)) )**axn
      endif
      chi_gamma_iso=tmp
      return
      end


*
* $Id: sortzv.F,v 1.1.1.1 1996/02/15 17:49:50 mclareni Exp $
*
* $Log: sortzv.F,v $
* Revision 1.1.1.1  1996/02/15 17:49:50  mclareni
* Kernlib
*
*
c$$$#include "kerngen/pilot.h"
      SUBROUTINE SORTZV (A,INDEX,N1,MODE,NWAY,NSORT)
C
C CERN PROGLIB# M101    SORTZV          .VERSION KERNFOR  3.15  820113
C ORIG. 02/10/75
C
      DIMENSION A(N1),INDEX(N1)
C
C
      N = N1
      IF (N.LE.0)            RETURN
      IF (NSORT.NE.0) GO TO 2
      DO 1 I=1,N
    1 INDEX(I)=I
C
    2 IF (N.EQ.1)            RETURN
      IF (MODE)    10,20,30
   10 STOP 5 ! CALL SORTTI (A,INDEX,N)
      GO TO 40
C
   20 STOP 5 ! CALL SSORTTC(A,INDEX,N)
      GO TO 40
C
   30 CALL SORTTF (A,INDEX,N)
C
   40 IF (NWAY.EQ.0) GO TO 50
      N2 = N/2
      DO 41 I=1,N2
      ISWAP = INDEX(I)
      K = N+1-I
      INDEX(I) = INDEX(K)
   41 INDEX(K) = ISWAP
   50 RETURN
      END
*     ========================================
      SUBROUTINE SORTTF (A,INDEX,N1)
C
      DIMENSION A(N1),INDEX(N1)
C
      N = N1
      DO 3 I1=2,N
      I3 = I1
      I33 = INDEX(I3)
      AI = A(I33)
    1 I2 = I3/2
      IF (I2) 3,3,2
    2 I22 = INDEX(I2)
      IF (AI.LE.A (I22)) GO TO 3
      INDEX (I3) = I22
      I3 = I2
      GO TO 1
    3 INDEX (I3) = I33
    4 I3 = INDEX (N)
      INDEX (N) = INDEX (1)
      AI = A(I3)
      N = N-1
      IF (N-1) 12,12,5
    5 I1 = 1
    6 I2 = I1 + I1
      IF (I2.LE.N) I22= INDEX(I2)
      IF (I2-N) 7,9,11
    7 I222 = INDEX (I2+1)
      IF (A(I22)-A(I222)) 8,9,9
    8 I2 = I2+1
      I22 = I222
    9 IF (AI-A(I22)) 10,11,11
   10 INDEX(I1) = I22
      I1 = I2
      GO TO 6
   11 INDEX (I1) = I3
      GO TO 4
   12 INDEX (1) = I3
      RETURN
      END
*     ========================================
      SUBROUTINE SORTTI (A,INDEX,N1)
C
      INTEGER A,AI
      DIMENSION A(N1),INDEX(N1)
C
      N = N1
      DO 3 I1=2,N
      I3 = I1
      I33 = INDEX(I3)
      AI = A(I33)
    1 I2 = I3/2
      IF (I2) 3,3,2
    2 I22 = INDEX(I2)
      IF (AI.LE.A (I22)) GO TO 3
      INDEX (I3) = I22
      I3 = I2
      GO TO 1
    3 INDEX (I3) = I33
    4 I3 = INDEX (N)
      INDEX (N) = INDEX (1)
      AI = A(I3)
      N = N-1
      IF (N-1) 12,12,5
    5 I1 = 1
    6 I2 = I1 + I1
      IF (I2.LE.N) I22= INDEX(I2)
      IF (I2-N) 7,9,11
    7 I222 = INDEX (I2+1)
      IF (A(I22)-A(I222)) 8,9,9
    8 I2 = I2+1
      I22 = I222
    9 IF (AI-A(I22)) 10,11,11
   10 INDEX(I1) = I22
      I1 = I2
      GO TO 6
   11 INDEX (I1) = I3
      GO TO 4
   12 INDEX (1) = I3
      RETURN
      END
*     ========================================
      SUBROUTINE SORTTC (A,INDEX,N1)
C
      INTEGER A,AI
      DIMENSION A(N1),INDEX(N1)
C
      N = N1
      DO 3 I1=2,N
      I3 = I1
      I33 = INDEX(I3)
      AI = A(I33)
    1 I2 = I3/2
      IF (I2) 3,3,2
    2 I22 = INDEX(I2)
      IF(ICMPCH(AI,A(I22)))3,3,21
   21 INDEX (I3) = I22
      I3 = I2
      GO TO 1
    3 INDEX (I3) = I33
    4 I3 = INDEX (N)
      INDEX (N) = INDEX (1)
      AI = A(I3)
      N = N-1
      IF (N-1) 12,12,5
    5 I1 = 1
    6 I2 = I1 + I1
      IF (I2.LE.N) I22= INDEX(I2)
      IF (I2-N) 7,9,11
    7 I222 = INDEX (I2+1)
      IF (ICMPCH(A(I22),A(I222))) 8,9,9
    8 I2 = I2+1
      I22 = I222
    9 IF (ICMPCH(AI,A(I22))) 10,11,11
   10 INDEX(I1) = I22
      I1 = I2
      GO TO 6
   11 INDEX (I1) = I3
      GO TO 4
   12 INDEX (1) = I3
      RETURN
      END
*     ========================================
      FUNCTION ICMPCH(IC1,IC2)
C     FUNCTION TO COMPARE TWO 4 CHARACTER EBCDIC STRINGS - IC1,IC2
C     ICMPCH=-1 IF HEX VALUE OF IC1 IS LESS THAN IC2
C     ICMPCH=0  IF HEX VALUES OF IC1 AND IC2 ARE THE SAME
C     ICMPCH=+1 IF HEX VALUES OF IC1 IS GREATER THAN IC2
      I1=IC1
      I2=IC2
      IF(I1.GE.0.AND.I2.GE.0)GOTO 40
      IF(I1.GE.0)GOTO 60
      IF(I2.GE.0)GOTO 80
      I1=-I1
      I2=-I2
      IF(I1-I2)80,70,60
 40   IF(I1-I2)60,70,80
 60   ICMPCH=-1
      RETURN
 70   ICMPCH=0
      RETURN
 80   ICMPCH=1
      RETURN
      END

c************************************************************************
c     Returns pTLund (i.e. the Pythia8 evolution variable) between two 
c     particles with momenta prad and pemt with momentum prec as spectator
c************************************************************************

      DOUBLE PRECISION FUNCTION RHOPYTHIA(PRAD, PEMT, PREC, FLAVRAD,
     &                                        FLAVEMT, RADTYPE, RECTYPE)

       IMPLICIT NONE
c
c     Arguments
c
      DOUBLE PRECISION PRAD(0:3),PEMT(0:3), PREC(0:3)
      INTEGER FLAVRAD, FLAVEMT, RADTYPE,RECTYPE
c
c     Local
c
      DOUBLE PRECISION Q(0:3),SUM(0:3), qBR(0:3), qAR(0:3)
      DOUBLE PRECISION Q2, m2Rad, m2Emt, m2Dip, qBR2, qAR2, x1, x2, z
      DOUBLE PRECISION m2RadAft, m2EmtAft, m2Rec, m2RadBef, m2ar, rescale
      DOUBLE PRECISION TEMP, lambda13, k1, k3, m2Final
      DOUBLE PRECISION m0u, m0d, m0c, m0s, m0t, m0b, m0w, m0z, m0x
      DOUBLE PRECISION PRECAFT(0:3)
      INTEGER emtsign
      INTEGER idRadBef
      LOGICAL allowed

c-----
c  Begin Code
c-----

C     Set masses. Currently no way of getting those?
      m0u = 0.0
      m0d = 0.0
      m0c = 1.5
      m0s = 0.0
      m0b = 4.7 
      m0t = 172.5
      m0w = 80.4
      m0z = 91.188
      m0x = 400.0

C     Store recoiler momentum (since FI splittings require recoiler
C     rescaling)
      PRECAFT(0) = PREC(0)
      PRECAFT(1) = PREC(1)
      PRECAFT(2) = PREC(2)
      PRECAFT(3) = PREC(3)
C     Get sign of emitted momentum
      emtsign = 1
      if(radtype .eq. -1) emtsign = -1

C     Get virtuality
      Q(0) = pRad(0) + emtsign*pEmt(0)
      Q(1) = pRad(1) + emtsign*pEmt(1)
      Q(2) = pRad(2) + emtsign*pEmt(2)
      Q(3) = pRad(3) + emtsign*pEmt(3)
      Q2   = emtsign * ( Q(0)**2 - Q(1)**2 - Q(2)**2 - Q(3)**2 );

C     Reset allowed
      allowed = .true.

C     Splitting not possible for negative virtuality.
      if ( Q2 .lt. 0.0 ) allowed = .false.

C     Try to reconstruct flavour of radiator before emission.
      idRadBef = 0
C     gluon radiation: idBef = idAft
      if (abs(flavEmt) .eq. 21 .or. abs(flavEmt) .eq. 22 ) idRadBef=flavRad
C     final state gluon splitting: idBef = 21
      if (radtype .eq.  1 .and. flavEmt .eq. -flavRad) idRadBef=21
C     final state quark -> gluon conversion
      if (radtype .eq.  1 .and. abs(flavEmt) .lt. 10 .and. flavRad .eq. 21) idRadBef=flavEmt
C     initial state gluon splitting: idBef = -idEmt
      if (radtype .eq. -1 .and. abs(flavEmt) .lt. 10 .and. flavRad .eq. 21) idRadBef=-flavEmt
C     initial state gluon -> quark conversion
      if (radtype .eq. -1 .and. abs(flavEmt) .lt. 10 .and. flavRad .eq. flavEmt) idRadBef=21
C     W-boson radiation
      if (flavEmt .eq.  24) idRadBef = flavRad+1
      if (flavEmt .eq. -24) idRadBef = flavRad-1

C     Set particle masses.
      m2RadAft = 0.0
      m2EmtAft = 0.0
      m2Rec    = 0.0
      m2RadBef = 0.0

      m2RadAft = pRad(0)*pRad(0)-pRad(1)*pRad(1)-pRad(2)*pRad(2)-pRad(3)*pRad(3)
      m2EmtAft = pEmt(0)*pEmt(0)-pEmt(1)*pEmt(1)-pEmt(2)*pEmt(2)-pEmt(3)*pEmt(3)
      m2Rec    = pRec(0)*pRec(0)-pRec(1)*pRec(1)-pRec(2)*pRec(2)-pRec(3)*pRec(3)

      if (m2RadAft .lt. 1d-4) m2RadAft = 0.0
      if (m2EmtAft .lt. 1d-4) m2EmtAft = 0.0
      if (m2Rec    .lt. 1d-4) m2Rec    = 0.0

      if (abs(flavRad) .ne. 21 .and. abs(flavRad) .ne. 22 .and.
     &    abs(flavEmt) .ne. 24 .and.
     &    abs(flavRad) .ne. abs(flavEmt)) then
        m2RadBef = m2RadAft
      else if (abs(flavEmt) .eq. 24) then
        if (idRadBef .ne. 0) then
          if( abs(idRadBef) .eq. 4 ) m2RadBef       = m0c**2
          if( abs(idRadBef) .eq. 5 ) m2RadBef       = m0b**2
          if( abs(idRadBef) .eq. 6 ) m2RadBef       = m0t**2
          if( abs(idRadBef) .eq. 9000001 ) m2RadBef = m0x**2
        endif
      else if (radtype .eq. -1) then
        if (abs(flavRad) .eq. 21 .and. abs(flavEmt) .eq. 21) m2RadBef = m2EmtAft
      endif

C     Calculate dipole mass for final-state radiation.
      m2Final = 0.0
      m2Final = m2Final + (pRad(0) + pRec(0) + pEmt(0))**2
      m2Final = m2Final - (pRad(1) + pRec(1) + pEmt(1))**2
      m2Final = m2Final - (pRad(2) + pRec(2) + pEmt(2))**2
      m2Final = m2Final - (pRad(3) + pRec(3) + pEmt(3))**2

C     Final state splitting not possible for negative dipole mass.
      if ( radtype .eq. 1 .and. m2Final .lt. 0.0 ) allowed = .false.

C     Rescale recoiler for final-intial splittings.
      rescale = 1.0
      if (radtype .eq. 1 .and. rectype .eq. -1) then
        m2ar = m2Final - 2.0*Q2 + 2.0*m2RadBef
        rescale = (1.0 - (Q2 - m2RadBef) / (m2ar-m2RadBef))
     &           /(1.0 + (Q2 - m2RadBef) / (m2ar-m2RadBef))
        pRecAft(0) = pRecAft(0)*rescale
        pRecAft(1) = pRecAft(1)*rescale
        pRecAft(2) = pRecAft(2)*rescale
        pRecAft(3) = pRecAft(3)*rescale
      endif

C     Final-initial splitting not possible for negative rescaling.
      if ( rescale .lt. 0.0 ) allowed = .false.

C     Construct dipole momentum for FSR.
      sum(0) = pRad(0) + pRecAft(0) + pEmt(0)
      sum(1) = pRad(1) + pRecAft(1) + pEmt(1)
      sum(2) = pRad(2) + pRecAft(2) + pEmt(2)
      sum(3) = pRad(3) + pRecAft(3) + pEmt(3)
      m2Dip = sum(0)**2 - sum(1)**2 - sum(2)**2 - sum(3)**2

C     Construct 2->3 variables for FSR
      x1     = 2. * ( sum(0)*pRad(0) - sum(1)*pRad(1)
     &             -  sum(2)*pRad(2) - sum(3)*pRad(3) ) / m2Dip
      x2     = 2. * ( sum(0)*pRecAft(0) - sum(1)*pRecAft(1)
     &             -  sum(2)*pRecAft(2) - sum(3)*pRecAft(3) ) / m2Dip

C     Final state splitting not possible for ill-defined
C     3-body-variables.
      if ( radtype .eq. 1 .and. x1 .lt. 0.0 ) allowed = .false.
      if ( radtype .eq. 1 .and. x1 .gt. 1.0 ) allowed = .false.
      if ( radtype .eq. 1 .and. x2 .lt. 0.0 ) allowed = .false.
      if ( radtype .eq. 1 .and. x2 .gt. 1.0 ) allowed = .false.

C     Auxiliary variables for massive FSR
      lambda13 = DSQRT( (Q2 - m2RadAft - m2EmtAft )**2 - 4.0 * m2RadAft*m2EmtAft)
      k1 = ( Q2 - lambda13 + (m2EmtAft - m2RadAft ) ) / ( 2.0 * Q2)
      k3 = ( Q2 - lambda13 - (m2EmtAft - m2RadAft ) ) / ( 2.0 * Q2)

C     Construct momenta of dipole before/after splitting for ISR
      qBR(0) = pRad(0) + pRec(0) - pEmt(0)
      qBR(1) = pRad(1) + pRec(1) - pEmt(1)
      qBR(2) = pRad(2) + pRec(2) - pEmt(2)
      qBR(3) = pRad(3) + pRec(3) - pEmt(3)
      qBR2   = qBR(0)**2 - qBR(1)**2 - qBR(2)**2 - qBR(3)**2

      qAR(0) = pRad(0) + pRec(0)
      qAR(1) = pRad(1) + pRec(1)
      qAR(2) = pRad(2) + pRec(2)
      qAR(3) = pRad(3) + pRec(3)
      qAR2   = qAR(0)**2 - qAR(1)**2 - qAR(2)**2 - qAR(3)**2

C     Calculate z of splitting, different for FSR and ISR
      z = 1.0 / (1.0 - k1 -k3) * ( x1 / (2.0-x2) - k3)
      if(radtype .eq. -1 ) z = qBR2 / qAR2;

C     Splitting not possible for ill-defined energy sharing.
      if ( z .lt. 0.0 .or. z .gt. 1.0 ) allowed = .false.

C     pT^2 = separation * virtuality (corrected with mass for FSR)
      if (radtype .eq.  1) temp = z*(1-z)*(Q2 - m2RadBef)
      if (radtype .eq. -1) temp = (1-z)*Q2

C     Check threshold in ISR
      if (radtype .ne. 1) then
        if ((abs(flavRad) .eq. 4 .or. abs(flavEmt) .eq. 4)
     &    .and. dsqrt(temp) .le. 2.0*m0c**2 ) temp = (1.-z)*(Q2+m0c**2)
        if ((abs(flavRad) .eq. 5 .or. abs(flavEmt) .eq. 5)
     &    .and. dsqrt(temp) .le. 2.0*m0b**2 ) temp = (1.-z)*(Q2+m0b**2)
      endif

C     Kinematically impossible splittings should not be included in the
C     pT definition!
      if( .not. allowed) temp = 1d15

      if(temp .lt. 0.0) temp = 0.0

C     Return pT
      rhoPythia = dsqrt(temp);

      RETURN
      END

      subroutine setrun
c----------------------------------------------------------------------
c     Sets the run parameters reading them from the run_card.dat
c
c 1. PDF set
c 2. Collider parameters
c 3. cuts
c---------------------------------------------------------------------- 
      implicit none
c
c     include
c
      include 'genps.inc'
      include 'PDF/pdf.inc'
      include 'run.inc'
      include 'alfas.inc'
c
c     local
c
      integer npara
      character*20 param(maxpara),value(maxpara)
      character*20 ctemp
      integer k,i,l1,l2
      character*132 buff
      real*8 sf1,sf2
      integer lp1,lp2
      real*8 eb1,eb2
      real*8 pb1,pb2
C
C     input cuts
C
      include 'cuts.inc'
c
c----------
c     start
c----------
c
c     read the run_card.dat
c
      call load_para(npara,param,value)

c*********************************************************************
c     Jet measure cuts                                               *
c*********************************************************************

      call get_real   (npara,param,value," xqcut ",xqcut,0d0)

c************************************************************************     
c    Collider energy and type                                           *
c************************************************************************     
c     lpp  = -1 (antiproton), 0 (no pdf), 1 (proton)
c     lpp  =  2 (proton emitting a photon without breaking)
c     lpp  =  3 (electron emitting a photon)
c     ebeam= energy of each beam in GeV

      call get_integer(npara,param,value," lpp1 "   ,lp1,1  )
      call get_integer(npara,param,value," lpp2 "   ,lp2,1  )
      call get_real   (npara,param,value," ebeam1 " ,eb1,7d3)
      call get_real   (npara,param,value," ebeam2 " ,eb2,7d3)
     
      lpp(1)=lp1
      lpp(2)=lp2
      ebeam(1)=eb1
      ebeam(2)=eb2

c************************************************************************     
c    Collider pdf                                                       *
c************************************************************************     

      call get_string (npara,param,value," pdlabel ",pdlabel,'cteq6l1')
c
c     if lhapdf is used the following number identifies the set
c
      if(pdlabel.eq.'''lhapdf''')
     $     call get_integer(npara,param,value," lhaid  ",lhaid,10042)

      call pdfwrap

      return
 99   write(*,*) 'error in reading'
      return
      end

      SUBROUTINE SMATRIX25(P,ANS)
C     
C     Generated by MadGraph5_aMC@NLO v. 2.8.2, 2020-10-30
C     By the MadGraph5_aMC@NLO Development Team
C     Visit launchpad.net/madgraph5 and amcatnlo.web.cern.ch
C     
C     MadGraph5_aMC@NLO for Madevent Version
C     
C     Returns amplitude squared -- no average over initial
C      state/symmetry factor
C     and helicities
C     for the point in phase space P(0:3,NEXTERNAL)
C     
C     Process: c~ b~ > t t~ c~ b~ NP<=2 QCD<=4 QED=0 @2
C     
      USE DISCRETESAMPLER
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INCLUDE 'genps.inc'
      INCLUDE 'maxconfigs.inc'
      INCLUDE 'nexternal.inc'
      INCLUDE 'maxamps.inc'
      INTEGER                 NCOMB
      PARAMETER (             NCOMB=64)
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=45)
      INTEGER    NDIAGS
      PARAMETER (NDIAGS=29)
      INTEGER    THEL
      PARAMETER (THEL=2*NCOMB)
C     
C     ARGUMENTS 
C     
      REAL*8 P(0:3,NEXTERNAL),ANS
C     
C     global (due to reading writting) 
C     
      LOGICAL GOODHEL(NCOMB,2)
      INTEGER NTRY(2)
      COMMON/BLOCK_GOODHEL/NTRY,GOODHEL

C     
C     LOCAL VARIABLES 
C     
      INTEGER NHEL(NEXTERNAL,NCOMB)
      INTEGER ISHEL(2)
      REAL*8 T,MATRIX25
      REAL*8 R,SUMHEL,TS(NCOMB)
      INTEGER I,IDEN
      INTEGER JC(NEXTERNAL),II
      REAL*8 HWGT, XTOT, XTRY, XREJ, XR, YFRAC(0:NCOMB)
      INTEGER NGOOD(2), IGOOD(NCOMB,2)
      INTEGER JHEL(2), J, JJ
      INTEGER THIS_NTRY(2)
      SAVE THIS_NTRY
      INTEGER NB_FAIL
      SAVE NB_FAIL
      DATA THIS_NTRY /0,0/
      DATA NB_FAIL /0/

C     
C     This is just to temporarily store the reference grid for
C      helicity of the DiscreteSampler so as to obtain its number of
C      entries with ref_helicity_grid%n_tot_entries
      TYPE(SAMPLEDDIMENSION) REF_HELICITY_GRID
C     
C     GLOBAL VARIABLES
C     
      DOUBLE PRECISION AMP2(MAXAMPS), JAMP2(0:MAXFLOW)
      COMMON/TO_AMPS/  AMP2,       JAMP2

      CHARACTER*101         HEL_BUFF
      COMMON/TO_HELICITY/  HEL_BUFF

      INTEGER NB_SPIN_STATE_IN(2)
      COMMON /NB_HEL_STATE/ NB_SPIN_STATE_IN

      INTEGER IMIRROR
      COMMON/TO_MIRROR/ IMIRROR

      REAL*8 POL(2)
      COMMON/TO_POLARIZATION/ POL

      DOUBLE PRECISION SMALL_WIDTH_TREATMENT
      COMMON/NARROW_WIDTH/SMALL_WIDTH_TREATMENT

      INTEGER          ISUM_HEL
      LOGICAL                    MULTI_CHANNEL
      COMMON/TO_MATRIX/ISUM_HEL, MULTI_CHANNEL
      INTEGER MAPCONFIG(0:LMAXCONFIGS), ICONFIG
      COMMON/TO_MCONFIGS/MAPCONFIG, ICONFIG
      INTEGER SUBDIAG(MAXSPROC),IB(2)
      COMMON/TO_SUB_DIAG/SUBDIAG,IB
      DATA XTRY, XREJ /0,0/
      DATA NGOOD /0,0/
      DATA ISHEL/0,0/
      SAVE YFRAC, IGOOD, JHEL
      DATA (NHEL(I,   1),I=1,6) /-1,-1,-1, 1, 1, 1/
      DATA (NHEL(I,   2),I=1,6) /-1,-1,-1, 1, 1,-1/
      DATA (NHEL(I,   3),I=1,6) /-1,-1,-1, 1,-1, 1/
      DATA (NHEL(I,   4),I=1,6) /-1,-1,-1, 1,-1,-1/
      DATA (NHEL(I,   5),I=1,6) /-1,-1,-1,-1, 1, 1/
      DATA (NHEL(I,   6),I=1,6) /-1,-1,-1,-1, 1,-1/
      DATA (NHEL(I,   7),I=1,6) /-1,-1,-1,-1,-1, 1/
      DATA (NHEL(I,   8),I=1,6) /-1,-1,-1,-1,-1,-1/
      DATA (NHEL(I,   9),I=1,6) /-1,-1, 1, 1, 1, 1/
      DATA (NHEL(I,  10),I=1,6) /-1,-1, 1, 1, 1,-1/
      DATA (NHEL(I,  11),I=1,6) /-1,-1, 1, 1,-1, 1/
      DATA (NHEL(I,  12),I=1,6) /-1,-1, 1, 1,-1,-1/
      DATA (NHEL(I,  13),I=1,6) /-1,-1, 1,-1, 1, 1/
      DATA (NHEL(I,  14),I=1,6) /-1,-1, 1,-1, 1,-1/
      DATA (NHEL(I,  15),I=1,6) /-1,-1, 1,-1,-1, 1/
      DATA (NHEL(I,  16),I=1,6) /-1,-1, 1,-1,-1,-1/
      DATA (NHEL(I,  17),I=1,6) /-1, 1,-1, 1, 1, 1/
      DATA (NHEL(I,  18),I=1,6) /-1, 1,-1, 1, 1,-1/
      DATA (NHEL(I,  19),I=1,6) /-1, 1,-1, 1,-1, 1/
      DATA (NHEL(I,  20),I=1,6) /-1, 1,-1, 1,-1,-1/
      DATA (NHEL(I,  21),I=1,6) /-1, 1,-1,-1, 1, 1/
      DATA (NHEL(I,  22),I=1,6) /-1, 1,-1,-1, 1,-1/
      DATA (NHEL(I,  23),I=1,6) /-1, 1,-1,-1,-1, 1/
      DATA (NHEL(I,  24),I=1,6) /-1, 1,-1,-1,-1,-1/
      DATA (NHEL(I,  25),I=1,6) /-1, 1, 1, 1, 1, 1/
      DATA (NHEL(I,  26),I=1,6) /-1, 1, 1, 1, 1,-1/
      DATA (NHEL(I,  27),I=1,6) /-1, 1, 1, 1,-1, 1/
      DATA (NHEL(I,  28),I=1,6) /-1, 1, 1, 1,-1,-1/
      DATA (NHEL(I,  29),I=1,6) /-1, 1, 1,-1, 1, 1/
      DATA (NHEL(I,  30),I=1,6) /-1, 1, 1,-1, 1,-1/
      DATA (NHEL(I,  31),I=1,6) /-1, 1, 1,-1,-1, 1/
      DATA (NHEL(I,  32),I=1,6) /-1, 1, 1,-1,-1,-1/
      DATA (NHEL(I,  33),I=1,6) / 1,-1,-1, 1, 1, 1/
      DATA (NHEL(I,  34),I=1,6) / 1,-1,-1, 1, 1,-1/
      DATA (NHEL(I,  35),I=1,6) / 1,-1,-1, 1,-1, 1/
      DATA (NHEL(I,  36),I=1,6) / 1,-1,-1, 1,-1,-1/
      DATA (NHEL(I,  37),I=1,6) / 1,-1,-1,-1, 1, 1/
      DATA (NHEL(I,  38),I=1,6) / 1,-1,-1,-1, 1,-1/
      DATA (NHEL(I,  39),I=1,6) / 1,-1,-1,-1,-1, 1/
      DATA (NHEL(I,  40),I=1,6) / 1,-1,-1,-1,-1,-1/
      DATA (NHEL(I,  41),I=1,6) / 1,-1, 1, 1, 1, 1/
      DATA (NHEL(I,  42),I=1,6) / 1,-1, 1, 1, 1,-1/
      DATA (NHEL(I,  43),I=1,6) / 1,-1, 1, 1,-1, 1/
      DATA (NHEL(I,  44),I=1,6) / 1,-1, 1, 1,-1,-1/
      DATA (NHEL(I,  45),I=1,6) / 1,-1, 1,-1, 1, 1/
      DATA (NHEL(I,  46),I=1,6) / 1,-1, 1,-1, 1,-1/
      DATA (NHEL(I,  47),I=1,6) / 1,-1, 1,-1,-1, 1/
      DATA (NHEL(I,  48),I=1,6) / 1,-1, 1,-1,-1,-1/
      DATA (NHEL(I,  49),I=1,6) / 1, 1,-1, 1, 1, 1/
      DATA (NHEL(I,  50),I=1,6) / 1, 1,-1, 1, 1,-1/
      DATA (NHEL(I,  51),I=1,6) / 1, 1,-1, 1,-1, 1/
      DATA (NHEL(I,  52),I=1,6) / 1, 1,-1, 1,-1,-1/
      DATA (NHEL(I,  53),I=1,6) / 1, 1,-1,-1, 1, 1/
      DATA (NHEL(I,  54),I=1,6) / 1, 1,-1,-1, 1,-1/
      DATA (NHEL(I,  55),I=1,6) / 1, 1,-1,-1,-1, 1/
      DATA (NHEL(I,  56),I=1,6) / 1, 1,-1,-1,-1,-1/
      DATA (NHEL(I,  57),I=1,6) / 1, 1, 1, 1, 1, 1/
      DATA (NHEL(I,  58),I=1,6) / 1, 1, 1, 1, 1,-1/
      DATA (NHEL(I,  59),I=1,6) / 1, 1, 1, 1,-1, 1/
      DATA (NHEL(I,  60),I=1,6) / 1, 1, 1, 1,-1,-1/
      DATA (NHEL(I,  61),I=1,6) / 1, 1, 1,-1, 1, 1/
      DATA (NHEL(I,  62),I=1,6) / 1, 1, 1,-1, 1,-1/
      DATA (NHEL(I,  63),I=1,6) / 1, 1, 1,-1,-1, 1/
      DATA (NHEL(I,  64),I=1,6) / 1, 1, 1,-1,-1,-1/
      DATA IDEN/36/

C     To be able to control when the matrix<i> subroutine can add
C      entries to the grid for the MC over helicity configuration
      LOGICAL ALLOW_HELICITY_GRID_ENTRIES
      COMMON/TO_ALLOW_HELICITY_GRID_ENTRIES/ALLOW_HELICITY_GRID_ENTRIES

C     ----------
C     BEGIN CODE
C     ----------

      NTRY(IMIRROR)=NTRY(IMIRROR)+1
      THIS_NTRY(IMIRROR) = THIS_NTRY(IMIRROR)+1
      DO I=1,NEXTERNAL
        JC(I) = +1
      ENDDO

      IF (MULTI_CHANNEL) THEN
        DO I=1,NDIAGS
          AMP2(I)=0D0
        ENDDO
        JAMP2(0)=6
        DO I=1,INT(JAMP2(0))
          JAMP2(I)=0D0
        ENDDO
      ENDIF
      ANS = 0D0
      WRITE(HEL_BUFF,'(20I5)') (0,I=1,NEXTERNAL)
      DO I=1,NCOMB
        TS(I)=0D0
      ENDDO

        !   If the helicity grid status is 0, this means that it is not yet initialized.
        !   If HEL_PICKED==-1, this means that calls to other matrix<i> where in initialization mode as well for the helicity.
      IF ((ISHEL(IMIRROR).EQ.0.AND.ISUM_HEL.EQ.0)
     $ .OR.(DS_GET_DIM_STATUS('Helicity').EQ.0).OR.(HEL_PICKED.EQ.-1))
     $  THEN
        DO I=1,NCOMB
          IF (GOODHEL(I,IMIRROR) .OR. NTRY(IMIRROR)
     $     .LE.MAXTRIES.OR.(ISUM_HEL.NE.0).OR.THIS_NTRY(IMIRROR).LE.2)
     $      THEN
            T=MATRIX25(P ,NHEL(1,I),JC(1))
            DO JJ=1,NINCOMING
              IF(POL(JJ).NE.1D0.AND.NHEL(JJ,I).EQ.INT(SIGN(1D0,POL(JJ))
     $         )) THEN
                T=T*ABS(POL(JJ))*NB_SPIN_STATE_IN(JJ)/2D0  ! NB_SPIN_STATE(JJ)/2d0 is added for polarised beam
              ELSE IF(POL(JJ).NE.1D0)THEN
                T=T*(2D0-ABS(POL(JJ)))*NB_SPIN_STATE_IN(JJ)/2D0
              ENDIF
            ENDDO
            IF (ISUM_HEL.NE.0.AND.DS_GET_DIM_STATUS('Helicity')
     $       .EQ.0.AND.ALLOW_HELICITY_GRID_ENTRIES) THEN
              CALL DS_ADD_ENTRY('Helicity',I,T)
            ENDIF
            ANS=ANS+DABS(T)
            TS(I)=T
          ENDIF
        ENDDO
        IF(NTRY(IMIRROR).EQ.(MAXTRIES+1)) THEN
          CALL RESET_CUMULATIVE_VARIABLE()  ! avoid biais of the initialization
        ENDIF
        IF (ISUM_HEL.NE.0) THEN
            !         We set HEL_PICKED to -1 here so that later on, the call to DS_add_point in dsample.f does not add anything to the grid since it was already done here.
          HEL_PICKED = -1
            !         For safety, hardset the helicity sampling jacobian to 0.0d0 to make sure it is not .
          HEL_JACOBIAN   = 1.0D0
            !         We don't want to re-update the helicity grid if it was already updated by another matrix<i>, so we make sure that the reference grid is empty.
          REF_HELICITY_GRID = DS_GET_DIMENSION(REF_GRID,'Helicity')
          IF((DS_GET_DIM_STATUS('Helicity').EQ.1)
     $     .AND.(REF_HELICITY_GRID%N_TOT_ENTRIES.EQ.0)) THEN
              !           If we finished the initialization we can update the grid so as to start sampling over it.
              !           However the grid will now be filled by dsample with different kind of weights (including pdf, flux, etc...) so by setting the grid_mode of the reference grid to 'initialization' we make sure it will be overwritten (as opposed to 'combined') by the running grid at the next update.
            CALL DS_UPDATE_GRID('Helicity')
            CALL DS_SET_GRID_MODE('Helicity','init')
          ENDIF
        ELSE
          JHEL(IMIRROR) = 1
          IF(NTRY(IMIRROR).LE.MAXTRIES.OR.THIS_NTRY(IMIRROR).LE.2)THEN
            DO I=1,NCOMB
              IF (.NOT.GOODHEL(I,IMIRROR) .AND. (DABS(TS(I)).GT.ANS
     $         *LIMHEL/NCOMB)) THEN
                GOODHEL(I,IMIRROR)=.TRUE.
                NGOOD(IMIRROR) = NGOOD(IMIRROR) +1
                IGOOD(NGOOD(IMIRROR),IMIRROR) = I
                PRINT *,'Added good helicity ',I,TS(I)*NCOMB/ANS,' in'
     $           //' event ',NTRY(IMIRROR), 'local:',THIS_NTRY(IMIRROR)
              ENDIF
            ENDDO
          ENDIF
          IF(NTRY(IMIRROR).EQ.MAXTRIES)THEN
            ISHEL(IMIRROR)=MIN(ISUM_HEL,NGOOD(IMIRROR))
          ENDIF
        ENDIF
      ELSE  ! random helicity 
C       The helicity configuration was chosen already by genps and put
C        in a common block defined in genps.inc.
        I = HEL_PICKED

        T=MATRIX25(P ,NHEL(1,I),JC(1))

        DO JJ=1,NINCOMING
          IF(POL(JJ).NE.1D0.AND.NHEL(JJ,I).EQ.INT(SIGN(1D0,POL(JJ))))
     $      THEN
            T=T*ABS(POL(JJ))
          ELSE IF(POL(JJ).NE.1D0)THEN
            T=T*(2D0-ABS(POL(JJ)))
          ENDIF
        ENDDO
C       Always one helicity at a time
        ANS = T
C       Include the Jacobian from helicity sampling
        ANS = ANS * HEL_JACOBIAN

        WRITE(HEL_BUFF,'(20i5)')(NHEL(II,I),II=1,NEXTERNAL)
      ENDIF
      IF (ANS.NE.0D0.AND.(ISUM_HEL .NE. 1.OR.HEL_PICKED.EQ.-1)) THEN
        CALL RANMAR(R)
        SUMHEL=0D0
        DO I=1,NCOMB
          SUMHEL=SUMHEL+DABS(TS(I))/ANS
          IF(R.LT.SUMHEL)THEN
            WRITE(HEL_BUFF,'(20i5)')(NHEL(II,I),II=1,NEXTERNAL)
C           Set right sign for ANS, based on sign of chosen helicity
            ANS=DSIGN(ANS,TS(I))
            GOTO 10
          ENDIF
        ENDDO
 10     CONTINUE
      ENDIF
      IF (MULTI_CHANNEL) THEN
        XTOT=0D0
        DO I=1,NDIAGS
          XTOT=XTOT+AMP2(I)
        ENDDO
        IF (XTOT.NE.0D0) THEN
          ANS=ANS*AMP2(SUBDIAG(25))/XTOT
        ELSE IF(ANS.NE.0D0) THEN
          IF(NB_FAIL.GE.10)THEN
            WRITE(*,*) 'Problem in the multi-channeling. All amp2 are'
     $       //' zero but not the total matrix-element'

            STOP 1
          ELSE
            NB_FAIL = NB_FAIL +1
          ENDIF
        ENDIF
      ENDIF
      ANS=ANS/DBLE(IDEN)
      END


      REAL*8 FUNCTION MATRIX25(P,NHEL,IC)
C     
C     Generated by MadGraph5_aMC@NLO v. 2.8.2, 2020-10-30
C     By the MadGraph5_aMC@NLO Development Team
C     Visit launchpad.net/madgraph5 and amcatnlo.web.cern.ch
C     
C     Returns amplitude squared summed/avg over colors
C     for the point with external lines W(0:6,NEXTERNAL)
C     
C     Process: c~ b~ > t t~ c~ b~ NP<=2 QCD<=4 QED=0 @2
C     
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=45)
      INCLUDE 'genps.inc'
      INCLUDE 'nexternal.inc'
      INCLUDE 'maxamps.inc'
      INTEGER    NWAVEFUNCS,     NCOLOR
      PARAMETER (NWAVEFUNCS=13, NCOLOR=6)
      REAL*8     ZERO
      PARAMETER (ZERO=0D0)
      COMPLEX*16 IMAG1
      PARAMETER (IMAG1=(0D0,1D0))
      INTEGER NAMPSO, NSQAMPSO
      PARAMETER (NAMPSO=1, NSQAMPSO=1)
      LOGICAL CHOSEN_SO_CONFIGS(NSQAMPSO)
      DATA CHOSEN_SO_CONFIGS/.TRUE./
      SAVE CHOSEN_SO_CONFIGS
C     
C     ARGUMENTS 
C     
      REAL*8 P(0:3,NEXTERNAL)
      INTEGER NHEL(NEXTERNAL), IC(NEXTERNAL)
C     
C     LOCAL VARIABLES 
C     
      INTEGER I,J,M,N
      COMPLEX*16 ZTEMP
      REAL*8 DENOM(NCOLOR), CF(NCOLOR,NCOLOR)
      COMPLEX*16 AMP(NGRAPHS), JAMP(NCOLOR,NAMPSO)
      COMPLEX*16 W(6,NWAVEFUNCS)
C     Needed for v4 models
      COMPLEX*16 DUM0,DUM1
      DATA DUM0, DUM1/(0D0, 0D0), (1D0, 0D0)/

      DOUBLE PRECISION FK_ZERO
      SAVE FK_ZERO

      LOGICAL FIRST
      DATA FIRST /.TRUE./
      SAVE FIRST
C     
C     FUNCTION
C     
      INTEGER SQSOINDEX25
C     
C     GLOBAL VARIABLES
C     
      DOUBLE PRECISION AMP2(MAXAMPS), JAMP2(0:MAXFLOW)
      COMMON/TO_AMPS/  AMP2,       JAMP2
      INCLUDE 'coupl.inc'

      DOUBLE PRECISION SMALL_WIDTH_TREATMENT
      COMMON/NARROW_WIDTH/SMALL_WIDTH_TREATMENT
C     
C     COLOR DATA
C     
      DATA DENOM(1)/1/
      DATA (CF(I,  1),I=  1,  6) /   27,    9,    9,    3,    3,    9/
C     1 T(1,4) T(2,5) T(3,6)
      DATA DENOM(2)/1/
      DATA (CF(I,  2),I=  1,  6) /    9,   27,    3,    9,    9,    3/
C     1 T(1,4) T(2,6) T(3,5)
      DATA DENOM(3)/1/
      DATA (CF(I,  3),I=  1,  6) /    9,    3,   27,    9,    9,    3/
C     1 T(1,5) T(2,4) T(3,6)
      DATA DENOM(4)/1/
      DATA (CF(I,  4),I=  1,  6) /    3,    9,    9,   27,    3,    9/
C     1 T(1,5) T(2,6) T(3,4)
      DATA DENOM(5)/1/
      DATA (CF(I,  5),I=  1,  6) /    3,    9,    9,    3,   27,    9/
C     1 T(1,6) T(2,4) T(3,5)
      DATA DENOM(6)/1/
      DATA (CF(I,  6),I=  1,  6) /    9,    3,    3,    9,    9,   27/
C     1 T(1,6) T(2,5) T(3,4)
C     ----------
C     BEGIN CODE
C     ----------
      IF (FIRST) THEN
        FIRST=.FALSE.
        IF(ZERO.NE.0D0) FK_ZERO = SIGN(MAX(ABS(ZERO), ABS(ZERO
     $   *SMALL_WIDTH_TREATMENT)), ZERO)
        IF(ZERO.NE.0D0) FK_ZERO = SIGN(MAX(ABS(ZERO), ABS(MDL_MT
     $   *SMALL_WIDTH_TREATMENT)), ZERO)
      ENDIF


      CALL OXXXXX(P(0,1),ZERO,NHEL(1),-1*IC(1),W(1,1))
      CALL OXXXXX(P(0,2),ZERO,NHEL(2),-1*IC(2),W(1,2))
      CALL OXXXXX(P(0,3),MDL_MT,NHEL(3),+1*IC(3),W(1,3))
      CALL IXXXXX(P(0,4),MDL_MT,NHEL(4),-1*IC(4),W(1,4))
      CALL IXXXXX(P(0,5),ZERO,NHEL(5),-1*IC(5),W(1,5))
      CALL IXXXXX(P(0,6),ZERO,NHEL(6),-1*IC(6),W(1,6))
      CALL FFV57P0_3(W(1,5),W(1,1),GC_11,ZERO, FK_ZERO,W(1,7))
      CALL FFV87P0_3(W(1,4),W(1,3),GC_11,ZERO, FK_ZERO,W(1,8))
      CALL FFV57_1(W(1,2),W(1,7),GC_11,ZERO, FK_ZERO,W(1,9))
C     Amplitude(s) for diagram number 1
      CALL FFV57_0(W(1,6),W(1,9),W(1,8),GC_11,AMP(1))
      CALL FFV57_2(W(1,6),W(1,7),GC_11,ZERO, FK_ZERO,W(1,10))
C     Amplitude(s) for diagram number 2
      CALL FFV57_0(W(1,10),W(1,2),W(1,8),GC_11,AMP(2))
      CALL FFV110P0_3(W(1,4),W(1,3),GC_358,ZERO, FK_ZERO,W(1,11))
C     Amplitude(s) for diagram number 3
      CALL FFV57_0(W(1,6),W(1,9),W(1,11),GC_11,AMP(3))
C     Amplitude(s) for diagram number 4
      CALL FFV57_0(W(1,10),W(1,2),W(1,11),GC_11,AMP(4))
      CALL FFV57P0_3(W(1,6),W(1,2),GC_11,ZERO, FK_ZERO,W(1,10))
C     Amplitude(s) for diagram number 5
      CALL VVV8_0(W(1,7),W(1,8),W(1,10),GC_10,AMP(5))
C     Amplitude(s) for diagram number 6
      CALL VVV8_0(W(1,7),W(1,11),W(1,10),GC_10,AMP(6))
C     Amplitude(s) for diagram number 7
      CALL FFVV186_0(W(1,4),W(1,3),W(1,7),W(1,10),GC_360,AMP(7))
      CALL FFV87_1(W(1,3),W(1,7),GC_11,MDL_MT, FK_ZERO,W(1,9))
C     Amplitude(s) for diagram number 8
      CALL FFV87_0(W(1,4),W(1,9),W(1,10),GC_11,AMP(8))
C     Amplitude(s) for diagram number 9
      CALL FFV110_0(W(1,4),W(1,9),W(1,10),GC_358,AMP(9))
      CALL FFV110_1(W(1,3),W(1,7),GC_358,MDL_MT, FK_ZERO,W(1,9))
C     Amplitude(s) for diagram number 10
      CALL FFV87_0(W(1,4),W(1,9),W(1,10),GC_11,AMP(10))
      CALL FFV87_2(W(1,4),W(1,7),GC_11,MDL_MT, FK_ZERO,W(1,9))
C     Amplitude(s) for diagram number 11
      CALL FFV87_0(W(1,9),W(1,3),W(1,10),GC_11,AMP(11))
C     Amplitude(s) for diagram number 12
      CALL FFV110_0(W(1,9),W(1,3),W(1,10),GC_358,AMP(12))
      CALL FFV110_2(W(1,4),W(1,7),GC_358,MDL_MT, FK_ZERO,W(1,9))
C     Amplitude(s) for diagram number 13
      CALL FFV87_0(W(1,9),W(1,3),W(1,10),GC_11,AMP(13))
      CALL FFFF18_3(W(1,4),W(1,2),W(1,3),GC_83,ZERO, FK_ZERO,W(1,9))
      CALL FFFF17_25_26_27_3(W(1,4),W(1,2),W(1,3),-GC_32,-GC_85,-GC_89
     $ ,-GC_71,ZERO, FK_ZERO,W(1,12))
      CALL FFFF25_26_27_3(W(1,4),W(1,2),W(1,3),-GC_86,-GC_90,-GC_72
     $ ,ZERO, FK_ZERO,W(1,13))
C     Amplitude(s) for diagram number 14
      CALL FFV57_0(W(1,6),W(1,9),W(1,7),GC_11,AMP(14))
      CALL FFV57_0(W(1,6),W(1,12),W(1,7),GC_11,AMP(15))
      CALL FFV57_0(W(1,6),W(1,13),W(1,7),GC_11,AMP(16))
      CALL FFFF18_2(W(1,4),W(1,6),W(1,3),GC_83,ZERO, FK_ZERO,W(1,13))
      CALL FFFF17_25_26_27_2(W(1,4),W(1,6),W(1,3),-GC_32,-GC_85,-GC_89
     $ ,-GC_71,ZERO, FK_ZERO,W(1,12))
      CALL FFFF25_26_27_2(W(1,4),W(1,6),W(1,3),-GC_86,-GC_90,-GC_72
     $ ,ZERO, FK_ZERO,W(1,9))
C     Amplitude(s) for diagram number 15
      CALL FFV57_0(W(1,13),W(1,2),W(1,7),GC_11,AMP(17))
      CALL FFV57_0(W(1,12),W(1,2),W(1,7),GC_11,AMP(18))
      CALL FFV57_0(W(1,9),W(1,2),W(1,7),GC_11,AMP(19))
      CALL FFFF18_1(W(1,2),W(1,6),W(1,3),GC_83,MDL_MT, FK_ZERO,W(1,9))
      CALL FFFF17_25_26_27_1(W(1,2),W(1,6),W(1,3),-GC_32,-GC_85,-GC_89
     $ ,-GC_71,MDL_MT, FK_ZERO,W(1,12))
      CALL FFFF25_26_27_1(W(1,2),W(1,6),W(1,3),-GC_86,-GC_90,-GC_72
     $ ,MDL_MT, FK_ZERO,W(1,13))
C     Amplitude(s) for diagram number 16
      CALL FFV87_0(W(1,4),W(1,9),W(1,7),GC_11,AMP(20))
      CALL FFV87_0(W(1,4),W(1,12),W(1,7),GC_11,AMP(21))
      CALL FFV87_0(W(1,4),W(1,13),W(1,7),GC_11,AMP(22))
      CALL FFFF18_4(W(1,4),W(1,2),W(1,6),GC_83,MDL_MT, FK_ZERO,W(1,13))
      CALL FFFF17_25_26_27_4(W(1,4),W(1,2),W(1,6),-GC_32,-GC_85,-GC_89
     $ ,-GC_71,MDL_MT, FK_ZERO,W(1,12))
      CALL FFFF25_26_27_4(W(1,4),W(1,2),W(1,6),-GC_86,-GC_90,-GC_72
     $ ,MDL_MT, FK_ZERO,W(1,9))
C     Amplitude(s) for diagram number 17
      CALL FFV87_0(W(1,13),W(1,3),W(1,7),GC_11,AMP(23))
      CALL FFV87_0(W(1,12),W(1,3),W(1,7),GC_11,AMP(24))
      CALL FFV87_0(W(1,9),W(1,3),W(1,7),GC_11,AMP(25))
      CALL FFV57_2(W(1,5),W(1,8),GC_11,ZERO, FK_ZERO,W(1,9))
C     Amplitude(s) for diagram number 18
      CALL FFV57_0(W(1,9),W(1,1),W(1,10),GC_11,AMP(26))
      CALL FFV57_2(W(1,5),W(1,10),GC_11,ZERO, FK_ZERO,W(1,9))
C     Amplitude(s) for diagram number 19
      CALL FFV57_0(W(1,9),W(1,1),W(1,8),GC_11,AMP(27))
      CALL FFV57_2(W(1,5),W(1,11),GC_11,ZERO, FK_ZERO,W(1,7))
C     Amplitude(s) for diagram number 20
      CALL FFV57_0(W(1,7),W(1,1),W(1,10),GC_11,AMP(28))
C     Amplitude(s) for diagram number 21
      CALL FFV57_0(W(1,9),W(1,1),W(1,11),GC_11,AMP(29))
      CALL FFFF18_24_28_29_3(W(1,5),W(1,1),W(1,3),GC_31,GC_87,GC_109
     $ ,GC_112,MDL_MT, FK_ZERO,W(1,9))
      CALL FFFF18_24_28_29_3(W(1,5),W(1,1),W(1,3),GC_35,GC_88,GC_110
     $ ,GC_113,MDL_MT, FK_ZERO,W(1,11))
C     Amplitude(s) for diagram number 22
      CALL FFV87_0(W(1,4),W(1,9),W(1,10),GC_11,AMP(30))
      CALL FFV87_0(W(1,4),W(1,11),W(1,10),GC_11,AMP(31))
      CALL FFFF18_24_28_29_4(W(1,5),W(1,1),W(1,4),GC_31,GC_87,GC_109
     $ ,GC_112,MDL_MT, FK_ZERO,W(1,11))
      CALL FFFF18_24_28_29_4(W(1,5),W(1,1),W(1,4),GC_35,GC_88,GC_110
     $ ,GC_113,MDL_MT, FK_ZERO,W(1,9))
C     Amplitude(s) for diagram number 23
      CALL FFV87_0(W(1,11),W(1,3),W(1,10),GC_11,AMP(32))
      CALL FFV87_0(W(1,9),W(1,3),W(1,10),GC_11,AMP(33))
      CALL FFFF18_28_1(W(1,2),W(1,5),W(1,1),GC_30,GC_87,ZERO, FK_ZERO
     $ ,W(1,9))
      CALL FFFF18_28_1(W(1,2),W(1,5),W(1,1),GC_34,GC_88,ZERO, FK_ZERO
     $ ,W(1,11))
C     Amplitude(s) for diagram number 24
      CALL FFV57_0(W(1,6),W(1,9),W(1,8),GC_11,AMP(34))
      CALL FFV57_0(W(1,6),W(1,11),W(1,8),GC_11,AMP(35))
      CALL FFFF18_28_2(W(1,6),W(1,5),W(1,1),GC_30,GC_87,ZERO, FK_ZERO
     $ ,W(1,11))
      CALL FFFF18_28_2(W(1,6),W(1,5),W(1,1),GC_34,GC_88,ZERO, FK_ZERO
     $ ,W(1,9))
C     Amplitude(s) for diagram number 25
      CALL FFV57_0(W(1,11),W(1,2),W(1,8),GC_11,AMP(36))
      CALL FFV57_0(W(1,9),W(1,2),W(1,8),GC_11,AMP(37))
      CALL FFFF18_24_28_29_2(W(1,5),W(1,4),W(1,3),GC_31,GC_87,GC_109
     $ ,GC_112,ZERO, FK_ZERO,W(1,9))
      CALL FFFF18_24_28_29_2(W(1,5),W(1,4),W(1,3),GC_35,GC_88,GC_110
     $ ,GC_113,ZERO, FK_ZERO,W(1,11))
C     Amplitude(s) for diagram number 26
      CALL FFV57_0(W(1,9),W(1,1),W(1,10),GC_11,AMP(38))
      CALL FFV57_0(W(1,11),W(1,1),W(1,10),GC_11,AMP(39))
      CALL FFFF18_28_4(W(1,6),W(1,2),W(1,5),GC_30,GC_87,ZERO, FK_ZERO
     $ ,W(1,11))
      CALL FFFF18_28_4(W(1,6),W(1,2),W(1,5),GC_34,GC_88,ZERO, FK_ZERO
     $ ,W(1,9))
C     Amplitude(s) for diagram number 27
      CALL FFV57_0(W(1,11),W(1,1),W(1,8),GC_11,AMP(40))
      CALL FFV57_0(W(1,9),W(1,1),W(1,8),GC_11,AMP(41))
      CALL FFFF18_24_28_29_1(W(1,1),W(1,4),W(1,3),GC_31,GC_87,GC_109
     $ ,GC_112,ZERO, FK_ZERO,W(1,9))
      CALL FFFF18_24_28_29_1(W(1,1),W(1,4),W(1,3),GC_35,GC_88,GC_110
     $ ,GC_113,ZERO, FK_ZERO,W(1,11))
C     Amplitude(s) for diagram number 28
      CALL FFV57_0(W(1,5),W(1,9),W(1,10),GC_11,AMP(42))
      CALL FFV57_0(W(1,5),W(1,11),W(1,10),GC_11,AMP(43))
      CALL FFFF18_28_3(W(1,6),W(1,2),W(1,1),GC_30,GC_87,ZERO, FK_ZERO
     $ ,W(1,11))
      CALL FFFF18_28_3(W(1,6),W(1,2),W(1,1),GC_34,GC_88,ZERO, FK_ZERO
     $ ,W(1,10))
C     Amplitude(s) for diagram number 29
      CALL FFV57_0(W(1,5),W(1,11),W(1,8),GC_11,AMP(44))
      CALL FFV57_0(W(1,5),W(1,10),W(1,8),GC_11,AMP(45))
C     JAMPs contributing to orders ALL_ORDERS=1
      JAMP(1,1)=+1D0/4D0*AMP(1)+1D0/4D0*AMP(3)-1D0/4D0*IMAG1*AMP(5)
     $ -1D0/4D0*IMAG1*AMP(6)+1D0/4D0*IMAG1*AMP(7)+1D0/4D0*AMP(11)+1D0
     $ /4D0*AMP(12)+1D0/4D0*AMP(13)-1D0/2D0*AMP(17)-1D0/4D0*AMP(19)
     $ -1D0/2D0*AMP(20)-1D0/4D0*AMP(22)+1D0/4D0*AMP(27)+1D0/4D0*AMP(29)
     $ +1D0/4D0*AMP(33)+1D0/4D0*AMP(35)+1D0/4D0*AMP(41)+1D0/4D0*AMP(43)
      JAMP(2,1)=-1D0/12D0*AMP(8)-1D0/12D0*AMP(9)-1D0/12D0*AMP(10)-1D0
     $ /12D0*AMP(11)-1D0/12D0*AMP(12)-1D0/12D0*AMP(13)-1D0/2D0*AMP(21)
     $ +1D0/12D0*AMP(22)-1D0/2D0*AMP(24)+1D0/12D0*AMP(25)-1D0/12D0
     $ *AMP(26)-1D0/12D0*AMP(27)-1D0/12D0*AMP(28)-1D0/12D0*AMP(29)-1D0
     $ /12D0*AMP(31)-1D0/12D0*AMP(33)-1D0/12D0*AMP(39)+1D0/2D0*AMP(40)
     $ -1D0/12D0*AMP(41)-1D0/12D0*AMP(43)+1D0/2D0*AMP(44)-1D0/12D0
     $ *AMP(45)
      JAMP(3,1)=-1D0/12D0*AMP(1)-1D0/12D0*AMP(2)-1D0/12D0*AMP(3)-1D0
     $ /12D0*AMP(4)-1D0/12D0*AMP(8)-1D0/12D0*AMP(9)-1D0/12D0*AMP(10)
     $ -1D0/12D0*AMP(11)-1D0/12D0*AMP(12)-1D0/12D0*AMP(13)+1D0/6D0
     $ *AMP(14)+1D0/12D0*AMP(16)+1D0/6D0*AMP(17)+1D0/12D0*AMP(19)+1D0
     $ /6D0*AMP(20)+1D0/12D0*AMP(22)+1D0/6D0*AMP(23)+1D0/12D0*AMP(25)
     $ +1D0/2D0*AMP(30)-1D0/12D0*AMP(31)+1D0/2D0*AMP(32)-1D0/12D0
     $ *AMP(33)+1D0/2D0*AMP(34)-1D0/12D0*AMP(35)+1D0/2D0*AMP(36)-1D0
     $ /12D0*AMP(37)
      JAMP(4,1)=+1D0/36D0*AMP(1)+1D0/36D0*AMP(2)+1D0/36D0*AMP(3)+1D0
     $ /36D0*AMP(4)+1D0/36D0*AMP(8)+1D0/36D0*AMP(9)+1D0/36D0*AMP(10)
     $ +1D0/36D0*AMP(11)+1D0/36D0*AMP(12)+1D0/36D0*AMP(13)+1D0/6D0
     $ *AMP(15)-1D0/36D0*AMP(16)+1D0/6D0*AMP(18)-1D0/36D0*AMP(19)+1D0
     $ /6D0*AMP(21)-1D0/36D0*AMP(22)+1D0/6D0*AMP(24)-1D0/36D0*AMP(25)
     $ +1D0/36D0*AMP(26)+1D0/36D0*AMP(27)+1D0/36D0*AMP(28)+1D0/36D0
     $ *AMP(29)-1D0/6D0*AMP(30)+1D0/36D0*AMP(31)-1D0/6D0*AMP(32)+1D0
     $ /36D0*AMP(33)-1D0/6D0*AMP(34)+1D0/36D0*AMP(35)-1D0/6D0*AMP(36)
     $ +1D0/36D0*AMP(37)-1D0/6D0*AMP(38)+1D0/36D0*AMP(39)-1D0/6D0
     $ *AMP(40)+1D0/36D0*AMP(41)-1D0/6D0*AMP(42)+1D0/36D0*AMP(43)-1D0
     $ /6D0*AMP(44)+1D0/36D0*AMP(45)
      JAMP(5,1)=+1D0/4D0*AMP(2)+1D0/4D0*AMP(4)+1D0/4D0*IMAG1*AMP(5)
     $ +1D0/4D0*IMAG1*AMP(6)-1D0/4D0*IMAG1*AMP(7)+1D0/4D0*AMP(8)+1D0
     $ /4D0*AMP(9)+1D0/4D0*AMP(10)-1D0/2D0*AMP(14)-1D0/4D0*AMP(16)-1D0
     $ /2D0*AMP(23)-1D0/4D0*AMP(25)+1D0/4D0*AMP(26)+1D0/4D0*AMP(28)
     $ +1D0/4D0*AMP(31)+1D0/4D0*AMP(37)+1D0/4D0*AMP(39)+1D0/4D0*AMP(45)
      JAMP(6,1)=-1D0/12D0*AMP(1)-1D0/12D0*AMP(2)-1D0/12D0*AMP(3)-1D0
     $ /12D0*AMP(4)-1D0/2D0*AMP(15)+1D0/12D0*AMP(16)-1D0/2D0*AMP(18)
     $ +1D0/12D0*AMP(19)-1D0/12D0*AMP(26)-1D0/12D0*AMP(27)-1D0/12D0
     $ *AMP(28)-1D0/12D0*AMP(29)-1D0/12D0*AMP(35)-1D0/12D0*AMP(37)+1D0
     $ /2D0*AMP(38)-1D0/12D0*AMP(39)-1D0/12D0*AMP(41)+1D0/2D0*AMP(42)
     $ -1D0/12D0*AMP(43)-1D0/12D0*AMP(45)

      MATRIX25 = 0.D0
      DO M = 1, NAMPSO
        DO I = 1, NCOLOR
          ZTEMP = (0.D0,0.D0)
          DO J = 1, NCOLOR
            ZTEMP = ZTEMP + CF(J,I)*JAMP(J,M)
          ENDDO
          DO N = 1, NAMPSO
            IF (CHOSEN_SO_CONFIGS(SQSOINDEX25(M,N))) THEN
              MATRIX25 = MATRIX25 + ZTEMP*DCONJG(JAMP(I,N))/DENOM(I)
            ENDIF
          ENDDO
        ENDDO
      ENDDO

      AMP2(8)=AMP2(8)+(AMP(8)+AMP(9)+AMP(10))*DCONJG(AMP(8)+AMP(9)
     $ +AMP(10))
      AMP2(11)=AMP2(11)+(AMP(11)+AMP(12)+AMP(13))*DCONJG(AMP(11)
     $ +AMP(12)+AMP(13))
      AMP2(5)=AMP2(5)+(AMP(5)+AMP(6))*DCONJG(AMP(5)+AMP(6))
      AMP2(1)=AMP2(1)+(AMP(1)+AMP(3))*DCONJG(AMP(1)+AMP(3))
      AMP2(2)=AMP2(2)+(AMP(2)+AMP(4))*DCONJG(AMP(2)+AMP(4))
      AMP2(18)=AMP2(18)+(AMP(26)+AMP(28))*DCONJG(AMP(26)+AMP(28))
      AMP2(19)=AMP2(19)+(AMP(27)+AMP(29))*DCONJG(AMP(27)+AMP(29))
      DO I = 1, NCOLOR
        DO M = 1, NAMPSO
          DO N = 1, NAMPSO
            IF (CHOSEN_SO_CONFIGS(SQSOINDEX25(M,N))) THEN
              JAMP2(I)=JAMP2(I)+DABS(DBLE(JAMP(I,M)*DCONJG(JAMP(I,N))))
            ENDIF
          ENDDO
        ENDDO
      ENDDO

      END

C     Set of functions to handle the array indices of the split orders


      INTEGER FUNCTION SQSOINDEX25(ORDERINDEXA, ORDERINDEXB)
C     
C     This functions plays the role of the interference matrix. It can
C      be hardcoded or 
C     made more elegant using hashtables if its execution speed ever
C      becomes a relevant
C     factor. From two split order indices, it return the
C      corresponding index in the squared 
C     order canonical ordering.
C     
C     CONSTANTS
C     

      INTEGER    NSO, NSQUAREDSO, NAMPSO
      PARAMETER (NSO=1, NSQUAREDSO=1, NAMPSO=1)
C     
C     ARGUMENTS
C     
      INTEGER ORDERINDEXA, ORDERINDEXB
C     
C     LOCAL VARIABLES
C     
      INTEGER I, SQORDERS(NSO)
      INTEGER AMPSPLITORDERS(NAMPSO,NSO)
      DATA (AMPSPLITORDERS(  1,I),I=  1,  1) /    1/
      COMMON/AMPSPLITORDERS25/AMPSPLITORDERS
C     
C     FUNCTION
C     
      INTEGER SOINDEX_FOR_SQUARED_ORDERS25
C     
C     BEGIN CODE
C     
      DO I=1,NSO
        SQORDERS(I)=AMPSPLITORDERS(ORDERINDEXA,I)
     $   +AMPSPLITORDERS(ORDERINDEXB,I)
      ENDDO
      SQSOINDEX25=SOINDEX_FOR_SQUARED_ORDERS25(SQORDERS)
      END

      INTEGER FUNCTION SOINDEX_FOR_SQUARED_ORDERS25(ORDERS)
C     
C     This functions returns the integer index identifying the squared
C      split orders list passed in argument which corresponds to the
C      values of the following list of couplings (and in this order).
C     []
C     
C     CONSTANTS
C     
      INTEGER    NSO, NSQSO, NAMPSO
      PARAMETER (NSO=1, NSQSO=1, NAMPSO=1)
C     
C     ARGUMENTS
C     
      INTEGER ORDERS(NSO)
C     
C     LOCAL VARIABLES
C     
      INTEGER I,J
      INTEGER SQSPLITORDERS(NSQSO,NSO)
      DATA (SQSPLITORDERS(  1,I),I=  1,  1) /    2/
      COMMON/SQPLITORDERS25/SQPLITORDERS
C     
C     BEGIN CODE
C     
      DO I=1,NSQSO
        DO J=1,NSO
          IF (ORDERS(J).NE.SQSPLITORDERS(I,J)) GOTO 1009
        ENDDO
        SOINDEX_FOR_SQUARED_ORDERS25 = I
        RETURN
 1009   CONTINUE
      ENDDO

      WRITE(*,*) 'ERROR:: Stopping in function'
      WRITE(*,*) 'SOINDEX_FOR_SQUARED_ORDERS25'
      WRITE(*,*) 'Could not find squared orders ',(ORDERS(I),I=1,NSO)
      STOP

      END

      SUBROUTINE GET_NSQSO_BORN25(NSQSO)
C     
C     Simple subroutine returning the number of squared split order
C     contributions returned when calling smatrix_split_orders 
C     

      INTEGER    NSQUAREDSO
      PARAMETER  (NSQUAREDSO=1)

      INTEGER NSQSO

      NSQSO=NSQUAREDSO

      END

C     This is the inverse subroutine of SOINDEX_FOR_SQUARED_ORDERS.
C      Not directly useful, but provided nonetheless.
      SUBROUTINE GET_SQUARED_ORDERS_FOR_SOINDEX25(SOINDEX,ORDERS)
C     
C     This functions returns the orders identified by the squared
C      split order index in argument. Order values correspond to
C      following list of couplings (and in this order):
C     []
C     
C     CONSTANTS
C     
      INTEGER    NSO, NSQSO
      PARAMETER (NSO=1, NSQSO=1)
C     
C     ARGUMENTS
C     
      INTEGER SOINDEX, ORDERS(NSO)
C     
C     LOCAL VARIABLES
C     
      INTEGER I
      INTEGER SQPLITORDERS(NSQSO,NSO)
      COMMON/SQPLITORDERS25/SQPLITORDERS
C     
C     BEGIN CODE
C     
      IF (SOINDEX.GT.0.AND.SOINDEX.LE.NSQSO) THEN
        DO I=1,NSO
          ORDERS(I) =  SQPLITORDERS(SOINDEX,I)
        ENDDO
        RETURN
      ENDIF

      WRITE(*,*) 'ERROR:: Stopping function'
     $ //' GET_SQUARED_ORDERS_FOR_SOINDEX25'
      WRITE(*,*) 'Could not find squared orders index ',SOINDEX
      STOP

      END SUBROUTINE

C     This is the inverse subroutine of getting amplitude SO orders.
C      Not directly useful, but provided nonetheless.
      SUBROUTINE GET_ORDERS_FOR_AMPSOINDEX25(SOINDEX,ORDERS)
C     
C     This functions returns the orders identified by the split order
C      index in argument. Order values correspond to following list of
C      couplings (and in this order):
C     []
C     
C     CONSTANTS
C     
      INTEGER    NSO, NAMPSO
      PARAMETER (NSO=1, NAMPSO=1)
C     
C     ARGUMENTS
C     
      INTEGER SOINDEX, ORDERS(NSO)
C     
C     LOCAL VARIABLES
C     
      INTEGER I
      INTEGER AMPSPLITORDERS(NAMPSO,NSO)
      COMMON/AMPSPLITORDERS25/AMPSPLITORDERS
C     
C     BEGIN CODE
C     
      IF (SOINDEX.GT.0.AND.SOINDEX.LE.NAMPSO) THEN
        DO I=1,NSO
          ORDERS(I) =  AMPSPLITORDERS(SOINDEX,I)
        ENDDO
        RETURN
      ENDIF

      WRITE(*,*) 'ERROR:: Stopping function'
     $ //' GET_ORDERS_FOR_AMPSOINDEX25'
      WRITE(*,*) 'Could not find amplitude split orders index ',SOINDEX
      STOP

      END SUBROUTINE

C     This function is not directly useful, but included for
C      completeness
      INTEGER FUNCTION SOINDEX_FOR_AMPORDERS25(ORDERS)
C     
C     This functions returns the integer index identifying the
C      amplitude split orders passed in argument which correspond to
C      the values of the following list of couplings (and in this
C      order):
C     []
C     
C     CONSTANTS
C     
      INTEGER    NSO, NAMPSO
      PARAMETER (NSO=1, NAMPSO=1)
C     
C     ARGUMENTS
C     
      INTEGER ORDERS(NSO)
C     
C     LOCAL VARIABLES
C     
      INTEGER I,J
      INTEGER AMPSPLITORDERS(NAMPSO,NSO)
      COMMON/AMPSPLITORDERS25/AMPSPLITORDERS
C     
C     BEGIN CODE
C     
      DO I=1,NAMPSO
        DO J=1,NSO
          IF (ORDERS(J).NE.AMPSPLITORDERS(I,J)) GOTO 1009
        ENDDO
        SOINDEX_FOR_AMPORDERS25 = I
        RETURN
 1009   CONTINUE
      ENDDO

      WRITE(*,*) 'ERROR:: Stopping function SOINDEX_FOR_AMPORDERS25'
      WRITE(*,*) 'Could not find squared orders ',(ORDERS(I),I=1,NSO)
      STOP

      END

      subroutine graph_init
c*************************************************************************
c     Set up graphing
c*************************************************************************
      implicit none
c
c     Local
c
      real xmin,xmax
c
c     Global
c
      real        h(80000)
      common/pawc/h
c-----
c  Begin Code
c-----
c      call hlimit(80000)
c
c     Total
c
c      print*,'Setting up graphs'
c      call hbook1(1,'s hat',100,0.,500.,0.)
      end

      subroutine graph_point2(x,y)
      double precision x,y
      end


      subroutine graph_point(p,dwgt)
c***************************************************************************
c     fill historgrams
c***************************************************************************
      implicit none
c
c     Constants
c
      double precision  pi              , to_deg
      parameter        (pi = 3.1415927d0, to_deg=180d0/pi)
c
c     Arguments
c
      double precision dwgt
      REAL*8 P(0:3,7)
c
c     Local
c
      real*4 wgt
      real*8 ptot(0:3),maxamp, shat
      integer i,iconfig, imax
c
c     Global
c
      include 'maxparticles.inc'
      include 'run.inc'

c
c     External
c
      double precision dot,et,eta,r2
c-----
c  Begin Code
c-----
      wgt=dwgt
c      call hfill(1,real(et(p(0,4))),0.,wgt)
      end

      subroutine graph_store
c*************************************************************************
c     Stores graphs
c*************************************************************************
      implicit none

c-----
c  Begin Code
c-----
c      call hcurve(1,'shat.dat')
c      call hrput(0,'wg.paw','N')
      end

C-----------------------------------------------
C
C	Routine to initialize a one-independent-variable histogram
C
	subroutine hbook1(id,inlabel,nx,xmin,xmax,zinitial)
C
C		id = integer used to identify histogram to HFILL
C		inlabel = label to be written on the output by the plotting
C				program (character of len <=40)
C		nx = number of x bins (integer)
C		xmin = min x value (real)
C		xmax = max x value (real)
C		zinitial = initial value for each bin (real)
C
	include 'hbook.inc'
	character*(*) inlabel

	if (nhist .eq. nhistmax) then
		print*,' Maximum number of histograms exceeded'
	else
		nhist = nhist+1
		label(nhist) = inlabel
		id number(nhist) = id
		single dim(nhist) = .true.
		k=pointer(nhist)
		pointer(nhist+1) = nx+3+k
		data(k)=nx
		data(k+1)=xmin
		data(k+2)=xmax
		do i=k+3,pointer(nhist+1)-1
			data(i)=zinitial
			error(i)=zinitial**2
			end do
		end if
	return
	end

C
C-----------------------------------------------------------------------------
C
      double precision function alfa(alfa0,qsq )
C
C-----------------------------------------------------------------------------
C
C	This function returns the 1-loop value of alpha.
C
C	INPUT: 
C		qsq   = Q^2
C
C-----------------------------------------------------------------------------
C
      implicit none
      double precision  qsq,alfa0
c
c constants
c
      double precision  One, Three, Pi,zmass
      parameter( One = 1.0d0, Three = 3.0d0 )
      parameter( Pi = 3.14159265358979323846d0 )
      parameter( zmass = 91.188d0 )
cc
      alfa = alfa0 / ( 1.0d0 - alfa0*dlog( qsq/zmass**2 ) /Three /Pi )
ccc
      return
      end

C
C-----------------------------------------------------------------------------
C
      double precision function alfaw(alfaw0,qsq,nh )
C
C-----------------------------------------------------------------------------
C
C	This function returns the 1-loop value of alpha_w.
C
C	INPUT: 
C		qsq = Q^2
C               nh  = # of Higgs doublets
C
C-----------------------------------------------------------------------------
C
      implicit none
      double precision  qsq, alphaw, dum,alfaw0
      integer  nh, nq
c
c	  include
c
	  
c
c constants
c
      double precision  Two, Four, Pi, Twpi, zmass,tmass
      parameter( Two = 2.0d0, Four = 4.0d0 )
      parameter( Pi = 3.14159265358979323846d0 )
      parameter( Twpi = 3.0d0*Four*Pi )
      parameter( zmass = 91.188d0,tmass=174d0 )
cc
      if ( qsq.ge.tmass**2 ) then
         nq = 6
      else
         nq = 5
      end if
      dum = ( 22.0d0 - Four*nq - nh/Two ) / Twpi
      alfaw = alfaw0 / ( 1.0d0 + dum*alfaw0*dlog( qsq/zmass**2 ) )
ccc
      return
      end

C-----------------------------------------------------------------------------
C
      DOUBLE PRECISION FUNCTION ALPHAS(Q)
C     wrapper to the lhapdf alphaS
C-----------------------------------------------------------------------------
      IMPLICIT NONE
c
      include 'alfas.inc'
      REAL*8 Q,alphasPDF
      external alphasPDF

      ALPHAS=alphasPDF(Q)

      RETURN
      END

C-----------------------------------------------------------------------------
C
      double precision function mfrun(mf,scale,asmz,nloop)
C
C-----------------------------------------------------------------------------
C
C	This function returns the 2-loop value of a MSbar fermion mass
C       at a given scale.
C
C	INPUT: mf    = MSbar mass of fermion at MSbar fermion mass scale 
C	       scale = scale at which the running mass is evaluated
C	       asmz  = AS(MZ) : this is passed to alphas(scale,asmz,nloop)
C              nloop = # of loops in the evolution
C       
C
C
C	EXTERNAL:      double precision alphas(scale,asmz,nloop)
C                      
C-----------------------------------------------------------------------------
C
      implicit none
C
C     ARGUMENTS
C
      double precision  mf,scale,asmz
      integer           nloop
C
C     LOCAL
C
      double precision  beta0, beta1,gamma0,gamma1
      double precision  A1,as,asmf,l2
      integer  nf
C
C     EXTERNAL
C
      double precision  alphas
      external          alphas
c
c     CONSTANTS
c
      double precision  One, Two, Three, Pi
      parameter( One = 1.0d0, Two = 2.0d0, Three = 3.0d0 )
      parameter( Pi = 3.14159265358979323846d0) 
      double precision tmass
      parameter(tmass=174d0)
cc
C
C
      if ( mf.gt.tmass ) then
         nf = 6
      else
         nf = 5
      end if

      beta0 = ( 11.0d0 - Two/Three *nf )/4d0
      beta1 = ( 102d0  - 38d0/Three*nf )/16d0
      gamma0= 1d0
      gamma1= ( 202d0/3d0  - 20d0/9d0*nf )/16d0
      A1    = -beta1*gamma0/beta0**2+gamma1/beta0
      as    = alphas(scale)
      asmf  = alphas(mf)
      l2    = (1+ A1*as/Pi)/(1+ A1*asmf/Pi)
      
      
      mfrun = mf * (as/asmf)**(gamma0/beta0)

      if(nloop.eq.2) mfrun =mfrun*l2
ccc
      return
      end

      subroutine run_printout
      implicit none
c
c     local
c
      integer i,iformat
      character*2 ab(2)
      real*8 ene
      double precision  Zero, One, Two, Three, Four, Half, Rt2
      parameter( Zero = 0.0d0, One = 1.0d0, Two = 2.0d0 )
c
c     include
c
      include 'PDF/pdf.inc'
      include 'maxparticles.inc'
      include 'run.inc'
      include 'alfas.inc'
c
c output all info
c
      write(6,*)            
      write(6,*)  'Collider parameters:'
      write(6,*)  '--------------------'

      do i=1,2
         IF(LPP(i).EQ. 0) ab(i)='e'
         IF(LPP(i).EQ. 1) ab(i)='P'
         IF(LPP(i).EQ.-1) ab(i)='Pb'
         IF(LPP(i).EQ.2) ab(i)='a2'
         IF(LPP(i).EQ.3) ab(i)='a3'
      enddo

      ene=2d0*dsqrt(ebeam(1)*ebeam(2))

      write(6,*)  
      write(6,*) 'Running at ',ab(1),ab(2),'  machine @ ', ene, ' GeV'
      write(6,*) 'PDF set = ',pdlabel
      write(6,'(1x,a12,1x,f6.4,a12,i1,a7)') 
     &     'alpha_s(Mz)=', asmz ,' running at ', nloop , ' loops.'
      if(lpp(1).ne.0.or.lpp(2).ne.0) then    
      write(6,'(1x,a12,1x,f6.4,a12,i1,a7)') 
     &     'alpha_s(Mz)=', asmz ,' running at ', nloop , ' loops. Value tuned to the PDF set.'
      else 
      write(6,'(1x,a12,1x,f6.4,a12,i1,a7)') 
     &     'alpha_s(Mz)=', asmz ,' running at ', nloop , ' loops. Value set in param_card.dat'
      endif      
           
      if(fixed_ren_scale) then
         write(6,*) 'Renormalization scale fixed @ ',scale 
      else
         write(6,*) 'Renormalization scale set on event-by-event basis'
      endif
      if(fixed_fac_scale) then
         write(6,*) 'Factorization scales  fixed @ ',
     &   dsqrt(q2fact(1)),dsqrt(q2fact(2)) 
      else
         write(6,*) 'Factorization   scale set on event-by-event basis'
      endif
   
      write(6,*)  
      write(6,*)  
      
      return
      end

C--------------------------------------------
C
C		Routine to dump histogram data to a file
C
	subroutine hcurve(id,filename)	
C
C		Dumps current histogram number id to file 'filename' and
C		clears histogram id.
C
	include 'hbook.inc'
	character*(*) filename
        real sum,npts

	if (nhist .eq. 0) return
	open (unit=69,name=filename,status='unknown')
	do i = 1, nhist
		if (id .eq. idnumber(i)) go to 10
		end do
	return
10	continue
	k = pointer(i)
	nx = int(data(k)+.1)
	xmin = data(k+1)
	xmax = data(k+2)
	xbinsize = (xmax-xmin)/nx
	if (single dim(i)) then
           sum=0
           npts=0
           do m=1,nx
              sum=sum+data(k+2+m)
              npts=npts+npoints(k+2+m)
           enddo
           write (69,300) label(i)(1:labelleng(label(i)))
           write (69,700) (xmin+(m-.5)*xbinsize,
     $          data(k+2+m),sqrt(abs(error(k+2+m))),
     $          npoints(k+2+m)/(npts*sum+1e-23),m=1,nx)
	else
		ny = int(data(k+3) + .1)
		ymin = data(k+4)
		ymax = data(k+5)
		ybinsize = (ymax-ymin)/ny
		write (69,300) label(i)(1:labelleng(label(i)))
		k = k + 5
		do n=1,ny
                   fixed y =  ymin + (n-.5)*ybinsize
                   write (69,500) (xmin+(m-.5)*xbinsize,fixed y,
     $                  data(k+m),m=1,nx)
		   write(69,*) 
                   k = k + nx
                end do
		end if
	close (unit=69)
	return
300	format ('# Histogram ',a)
400	format (1x,2g15.6)
500	format (1x,3g15.6)
700	format (1x,4g15.6)
	end
C
C
C
C
	function labelleng(string)
	character*(*) string

	do i=len(string),1,-1
		if (string(i:i) .ne. ' ') then
			labelleng=i
			return
			end if
		end do
	labelleng=1
	return
	end

      subroutine idenparts(iden_part,itree,sprop,forcebw,prwidth)
c
c     Keep track of identical particles to map radiation processes
c     (i.e., not use BW for such processes).
c     Only consider particles that are present in final state as
c     radiating, since need to correctly map conflicting BWs for decays.
c
c     Constants
c
      include 'genps.inc'
      include 'maxconfigs.inc'
      include 'maxamps.inc'
      include 'nexternal.inc'
c
c     Arguments
c
      integer iden_part(-nexternal+1:nexternal)
      integer itree(2,-max_branch:-1),iconfig
      integer sprop(maxsproc,-max_branch:-1)  ! Propagator id
      integer forcebw(-max_branch:-1) ! Forced BW, for identical particle conflicts
      double precision prwidth(-nexternal:0)  !Propagator width
c
c     local
c
      integer i,j,it,isp
      integer idup(nexternal,maxproc,maxsproc)
      integer mothup(2,nexternal)
      integer icolup(2,nexternal,maxflow,maxsproc)
      include 'leshouche.inc'
      integer ipdg(-nexternal+1:nexternal)
c
c     Global
c
      include 'coupl.inc'                     !Mass and width info
      double precision stot
      common/to_stot/stot

      do i=1,nexternal
         ipdg(i) = idup(i,1,1)
      enddo
      do i=-(nexternal-1),nexternal
         iden_part(i)=0
      enddo

      i=1
      do while (i .lt. nexternal-2 .and. itree(1,-i) .ne. 1)
C        Find first non-zero sprop
         do j=1,maxsproc
            if(sprop(j,-i).ne.0) then
               isp=sprop(j,-i)
               exit
            endif
         enddo
         ipdg(-i)=isp
         if (prwidth(-i) .gt. 0d0) then
            if(ipdg(-i).eq.ipdg(itree(1,-i)).and.itree(1,-i).gt.0.or.
     $         ipdg(-i).eq.ipdg(itree(2,-i)).and.itree(2,-i).gt.0) then
               iden_part(-i) = ipdg(-i)
            else if(ipdg(-i).eq.ipdg(itree(1,-i)).and.
     $              iden_part(itree(1,-i)).ne.0.or.
     $         ipdg(-i).eq.ipdg(itree(2,-i)).and.
     $              iden_part(itree(2,-i)).ne.0) then
               iden_part(-i) = ipdg(-i)
            endif
         endif
         i=i+1
      enddo
      end

C     This File is Automatically generated by ALOHA 
C     The process calculated in this file is: 
C     Gamma(-1,2,-2)*Gamma(-1,4,-3)*ProjM(-3,1)*ProjM(-2,3)
C     
      SUBROUTINE FFFF17_1(F2, F3, F4, COUP, M1, W1,F1)
      IMPLICIT NONE
      COMPLEX*16 CI
      PARAMETER (CI=(0D0,1D0))
      COMPLEX*16 COUP
      COMPLEX*16 F1(6)
      COMPLEX*16 F2(*)
      COMPLEX*16 F3(*)
      COMPLEX*16 F4(*)
      REAL*8 M1
      REAL*8 P1(0:3)
      REAL*8 W1
      COMPLEX*16 DENOM
      F1(1) = +F2(1)+F3(1)+F4(1)
      F1(2) = +F2(2)+F3(2)+F4(2)
      P1(0) = -DBLE(F1(1))
      P1(1) = -DBLE(F1(2))
      P1(2) = -DIMAG(F1(2))
      P1(3) = -DIMAG(F1(1))
      DENOM = COUP/(P1(0)**2-P1(1)**2-P1(2)**2-P1(3)**2 - M1 * (M1 -CI
     $ * W1))
      F1(3)= DENOM*2D0 * CI * F3(4)*M1*(-F4(6)*F2(5)+F4(5)*F2(6))
      F1(4)= DENOM*2D0 * CI * F3(3)*M1*(F4(6)*F2(5)-F4(5)*F2(6))
      F1(5)= DENOM*(-2D0 * CI)*(F3(3)*(F2(5)*-F4(6)*(P1(1)+CI*(P1(2)))
     $ +F2(6)*F4(5)*(P1(1)+CI*(P1(2))))+F3(4)*(F2(5)*F4(6)*(-P1(0)
     $ +P1(3))+F2(6)*F4(5)*(P1(0)-P1(3))))
      F1(6)= DENOM*(-2D0 * CI)*(F3(3)*(F2(5)*F4(6)*(P1(0)+P1(3))-F2(6)
     $ *F4(5)*(P1(0)+P1(3)))+F3(4)*(F2(5)*F4(6)*(P1(1)-CI*(P1(2)))
     $ +F2(6)*F4(5)*(-P1(1)+CI*(P1(2)))))
      END


C     This File is Automatically generated by ALOHA 
C     The process calculated in this file is: 
C     Gamma(-1,2,-2)*Gamma(-1,4,-3)*ProjM(-3,1)*ProjM(-2,3)
C     
      SUBROUTINE FFFF17_212_1(F2, F3, F4, COUP1, COUP2, M1, W1,F1)
      IMPLICIT NONE
      COMPLEX*16 CI
      PARAMETER (CI=(0D0,1D0))
      COMPLEX*16 COUP1
      COMPLEX*16 COUP2
      COMPLEX*16 F1(6)
      COMPLEX*16 F2(*)
      COMPLEX*16 F3(*)
      COMPLEX*16 F4(*)
      COMPLEX*16 FTMP(6)
      REAL*8 M1
      REAL*8 P1(0:3)
      REAL*8 W1
      COMPLEX*16 DENOM
      INTEGER*4 I
      CALL FFFF17_1(F2,F3,F4,COUP1,M1,W1,F1)
      CALL FFFF212_1(F2,F3,F4,COUP2,M1,W1,FTMP)
      DO I = 3, 6
        F1(I) = F1(I) + FTMP(I)
      ENDDO
      END


C     This File is Automatically generated by ALOHA 
C     The process calculated in this file is: 
C     Gamma(-1,2,-2)*Gamma(-1,4,-3)*ProjM(-3,1)*ProjM(-2,3)
C     
      SUBROUTINE FFFF17_25_26_27_1(F2, F3, F4, COUP1, COUP2, COUP3,
     $  COUP4, M1, W1,F1)
      IMPLICIT NONE
      COMPLEX*16 CI
      PARAMETER (CI=(0D0,1D0))
      COMPLEX*16 COUP1
      COMPLEX*16 COUP2
      COMPLEX*16 COUP3
      COMPLEX*16 COUP4
      COMPLEX*16 F1(6)
      COMPLEX*16 F2(*)
      COMPLEX*16 F3(*)
      COMPLEX*16 F4(*)
      COMPLEX*16 FTMP(6)
      REAL*8 M1
      REAL*8 P1(0:3)
      REAL*8 W1
      COMPLEX*16 DENOM
      INTEGER*4 I
      CALL FFFF17_1(F2,F3,F4,COUP1,M1,W1,F1)
      CALL FFFF25_1(F2,F3,F4,COUP2,M1,W1,FTMP)
      DO I = 3, 6
        F1(I) = F1(I) + FTMP(I)
      ENDDO
      CALL FFFF26_1(F2,F3,F4,COUP3,M1,W1,FTMP)
      DO I = 3, 6
        F1(I) = F1(I) + FTMP(I)
      ENDDO
      CALL FFFF27_1(F2,F3,F4,COUP4,M1,W1,FTMP)
      DO I = 3, 6
        F1(I) = F1(I) + FTMP(I)
      ENDDO
      END

      subroutine set_ren_scale(P,rscale)
c----------------------------------------------------------------------
c     This is the USER-FUNCTION to calculate the renormalization
c     scale on event-by-event basis.
c----------------------------------------------------------------------      
      implicit none
      real*8   alphas
      external alphas
c
c     INCLUDE and COMMON
c
      include 'genps.inc'
      include 'nexternal.inc'
      include 'coupl.inc'

      integer i
      include 'maxamps.inc'
      integer idup(nexternal,maxproc,maxsproc)
      integer mothup(2,nexternal)
      integer icolup(2,nexternal,maxflow,maxsproc)
      include 'leshouche.inc'
      include 'run.inc'

      double precision pmass(nexternal)
      common/to_mass/  pmass

      real*8 xptj,xptb,xpta,xptl,xmtc
      real*8 xetamin,xqcut,deltaeta
      common /to_specxpt/xptj,xptb,xpta,xptl,xmtc,xetamin,xqcut,deltaeta

c
c     ARGUMENTS
c      
      REAL*8 P(0:3,nexternal)
      REAL*8 rscale
c
c     EXTERNAL
c
      REAL*8 R2,DOT,ET,ETA,DJ,SumDot,PT

c----------
c     start
c----------

      if (dynamical_scale_choice.eq.-1) then
c         Cluster external states until reducing the system to a 2->2 topology whose transverse mass is used for setting the scale.
c         This is not done in this file due to the clustering.
         rscale=0d0
      elseif(dynamical_scale_choice.eq.1) then
c         Total transverse energy of the event.         
          rscale=0d0
          do i=3,nexternal
             rscale=rscale+et(P(0,i))
          enddo      
      elseif(dynamical_scale_choice.eq.2) then
c         sum of the transverse mass
c         m^2+pt^2=p(0)^2-p(3)^2=(p(0)+p(3))*(p(0)-p(3))
          rscale=0d0
          do i=3,nexternal
            rscale=rscale+dsqrt(max(0d0,(P(0,i)+P(3,i))*(P(0,i)-P(3,i))))
          enddo
          rscale=rscale
      elseif(dynamical_scale_choice.eq.3) then
c         sum of the transverse mass divide by 2
c         m^2+pt^2=p(0)^2-p(3)^2=(p(0)+p(3))*(p(0)-p(3))
          rscale=0d0
          do i=3,nexternal
            rscale=rscale+dsqrt(max(0d0,(P(0,i)+P(3,i))*(P(0,i)-P(3,i))))
          enddo
          rscale=rscale/2d0
      elseif(dynamical_scale_choice.eq.4) then
c         \sqrt(s), partonic energy
          rscale=dsqrt(max(0d0,2d0*dot(P(0,1),P(0,2))))
      elseif(dynamical_scale_choice.eq.5) then
c         \decaying particle mass, for decays
          rscale=dsqrt(max(0d0,dot(P(0,1),P(0,1))))
      elseif(dynamical_scale_choice.eq.0) then
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cc      USER-DEFINED SCALE: ENTER YOUR CODE HERE                                 cc
cc      to use this code you must set                                            cc
cc                 dynamical_scale_choice = 0                                    cc
cc      in the run_card (run_card.dat)                                           cc
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         write(*,*) "User-defined scale not set"
         stop 21
         rscale = 0
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cc      USER-DEFINED SCALE: END OF USER CODE                                     cc
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      else
        write(*,*)'Unknown option in scale_global_reference',dynamical_scale_choice
        stop
      endif
      rscale = scalefact*rscale
      return
      end


      subroutine set_fac_scale(P,q2factorization)
c----------------------------------------------------------------------
c     This is the USER-FUNCTION to calculate the factorization 
c     scales^2 on event-by-event basis.
c----------------------------------------------------------------------      
      implicit none

c     INCLUDE and COMMON
c
      include 'genps.inc'
      include 'nexternal.inc'
      include 'coupl.inc'
      include 'run.inc'
c--masses and poles
c
c     ARGUMENTS
c      
      REAL*8 P(0:3,nexternal)
      real*8 q2factorization(2)
c
c     EXTERNAL
c
      REAL*8 R2,DOT,ET,ETA,DJ,SumDot,PT
c
c     LOCAL
c
      integer i
      logical first
      data first/.true./

c----------
c     start
c----------
      
      if (dynamical_scale_choice.eq.-1) then
c         Cluster external states until reducing the system to a 2->2 topology whose transverse mass is used for setting the scale.
c         This is not done in this file due to the clustering.
         q2factorization(1)=0d0          !factorization scale**2 for pdf1
         q2factorization(2)=0d0          !factorization scale**2 for pdf2
      elseif(dynamical_scale_choice.eq.0) then
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cc      USER DEFINE SCALE: ENTER YOUR CODE HERE                                  cc
cc      to use this code you need to set                                         cc
cc                 dymamical_scale_choice to 0 in the run_card                   cc
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c         default: use the renormalization scale
          call set_ren_scale(P,q2factorization(1))
          q2factorization(1)=q2factorization(1)**2
          q2factorization(2)=q2factorization(1)   !factorization scale**2 for pdf2

c
c-some examples of dynamical scales
c

c---------------------------------------
c-- total transverse energy of the event 
c---------------------------------------
c     q2factorization(1)=0d0
c     do i=3,nexternal
c      q2factorization(1)= q2factorization(1)+et(P(0,i))**2
c     enddo
c     q2factorization(2)=q2factorization(1)  

c--------------------------------------
c-- scale^2 = \sum_i  (pt_i^2+m_i^2)  
c--------------------------------------
c     q2factorization(1)=0d0
c     do i=3,nexternal
c      q2factorization(1)=q2factorization(1)+pt(P(0,i))**2+dot(p(0,i),p(0,i))
c     enddo
c     q2factorization(2)=q2factorization(1)  

c--------------------------------------
c-- \sqrt(s): partonic energy
c--------------------------------------
c     q2factorization(1)=2d0*dot(P(0,1),P(0,2))
c     q2factorization(2)=q2factorization(1)  



ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cc      USER DEFINE SCALE: END of USER CODE                                      cc
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      else
          call set_ren_scale(P,q2factorization(1))
          q2factorization(1)=q2factorization(1)**2
          q2factorization(2)=q2factorization(1)   !factorization scale**2 for pdf2
      endif


      

      
      return
      end

      SUBROUTINE SMATRIX2(P,ANS)
C     
C     Generated by MadGraph5_aMC@NLO v. 2.8.2, 2020-10-30
C     By the MadGraph5_aMC@NLO Development Team
C     Visit launchpad.net/madgraph5 and amcatnlo.web.cern.ch
C     
C     MadGraph5_aMC@NLO for Madevent Version
C     
C     Returns amplitude squared -- no average over initial
C      state/symmetry factor
C     and helicities
C     for the point in phase space P(0:3,NEXTERNAL)
C     
C     Process: c c~ > t t~ g g NP<=2 QCD<=4 QED=0 @2
C     
      USE DISCRETESAMPLER
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INCLUDE 'genps.inc'
      INCLUDE 'maxconfigs.inc'
      INCLUDE 'nexternal.inc'
      INCLUDE 'maxamps.inc'
      INTEGER                 NCOMB
      PARAMETER (             NCOMB=64)
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=163)
      INTEGER    NDIAGS
      PARAMETER (NDIAGS=135)
      INTEGER    THEL
      PARAMETER (THEL=2*NCOMB)
C     
C     ARGUMENTS 
C     
      REAL*8 P(0:3,NEXTERNAL),ANS
C     
C     global (due to reading writting) 
C     
      LOGICAL GOODHEL(NCOMB,2)
      INTEGER NTRY(2)
      COMMON/BLOCK_GOODHEL/NTRY,GOODHEL

C     
C     LOCAL VARIABLES 
C     
      INTEGER NHEL(NEXTERNAL,NCOMB)
      INTEGER ISHEL(2)
      REAL*8 T,MATRIX2
      REAL*8 R,SUMHEL,TS(NCOMB)
      INTEGER I,IDEN
      INTEGER JC(NEXTERNAL),II
      REAL*8 HWGT, XTOT, XTRY, XREJ, XR, YFRAC(0:NCOMB)
      INTEGER NGOOD(2), IGOOD(NCOMB,2)
      INTEGER JHEL(2), J, JJ
      INTEGER THIS_NTRY(2)
      SAVE THIS_NTRY
      INTEGER NB_FAIL
      SAVE NB_FAIL
      DATA THIS_NTRY /0,0/
      DATA NB_FAIL /0/

C     
C     This is just to temporarily store the reference grid for
C      helicity of the DiscreteSampler so as to obtain its number of
C      entries with ref_helicity_grid%n_tot_entries
      TYPE(SAMPLEDDIMENSION) REF_HELICITY_GRID
C     
C     GLOBAL VARIABLES
C     
      DOUBLE PRECISION AMP2(MAXAMPS), JAMP2(0:MAXFLOW)
      COMMON/TO_AMPS/  AMP2,       JAMP2

      CHARACTER*101         HEL_BUFF
      COMMON/TO_HELICITY/  HEL_BUFF

      INTEGER NB_SPIN_STATE_IN(2)
      COMMON /NB_HEL_STATE/ NB_SPIN_STATE_IN

      INTEGER IMIRROR
      COMMON/TO_MIRROR/ IMIRROR

      REAL*8 POL(2)
      COMMON/TO_POLARIZATION/ POL

      DOUBLE PRECISION SMALL_WIDTH_TREATMENT
      COMMON/NARROW_WIDTH/SMALL_WIDTH_TREATMENT

      INTEGER          ISUM_HEL
      LOGICAL                    MULTI_CHANNEL
      COMMON/TO_MATRIX/ISUM_HEL, MULTI_CHANNEL
      INTEGER MAPCONFIG(0:LMAXCONFIGS), ICONFIG
      COMMON/TO_MCONFIGS/MAPCONFIG, ICONFIG
      INTEGER SUBDIAG(MAXSPROC),IB(2)
      COMMON/TO_SUB_DIAG/SUBDIAG,IB
      DATA XTRY, XREJ /0,0/
      DATA NGOOD /0,0/
      DATA ISHEL/0,0/
      SAVE YFRAC, IGOOD, JHEL
      DATA (NHEL(I,   1),I=1,6) / 1,-1,-1, 1,-1,-1/
      DATA (NHEL(I,   2),I=1,6) / 1,-1,-1, 1,-1, 1/
      DATA (NHEL(I,   3),I=1,6) / 1,-1,-1, 1, 1,-1/
      DATA (NHEL(I,   4),I=1,6) / 1,-1,-1, 1, 1, 1/
      DATA (NHEL(I,   5),I=1,6) / 1,-1,-1,-1,-1,-1/
      DATA (NHEL(I,   6),I=1,6) / 1,-1,-1,-1,-1, 1/
      DATA (NHEL(I,   7),I=1,6) / 1,-1,-1,-1, 1,-1/
      DATA (NHEL(I,   8),I=1,6) / 1,-1,-1,-1, 1, 1/
      DATA (NHEL(I,   9),I=1,6) / 1,-1, 1, 1,-1,-1/
      DATA (NHEL(I,  10),I=1,6) / 1,-1, 1, 1,-1, 1/
      DATA (NHEL(I,  11),I=1,6) / 1,-1, 1, 1, 1,-1/
      DATA (NHEL(I,  12),I=1,6) / 1,-1, 1, 1, 1, 1/
      DATA (NHEL(I,  13),I=1,6) / 1,-1, 1,-1,-1,-1/
      DATA (NHEL(I,  14),I=1,6) / 1,-1, 1,-1,-1, 1/
      DATA (NHEL(I,  15),I=1,6) / 1,-1, 1,-1, 1,-1/
      DATA (NHEL(I,  16),I=1,6) / 1,-1, 1,-1, 1, 1/
      DATA (NHEL(I,  17),I=1,6) / 1, 1,-1, 1,-1,-1/
      DATA (NHEL(I,  18),I=1,6) / 1, 1,-1, 1,-1, 1/
      DATA (NHEL(I,  19),I=1,6) / 1, 1,-1, 1, 1,-1/
      DATA (NHEL(I,  20),I=1,6) / 1, 1,-1, 1, 1, 1/
      DATA (NHEL(I,  21),I=1,6) / 1, 1,-1,-1,-1,-1/
      DATA (NHEL(I,  22),I=1,6) / 1, 1,-1,-1,-1, 1/
      DATA (NHEL(I,  23),I=1,6) / 1, 1,-1,-1, 1,-1/
      DATA (NHEL(I,  24),I=1,6) / 1, 1,-1,-1, 1, 1/
      DATA (NHEL(I,  25),I=1,6) / 1, 1, 1, 1,-1,-1/
      DATA (NHEL(I,  26),I=1,6) / 1, 1, 1, 1,-1, 1/
      DATA (NHEL(I,  27),I=1,6) / 1, 1, 1, 1, 1,-1/
      DATA (NHEL(I,  28),I=1,6) / 1, 1, 1, 1, 1, 1/
      DATA (NHEL(I,  29),I=1,6) / 1, 1, 1,-1,-1,-1/
      DATA (NHEL(I,  30),I=1,6) / 1, 1, 1,-1,-1, 1/
      DATA (NHEL(I,  31),I=1,6) / 1, 1, 1,-1, 1,-1/
      DATA (NHEL(I,  32),I=1,6) / 1, 1, 1,-1, 1, 1/
      DATA (NHEL(I,  33),I=1,6) /-1,-1,-1, 1,-1,-1/
      DATA (NHEL(I,  34),I=1,6) /-1,-1,-1, 1,-1, 1/
      DATA (NHEL(I,  35),I=1,6) /-1,-1,-1, 1, 1,-1/
      DATA (NHEL(I,  36),I=1,6) /-1,-1,-1, 1, 1, 1/
      DATA (NHEL(I,  37),I=1,6) /-1,-1,-1,-1,-1,-1/
      DATA (NHEL(I,  38),I=1,6) /-1,-1,-1,-1,-1, 1/
      DATA (NHEL(I,  39),I=1,6) /-1,-1,-1,-1, 1,-1/
      DATA (NHEL(I,  40),I=1,6) /-1,-1,-1,-1, 1, 1/
      DATA (NHEL(I,  41),I=1,6) /-1,-1, 1, 1,-1,-1/
      DATA (NHEL(I,  42),I=1,6) /-1,-1, 1, 1,-1, 1/
      DATA (NHEL(I,  43),I=1,6) /-1,-1, 1, 1, 1,-1/
      DATA (NHEL(I,  44),I=1,6) /-1,-1, 1, 1, 1, 1/
      DATA (NHEL(I,  45),I=1,6) /-1,-1, 1,-1,-1,-1/
      DATA (NHEL(I,  46),I=1,6) /-1,-1, 1,-1,-1, 1/
      DATA (NHEL(I,  47),I=1,6) /-1,-1, 1,-1, 1,-1/
      DATA (NHEL(I,  48),I=1,6) /-1,-1, 1,-1, 1, 1/
      DATA (NHEL(I,  49),I=1,6) /-1, 1,-1, 1,-1,-1/
      DATA (NHEL(I,  50),I=1,6) /-1, 1,-1, 1,-1, 1/
      DATA (NHEL(I,  51),I=1,6) /-1, 1,-1, 1, 1,-1/
      DATA (NHEL(I,  52),I=1,6) /-1, 1,-1, 1, 1, 1/
      DATA (NHEL(I,  53),I=1,6) /-1, 1,-1,-1,-1,-1/
      DATA (NHEL(I,  54),I=1,6) /-1, 1,-1,-1,-1, 1/
      DATA (NHEL(I,  55),I=1,6) /-1, 1,-1,-1, 1,-1/
      DATA (NHEL(I,  56),I=1,6) /-1, 1,-1,-1, 1, 1/
      DATA (NHEL(I,  57),I=1,6) /-1, 1, 1, 1,-1,-1/
      DATA (NHEL(I,  58),I=1,6) /-1, 1, 1, 1,-1, 1/
      DATA (NHEL(I,  59),I=1,6) /-1, 1, 1, 1, 1,-1/
      DATA (NHEL(I,  60),I=1,6) /-1, 1, 1, 1, 1, 1/
      DATA (NHEL(I,  61),I=1,6) /-1, 1, 1,-1,-1,-1/
      DATA (NHEL(I,  62),I=1,6) /-1, 1, 1,-1,-1, 1/
      DATA (NHEL(I,  63),I=1,6) /-1, 1, 1,-1, 1,-1/
      DATA (NHEL(I,  64),I=1,6) /-1, 1, 1,-1, 1, 1/
      DATA IDEN/72/

C     To be able to control when the matrix<i> subroutine can add
C      entries to the grid for the MC over helicity configuration
      LOGICAL ALLOW_HELICITY_GRID_ENTRIES
      COMMON/TO_ALLOW_HELICITY_GRID_ENTRIES/ALLOW_HELICITY_GRID_ENTRIES

C     ----------
C     BEGIN CODE
C     ----------

      NTRY(IMIRROR)=NTRY(IMIRROR)+1
      THIS_NTRY(IMIRROR) = THIS_NTRY(IMIRROR)+1
      DO I=1,NEXTERNAL
        JC(I) = +1
      ENDDO

      IF (MULTI_CHANNEL) THEN
        DO I=1,NDIAGS
          AMP2(I)=0D0
        ENDDO
        JAMP2(0)=12
        DO I=1,INT(JAMP2(0))
          JAMP2(I)=0D0
        ENDDO
      ENDIF
      ANS = 0D0
      WRITE(HEL_BUFF,'(20I5)') (0,I=1,NEXTERNAL)
      DO I=1,NCOMB
        TS(I)=0D0
      ENDDO

        !   If the helicity grid status is 0, this means that it is not yet initialized.
        !   If HEL_PICKED==-1, this means that calls to other matrix<i> where in initialization mode as well for the helicity.
      IF ((ISHEL(IMIRROR).EQ.0.AND.ISUM_HEL.EQ.0)
     $ .OR.(DS_GET_DIM_STATUS('Helicity').EQ.0).OR.(HEL_PICKED.EQ.-1))
     $  THEN
        DO I=1,NCOMB
          IF (GOODHEL(I,IMIRROR) .OR. NTRY(IMIRROR)
     $     .LE.MAXTRIES.OR.(ISUM_HEL.NE.0).OR.THIS_NTRY(IMIRROR).LE.2)
     $      THEN
            T=MATRIX2(P ,NHEL(1,I),JC(1))
            DO JJ=1,NINCOMING
              IF(POL(JJ).NE.1D0.AND.NHEL(JJ,I).EQ.INT(SIGN(1D0,POL(JJ))
     $         )) THEN
                T=T*ABS(POL(JJ))*NB_SPIN_STATE_IN(JJ)/2D0  ! NB_SPIN_STATE(JJ)/2d0 is added for polarised beam
              ELSE IF(POL(JJ).NE.1D0)THEN
                T=T*(2D0-ABS(POL(JJ)))*NB_SPIN_STATE_IN(JJ)/2D0
              ENDIF
            ENDDO
            IF (ISUM_HEL.NE.0.AND.DS_GET_DIM_STATUS('Helicity')
     $       .EQ.0.AND.ALLOW_HELICITY_GRID_ENTRIES) THEN
              CALL DS_ADD_ENTRY('Helicity',I,T)
            ENDIF
            ANS=ANS+DABS(T)
            TS(I)=T
          ENDIF
        ENDDO
        IF(NTRY(IMIRROR).EQ.(MAXTRIES+1)) THEN
          CALL RESET_CUMULATIVE_VARIABLE()  ! avoid biais of the initialization
        ENDIF
        IF (ISUM_HEL.NE.0) THEN
            !         We set HEL_PICKED to -1 here so that later on, the call to DS_add_point in dsample.f does not add anything to the grid since it was already done here.
          HEL_PICKED = -1
            !         For safety, hardset the helicity sampling jacobian to 0.0d0 to make sure it is not .
          HEL_JACOBIAN   = 1.0D0
            !         We don't want to re-update the helicity grid if it was already updated by another matrix<i>, so we make sure that the reference grid is empty.
          REF_HELICITY_GRID = DS_GET_DIMENSION(REF_GRID,'Helicity')
          IF((DS_GET_DIM_STATUS('Helicity').EQ.1)
     $     .AND.(REF_HELICITY_GRID%N_TOT_ENTRIES.EQ.0)) THEN
              !           If we finished the initialization we can update the grid so as to start sampling over it.
              !           However the grid will now be filled by dsample with different kind of weights (including pdf, flux, etc...) so by setting the grid_mode of the reference grid to 'initialization' we make sure it will be overwritten (as opposed to 'combined') by the running grid at the next update.
            CALL DS_UPDATE_GRID('Helicity')
            CALL DS_SET_GRID_MODE('Helicity','init')
          ENDIF
        ELSE
          JHEL(IMIRROR) = 1
          IF(NTRY(IMIRROR).LE.MAXTRIES.OR.THIS_NTRY(IMIRROR).LE.2)THEN
            DO I=1,NCOMB
              IF (.NOT.GOODHEL(I,IMIRROR) .AND. (DABS(TS(I)).GT.ANS
     $         *LIMHEL/NCOMB)) THEN
                GOODHEL(I,IMIRROR)=.TRUE.
                NGOOD(IMIRROR) = NGOOD(IMIRROR) +1
                IGOOD(NGOOD(IMIRROR),IMIRROR) = I
                PRINT *,'Added good helicity ',I,TS(I)*NCOMB/ANS,' in'
     $           //' event ',NTRY(IMIRROR), 'local:',THIS_NTRY(IMIRROR)
              ENDIF
            ENDDO
          ENDIF
          IF(NTRY(IMIRROR).EQ.MAXTRIES)THEN
            ISHEL(IMIRROR)=MIN(ISUM_HEL,NGOOD(IMIRROR))
          ENDIF
        ENDIF
      ELSE  ! random helicity 
C       The helicity configuration was chosen already by genps and put
C        in a common block defined in genps.inc.
        I = HEL_PICKED

        T=MATRIX2(P ,NHEL(1,I),JC(1))

        DO JJ=1,NINCOMING
          IF(POL(JJ).NE.1D0.AND.NHEL(JJ,I).EQ.INT(SIGN(1D0,POL(JJ))))
     $      THEN
            T=T*ABS(POL(JJ))
          ELSE IF(POL(JJ).NE.1D0)THEN
            T=T*(2D0-ABS(POL(JJ)))
          ENDIF
        ENDDO
C       Always one helicity at a time
        ANS = T
C       Include the Jacobian from helicity sampling
        ANS = ANS * HEL_JACOBIAN

        WRITE(HEL_BUFF,'(20i5)')(NHEL(II,I),II=1,NEXTERNAL)
      ENDIF
      IF (ANS.NE.0D0.AND.(ISUM_HEL .NE. 1.OR.HEL_PICKED.EQ.-1)) THEN
        CALL RANMAR(R)
        SUMHEL=0D0
        DO I=1,NCOMB
          SUMHEL=SUMHEL+DABS(TS(I))/ANS
          IF(R.LT.SUMHEL)THEN
            WRITE(HEL_BUFF,'(20i5)')(NHEL(II,I),II=1,NEXTERNAL)
C           Set right sign for ANS, based on sign of chosen helicity
            ANS=DSIGN(ANS,TS(I))
            GOTO 10
          ENDIF
        ENDDO
 10     CONTINUE
      ENDIF
      IF (MULTI_CHANNEL) THEN
        XTOT=0D0
        DO I=1,NDIAGS
          XTOT=XTOT+AMP2(I)
        ENDDO
        IF (XTOT.NE.0D0) THEN
          ANS=ANS*AMP2(SUBDIAG(2))/XTOT
        ELSE IF(ANS.NE.0D0) THEN
          IF(NB_FAIL.GE.10)THEN
            WRITE(*,*) 'Problem in the multi-channeling. All amp2 are'
     $       //' zero but not the total matrix-element'

            STOP 1
          ELSE
            NB_FAIL = NB_FAIL +1
          ENDIF
        ENDIF
      ENDIF
      ANS=ANS/DBLE(IDEN)
      END


      REAL*8 FUNCTION MATRIX2(P,NHEL,IC)
C     
C     Generated by MadGraph5_aMC@NLO v. 2.8.2, 2020-10-30
C     By the MadGraph5_aMC@NLO Development Team
C     Visit launchpad.net/madgraph5 and amcatnlo.web.cern.ch
C     
C     Returns amplitude squared summed/avg over colors
C     for the point with external lines W(0:6,NEXTERNAL)
C     
C     Process: c c~ > t t~ g g NP<=2 QCD<=4 QED=0 @2
C     
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=163)
      INCLUDE 'genps.inc'
      INCLUDE 'nexternal.inc'
      INCLUDE 'maxamps.inc'
      INTEGER    NWAVEFUNCS,     NCOLOR
      PARAMETER (NWAVEFUNCS=29, NCOLOR=12)
      REAL*8     ZERO
      PARAMETER (ZERO=0D0)
      COMPLEX*16 IMAG1
      PARAMETER (IMAG1=(0D0,1D0))
      INTEGER NAMPSO, NSQAMPSO
      PARAMETER (NAMPSO=1, NSQAMPSO=1)
      LOGICAL CHOSEN_SO_CONFIGS(NSQAMPSO)
      DATA CHOSEN_SO_CONFIGS/.TRUE./
      SAVE CHOSEN_SO_CONFIGS
C     
C     ARGUMENTS 
C     
      REAL*8 P(0:3,NEXTERNAL)
      INTEGER NHEL(NEXTERNAL), IC(NEXTERNAL)
C     
C     LOCAL VARIABLES 
C     
      INTEGER I,J,M,N
      COMPLEX*16 ZTEMP
      REAL*8 DENOM(NCOLOR), CF(NCOLOR,NCOLOR)
      COMPLEX*16 AMP(NGRAPHS), JAMP(NCOLOR,NAMPSO)
      COMPLEX*16 W(6,NWAVEFUNCS)
C     Needed for v4 models
      COMPLEX*16 DUM0,DUM1
      DATA DUM0, DUM1/(0D0, 0D0), (1D0, 0D0)/

      DOUBLE PRECISION FK_ZERO
      SAVE FK_ZERO

      LOGICAL FIRST
      DATA FIRST /.TRUE./
      SAVE FIRST
C     
C     FUNCTION
C     
      INTEGER SQSOINDEX2
C     
C     GLOBAL VARIABLES
C     
      DOUBLE PRECISION AMP2(MAXAMPS), JAMP2(0:MAXFLOW)
      COMMON/TO_AMPS/  AMP2,       JAMP2
      INCLUDE 'coupl.inc'

      DOUBLE PRECISION SMALL_WIDTH_TREATMENT
      COMMON/NARROW_WIDTH/SMALL_WIDTH_TREATMENT
C     
C     COLOR DATA
C     
      DATA DENOM(1)/3/
      DATA (CF(I,  1),I=  1,  6) /   48,   -6,   16,   -2,   16,   -2/
      DATA (CF(I,  1),I=  7, 12) /    6,    6,    0,   -2,   16,    0/
C     1 T(2,1) T(5,6,3,4)
      DATA DENOM(2)/3/
      DATA (CF(I,  2),I=  1,  6) /   -6,   48,   -2,   16,   -2,   16/
      DATA (CF(I,  2),I=  7, 12) /    6,    6,    0,   16,   -2,    0/
C     1 T(2,1) T(6,5,3,4)
      DATA DENOM(3)/3/
      DATA (CF(I,  3),I=  1,  6) /   16,   -2,   48,   -6,    6,    6/
      DATA (CF(I,  3),I=  7, 12) /   16,   -2,   -2,    0,    0,   16/
C     1 T(2,4) T(5,6,3,1)
      DATA DENOM(4)/3/
      DATA (CF(I,  4),I=  1,  6) /   -2,   16,   -6,   48,    6,    6/
      DATA (CF(I,  4),I=  7, 12) /   -2,   16,   16,    0,    0,   -2/
C     1 T(2,4) T(6,5,3,1)
      DATA DENOM(5)/3/
      DATA (CF(I,  5),I=  1,  6) /   16,   -2,    6,    6,   48,   -6/
      DATA (CF(I,  5),I=  7, 12) /   16,   -2,   16,    0,    0,   -2/
C     1 T(3,1) T(5,6,2,4)
      DATA DENOM(6)/3/
      DATA (CF(I,  6),I=  1,  6) /   -2,   16,    6,    6,   -6,   48/
      DATA (CF(I,  6),I=  7, 12) /   -2,   16,   -2,    0,    0,   16/
C     1 T(3,1) T(6,5,2,4)
      DATA DENOM(7)/3/
      DATA (CF(I,  7),I=  1,  6) /    6,    6,   16,   -2,   16,   -2/
      DATA (CF(I,  7),I=  7, 12) /   48,   -6,    0,   16,   -2,    0/
C     1 T(3,4) T(5,6,2,1)
      DATA DENOM(8)/3/
      DATA (CF(I,  8),I=  1,  6) /    6,    6,   -2,   16,   -2,   16/
      DATA (CF(I,  8),I=  7, 12) /   -6,   48,    0,   -2,   16,    0/
C     1 T(3,4) T(6,5,2,1)
      DATA DENOM(9)/3/
      DATA (CF(I,  9),I=  1,  6) /    0,    0,   -2,   16,   16,   -2/
      DATA (CF(I,  9),I=  7, 12) /    0,    0,   48,   16,   16,    6/
C     1 T(5,2,1) T(6,3,4)
      DATA DENOM(10)/3/
      DATA (CF(I, 10),I=  1,  6) /   -2,   16,    0,    0,    0,    0/
      DATA (CF(I, 10),I=  7, 12) /   16,   -2,   16,   48,    6,   16/
C     1 T(5,2,4) T(6,3,1)
      DATA DENOM(11)/3/
      DATA (CF(I, 11),I=  1,  6) /   16,   -2,    0,    0,    0,    0/
      DATA (CF(I, 11),I=  7, 12) /   -2,   16,   16,    6,   48,   16/
C     1 T(5,3,1) T(6,2,4)
      DATA DENOM(12)/3/
      DATA (CF(I, 12),I=  1,  6) /    0,    0,   16,   -2,   -2,   16/
      DATA (CF(I, 12),I=  7, 12) /    0,    0,    6,   16,   16,   48/
C     1 T(5,3,4) T(6,2,1)
C     ----------
C     BEGIN CODE
C     ----------
      IF (FIRST) THEN
        FIRST=.FALSE.
        IF(ZERO.NE.0D0) FK_ZERO = SIGN(MAX(ABS(ZERO), ABS(ZERO
     $   *SMALL_WIDTH_TREATMENT)), ZERO)
        IF(ZERO.NE.0D0) FK_ZERO = SIGN(MAX(ABS(ZERO), ABS(MDL_MT
     $   *SMALL_WIDTH_TREATMENT)), ZERO)
      ENDIF


      CALL IXXXXX(P(0,1),ZERO,NHEL(1),+1*IC(1),W(1,1))
      CALL OXXXXX(P(0,2),ZERO,NHEL(2),-1*IC(2),W(1,2))
      CALL OXXXXX(P(0,3),MDL_MT,NHEL(3),+1*IC(3),W(1,3))
      CALL IXXXXX(P(0,4),MDL_MT,NHEL(4),-1*IC(4),W(1,4))
      CALL VXXXXX(P(0,5),ZERO,NHEL(5),+1*IC(5),W(1,5))
      CALL VXXXXX(P(0,6),ZERO,NHEL(6),+1*IC(6),W(1,6))
      CALL VVV8P0_1(W(1,5),W(1,6),GC_10,ZERO, FK_ZERO,W(1,7))
      CALL FFV87P0_3(W(1,4),W(1,3),GC_11,ZERO, FK_ZERO,W(1,8))
      CALL FFV57_1(W(1,2),W(1,7),GC_11,ZERO, FK_ZERO,W(1,9))
C     Amplitude(s) for diagram number 1
      CALL FFV57_0(W(1,1),W(1,9),W(1,8),GC_11,AMP(1))
      CALL FFV57_2(W(1,1),W(1,7),GC_11,ZERO, FK_ZERO,W(1,10))
C     Amplitude(s) for diagram number 2
      CALL FFV57_0(W(1,10),W(1,2),W(1,8),GC_11,AMP(2))
      CALL FFV110P0_3(W(1,4),W(1,3),GC_358,ZERO, FK_ZERO,W(1,11))
C     Amplitude(s) for diagram number 3
      CALL FFV57_0(W(1,1),W(1,9),W(1,11),GC_11,AMP(3))
C     Amplitude(s) for diagram number 4
      CALL FFV57_0(W(1,10),W(1,2),W(1,11),GC_11,AMP(4))
      CALL FFV57P0_3(W(1,1),W(1,2),GC_11,ZERO, FK_ZERO,W(1,10))
C     Amplitude(s) for diagram number 5
      CALL VVV8_0(W(1,7),W(1,8),W(1,10),GC_10,AMP(5))
C     Amplitude(s) for diagram number 6
      CALL VVV8_0(W(1,7),W(1,11),W(1,10),GC_10,AMP(6))
C     Amplitude(s) for diagram number 7
      CALL FFVV186_0(W(1,4),W(1,3),W(1,7),W(1,10),GC_360,AMP(7))
      CALL FFV87_1(W(1,3),W(1,7),GC_11,MDL_MT, FK_ZERO,W(1,9))
C     Amplitude(s) for diagram number 8
      CALL FFV87_0(W(1,4),W(1,9),W(1,10),GC_11,AMP(8))
C     Amplitude(s) for diagram number 9
      CALL FFV110_0(W(1,4),W(1,9),W(1,10),GC_358,AMP(9))
      CALL FFV110_1(W(1,3),W(1,7),GC_358,MDL_MT, FK_ZERO,W(1,9))
C     Amplitude(s) for diagram number 10
      CALL FFV87_0(W(1,4),W(1,9),W(1,10),GC_11,AMP(10))
      CALL FFV87_2(W(1,4),W(1,7),GC_11,MDL_MT, FK_ZERO,W(1,9))
C     Amplitude(s) for diagram number 11
      CALL FFV87_0(W(1,9),W(1,3),W(1,10),GC_11,AMP(11))
C     Amplitude(s) for diagram number 12
      CALL FFV110_0(W(1,9),W(1,3),W(1,10),GC_358,AMP(12))
      CALL FFV110_2(W(1,4),W(1,7),GC_358,MDL_MT, FK_ZERO,W(1,9))
C     Amplitude(s) for diagram number 13
      CALL FFV87_0(W(1,9),W(1,3),W(1,10),GC_11,AMP(13))
      CALL FFFF18_24_28_29_1(W(1,2),W(1,4),W(1,3),GC_31,GC_87,GC_109
     $ ,GC_112,ZERO, FK_ZERO,W(1,9))
      CALL FFFF18_24_28_29_1(W(1,2),W(1,4),W(1,3),GC_35,GC_88,GC_110
     $ ,GC_113,ZERO, FK_ZERO,W(1,12))
C     Amplitude(s) for diagram number 14
      CALL FFV57_0(W(1,1),W(1,9),W(1,7),GC_11,AMP(14))
      CALL FFV57_0(W(1,1),W(1,12),W(1,7),GC_11,AMP(15))
      CALL FFFF18_24_28_29_2(W(1,1),W(1,4),W(1,3),GC_31,GC_87,GC_109
     $ ,GC_112,ZERO, FK_ZERO,W(1,13))
      CALL FFFF18_24_28_29_2(W(1,1),W(1,4),W(1,3),GC_35,GC_88,GC_110
     $ ,GC_113,ZERO, FK_ZERO,W(1,14))
C     Amplitude(s) for diagram number 15
      CALL FFV57_0(W(1,13),W(1,2),W(1,7),GC_11,AMP(16))
      CALL FFV57_0(W(1,14),W(1,2),W(1,7),GC_11,AMP(17))
      CALL FFFF18_24_28_29_3(W(1,1),W(1,2),W(1,3),GC_31,GC_87,GC_109
     $ ,GC_112,MDL_MT, FK_ZERO,W(1,15))
      CALL FFFF18_24_28_29_3(W(1,1),W(1,2),W(1,3),GC_35,GC_88,GC_110
     $ ,GC_113,MDL_MT, FK_ZERO,W(1,16))
C     Amplitude(s) for diagram number 16
      CALL FFV87_0(W(1,4),W(1,15),W(1,7),GC_11,AMP(18))
      CALL FFV87_0(W(1,4),W(1,16),W(1,7),GC_11,AMP(19))
      CALL FFFF18_24_28_29_4(W(1,1),W(1,2),W(1,4),GC_31,GC_87,GC_109
     $ ,GC_112,MDL_MT, FK_ZERO,W(1,17))
      CALL FFFF18_24_28_29_4(W(1,1),W(1,2),W(1,4),GC_35,GC_88,GC_110
     $ ,GC_113,MDL_MT, FK_ZERO,W(1,18))
C     Amplitude(s) for diagram number 17
      CALL FFV87_0(W(1,17),W(1,3),W(1,7),GC_11,AMP(20))
      CALL FFV87_0(W(1,18),W(1,3),W(1,7),GC_11,AMP(21))
      CALL FFV87_1(W(1,3),W(1,5),GC_11,MDL_MT, FK_ZERO,W(1,7))
      CALL FFV87_2(W(1,4),W(1,6),GC_11,MDL_MT, FK_ZERO,W(1,19))
C     Amplitude(s) for diagram number 18
      CALL FFFF18_24_28_29_0(W(1,1),W(1,2),W(1,19),W(1,7),GC_31,GC_87
     $ ,GC_109,GC_112,AMP(22))
      CALL FFFF18_24_28_29_0(W(1,1),W(1,2),W(1,19),W(1,7),GC_35,GC_88
     $ ,GC_110,GC_113,AMP(23))
C     Amplitude(s) for diagram number 19
      CALL FFV87_0(W(1,19),W(1,7),W(1,10),GC_11,AMP(24))
C     Amplitude(s) for diagram number 20
      CALL FFV110_0(W(1,19),W(1,7),W(1,10),GC_358,AMP(25))
      CALL FFV110_2(W(1,4),W(1,6),GC_358,MDL_MT, FK_ZERO,W(1,20))
C     Amplitude(s) for diagram number 21
      CALL FFV87_0(W(1,20),W(1,7),W(1,10),GC_11,AMP(26))
      CALL FFV110_1(W(1,3),W(1,5),GC_358,MDL_MT, FK_ZERO,W(1,21))
C     Amplitude(s) for diagram number 22
      CALL FFV87_0(W(1,19),W(1,21),W(1,10),GC_11,AMP(27))
      CALL FFV57_1(W(1,2),W(1,6),GC_11,ZERO, FK_ZERO,W(1,22))
C     Amplitude(s) for diagram number 23
      CALL FFFF18_24_28_29_0(W(1,1),W(1,22),W(1,4),W(1,7),GC_31,GC_87
     $ ,GC_109,GC_112,AMP(28))
      CALL FFFF18_24_28_29_0(W(1,1),W(1,22),W(1,4),W(1,7),GC_35,GC_88
     $ ,GC_110,GC_113,AMP(29))
      CALL FFV87P0_3(W(1,4),W(1,7),GC_11,ZERO, FK_ZERO,W(1,23))
C     Amplitude(s) for diagram number 24
      CALL FFV57_0(W(1,1),W(1,22),W(1,23),GC_11,AMP(30))
      CALL FFV110P0_3(W(1,4),W(1,7),GC_358,ZERO, FK_ZERO,W(1,24))
C     Amplitude(s) for diagram number 25
      CALL FFV57_0(W(1,1),W(1,22),W(1,24),GC_11,AMP(31))
      CALL FFV87P0_3(W(1,4),W(1,21),GC_11,ZERO, FK_ZERO,W(1,25))
C     Amplitude(s) for diagram number 26
      CALL FFV57_0(W(1,1),W(1,22),W(1,25),GC_11,AMP(32))
      CALL FFV57_2(W(1,1),W(1,6),GC_11,ZERO, FK_ZERO,W(1,26))
C     Amplitude(s) for diagram number 27
      CALL FFFF18_24_28_29_0(W(1,26),W(1,2),W(1,4),W(1,7),GC_31,GC_87
     $ ,GC_109,GC_112,AMP(33))
      CALL FFFF18_24_28_29_0(W(1,26),W(1,2),W(1,4),W(1,7),GC_35,GC_88
     $ ,GC_110,GC_113,AMP(34))
C     Amplitude(s) for diagram number 28
      CALL FFV57_0(W(1,26),W(1,2),W(1,23),GC_11,AMP(35))
C     Amplitude(s) for diagram number 29
      CALL FFV57_0(W(1,26),W(1,2),W(1,24),GC_11,AMP(36))
C     Amplitude(s) for diagram number 30
      CALL FFV57_0(W(1,26),W(1,2),W(1,25),GC_11,AMP(37))
C     Amplitude(s) for diagram number 31
      CALL FFVV186_0(W(1,4),W(1,7),W(1,6),W(1,10),GC_360,AMP(38))
      CALL FFV87_1(W(1,7),W(1,6),GC_11,MDL_MT, FK_ZERO,W(1,27))
C     Amplitude(s) for diagram number 32
      CALL FFV87_0(W(1,4),W(1,27),W(1,10),GC_11,AMP(39))
C     Amplitude(s) for diagram number 33
      CALL FFV110_0(W(1,4),W(1,27),W(1,10),GC_358,AMP(40))
      CALL FFV110_1(W(1,7),W(1,6),GC_358,MDL_MT, FK_ZERO,W(1,27))
C     Amplitude(s) for diagram number 34
      CALL FFV87_0(W(1,4),W(1,27),W(1,10),GC_11,AMP(41))
C     Amplitude(s) for diagram number 35
      CALL VVV8_0(W(1,6),W(1,10),W(1,23),GC_10,AMP(42))
C     Amplitude(s) for diagram number 36
      CALL VVV8_0(W(1,6),W(1,10),W(1,24),GC_10,AMP(43))
      CALL FFV87_1(W(1,21),W(1,6),GC_11,MDL_MT, FK_ZERO,W(1,24))
C     Amplitude(s) for diagram number 37
      CALL FFV87_0(W(1,4),W(1,24),W(1,10),GC_11,AMP(44))
C     Amplitude(s) for diagram number 38
      CALL VVV8_0(W(1,6),W(1,10),W(1,25),GC_10,AMP(45))
C     Amplitude(s) for diagram number 39
      CALL FFV87_0(W(1,17),W(1,7),W(1,6),GC_11,AMP(46))
      CALL FFV87_0(W(1,18),W(1,7),W(1,6),GC_11,AMP(47))
      CALL FFV87_2(W(1,4),W(1,5),GC_11,MDL_MT, FK_ZERO,W(1,7))
      CALL FFV87_1(W(1,3),W(1,6),GC_11,MDL_MT, FK_ZERO,W(1,25))
C     Amplitude(s) for diagram number 40
      CALL FFFF18_24_28_29_0(W(1,1),W(1,2),W(1,7),W(1,25),GC_31,GC_87
     $ ,GC_109,GC_112,AMP(48))
      CALL FFFF18_24_28_29_0(W(1,1),W(1,2),W(1,7),W(1,25),GC_35,GC_88
     $ ,GC_110,GC_113,AMP(49))
C     Amplitude(s) for diagram number 41
      CALL FFV87_0(W(1,7),W(1,25),W(1,10),GC_11,AMP(50))
C     Amplitude(s) for diagram number 42
      CALL FFV110_0(W(1,7),W(1,25),W(1,10),GC_358,AMP(51))
      CALL FFV110_1(W(1,3),W(1,6),GC_358,MDL_MT, FK_ZERO,W(1,24))
C     Amplitude(s) for diagram number 43
      CALL FFV87_0(W(1,7),W(1,24),W(1,10),GC_11,AMP(52))
      CALL FFV110_2(W(1,4),W(1,5),GC_358,MDL_MT, FK_ZERO,W(1,21))
C     Amplitude(s) for diagram number 44
      CALL FFV87_0(W(1,21),W(1,25),W(1,10),GC_11,AMP(53))
C     Amplitude(s) for diagram number 45
      CALL FFFF18_24_28_29_0(W(1,1),W(1,22),W(1,7),W(1,3),GC_31,GC_87
     $ ,GC_109,GC_112,AMP(54))
      CALL FFFF18_24_28_29_0(W(1,1),W(1,22),W(1,7),W(1,3),GC_35,GC_88
     $ ,GC_110,GC_113,AMP(55))
      CALL FFV87P0_3(W(1,7),W(1,3),GC_11,ZERO, FK_ZERO,W(1,23))
C     Amplitude(s) for diagram number 46
      CALL FFV57_0(W(1,1),W(1,22),W(1,23),GC_11,AMP(56))
      CALL FFV110P0_3(W(1,7),W(1,3),GC_358,ZERO, FK_ZERO,W(1,27))
C     Amplitude(s) for diagram number 47
      CALL FFV57_0(W(1,1),W(1,22),W(1,27),GC_11,AMP(57))
      CALL FFV87P0_3(W(1,21),W(1,3),GC_11,ZERO, FK_ZERO,W(1,28))
C     Amplitude(s) for diagram number 48
      CALL FFV57_0(W(1,1),W(1,22),W(1,28),GC_11,AMP(58))
C     Amplitude(s) for diagram number 49
      CALL FFFF18_24_28_29_0(W(1,26),W(1,2),W(1,7),W(1,3),GC_31,GC_87
     $ ,GC_109,GC_112,AMP(59))
      CALL FFFF18_24_28_29_0(W(1,26),W(1,2),W(1,7),W(1,3),GC_35,GC_88
     $ ,GC_110,GC_113,AMP(60))
C     Amplitude(s) for diagram number 50
      CALL FFV57_0(W(1,26),W(1,2),W(1,23),GC_11,AMP(61))
C     Amplitude(s) for diagram number 51
      CALL FFV57_0(W(1,26),W(1,2),W(1,27),GC_11,AMP(62))
C     Amplitude(s) for diagram number 52
      CALL FFV57_0(W(1,26),W(1,2),W(1,28),GC_11,AMP(63))
C     Amplitude(s) for diagram number 53
      CALL FFVV186_0(W(1,7),W(1,3),W(1,6),W(1,10),GC_360,AMP(64))
      CALL FFV87_2(W(1,7),W(1,6),GC_11,MDL_MT, FK_ZERO,W(1,29))
C     Amplitude(s) for diagram number 54
      CALL FFV87_0(W(1,29),W(1,3),W(1,10),GC_11,AMP(65))
C     Amplitude(s) for diagram number 55
      CALL FFV110_0(W(1,29),W(1,3),W(1,10),GC_358,AMP(66))
      CALL FFV110_2(W(1,7),W(1,6),GC_358,MDL_MT, FK_ZERO,W(1,29))
C     Amplitude(s) for diagram number 56
      CALL FFV87_0(W(1,29),W(1,3),W(1,10),GC_11,AMP(67))
C     Amplitude(s) for diagram number 57
      CALL VVV8_0(W(1,6),W(1,10),W(1,23),GC_10,AMP(68))
C     Amplitude(s) for diagram number 58
      CALL VVV8_0(W(1,6),W(1,10),W(1,27),GC_10,AMP(69))
      CALL FFV87_2(W(1,21),W(1,6),GC_11,MDL_MT, FK_ZERO,W(1,27))
C     Amplitude(s) for diagram number 59
      CALL FFV87_0(W(1,27),W(1,3),W(1,10),GC_11,AMP(70))
C     Amplitude(s) for diagram number 60
      CALL VVV8_0(W(1,6),W(1,10),W(1,28),GC_10,AMP(71))
C     Amplitude(s) for diagram number 61
      CALL FFV87_0(W(1,7),W(1,15),W(1,6),GC_11,AMP(72))
      CALL FFV87_0(W(1,7),W(1,16),W(1,6),GC_11,AMP(73))
      CALL FFV57_1(W(1,2),W(1,5),GC_11,ZERO, FK_ZERO,W(1,7))
C     Amplitude(s) for diagram number 62
      CALL FFFF18_24_28_29_0(W(1,1),W(1,7),W(1,4),W(1,25),GC_31,GC_87
     $ ,GC_109,GC_112,AMP(74))
      CALL FFFF18_24_28_29_0(W(1,1),W(1,7),W(1,4),W(1,25),GC_35,GC_88
     $ ,GC_110,GC_113,AMP(75))
      CALL FFV57P0_3(W(1,1),W(1,7),GC_11,ZERO, FK_ZERO,W(1,28))
C     Amplitude(s) for diagram number 63
      CALL FFV87_0(W(1,4),W(1,25),W(1,28),GC_11,AMP(76))
C     Amplitude(s) for diagram number 64
      CALL FFV110_0(W(1,4),W(1,25),W(1,28),GC_358,AMP(77))
C     Amplitude(s) for diagram number 65
      CALL FFV87_0(W(1,4),W(1,24),W(1,28),GC_11,AMP(78))
C     Amplitude(s) for diagram number 66
      CALL FFFF18_24_28_29_0(W(1,1),W(1,7),W(1,19),W(1,3),GC_31,GC_87
     $ ,GC_109,GC_112,AMP(79))
      CALL FFFF18_24_28_29_0(W(1,1),W(1,7),W(1,19),W(1,3),GC_35,GC_88
     $ ,GC_110,GC_113,AMP(80))
C     Amplitude(s) for diagram number 67
      CALL FFV87_0(W(1,19),W(1,3),W(1,28),GC_11,AMP(81))
C     Amplitude(s) for diagram number 68
      CALL FFV110_0(W(1,19),W(1,3),W(1,28),GC_358,AMP(82))
C     Amplitude(s) for diagram number 69
      CALL FFV87_0(W(1,20),W(1,3),W(1,28),GC_11,AMP(83))
C     Amplitude(s) for diagram number 70
      CALL FFFF18_24_28_29_0(W(1,26),W(1,7),W(1,4),W(1,3),GC_31,GC_87
     $ ,GC_109,GC_112,AMP(84))
      CALL FFFF18_24_28_29_0(W(1,26),W(1,7),W(1,4),W(1,3),GC_35,GC_88
     $ ,GC_110,GC_113,AMP(85))
C     Amplitude(s) for diagram number 71
      CALL FFV57_0(W(1,26),W(1,7),W(1,8),GC_11,AMP(86))
C     Amplitude(s) for diagram number 72
      CALL FFV57_0(W(1,26),W(1,7),W(1,11),GC_11,AMP(87))
      CALL FFV57_1(W(1,7),W(1,6),GC_11,ZERO, FK_ZERO,W(1,27))
C     Amplitude(s) for diagram number 73
      CALL FFV57_0(W(1,1),W(1,27),W(1,8),GC_11,AMP(88))
C     Amplitude(s) for diagram number 74
      CALL VVV8_0(W(1,6),W(1,8),W(1,28),GC_10,AMP(89))
C     Amplitude(s) for diagram number 75
      CALL FFV57_0(W(1,1),W(1,27),W(1,11),GC_11,AMP(90))
C     Amplitude(s) for diagram number 76
      CALL VVV8_0(W(1,6),W(1,11),W(1,28),GC_10,AMP(91))
      CALL FFVV186P0_3(W(1,4),W(1,3),W(1,6),GC_360,ZERO, FK_ZERO,W(1
     $ ,28))
C     Amplitude(s) for diagram number 77
      CALL FFV57_0(W(1,1),W(1,7),W(1,28),GC_11,AMP(92))
C     Amplitude(s) for diagram number 78
      CALL FFV57_0(W(1,13),W(1,7),W(1,6),GC_11,AMP(93))
      CALL FFV57_0(W(1,14),W(1,7),W(1,6),GC_11,AMP(94))
      CALL FFV57_2(W(1,1),W(1,5),GC_11,ZERO, FK_ZERO,W(1,7))
C     Amplitude(s) for diagram number 79
      CALL FFFF18_24_28_29_0(W(1,7),W(1,2),W(1,4),W(1,25),GC_31,GC_87
     $ ,GC_109,GC_112,AMP(95))
      CALL FFFF18_24_28_29_0(W(1,7),W(1,2),W(1,4),W(1,25),GC_35,GC_88
     $ ,GC_110,GC_113,AMP(96))
      CALL FFV57P0_3(W(1,7),W(1,2),GC_11,ZERO, FK_ZERO,W(1,27))
C     Amplitude(s) for diagram number 80
      CALL FFV87_0(W(1,4),W(1,25),W(1,27),GC_11,AMP(97))
C     Amplitude(s) for diagram number 81
      CALL FFV110_0(W(1,4),W(1,25),W(1,27),GC_358,AMP(98))
C     Amplitude(s) for diagram number 82
      CALL FFV87_0(W(1,4),W(1,24),W(1,27),GC_11,AMP(99))
C     Amplitude(s) for diagram number 83
      CALL FFFF18_24_28_29_0(W(1,7),W(1,2),W(1,19),W(1,3),GC_31,GC_87
     $ ,GC_109,GC_112,AMP(100))
      CALL FFFF18_24_28_29_0(W(1,7),W(1,2),W(1,19),W(1,3),GC_35,GC_88
     $ ,GC_110,GC_113,AMP(101))
C     Amplitude(s) for diagram number 84
      CALL FFV87_0(W(1,19),W(1,3),W(1,27),GC_11,AMP(102))
C     Amplitude(s) for diagram number 85
      CALL FFV110_0(W(1,19),W(1,3),W(1,27),GC_358,AMP(103))
C     Amplitude(s) for diagram number 86
      CALL FFV87_0(W(1,20),W(1,3),W(1,27),GC_11,AMP(104))
C     Amplitude(s) for diagram number 87
      CALL FFFF18_24_28_29_0(W(1,7),W(1,22),W(1,4),W(1,3),GC_31,GC_87
     $ ,GC_109,GC_112,AMP(105))
      CALL FFFF18_24_28_29_0(W(1,7),W(1,22),W(1,4),W(1,3),GC_35,GC_88
     $ ,GC_110,GC_113,AMP(106))
C     Amplitude(s) for diagram number 88
      CALL FFV57_0(W(1,7),W(1,22),W(1,8),GC_11,AMP(107))
C     Amplitude(s) for diagram number 89
      CALL FFV57_0(W(1,7),W(1,22),W(1,11),GC_11,AMP(108))
      CALL FFV57_2(W(1,7),W(1,6),GC_11,ZERO, FK_ZERO,W(1,21))
C     Amplitude(s) for diagram number 90
      CALL FFV57_0(W(1,21),W(1,2),W(1,8),GC_11,AMP(109))
C     Amplitude(s) for diagram number 91
      CALL VVV8_0(W(1,6),W(1,8),W(1,27),GC_10,AMP(110))
C     Amplitude(s) for diagram number 92
      CALL FFV57_0(W(1,21),W(1,2),W(1,11),GC_11,AMP(111))
C     Amplitude(s) for diagram number 93
      CALL VVV8_0(W(1,6),W(1,11),W(1,27),GC_10,AMP(112))
C     Amplitude(s) for diagram number 94
      CALL FFV57_0(W(1,7),W(1,2),W(1,28),GC_11,AMP(113))
C     Amplitude(s) for diagram number 95
      CALL FFV57_0(W(1,7),W(1,9),W(1,6),GC_11,AMP(114))
      CALL FFV57_0(W(1,7),W(1,12),W(1,6),GC_11,AMP(115))
C     Amplitude(s) for diagram number 96
      CALL FFVV186_0(W(1,4),W(1,25),W(1,5),W(1,10),GC_360,AMP(116))
      CALL FFV87_1(W(1,25),W(1,5),GC_11,MDL_MT, FK_ZERO,W(1,7))
C     Amplitude(s) for diagram number 97
      CALL FFV87_0(W(1,4),W(1,7),W(1,10),GC_11,AMP(117))
C     Amplitude(s) for diagram number 98
      CALL FFV110_0(W(1,4),W(1,7),W(1,10),GC_358,AMP(118))
      CALL FFV110_1(W(1,25),W(1,5),GC_358,MDL_MT, FK_ZERO,W(1,7))
C     Amplitude(s) for diagram number 99
      CALL FFV87_0(W(1,4),W(1,7),W(1,10),GC_11,AMP(119))
      CALL VVV8P0_1(W(1,5),W(1,10),GC_10,ZERO, FK_ZERO,W(1,7))
C     Amplitude(s) for diagram number 100
      CALL FFV87_0(W(1,4),W(1,25),W(1,7),GC_11,AMP(120))
C     Amplitude(s) for diagram number 101
      CALL FFV110_0(W(1,4),W(1,25),W(1,7),GC_358,AMP(121))
      CALL FFV87_1(W(1,24),W(1,5),GC_11,MDL_MT, FK_ZERO,W(1,27))
C     Amplitude(s) for diagram number 102
      CALL FFV87_0(W(1,4),W(1,27),W(1,10),GC_11,AMP(122))
C     Amplitude(s) for diagram number 103
      CALL FFV87_0(W(1,4),W(1,24),W(1,7),GC_11,AMP(123))
C     Amplitude(s) for diagram number 104
      CALL FFV87_0(W(1,17),W(1,25),W(1,5),GC_11,AMP(124))
      CALL FFV87_0(W(1,18),W(1,25),W(1,5),GC_11,AMP(125))
C     Amplitude(s) for diagram number 105
      CALL FFVV186_0(W(1,19),W(1,3),W(1,5),W(1,10),GC_360,AMP(126))
      CALL FFV87_2(W(1,19),W(1,5),GC_11,MDL_MT, FK_ZERO,W(1,25))
C     Amplitude(s) for diagram number 106
      CALL FFV87_0(W(1,25),W(1,3),W(1,10),GC_11,AMP(127))
C     Amplitude(s) for diagram number 107
      CALL FFV110_0(W(1,25),W(1,3),W(1,10),GC_358,AMP(128))
      CALL FFV110_2(W(1,19),W(1,5),GC_358,MDL_MT, FK_ZERO,W(1,25))
C     Amplitude(s) for diagram number 108
      CALL FFV87_0(W(1,25),W(1,3),W(1,10),GC_11,AMP(129))
C     Amplitude(s) for diagram number 109
      CALL FFV87_0(W(1,19),W(1,3),W(1,7),GC_11,AMP(130))
C     Amplitude(s) for diagram number 110
      CALL FFV110_0(W(1,19),W(1,3),W(1,7),GC_358,AMP(131))
      CALL FFV87_2(W(1,20),W(1,5),GC_11,MDL_MT, FK_ZERO,W(1,25))
C     Amplitude(s) for diagram number 111
      CALL FFV87_0(W(1,25),W(1,3),W(1,10),GC_11,AMP(132))
C     Amplitude(s) for diagram number 112
      CALL FFV87_0(W(1,20),W(1,3),W(1,7),GC_11,AMP(133))
C     Amplitude(s) for diagram number 113
      CALL FFV87_0(W(1,19),W(1,15),W(1,5),GC_11,AMP(134))
      CALL FFV87_0(W(1,19),W(1,16),W(1,5),GC_11,AMP(135))
      CALL FFV57_1(W(1,22),W(1,5),GC_11,ZERO, FK_ZERO,W(1,19))
C     Amplitude(s) for diagram number 114
      CALL FFV57_0(W(1,1),W(1,19),W(1,8),GC_11,AMP(136))
      CALL VVV8P0_1(W(1,5),W(1,8),GC_10,ZERO, FK_ZERO,W(1,16))
C     Amplitude(s) for diagram number 115
      CALL FFV57_0(W(1,1),W(1,22),W(1,16),GC_11,AMP(137))
C     Amplitude(s) for diagram number 116
      CALL FFV57_0(W(1,1),W(1,19),W(1,11),GC_11,AMP(138))
      CALL VVV8P0_1(W(1,5),W(1,11),GC_10,ZERO, FK_ZERO,W(1,19))
C     Amplitude(s) for diagram number 117
      CALL FFV57_0(W(1,1),W(1,22),W(1,19),GC_11,AMP(139))
C     Amplitude(s) for diagram number 118
      CALL FFV57_0(W(1,13),W(1,22),W(1,5),GC_11,AMP(140))
      CALL FFV57_0(W(1,14),W(1,22),W(1,5),GC_11,AMP(141))
      CALL FFV57_2(W(1,26),W(1,5),GC_11,ZERO, FK_ZERO,W(1,14))
C     Amplitude(s) for diagram number 119
      CALL FFV57_0(W(1,14),W(1,2),W(1,8),GC_11,AMP(142))
C     Amplitude(s) for diagram number 120
      CALL FFV57_0(W(1,26),W(1,2),W(1,16),GC_11,AMP(143))
C     Amplitude(s) for diagram number 121
      CALL FFV57_0(W(1,14),W(1,2),W(1,11),GC_11,AMP(144))
C     Amplitude(s) for diagram number 122
      CALL FFV57_0(W(1,26),W(1,2),W(1,19),GC_11,AMP(145))
C     Amplitude(s) for diagram number 123
      CALL FFV57_0(W(1,26),W(1,9),W(1,5),GC_11,AMP(146))
      CALL FFV57_0(W(1,26),W(1,12),W(1,5),GC_11,AMP(147))
C     Amplitude(s) for diagram number 124
      CALL VVVV16_0(W(1,5),W(1,6),W(1,8),W(1,10),GC_12,AMP(148))
      CALL VVVV19_0(W(1,5),W(1,6),W(1,8),W(1,10),GC_12,AMP(149))
      CALL VVVV20_0(W(1,5),W(1,6),W(1,8),W(1,10),GC_12,AMP(150))
C     Amplitude(s) for diagram number 125
      CALL VVV8_0(W(1,6),W(1,10),W(1,16),GC_10,AMP(151))
C     Amplitude(s) for diagram number 126
      CALL VVV8_0(W(1,6),W(1,8),W(1,7),GC_10,AMP(152))
C     Amplitude(s) for diagram number 127
      CALL VVVV16_0(W(1,5),W(1,6),W(1,11),W(1,10),GC_12,AMP(153))
      CALL VVVV19_0(W(1,5),W(1,6),W(1,11),W(1,10),GC_12,AMP(154))
      CALL VVVV20_0(W(1,5),W(1,6),W(1,11),W(1,10),GC_12,AMP(155))
C     Amplitude(s) for diagram number 128
      CALL VVV8_0(W(1,6),W(1,10),W(1,19),GC_10,AMP(156))
C     Amplitude(s) for diagram number 129
      CALL VVV8_0(W(1,6),W(1,11),W(1,7),GC_10,AMP(157))
      CALL FFVV186_1(W(1,3),W(1,5),W(1,6),GC_360,MDL_MT, FK_ZERO,W(1,7)
     $ )
C     Amplitude(s) for diagram number 130
      CALL FFV87_0(W(1,4),W(1,7),W(1,10),GC_11,AMP(158))
      CALL FFVV186_2(W(1,4),W(1,5),W(1,6),GC_360,MDL_MT, FK_ZERO,W(1,7)
     $ )
C     Amplitude(s) for diagram number 131
      CALL FFV87_0(W(1,7),W(1,3),W(1,10),GC_11,AMP(159))
      CALL FFVV186P0_3(W(1,4),W(1,3),W(1,5),GC_360,ZERO, FK_ZERO,W(1,7)
     $ )
C     Amplitude(s) for diagram number 132
      CALL FFV57_0(W(1,1),W(1,22),W(1,7),GC_11,AMP(160))
C     Amplitude(s) for diagram number 133
      CALL FFV57_0(W(1,26),W(1,2),W(1,7),GC_11,AMP(161))
C     Amplitude(s) for diagram number 134
      CALL VVV8_0(W(1,7),W(1,6),W(1,10),GC_10,AMP(162))
C     Amplitude(s) for diagram number 135
      CALL VVV8_0(W(1,5),W(1,28),W(1,10),GC_10,AMP(163))
C     JAMPs contributing to orders ALL_ORDERS=1
      JAMP(1,1)=-1D0/6D0*IMAG1*AMP(8)-1D0/6D0*IMAG1*AMP(9)-1D0/6D0
     $ *IMAG1*AMP(10)-1D0/6D0*IMAG1*AMP(11)-1D0/6D0*IMAG1*AMP(12)-1D0
     $ /6D0*IMAG1*AMP(13)+IMAG1*AMP(18)-1D0/6D0*IMAG1*AMP(19)+IMAG1
     $ *AMP(20)-1D0/6D0*IMAG1*AMP(21)-AMP(22)+1D0/6D0*AMP(23)+1D0/6D0
     $ *AMP(24)+1D0/6D0*AMP(25)+1D0/6D0*AMP(26)+1D0/6D0*AMP(27)+1D0
     $ /6D0*AMP(39)+1D0/6D0*AMP(40)+1D0/6D0*AMP(41)+1D0/6D0*AMP(44)
     $ -AMP(46)+1D0/6D0*AMP(47)+1D0/6D0*AMP(127)+1D0/6D0*AMP(128)+1D0
     $ /6D0*AMP(129)+1D0/6D0*AMP(132)-AMP(134)+1D0/6D0*AMP(135)-1D0
     $ /6D0*IMAG1*AMP(158)-1D0/6D0*IMAG1*AMP(159)
      JAMP(2,1)=+1D0/6D0*IMAG1*AMP(8)+1D0/6D0*IMAG1*AMP(9)+1D0/6D0
     $ *IMAG1*AMP(10)+1D0/6D0*IMAG1*AMP(11)+1D0/6D0*IMAG1*AMP(12)+1D0
     $ /6D0*IMAG1*AMP(13)-IMAG1*AMP(18)+1D0/6D0*IMAG1*AMP(19)-IMAG1
     $ *AMP(20)+1D0/6D0*IMAG1*AMP(21)-AMP(48)+1D0/6D0*AMP(49)+1D0/6D0
     $ *AMP(50)+1D0/6D0*AMP(51)+1D0/6D0*AMP(52)+1D0/6D0*AMP(53)+1D0
     $ /6D0*AMP(65)+1D0/6D0*AMP(66)+1D0/6D0*AMP(67)+1D0/6D0*AMP(70)
     $ -AMP(72)+1D0/6D0*AMP(73)+1D0/6D0*AMP(117)+1D0/6D0*AMP(118)+1D0
     $ /6D0*AMP(119)+1D0/6D0*AMP(122)-AMP(124)+1D0/6D0*AMP(125)+1D0
     $ /6D0*IMAG1*AMP(158)+1D0/6D0*IMAG1*AMP(159)
      JAMP(3,1)=+1D0/2D0*(+IMAG1*AMP(2)+IMAG1*AMP(4)-AMP(5)-AMP(6)
     $ +AMP(7)+IMAG1*AMP(8)+IMAG1*AMP(9)+IMAG1*AMP(10)+IMAG1*AMP(15)
     $ +IMAG1*AMP(21)-AMP(34)-AMP(35)-AMP(36)-AMP(37)+IMAG1*AMP(38)
     $ -AMP(39)-AMP(40)-AMP(41)+IMAG1*AMP(42)+IMAG1*AMP(43)-AMP(44)
     $ +IMAG1*AMP(45)-AMP(47)-AMP(142)-IMAG1*AMP(143)-AMP(144)-IMAG1
     $ *AMP(145)-AMP(147)-AMP(148)-AMP(149)-AMP(151)-AMP(153)-AMP(154)
     $ -AMP(156)+IMAG1*AMP(158)-IMAG1*AMP(161)-AMP(162))
      JAMP(4,1)=+1D0/2D0*(-IMAG1*AMP(2)-IMAG1*AMP(4)+AMP(5)+AMP(6)
     $ -AMP(7)-IMAG1*AMP(8)-IMAG1*AMP(9)-IMAG1*AMP(10)-IMAG1*AMP(15)
     $ -IMAG1*AMP(21)-AMP(96)-AMP(97)-AMP(98)-AMP(99)-AMP(109)-IMAG1
     $ *AMP(110)-AMP(111)-IMAG1*AMP(112)-IMAG1*AMP(113)-AMP(115)+IMAG1
     $ *AMP(116)-AMP(117)-AMP(118)-AMP(119)+IMAG1*AMP(120)+IMAG1
     $ *AMP(121)-AMP(122)+IMAG1*AMP(123)-AMP(125)+AMP(148)-AMP(150)
     $ -AMP(152)+AMP(153)-AMP(155)-AMP(157)-IMAG1*AMP(158)+AMP(163))
      JAMP(5,1)=+1D0/2D0*(+IMAG1*AMP(1)+IMAG1*AMP(3)+AMP(5)+AMP(6)
     $ -AMP(7)+IMAG1*AMP(11)+IMAG1*AMP(12)+IMAG1*AMP(13)+IMAG1*AMP(17)
     $ +IMAG1*AMP(19)-AMP(80)-AMP(81)-AMP(82)-AMP(83)-AMP(88)+IMAG1
     $ *AMP(89)-AMP(90)+IMAG1*AMP(91)+IMAG1*AMP(92)-AMP(94)-IMAG1
     $ *AMP(126)-AMP(127)-AMP(128)-AMP(129)-IMAG1*AMP(130)-IMAG1
     $ *AMP(131)-AMP(132)-IMAG1*AMP(133)-AMP(135)+AMP(148)-AMP(150)
     $ -AMP(152)+AMP(153)-AMP(155)-AMP(157)+IMAG1*AMP(159)+AMP(163))
      JAMP(6,1)=+1D0/2D0*(-IMAG1*AMP(1)-IMAG1*AMP(3)-AMP(5)-AMP(6)
     $ +AMP(7)-IMAG1*AMP(11)-IMAG1*AMP(12)-IMAG1*AMP(13)-IMAG1*AMP(17)
     $ -IMAG1*AMP(19)-AMP(55)-AMP(56)-AMP(57)-AMP(58)-IMAG1*AMP(64)
     $ -AMP(65)-AMP(66)-AMP(67)-IMAG1*AMP(68)-IMAG1*AMP(69)-AMP(70)
     $ -IMAG1*AMP(71)-AMP(73)-AMP(136)+IMAG1*AMP(137)-AMP(138)+IMAG1
     $ *AMP(139)-AMP(141)-AMP(148)-AMP(149)-AMP(151)-AMP(153)-AMP(154)
     $ -AMP(156)-IMAG1*AMP(159)+IMAG1*AMP(160)-AMP(162))
      JAMP(7,1)=-1D0/6D0*IMAG1*AMP(1)-1D0/6D0*IMAG1*AMP(2)-1D0/6D0
     $ *IMAG1*AMP(3)-1D0/6D0*IMAG1*AMP(4)+IMAG1*AMP(14)-1D0/6D0*IMAG1
     $ *AMP(15)+IMAG1*AMP(16)-1D0/6D0*IMAG1*AMP(17)-AMP(84)+1D0/6D0
     $ *AMP(85)+1D0/6D0*AMP(86)+1D0/6D0*AMP(87)+1D0/6D0*AMP(88)+1D0
     $ /6D0*AMP(90)-AMP(93)+1D0/6D0*AMP(94)+1D0/6D0*AMP(142)+1D0/6D0
     $ *AMP(144)-AMP(146)+1D0/6D0*AMP(147)
      JAMP(8,1)=+1D0/6D0*IMAG1*AMP(1)+1D0/6D0*IMAG1*AMP(2)+1D0/6D0
     $ *IMAG1*AMP(3)+1D0/6D0*IMAG1*AMP(4)-IMAG1*AMP(14)+1D0/6D0*IMAG1
     $ *AMP(15)-IMAG1*AMP(16)+1D0/6D0*IMAG1*AMP(17)-AMP(105)+1D0/6D0
     $ *AMP(106)+1D0/6D0*AMP(107)+1D0/6D0*AMP(108)+1D0/6D0*AMP(109)
     $ +1D0/6D0*AMP(111)-AMP(114)+1D0/6D0*AMP(115)+1D0/6D0*AMP(136)
     $ +1D0/6D0*AMP(138)-AMP(140)+1D0/6D0*AMP(141)
      JAMP(9,1)=-AMP(74)+1D0/6D0*AMP(75)+1D0/6D0*AMP(76)+1D0/6D0
     $ *AMP(77)+1D0/6D0*AMP(78)-AMP(79)+1D0/6D0*AMP(80)+1D0/6D0*AMP(81)
     $ +1D0/6D0*AMP(82)+1D0/6D0*AMP(83)-AMP(95)+1D0/6D0*AMP(96)+1D0
     $ /6D0*AMP(97)+1D0/6D0*AMP(98)+1D0/6D0*AMP(99)-AMP(100)+1D0/6D0
     $ *AMP(101)+1D0/6D0*AMP(102)+1D0/6D0*AMP(103)+1D0/6D0*AMP(104)
      JAMP(10,1)=+1D0/2D0*(-AMP(49)-AMP(50)-AMP(51)-AMP(52)-AMP(53)
     $ -AMP(60)-AMP(61)-AMP(62)-AMP(63)+IMAG1*AMP(64)+IMAG1*AMP(68)
     $ +IMAG1*AMP(69)+IMAG1*AMP(71)-AMP(75)-AMP(76)-AMP(77)-AMP(78)
     $ -AMP(85)-AMP(86)-AMP(87)-IMAG1*AMP(89)-IMAG1*AMP(91)-IMAG1
     $ *AMP(92)-IMAG1*AMP(116)-IMAG1*AMP(120)-IMAG1*AMP(121)-IMAG1
     $ *AMP(123)+IMAG1*AMP(143)+IMAG1*AMP(145)+AMP(149)+AMP(150)
     $ +AMP(151)+AMP(152)+AMP(154)+AMP(155)+AMP(156)+AMP(157)+IMAG1
     $ *AMP(161)+AMP(162)-AMP(163))
      JAMP(11,1)=+1D0/2D0*(-AMP(23)-AMP(24)-AMP(25)-AMP(26)-AMP(27)
     $ -AMP(29)-AMP(30)-AMP(31)-AMP(32)-IMAG1*AMP(38)-IMAG1*AMP(42)
     $ -IMAG1*AMP(43)-IMAG1*AMP(45)-AMP(101)-AMP(102)-AMP(103)-AMP(104)
     $ -AMP(106)-AMP(107)-AMP(108)+IMAG1*AMP(110)+IMAG1*AMP(112)+IMAG1
     $ *AMP(113)+IMAG1*AMP(126)+IMAG1*AMP(130)+IMAG1*AMP(131)+IMAG1
     $ *AMP(133)-IMAG1*AMP(137)-IMAG1*AMP(139)+AMP(149)+AMP(150)
     $ +AMP(151)+AMP(152)+AMP(154)+AMP(155)+AMP(156)+AMP(157)-IMAG1
     $ *AMP(160)+AMP(162)-AMP(163))
      JAMP(12,1)=-AMP(28)+1D0/6D0*AMP(29)+1D0/6D0*AMP(30)+1D0/6D0
     $ *AMP(31)+1D0/6D0*AMP(32)-AMP(33)+1D0/6D0*AMP(34)+1D0/6D0*AMP(35)
     $ +1D0/6D0*AMP(36)+1D0/6D0*AMP(37)-AMP(54)+1D0/6D0*AMP(55)+1D0
     $ /6D0*AMP(56)+1D0/6D0*AMP(57)+1D0/6D0*AMP(58)-AMP(59)+1D0/6D0
     $ *AMP(60)+1D0/6D0*AMP(61)+1D0/6D0*AMP(62)+1D0/6D0*AMP(63)

      MATRIX2 = 0.D0
      DO M = 1, NAMPSO
        DO I = 1, NCOLOR
          ZTEMP = (0.D0,0.D0)
          DO J = 1, NCOLOR
            ZTEMP = ZTEMP + CF(J,I)*JAMP(J,M)
          ENDDO
          DO N = 1, NAMPSO
            IF (CHOSEN_SO_CONFIGS(SQSOINDEX2(M,N))) THEN
              MATRIX2 = MATRIX2 + ZTEMP*DCONJG(JAMP(I,N))/DENOM(I)
            ENDIF
          ENDDO
        ENDDO
      ENDDO

      AMP2(1)=AMP2(1)+(AMP(1)+AMP(3))*DCONJG(AMP(1)+AMP(3))
      AMP2(2)=AMP2(2)+(AMP(2)+AMP(4))*DCONJG(AMP(2)+AMP(4))
      AMP2(5)=AMP2(5)+(AMP(5)+AMP(6))*DCONJG(AMP(5)+AMP(6))
      AMP2(8)=AMP2(8)+(AMP(8)+AMP(9)+AMP(10))*DCONJG(AMP(8)+AMP(9)
     $ +AMP(10))
      AMP2(11)=AMP2(11)+(AMP(11)+AMP(12)+AMP(13))*DCONJG(AMP(11)
     $ +AMP(12)+AMP(13))
      AMP2(19)=AMP2(19)+(AMP(24)+AMP(25)+AMP(26)+AMP(27))
     $ *DCONJG(AMP(24)+AMP(25)+AMP(26)+AMP(27))
      AMP2(24)=AMP2(24)+(AMP(30)+AMP(31)+AMP(32))*DCONJG(AMP(30)
     $ +AMP(31)+AMP(32))
      AMP2(28)=AMP2(28)+(AMP(35)+AMP(36)+AMP(37))*DCONJG(AMP(35)
     $ +AMP(36)+AMP(37))
      AMP2(32)=AMP2(32)+(AMP(39)+AMP(40)+AMP(41)+AMP(44))
     $ *DCONJG(AMP(39)+AMP(40)+AMP(41)+AMP(44))
      AMP2(35)=AMP2(35)+(AMP(42)+AMP(43)+AMP(45))*DCONJG(AMP(42)
     $ +AMP(43)+AMP(45))
      AMP2(41)=AMP2(41)+(AMP(50)+AMP(51)+AMP(52)+AMP(53))
     $ *DCONJG(AMP(50)+AMP(51)+AMP(52)+AMP(53))
      AMP2(46)=AMP2(46)+(AMP(56)+AMP(57)+AMP(58))*DCONJG(AMP(56)
     $ +AMP(57)+AMP(58))
      AMP2(50)=AMP2(50)+(AMP(61)+AMP(62)+AMP(63))*DCONJG(AMP(61)
     $ +AMP(62)+AMP(63))
      AMP2(54)=AMP2(54)+(AMP(65)+AMP(66)+AMP(67)+AMP(70))
     $ *DCONJG(AMP(65)+AMP(66)+AMP(67)+AMP(70))
      AMP2(57)=AMP2(57)+(AMP(68)+AMP(69)+AMP(71))*DCONJG(AMP(68)
     $ +AMP(69)+AMP(71))
      AMP2(63)=AMP2(63)+(AMP(76)+AMP(77)+AMP(78))*DCONJG(AMP(76)
     $ +AMP(77)+AMP(78))
      AMP2(67)=AMP2(67)+(AMP(81)+AMP(82)+AMP(83))*DCONJG(AMP(81)
     $ +AMP(82)+AMP(83))
      AMP2(71)=AMP2(71)+(AMP(86)+AMP(87))*DCONJG(AMP(86)+AMP(87))
      AMP2(73)=AMP2(73)+(AMP(88)+AMP(90))*DCONJG(AMP(88)+AMP(90))
      AMP2(74)=AMP2(74)+(AMP(89)+AMP(91))*DCONJG(AMP(89)+AMP(91))
      AMP2(80)=AMP2(80)+(AMP(97)+AMP(98)+AMP(99))*DCONJG(AMP(97)
     $ +AMP(98)+AMP(99))
      AMP2(84)=AMP2(84)+(AMP(102)+AMP(103)+AMP(104))*DCONJG(AMP(102)
     $ +AMP(103)+AMP(104))
      AMP2(88)=AMP2(88)+(AMP(107)+AMP(108))*DCONJG(AMP(107)+AMP(108))
      AMP2(90)=AMP2(90)+(AMP(109)+AMP(111))*DCONJG(AMP(109)+AMP(111))
      AMP2(91)=AMP2(91)+(AMP(110)+AMP(112))*DCONJG(AMP(110)+AMP(112))
      AMP2(97)=AMP2(97)+(AMP(117)+AMP(118)+AMP(119)+AMP(122))
     $ *DCONJG(AMP(117)+AMP(118)+AMP(119)+AMP(122))
      AMP2(100)=AMP2(100)+(AMP(120)+AMP(121)+AMP(123))*DCONJG(AMP(120)
     $ +AMP(121)+AMP(123))
      AMP2(106)=AMP2(106)+(AMP(127)+AMP(128)+AMP(129)+AMP(132))
     $ *DCONJG(AMP(127)+AMP(128)+AMP(129)+AMP(132))
      AMP2(109)=AMP2(109)+(AMP(130)+AMP(131)+AMP(133))*DCONJG(AMP(130)
     $ +AMP(131)+AMP(133))
      AMP2(114)=AMP2(114)+(AMP(136)+AMP(138))*DCONJG(AMP(136)+AMP(138))
      AMP2(115)=AMP2(115)+(AMP(137)+AMP(139))*DCONJG(AMP(137)+AMP(139))
      AMP2(119)=AMP2(119)+(AMP(142)+AMP(144))*DCONJG(AMP(142)+AMP(144))
      AMP2(120)=AMP2(120)+(AMP(143)+AMP(145))*DCONJG(AMP(143)+AMP(145))
      AMP2(125)=AMP2(125)+(AMP(151)+AMP(156))*DCONJG(AMP(151)+AMP(156))
      AMP2(126)=AMP2(126)+(AMP(152)+AMP(157))*DCONJG(AMP(152)+AMP(157))
      DO I = 1, NCOLOR
        DO M = 1, NAMPSO
          DO N = 1, NAMPSO
            IF (CHOSEN_SO_CONFIGS(SQSOINDEX2(M,N))) THEN
              JAMP2(I)=JAMP2(I)+DABS(DBLE(JAMP(I,M)*DCONJG(JAMP(I,N))))
            ENDIF
          ENDDO
        ENDDO
      ENDDO

      END

C     Set of functions to handle the array indices of the split orders


      INTEGER FUNCTION SQSOINDEX2(ORDERINDEXA, ORDERINDEXB)
C     
C     This functions plays the role of the interference matrix. It can
C      be hardcoded or 
C     made more elegant using hashtables if its execution speed ever
C      becomes a relevant
C     factor. From two split order indices, it return the
C      corresponding index in the squared 
C     order canonical ordering.
C     
C     CONSTANTS
C     

      INTEGER    NSO, NSQUAREDSO, NAMPSO
      PARAMETER (NSO=1, NSQUAREDSO=1, NAMPSO=1)
C     
C     ARGUMENTS
C     
      INTEGER ORDERINDEXA, ORDERINDEXB
C     
C     LOCAL VARIABLES
C     
      INTEGER I, SQORDERS(NSO)
      INTEGER AMPSPLITORDERS(NAMPSO,NSO)
      DATA (AMPSPLITORDERS(  1,I),I=  1,  1) /    1/
      COMMON/AMPSPLITORDERS2/AMPSPLITORDERS
C     
C     FUNCTION
C     
      INTEGER SOINDEX_FOR_SQUARED_ORDERS2
C     
C     BEGIN CODE
C     
      DO I=1,NSO
        SQORDERS(I)=AMPSPLITORDERS(ORDERINDEXA,I)
     $   +AMPSPLITORDERS(ORDERINDEXB,I)
      ENDDO
      SQSOINDEX2=SOINDEX_FOR_SQUARED_ORDERS2(SQORDERS)
      END

      INTEGER FUNCTION SOINDEX_FOR_SQUARED_ORDERS2(ORDERS)
C     
C     This functions returns the integer index identifying the squared
C      split orders list passed in argument which corresponds to the
C      values of the following list of couplings (and in this order).
C     []
C     
C     CONSTANTS
C     
      INTEGER    NSO, NSQSO, NAMPSO
      PARAMETER (NSO=1, NSQSO=1, NAMPSO=1)
C     
C     ARGUMENTS
C     
      INTEGER ORDERS(NSO)
C     
C     LOCAL VARIABLES
C     
      INTEGER I,J
      INTEGER SQSPLITORDERS(NSQSO,NSO)
      DATA (SQSPLITORDERS(  1,I),I=  1,  1) /    2/
      COMMON/SQPLITORDERS2/SQPLITORDERS
C     
C     BEGIN CODE
C     
      DO I=1,NSQSO
        DO J=1,NSO
          IF (ORDERS(J).NE.SQSPLITORDERS(I,J)) GOTO 1009
        ENDDO
        SOINDEX_FOR_SQUARED_ORDERS2 = I
        RETURN
 1009   CONTINUE
      ENDDO

      WRITE(*,*) 'ERROR:: Stopping in function'
      WRITE(*,*) 'SOINDEX_FOR_SQUARED_ORDERS2'
      WRITE(*,*) 'Could not find squared orders ',(ORDERS(I),I=1,NSO)
      STOP

      END

      SUBROUTINE GET_NSQSO_BORN2(NSQSO)
C     
C     Simple subroutine returning the number of squared split order
C     contributions returned when calling smatrix_split_orders 
C     

      INTEGER    NSQUAREDSO
      PARAMETER  (NSQUAREDSO=1)

      INTEGER NSQSO

      NSQSO=NSQUAREDSO

      END

C     This is the inverse subroutine of SOINDEX_FOR_SQUARED_ORDERS.
C      Not directly useful, but provided nonetheless.
      SUBROUTINE GET_SQUARED_ORDERS_FOR_SOINDEX2(SOINDEX,ORDERS)
C     
C     This functions returns the orders identified by the squared
C      split order index in argument. Order values correspond to
C      following list of couplings (and in this order):
C     []
C     
C     CONSTANTS
C     
      INTEGER    NSO, NSQSO
      PARAMETER (NSO=1, NSQSO=1)
C     
C     ARGUMENTS
C     
      INTEGER SOINDEX, ORDERS(NSO)
C     
C     LOCAL VARIABLES
C     
      INTEGER I
      INTEGER SQPLITORDERS(NSQSO,NSO)
      COMMON/SQPLITORDERS2/SQPLITORDERS
C     
C     BEGIN CODE
C     
      IF (SOINDEX.GT.0.AND.SOINDEX.LE.NSQSO) THEN
        DO I=1,NSO
          ORDERS(I) =  SQPLITORDERS(SOINDEX,I)
        ENDDO
        RETURN
      ENDIF

      WRITE(*,*) 'ERROR:: Stopping function'
     $ //' GET_SQUARED_ORDERS_FOR_SOINDEX2'
      WRITE(*,*) 'Could not find squared orders index ',SOINDEX
      STOP

      END SUBROUTINE

C     This is the inverse subroutine of getting amplitude SO orders.
C      Not directly useful, but provided nonetheless.
      SUBROUTINE GET_ORDERS_FOR_AMPSOINDEX2(SOINDEX,ORDERS)
C     
C     This functions returns the orders identified by the split order
C      index in argument. Order values correspond to following list of
C      couplings (and in this order):
C     []
C     
C     CONSTANTS
C     
      INTEGER    NSO, NAMPSO
      PARAMETER (NSO=1, NAMPSO=1)
C     
C     ARGUMENTS
C     
      INTEGER SOINDEX, ORDERS(NSO)
C     
C     LOCAL VARIABLES
C     
      INTEGER I
      INTEGER AMPSPLITORDERS(NAMPSO,NSO)
      COMMON/AMPSPLITORDERS2/AMPSPLITORDERS
C     
C     BEGIN CODE
C     
      IF (SOINDEX.GT.0.AND.SOINDEX.LE.NAMPSO) THEN
        DO I=1,NSO
          ORDERS(I) =  AMPSPLITORDERS(SOINDEX,I)
        ENDDO
        RETURN
      ENDIF

      WRITE(*,*) 'ERROR:: Stopping function GET_ORDERS_FOR_AMPSOINDEX2'
      WRITE(*,*) 'Could not find amplitude split orders index ',SOINDEX
      STOP

      END SUBROUTINE

C     This function is not directly useful, but included for
C      completeness
      INTEGER FUNCTION SOINDEX_FOR_AMPORDERS2(ORDERS)
C     
C     This functions returns the integer index identifying the
C      amplitude split orders passed in argument which correspond to
C      the values of the following list of couplings (and in this
C      order):
C     []
C     
C     CONSTANTS
C     
      INTEGER    NSO, NAMPSO
      PARAMETER (NSO=1, NAMPSO=1)
C     
C     ARGUMENTS
C     
      INTEGER ORDERS(NSO)
C     
C     LOCAL VARIABLES
C     
      INTEGER I,J
      INTEGER AMPSPLITORDERS(NAMPSO,NSO)
      COMMON/AMPSPLITORDERS2/AMPSPLITORDERS
C     
C     BEGIN CODE
C     
      DO I=1,NAMPSO
        DO J=1,NSO
          IF (ORDERS(J).NE.AMPSPLITORDERS(I,J)) GOTO 1009
        ENDDO
        SOINDEX_FOR_AMPORDERS2 = I
        RETURN
 1009   CONTINUE
      ENDDO

      WRITE(*,*) 'ERROR:: Stopping function SOINDEX_FOR_AMPORDERS2'
      WRITE(*,*) 'Could not find squared orders ',(ORDERS(I),I=1,NSO)
      STOP

      END

      subroutine setrun
c----------------------------------------------------------------------
c     Sets the run parameters reading them from the run_card.dat
c
c 1. PDF set
c 2. Collider parameters
c 3. cuts
c---------------------------------------------------------------------- 
      implicit none
c
c     include
c
      include 'genps.inc'
      include 'run_config.inc'
      include 'PDF/pdf.inc'
      include 'run.inc'
      include 'alfas.inc'
      include 'MODEL/coupl.inc'

      double precision D
      common/to_dj/D
c
c     PARAM_CARD
c
      character*30 param_card_name
      common/to_param_card_name/param_card_name
c
c     local
c     
      integer npara
      character*20 param(maxpara),value(maxpara)
      character*20 ctemp
      integer k,i,l1,l2
      character*132 buff
      real*8 sf1,sf2
      real*8 pb1,pb2
C
C     input cuts
C
      include 'cuts.inc'
C
C     BEAM POLARIZATION
C
      REAL*8 POL(2)
      common/to_polarization/ POL
      data POL/1d0,1d0/
c
c     Les Houches init block (for the <init> info)
c
      integer maxpup
      parameter(maxpup=100)
      integer idbmup,pdfgup,pdfsup,idwtup,nprup,lprup
      double precision ebmup,xsecup,xerrup,xmaxup
      common /heprup/ idbmup(2),ebmup(2),pdfgup(2),pdfsup(2),
     &     idwtup,nprup,xsecup(maxpup),xerrup(maxpup),
     &     xmaxup(maxpup),lprup(maxpup)
c
      include 'nexternal.inc'
      include 'maxamps.inc'
      integer idup(nexternal,maxproc,maxsproc)
      integer mothup(2,nexternal)
      integer icolup(2,nexternal,maxflow,maxsproc)
      include 'leshouche.inc'
      data pdfwgt/.false./
c
c
c
      logical gridrun,gridpack
      integer*8          iseed
      common /to_seed/ iseed
c
c----------
c     start
c----------
c
c     read the run_card.dat
c
      include 'run_card.inc'

c     if no matching ensure that no pdfreweight are done
      if (ickkw.eq.0) pdfwgt = .false.

      q2fact(1) = sf1**2      ! fact scale**2 for pdf1
      q2fact(2) = sf2**2      ! fact scale**2 for pdf2     

      if(pb1.ne.0d0)then
         if (abs(lpp(1)).eq.1.or.abs(lpp(1)).eq.2)then
            write(*,*) 'proton/anti-proton beam polarization are not allowed'
            stop 1
         endif
         pol(1)=sign(1+abs(pb1)/100d0,pb1)
      endif
      if(pb2.ne.0d0)then
         if (abs(lpp(2)).eq.1.or.abs(lpp(2)).eq.2)then
            write(*,*) 'proton/anti-proton beam polarization are not allowed'
            stop 1
         endif
         pol(2)=sign(1+abs(pb2)/100d0,pb2)
      endif

      
      if(pb1.ne.0d0.and.lpp(1).eq.0) pol(1)=sign(1+abs(pb1)/100d0,pb1)
      if(pb2.ne.0d0.and.lpp(2).eq.0) pol(2)=sign(1+abs(pb2)/100d0,pb2)

      if(pb1.ne.0.or.pb2.ne.0) write(*,*) 'Setting beam polarization ',
     $     sign((abs(pol(1))-1)*100,pol(1)),
     $     sign((abs(pol(2))-1)*100,pol(2))

c !!! Default behavior changed (MH, Aug. 07) !!!
c If no pdf, read the param_card and use the value from there and
c order of alfas running = 2

      if(lpp(1).ne.0.or.lpp(2).ne.0) then
          write(*,*) 'A PDF is used, so alpha_s(MZ) is going to be modified'
          call setpara(param_card_name)
          asmz=G**2/(16d0*atan(1d0))
          write(*,*) 'Old value of alpha_s from param_card: ',asmz
          call pdfwrap
          write(*,*) 'New value of alpha_s from PDF ',pdlabel,':',asmz
      else
          call setpara(param_card_name)
          asmz=G**2/(16d0*atan(1d0))
          nloop=2
          pdlabel='none'
          write(*,*) 'No PDF is used, alpha_s(MZ) from param_card is used'
          write(*,*) 'Value of alpha_s from param_card: ',asmz
          write(*,*) 'The default order of alpha_s running is fixed to ',nloop
      endif
c !!! end of modification !!!

C     If use_syst, ensure that all variational parameters are 1
c           In principle this should be always the case since the
c           banner.py is expected to correct such wrong run_card.
      if(use_syst)then
         if(scalefact.ne.1)then
            write(*,*) 'Warning: use_syst=T, setting scalefact to 1'
            scalefact=1
         endif
         if(alpsfact.ne.1)then
            write(*,*) 'Warning: use_syst=T, setting alpsfact to 1'
            alpsfact=1
         endif
      endif

C       Fill common block for Les Houches init info
      do i=1,2
        if(lpp(i).eq.1.or.lpp(i).eq.2) then
          idbmup(i)=2212
        elseif(lpp(i).eq.-1.or.lpp(i).eq.-2) then
          idbmup(i)=-2212
        elseif(lpp(i).eq.3) then
          idbmup(i)=11
        elseif(lpp(i).eq.-3) then
          idbmup(i)=-11
        elseif(lpp(i).eq.0) then
          idbmup(i)=idup(i,1,1)
        else
          idbmup(i)=lpp(i)
        endif
      enddo
      ebmup(1)=ebeam(1)
      ebmup(2)=ebeam(2)
      call get_pdfup(pdlabel,pdfgup,pdfsup,lhaid)

      return
 99   write(*,*) 'error in reading'
      return
      end

C-------------------------------------------------
C   GET_PDFUP
C   Convert MadEvent pdf name to LHAPDF number
C-------------------------------------------------

      subroutine get_pdfup(pdfin,pdfgup,pdfsup,lhaid)
      implicit none

      character*(*) pdfin
      integer mpdf
      integer npdfs,i,pdfgup(2),pdfsup(2),lhaid

      parameter (npdfs=16)
      character*7 pdflabs(npdfs)
      data pdflabs/
     $   'none',
     $   'mrs02nl',
     $   'mrs02nn',
     $   'cteq4_m',
     $   'cteq4_l',
     $   'cteq4_d',
     $   'cteq5_m',
     $   'cteq5_d',
     $   'cteq5_l',
     $   'cteq5m1',
     $   'cteq6_m',
     $   'cteq6_l',
     $   'cteq6l1',     
     $   'nn23lo',
     $   'nn23lo1',
     $   'nn23nlo'/
      integer numspdf(npdfs)
      data numspdf/
     $   00000,
     $   20250,
     $   20270,
     $   19150,
     $   19170,
     $   19160,
     $   19050,
     $   19060,
     $   19070,
     $   19051,
     $   10000,
     $   10041,
     $   10042,
     $   246800,
     $   247000,
     $   244800/


      if(pdfin.eq."lhapdf") then
        write(*,*)'using LHAPDF'
        do i=1,2
           pdfgup(i)=0
           pdfsup(i)=lhaid
        enddo
        return
      endif

      
      mpdf=-1
      do i=1,npdfs
        if(pdfin(1:len_trim(pdfin)) .eq. pdflabs(i))then
          mpdf=numspdf(i)
        endif
      enddo

      if(mpdf.eq.-1) then
        write(*,*)'pdf ',pdfin,' not implemented in get_pdfup.'
        write(*,*)'known pdfs are'
        write(*,*) pdflabs
        write(*,*)'using ',pdflabs(12)
        mpdf=numspdf(12)
      endif

      do i=1,2
        pdfgup(i)=0
        pdfsup(i)=mpdf
      enddo

      return
      end

*
* $Id: abend.f,v 1.1 2009/07/30 22:46:16 madgraph Exp $
*
* $Log: abend.f,v $
* Revision 1.1  2009/07/30 22:46:16  madgraph
* JA: Implemented CKKW-style matching with Pythia pT-ordered showers
*
* Revision 1.1.1.1  1996/02/15 17:50:37  mclareni
* Kernlib
*
*
      SUBROUTINE ABEND
C
C CERN PROGLIB# Z035    ABEND           .VERSION KERNFOR  4.31  911111
C ORIG.  8/02/88  JZ
C

      STOP  7
      END

      subroutine initcluster()

      implicit none

      include 'message.inc'
      include 'maxparticles.inc'
      include 'run.inc'
      include 'nexternal.inc'
      include 'maxamps.inc'
      include 'cluster.inc'
C
C     SPECIAL CUTS
C
      real*8 xptj,xptb,xpta,xptl,xmtc
      real*8 xetamin,xqcut,deltaeta
      common /to_specxpt/xptj,xptb,xpta,xptl,xmtc,xetamin,xqcut,deltaeta

      integer i,j,iproc
      logical filmap, cluster
      external filmap, cluster

c     
c     check whether y_cut is used -> set scale to y_cut*S
c

c      if (ickkw.le.0) return
      if (ickkw.le.0.and.xqcut.le.0d0.and.fixed_ren_scale.and.fixed_fac_scale) return

c      if(ickkw.eq.2.and.xqcut.le.0d0)then
c        write(*,*)'Must set qcut > 0 for ickkw = 2'
c        write(*,*)'Exiting...'
c        stop
c      endif

c      if(xqcut.gt.0d0)then
c      if(ickkw.eq.2)then
c        scale = xqcut
c        q2fact(1) = scale**2    ! fact scale**2 for pdf1
c        q2fact(2) = scale**2    ! fact scale**2 for pdf2
c        fixed_ren_scale=.true.
c        fixed_fac_scale=.true.
c      endif
c   
c     initialize clustering map
c         
      if (.not.filmap()) then
        write(*,*) 'cuts.f: cluster map initialization failed'
        stop
      endif
      if (btest(mlevel,3)) then
        do iproc=1,maxsproc
           write(*,*)'for proc ',iproc
           do i=1,n_max_cl
              write(*,*) 'prop ',i,' in'
              do j=1,id_cl(iproc,i,0)
                 write(*,*) '  graph ',id_cl(iproc,i,j)
              enddo
           enddo
           write(*,*)'ok'
        enddo
      endif
      igraphs(0)=0
       
      RETURN
      END

C     This File is Automatically generated by ALOHA 
C     The process calculated in this file is: 
C     Metric(1,4)*Metric(2,3) - Metric(1,3)*Metric(2,4)
C     
      SUBROUTINE VVVV16_0(V1, V2, V3, V4, COUP,VERTEX)
      IMPLICIT NONE
      COMPLEX*16 CI
      PARAMETER (CI=(0D0,1D0))
      COMPLEX*16 COUP
      COMPLEX*16 TMP14
      COMPLEX*16 TMP15
      COMPLEX*16 TMP6
      COMPLEX*16 TMP7
      COMPLEX*16 V1(*)
      COMPLEX*16 V2(*)
      COMPLEX*16 V3(*)
      COMPLEX*16 V4(*)
      COMPLEX*16 VERTEX
      TMP14 = (V4(3)*V2(3)-V4(4)*V2(4)-V4(5)*V2(5)-V4(6)*V2(6))
      TMP15 = (V3(3)*V1(3)-V3(4)*V1(4)-V3(5)*V1(5)-V3(6)*V1(6))
      TMP6 = (V4(3)*V1(3)-V4(4)*V1(4)-V4(5)*V1(5)-V4(6)*V1(6))
      TMP7 = (V3(3)*V2(3)-V3(4)*V2(4)-V3(5)*V2(5)-V3(6)*V2(6))
      VERTEX = COUP*(-CI*(TMP6*TMP7)+CI*(TMP14*TMP15))
      END

      double precision function pdg2pdf(ih,ipdg,beamid,x,xmu)
c***************************************************************************
c     Based on pdf.f, wrapper for calling the pdf of MCFM
c***************************************************************************
      implicit none
c
c     Arguments
c
      DOUBLE  PRECISION x,xmu
      INTEGER IH,ipdg
      integer beamid
C
C     Include
C
      include 'pdf.inc'
C
      integer nb_proton(2)
      integer nb_neutron(2)
      common/to_heavyion_pdg/ nb_proton, nb_neutron
      integer nb_hadron

C      
      double precision get_ion_pdf
      integer i,j,ihlast(20),ipart,iporg,ireuse,imemlast(20),iset,imem
     &     ,i_replace,ii,ipartlast(20)
      double precision xlast(20),xmulast(20),pdflast(-7:7,20)
      double precision epa_proton, epa_lepton
      save ihlast,xlast,xmulast,pdflast,imemlast,ipartlast
      data ihlast/20*-99/
      data ipartlast/20*-99/
      data xlast/20*-99d9/
      data xmulast/20*-99d9/
      data pdflast/300*-99d9/
      data imemlast/20*-99/
      data i_replace/20/

      nb_hadron = (nb_proton(beamid)+nb_neutron(beamid))
c     Make sure we have a reasonable Bjorken x. Note that even though
c     x=0 is not reasonable, we prefer to simply return pdg2pdf=0
c     instead of stopping the code, as this might accidentally happen.
      if (x.eq.0d0) then
         pdg2pdf=0d0
         return
      elseif (x.lt.0d0 .or. (x*nb_hadron).gt.1d0) then
         if(nb_hadron.eq.1.or.x.lt.0d0)then
            write (*,*) 'PDF not supported for Bjorken x ', x*nb_hadron
            open(unit=26,file='../../../error',status='unknown')
            write(26,*) 'Error: PDF not supported for Bjorken x ',x*nb_hadron
            stop 1
         else
            pdg2pdf=0d0
            return
         endif
      endif

      ipart=ipdg
      if(iabs(ipart).eq.21) then
         ipart=0
      else if(iabs(ipart).eq.22) then 
         ipart=7
      else if (iabs(ipart).eq.7) then
         ipart=7
c     This will be called for any PDG code, but we only support up to 7
      else if(iabs(ipart).gt.7)then
         write(*,*) 'PDF not supported for pdg ',ipdg
         write(*,*) 'For lepton colliders, please set the lpp* '//
     $    'variables to 0 in the run_card'  
         open(unit=26,file='../../../error',status='unknown')
         write(26,*) 'Error: PDF not supported for pdg ',ipdg
         stop 1
      endif

      iporg=ipart
c     Determine the iset used in lhapdf
      call getnset(iset)
      if (iset.ne.1) then
         write (*,*) 'PDF not supported for Bjorken x ', x
         open(unit=26,file='../../../error',status='unknown')
         write(26,*) 'Error: PDF not supported for Bjorken x ',x
         stop 1
      endif

c     Determine the member of the set (function of lhapdf)
      call getnmem(iset,imem)

      ireuse = 0
      ii=i_replace
      do i=1,20
c     Check if result can be reused since any of last twenty
c     calls. Start checking with the last call and move back in time
         if (ih.eq.ihlast(ii)) then
            if (ipart.eq.ipartlast(ii)) then
               if (x*nb_hadron.eq.xlast(ii)) then
                  if (xmu.eq.xmulast(ii)) then
                     if (imem.eq.imemlast(ii)) then
                        ireuse = ii
                        exit
                     endif
                  endif
               endif
            endif
         endif
         ii=ii-1
         if (ii.eq.0) ii=ii+20
      enddo

c     Reuse previous result, if possible
      if (ireuse.gt.0) then
         if (pdflast(ipart,ireuse).ne.-99d9) then
            pdg2pdf = get_ion_pdf(pdflast(-7,ireuse), ipart, nb_proton(beamid), nb_neutron(beamid))/x
            return 
         endif
      endif

c Calculated a new value: replace the value computed longest ago
      i_replace=mod(i_replace,20)+1

c     Call lhapdf and give the current values to the arrays that should
c     be saved
      if(ih.eq.1) then
         if (nb_proton(beamid).eq.1.and.nb_neutron(beamid).eq.0) then
            call evolvepart(ipart,x,xmu,pdg2pdf)
            pdflast(ipart, i_replace)=pdg2pdf
         else
            if (ipart.eq.1.or.ipart.eq.2) then
               call evolvepart(1,x*nb_hadron
     &                         ,xmu,pdflast(1, i_replace))
               call evolvepart(2,x*nb_hadron
     &                         ,xmu,pdflast(2, i_replace))
            else if (ipart.eq.-1.or.ipart.eq.-2)then
               call evolvepart(-1,x*nb_hadron
     &                         ,xmu,pdflast(-1, i_replace))
               call evolvepart(-2,x*nb_hadron
     &                         ,xmu,pdflast(-2, i_replace))
            else
               call evolvepart(ipart,x*nb_hadron
     &                         ,xmu,pdflast(ipart, i_replace))
            endif 
            pdg2pdf = get_ion_pdf(pdflast(-7, i_replace), ipart, nb_proton(beamid), nb_neutron(beamid))
         endif
         pdg2pdf=pdg2pdf/x
      else if(abs(ih).eq.3.or.abs(ih).eq.4) then       !from the electron
            pdg2pdf=epa_lepton(x,xmu*xmu, ih)
      else if(ih.eq.2) then ! photon from a proton without breaking
          pdg2pdf = epa_proton(x,xmu*xmu)
      else
         write (*,*) 'beam type not supported in lhadpf'
         stop 1
      endif
      xlast(i_replace)=x*nb_hadron
      xmulast(i_replace)=xmu
      ihlast(i_replace)=ih
      imemlast(i_replace)=imem
c
      return
      end

c************************************************************************
c**                                                                    **
c**           MadGraph/MadEvent Interface to FeynRules                 **
c**                                                                    **
c**          C. Duhr (Louvain U.) - M. Herquet (NIKHEF)                **
c**                                                                    **
c************************************************************************

      subroutine setpara(param_name)
      implicit none

      character*(*) param_name
      logical readlha

      include 'coupl.inc'
      include 'input.inc'
      include 'model_functions.inc'

      integer maxpara
      parameter (maxpara=5000)
      
      integer npara
      character*20 param(maxpara),value(maxpara)

      
      include 'param_read.inc'
      call coup()

      return

      end

      subroutine setParamLog(OnOff)

      logical OnOff
      logical WriteParamLog
      data WriteParamLog/.TRUE./
      common/IOcontrol/WriteParamLog

      WriteParamLog = OnOff

      end

      subroutine setpara2(param_name)
      implicit none

      character(512) param_name

      integer k
      logical found

      character(512) ParamCardPath
      common/ParamCardPath/ParamCardPath

      if (param_name(1:1).ne.' ') then
        ! Save the basename of the param_card for the ident_card.
        ! If no absolute path was used then this ParamCardPath
        ! remains empty
        ParamCardPath = '.'
        k = LEN(param_name)
        found = .False.
        do while (k.ge.1.and..not.found)
          if (param_name(k:k).eq.'/') then
              found=.True.
          endif
          k=k-1
        enddo
        if (k.ge.1) then
          ParamCardPath(1:k)=param_name(1:k)
        endif
        call setpara(param_name)
      endif
      if (param_name(1:1).eq.'*') then
         ! Dummy call to printout so that it is available in the
         ! dynamic library for MadLoop BLHA2
         ! In principle the --whole-archive option of ld could be 
         ! used but it is not always supported
         call printout()
         call setParamLog(.True.)
      endif
      return

      end

      SUBROUTINE PDFWRAP
      IMPLICIT NONE
C     
C     INCLUDE
C     
      INCLUDE 'pdf.inc'
      INCLUDE '../alfas.inc'
      REAL*8 ZMASS
      DATA ZMASS/91.188D0/
      CHARACTER*150 LHAPATH
      CHARACTER*20 PARM(20)
      DOUBLE PRECISION VALUE(20)
      REAL*8 ALPHASPDF
      EXTERNAL ALPHASPDF


C     -------------------
C     START THE CODE
C     -------------------      

C     initialize the pdf set
      CALL FINDPDFPATH(LHAPATH)
      CALL SETPDFPATH(LHAPATH)
      VALUE(1)=LHAID
      PARM(1)='DEFAULT'
      CALL PDFSET(PARM,VALUE)
      CALL GETORDERAS(NLOOP)
      NLOOP=NLOOP+1
      ASMZ=ALPHASPDF(ZMASS)

      RETURN
      END


      SUBROUTINE FINDPDFPATH(LHAPATH)
C     *****************************************************************
C     ***
C     generic subroutine to open the table files in the right
C      directories
C     *****************************************************************
C     ***
      IMPLICIT NONE
C     
      CHARACTER LHAPATH*150,UP*3
      DATA UP/'../'/
      LOGICAL EXISTS
      INTEGER I, POS
      CHARACTER*300  TEMPNAME2
      CHARACTER*300 PATH  ! path of the executable
      INTEGER FINE2
      CHARACTER*30  UPNAME  ! sequence of ../

C     first try in the current directory
      LHAPATH='./PDFsets'
      INQUIRE(FILE=LHAPATH, EXIST=EXISTS)
      IF(EXISTS)RETURN

      DO I=1,6
        LHAPATH=UP//LHAPATH
        INQUIRE(FILE=LHAPATH, EXIST=EXISTS)
        IF(EXISTS)RETURN
      ENDDO

C     
C     getting the path of the executable
C     
      CALL GETARG(0,PATH)  !path is the PATH to the madevent executable (either global or from launching directory)
      POS = INDEX(PATH,'/',.TRUE.)
      PATH = PATH(:POS)
      FINE2=INDEX(PATH,' ')-1


C     
C     check path from the executable
C     
      LHAPATH='lib/PDFsets'
      INQUIRE(FILE=LHAPATH, EXIST=EXISTS)
      IF(EXISTS)RETURN
      UPNAME='../../../../../../../'
      DO I=1,6
        TEMPNAME2=PATH(:FINE2)//UPNAME(:3*I)//LHAPATH
C       LHAPath=up//LHAPath
        INQUIRE(FILE=TEMPNAME2, EXIST=EXISTS)
        IF(EXISTS)THEN
          LHAPATH = TEMPNAME2
          RETURN
        ENDIF
      ENDDO
      PRINT*,'Could not find PDFsets directory, quitting'
      STOP

      RETURN
      END

      FUNCTION GET_COLOR(IPDG)
      IMPLICIT NONE
      INTEGER GET_COLOR, IPDG

      IF(IPDG.EQ.-6)THEN
        GET_COLOR=-3
        RETURN
      ELSE IF(IPDG.EQ.6)THEN
        GET_COLOR=3
        RETURN
      ELSE IF(IPDG.EQ.21)THEN
        GET_COLOR=8
        RETURN
      ELSE IF(IPDG.EQ.7)THEN
C       This is dummy particle used in multiparticle vertices
        GET_COLOR=2
        RETURN
      ELSE
        WRITE(*,*)'Error: No color given for pdg ',IPDG
        GET_COLOR=0
        RETURN
      ENDIF
      END

      subroutine addmothers(ip,jpart,pb,isym,jsym,rscale,aqcd,aqed,buff,
     $                      npart,numproc,flip)

      implicit none
      include 'genps.inc'
      include 'maxconfigs.inc'
      include 'nexternal.inc'
      include 'coupl.inc'
      include 'maxamps.inc'
      include 'cluster.inc'
      include 'message.inc'
      include 'run.inc'

      integer jpart(7,-nexternal+3:2*nexternal-3),npart,ip,numproc
      double precision pb(0:4,-nexternal+3:2*nexternal-3)
      double precision rscale,aqcd,aqed,targetamp(maxflow)
      character*1000 buff
      character*20 cform
      logical flip ! If .true., initial state is mirrored

      integer isym(nexternal,99), jsym
      integer i,j,k,ida(2),ns,nres,ires,icl,ito2,idenpart,nc,ic
      integer mo_color,da_color(2),itmp
      integer ito(-nexternal+3:nexternal),iseed,maxcolor,maxorg
      integer icolalt(2,-nexternal+2:2*nexternal-3)
      double precision qicl(-nexternal+3:2*nexternal-3), factpm
      double precision xtarget
      data iseed/0/
      integer lconfig,idij(-nexternal+2:nexternal)

      integer diag_number
      common/to_diag_number/diag_number

c     Variables for combination of color indices (including multipart. vert)
      integer maxcolmp
      parameter(maxcolmp=20)
      integer ncolmp,icolmp(2,maxcolmp),is_colors(2,nincoming)

      double precision ZERO
      parameter (ZERO=0d0)
      double precision prmass(-nexternal:0,lmaxconfigs)
      double precision prwidth(-nexternal:0,lmaxconfigs)
      integer pow(-nexternal:0,lmaxconfigs)
      logical first_time,tchannel
      save prmass,prwidth,pow
      data first_time /.true./

      Double Precision amp2(maxamps), jamp2(0:maxflow)
      common/to_amps/  amp2,       jamp2

      integer           mincfig, maxcfig
      common/to_configs/mincfig, maxcfig
      integer idmap(-nexternal:nexternal),icmp

      integer iforest(2,-max_branch:-1,lmaxconfigs)
      common/to_forest/ iforest
      integer sprop(maxsproc,-max_branch:-1,lmaxconfigs)
      integer tprid(-max_branch:-1,lmaxconfigs)
      common/to_sprop/sprop,tprid
      integer            mapconfig(0:lmaxconfigs), iconfig
      common/to_mconfigs/mapconfig, iconfig

      integer idup(nexternal,maxproc,maxsproc)
      integer mothup(2,nexternal)
      integer icolup(2,nexternal,maxflow,maxsproc)
      include 'leshouche.inc'
      include 'coloramps.inc'
      
      logical             OnBW(-nexternal:0)     !Set if event is on B.W.
      common/to_BWEvents/ OnBW
      CHARACTER temp*600,temp0*7,integ*1,float*18
      CHARACTER integfour*4      
      CHARACTER(LEN=45*nexternal) ptclusstring

C     iproc has the present process number
      integer imirror, iproc
      common/to_mirror/imirror, iproc
      data iproc/1/
c      integer ncols,ncolflow(maxamps),ncolalt(maxamps),icorg
c      common/to_colstats/ncols,ncolflow,ncolalt,icorg

c
c     LOCAL
c
      logical is_LC ! for not leading color bypass the writing of intermediate particle since the diagram is a very good candididate (and that it leads to issue)


      double precision pt
      integer get_color,elim_indices,set_colmp,fix_tchannel_color,combid
      real ran1
      external pt,ran1,get_color,elim_indices,set_colmp,fix_tchannel_color

      if (first_time) then
         include 'props.inc'
         first_time=.false.
      endif

      npart = nexternal
      buff = ' '

      do i=-nexternal+2,nexternal
         icolalt(1,i)=0
         icolalt(2,i)=0
      enddo

c   
c   Choose the config (diagram) which was actually used to produce the event
c   
c   ...unless the diagram is passed in igraphs(1); then use that diagram
      lconfig=iconfig
      if (ickkw.gt.0) then
         if (btest(mlevel,3)) then
            write(*,*)'unwgt.f: write out diagram ',igraphs(1)
         endif
         lconfig=igraphs(1)
      endif
      
c
c    Choose a color flow which is certain to work with the propagator
c    structure of the chosen diagram and use that as an alternative
c   

      nc = int(jamp2(0))
      is_LC = .true.
      maxcolor=0
      if(nc.gt.0)then
      if(icolamp(1,lconfig,iproc)) then
        targetamp(1)=jamp2(1)
c        print *,'Color flow 1 allowed for config ',lconfig
      else
        targetamp(1)=0d0
      endif
      do ic =2,nc
        if(icolamp(ic,lconfig,iproc))then
          targetamp(ic) = jamp2(ic)+targetamp(ic-1)
c          print *,'Color flow ',ic,' allowed for config ',lconfig,targetamp(ic)
        else
          targetamp(ic)=targetamp(ic-1)
        endif
      enddo
c     ensure that at least one leading color is different of zero if not allow
c     all subleading color. 
      if (targetamp(nc).eq.0)then
       is_LC = .false.
       targetamp(1)=jamp2(1)
       do ic =2,nc
           targetamp(ic) = jamp2(ic)+targetamp(ic-1)
       enddo
      endif


      xtarget=ran1(iseed)*targetamp(nc)

      ic = 1
      do while (targetamp(ic) .lt. xtarget .and. ic .lt. nc)
         ic=ic+1
      enddo
      if(targetamp(nc).eq.0) ic=0
c      print *,'Chose color flow ',ic
      do i=1,nexternal
         if(ic.gt.0) then
            icolalt(1,isym(i,jsym))=icolup(1,i,ic,numproc)
            icolalt(2,isym(i,jsym))=icolup(2,i,ic,numproc)
c            write(*,*) i, icolalt(1,isym(i,jsym)), icolalt(2,isym(i,jsym))
            if (abs(icolup(1,i,ic, numproc)).gt.maxcolor) maxcolor=icolup(1,i,ic, numproc)
            if (abs(icolup(2,i,ic, numproc)).gt.maxcolor) maxcolor=icolup(2,i,ic, numproc)
         endif
      enddo
      else ! nc.gt.0

      do i=1,nexternal
         icolalt(1,i)=0
         icolalt(2,i)=0
      enddo

      endif ! nc.gt.0

c     Store original maxcolor to know if we have epsilon vertices
        maxorg=maxcolor
c     Keep track of IS colors that go through to final state
c     (since we shouldn't replace pop-up indices with those)
        do i=1,nincoming
           do j=1,2
              is_colors(j,i)=0
              do k=3,nexternal
                 if (iabs(icolalt(j,i)).eq.iabs(icolalt(j,k))) then
c                This color is going through to FS
                    is_colors(j,i)=iabs(icolalt(j,i))
                 endif
              enddo
           enddo
        enddo
c     
c     Get mother information from chosen graph
c     

c     Set idij for external particles (needed to keep track of BWs)
        if(ickkw.gt.0) then
           do i=1,nexternal
              idij(i)=ishft(1,i-1)
           enddo
        endif

c     First check number of resonant s-channel propagators
        ns=0
        nres=0
        tchannel=.false.
c     Ensure that mother-daughter information starts from 0
        do i=-nexternal+3,0
           jpart(2,i) = 0
           jpart(3,i) = 0
        enddo
 
        
c     Loop over propagators to find mother-daughter information
        do i=-1,-nexternal+2,-1
c       Daughters
          if(i.gt.-nexternal+2)then
             ida(1)=iforest(1,i,lconfig)
             ida(2)=iforest(2,i,lconfig)
             do j=1,2
                if(ida(j).gt.0) ida(j)=isym(ida(j),jsym)
             enddo
c            Set idij (needed to keep track of BWs)
             if(ickkw.gt.0) idij(i)=combid(idij(ida(1)),idij(ida(2)))
          endif
c       Decide s- or t-channel (for not LC -> set to none
          if(i.gt.-nexternal+2.and.is_LC.and.
     $         iabs(sprop(numproc,i,lconfig)).gt.0) then ! s-channel propagator
            jpart(1,i)=sprop(numproc,i,lconfig)
            ns=ns+1
          else if(nres.gt.0.and.maxcolor.gt.maxorg.and.is_LC) then
c         For t-channel propagators, just check that the colors are ok
             if(i.eq.-nexternal+2) then
c            This is the final t-channel, combining with leg 2
                mo_color=0
                if(.not.tchannel)then
c                  There are no previous t-channels, so this is a combination of
c                  2, 1 and the last s-channel
                   ida(1)=1
                   ida(2)=i+1
                else
c                  The daughter info is in iforest
                   ida(1)=iforest(1,i,lconfig)
                   ida(2)=iforest(2,i,lconfig)
                endif
c            Reverse colors of t-channels to get right color ordering
                ncolmp=0
                ncolmp=set_colmp(ncolmp,icolmp,2,jpart,
     $               iforest(1,-max_branch,lconfig),icolalt,
     $               icolalt(2,2),icolalt(1,2))
             else
                jpart(1,i)=tprid(i,lconfig)
                mo_color=get_color(jpart(1,i))
                ncolmp=0
             endif
             if(mo_color.gt.1.and.
     $            mo_color.ne.3.and.mo_color.ne.8)then
                da_color(1)=get_color(jpart(1,ida(1)))
                da_color(2)=get_color(jpart(1,ida(2)))
                call write_error(da_color(1), da_color(2), mo_color)
             endif
c            Set icolmp for daughters
             ncolmp=set_colmp(ncolmp,icolmp,ida(2),jpart,
     $            iforest(1,-max_branch,lconfig),icolalt,
     $            icolalt(1,ida(2)),icolalt(2,ida(2)))
c            Reverse colors of t-channels to get right color ordering
             ncolmp=set_colmp(ncolmp,icolmp,ida(1),jpart,
     $            iforest(1,-max_branch,lconfig),icolalt,
     $            icolalt(2,ida(1)),icolalt(1,ida(1)))
c            Fix t-channel color
c             print *,'t-channel: ',i,ida(1),ida(2),mo_color
c             print *,'colors: ',((icolmp(j,k),j=1,2),k=1,ncolmp)
             maxcolor=fix_tchannel_color(mo_color,maxcolor,
     $                        ncolmp,icolmp,i,icolalt,is_colors)
             tchannel=.true.
             cycle
          else
            goto 100             
          endif
c       Set status codes for propagator
c          if((igscl(0).ne.0.and.
c     $       (iabs(jpart(1,i)).gt.5.and.iabs(jpart(1,i)).lt.11).or.
c     $       (iabs(jpart(1,i)).gt.16.and.iabs(jpart(1,i)).ne.21)).or.
c     $       (igscl(0).eq.0.and.OnBW(i))) then 
          if(ickkw.eq.0.and.OnBW(i))then
c         Resonance whose mass should be preserved
            jpart(6,i)=2
            nres=nres+1
          else if (ickkw.gt.0) then
             if(isbw(idij(i))) then 
c         Resonance whose mass should be preserved
                jpart(6,i)=2
                nres=nres+1
             else
                jpart(6,i)=3
             endif
          else
c         Propagator for documentation only - not included
            jpart(6,i)=3
          endif
c       Calculate momentum (p1+p2 for s-channel, p2-p1 for t-channel)
          do j=0,3
            pb(j,i)=pb(j,ida(1))+pb(j,ida(2))
          enddo
          pb(4,i)=sqrt(max(0d0,pb(0,i)**2-pb(1,i)**2-pb(2,i)**2-pb(3,i)**2))
c          if(jpart(6,i).eq.2.and.
c     $       abs(pb(4,i)-prmass(i,lconfig)).gt.5d0*prwidth(i,lconfig)) then
c            jpart(6,i)=3
c            nres=nres-1
c          endif
c       Set color info for all s-channels
          mo_color = get_color(jpart(1,i))
c     If inside multipart. vertex (indicated by color 2) cycle
c         Set tentative mothers
          jpart(2,i) = 1
          jpart(3,i) = 2
c         Set mother info for daughters
          do j=1,2
            jpart(2,ida(j)) = i
            jpart(3,ida(j)) = i
          enddo
          if(mo_color.eq.2) cycle
c     Reset list of color indices
          ncolmp=0
c     Add new color indices to list of color indices
          do j=1,2
             ncolmp=set_colmp(ncolmp,icolmp,ida(j),jpart,
     $            iforest(1,-max_branch,lconfig),icolalt,
     $            icolalt(1,ida(j)),icolalt(2,ida(j)))
          enddo
c          print *,'s-channel: ',i,mo_color,ida(1),ida(2)
c          print *,'colors: ',((icolmp(j,k),j=1,2),k=1,ncolmp)
          if(is_LC)then
          if (icolmp(1,1).eq.1000.or.icolmp(2,1).eq.1000)then
             if (jpart(6,i).eq.2)then
               stop 5
            endif
          elseif(mo_color.eq.1) then ! color singlet
             maxcolor=elim_indices(0,0,ncolmp,icolmp,i,icolalt,
     $            is_colors,maxcolor)
          elseif(mo_color.eq.-3) then ! color anti-triplet
             maxcolor=elim_indices(0,1,ncolmp,icolmp,i,icolalt,
     $            is_colors,maxcolor)
          elseif(mo_color.eq.3) then ! color triplet
             maxcolor=elim_indices(1,0,ncolmp,icolmp,i,icolalt,
     $            is_colors,maxcolor)
          elseif(mo_color.eq.-6) then ! color anti-sextet
             maxcolor=elim_indices(0,2,ncolmp,icolmp,i,icolalt,
     $            is_colors,maxcolor)
          elseif(mo_color.eq.6) then ! color sextet
             maxcolor=elim_indices(2,0,ncolmp,icolmp,i,icolalt,
     $            is_colors,maxcolor)
          elseif(mo_color.eq.8) then ! color octet
             maxcolor=elim_indices(1,1,ncolmp,icolmp,i,icolalt,
     $            is_colors,maxcolor)
          else ! 2 indicates multipart. vertex
             da_color(1) = get_color(jpart(1,ida(1)))
             da_color(2) = get_color(jpart(1,ida(2)))
             call write_error(da_color(1), da_color(2), mo_color)
          endif
         endif !end of check on LC

c       Just zero helicity info for intermediate states
          jpart(7,i) = 0
        enddo                   ! do i
 100    continue
        if (is_LC) call check_pure_internal_flow(icolalt,jpart, maxcolor)

c    Remove non-resonant mothers, set position of particles
        ires=0
        do i=-ns,nexternal
          jpart(4,i)=icolalt(1,i)
          jpart(5,i)=icolalt(2,i)
          if(i.eq.1.or.i.eq.2) then 
            ito(i)=i            ! initial state particle
          else if(i.ge.3) then 
            ito(i)=i+nres       ! final state particle
          else if(i.le.-1.and.jpart(6,i).eq.2) then
            ires=ires+1
            ito(i)=2+ires       ! s-channel resonances
          else 
            ito(i)=0
            if(i.eq.0) cycle
          endif
          if(jpart(2,i).lt.0.and.jpart(6,jpart(2,i)).ne.2) then
            jpart(2,i)=jpart(2,jpart(2,i))
            jpart(3,i)=jpart(3,jpart(3,i))
          endif
        enddo
c
c    Shift particles to right place and set mothers of particles
c
        do i=nexternal,-ns,-1
          if(ito(i).le.0) cycle
          do j=1,7
            jpart(j,ito(i))=jpart(j,i)
          enddo
          if(jpart(2,ito(i)).lt.0) then
            jpart(2,ito(i))=ito(jpart(2,ito(i)))
            jpart(3,ito(i))=ito(jpart(3,ito(i)))
          endif
          do j=0,4
            pb(j,ito(i))=pb(j,i)
          enddo
        enddo
c
c     Set correct mother number for clustering info
c
        if (icluster(1,1).ne.0) then
           do i=1,nexternal-2
              if(icluster(4,i).gt.0)then
                 icluster(4,i)=ito(icluster(4,i))
              else
                 icluster(4,i)=-1
              endif
              if(icluster(3,i).eq.0)then
                 icluster(3,i)=-1
              endif
              if(ito(icluster(1,i)).gt.0)
     $             icluster(1,i)=ito(icluster(1,i))
              if(ito(icluster(2,i)).gt.0)
     $             icluster(2,i)=ito(icluster(2,i))
              if(flip)then
                 if(icluster(1,i).le.2)
     $             icluster(1,i)=3-icluster(1,i)
                 if(icluster(2,i).le.2)
     $             icluster(2,i)=3-icluster(2,i)
                 if(icluster(3,i).ge.1.and.icluster(3,i).le.2)
     $             icluster(3,i)=3-icluster(3,i)
              endif
           enddo
        endif

        if (flip) then
c       Need to flip initial state color, since might be overwritten
           do i=1,7
              j=jpart(i,1)
              jpart(i,1)=jpart(i,2)
              jpart(i,2)=j
           enddo
        endif

        if(ickkw.gt.0) then
            if (lhe_version.lt.3d0) then
              write(cform,'(a4,i2,a6)') '(a1,',max(nexternal,10),'e15.7)'
              write(buff,cform) '#',(ptclus(i),i=3,nexternal)
           else if(nexternal.gt.2)then
              temp0='<scales '
              temp=''
              do i=3,nexternal
                 integfour=''
                 float=''
                 Write(float,'(f16.5)') ptclus(i)
                 write(integfour,'(i4)') ito(i)
                 temp=trim(temp)//' pt_clust_'//trim(adjustl(integfour))//'="'//trim(adjustl(float))//'"'
              enddo
              ptclusstring=trim(adjustl(temp0//trim(temp)//'></scales>'))
c             write(*,*)'WRITING THE ptclusscale:',trim(adjustl(ptclusstring))
              write(buff,'(a)') trim(adjustl(ptclusstring))
           endif
        endif

        npart = nexternal+nres

      return
      end

c     *************************************
      subroutine write_error(ida1,ida2,imo)
c     *************************************
      implicit none
      integer ida1,ida2,imo

      open(unit=26,file='../../../error',status='unknown',err=999)
      if (ida1.eq.1000)then
         write(26,*) 'Error: too many particles in multipart. vertex,',
     $        ' please increase maxcolmp in addmothers.f'
         write(*,*) 'Error: too many particles in multipart. vertex,',
     $        ' please increase maxcolmp in addmothers.f'
         stop
      endif
      if (ida1.eq.1001)then
         write(26,*) 'Error: failed to reduce to color indices: ',ida2,imo
         write(*,*) 'Error: failed to reduce to color indices: ',ida2,imo
         stop
      endif
      write(26,*) 'Error: Color combination ',ida1,ida2,
     $     '->',imo,' not implemented in addmothers.f'
      write(*,*) 'Error: Color combination ',ida1,ida2,
     $     '->',imo,' not implemented in addmothers.f'
      stop

 999  write(*,*) 'error'
      end

c     *********************************************************************
      function set_colmp(ncolmp,icolmp,npart,jpart,forest,icol,icol1,icol2)
c     *********************************************************************
      implicit none
      integer maxcolmp
      parameter(maxcolmp=20)
      include 'nexternal.inc'
      include 'genps.inc'
c     Arguments
      integer set_colmp
      integer ncolmp,icolmp(2,*),npart,icol1,icol2
      integer icol(2,-nexternal+2:2*nexternal-3)
      integer jpart(7,-nexternal+3:2*nexternal-3)
      integer forest(2,-max_branch:-1)
c     Local
      integer da_color(2),itmp,ida(2),icolor,ipart,i,j
      integer get_color,set1colmp

      set_colmp=ncolmp
      icolor=get_color(jpart(1,npart))
      if(icolor.eq.1) return
      if(icolor.eq.2) then
c     Multiparticle vertex - need to go through daughters and collect all colors
         ipart=npart
        do while(icolor.eq.2)
          ida(1)=forest(1,ipart)
          ida(2)=forest(2,ipart)
          da_color(1)=get_color(jpart(1,ida(1)))
          da_color(2)=get_color(jpart(1,ida(2)))
c          print *,'iforest: ',ipart,ida(1),ida(2),da_color(1),da_color(2)
          if(da_color(1).ne.2.and.da_color(2).lt.da_color(1).or.
     $         da_color(2).eq.2)then
c            Order daughters according to color, but always color 2 first
             itmp=ida(1)
             ida(1)=ida(2)
             ida(2)=itmp
             itmp=da_color(1)
             da_color(1)=da_color(2)
             da_color(2)=itmp
          endif
          do i=1,2
             if(da_color(i).ne.1.and.da_color(i).ne.2)then
                ncolmp=set1colmp(ncolmp,icolmp,icol(1,ida(i)),
     $               icol(2,ida(i)))
             endif
          enddo
          icolor=da_color(1)
          ipart=ida(1)
        enddo
      else
         ncolmp=set1colmp(ncolmp,icolmp,icol1,icol2)
      endif
      set_colmp=ncolmp
      return
      end

c     ******************************************************
      function set1colmp(ncolmp,icolmp,icol1,icol2)
c     ******************************************************
      implicit none
c     Arguments
      integer maxcolmp
      parameter(maxcolmp=20)
      integer set1colmp
      integer ncolmp,icolmp(2,*),icol1,icol2,i,j

c      print *,'icol1,icol2: ',icol1,icol2

      ncolmp=ncolmp+1
      icolmp(1,ncolmp)=icol1
      icolmp(2,ncolmp)=icol2
c     Avoid color sextet-type negative indices
      if(icolmp(1,ncolmp).lt.0)then
         ncolmp=ncolmp+1
         icolmp(2,ncolmp)=-icolmp(1,ncolmp-1)
         icolmp(1,ncolmp-1)=0
         icolmp(1,ncolmp)=0
      elseif(icolmp(2,ncolmp).lt.0)then
         ncolmp=ncolmp+1
         icolmp(1,ncolmp)=-icolmp(2,ncolmp-1)
         icolmp(2,ncolmp-1)=0
         icolmp(2,ncolmp)=0
      endif
c      print *,'icolmp: ',((icolmp(i,j),i=1,2),j=1,ncolmp)
      if(ncolmp.gt.maxcolmp)
     $     call write_error(1000,ncolmp,maxcolmp)
      set1colmp=ncolmp
      return
      end

c********************************************************************
      function fix_tchannel_color(mo_color,maxcolor,ncolmp,icolmp,ires,
     $                            icol,is_colors)
c********************************************************************
c     Successively eliminate identical pairwise color indices from the
c     icolmp list, until only (max) one triplet and one antitriplet remains
c

      implicit none
      include 'nexternal.inc'
      integer fix_tchannel_color
      integer mo_color,maxcolor,ncolmp,icolmp(2,*)
      integer ires,icol(2,-nexternal+2:2*nexternal-3)
      integer is_colors(2,nincoming)
      integer i,j,i3,i3bar,max3,max3bar,min3,min3bar,maxcol,mincol
      integer count

c     Successively eliminate color indices in pairs until only the wanted
c     indices remain
      do i=1,ncolmp
         do j=1,ncolmp
            if(icolmp(1,i).ne.0.and.icolmp(1,i).eq.icolmp(2,j)) then
               icolmp(1,i)=0
               icolmp(2,j)=0
            endif
         enddo
      enddo
      
      i3=0
      i3bar=0
      icol(1,ires)=0
      icol(2,ires)=0
      do i=1,ncolmp
         if(icolmp(1,i).gt.0)then
            i3=i3+1
c           color for t-channels needs to be reversed
            if(i3.eq.1) icol(2,ires)=icolmp(1,i)
            if(i3.eq.2) icol(1,ires)=-icolmp(1,i)
         endif
         if(icolmp(2,i).gt.0)then
            i3bar=i3bar+1
c           color for t-channels needs to be reversed
            if(i3bar.eq.1) icol(1,ires)=icolmp(2,i)
            if(i3bar.eq.2) icol(2,ires)=-icolmp(2,i)
         endif
      enddo

      if(mo_color.eq.0)then
         icol(1,ires)=0
         icol(2,ires)=0
      endif

      fix_tchannel_color=maxcolor
      if(mo_color.le.1.and.i3.eq.0.and.i3bar.eq.0) return
      if(mo_color.eq.3.and.(i3.eq.1.and.i3bar.eq.0
     $     .or.i3bar.eq.1.and.i3.eq.0)) return
      if(mo_color.eq.8.and.i3.eq.1.and.i3bar.eq.1) return

c     Make sure that max and min don't come from the same octet
      call find_max_min(icolmp,ncolmp,max3,min3,max3bar,min3bar,
     $     i3,i3bar,is_colors)
c      print *,'After finding: ',ncolmp,((icolmp(j,i),j=1,2),i=1,ncolmp)
c      print *,'mo_color = ',mo_color

      if(mo_color.le.1.and.i3-i3bar.eq.2.or.
     $   mo_color.le.1.and.i3bar-i3.eq.2.or.
     $   mo_color.le.1.and.i3.eq.1.and.i3bar.eq.1) then
c     Replace the maximum index with the minimum one everywhere
         maxcol=max(max3,max3bar)
         if(maxcol.eq.max3) then
            mincol=min3bar
         else
            mincol=min3
         endif
         do i=ires+1,-1
            do j=1,2
               if(icol(j,i).eq.maxcol)
     $              icol(j,i)=mincol
            enddo
         enddo
c         print *,'Replaced ',maxcol,' by ',mincol
      elseif(mo_color.le.1.and.i3.eq.2.and.i3bar.eq.2) then
c     Ensure that max > min
         if(max3bar.lt.min3)then
            i=min3
            min3=max3bar
            max3bar=i
         endif
         if(max3.lt.min3bar)then
            i=min3bar
            min3bar=max3
            max3=i
         endif
c     Replace the maximum indices with the minimum ones everywhere
         do i=ires+1,-1
            do j=1,2
               if(icol(j,i).eq.max3bar)
     $              icol(j,i)=min3
               if(icol(j,i).eq.max3)
     $              icol(j,i)=min3bar
            enddo
         enddo
c         print *,'Replaced ',max3bar,' by ',min3,' and ',max3,' by ',min3bar
      elseif(mo_color.le.1.and.mod(i3,3).eq.0.and.mod(i3bar,3).eq.0)then
c     This is epsilon index - do nothing
         continue
      else if(mo_color.eq.3.and.mod(i3-i3bar,3).eq.2) then
c     This is an epsilon index
         maxcolor=maxcolor+1
         icol(1,ires)=maxcolor
         icol(2,ires)=0
c         print *,'Set mother color for ',ires,' to ',(icol(j,ires),j=1,2)
      else if(mo_color.eq.3.and.mod(i3bar-i3,3).eq.2) then
c     This is an epsilon index
         maxcolor=maxcolor+1
         icol(1,ires)=0
         icol(2,ires)=maxcolor
c         print *,'Set mother color for ',ires,' to ',(icol(j,ires),j=1,2)
      else if(mo_color.eq.3.and.(i3-i3bar.eq.1.or.i3bar-i3.eq.1).or.
     $        mo_color.eq.8.and.i3.eq.2.and.i3bar.eq.2) then
c     Replace the maximum index with the minimum one everywhere
c     (we don't know if we should replace i3 with i3bar or vice versa)
c     Actually we know if one of the index is repeated (we do not want to replace that one)
         maxcol=max(max3,max3bar)
         if(maxcol.eq.max3) then
            mincol=min3bar
         else
            mincol=min3
         endif
         do i=ires+1,-1
            do j=1,2
               if(icol(j,i).eq.maxcol)
     $              icol(j,i)=mincol
            enddo
         enddo

         if (mincol.eq.0.and.mo_color.eq.3) then
c            situation like (possible if they are epsilon in the gluon decay
c            (503,0)----------+ggggggggggggg (509,508)
c                             |
c                             |(x,y)
c            in this case maxcol=509 and mincol=0
c            The correct solution in this case is:
c            (503,0)----------+ggggggggggggg (503,508)
c                             |
c                             |(0,508)
            if(icolmp(2,1).eq.0)then
               maxcol = icolmp(1,2)
               mincol = icolmp(1,1)
               icol(1,ires) = 0
               icol(2,ires) = icolmp(2,2)
            elseif(icolmp(1,1).eq.0)then
               maxcol = icolmp(2,2)
               mincol = icolmp(2,1)
               icol(1,ires) = icolmp(1,2)
               icol(2,ires) = 0 
            elseif(icolmp(2,2).eq.0)then
               maxcol = icolmp(1,1)
               mincol = icolmp(1,2)
               icol(1,ires) = 0
               icol(2,ires) = icolmp(2,1)
            elseif(icolmp(1,2).eq.0)then
               maxcol = icolmp(2,1)
               mincol = icolmp(2,2)
               icol(1,ires) = icolmp(1,1)
               icol(2,ires) = 0
            else
               !should not happen
               write(*,*) "weird color combination in addmothers.f"
               write(*,*) icolmp(1,1), icolmp(2,1), icolmp(1,2), icolmp(2,2)
               call write_error(1001,0,0) 
            endif
c           now maxcol=509 and mincol=503 so replace all occurence of 509-> 503
c            print *,'Replaced ',maxcol,' by ',mincol
            do i=ires+1,nexternal
               do j=1,2
                  if(icol(j,i).eq.maxcol)
     $                 icol(j,i)=mincol
               enddo
            enddo
         else
c        standard case
c     First check that mincol is not a going trough index. If it is it 
C     should not be assign to one of the temporary index
            count=0
            do i=1,nexternal
               do j=1,2
                  if (icol(j,i).eq.mincol) count = count +1
               enddo
            enddo

            if(count.eq.2)then
c     we do not want to use that index pass to the other one
               if (mincol.eq.min3)then
                  mincol = min3bar
                  maxcol = max3
               else
                  mincol = min3
                  maxcol = max3bar
               endif
            endif

c     Fix the color for ires (remember 3<->3bar for t-channels)
            icol(1,ires)=0
            icol(2,ires)=0
c         print *,'Replaced ',maxcol,' by ',mincol
            if(max3.eq.maxcol)then
               if(i3-i3bar.ge.0) icol(2,ires)=min3
               if(i3bar-i3.ge.0) icol(1,ires)=max3bar
            else
               if(i3-i3bar.ge.0) icol(2,ires)=max3
               if(i3bar-i3.ge.0) icol(1,ires)=min3bar
            endif
         endif
c     print *,'Set mother color for ',ires,' to ',(icol(j,ires),j=1,2)
      else
c     Don't know how to deal with this
         call write_error(i3,i3bar,mo_color)
      endif
      fix_tchannel_color=maxcolor
      
      return
      end

c*******************************************************************
      function elim_indices(n3,n3bar,ncolmp,icolmp,ires,icol,
     $     is_colors,maxcolor)
c*******************************************************************
c     Successively eliminate identical pairwise color indices from the
c     icolmp list, until only the wanted indices remain
c     n3 gives the number of triplet indices, n3bar number of antitriplets
c     n3=1 for triplet, n3bar=1 for antitriplet, 
c     (n3,n3bar)=(1,1) for octet,
c     n3=2 for sextet, n3bar=2 for antisextet 
c     If there are epsilon^{ijk} or epsilonbar color couplings, we
c     need to introduce new index based on maxcolor.
c

      implicit none
      include 'nexternal.inc'
      integer elim_indices
      integer n3,n3bar,ncolmp,icolmp(2,*),maxcolor
      integer ires,icol(2,-nexternal+2:2*nexternal-3)
      integer is_colors(2,nincoming)
      integer i,j,i3,i3bar

c     Successively eliminate color indices in pairs until only the wanted
c     indices remain
      do i=1,ncolmp
         do j=1,ncolmp
            if(icolmp(1,i).ne.0.and.icolmp(1,i).eq.icolmp(2,j)) then
               icolmp(1,i)=0
               icolmp(2,j)=0
            endif
         enddo
      enddo
      
      i3=0
      i3bar=0
      icol(1,ires)=0
      icol(2,ires)=0
      do i=1,ncolmp
         if(icolmp(1,i).gt.0)then
            i3=i3+1
            if(i3.eq.1) icol(1,ires)=icolmp(1,i)
            if(i3.eq.2) icol(2,ires)=-icolmp(1,i)
         endif
         if(icolmp(2,i).gt.0)then
            i3bar=i3bar+1
            if(i3bar.eq.1) icol(2,ires)=icolmp(2,i)
            if(i3bar.eq.2) icol(1,ires)=-icolmp(2,i)
         endif
      enddo

c      print *,'i3,n3,i3bar,n3bar: ',i3,n3,i3bar,n3bar
c      print *,'icol(1,ires),icol(2,ires): ',icol(1,ires),icol(2,ires)

      if(n3bar.le.1.and.n3.eq.0) icol(1,ires)=0
      if(n3.le.1.and.n3bar.eq.0) icol(2,ires)=0

      if(i3.ne.n3.or.i3bar.ne.n3bar) then
         if(n3.gt.0.and.n3bar.eq.0.and.mod(i3bar+n3,3).eq.0.and.i3.eq.0)then
c        This is an epsilon index interaction
c            write(*,*) i3, n3, i3bar, n3bar, ires
            maxcolor=maxcolor+1
            icol(1,ires)=maxcolor
            if(n3.eq.2)then
               maxcolor=maxcolor+1
               icol(2,ires)=-maxcolor
            endif
         elseif(n3bar.gt.0.and.n3.eq.0.and.mod(i3+n3bar,3).eq.0.and.i3bar.eq.0)then
c        This is an epsilonbar index interaction
c            write(*,*) i3, n3, i3bar, n3bar, ires
            maxcolor=maxcolor+1
            icol(2,ires)=maxcolor
            if(n3.eq.2)then
               maxcolor=maxcolor+1
               icol(1,ires)=-maxcolor
            endif
         elseif(n3.gt.0.and.n3bar.eq.0.and.i3-i3bar.eq.n3.or.
     $          n3bar.gt.0.and.n3.eq.0.and.i3bar-i3.eq.n3bar.or.
     $          n3.eq.1.and.n3bar.eq.1.and.i3-i3bar.eq.0.or.
     $          n3.eq.0.and.n3bar.eq.0.and.i3-i3bar.eq.0.or.
     $      n3bar.gt.0.and.n3.eq.0.and.mod(i3+n3bar,3).eq.0.and.i3bar.ne.0.or.
     $      n3.gt.0.and.n3bar.eq.0.and.mod(i3bar+n3,3).eq.0.and.i3.ne.0)then
c        We have a previous epsilon which gives the wrong pop-up index
            call fix_s_color_indices(n3,n3bar,i3,i3bar,ncolmp,icolmp,
     $           ires,icol,is_colors)
         else
c           Don't know how to deal with this
            call write_error(1001,n3,n3bar)
         endif
      endif

      elim_indices=maxcolor
      
      return
      end

c*******************************************************************
      subroutine fix_s_color_indices(n3,n3bar,i3,i3bar,ncolmp,icolmp,
     $                             ires,icol,is_colors)
c*******************************************************************
c
c     Fix color flow if some particle has got the wrong pop-up color
c     due to epsilon-ijk vertices
c

      implicit none
      include 'nexternal.inc'
      integer n3,n3bar,ncolmp,icolmp(2,*),maxcolor
      integer ires,icol(2,-nexternal+2:2*nexternal-3)
      integer is_colors(2,nincoming)
      integer i,j,i3,i3bar
      integer max_n3,max_n3bar,min_n3,min_n3bar,maxcol,mincol

      icol(1,ires)=0
      icol(2,ires)=0
      
c      print *,'Colors: ',ncolmp,((icolmp(j,i),j=1,2),i=1,ncolmp)
c      print *,'n3,n3bar,i3,i3bar: ',n3,n3bar,i3,i3bar

c     Make sure that max and min don't come from the same octet
      call find_max_min(icolmp,ncolmp,max_n3,min_n3,
     $                   max_n3bar,min_n3bar,i3,i3bar,is_colors)
c      print *,'max3,min3bar,min3,max3bar: ',max_n3,min_n3bar,min_n3,max_n3bar

      if(n3.eq.1.and.n3bar.eq.0.and.i3-i3bar.eq.n3.or.
     $   n3bar.eq.1.and.n3.eq.0.and.i3bar-i3.eq.n3bar.or.
     $   n3bar.eq.1.and.n3.eq.1.and.i3bar-i3.eq.0.or.
     $   n3bar.eq.0.and.n3.eq.0.and.i3bar-i3.eq.0.or.
     $      n3bar.gt.0.and.n3.eq.0.and.mod(i3+n3bar,3).eq.0.and.i3bar.ne.0.or.
     $      n3.gt.0.and.n3bar.eq.0.and.mod(i3bar+n3,3).eq.0.and.i3.ne.0)then

      if ((i3.eq.2.or.i3bar.eq.2).and.(n3bar+n3.eq.1))then
c     Special case:
c     -------------------- (0,503)
c              g
c              g
c              g (504,505)
c
c    need to correct to 
c    -------------------------  (0,503)
c    (0,505)   g
c              g
c              g (503,505)
         if (i3.eq.2) then
            icol(1,ires) = max(icolmp(1,1), icolmp(1,2))
            icol(2,ires) = 0
            maxcol = max(icolmp(2,1), icolmp(2,2))
            mincol = min(icolmp(1,1), icolmp(1,2))
c           replace maxcol by mincol
         elseif (i3bar.eq.2) then
            icol(1,ires) = 0
            icol(2,ires) = max(icolmp(2,1), icolmp(2,2))
            maxcol = max(icolmp(1,1), icolmp(1,2))
            mincol = min(icolmp(2,1), icolmp(2,2))
         endif
c         write(*,*) "replace ", maxcol,"by",mincol
            do i=ires+1,nexternal
               do j=1,2
                  if(icol(j,i).eq.maxcol)
     $                 icol(j,i)=mincol
               enddo
            enddo            
        

      else
c     Replace the highest 3bar-index with the lowest 3-index,
c     or vice versa


         maxcol=max(max_n3,max_n3bar)
         if(maxcol.eq.max_n3) then
            mincol=min_n3bar
         else
            mincol=min_n3
         endif
         do i=ires,-1
            do j=1,2
               if(icol(j,i).eq.maxcol)
     $              icol(j,i)=mincol
            enddo
         enddo
c         print *,'Replaced ',maxcol,' with ',mincol
         if(max_n3.eq.maxcol)then
            if(n3.eq.1) icol(1,ires)=min_n3
            if(n3bar.eq.1) icol(2,ires)=max_n3bar
         else
            if(n3.eq.1) icol(1,ires)=max_n3
            if(n3bar.eq.1) icol(2,ires)=min_n3bar
         endif
c         print *,'Set mother color for ',ires,' to ',(icol(j,ires),j=1,2)
      endif
      else
c     Don't know how to deal with this
         call write_error(1001,n3,n3bar)
      endif       
      return
      end


      subroutine check_pure_internal_flow(icol,jpart, maxcolor)

      implicit none 
      include 'nexternal.inc'
      integer jpart(7,-nexternal+3:2*nexternal-3)
      integer icol(2,-nexternal+2:2*nexternal-3)
      integer maxcolor
      integer i,j,k,l
      logical found

c      do i=-nexternal+3,nexternal
c         write(*,*) i, icol(1,i), icol(2,i),(jpart(j,i) , j=1,3)
c      enddo
      do i=-nexternal+3,-1
         if (jpart(2,i).eq.0.or.jpart(3,i).eq.0) goto 20 ! not define mother -> continue
         if (icol(1,i).eq.1000.or.icol(2,i).eq.1000) goto 20 ! special color value -> continue
         do k = 1,2
            found=.false.
            do j=1,nexternal
               if(icol(k,i).eq.icol(1,j).or.icol(k,i).eq.icol(2,j))then
                  found=.true.
                  goto 10       ! break
               endif
            enddo
 10         continue
            if (.not.found)then
               call correct_external_flow_epsilon(icol, jpart, maxcolor,
     &              icol(k,i))
            endif
         enddo
 20      continue
      enddo
      return 
      end



      subroutine correct_external_flow_epsilon(icol, jpart, maxcolor, mincol)
c
c     for avoiding double epsilon problem
c
      implicit none
      include 'nexternal.inc'
      integer jpart(7,-nexternal+3:2*nexternal-3)
      integer maxcolor
      integer icol(2,-nexternal+2:2*nexternal-3)
      integer i,j,i3
      integer mincol ! the potential propagator linked to the two epsilon.
      integer k,l
      integer potential_index(2)
      integer epsilon_index(4)
      integer mothers(2*nexternal-3)
      logical to_change

C        In presence of two epsilon_ijk  connected by a flow we need to ensure that the 
C        the index of the non summed indices do not repeat each other
         l=0
         do i=-nexternal+3,2*nexternal-3
            if (icol(1,i).eq.mincol.or.icol(2,i).eq.mincol)then
               potential_index(1)=0
c               write(*,*) "particle",i,"has color index", mincol
               k=0 !index to see how many child we found so far
               do j=-nexternal+3,2*nexternal-3
                  if (jpart(2,j).eq.i.or.jpart(3,j).eq.i)then
c                     write(*,*) "find the child", j
                     if (icol(1,j).eq.mincol.or.icol(2,j).eq.mincol)then
                        potential_index(1)=0
c                        write(*,*) "the color", mincol, 
c     &       "is pass to one of the children ->no epsilon at this stage"
c                       the color flow is pass to a child so no need to do anything for this part/junction                        
                        goto 10 ! break
                     elseif(icol(1,j).ne.0) then
c             write(*,*) "child has not colour", mincol, "add", icol(1,j)
                        k = k+1
                        potential_index(k) = icol(1,j)
                        mothers(1) = i
                     elseif(icol(2,j).ne.0)then
c             write(*,*) "child has not colour", mincol, "add", icol(2,j)
                        k = k+1
                        potential_index(k) = icol(2,j)
                        mothers(1) = i 
                     else
                        call write_error(1001,0,0) 
                     endif
                  endif
               enddo
 10            continue
c              store the index of the final junction for this color 
c               write(*,*) "found", potential_index
               if (potential_index(1).ne.0) then
                  l = l+1
                  epsilon_index(l) = potential_index(1)
                  l = l+1
                  epsilon_index(l) = potential_index(2)
               endif
            endif
         enddo
C        Remove the duplication index if any 
         mothers(2) = 0
c        check the mother of mothers1 and change the color index
c        epsilon_index(3) -> maxcolor+1, epsilon_index(4) -> maxcolor+2          
c        then add info on mothers to recursively change
c        Firs check if we have to change  
         to_change = .false.
         do i=3,4
            do j=1,2
               if (epsilon_index(i).eq.epsilon_index(j))then
C     `         The index is duplicated need to change one
                  to_change = .true. 
               endif
            enddo
         enddo
         if (epsilon_index(4).eq.0) to_change = .false.
         if (to_change)then
         k=1
         do i =1, 2*nexternal-3
            if (mothers(i).eq.0)then 
               goto 20 !break
            endif
            do j=mothers(i)+1,2*nexternal-3
               if (jpart(2,j).eq.mothers(i).or.jpart(3,j).eq.mothers(i))then
                  if (icol(1,j).eq.epsilon_index(3))then
                     icol(1,j) = maxcolor + 1
                     k = k+1
                     mothers(k) = j
                     mothers(k+1) = 0
                  elseif (icol(2,j).eq.epsilon_index(3))then
                     icol(2,j) = maxcolor + 1
                     k = k+1
                     mothers(k) = j
                     mothers(k+1) = 0
                  elseif (icol(1,j).eq.epsilon_index(4))then
                     icol(1,j) = maxcolor + 2
                     k = k+1
                     mothers(k) = j
                     mothers(k+1) = 0
                  elseif (icol(2,j).eq.epsilon_index(4))then
                     icol(2,j) = maxcolor + 2
                     k = k+1
                     mothers(k) = j
                     mothers(k+1) = 0
                  endif
               endif
            enddo
         enddo
 20      continue
         maxcolor = maxcolor +2
      endif
      end

c*******************************************************************************
      subroutine find_max_min(icolmp,ncolmp,max3,min3,max3bar,min3bar,
     $     i3,i3bar,is_colors)
c*******************************************************************************
      implicit none
      include 'nexternal.inc'
      integer ncolmp,icolmp(2,*)
      integer is_colors(2,nincoming)
      integer i,j,k,max3,max3bar,min3,min3bar,i3,i3bar,i3now,i3barnow
      integer allpairs(2,nexternal),npairs,maxcol,mincol

      i3now=i3
      i3barnow=i3bar

c     Create all possible pairs (3,3bar) that
c     1. come from different octets, 2. are different, 
c     3. don't contain any color lines passing through the event
      npairs = 0
      do 20 i=1,ncolmp
         if(icolmp(1,i).eq.0) goto 20
         do k=1,nincoming
            if(icolmp(1,i).eq.is_colors(1,k)) goto 20
         enddo
         do 10 j=1,ncolmp
            if(i.eq.j.or.icolmp(2,j).eq.0.or.
     $           icolmp(1,i).eq.icolmp(2,j)) goto 10
            do k=1,nincoming
               if(icolmp(2,j).eq.is_colors(2,k)) goto 10
            enddo
            npairs=npairs+1
            allpairs(1,npairs)=icolmp(1,i)
            allpairs(2,npairs)=icolmp(2,j)
 10      enddo
 20   enddo

c      print *,'is_colors: ',((is_colors(i,j),i=1,2),j=1,nincoming)
c      print *,'pairs: ',((allpairs(i,j),i=1,2),j=1,npairs)

c     Find the pairs with maximum 3 and 3bar
      min3=1000
      min3bar=1000
      max3=0
      max3bar=0
      do i=1,npairs
         if(allpairs(1,i).gt.max3.and.
     $      (allpairs(2,i).lt.max3bar.or.
     $       allpairs(1,i).gt.allpairs(2,i)))then
            max3=allpairs(1,i)
            min3bar=allpairs(2,i)
         else if(allpairs(2,i).gt.max3bar.and.
     $           (allpairs(1,i).lt.max3.or.
     $            allpairs(2,i).gt.allpairs(1,i)))then
            max3bar=allpairs(2,i)
            min3=allpairs(1,i)
         endif
      enddo

c     Find "maximum" pairs with minimum 3 and 3bar
      do i=1,npairs
         if(allpairs(1,i).eq.max3.and.
     $        allpairs(2,i).lt.min3bar.and.
     $        allpairs(2,i).ne.max3bar)
     $        min3bar=allpairs(2,i)
         if(allpairs(2,i).eq.max3bar.and.
     $        allpairs(1,i).lt.min3.and.
     $        allpairs(1,i).ne.max3)
     $        min3=allpairs(1,i)
      enddo

c     Check that the pair are indeed different. Might not be the case if
c     The process contains some epsilon_ijk somewhere else.
      if (i3bar.gt.1.and.i3.gt.1)then
      if (max3bar.eq.min3bar)then
c        try to change min3bar
         min3bar=10000
         do i=1,npairs
c          search a new pair but with a different index!
           if(allpairs(1,i).eq.max3.and.
     $        allpairs(2,i).lt.min3bar.and.
     $        allpairs(2,i).ne.max3bar)then
              min3bar=allpairs(2,i)
              endif
         enddo
c        check if we found a new one. If not try to change the other index (max3bar)
         if (min3bar.eq.10000)then
            min3bar = max3bar
            max3bar = 0
c           search a new pair but with a different index!
            do i=1,npairs
               if(allpairs(1,i).eq.min3.and.
     $              allpairs(2,i).gt.max3bar.and.
     $              allpairs(2,i).ne.min3bar) then
                  max3bar = allpairs(2,i)
               endif
            enddo
c           This should not happen.
            if (max3bar.eq.0)then
               write(*,*) "colorflow problem"
               call write_error(1001,0,0) 
            endif
         endif
      endif
c     Doing the same but for the color index.
      if (max3.eq.min3)then
c        try to change min3
         min3=10000
         do i=1,npairs
           if(allpairs(2,i).eq.max3bar.and.
     $        allpairs(1,i).lt.min3.and.
     $        allpairs(1,i).ne.max3)then
              min3=allpairs(1,i)
              endif
         enddo
         if (min3.eq.10000)then
            min3 = max3 ! restore value
            max3 = 0
c         try to change max3
            do i=1,npairs
               if(allpairs(2,i).eq.min3bar.and.
     $              allpairs(1,i).gt.max3.and.
     $              allpairs(1,i).ne.min3) then
                  max3 = allpairs(1,i)
               endif
            enddo
            if (max3.eq.0)then
               write(*,*) "colorflow problem"
               stop
            endif
         endif
      endif
      endif

      if (max3.gt.0.and.max3bar.gt.0) then
c       We have found our two pairs, so we're done
         return
      endif

      if(max3.gt.0.or.max3bar.gt.0)then
         i3now=i3now-1
         i3barnow=i3barnow-1
      endif

c     Find pair for non-maximum (where we allow all colors)
      maxcol=max(max3,max3bar)
      if(maxcol.eq.max3) then
         mincol=min3bar
      else
         mincol=min3
      endif

      npairs=0
      do i=1,ncolmp
         if(icolmp(1,i).eq.0.and.i3now.gt.0) cycle
         if(icolmp(1,i).eq.maxcol.or.icolmp(1,i).eq.mincol)
     $        cycle
         do j=1,ncolmp
            if(icolmp(2,j).eq.0.and.i3barnow.gt.0) cycle
            if(i.eq.j.or.icolmp(1,i).eq.icolmp(2,j)) cycle
            if(icolmp(2,j).eq.maxcol.or.icolmp(2,j).eq.mincol)
     $           cycle
            npairs=npairs+1
            allpairs(1,npairs)=icolmp(1,i)
            allpairs(2,npairs)=icolmp(2,j)
         enddo
      enddo
      if(npairs.ge.1)then
         if(maxcol.eq.max3)then
            min3=allpairs(1,1)
            max3bar=allpairs(2,1)
         else
            max3=allpairs(1,1)
            min3bar=allpairs(2,1)            
         endif
      endif
      
c      print *,'allpairs: ',((allpairs(i,j),i=1,2),j=1,npairs)

      end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c      written by the UFO converter
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      SUBROUTINE COUP1()

      IMPLICIT NONE
      INCLUDE 'model_functions.inc'

      DOUBLE PRECISION PI, ZERO
      PARAMETER  (PI=3.141592653589793D0)
      PARAMETER  (ZERO=0D0)
      INCLUDE 'input.inc'
      INCLUDE 'coupl.inc'
      GC_109 = (MDL_CTQ1*MDL_COMPLEXI)/MDL_LAMBDA__EXP__2
      GC_110 = (MDL_CTQ8*MDL_COMPLEXI)/MDL_LAMBDA__EXP__2
      GC_112 = (MDL_CTU1*MDL_COMPLEXI)/MDL_LAMBDA__EXP__2
      GC_113 = (MDL_CTU8*MDL_COMPLEXI)/MDL_LAMBDA__EXP__2
      GC_30 = (MDL_CQQ11*MDL_COMPLEXI)/MDL_LAMBDA__EXP__2-(MDL_CQQ13
     $ *MDL_COMPLEXI)/MDL_LAMBDA__EXP__2
      GC_31 = (MDL_CQQ11*MDL_COMPLEXI)/MDL_LAMBDA__EXP__2+(MDL_CQQ13
     $ *MDL_COMPLEXI)/MDL_LAMBDA__EXP__2
      GC_32 = (MDL_CQQ1*MDL_COMPLEXI)/MDL_LAMBDA__EXP__2-(MDL_CQQ8
     $ *MDL_COMPLEXI)/(6.000000D+00*MDL_LAMBDA__EXP__2)
      GC_33 = (MDL_CQQ1*MDL_COMPLEXI)/MDL_LAMBDA__EXP__2+(MDL_CQQ8
     $ *MDL_COMPLEXI)/(3.000000D+00*MDL_LAMBDA__EXP__2)
      GC_34 = (MDL_CQQ81*MDL_COMPLEXI)/MDL_LAMBDA__EXP__2-(MDL_CQQ83
     $ *MDL_COMPLEXI)/MDL_LAMBDA__EXP__2
      GC_35 = (MDL_CQQ81*MDL_COMPLEXI)/MDL_LAMBDA__EXP__2+(MDL_CQQ83
     $ *MDL_COMPLEXI)/MDL_LAMBDA__EXP__2
      GC_71 = (MDL_CQD1*MDL_COMPLEXI)/MDL_LAMBDA__EXP__2
      GC_72 = (MDL_CQD8*MDL_COMPLEXI)/MDL_LAMBDA__EXP__2
      GC_83 = (MDL_CQQ8*MDL_COMPLEXI)/(2.000000D+00*MDL_LAMBDA__EXP__2)
      GC_85 = (MDL_CQT1*MDL_COMPLEXI)/MDL_LAMBDA__EXP__2
      GC_86 = (MDL_CQT8*MDL_COMPLEXI)/MDL_LAMBDA__EXP__2
      GC_87 = (MDL_CQU1*MDL_COMPLEXI)/MDL_LAMBDA__EXP__2
      GC_88 = (MDL_CQU8*MDL_COMPLEXI)/MDL_LAMBDA__EXP__2
      GC_89 = (MDL_CTD1*MDL_COMPLEXI)/MDL_LAMBDA__EXP__2
      GC_90 = (MDL_CTD8*MDL_COMPLEXI)/MDL_LAMBDA__EXP__2
      END

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c      written by the UFO converter
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      SUBROUTINE COUP2()

      IMPLICIT NONE
      INCLUDE 'model_functions.inc'

      DOUBLE PRECISION PI, ZERO
      PARAMETER  (PI=3.141592653589793D0)
      PARAMETER  (ZERO=0D0)
      INCLUDE 'input.inc'
      INCLUDE 'coupl.inc'
      GC_10 = -G
      GC_11 = MDL_COMPLEXI*G
      GC_12 = MDL_COMPLEXI*MDL_G__EXP__2
      GC_358 = (MDL_CTG*MDL_COMPLEXI*G*MDL_VEV0)/(MDL_LAMBDA__EXP__2
     $ *MDL_SQRT__2)
      GC_360 = -((MDL_CTG*MDL_G__EXP__2*MDL_VEV0)/(MDL_LAMBDA__EXP__2
     $ *MDL_SQRT__2))
      END

C     This File is Automatically generated by ALOHA 
C     The process calculated in this file is: 
C     Gamma(-1,2,-3)*Gamma(-1,4,-2)*ProjM(-2,3)*ProjP(-3,1)
C     
      SUBROUTINE FFFF24_0(F1, F2, F3, F4, COUP,VERTEX)
      IMPLICIT NONE
      COMPLEX*16 CI
      PARAMETER (CI=(0D0,1D0))
      COMPLEX*16 COUP
      COMPLEX*16 F1(*)
      COMPLEX*16 F2(*)
      COMPLEX*16 F3(*)
      COMPLEX*16 F4(*)
      COMPLEX*16 TMP1
      COMPLEX*16 VERTEX
      TMP1 = (F1(5)*F4(5)*(F2(3)*F3(3)+F2(4)*F3(4))+F1(6)*F4(6)*(F2(3)
     $ *F3(3)+F2(4)*F3(4)))
      VERTEX = COUP*(-2D0 * CI * TMP1)
      END

!
!     Module      : DiscreteSampler
!     Author      : Valentin Hirschi
!     Date        : 29.10.2014
!     Description : 
!              A relatively simple and flexible module to do
!              sampling of discrete dimensions for Monte-Carlo
!              purposes.
!
!     List of public subroutines and usage :
!
!     DS_initialize(tolerate_zero_grid, verbose)
!       :: Initializes the general options of the DiscreteSampler.
!       :: tolerate_zero_grid is a logical that specifies whether
!       :: DiscreteSampler should crash when asked to sample a dimension
!       :: of zero norm.
!       :: Verbose is another logical setting the verbosity of the
!       :: module.
!
!     DS_register_dimension(name, n_bins,(all_grid|void))
!       ::  Register a new dimension with its name and number of bins
!       ::  If all_grid is specified and set to False, then only a 
!       ::  running grid is specified, it is useful for registering
!       ::  grid intended for convolution only.
!
!     DS_remove_dimension(name)
!       ::  Removes and clear the dimension of input name
!
!     DS_print_global_info(name|index|void)
!       ::  Print global information on a registered information, using
!       ::  either its name or index. or all if none is selected
!     
!     DS_clear
!       ::  Reinitializes the module and all grid data
!
!     DS_binID(integer_ID)
!       ::  Creates an object of binID type from an integer ID. Notice
!       ::  that you can also use the assignment operator directly.
!
!     DS_add_bin(dimension_name, (binID|integerID|void))
!       ::  Add one bin to dimension of name dimension_name.
!       ::  The user can add an ID to the added bin or just use the
!       ::  default sequential labeling
!    
!     DS_remove_bin(dimension_name, (binID|integerID))
!       ::  Remove a bin in a dimension by either specfiying its index
!       ::  in this dimension or its binID (remember you can create a
!       ::  binID on the flight from an integer using the function
!       ::  DS_binID )
!
!     DS_add_entry(dimension_name, (binID|integerID), weight, (reset|void))
!       ::  Add a new weight to a certan bin (characterized by either
!       ::  its binID or the integer of the binID). If the dimension or
!       ::  the binID do not exist at the time of adding them, they will
!       ::  be registered on the flight. By setting the option 'reset'
!       ::  to '.True.' (default is '.False.'), you can chose to hardset
!       ::  the weight of this bin (with n_entries=min_bin_probing_points 
!       ::  then) instead of adding it.
!
!     DS_update_grid((dim_name|void))
!       ::  Update the reference grid of the dimension dim_name or 
!       ::  update all of them at the same time without argument.
!       ::  It uses the running grid for this and it reinitilizes it.
!
!     DS_write_grid((file_name|stream_id), (dim_name|void), (grid_type|void))
!       :: Append to file 'file_name' or a given stream the data for 
!       :: the current reference grid for dimension dim_name or
!       :: or all of them if called without dim_name.
!       :: You can specify grid_type to be written out to be either 'ref'
!       :: or 'run', and it is 'ref' by default.
!
!     DS_load_grid((file_name|stream_id), (dim_name|void))
!       :: Reset the run_grid for dimension dim_name and loads in
!       :: the data obtained from file 'file_name' or stream_id for this
!       :: dimension or all of them if called without dim_name.
!       :: The data is loaded in the running grid only (which is
!       :: re-initialized before this), so you have to call 
!       :: 'DS_update_grid' if you want it pased to the ref_grid.
!
!     DS_get_point(dim_name, random_variable, 
!       (binIDPicked|integerIDPicked), jacobian_weight, (mode|void),
!                                        (convoluted_grid_names|void))
!       :: From a given random variable in [0.0,1.0] and a dimension
!       :: name, this subroutine returns the picked bin or index and
!       :: the Jacobian weight associated.
!       :: The mode is by default 'norm' but can also be 'variance'
!       :: which means that the sampling is done either on the
!       :: variance in each bin or the absolute value of the weights.
!       :: mode == 'norm'
!       :: Jacobian = 1.0d0 / normalized_abs_wgt_in_selected_bin
!       :: mode == 'variance'
!       :: Jacobian = 1.0d0 / normalized_variance_in_selected_bin
!       :: mode == 'uniform'
!       :: Jacobian = 1.0d0 / n_bins_in_dimension
!       :: Setting the option 'convoluted_grid_names' to an array of
!       :: dimension names already registered in the module will have
!       :: the subroutine DS_get_point return a point sampled as the
!       :: grid 'dim_name' *convoluted with all grids specified in
!       :: convoluted_grid_names*.
!       :: Example:
!       ::  call DS_get_point('MyDim',0.02,out_binPicked,out_jac,mode='norm',
!       :: & convoluted_grid_names = (/'ConvolutionDim1','ConvolutionDim2'/))
! 
!     DS_set_min_points(min_point, (dim_name|void))
!       :: Sets the minimum number of points that must be used to probe
!       :: each bin of a particular dimension (or all if not specified) 
!       :: before DS_get_point uses a uniform sampling on the bins 
!       :: (possibly with convolution) when the reference grid is empty. 
!       :: By default it is 10.
!
!     DS_get_dim_status(dim_name)
!       :: Return an integer that specifies the status of a given dimension
!       :: dim_status = -1 : Dimension is not registered.
!       :: dim_status =  0 : Dimension exists but the reference grid is
!       ::                   empty and the running grid does not yet
!       ::                   have all its bins filled with min_point.
!       :: dim_status =  1 : Dimension exists with a non-empty 
!       ::                   reference grid and a running grid with all
!       ::                   bins filled with more than min_points entries.
!    
!     DS_set_grid_mode(grid_name,grid_mode)
!       :: Sets the kind of reference grid which is currently active.
!       :: grid_mode = 'default' : This means that the reference grid holds 
!       ::   the same kind of weights than the running grid. When the reference
!       ::   grid will be updated, the running grid will be *combined* with
!       ::   the reference grid, and not overwritten by it.
!       :: grid_mode = 'init' : This means that the reference grid is used for
!       ::   initialisation, and its weights do not compare with those put
!       ::   in the running grid. When updated, the reference grid will 
!       ::   therefore be *overwritten* by the running grid.
!
!
!     DS_get_damping_for_grid(grid_name, small_contrib, damping_power)
!       :: Returns the current value stored in the run grid for
!       :: dimension grid_name of what are the parameter damping the
!       :: bin with small contributions and whose Jacobian can
!       :: potentially be very large. See the definition of these 
!       :: parameters for a description of the procedure.
!
!     DS_set_damping_for_grid(grid_name, small_contrib, damping_power)
!       :: Sets the value for both the ref and running grid of the
!       :: dimension grid_name of what are the parameter damping the
!       :: bin with small contributions and whose Jacobian can
!       :: potentially be very large. See the definition of these 
!       :: parameters for a description of the procedure.
!
      module DiscreteSampler

      use StringCast

!     Global options for the module
      logical    DS_verbose
      save DS_verbose
      logical    DS_tolerate_zero_norm
      save DS_tolerate_zero_norm
!     An allocatable to mark initialization
      logical, dimension(:), allocatable  :: DS_isInitialized

!     This parameter sets how large must be the sampling bar when
!     displaying information about a dimension
      integer samplingBarWidth
      parameter (samplingBarWidth=80)

!     Attributes identifying a bin
!     For now just an integer
      type binID
        integer id
      endtype
!     And an easy way to create a binIDs
      interface assignment (=)
        module procedure  binID_from_binID
        module procedure  binID_from_integer
      end interface assignment (=)
!     Define and easy way of comparing binIDs 
      interface operator (==)
        module procedure  equal_binID
      end interface operator (==)

!     Information relevant to a bin
      type bin
        real*8 weight
!       Sum of the squared weights, to compute the variance
        real*8 weight_sqr
!       Sum of the absolute value of the weights put in this bin,
!       necessary when in presence of negative weights.
        real*8 abs_weight
        integer n_entries
!       Practical to be able to identify a bin by its id
        type(binID) bid
      endtype

!     Define and easy way of adding Bins 
      interface operator (+)
        module procedure  DS_combine_two_bins
      end interface operator (+)

      type sampledDimension
!       The grid_mode can take the following values
!       grid_mode = 1 : This means that the reference grid holds the
!         same kind of weights than the running grid. When the reference
!         grid will be updated, the running grid will be *combined* with
!         the reference grid, and not overwrite it.
!       grid_mode = 2 : This means that the reference grid is used for
!         initialisation, and its weights do not compare with those put
!         in the running grid. When updated, the reference grid will 
!         therefore be *overwritten* by the running grid.
        integer                               :: grid_mode
!
!       Treat specially bin with a contribution (i.e. weight) worth less than 
!       'small_contrib_threshold' of the averaged contributionover all bins.
!       For those, we sample according to the square root (or the specified power 
!       'damping power' of the difference between the reference value corresponding 
!       to the chosen mode and the small_contrib_threshold.
!       In this way, we are less sensitive to possible large fluctuations 
!       of very suppressed contributions for which the Jacobian would be 
!       really big. However, the square-root is such that a really
!       suppressed contribution at the level of numerical precision
!       would still never be probed.
!       Notice that this procedure does *not* change the weight in the
!       bin, but only how it is used for bin picking.
        real*8                                :: small_contrib_threshold
        real*8                                :: damping_power
!       Minimum number of points to probe each bin with when the reference
!       grid is empty. Once each bin has been probed that many times, the
!       subroutine DS_get_point will use a uniform distribution
        integer                               :: min_bin_probing_points
!       Keep track of the norm (i.e. sum of all weights) and the total
!       number of points for ease and optimisation purpose
        real*8                                :: norm
!       The sum of the absolute value of the weight in each bin
        real*8                                :: abs_norm
!       The sum of the variance of the weight in each bin
        real*8                                :: variance_norm
!       The sum of the squared weights in each bin
        real*8                                :: norm_sqr    
        integer                               :: n_tot_entries
!       A handy way of referring to the dimension by its name rather than
!       an index.
        character, dimension(:), allocatable  :: dimension_name
!       Bins of the grid
        type(bin) , dimension(:), allocatable :: bins
      endtype sampledDimension

!     This stores the overall discrete reference grid
      type(sampledDimension), dimension(:), allocatable :: ref_grid

!       This is the running grid, whose weights are being updated for each point
!       but not yet used for the sampling. The user must call the 'update'
!       function for the running grid to be merged to the reference one.
      type(sampledDimension), dimension(:), allocatable :: run_grid

      interface DS_add_entry
        module procedure DS_add_entry_with_BinID
        module procedure DS_add_entry_with_BinIntID
      end interface DS_add_entry ! DS_add_entry

      interface DS_print_global_info
        module procedure DS_print_dim_global_info_from_name
        module procedure DS_print_dim_global_info_from_void
      end interface ! DS_print_dim_global_info

      interface DS_add_bin
        module procedure DS_add_bin_with_binID
        module procedure DS_add_bin_with_IntegerID
        module procedure DS_add_bin_with_void
      end interface ! DS_add_bin

      interface DS_remove_bin
        module procedure DS_remove_bin_withIntegerID
        module procedure DS_remove_bin_withBinID
      end interface ! DS_remove_bin

      interface DS_get_bin
        module procedure DS_get_bin_from_binID
        module procedure DS_get_bin_from_binID_and_dimName
      end interface ! DS_get_bin

      interface DS_update_grid
        module procedure DS_update_grid_with_dim_name
        module procedure DS_update_all_grids
        module procedure DS_update_grid_with_dim_index
      end interface ! DS_update_grid

      interface DS_write_grid
        module procedure DS_write_grid_with_filename
        module procedure DS_write_grid_with_streamID
      end interface ! DS_write_grid

      interface DS_load_grid
        module procedure DS_load_grid_with_filename
        module procedure DS_load_grid_with_streamID
      end interface ! DS_load_grid

      interface DS_dim_index
        module procedure DS_dim_index_default
        module procedure DS_dim_index_with_force
        module procedure DS_dim_index_default_with_chararray
        module procedure DS_dim_index_with_force_with_chararray
      end interface ! DS_dim_index

      interface DS_bin_index
        module procedure DS_bin_index_default
        module procedure DS_bin_index_with_force
      end interface ! DS_bin_index

      interface DS_get_point
        module procedure DS_get_point_with_integerBinID
        module procedure DS_get_point_with_BinID
      end interface ! DS_get_point

      contains

!       ---------------------------------------------------------------
!       This subroutine is simply the logger of this module
!       ---------------------------------------------------------------
        subroutine DS_initialize(tolerate_zero_norm, verbose)
        implicit none
!         
!         Subroutine arguments
!         
          logical, optional, intent(in)            :: tolerate_zero_norm
          logical, optional, intent(in)            :: verbose 

          if (allocated(DS_isInitialized)) then
            write(*,*) "DiscreteSampler:: Error: The DiscreteSampler"//
     &        " module can only be initialized once."
            stop 1
          else
            allocate(DS_isInitialized(1))
          endif
          if (present(verbose)) then
            DS_verbose = verbose
          else
            DS_verbose = .False.
          endif

          if (present(tolerate_zero_norm)) then
            DS_tolerate_zero_norm = tolerate_zero_norm
          else
            DS_tolerate_zero_norm = .True.
          endif

!         Re-instore the if statement below if too annoying
!          if(DS_verbose) then
            write(*,*) ''
            write(*,*) '********************************************'
            write(*,*) '* You are using the DiscreteSampler module *'
            write(*,*) '*      part of the MG5_aMC framework       *'
            write(*,*) '*         Author: Valentin Hirschi         *'
            write(*,*) '********************************************'
            write(*,*) ''
!          endif

        end subroutine DS_initialize

!       ---------------------------------------------------------------
!       This subroutine is simply the logger of this module
!       ---------------------------------------------------------------

        subroutine DS_Logger(msg)
        implicit none
!         
!         Subroutine arguments
!         
          character(len=*), intent(in)        :: msg

          if (DS_verbose) write(*,*) msg

        end subroutine DS_Logger

!       ---------------------------------------------------------------
!       This subroutine clears the module and reinitialize all data 
!       ---------------------------------------------------------------
        subroutine DS_clear()
          call DS_deallocate_grid(ref_grid)
          call DS_deallocate_grid(run_grid)
        end subroutine DS_clear

        subroutine DS_deallocate_grid(grid)
          integer i
          type(sampledDimension), dimension(:), allocatable,
     &                                            intent(inout) :: grid
          if (allocated(grid)) then
            do i = 1,size(grid)
              if (allocated(grid(i)%bins)) then
                deallocate(grid(i)%bins)
              endif
              if (allocated(grid(i)%dimension_name)) then
                deallocate(grid(i)%dimension_name)
              endif
            enddo
            deallocate(grid)            
          endif
        end subroutine DS_deallocate_grid

!       ---------------------------------------------------------------
!       This subroutine takes care of registering a new dimension in
!       the DSampler module by characterizin it by its name and number
!       of bins.
!       ---------------------------------------------------------------
        subroutine DS_register_dimension(dim_name,n_bins,all_grids)
        implicit none
!         
!         Subroutine arguments
!        
          integer , intent(in)                :: n_bins
          character(len=*), intent(in)        :: dim_name
          logical , optional                  :: all_grids
!
!         Local variables
!
          logical                             :: do_all_grids
!
!         Begin code
!
!         Make sure the module is initialized
          if (.not.allocated(DS_isInitialized)) then
              call DS_initialize()
          endif
          if (present(all_grids)) then
            do_all_grids = all_grids
          else
            do_all_grids = .True.
          endif
          if (do_all_grids) then
            call DS_add_dimension_to_grid(ref_grid, dim_name, n_bins)
          endif
          call DS_add_dimension_to_grid(run_grid, dim_name, n_bins)

          call DS_Logger("DiscreteSampler:: Successfully registered "//
     $    "dimension '"//dim_name//"' ("//TRIM(toStr(n_bins))//' bins)')

        end subroutine DS_register_dimension

!       ---------------------------------------------------------------
!       This subroutine registers a dimension to a given grid 
!       ---------------------------------------------------------------
        subroutine DS_add_dimension_to_grid(grid, dim_name, n_bins)
        implicit none
!         
!         Subroutine arguments
!
          type(sampledDimension), dimension(:), allocatable,
     &      intent(inout)                          :: grid
          integer , intent(in)                     :: n_bins
          character(len=*), intent(in)             :: dim_name
!
!         Local variables
!
          integer                                           :: dim_index
          type(sampledDimension), dimension(:), allocatable :: tmp
          integer i
!
!         Begin code
!
!         Make sure the module is initialized
          if (.not.allocated(DS_isInitialized)) then
              call DS_initialize()
          endif
          if(allocated(grid)) then
            dim_index = DS_dim_index(grid,dim_name,.True.)
            if (dim_index.ne.-1) then
               write(*,*) 'DiscreteSampler:: Error, the dimension'//
     $              " with name '"//dim_name//"' is already registered."
               stop 1
            endif
          endif

!         Either allocate the discrete grids or append a dimension 
          if (allocated(grid)) then
            allocate(tmp(size(grid)))
            do i=1, size(grid)
              call DS_copy_dimension(grid(i), tmp(i))
            enddo
            call DS_deallocate_grid(grid)
            allocate(grid(size(tmp)+1))
            do i=1, size(tmp)
              call DS_copy_dimension(tmp(i), grid(i))
            enddo
            call DS_deallocate_grid(tmp)
          else
            allocate(grid(1))
          endif
!         Now we can fill in the appended element with the
!         characteristics of the dimension which must be added
          allocate(grid(size(grid))%bins(n_bins))
          allocate(grid(size(grid))%dimension_name(len(dim_name)))
!         Initialize the values of the grid with default
          call DS_initialize_dimension(grid(size(grid)))
!         For the string assignation, I have to it character by
!         character.
          do i=1, len(dim_name)
            grid(size(grid))%dimension_name(i) = dim_name(i:i)
          enddo

        end subroutine DS_add_dimension_to_grid

!       ----------------------------------------------------------------------
!       Copy a dimension from source to target, making sure to allocate  
!       ----------------------------------------------------------------------
        subroutine DS_copy_dimension(source, trget)
          type(sampledDimension), intent(out)   :: trget
          type(sampledDimension), intent(in)    :: source
          integer i

          if (allocated(trget%bins)) then
            deallocate(trget%bins)
          endif
          allocate(trget%bins(size(source%bins)))
          do i=1,size(source%bins)
            call DS_copy_bin(source%bins(i),trget%bins(i))
          enddo
          if (allocated(trget%dimension_name)) then
            deallocate(trget%dimension_name)
          endif
          allocate(trget%dimension_name(size(source%dimension_name)))
          do i=1, size(source%dimension_name)
            trget%dimension_name(i) = source%dimension_name(i)
          enddo
          trget%norm                    = source%norm
          trget%abs_norm                = source%abs_norm
          trget%variance_norm           = source%variance_norm
          trget%norm_sqr                = source%norm_sqr
          trget%n_tot_entries           = source%n_tot_entries 
          trget%min_bin_probing_points  = source%min_bin_probing_points
          trget%grid_mode               = source%grid_mode
          trget%damping_power           = source%damping_power
          trget%small_contrib_threshold = source%small_contrib_threshold
        end subroutine DS_copy_dimension

!       ----------------------------------------------------------------------
!       This subroutine removes a dimension at index dim_index from a given grid 
!       ----------------------------------------------------------------------
        subroutine DS_remove_dimension(dim_name)
        implicit none
!         
!         Subroutine arguments
!
          character(len=*), intent(in) :: dim_name
!
!         Local variables
!
          integer         :: ref_dim_index, run_dim_index
!
!         Begin code
!
          ref_dim_index = DS_dim_index(ref_grid, dim_name)
          run_dim_index = DS_dim_index(run_grid, dim_name)
          call DS_remove_dimension_from_grid(ref_grid, ref_dim_index)
          call DS_remove_dimension_from_grid(run_grid, run_dim_index)
        end subroutine DS_remove_dimension
!

!       ----------------------------------------------------------------------
!       This subroutine removes a dimension at index dim_index from a given grid 
!       ----------------------------------------------------------------------
        subroutine DS_remove_dimension_from_grid(grid, dim_index)
        implicit none
!         
!         Subroutine arguments
!
          type(sampledDimension), dimension(:), allocatable,
     &      intent(inout)                          :: grid
          integer, intent(in)                      :: dim_index
!
!         Local variables
!
          type(sampledDimension), dimension(:), allocatable :: tmp
          integer i
!
!         Begin code
!

          allocate(tmp(size(grid)-1))
          do i=1,dim_index-1
            call DS_copy_dimension(grid(i), tmp(i))
          enddo
          do i=dim_index+1,size(grid)
            call DS_copy_dimension(grid(i), tmp(i-1))
          enddo
          call DS_deallocate_grid(grid)
          allocate(grid(size(tmp)))
          do i=1,size(tmp)
            call DS_copy_dimension(tmp(i), grid(i))
          enddo
          call DS_deallocate_grid(tmp)
        end subroutine DS_remove_dimension_from_grid

!       ---------------------------------------------------------------
!       This subroutine takes care of reinitializing a given dimension
!       with default values
!       ---------------------------------------------------------------
        subroutine DS_reinitialize_dimension(d_dim)
        implicit none
!         
!         Subroutine arguments
!
          type(sampledDimension), intent(inout) :: d_dim 
!
!         Local variables
!

          integer i
!
!         Begin code
!
          do i=1, size(d_dim%bins)
            call DS_reinitialize_bin(d_dim%bins(i))
          enddo
          d_dim%norm_sqr        = 0.0d0
          d_dim%abs_norm        = 0.0d0
          d_dim%variance_norm   = 0.0d0
          d_dim%norm            = 0.0d0
          d_dim%n_tot_entries   = 0

        end subroutine DS_reinitialize_dimension

!       ---------------------------------------------------------------
!       This subroutine takes care of initializing a given dimension
!       with default values
!       ---------------------------------------------------------------
        subroutine DS_initialize_dimension(d_dim)
        implicit none
!         
!         Subroutine arguments
!
          type(sampledDimension), intent(inout) :: d_dim 
!
!         Local variables
!

          integer i
!
!         Begin code
!
          call DS_reinitialize_dimension(d_dim)
          do i=1, size(d_dim%bins)
            call DS_initialize_bin(d_dim%bins(i))
          enddo
          do i= 1, len(d_dim%dimension_name)
            d_dim%dimension_name(i:i) = ' '
          enddo
!         By default require each bin to be probed by 10 points
!         before a uniform distribution is used when the reference grid
!         is empty
          d_dim%min_bin_probing_points  = 10
          d_dim%grid_mode               = 1
!         Turn off the damping of small contributions by default
          d_dim%small_contrib_threshold = 0.0d0
          d_dim%damping_power           = 0.5d0
!         By default give sequential ids to the bins
          do i=1, size(d_dim%bins)
            d_dim%bins(i)%bid = i
          enddo
        end subroutine DS_initialize_dimension

!       ---------------------------------------------------------------
!       This subroutine takes care of reinitializing a given bin 
!       ---------------------------------------------------------------
        subroutine DS_initialize_bin(d_bin)
        implicit none
!         
!         Subroutine arguments
!
          type(bin), intent(inout) :: d_bin
!
!         Begin code
!
          call DS_reinitialize_bin(d_bin)
          d_bin%bid         = 0
        end subroutine DS_initialize_bin

!       ---------------------------------------------------------------
!       This subroutine takes care of initializing a given bin 
!       ---------------------------------------------------------------
        subroutine DS_reinitialize_bin(d_bin)
        implicit none
!         
!         Subroutine arguments
!
          type(bin), intent(inout) :: d_bin
!
!         Begin code
!
          d_bin%weight_sqr = 0.0d0
          d_bin%abs_weight = 0.0d0          
          d_bin%weight     = 0.0d0
          d_bin%n_entries  = 0
        end subroutine DS_reinitialize_bin

!       ---------------------------------------------------------------
!       Set the minimum number of point for which the bins must be
!       probed before a uniform distribution is used when the reference
!       grid is empty
!       ---------------------------------------------------------------
        subroutine DS_set_min_points(min_points, dim_name)
        implicit none
!         
!         Subroutine arguments
!
!     
          integer, intent(in)                      :: min_points
          character(len=*), intent(in), optional   :: dim_name
!
!         Local variables
!
          integer i
!
!         Begin Code
!
          if(present(dim_name)) then
            ref_grid(DS_dim_index(ref_grid,dim_name))%
     &                               min_bin_probing_points = min_points
            run_grid(DS_dim_index(ref_grid,dim_name))% 
     &                               min_bin_probing_points = min_points
          else
            do i=1,size(ref_grid)
              ref_grid(i)%min_bin_probing_points = min_points
              run_grid(i)%min_bin_probing_points = min_points
            enddo
          endif
        end subroutine DS_set_min_points

!       ---------------------------------------------------------------
!       Returns an integer that specifies the status of a given dimension
!       dim_status = -1 : Dimension is not registered.
!       dim_status =  0 : Dimension exists but the reference grid is
!                         empty and the running grid does not yet
!                         have all its bins filled with min_point.
!       dim_status =  1 : Dimension exists with a non-empty 
!                         reference grid and a running grid with all
!                         bins filled with more than min_points entries.
!       ---------------------------------------------------------------
        function DS_get_dim_status(grid_name)
        implicit none
!         
!         Function arguments
!
          character(len=*), intent(in)     :: grid_name
          integer                          :: DS_get_dim_status
!
!         Local variables
!
          integer                           :: ref_grid_index
          integer                           :: run_grid_index
          integer                           :: int_grid_mode
          type(Bin)                         :: mRunBin
          integer                           :: i
!         
!         Begin code
!
          ref_grid_index = DS_dim_index(ref_grid, grid_name, .True.)
          run_grid_index = DS_dim_index(run_grid, grid_name, .True.)
          if (ref_grid_index.eq.-1.or.run_grid_index.eq.-1) then
            DS_get_dim_status = -1
            return
          endif
          if (ref_grid(ref_grid_index)%n_tot_entries.ne.0) then
            DS_get_dim_status = 1
            return
          endif    
         
!         If the running grid has zero entries, then consider the grid
!         uninitialized
          if(size(run_grid(run_grid_index)%bins).eq.0) then
            DS_get_dim_status = 0
            return
          endif

          do i=1,size(ref_grid(ref_grid_index)%bins)
            mRunBin = DS_get_bin(run_grid(run_grid_index)%bins,
     &                             ref_grid(ref_grid_index)%bins(i)%bid)
            if (mRunBin%n_entries.lt.ref_grid(ref_grid_index)
     &                                    %min_bin_probing_points) then
              DS_get_dim_status = 0
              return
            endif
          enddo

          DS_get_dim_status = 1
          return
        end function DS_get_dim_status

!       ---------------------------------------------------------------
!       Access function to modify the damping parameters of small
!       contributions
!       ---------------------------------------------------------------
        subroutine DS_set_damping_for_grid(grid_name, in_small_contrib,
     &                                                 in_damping_power)
        implicit none
!         
!         Subroutine arguments
!
          character(len=*), intent(in)     :: grid_name          
          real*8, intent(in)               :: in_small_contrib
          real*8, intent(in)               :: in_damping_power
!
!         Local variables
!
          integer                          :: ref_grid_index
          integer                          :: run_grid_index
!         
!         Begin code
!
          ref_grid_index = DS_dim_index(ref_grid, grid_name, .True.)
          if (ref_grid_index.eq.-1) then
            write(*,*) "DiscreteSampler:: Error in 'DS_set_damping_"//
     &        "for_grid', dimension '"//grid_name//"' could not be"//
     &        " found in the reference grid."
              stop 1
          endif
          run_grid_index = DS_dim_index(run_grid, grid_name, .True.)
          if (run_grid_index.eq.-1) then
            write(*,*) "DiscreteSampler:: Error in 'DS_set_damping_"//
     &        "for_grid', dimension '"//grid_name//"' could not be"//
     &        " found in the running grid."
              stop 1
          endif

!         Limit arbitrarily at 50% because anything above that really
!         breaks the assumption of a small grid deformation not 
!         significantly affecting the averaged contribution taked as
!         a threshold.
          if (in_small_contrib.lt.0.0d0.or.
     &                                  in_small_contrib.gt.0.5d0) then
            write(*,*) "The small relative contribution threshold "//
     &      toStr_real_with_ndig(in_small_contrib,3) 
     &      //") given in argument of the function 'DS_set_damping_"//
     &      "for_grid' must be >=0.0 and <= 0.5."
            stop 1
          endif

          if (in_damping_power.lt.0.0d0.or.
     &                                  in_damping_power.gt.1.0d0) then
            write(*,*) "The damping power ("//
     &      toStr_real_with_ndig(in_damping_power,3) 
     &      //") given in argument of the function 'DS_set_damping_"//
     &      "for_grid' must be >= 0.0 and <= 1.0."
            stop 1
          endif

          ref_grid(ref_grid_index)%small_contrib_threshold = 
     &                                                  in_small_contrib
          ref_grid(ref_grid_index)%damping_power = in_damping_power
          run_grid(run_grid_index)%small_contrib_threshold = 
     &                                                  in_small_contrib
          run_grid(run_grid_index)%damping_power = in_damping_power
        end subroutine DS_set_damping_for_grid

!       ---------------------------------------------------------------
!       Access function to access the damping parameters for small
!       contributions stored in the reference grid
!       ---------------------------------------------------------------
        subroutine DS_get_damping_for_grid(grid_name, out_small_contrib,
     &                                                out_damping_power)
        implicit none
!         
!         Subroutine arguments
!
          character(len=*), intent(in)      :: grid_name          
          real*8, intent(out)               :: out_small_contrib
          real*8, intent(out)               :: out_damping_power        
!
!         Local variables
!
          integer                           :: run_grid_index
!         
!         Begin code
!
          run_grid_index = DS_dim_index(run_grid, grid_name, .True.)
          if (run_grid_index.eq.-1) then
            write(*,*) "DiscreteSampler:: Error in 'DS_get_damping_"//
     &        "for_grid', dimension '"//grid_name//"' could not be"//
     &        " found in the running grid."
              stop 1
          endif

          out_small_contrib = run_grid(run_grid_index)%
     &                                           small_contrib_threshold
          out_damping_power = run_grid(run_grid_index)%damping_power

        end subroutine DS_get_damping_for_grid

!       ---------------------------------------------------------------
!       Access function to modify the mode of the reference grid:
!       grid_mode = 'default' : This means that the reference grid holds 
!         the same kind of weights than the running grid. When the reference
!         grid will be updated, the running grid will be *combined* with
!         the reference grid, and not overwritten by it.
!       grid_mode = 'init' : This means that the reference grid is used for
!         initialisation, and its weights do not compare with those put
!         in the running grid. When updated, the reference grid will 
!         therefore be *overwritten* by the running grid.
!       ---------------------------------------------------------------
        subroutine DS_set_grid_mode(grid_name, grid_mode)
        implicit none
!         
!         Subroutine arguments
!
          character(len=*), intent(in)     :: grid_mode
          character(len=*), intent(in)     :: grid_name          
!
!         Local variables
!
          integer                           :: ref_grid_index
          integer                           :: int_grid_mode
!         
!         Begin code
!
          ref_grid_index = DS_dim_index(ref_grid, grid_name, .True.)
          if (ref_grid_index.eq.-1) then
            write(*,*) 'DiscreteSampler:: Error in DS_set_grid_mode, '//
     &        "dimension '"//grid_name//"' could not be found in the "//
     &        "reference grid."
              stop 1
          endif
          if (grid_mode.eq.'init') then
            int_grid_mode=2
          elseif (grid_mode.eq.'default') then
            int_grid_mode=1
          else
            write(*,*) 'DiscreteSampler:: Error in DS_set_grid_mode, '//
     &        " grid_mode '"//grid_mode//"' not recognized. It must "//
     &        " be one of the following: 'default', 'init'."
              stop 1
          endif

!         Notice that we don't change the mode of the running_grid
!         because in this way, after any DS_update() is done, the
!         ref_grid will automatically turn its mode to 'default' because
!         it inherits the attribute of the running grid. 
!         However, if the running grid was loaded from a saved grid file
!         then it might be that the run_grid also has the grid_mode set
!         to 'initialization' which will then correctly be copied to the
!         ref_grid after the DS_update() performed at the end of
!         DS_load() which correctly reproduce the state of the
!         DiscreteSampler module at the time it wrote the grids.
          ref_grid(ref_grid_index)%grid_mode = int_grid_mode
        end subroutine DS_set_grid_mode

!       ---------------------------------------------------------------
!       Dictionary access-like subroutine to obtain a grid from its name
!       ---------------------------------------------------------------

        function DS_get_dimension(grid, dim_name)
        implicit none
!         
!         Function arguments
!
          type(sampledDimension), dimension(:), intent(in), allocatable
     &                                  :: grid
          character(len=*), intent(in)  :: dim_name
          type(sampledDimension)        :: DS_get_dimension
!
!         Begin code
!
          DS_get_dimension = grid(DS_dim_index(grid,dim_name))
        end function DS_get_dimension

!       ---------------------------------------------------------------
!       Returns the index of a bin with mBinID in the list bins
!       ---------------------------------------------------------------
        function DS_bin_index_default(bins, mBinID)
        implicit none
!         
!         Function arguments
!
          type(Bin), dimension(:), intent(in)  
     &                                  :: bins
          type(BinID)                   :: mBinID
          integer                       :: DS_bin_index_default
!
!         Begin code
!
          DS_bin_index_default = DS_bin_index_with_force(bins,mBinID,
     &                                                          .False.)
        end function DS_bin_index_default

        function DS_bin_index_with_force(bins, mBinID,force)
        implicit none
!         
!         Function arguments
!
          type(Bin), dimension(:), intent(in)  
     &                                  :: bins
          type(BinID)                   :: mBinID
          integer                       :: DS_bin_index_with_force
          logical                       :: force
!
!         Local variables
!
          integer i
!
!         Begin code
!
!         For efficiency first look at index mBinID%id
          if (size(bins).ge.mBinID%id) then
            if (bins(mBinID%id)%bid==mBinID) then
              DS_bin_index_with_force = mBinID%id
              return
            endif
          endif
          
          DS_bin_index_with_force = -1
          do i = 1, size(bins)
            if (bins(i)%bid==mBinID) then
              DS_bin_index_with_force = i
              return              
            endif
          enddo
          if (DS_bin_index_with_force.eq.-1.and.(.not.Force)) then
            write(*,*) 'DiscreteSampler:: Error in function bin_index'//
     &        "(), bin with BinID '"//trim(DS_toStr(mBinID))
     &        //"' not found."
            stop 1
          endif
        end function DS_bin_index_with_force

!       ---------------------------------------------------------------
!       Functions of the interface get_bin facilitating the access to a
!       given bin.
!       ---------------------------------------------------------------
        
        function DS_get_bin_from_binID(bins, mBinID)
        implicit none
!         
!         Function arguments
!
          type(Bin), dimension(:), intent(in)  
     &                                  :: bins
          type(BinID)                   :: mBinID
          type(Bin)                     :: DS_get_bin_from_binID
!
!         Local variables
!
          integer i
!
!         Begin code
!
          DS_get_bin_from_binID = bins(DS_bin_index(bins,mBinID))
        end function DS_get_bin_from_binID

        function DS_get_bin_from_binID_and_dimName(grid, dim_name,
     &                                                          mBinID)
        implicit none
!         
!         Function arguments
!
          type(sampledDimension), dimension(:), intent(in), allocatable
     &                                  :: grid
          character(len=*), intent(in)  :: dim_name
          type(BinID)                   :: mBinID
          type(Bin)             :: DS_get_bin_from_binID_and_dimName
!
!         Local variables
!
          integer i
          type(SampledDimension)        :: m_dim
!
!         Begin code
!
          m_dim = DS_get_dimension(grid,dim_name)
          DS_get_bin_from_binID_and_dimName = DS_get_bin_from_binID(
     &                  m_dim%bins,mBinID)
        end function DS_get_bin_from_binID_and_dimName


!       ---------------------------------------------------------------
!       Add a new weight to a certan bin (characterized by either its 
!       binID or index)
!       ---------------------------------------------------------------
        subroutine DS_add_entry_with_BinID(dim_name, mBinID, weight,
     &                                                            reset)
          implicit none
!         
!         Subroutine arguments
!
          character(len=*), intent(in)  :: dim_name
          type(BinID)                   :: mBinID
          real*8                        :: weight
          logical, optional             :: reset
!
!         Local variables
!
          integer dim_index, bin_index
          type(Bin)                     :: newBin
          integer                       :: n_entries
          logical                       :: opt_reset          
!
!         Begin code
!
          if (present(reset)) then
            opt_reset = reset
          else
            opt_reset = .False.
          endif

          dim_index = DS_dim_index(run_grid, dim_name, .TRUE.)
          if (dim_index.eq.-1) then
              call DS_Logger('Dimension  '//dim_name//
     &        ' does not exist in the run grid. Creating it now.')
              call DS_register_dimension(dim_name,0)
              dim_index = DS_dim_index(run_grid, dim_name)
          endif

          bin_index = DS_bin_index(
     &                           run_grid(dim_index)%bins,mBinID,.TRUE.)
          if (bin_index.eq.-1) then
              call DS_Logger('Bin with binID '//trim(DS_toStr(mBinID))//
     &        ' does not exist in the run grid. Creating it now.')
              call DS_reinitialize_bin(newBin)
              newBin%bid = mBinID
              call DS_add_bin_to_bins(run_grid(dim_index)%bins,newBin)
              bin_index = DS_bin_index(run_grid(dim_index)%bins,mBinID)
          endif

!         First remove bin from global cumulative information in the grid
          run_grid(dim_index)%norm = run_grid(dim_index)%norm -
     &                   run_grid(dim_index)%bins(bin_index)%weight
          run_grid(dim_index)%norm_sqr = run_grid(dim_index)%norm_sqr -
     &                   run_grid(dim_index)%bins(bin_index)%weight_sqr
          run_grid(dim_index)%abs_norm = run_grid(dim_index)%abs_norm -
     &                   run_grid(dim_index)%bins(bin_index)%abs_weight
          run_grid(dim_index)%variance_norm = 
     &              run_grid(dim_index)%variance_norm -
     &              DS_bin_variance(run_grid(dim_index)%bins(bin_index))
          run_grid(dim_index)%n_tot_entries = 
     &              run_grid(dim_index)%n_tot_entries -
     &                     run_grid(dim_index)%bins(bin_index)%n_entries
!         Update the information directly stored in the bin
          if(.not.opt_reset) then
            n_entries = run_grid(dim_index)%bins(bin_index)%n_entries
            run_grid(dim_index)%bins(bin_index)%weight = 
     &        (run_grid(dim_index)%bins(bin_index)%weight*n_entries
     &                                           + weight)/(n_entries+1)
            run_grid(dim_index)%bins(bin_index)%weight_sqr = 
     &        (run_grid(dim_index)%bins(bin_index)%weight_sqr*n_entries
     &                                        + weight**2)/(n_entries+1)
            run_grid(dim_index)%bins(bin_index)%abs_weight = 
     &        (run_grid(dim_index)%bins(bin_index)%abs_weight*n_entries
     &                                      + abs(weight))/(n_entries+1)
            run_grid(dim_index)%bins(bin_index)%n_entries = n_entries+1
          else
            run_grid(dim_index)%bins(bin_index)%weight = weight
            run_grid(dim_index)%bins(bin_index)%weight_sqr = weight**2
            run_grid(dim_index)%bins(bin_index)%abs_weight = abs(weight)
            run_grid(dim_index)%bins(bin_index)%n_entries = 
     &                       run_grid(dim_index)%min_bin_probing_points
          endif
!         Now add the bin information back to the info in the grid
          run_grid(dim_index)%norm = run_grid(dim_index)%norm +
     &                   run_grid(dim_index)%bins(bin_index)%weight
          run_grid(dim_index)%norm_sqr = run_grid(dim_index)%norm_sqr +
     &                   run_grid(dim_index)%bins(bin_index)%weight_sqr
          run_grid(dim_index)%abs_norm = run_grid(dim_index)%abs_norm +
     &                   run_grid(dim_index)%bins(bin_index)%abs_weight
          run_grid(dim_index)%variance_norm = 
     &              run_grid(dim_index)%variance_norm +
     &              DS_bin_variance(run_grid(dim_index)%bins(bin_index))
          run_grid(dim_index)%n_tot_entries = 
     &              run_grid(dim_index)%n_tot_entries +
     &                     run_grid(dim_index)%bins(bin_index)%n_entries

        end subroutine DS_add_entry_with_BinID

        subroutine DS_add_entry_with_BinIntID(dim_name, BinIntID,
     &                                                weight, reset)
          implicit none
!         
!         Subroutine arguments
!
          character(len=*), intent(in)  :: dim_name
          integer                       :: BinIntID
          real*8                        :: weight
          logical, optional             :: reset          
!
!         Begin code
!
          if (present(reset)) then
            call DS_add_entry_with_BinID(dim_name, DS_BinID(BinIntID),
     &                                                    weight, reset)
          else
            call DS_add_entry_with_BinID(dim_name, DS_BinID(BinIntID),
     &                                                           weight)
          endif
        end subroutine DS_add_entry_with_BinIntID

!       ---------------------------------------------------------------
!       Prints out all informations for dimension of index d_index, or
!       name d_name.
!       ---------------------------------------------------------------
        subroutine DS_print_dim_global_info_from_void()
          integer i
          if(allocated(ref_grid).and.allocated(run_grid)) then
            do i = 1, size(ref_grid)
              call DS_print_dim_global_info_from_name(
     &                          trim(toStr(ref_grid(i)%dimension_name)))
            enddo
          else
            write(*,*) 'DiscreteSampler:: No dimension setup yet.'
          endif
        end subroutine DS_print_dim_global_info_from_void

        subroutine DS_print_dim_global_info_from_name(d_name)
        implicit none

!         Function arguments
!
          character(len=*), intent(in) :: d_name
!
!         Local variables
!
          integer n_bins, ref_dim_index, run_dim_index
!
!         Begin code
!
!         The running grid and ref grid must have the same number of
!         bins at this stage

          if(.not.(allocated(ref_grid).and.allocated(run_grid))) then
            write(*,*) 'DiscreteSampler:: No dimension setup yet.'
            return
          endif

          ref_dim_index = DS_dim_index(ref_grid,d_name,.TRUE.)
          run_dim_index = DS_dim_index(run_grid,d_name,.TRUE.)

          if (ref_dim_index.ne.-1) then
            n_bins = size(ref_grid(DS_dim_index(ref_grid,d_name))%bins)
          elseif (run_dim_index.ne.-1) then
            n_bins = size(run_grid(DS_dim_index(run_grid,d_name))%bins)
          else
            write(*,*) 'DiscreteSampler:: No grid registered for name'//
     &        " '"//d_name//"'."
            return
          endif  

          write(*,*) "DiscreteSampler:: ========================"//
     &       "=========================="
          write(*,*) "DiscreteSampler:: Information for dimension '"//
     &                     d_name//"' ("//trim(toStr(n_bins))//" bins):"
          write(*,*) "DiscreteSampler:: -> Grids status ID : "//
     &                            trim(toStr(DS_get_dim_status(d_name)))
          if (ref_dim_index.ne.-1) then
            write(*,*) "DiscreteSampler:: || Reference grid "
            select case(ref_grid(ref_dim_index)%grid_mode)
              case(1)
                write(*,*) "DiscreteSampler::   -> Grid mode : default"
              case(2)
                write(*,*) "DiscreteSampler::   -> Grid mode : "//
     &            "initialization"
            end select
            call DS_print_dim_info(ref_grid(ref_dim_index))
          else
            write(*,*) "DiscreteSampler:: || No reference grid for "//
     &         "that dimension."
          endif
          if (run_dim_index.ne.-1) then
            write(*,*) "DiscreteSampler:: || Running grid "
            write(*,*) "DiscreteSampler::   -> Initialization "//
     &        "minimum points : "//trim(toStr(run_grid(
     &                           run_dim_index)%min_bin_probing_points))
            call DS_print_dim_info(run_grid(run_dim_index))
          else
            write(*,*) "DiscreteSampler:: || No running grid for "//
     &         "that dimension."
          endif
          write(*,*) "DiscreteSampler:: ========================"//
     &       "=========================="
        end subroutine DS_print_dim_global_info_from_name

!       ---------------------------------------------------------------
!       Print all informations related to a specific sampled dimension
!       in a given grid
!       ---------------------------------------------------------------
        subroutine DS_print_dim_info(d_dim)
        implicit none
!         
!         Function arguments
!
          type(sampledDimension), intent(in)  :: d_dim
!
!         Local variables
!
          integer i,j, curr_pos1, curr_pos2, curr_pos3
          integer n_bins, bin_width
!         Adding the minimum size for the separators '|' and binID assumed
!         of being of length 2 at most, so 10*2+11 and + 20 security :)

          character(samplingBarWidth+10*2+11+20)       :: samplingBar1
          character(samplingBarWidth+10*2+11+20)       :: samplingBar2
          character(samplingBarWidth+10*2+11+20)       :: samplingBar3
          real*8            :: tot_entries, tot_variance, tot_abs_weight
!
!         Begin code
!
!
!         Setup the sampling bars
!
          tot_entries = 0
          tot_variance = 0.0d0
          tot_abs_weight = 0.0d0
          do i=1,min(size(d_dim%bins),10)
            tot_entries = tot_entries + d_dim%bins(i)%n_entries
            tot_variance = tot_variance + DS_bin_variance(d_dim%bins(i))
            tot_abs_weight = tot_abs_weight + d_dim%bins(i)%abs_weight
          enddo
          if (d_dim%n_tot_entries.eq.0) then
            samplingBar1 = "| Empty grid |"
            samplingBar2 = "| Empty grid |"
            samplingBar3 = "| Empty grid |"
          else
            do i=1,len(samplingBar1)
              samplingBar1(i:i)=' '
            enddo
            do i=1,len(samplingBar2)
              samplingBar2(i:i)=' '
            enddo
            do i=1,len(samplingBar3)
              samplingBar3(i:i)=' '
            enddo
            samplingBar1(1:1) = '|'
            samplingBar2(1:1) = '|'
            samplingBar3(1:1) = '|'             
            curr_pos1 = 2
            curr_pos2 = 2
            curr_pos3 = 2 
            do i=1,min(10,size(d_dim%bins)) 
              samplingBar1(curr_pos1:curr_pos1+1) =
     &                             trim(DS_toStr(d_dim%bins(i)%bid))
              samplingBar2(curr_pos2:curr_pos2+1) = 
     &                             trim(DS_toStr(d_dim%bins(i)%bid))
              samplingBar3(curr_pos3:curr_pos3+1) = 
     &                             trim(DS_toStr(d_dim%bins(i)%bid))
              curr_pos1 = curr_pos1+2
              curr_pos2 = curr_pos2+2
              curr_pos3 = curr_pos3+2

              if (tot_abs_weight.ne.0.0d0) then
                bin_width = int((d_dim%bins(i)%abs_weight/
     &                                 tot_abs_weight)*samplingBarWidth)
                do j=1,bin_width
                  samplingBar1(curr_pos1+j:curr_pos1+j) = ' '
                enddo
                curr_pos1 = curr_pos1+bin_width+1
                samplingBar1(curr_pos1:curr_pos1) = '|'
                curr_pos1 = curr_pos1+1
              endif

              if (tot_entries.ne.0) then
                bin_width = int((float(d_dim%bins(i)%n_entries)/
     &                                    tot_entries)*samplingBarWidth)
                do j=1,bin_width
                  samplingBar2(curr_pos2+j:curr_pos2+j) = ' '
                enddo
                curr_pos2 = curr_pos2+bin_width+1
                samplingBar2(curr_pos2:curr_pos2) = '|'
                curr_pos2 = curr_pos2+1
              endif

              if (tot_variance.ne.0.0d0) then
                bin_width = int((DS_bin_variance(d_dim%bins(i))/
     &                                   tot_variance)*samplingBarWidth)
                do j=1,bin_width
                  samplingBar3(curr_pos3+j:curr_pos3+j) = ' '
                enddo
                curr_pos3 = curr_pos3+bin_width+1
                samplingBar3(curr_pos3:curr_pos3) = '|'
                curr_pos3 = curr_pos3+1
              endif
            enddo
            if (tot_abs_weight.eq.0.0d0) then
              samplingBar1 = "| All considered bins have zero weight |"
            endif
            if (tot_entries.eq.0) then
              samplingBar2 = "| All considered bins have no entries |"
            endif
            if (tot_variance.eq.0.0d0) then
              samplingBar3 = "| All variances are zeros in considered"//
     &        " bins. Maybe not enough entries (need at least one bin"//
     &        " with >=2 entries). |"
            endif
          endif
!
!         Write out info
!
          n_bins = size(d_dim%bins)
          
          write(*,*) "DiscreteSampler::   -> Total number of "//
     &         "entries : "//trim(toStr(d_dim%n_tot_entries))
          if (n_bins.gt.10) then
            write(*,*) "DiscreteSampler::   -> Sampled as"//
     &                                      " (first 10 bins):"
          else
            write(*,*) "DiscreteSampler::   -> Sampled as:"
          endif
          write(*,*) "DiscreteSampler::    "//trim(samplingBar2)
          write(*,*) "DiscreteSampler::   -> (norm_sqr , "//
     &      "abs_norm , norm     , variance ) :"
          write(*,*) "DiscreteSampler::      ("//
     &      trim(toStr(d_dim%norm_sqr,'Ew.3'))//", "//
     &      trim(toStr(d_dim%abs_norm,'Ew.3'))//", "//
     &      trim(toStr(d_dim%norm,'Ew.3'))//", "//
     &      trim(toStr(d_dim%variance_norm,'Ew.3'))//")"
          if (n_bins.gt.10) then
            write(*,*) "DiscreteSampler::   -> Abs weights sampled as"//
     &                                      " (first 10 bins):"
          else
            write(*,*) "DiscreteSampler::   -> Abs weights sampled as:"
          endif
          write(*,*) "DiscreteSampler::    "//trim(samplingBar1)
          if (n_bins.gt.10) then
            write(*,*) "DiscreteSampler::   -> Variance sampled as"//
     &                                      " (first 10 bins):"
          else
            write(*,*) "DiscreteSampler::   -> Variance sampled as:"
          endif
          write(*,*) "DiscreteSampler::    "//trim(samplingBar3)

        end subroutine DS_print_dim_info

!       ---------------------------------------------------------------
!         Functions to add a bin with different binID specifier
!       ---------------------------------------------------------------      
        subroutine DS_add_bin_with_IntegerID(dim_name,intID)
          implicit none
!         
!         Subroutine arguments
!
          integer, intent(in)      :: intID
          character(len=*)         :: dim_name
!
!         Begin code
!
          call DS_add_bin_with_binID(dim_name,DS_binID(intID))
        end subroutine DS_add_bin_with_IntegerID

        subroutine DS_add_bin_with_void(dim_name)
          implicit none
!         
!         Subroutine arguments
!
          character(len=*)         :: dim_name
!
!         Local variables
!
          integer                  :: ref_size, run_size
!
!         Begin code
!
          ref_size=size(ref_grid(DS_dim_index(ref_grid,dim_name))%bins)
          run_size=size(run_grid(DS_dim_index(run_grid,dim_name))%bins)
          call DS_add_bin_with_binID(dim_name,DS_binID(
     &                                      max(ref_size, run_size)+1))
        end subroutine DS_add_bin_with_void

        subroutine DS_add_bin_with_binID(dim_name,mBinID)
          implicit none
!         
!         Subroutine arguments
!
          type(binID), intent(in)  :: mBinID
          character(len=*)         :: dim_name
!
!         Local variables
!
          type(Bin)                :: new_bin
!
!         Begin code
!
          call DS_reinitialize_bin(new_bin)
          new_bin%bid = mBinID
          call DS_add_bin_to_bins(ref_grid(DS_dim_index(ref_grid, 
     &                                          dim_name))%bins,new_bin)
          call DS_add_bin_to_bins(run_grid(DS_dim_index(run_grid, 
     &                                          dim_name))%bins,new_bin)
        end subroutine DS_add_bin_with_binID

        subroutine DS_add_bin_to_bins(bins,new_bin)
          implicit none
!         
!         Subroutine arguments
!
          type(Bin), dimension(:), allocatable, intent(inout)  
     &                             :: bins
          type(Bin)                :: new_bin
!
!         Local variables
!
          type(Bin), dimension(:), allocatable :: tmp
          integer                              :: i, bin_index
!
!         Begin code
!
          bin_index = DS_bin_index(bins,new_bin%bid,.True.)
          if (bin_index.ne.-1) then
             write(*,*)"DiscreteSampler:: Error, the bin with binID '"//
     &         trim(DS_toStr(new_bin%bid))//"' cannot be added "//
     &         "be added because it already exists."
               stop 1
          endif


          allocate(tmp(size(bins)+1))
          do i=1,size(bins)
            call DS_copy_bin(bins(i),tmp(i))
          enddo
          tmp(size(bins)+1) = new_bin
          deallocate(bins)
          allocate(bins(size(tmp)))
          do i=1,size(bins)
            call DS_copy_bin(tmp(i),bins(i))          
          enddo
          deallocate(tmp)
        end subroutine DS_add_bin_to_bins

        subroutine DS_copy_bin(source, trget)
            implicit none
            type(Bin), intent(out) :: trget
            type(Bin), intent(in)  :: source
            trget%weight     = source%weight
            trget%weight_sqr = source%weight_sqr
            trget%abs_weight = source%abs_weight
            trget%n_entries  = source%n_entries
            trget%bid        = DS_binID(source%bid%id)
        end subroutine DS_copy_bin

!       ---------------------------------------------------------------
!         Functions to remove a bin from a dimension
!       ---------------------------------------------------------------
        subroutine DS_remove_bin_withIndex(dim_name, binIndex)
          implicit none
!         
!         Subroutine arguments
!
          character(len=*), intent(in)   :: dim_name
          integer, intent(in)            :: binIndex
!
!         Begin code
!

          call DS_remove_bin_from_grid(run_grid(
     &                       DS_dim_index(run_grid, dim_name)),binIndex)
        end subroutine DS_remove_bin_withIndex

        subroutine DS_remove_bin_withBinID(dim_name, mbinID)
          implicit none
!         
!         Subroutine arguments
!
          character(len=*), intent(in)   :: dim_name
          type(binID), intent(in)        :: mbinID
!
!         Local variables
!
          integer                        :: ref_dim_index,run_dim_index
          integer                        :: ref_bin_index,run_bin_index
!
!         Begin code
!
          ref_dim_index = DS_dim_index(ref_grid, dim_name)
          ref_bin_index = DS_bin_index(ref_grid(ref_dim_index)%bins,
     &                                                          mbinID)
          call DS_remove_bin_from_grid(ref_grid(ref_dim_index),
     &                                                   ref_bin_index)
          run_dim_index = DS_dim_index(run_grid, dim_name)
          run_bin_index = DS_bin_index(run_grid(run_dim_index)%bins,
     &                                                          mbinID)
          call DS_remove_bin_from_grid(run_grid(run_dim_index),
     &                                                   run_bin_index)
        end subroutine DS_remove_bin_withBinID

        subroutine DS_remove_bin_withIntegerID(dim_name, mBinIntID)
          implicit none
!         
!         Subroutine arguments
!
          character(len=*), intent(in)   :: dim_name
          integer, intent(in)            :: mBinIntID       
!
!         Begin code
!
          call DS_remove_bin_withBinID(dim_name,DS_binID(mBinIntID))
        end subroutine DS_remove_bin_withIntegerID

        subroutine DS_remove_bin_from_grid(grid, bin_index)
          implicit none
!         
!         Subroutine arguments
!
          type(SampledDimension), intent(inout)  :: grid
          integer, intent(in)                    :: bin_index
!
!         Local variables
!
          type(Bin), dimension(:), allocatable :: tmp
          integer                              :: i
!
!         Begin code
!

!         Update the norm, norm_sqr and the number of entries in
!         the corresponding dimension
          grid%norm = grid%norm - grid%bins(bin_index)%weight
          grid%norm_sqr = grid%norm_sqr - 
     &                                   grid%bins(bin_index)%weight_sqr
          grid%abs_norm = grid%abs_norm -
     &                                   grid%bins(bin_index)%abs_weight
          grid%variance_norm = grid%variance_norm
     &                           - DS_bin_variance(grid%bins(bin_index))
          grid%n_tot_entries = grid%n_tot_entries
     &                                  - grid%bins(bin_index)%n_entries
          allocate(tmp(size(grid%bins)-1))
          do i=1,bin_index-1
            tmp(i) = grid%bins(i)
          enddo
          do i=bin_index+1,size(grid%bins)
            tmp(i-1) = grid%bins(i)          
          enddo
          deallocate(grid%bins)
          allocate(grid%bins(size(tmp)))
          do i=1,size(tmp)
            grid%bins(i)=tmp(i)
          enddo
          deallocate(tmp)
        end subroutine DS_remove_bin_from_grid


!       ---------------------------------------------------------------
!       Function to update the reference grid with the running one
!       ---------------------------------------------------------------
        subroutine DS_update_all_grids(filterZeros)
        implicit none
!         
!         Subroutine arguments
!
          logical, optional :: filterZeros
!         
!         Local variables
!
          integer           :: i
          logical           :: do_filterZeros          
!
!         Begin code
!
          if (.not.allocated(run_grid)) then
            return
          endif
          if(present(filterZeros)) then
            do_filterZeros = filterZeros
          else
            do_filterZeros = .False.
          endif
          do i=1, size(run_grid)
            call DS_update_grid_with_dim_index(i,do_filterZeros)
          enddo
        end subroutine DS_update_all_grids

        subroutine DS_update_grid_with_dim_name(dim_name, filterZeros)
        implicit none
!         
!         Subroutine arguments
!
          character(len=*)                 :: dim_name
          logical, optional                :: filterZeros          
!         
!         Local variables
!
          integer           :: i
          logical           :: do_filterZeros
!
!         Begin code
!
          if(present(filterZeros)) then
            do_filterZeros = filterZeros
          else
            do_filterZeros = .False.
          endif
          call DS_update_grid_with_dim_index(
     &                   DS_dim_index(run_grid,dim_name),do_filterZeros)

        end subroutine DS_update_grid_with_dim_name

        subroutine DS_update_grid_with_dim_index(d_index,filterOutZeros)
        implicit none
!         
!         Subroutine arguments
!
          integer                               :: d_index
          logical                               :: filterOutZeros
!         
!         Local variables
!
          integer                               :: i, ref_d_index 
          integer                               :: ref_bin_index
          integer                               :: j, shift
          character, dimension(:), allocatable  :: dim_name
          type(BinID)                           :: mBinID
          type(Bin)                        :: new_bin, ref_bin, run_bin
          logical                          :: empty_ref_grid
!
!         Begin code
!
          allocate(dim_name(size(run_grid(d_index)%dimension_name)))
          dim_name = run_grid(d_index)%dimension_name
          call DS_Logger("Updating dimension '"//
     &                                      trim(toStr(dim_name))//"'.")

!         Start by making sure that the dimension exists in the
!         reference grid. If not, then create it.
          if (DS_dim_index(ref_grid,
     &         run_grid(d_index)%dimension_name,.True.).eq.-1) then
              call DS_Logger('Reference grid does not have dimension '//
     &                         trim(toStr(dim_name))//'. Adding it now')
              call DS_add_dimension_to_grid(ref_grid, 
     &                                        trim(toStr(dim_name)) , 0)
          endif
          ref_d_index = DS_dim_index(ref_grid, dim_name)

          empty_ref_grid = (ref_grid(ref_d_index)%n_tot_entries.eq.0)

          do i=1,size(run_grid(d_index)%bins)
            mBinID = run_grid(d_index)%bins(i)%bid
            ref_bin_index = DS_bin_index(
     &                        ref_grid(ref_d_index)%bins,mBinID,.True.) 
            if (ref_bin_index.eq.-1) then
              call DS_Logger('Bin with binID '//trim(DS_toStr(mBinID))//
     &              ' is missing in the reference grid. Adding it now.')
              call DS_reinitialize_bin(new_bin)
              new_bin%bid = mBinID
              call DS_add_bin_to_bins(ref_grid(ref_d_index)%bins,
     &                                                          new_bin)
              ref_bin_index = DS_bin_index(
     &                                ref_grid(ref_d_index)%bins,mBinID)
            endif
            
            run_bin = run_grid(d_index)%bins(i)
            if ((run_bin%n_entries.lt.ref_grid(ref_d_index)%
     &           min_bin_probing_points).and.empty_ref_grid) then
              write(*,*) "DiscreteSampler:: WARNING, the bin '"//
     &        trim(DS_toStr(run_bin%bid))//"' of dimension '"//
     &        trim(toStr(dim_name))//"' will be used for reference"//
     &        " even though it has been probed only "//
     &        trim(toStr(run_bin%n_entries))//" times (minimum "//
     &        "requested is "//trim(toStr(ref_grid(ref_d_index)%
     &        min_bin_probing_points))//" times)."
            endif

          ref_bin = ref_grid(ref_d_index)%bins(ref_bin_index)
          if (ref_grid(ref_d_index)%grid_mode.eq.2) then
!           This means that the reference grid is in 'initialization'
!           mode and should be overwritten by the running grid (instead
!           of being combined with it) when updated except for the
!           bins with not enough entries in the run_grid.
            if (run_bin%n_entries.ge.ref_grid(ref_d_index)%
     &                                    min_bin_probing_points) then
              call DS_reinitialize_bin(ref_bin)
            else
!             Then we combine the run_bin and the ref_bin by weighting
!             the ref_bin with the ratio of the corresponding norms
              ref_bin%weight = ref_bin%weight * (run_grid(
     &          d_index)%abs_norm / ref_grid(ref_d_index)%abs_norm)
              ref_bin%abs_weight = ref_bin%abs_weight * (run_grid(
     &          d_index)%abs_norm / ref_grid(ref_d_index)%abs_norm)
              ref_bin%weight_sqr = ref_bin%weight_sqr * (run_grid(
     &          d_index)%norm_sqr / ref_grid(ref_d_index)%norm_sqr)
            endif
          endif

          new_bin = ref_bin + run_bin

!         Now update the ref grid bin
          ref_grid(ref_d_index)%bins(ref_bin_index) = new_bin

          enddo
          call DS_synchronize_grid_with_bins(ref_grid(ref_d_index))

!         Now we set the global attribute of the reference_grid to be
!         the ones of the running grid.
          ref_grid(ref_d_index)%min_bin_probing_points =
     &       run_grid(d_index)%min_bin_probing_points
          ref_grid(ref_d_index)%grid_mode = run_grid(d_index)%grid_mode
          ref_grid(ref_d_index)%small_contrib_threshold = 
     &                        run_grid(d_index)%small_contrib_threshold
          ref_grid(ref_d_index)%damping_power = 
     &                                  run_grid(d_index)%damping_power

!         Now filter all bins in ref_grid that have 0.0 weight and
!         remove them! They will not be probed anyway.
          if (filterOutZeros) then
            shift = 0
            do j=1,size(ref_grid(ref_d_index)%bins)
              i = j - shift
              if ((ref_grid(ref_d_index)%bins(i)%weight.eq.0.0d0).and.
     &        (ref_grid(ref_d_index)%bins(i)%abs_weight.eq.0.0d0).and.
     &        (ref_grid(ref_d_index)%bins(i)%weight_sqr.eq.0.0d0)) then
                call DS_Logger('Bin with binID '//
     &            trim(DS_toStr(ref_grid(ref_d_index)%bins(i)%bid))//
     &            ' is zero and will be filtered out. Removing it now.')
                call DS_remove_bin_from_grid(ref_grid(ref_d_index),i)
                shift = shift + 1
              endif
            enddo
          endif

!         Clear the running grid now
          call DS_reinitialize_dimension(run_grid(d_index))

          deallocate(dim_name)

        end subroutine DS_update_grid_with_dim_index


        function DS_combine_two_bins(BinA, BinB) result(CombinedBin)
        implicit none
!         
!         Function arguments
!
          integer               :: d_index
          Type(Bin), intent(in) :: BinA, BinB
          Type(Bin)             :: CombinedBin
!         
!         Local variables
!
          call DS_reinitialize_bin(CombinedBin)
          if(.not.(BinA%bid==BinB%bid)) then
            write(*,*) 'DiscreteSampler:: Error in function '//
     &        'DS_combine_two_bins, cannot combine two bins '//
     &        ' with different bin IDs : '//trim(DS_toStr(BinA%bid))//
     &        ', '//trim(DS_toStr(BinB%bid))
            stop 1
          endif
          CombinedBin%bid = BinA%bid
          CombinedBin%n_entries = BinA%n_entries + BinB%n_entries
          if (CombinedBin%n_entries.eq.0) then
            CombinedBin%weight     = 0.0d0
            CombinedBin%abs_weight = 0.0d0
            CombinedBin%weight_sqr = 0.0d0
          else
            CombinedBin%weight     = (BinA%weight*BinA%n_entries + 
     &                 BinB%weight*BinB%n_entries)/CombinedBin%n_entries
            CombinedBin%abs_weight = (BinA%abs_weight*BinA%n_entries +
     &             BinB%abs_weight*BinB%n_entries)/CombinedBin%n_entries
            CombinedBin%weight_sqr = (BinA%weight_sqr*BinA%n_entries + 
     &             BinB%weight_sqr*BinB%n_entries)/CombinedBin%n_entries
          endif
        end function DS_combine_two_bins

!       ================================================
!       Main function to pick a point
!       ================================================
 
      subroutine DS_get_point_with_integerBinID(dim_name,
     &           random_variable, integerIDPicked, jacobian_weight,mode,
     &                                            convoluted_grid_names)
!
!       Subroutine arguments
!
        character(len=*), intent(in)             ::  dim_name
        real*8, intent(in)                       ::  random_variable
        integer, intent(out)                     ::  integerIDPicked
        real*8, intent(out)                      ::  jacobian_weight
        character(len=*), intent(in), optional   ::  mode
        character(len=*), dimension(:), intent(in), optional ::
     &                                             convoluted_grid_names
!
!       Local variables
!
        type(BinID)                             ::  mBinID
!
!       Begin code
!
        if (present(mode)) then
          if (present(convoluted_grid_names)) then
            call DS_get_point_with_BinID(dim_name,random_variable,
     &                      mBinID,jacobian_weight,mode=mode,
     &                      convoluted_grid_names=convoluted_grid_names)
          else
            call DS_get_point_with_BinID(dim_name,random_variable,
     &                                 mBinID,jacobian_weight,mode=mode)
          endif
        else
          if (present(convoluted_grid_names)) then
            call DS_get_point_with_BinID(dim_name,random_variable,
     &                      mBinID,jacobian_weight,
     &                      convoluted_grid_names=convoluted_grid_names)
          else
            call DS_get_point_with_BinID(dim_name,random_variable,
     &                                           mBinID,jacobian_weight)
          endif
        endif
        integerIDPicked = mBinID%id
      end subroutine DS_get_point_with_integerBinID

      subroutine DS_get_point_with_BinID(dim_name,
     &           random_variable, mBinID, jacobian_weight, mode,
     &                                            convoluted_grid_names)
!
!       Subroutine arguments
!
        character(len=*), intent(in)            ::  dim_name
        real*8, intent(in)                      ::  random_variable
        type(BinID), intent(out)                ::  mBinID
        real*8, intent(out)                     ::  jacobian_weight
        character(len=*), intent(in), optional  ::  mode
        character(len=*), dimension(:), intent(in), optional ::
     &                                             convoluted_grid_names
!
!       Local variables
!
!       chose_mode = 1 : Sampling accoridng to variance
!       chose_mode = 2 : Sampling according to norm
!       chose_mode = 3 : Uniform sampling
        integer                 :: chosen_mode
        type(SampledDimension)  :: mGrid, runGrid
        type(Bin)               :: mBin, mRunBin
        integer                 :: ref_grid_index, run_grid_index
        integer                 :: i,j
        real*8                  :: running_bound
        real*8                  :: normalized_bin_bound
        logical, dimension(:), allocatable   :: bin_indices_to_fill
        logical                 :: initialization_done
        real*8                  :: sampling_norm        
!       Local variables related to convolution
        real*8, dimension(:), allocatable :: convolution_factors
        integer                 :: conv_bin_index
        type(SampledDimension)  :: conv_dim
        logical                 :: one_norm_is_zero
        real*8                  :: small_contrib_thres
!
!       Begin code
!
        if (present(mode)) then
          if (mode.eq.'variance') then
            chosen_mode = 1
          elseif (mode.eq.'norm') then
            chosen_mode = 2
          elseif (mode.eq.'uniform') then
            chosen_mode = 3
          else
            write(*,*) "DiscreteSampler:: Error in subroutine"//
     &        " DS_get_point, mode '"//mode//"' is not recognized."
            stop 1
          endif
        else
          chosen_mode = 2
        endif  

        if (.not.allocated(ref_grid)) then
          write(*,*) "DiscreteSampler:: Error, dimensions"//
     &     " must first be registered with 'DS_register_dimension'"//
     &     " before the module can be used to pick a point."
          stop 1
        endif

        ref_grid_index = DS_dim_index(ref_grid, dim_name,.True.)
        if (ref_grid_index.eq.-1) then
          write(*,*) "DiscreteSampler:: Error in subroutine"//
     &     " DS_get_point, dimension '"//dim_name//"' not found."
          stop 1
        endif
        mGrid   = ref_grid(ref_grid_index)
        run_grid_index = DS_dim_index(run_grid, dim_name,.True.)
        if (run_grid_index.eq.-1) then
          write(*,*) "DiscreteSampler:: Error in subroutine"//
     &     " DS_get_point, dimension '"//dim_name//"' not found"//
     &     " in the running grid."
          stop 1
        endif
        runGrid = run_grid(run_grid_index)        

!       If the reference grid is empty, force the use of uniform
!       sampling
        if (mGrid%n_tot_entries.eq.0) then
          chosen_mode = 3
        endif

!       Pick the right norm for the chosen mode
        if (chosen_mode.eq.1) then
          sampling_norm           = mGrid%variance_norm
        elseif (chosen_mode.eq.2) then
          sampling_norm           = mGrid%abs_norm
        elseif (chosen_mode.eq.3) then
          sampling_norm           = float(size(mGrid%bins))
        endif

!       If the grid is empty we must first make sure that each bin was
!       probed with min_bin_probing_points before using a uniform grid
        allocate(bin_indices_to_fill(size(mGrid%bins)))
        initialization_done = .True.        
        if(mGrid%n_tot_entries.eq.0) then
          min_bin_index     = 1
          do i=1,size(mGrid%bins)
            mRunBin = DS_get_bin(runGrid%bins,mGrid%bins(i)%bid)
            if (mRunBin%n_entries.lt.mGrid%min_bin_probing_points) then
              bin_indices_to_fill(i) = .True.
              initialization_done    = .False.            
            else
              bin_indices_to_fill(i) = .False.
            endif
          enddo
          if(.not.initialization_done) then
!           In this case, we will only fill in bins which do not have 
!           have enough entries (and select them uniformly) and veto the 
!           others. The jacobian returned is still the one corresponding
!           to a uniform distributions over the whole set of bins.
!           Possible convolutions are ignored
            sampling_norm = 0.0d0
            do i=1,size(bin_indices_to_fill)
              if (bin_indices_to_fill(i)) then
                sampling_norm = sampling_norm + 1.0d0
              endif
            enddo
          endif
        endif

        if (initialization_done) then
          do i=1,size(mGrid%bins)
            bin_indices_to_fill(i) = .True.
          enddo
        endif

!       Pick the right reference bin value for the chosen mode. Note
!       that this reference value is stored in the %weight attribute
!       of the reference grid local copy mGrid
        do i=1,size(mGrid%bins)
          if (.not.bin_indices_to_fill(i)) then
            mGrid%bins(i)%weight    = 0.0d0
          elseif (chosen_mode.eq.1) then
            mGrid%bins(i)%weight    = DS_bin_variance(mGrid%bins(i))
          elseif (chosen_mode.eq.2) then
            mGrid%bins(i)%weight    = mGrid%bins(i)%abs_weight
          elseif (chosen_mode.eq.3) then
            mGrid%bins(i)%weight    = 1.0d0
          endif
        enddo

!
!       Treat specially contributions worth less than 5% of the
!       contribution averaged over all bins. For those, we sample
!       according to the square root (or the specified power 'pow'
!       of the reference value corresponding to the chosen mode. 
!       In this way, we are less sensitive to possible large fluctuations 
!       of very suppressed contributions for which the Jacobian would be 
!       really big. However, the square-root is such that a really
!       suppressed contribution at the level of numerical precision
!       would still never be probed.
!       
        average_contrib              = sampling_norm / size(mGrid%bins)
!       Ignore this if the average contribution is zero
        if (average_contrib.gt.0.0d0) then
          do i=1,size(mGrid%bins)
            mBin = mGrid%bins(i)    
            if ( (mBin%weight/average_contrib) .lt.
     &                               runGrid%small_contrib_threshold) then
              sampling_norm       = sampling_norm - mGrid%bins(i)%weight
              mGrid%bins(i)%weight = 
     &          ((mBin%weight/(runGrid%small_contrib_threshold
     &        *average_contrib))**runGrid%damping_power)*
     &        runGrid%small_contrib_threshold*average_contrib
              sampling_norm       = sampling_norm + mGrid%bins(i)%weight
            endif
          enddo
        endif
!
!       Now appropriately set the convolution factors
!
        allocate(convolution_factors(size(mGrid%bins)))
        if (present(convoluted_grid_names).and.initialization_done) then
!         Sanity check
          do j=1,size(convoluted_grid_names)
            if (DS_dim_index(run_grid,convoluted_grid_names(j),
     &                                               .True.).eq.-1) then
              write(*,*) "DiscreteSampler:: Error, dimension '"//
     &         convoluted_grid_names(j)//"' for convolut"//
     &         "ion could not be found in the running grid."
              stop 1
            endif
          enddo
          sampling_norm          = 0.0d0          
          do i=1,size(mGrid%bins)
            convolution_factors(i) = 1.0d0
            do j=1,size(convoluted_grid_names)
              conv_dim = DS_get_dimension(
     &                                run_grid,convoluted_grid_names(j))
              conv_bin_index = DS_bin_index(conv_dim%bins,
     &                                         mGrid%bins(i)%bid,.True.)
              if (conv_bin_index.eq.-1) then
                write(*,*) "DiscreteSampler:: Error, bin '"//
     &          trim(DS_toStr(mGrid%bins(i)%bid))//"' could not be fo"//
     &          "und in convoluted dimension '"//
     &                                    convoluted_grid_names(j)//"'."
                stop 1
              endif
              ! Notice that for the convolution we always use the
              ! absolute value of the weight because we assume the user
              ! has edited this grid by himself for with a single entry.
              convolution_factors(i) = convolution_factors(i)*
     &                          conv_dim%bins(conv_bin_index)%abs_weight
            enddo
            sampling_norm = sampling_norm + 
     &        convolution_factors(i)*mGrid%bins(i)%weight
          enddo
        else
          do i=1,size(mGrid%bins)
            convolution_factors(i)    = 1.0d0
          enddo
        endif

!       Now crash nicely on zero norm grid
        if (sampling_norm.eq.0d0.and..not.DS_tolerate_zero_norm) then
          one_norm_is_zero = .FALSE.
          write(*,*) 'DiscreteSampler:: Error, all bins'//
     &     " of sampled dimension '"//dim_name//"' or of the"//
     &     " following convoluted dimensions have zero weight:"
          if (chosen_mode.eq.2) then
            write(*,*) "DiscreteSampler:: Sampled dimension "//
     & "    : '"//trim(toStr(mGrid%dimension_name))//"' with norm "//
     &                     trim(toStr(mGrid%abs_norm,'ENw.3'))//"."
            one_norm_is_zero = (one_norm_is_zero.or.
     &                                          mGrid%abs_norm.eq.0.0d0)
          elseif (chosen_mode.eq.1) then
            write(*,*) "DiscreteSampler:: Sampled dimension "//
     & "    : '"//trim(toStr(mGrid%dimension_name))//"' with norm "//
     &                     trim(toStr(mGrid%variance_norm,'ENw.3'))//"."
            one_norm_is_zero = (one_norm_is_zero.or.
     &                                     mGrid%variance_norm.eq.0.0d0)
          elseif (chosen_mode.eq.3) then
            write(*,*) "DiscreteSampler:: Norm of sampled dimension '"//
     &       trim(toStr(mGrid%dimension_name))//"' irrelevant since"//
     &       " uniform sampling was selected."
          endif
          if(present(convoluted_grid_names).and.initialization_done)then
            do i=1,size(convoluted_grid_names)
              conv_dim = DS_get_dimension(run_grid,
     &                                         convoluted_grid_names(i))
              write(*,*) "DiscreteSampler:: Convoluted dimension "//
     &       trim(toStr(i))//": '"//convoluted_grid_names(i)//
     &       "' with norm "//trim(toStr(conv_dim%abs_norm,'ENw.3'))//"."
            one_norm_is_zero = (one_norm_is_zero.or.
     &                                       conv_dim%abs_norm.eq.0.0d0)
            enddo
          endif
          if(present(convoluted_grid_names).and.initialization_done
     &                                .and.(.not.one_norm_is_zero))then
            write(*,*) "DiscreteSampler:: None of the norm above"
     &        //" is zero, this means that the convolution (product)"
     &        //" of the grids yields zero for each bin, even though"
     &        //" they are not zero separately."
            write(*,*) "DiscreteSampler:: Use DS_print_global_info()"//
     &        " to investigate further."
          endif
          write(*,*) "DiscreteSampler:: One norm is zero, no sampling"//
     &     " can be done in these conditions. Set 'tolerate_zero_norm"//
     &     "' to .True. when initializating the module to proceed wi"//
     &     "th a uniform distribution for the grids of zero norm."
          stop 1
        endif

!       Or make it pure random if DS_tolerate_zero_norm is True.
        if (sampling_norm.eq.0d0) then
            do i=1,size(mGrid%bins)
               bin_indices_to_fill(i) = .True.
               if(chosen_mode.eq.2.and.mGrid%abs_norm.eq.0.0d0.or.
     &            chosen_mode.eq.1.and.mGrid%variance_norm.eq.0.0d0) then
                 mGrid%bins(i)%weight     = 1.0d0
               endif
               if (present(convoluted_grid_names).and.
     &             initialization_done.and.conv_dim%abs_norm.eq.0.0d0) then
                 conv_dim = DS_get_dimension(run_grid,
     &                                         convoluted_grid_names(i))
                 if (conv_dim%abs_norm.eq.0.0d0) then
                   convolution_factors(i) = 1.0d0
                 endif
               endif
               sampling_norm = sampling_norm + 
     &                       mGrid%bins(i)%weight*convolution_factors(i)
            enddo
!           If sampling_norm is again zero it means that the two grids
!           are "orthogonal" so that we have no choice but to randomize 
!           both.
            if (sampling_norm.eq.0.0d0) then
              do i=1,size(mGrid%bins)
                mGrid%bins(i)%weight = 1.0d0
                convolution_factors(i) = 1.0d0
                sampling_norm = sampling_norm + 1.0d0
              enddo
            endif
        endif

!
!       Now come the usual sampling method 
!
        running_bound = 0.0d0
        do i=1,size(mGrid%bins)
          if (.not.bin_indices_to_fill(i)) then
            cycle
          endif
          mBin = mGrid%bins(i)
          normalized_bin_bound = mBin%weight * 
     &                        ( convolution_factors(i) / sampling_norm )
          running_bound = running_bound + normalized_bin_bound
          if (random_variable.lt.running_bound) then
            mBinID = mGrid%bins(i)%bid
            jacobian_weight = 1.0d0 / normalized_bin_bound
            deallocate(convolution_factors)
            deallocate(bin_indices_to_fill)
            return
          endif
        enddo
!       If no point was picked at this stage, there was a problem
        write(*,*) 'DiscreteSampler:: Error, no point could be '//
     &   'picked with random variable '//trim(toStr(random_variable))//
     &   ' using upper bound found of '//trim(toStr(running_bound))//'.'
        stop 1
      end subroutine DS_get_point_with_BinID

      function DS_bin_variance(mBin)
!
!       Function arguments
!
        type(Bin), intent(in)       :: mBin
        real*8                      :: DS_bin_variance
!
!       Begin code
!
        DS_bin_variance = ((mBin%weight_sqr - mBin%weight**2) *
     &                              (mBin%n_entries))/(mBin%n_entries+1)
      end function DS_bin_variance
!       ================================================
!       Grid I/O functions
!       ================================================

!       ---------------------------------------------------------------
!       This function writes the ref_grid to a file specified by its 
!       filename.
!       ---------------------------------------------------------------
        subroutine DS_write_grid_with_filename(filename, dim_name,
     &                                                        grid_type)
        implicit none
!         
!         Subroutine arguments
!
          character(len=*), intent(in)           :: filename
          character(len=*), intent(in), optional :: dim_name
          character(len=*), intent(in), optional :: grid_type          
!         
!         Local variables
!
          logical fileExist
!
!         Begin code
!
          inquire(file=filename, exist=fileExist)
          if (fileExist) then
            call DS_Logger('DiscreteSampler:: The file '
     &        //filename//' already exists, so beware that '//
     &                  ' the grid information will be appended to it.')
          endif
          open(123, file=filename, err=11, access='append',
     &                                                   action='write')
          goto 12
11        continue
          write(*,*) 'DiscreteSampler :: Error, file '//filename//
     &                               ' could not be opened for writing.'
          stop 1
12        continue
          if (present(dim_name)) then
            if (present(grid_type)) then
              call DS_write_grid_with_streamID(123, dim_name, grid_type)
            else
              call DS_write_grid_with_streamID(123, dim_name)
            endif
          else
            if (present(grid_type)) then              
              call DS_write_grid_with_streamID(123, grid_type=grid_type)
            else
              call DS_write_grid_with_streamID(123)
            endif                
          endif
          close(123)
        end subroutine DS_write_grid_with_filename

!       ---------------------------------------------------------------
!       This function writes the ref_grid or all grids to a file
!       specified by its stream ID.
!       ---------------------------------------------------------------
        subroutine DS_write_grid_with_streamID(streamID, dim_name, 
     &                                                       grid_type)
        implicit none
!         
!         Subroutine arguments
!
          integer, intent(in)                    :: streamID
          character(len=*), intent(in), optional :: dim_name
          character(len=*), intent(in), optional :: grid_type
!         
!         Local variables
!
          type(SampledDimension)                 :: grid
          integer                                :: i
          integer                                :: chosen_grid
!
!         Begin code
!
          if (present(grid_type)) then
            if (grid_type.eq.'ref') then
              chosen_grid = 1
            elseif (grid_type.eq.'run') then
              chosen_grid = 2
            elseif (grid_type.eq.'all') then
              chosen_grid = 3
            else
              write(*,*) 'DiscreteSampler:: Error in'//
     &          " subroutine 'DS_write_grid_with_streamID',"//
     &          " argument grid_type='"//grid_type//"' not"//
     &          " recognized."
              stop 1
            endif
          else
            chosen_grid = 1
          endif
          if ((chosen_grid.eq.1.or.chosen_grid.eq.3)
     &                        .and..not.allocated(ref_grid)) then
            return
          endif
          if ((chosen_grid.eq.2..or.chosen_grid.eq.3)
     &                        .and..not.allocated(run_grid)) then
            return
          endif
          if (present(dim_name)) then
            if (chosen_grid.eq.1.or.chosen_grid.eq.3) then            
              grid = ref_grid(DS_dim_index(ref_grid, dim_name))
              call DS_write_grid_from_grid(grid, streamID,'ref')
            endif
            if (chosen_grid.eq.2.or.chosen_grid.eq.3) then
              grid = run_grid(DS_dim_index(run_grid, dim_name))
              call DS_write_grid_from_grid(grid, streamID,'run')
            endif
          else
            if (chosen_grid.eq.1.or.chosen_grid.eq.3) then
              do i=1,size(ref_grid)
                grid = ref_grid(i)
                call DS_write_grid_from_grid(grid, streamID,'ref')
              enddo
            endif
            if (chosen_grid.eq.2.or.chosen_grid.eq.3) then
              do i=1,size(run_grid)
                grid = run_grid(i)
                call DS_write_grid_from_grid(grid, streamID,'run')
              enddo
            endif
          endif
        end subroutine DS_write_grid_with_streamID

!       ---------------------------------------------------------------
!       This function writes a given grid to a file.
!       ---------------------------------------------------------------
        subroutine DS_write_grid_from_grid(grid, streamID, grid_type)
        implicit none
!         
!         Subroutine arguments
!
          integer, intent(in)                    :: streamID
          type(SampledDimension), intent(in)     :: grid
          character(len=*), intent(in)           :: grid_type          
!         
!         Local variables
!
          integer                                :: i
!
!         Begin code
!

          write(streamID,*) ' <DiscreteSampler_grid>'
          write(streamID,*) ' '//trim(toStr(grid%dimension_name))
          if (grid_type.eq.'ref') then
            write(streamID,*) ' '//trim(toStr(1))
     &      //" # 1 for a reference and 2 for a running grid."
          elseif (grid_type.eq.'run') then
            write(streamID,*) ' '//trim(toStr(2))
     &      //" # 1 for a reference and 2 for a running grid."
          else
            write(*,*) "DiscreteSampler:: Error, grid_type'"//
     &       grid_type//"' not recognized."
            stop 1
          endif  
          write(streamID,*) ' '//trim(toStr(grid%min_bin_probing_points
     &      ))//" # Attribute 'min_bin_probing_points' of the grid."
          write(streamID,*) ' '//trim(toStr(grid%grid_mode
     &      ))//" # Attribute 'grid_mode' of the grid. 1=='default',"
     &      //"2=='initialization'"
          write(streamID,*) ' '//trim(toStr(grid%small_contrib_threshold
     &      ))//" # Attribute 'small_contrib_threshold' of the grid."
          write(streamID,*) ' '//trim(toStr(grid%damping_power
     &      ))//" # Attribute 'damping_power' of the grid."
          write(streamID,*) '# binID   n_entries weight   weight_sqr'//
     &      '   abs_weight'
          do i=1,size(grid%bins)
            write(streamID,*) 
     &          '   '//trim(DS_toStr(grid%bins(i)%bid))//
     &          '   '//trim(toStr(grid%bins(i)%n_entries))//
     &          '   '//trim(toStr(grid%bins(i)%weight,'ESw.15E3'))//
     &          '   '//trim(toStr(grid%bins(i)%weight_sqr,'ESw.15E3'))//
     &          '   '//trim(toStr(grid%bins(i)%abs_weight,'ESw.15E3'))
          enddo
          write(streamID,*) ' </DiscreteSampler_grid>'

        end subroutine DS_write_grid_from_grid

!       ---------------------------------------------------------------
!       This function loads the grid specified in a file specified by its
!       stream ID into the run_grid.
!       ---------------------------------------------------------------
        subroutine DS_load_grid_with_filename(filename, dim_name)
        implicit none
!         
!         Subroutine arguments
!
          character(len=*), intent(in)           :: filename
          character(len=*), intent(in), optional :: dim_name
!         
!         Local variables
!
          logical fileExist        
!
!         Begin code
!
!         Make sure the module is initialized
          if (.not.allocated(DS_isInitialized)) then
              call DS_initialize()
          endif
          inquire(file=filename, exist=fileExist)
          if (.not.fileExist) then
            write(*,*) 'DiscreteSampler:: Error, the file '//filename//
     &                                           ' could not be found.'
            stop 1
          endif
          open(124, file=filename, err=13, action='read')
          goto 14
13        continue
          write(*,*) 'DiscreteSampler :: Error, file '//filename//
     &                                ' exists but could not be read.'
14        continue
          if (present(dim_name)) then
            call DS_load_grid_with_streamID(124, dim_name)
          else
            call DS_load_grid_with_streamID(124)
          endif
          close(124)
        end subroutine DS_load_grid_with_filename

!       ---------------------------------------------------------------
!       This function loads the grid specified in a file specified by its 
!       stream ID into the run_grid.
!       ---------------------------------------------------------------
        subroutine DS_load_grid_with_streamID(streamID, dim_name)
        implicit none
!         
!         Subroutine arguments
!
          integer, intent(in)                    :: streamID
          character(len=*), intent(in), optional :: dim_name
!         
!         Local variables
!
          integer                                :: i
          character(512)                         :: buff
          character(2)                           :: TwoBuff
          character(3)                           :: ThreeBuff
          logical                                :: startedGrid
          real*8                       :: weight, abs_weight, weight_sqr
          integer                      :: n_entries, bid
          type(Bin)                    :: new_bin
          integer                      :: char_size
          integer                      :: read_position
          integer                      :: run_dim_index
          integer                      :: grid_mode
          real*8                       :: small_contrib_threshold
          real*8                       :: damping_power
!
!         Begin code
!
!         Make sure the module is initialized
          if (.not.allocated(DS_isInitialized)) then
              call DS_initialize()
          endif
!         Now start reading the file
          startedGrid   = .False.
          read_position = 0
          do
998         continue          
            read(streamID, "(A)", size=char_size, eor=998,
     &                                    end=999, advance='no') TwoBuff

      
            if (char_size.le.1) then
              cycle
            endif
            if (TwoBuff(1:1).eq.'#'.or.TwoBuff(2:2).eq.'#') then
!             Advance the stream
              read(streamID,*,end=990) buff
              cycle
            endif
            if (startedGrid) then
              read(streamID, "(A)", size=char_size,
     &                                    end=999, advance='no') TwoBuff
              if (TwoBuff(1:2).eq.'</') then
!             Advance the stream
                read(streamID,*,end=990) buff
                startedGrid   = .False.
                read_position = 0
                cycle
              endif
              read(streamID,*,end=990) bid, n_entries, weight, 
     &                                            weight_sqr, abs_weight
              new_bin%bid           = bid
              new_bin%n_entries     = n_entries
              new_bin%weight        = weight
              new_bin%weight_sqr    = weight_sqr
              new_bin%abs_weight    = abs_weight
              call DS_add_bin_to_bins(run_grid(size(run_grid))%bins,
     &                                                          new_bin)
            else
!             Advance the stream
              if (read_position.eq.0) then
                read(streamID,*,end=990) buff
                if (buff(1:22).eq.'<DiscreteSampler_grid>') then
                  read_position = read_position + 1
                endif
              else
                select case(read_position)
                  case(1)
                    read(streamID,*,end=990) buff
                    run_dim_index = DS_dim_index(run_grid,
     &                                               trim(buff),.True.)
                    if (run_dim_index.ne.-1) then
                      call DS_remove_dimension_from_grid(run_grid, 
     &                                                    run_dim_index)
                    endif
                    call DS_register_dimension(trim(buff),0,.False.)
                  case(2)
                    read(streamID,*,end=990) grid_mode
                    if (grid_mode.ne.1) then
                      write(*,*) 'DiscreteSampler:: Warning, the '//
     &                  "grid read is not of type 'reference'."//
     &                  "  It will be skipped."
                      call DS_remove_dimension_from_grid(run_grid, 
     &                                                    run_dim_index)
                      read_position = 0
                      startedGrid = .False.
                      goto 998
                    endif
                  case(3)
                    read(streamID,*,end=990) 
     &                run_grid(size(run_grid))%min_bin_probing_points
                  case(4)
                    read(streamID,*,end=990) 
     &                run_grid(size(run_grid))%grid_mode
                  case(5)
                    read(streamID,*,end=990) small_contrib_threshold
                    if (small_contrib_threshold.lt.0.0d0.or.
     &                              small_contrib_threshold.gt.0.5d0) then
                      write(*,*) 'DiscreteSampler:: The '//
     &                  'small_contrib_threshold must be >= 0.0 and '//
     &                  '< 0.5 to be meaningful.'
                      stop 1
                    endif
                    run_grid(size(run_grid))%small_contrib_threshold
     &                                         = small_contrib_threshold
                  case(6)
                    read(streamID,*,end=990) damping_power
                    if (damping_power.lt.0.0d0.or.
     &                                         damping_power.gt.1.0d0) then
                      write(*,*) 'DiscreteSampler:: The damping power'//
     &                  ' must be >= 0.0 and <= 1.0.'
                      stop 1
                    endif
                    run_grid(size(run_grid))%damping_power
     &                                                   = damping_power
!                   Make sure that the last info read before reading the
!                   bin content (here the info with read_position=6)
!                   sets startedGrid to .True. to start the bin readout 
                    startedGrid   = .True.
                  case default
                    write(*,*) 'DiscreteSampler:: Number of entries'//
     &                ' before reaching bin lists exceeded.'
                    goto 990 
                end select
                read_position = read_position + 1
              endif
            endif
          enddo
          goto 999
990       continue
          write(*,*) 'DiscreteSampler:: Error, when loading grids'//
     &      ' from file.'
          stop 1
999       continue

!         Now update the running grid into the reference one
          call DS_update_grid()
        end subroutine DS_load_grid_with_streamID


!       ---------------------------------------------------------------
!       Synchronizes the cumulative information in a given grid from
!       its bins.
!       --------------------------------------------------------------- 
        subroutine DS_synchronize_grid_with_bins(grid)
        implicit none
!
!         Subroutine argument
!
          type(sampledDimension), intent(inout) :: grid
!         
!         Local variables
!
          real*8           :: norm, abs_norm, norm_sqr, variance_norm
          integer          :: i, n_tot_entries
!
!         Begin Code
!
          norm              = 0.0d0
          abs_norm          = 0.0d0
          norm_sqr          = 0.0d0
          variance_norm     = 0.0d0
          n_tot_entries     = 0
          do i=1,size(grid%bins)
            n_tot_entries   = n_tot_entries  + grid%bins(i)%n_entries
            norm_sqr        = norm_sqr       + grid%bins(i)%weight_sqr
            abs_norm        = abs_norm       + grid%bins(i)%abs_weight
            norm            = norm           + grid%bins(i)%weight
            variance_norm   = variance_norm  + 
     &                                     DS_bin_variance(grid%bins(i))
          enddo
          grid%n_tot_entries = n_tot_entries
          grid%norm_sqr      = norm_sqr
          grid%abs_norm      = abs_norm
          grid%norm          = norm
          grid%variance_norm = variance_norm
        end subroutine DS_synchronize_grid_with_bins

!       ================================================
!       Functions and subroutine handling derived types
!       ================================================

!       ---------------------------------------------------------------
!       Specify how bin idea should be compared
!       ---------------------------------------------------------------
        function equal_binID(binID1,binID2)
        implicit none
!         
!         Function arguments
!
          type(binID), intent(in)  :: binID1, binID2
          logical                  :: equal_binID
!
!         Begin code
!
          if(binID1%id.ne.binID2%id) then
            equal_binID = .False.
            return
          endif
          equal_binID = .True.
          return
        end function equal_binID

!       ---------------------------------------------------------------
!       BinIDs constructors
!       ---------------------------------------------------------------
        pure elemental subroutine binID_from_binID(binID1,binID2)
        implicit none
!         
!         Function arguments
!
          type(binID), intent(out)  :: binID1
          type(binID), intent(in)  :: binID2
!
!         Begin code
!
          binID1%id = binID2%id
        end subroutine binID_from_binID

        pure elemental subroutine binID_from_integer(binID1,binIDInt)
        implicit none
!         
!         Function arguments
!
          type(binID), intent(out)  :: binID1
          integer,     intent(in)   :: binIDInt
!
!         Begin code
!
          binID1%id = binIDInt
        end subroutine binID_from_integer

!       Provide a constructor-like way of creating a binID
        function DS_binID(binIDInt)
        implicit none
!         
!         Function arguments
!
          type(binID)              :: DS_binID
          integer,     intent(in)  :: binIDInt
!
!         Begin code
!
          DS_binID = binIDInt
        end function DS_binID
!       ---------------------------------------------------------------
!       String representation of a binID
!       ---------------------------------------------------------------
        function DS_toStr(mBinID)
        implicit none
!         
!         Function arguments
!
          type(binID), intent(in)  :: mBinID
          character(100)           :: DS_toStr
!
!         Begin code
!
          DS_toStr = trim(toStr(mBinID%id))
        end function DS_toStr


!       ================================================
!        Access routines emulating a dictionary
!       ================================================

!       ---------------------------------------------------------------
!       Returns the index of the discrete dimension with name dim_name
!       ---------------------------------------------------------------
        function DS_dim_index_default(grid, dim_name)
        implicit none
!         
!         Function arguments
!
          type(sampledDimension), dimension(:), intent(in), allocatable
     &                                  :: grid
          character(len=*), intent(in)  :: dim_name
          integer                       :: DS_dim_index_default
!
!         Begin code
!  
          DS_dim_index_default =
     &               DS_dim_index_with_force(grid, dim_name, .False.)
        end function DS_dim_index_default

        function DS_dim_index_with_force(grid, dim_name, force)
        implicit none
!         
!         Function arguments
!
          type(sampledDimension), dimension(:), intent(in), allocatable
     &                                  :: grid
          character(len=*), intent(in)  :: dim_name
          integer                       :: DS_dim_index_with_force
          logical                       :: force
!
!         Local variables
!

          integer i,j
!
!         Begin code
!
          DS_dim_index_with_force = -1
          if (.not.allocated(grid)) then
            return
          endif
          do i = 1, size(grid)
            if (len(dim_name).ne.size(grid(i)%dimension_name)) cycle
            do j =1, len(dim_name)
              if(grid(i)%dimension_name(j).ne.dim_name(j:j)) then
                goto 1
              endif
            enddo
            DS_dim_index_with_force = i
            return
1           continue
          enddo
          if (DS_dim_index_with_force.eq.-1.and.(.not.force)) then
            write(*,*) 'DiscreteSampler:: Error in function dim_index'//
     &        "(), dimension name '"//dim_name//"' not found."
            stop 1
          endif
        end function DS_dim_index_with_force

        function DS_dim_index_default_with_chararray(grid, dim_name)
        implicit none
!         
!         Function arguments
!
          type(sampledDimension), dimension(:), intent(in), allocatable 
     &                                         :: grid
          character, dimension(:), intent(in)  :: dim_name
          integer                 :: DS_dim_index_default_with_chararray
!
!         Begin code
!  
          DS_dim_index_default_with_chararray = 
     &                DS_dim_index_with_force_with_chararray(
     &                                          grid, dim_name, .False.)
        end function DS_dim_index_default_with_chararray

        function DS_dim_index_with_force_with_chararray(
     &                                            grid, dim_name, force)
        implicit none
!         
!         Function arguments
!
          type(sampledDimension), dimension(:), intent(in), allocatable
     &                                        :: grid
          character, dimension(:), intent(in) :: dim_name
          integer              :: DS_dim_index_with_force_with_chararray
          logical                             :: force
!
!         Local variables
!

          integer i,j
!
!         Begin code
!
          DS_dim_index_with_force_with_chararray = -1
          if (.not.allocated(grid)) then
            return
          endif
          do i = 1, size(grid)
            if (size(dim_name).ne.size(grid(i)%dimension_name)) cycle
            do j =1, size(dim_name)
              if(grid(i)%dimension_name(j).ne.dim_name(j)) then
                goto 1
              endif
            enddo
            DS_dim_index_with_force_with_chararray = i
            return
1           continue
          enddo
          if (DS_dim_index_with_force_with_chararray.eq.-1.and.
     &                                                (.not.force)) then
            write(*,*) 'DiscreteSampler:: Error in function dim_index'//
     &        "(), dimension name '"//dim_name//"' not found."
            stop 1
          endif
        end function DS_dim_index_with_force_with_chararray

!       End module
        end module DiscreteSampler

C============================================================================
C                CTEQ Parton Distribution Functions: Version 6
C                             January 24, 2002, v6.0
C                             April 10, 2002, v6.1
C
C   Ref: "New Generation of Parton Distributions with
C         Uncertainties from Global QCD Analysis"
C   By: J. Pumplin, D.R. Stump, J.Huston, H.L. Lai, P. Nadolsky, W.K. Tung
C       hep-ph/0201195
C
C   This package contains 3 standard sets of CTEQ6 PDF's and 40 up/down sets
C   with respect to CTEQ6M PDF's. Details are:
C ---------------------------------------------------------------------------
C  Iset   PDF        Description       Alpha_s(Mz)**Lam4  Lam5   Table_File
C ---------------------------------------------------------------------------
C   1    CTEQ6M   Standard MSbar scheme   0.118     326   226    cteq6m.tbl
C   2    CTEQ6D   Standard DIS scheme     0.118     326   226    cteq6d.tbl
C   3    CTEQ6L   Leading Order           0.118**   326** 226    cteq6l.tbl
C   4    CTEQ6L1  Leading Order           0.130     215   165    cteq6l1.tbl
C     ------------------------------
C   1xx  CTEQ6M1xx  +/- w.r.t. CTEQ6M     0.118     326   226    cteq6m1xx.tbl
C    (where xx=01--40)
C ---------------------------------------------------------------------------
C   ** ALL fits are obtained by using the same coupling strength 
C   \alpha_s(Mz)=0.118 and the NLO running \alpha_s formula, except CTEQ6L1 
C   which uses the LO running \alpha_s and its value determined from the fit.
C   For the LO fits, the evolution of the PDF and the hard cross sections are
C   calculated at LO.  More detailed discussions are given in hep-ph/0201195.
C
C   The table grids are generated for 10^-6 < x < 1 and 1.3 < Q < 10,000 (GeV).
C   PDF values outside of the above range are returned using extrapolation.
C   Lam5 (Lam4) represents Lambda value (in MeV) for 5 (4) flavors.
C   The matching alpha_s between 4 and 5 flavors takes place at Q=4.5 GeV,
C   which is defined as the bottom quark mass, whenever it can be applied.
C
C   The Table_Files are assumed to be in the working directory.
C
C   Before using the PDF, it is necessary to do the initialization by
C       Call SetCtq6(Iset)
C   where Iset is the desired PDF specified in the above table.
C
C   The function Ctq6Pdf (Iparton, X, Q)
C   returns the parton distribution inside the proton for parton [Iparton]
C   at [X] Bjorken_X and scale [Q] (GeV) in PDF set [Iset].
C   Iparton  is the parton label (5, 4, 3, 2, 1, 0, -1, ......, -5)
C                            for (b, c, s, d, u, g, u_bar, ..., b_bar),
C
C   For detailed information on the parameters used, e.q. quark masses,
C   QCD Lambda, ... etc.,  see info lines at the beginning of the
C   Table_Files.
C
C   These programs, as provided, are in double precision.  By removing the
C   "Implicit Double Precision" lines, they can also be run in single
C   precision.
C
C   If you have detailed questions concerning these CTEQ6 distributions,
C   or if you find problems/bugs using this package, direct inquires to
C   Pumplin@pa.msu.edu or Tung@pa.msu.edu.
C
C===========================================================================

      Function Ctq6Pdf (Iparton, X, Q)
      Implicit Double Precision (A-H,O-Z)
      Logical Warn
      Common
     > / CtqPar2 / Nx, Nt, NfMx
     > / QCDtable /  Alambda, Nfl, Iorder

      Data Warn /.true./
      save Warn

      If (X .lt. 0D0 .or. X .gt. 1D0) Then
        Print *, 'X out of range in Ctq6Pdf: ', X
        Stop
      Endif
      If (Q .lt. Alambda) Then
        Print *, 'Q out of range in Ctq6Pdf: ', Q
        Stop
      Endif
      If ((Iparton .lt. -NfMx .or. Iparton .gt. NfMx)) Then
         If (Warn) Then
C        put a warning for calling extra flavor.
             Warn = .false.
             Print *, 'Warning: Iparton out of range in Ctq6Pdf: '
     >              , Iparton
         Endif
         Ctq6Pdf = 0D0
         Return
      Endif

      Ctq6Pdf = PartonX6 (Iparton, X, Q)
      if(Ctq6Pdf.lt.0.D0)  Ctq6Pdf = 0.D0

      Return

C                             ********************
      End

      Subroutine SetCtq6 (Iset)
      Implicit Double Precision (A-H,O-Z)
      Parameter (Isetmax0=4)
      Character Flnm(Isetmax0)*6, nn*3, Tablefile*40
      Data (Flnm(I), I=1,Isetmax0)
     > / 'cteq6m', 'cteq6d', 'cteq6l', 'cteq6l'/
      Data Isetold, Isetmin0, Isetmin1, Isetmax1 /-987,1,101,140/
      save

C             If data file not initialized, do so.
      If(Iset.ne.Isetold) then
         IU= NextUn6()
         If (Iset.ge.Isetmin0 .and. Iset.le.3) Then
            Tablefile=Flnm(Iset)//'.tbl'
         Elseif (Iset.eq.Isetmax0) Then
            Tablefile=Flnm(Iset)//'1.tbl'
         Elseif (Iset.ge.Isetmin1 .and. Iset.le.Isetmax1) Then
            write(nn,'(I3)') Iset
            Tablefile=Flnm(1)//nn//'.tbl'
         Else
            Print *, 'Invalid Iset number in SetCtq6 :', Iset
            Stop
         Endif
c     Open(IU, File='Pdfdata/'//Tablefile, Status='OLD', Err=100)
            call OpenData(TableFile)
 21      Call ReadTbl6 (IU)
         Close (IU)
         Isetold=Iset
      Endif
      Return

 100  Print *, ' Data file ', Tablefile, ' cannot be opened '
     >//'in SetCtq6!!'
      Stop
C                             ********************
      End

      Subroutine ReadTbl6 (Nu)
      Implicit Double Precision (A-H,O-Z)
      Character Line*80
      PARAMETER (MXX = 96, MXQ = 20, MXF = 5)
      PARAMETER (MXPQX = (MXF + 3) * MXQ * MXX)
      Common
     > / CtqPar1 / Al, XV(0:MXX), TV(0:MXQ), UPD(MXPQX)
     > / CtqPar2 / Nx, Nt, NfMx
     > / XQrange / Qini, Qmax, Xmin
     > / QCDtable /  Alambda, Nfl, Iorder
     > / Masstbl / Amass(6)

      Read  (Nu, '(A)') Line
      Read  (Nu, '(A)') Line
      Read  (Nu, *) Dr, Fl, Al, (Amass(I),I=1,6)
      Iorder = Nint(Dr)
      Nfl = Nint(Fl)
      Alambda = Al

      Read  (Nu, '(A)') Line
      Read  (Nu, *) NX,  NT, NfMx

      Read  (Nu, '(A)') Line
      Read  (Nu, *) QINI, QMAX, (TV(I), I =0, NT)

      Read  (Nu, '(A)') Line
      Read  (Nu, *) XMIN, (XV(I), I =0, NX)

      Do 11 Iq = 0, NT
         TV(Iq) = Log(Log (TV(Iq) /Al))
   11 Continue
C
C                  Since quark = anti-quark for nfl>2 at this stage,
C                  we Read  out only the non-redundent data points
C     No of flavors = NfMx (sea) + 1 (gluon) + 2 (valence)

      Nblk = (NX+1) * (NT+1)
      Npts =  Nblk  * (NfMx+3)
      Read  (Nu, '(A)') Line
      Read  (Nu, *, IOSTAT=IRET) (UPD(I), I=1,Npts)

      Return
C                        ****************************
      End

      Function NextUn6()
C                                 Returns an unallocated FORTRAN i/o unit.
      Logical EX
C
      Do 10 N = 10, 300
         INQUIRE (UNIT=N, OPENED=EX)
         If (.NOT. EX) then
            NextUn6 = N
            Return
         Endif
 10   Continue
      Stop ' There is no available I/O unit. '
C               *************************
      End
C

      SUBROUTINE POLINT6 (XA,YA,N,X,Y,DY)

      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
C                                        Adapted from "Numerical Recipes"
      PARAMETER (NMAX=10)
      DIMENSION XA(N),YA(N),C(NMAX),D(NMAX)
      NS=1
      DIF=ABS(X-XA(1))
      DO 11 I=1,N
        DIFT=ABS(X-XA(I))
        IF (DIFT.LT.DIF) THEN
          NS=I
          DIF=DIFT
        ENDIF
        C(I)=YA(I)
        D(I)=YA(I)
11    CONTINUE
      Y=YA(NS)
      NS=NS-1
      DO 13 M=1,N-1
        DO 12 I=1,N-M
          HO=XA(I)-X
          HP=XA(I+M)-X
          W=C(I+1)-D(I)
          DEN=HO-HP
          IF(DEN.EQ.0.) stop
          DEN=W/DEN
          D(I)=HP*DEN
          C(I)=HO*DEN
12      CONTINUE
        IF (2*NS.LT.N-M)THEN
          DY=C(NS+1)
        ELSE
          DY=D(NS)
          NS=NS-1
        ENDIF
        Y=Y+DY
13    CONTINUE
      RETURN
      END

      Function PartonX6 (IPRTN, XX, QQ)

c  Given the parton distribution function in the array U in
c  COMMON / PEVLDT / , this routine interpolates to find
c  the parton distribution at an arbitray point in x and q.
c
      Implicit Double Precision (A-H,O-Z)

      Parameter (MXX = 96, MXQ = 20, MXF = 5)
      Parameter (MXQX= MXQ * MXX,   MXPQX = MXQX * (MXF+3))

      Common
     > / CtqPar1 / Al, XV(0:MXX), TV(0:MXQ), UPD(MXPQX)
     > / CtqPar2 / Nx, Nt, NfMx
     > / XQrange / Qini, Qmax, Xmin

      Dimension fvec(4), fij(4)
      Dimension xvpow(0:mxx)
      Data OneP / 1.00001 /
      Data xpow / 0.3d0 /       !**** choice of interpolation variable
      Data nqvec / 4 /
      Data ientry / 0 /
      Save ientry,xvpow

c store the powers used for interpolation on first call...
      if(ientry .eq. 0) then
         ientry = 1

         xvpow(0) = 0D0
         do i = 1, nx
            xvpow(i) = xv(i)**xpow
         enddo
      endif

      X = XX
      Q = QQ
      tt = log(log(Q/Al))

c      -------------    find lower end of interval containing x, i.e.,
c                       get jx such that xv(jx) .le. x .le. xv(jx+1)...
      JLx = -1
      JU = Nx+1
 11   If (JU-JLx .GT. 1) Then
         JM = (JU+JLx) / 2
         If (X .Ge. XV(JM)) Then
            JLx = JM
         Else
            JU = JM
         Endif
         Goto 11
      Endif
C                     Ix    0   1   2      Jx  JLx         Nx-2     Nx
C                           |---|---|---|...|---|-x-|---|...|---|---|
C                     x     0  Xmin               x                 1
C
      If     (JLx .LE. -1) Then
        Print '(A,1pE12.4)', 'Severe error: x <= 0 in PartonX6! x = ', x
        Stop
      ElseIf (JLx .Eq. 0) Then
         Jx = 0
      Elseif (JLx .LE. Nx-2) Then

C                For interrior points, keep x in the middle, as shown above
         Jx = JLx - 1
      Elseif (JLx.Eq.Nx-1 .or. x.LT.OneP) Then

C                  We tolerate a slight over-shoot of one (OneP=1.00001),
C              perhaps due to roundoff or whatever, but not more than that.
C                                      Keep at least 4 points >= Jx
         Jx = JLx - 2
      Else
        Print '(A,1pE12.4)', 'Severe error: x > 1 in PartonX6! x = ', x
        Stop
      Endif
C          ---------- Note: JLx uniquely identifies the x-bin; Jx does not.

C                       This is the variable to be interpolated in
      ss = x**xpow

      If (JLx.Ge.2 .and. JLx.Le.Nx-2) Then

c     initiation work for "interior bins": store the lattice points in s...
      svec1 = xvpow(jx)
      svec2 = xvpow(jx+1)
      svec3 = xvpow(jx+2)
      svec4 = xvpow(jx+3)

      s12 = svec1 - svec2
      s13 = svec1 - svec3
      s23 = svec2 - svec3
      s24 = svec2 - svec4
      s34 = svec3 - svec4

      sy2 = ss - svec2
      sy3 = ss - svec3

c constants needed for interpolating in s at fixed t lattice points...
      const1 = s13/s23
      const2 = s12/s23
      const3 = s34/s23
      const4 = s24/s23
      s1213 = s12 + s13
      s2434 = s24 + s34
      sdet = s12*s34 - s1213*s2434
      tmp = sy2*sy3/sdet
      const5 = (s34*sy2-s2434*sy3)*tmp/s12
      const6 = (s1213*sy2-s12*sy3)*tmp/s34

      EndIf

c         --------------Now find lower end of interval containing Q, i.e.,
c                          get jq such that qv(jq) .le. q .le. qv(jq+1)...
      JLq = -1
      JU = NT+1
 12   If (JU-JLq .GT. 1) Then
         JM = (JU+JLq) / 2
         If (tt .GE. TV(JM)) Then
            JLq = JM
         Else
            JU = JM
         Endif
         Goto 12
       Endif

      If     (JLq .LE. 0) Then
         Jq = 0
      Elseif (JLq .LE. Nt-2) Then
C                                  keep q in the middle, as shown above
         Jq = JLq - 1
      Else
C                         JLq .GE. Nt-1 case:  Keep at least 4 points >= Jq.
        Jq = Nt - 3

      Endif
C                                   This is the interpolation variable in Q

      If (JLq.GE.1 .and. JLq.LE.Nt-2) Then
c                                        store the lattice points in t...
      tvec1 = Tv(jq)
      tvec2 = Tv(jq+1)
      tvec3 = Tv(jq+2)
      tvec4 = Tv(jq+3)

      t12 = tvec1 - tvec2
      t13 = tvec1 - tvec3
      t23 = tvec2 - tvec3
      t24 = tvec2 - tvec4
      t34 = tvec3 - tvec4

      ty2 = tt - tvec2
      ty3 = tt - tvec3

      tmp1 = t12 + t13
      tmp2 = t24 + t34

      tdet = t12*t34 - tmp1*tmp2

      EndIf


c get the pdf function values at the lattice points...

      If (Iprtn .GE. 3) Then
         Ip = - Iprtn
      Else
         Ip = Iprtn
      EndIf
      jtmp = ((Ip + NfMx)*(NT+1)+(jq-1))*(NX+1)+jx+1

      Do it = 1, nqvec

         J1  = jtmp + it*(NX+1)

       If (Jx .Eq. 0) Then
C                          For the first 4 x points, interpolate x^2*f(x,Q)
C                           This applies to the two lowest bins JLx = 0, 1
C            We can not put the JLx.eq.1 bin into the "interrior" section
C                           (as we do for q), since Upd(J1) is undefined.
         fij(1) = 0
         fij(2) = Upd(J1+1) * XV(1)**2
         fij(3) = Upd(J1+2) * XV(2)**2
         fij(4) = Upd(J1+3) * XV(3)**2
C
C                 Use Polint6 which allows x to be anywhere w.r.t. the grid

         Call Polint6 (XVpow(0), Fij(1), 4, ss, Fx, Dfx)

         If (x .GT. 0D0)  Fvec(it) =  Fx / x**2
C                                              Pdf is undefined for x.eq.0
       ElseIf  (JLx .Eq. Nx-1) Then
C                                                This is the highest x bin:

        Call Polint6 (XVpow(Nx-3), Upd(J1), 4, ss, Fx, Dfx)

        Fvec(it) = Fx

       Else
C                       for all interior points, use Jon's in-line function
C                              This applied to (JLx.Ge.2 .and. JLx.Le.Nx-2)
         sf2 = Upd(J1+1)
         sf3 = Upd(J1+2)

         g1 =  sf2*const1 - sf3*const2
         g4 = -sf2*const3 + sf3*const4

         Fvec(it) = (const5*(Upd(J1)-g1)
     &               + const6*(Upd(J1+3)-g4)
     &               + sf2*sy3 - sf3*sy2) / s23

       Endif

      enddo
C                                   We now have the four values Fvec(1:4)
c     interpolate in t...

      If (JLq .LE. 0) Then
C                         1st Q-bin, as well as extrapolation to lower Q
        Call Polint6 (TV(0), Fvec(1), 4, tt, ff, Dfq)

      ElseIf (JLq .GE. Nt-1) Then
C                         Last Q-bin, as well as extrapolation to higher Q
        Call Polint6 (TV(Nt-3), Fvec(1), 4, tt, ff, Dfq)
      Else
C                         Interrior bins : (JLq.GE.1 .and. JLq.LE.Nt-2)
C       which include JLq.Eq.1 and JLq.Eq.Nt-2, since Upd is defined for
C                         the full range QV(0:Nt)  (in contrast to XV)
        tf2 = fvec(2)
        tf3 = fvec(3)

        g1 = ( tf2*t13 - tf3*t12) / t23
        g4 = (-tf2*t34 + tf3*t24) / t23

        h00 = ((t34*ty2-tmp2*ty3)*(fvec(1)-g1)/t12
     &    +  (tmp1*ty2-t12*ty3)*(fvec(4)-g4)/t34)

        ff = (h00*ty2*ty3/tdet + tf2*ty3 - tf3*ty2) / t23
      EndIf

      PartonX6 = ff

      Return
C                                       ********************
      End

      double precision function pdg2pdf(ih,ipdg,beamid,x,xmu)
c***************************************************************************
c     Based on pdf.f, wrapper for calling the pdf of MCFM
c***************************************************************************
      implicit none
c
c     Arguments
c
      DOUBLE  PRECISION x,xmu
      INTEGER IH,ipdg
      integer beamid ! 1 or 2 (for left or right beam)
C
C     Include
C
      include 'pdf.inc'
c
      double precision tmp1, tmp2
      integer nb_proton(2), nb_neutron(2) 
      common/to_heavyion_pdg/ nb_proton, nb_neutron
      integer nb_hadron
C      

      double precision Ctq6Pdf, get_ion_pdf
      integer mode,Irt,i,j
      double precision xlast(2),xmulast(2),pdflast(-7:7,2),q2max
      character*7 pdlabellast(2)
      double precision epa_lepton,epa_proton
      integer ipart,ireuse,iporg,ihlast(2)
      save xlast,xmulast,pdflast,pdlabellast,ihlast
      data xlast/2*-99d9/
      data xmulast/2*-99d9/
      data pdflast/30*-99d9/
      data pdlabellast/2*'abcdefg'/
      data ihlast/2*-99/

      if (ih.eq.9) then
         pdg2pdf = 1d0
         return
      endif

      nb_hadron = (nb_proton(beamid)+nb_neutron(beamid))
c     Make sure we have a reasonable Bjorken x. Note that even though
c     x=0 is not reasonable, we prefer to simply return pdg2pdf=0
c     instead of stopping the code, as this might accidentally happen.
      if (x.eq.0d0) then
         pdg2pdf=0d0
         return
      elseif (x.lt.0d0 .or. (x*nb_hadron).gt.1d0) then
         if (nb_hadron.eq.1.or.x.lt.0d0) then
            write (*,*) 'PDF not supported for Bjorken x ', x*nb_hadron
            open(unit=26,file='../../../error',status='unknown')
            write(26,*) 'Error: PDF not supported for Bjorken x ',x*nb_hadron
            stop 1
         else
            pdg2pdf = 0d0
            return
         endif
      endif

      ipart=ipdg
      if(iabs(ipart).eq.21) then
         ipart=0
      else if(iabs(ipart).eq.22) then
         ipart=7
      else if(iabs(ipart).eq.7) then
         ipart=7
c     This will be called for any PDG code, but we only support up to 7
      else if(iabs(ipart).gt.7)then
         write(*,*) 'PDF not supported for pdg ',ipdg
         write(*,*) 'For lepton colliders, please set the lpp* '//
     $    'variables to 0 in the run_card'  
         open(unit=26,file='../../../error',status='unknown')
         write(26,*) 'Error: PDF not supported for pdg ',ipdg
         stop 1
      endif

      iporg=ipart
      ireuse = 0
      do i=1,2
c     Check if result can be reused since any of last two calls
         if (x.eq.xlast(i) .and. xmu.eq.xmulast(i) .and.
     $        pdlabel.eq.pdlabellast(i) .and. ih.eq.ihlast(i)) then
            ireuse = i
         endif
      enddo

c     Reuse previous result, if possible
      if (ireuse.gt.0.)then
         if (pdflast(iporg,ireuse).ne.-99d9) then
            pdg2pdf = get_ion_pdf(pdflast(-7, ireuse), iporg, nb_proton(beamid),
     $                         nb_neutron(beamid))
            return 
         endif
      endif

c     Bjorken x and/or facrorization scale and/or PDF set are not
c     identical to the saved values: this means a new event and we
c     should reset everything to compute new PDF values. Also, determine
c     if we should fill ireuse=1 or ireuse=2.
      if (ireuse.eq.0.and.xlast(1).ne.-99d9.and.xlast(2).ne.-99d9)then
         do i=1,2
            xlast(i)=-99d9
            xmulast(i)=-99d9
            do j=-7,7
               pdflast(j,i)=-99d9
            enddo
            pdlabellast(i)='abcdefg'
            ihlast(i)=-99
         enddo
c     everything has been reset. Now set ireuse=1 to fill the first
c     arrays of saved values below
         ireuse=1
      else if(ireuse.eq.0.and.xlast(1).ne.-99d9)then
c     This is first call after everything has been reset, so the first
c     arrays are already filled with the saved values (hence
c     xlast(1).ne.-99d9). Fill the second arrays of saved values (done
c     below) by setting ireuse=2
         ireuse=2
      else if(ireuse.eq.0)then
c     Special: only used for the very first call to this function:
c     xlast(i) are initialized as data statements to be equal to -99d9
         ireuse=1
      endif

c     Give the current values to the arrays that should be
c     saved. 'pdflast' is filled below.
      xlast(ireuse)=x*nb_hadron
      xmulast(ireuse)=xmu
      pdlabellast(ireuse)=pdlabel
      ihlast(ireuse)=ih

      if(iabs(ipart).eq.7.and.ih.gt.1) then
         q2max=xmu*xmu
         if(abs(ih).eq.3.or.abs(ih).eq.4) then       !from the electron or muonn
            pdg2pdf=epa_lepton(x,q2max, ih)
         elseif(ih .eq. 2) then !from a proton without breaking
            pdg2pdf=epa_proton(x,q2max,beamid)
         endif 
         pdflast(iporg,ireuse)=pdg2pdf
         return
      endif
      
      if (pdlabel(1:5) .eq. 'cteq6') then
C        Be carefull u and d are flipped inside cteq6
         if (nb_proton(beamid).gt.1.or.nb_neutron(beamid).ne.0)then
            if (ipart.eq.1.or.ipart.eq.2)then
               pdflast(1,ireuse)=Ctq6Pdf(2,x*nb_hadron,xmu) ! remember u/d flipping in cteq
               pdflast(2,ireuse)=Ctq6Pdf(1,x*nb_hadron,xmu)
               pdg2pdf = get_ion_pdf(pdflast(-7,ireuse), ipart, nb_proton(beamid), nb_neutron(beamid))
            else if (ipart.eq.-1.or.ipart.eq.-2)then
               pdflast(-1,ireuse)=Ctq6Pdf(-2,x*nb_hadron,xmu) ! remember u/d flipping in cteq
               pdflast(-2,ireuse)=Ctq6Pdf(-1,x*nb_hadron,xmu)
               pdg2pdf = get_ion_pdf(pdflast(-7,ireuse), ipart, nb_proton(beamid), nb_neutron(beamid))
            else
               pdflast(ipart,ireuse)=Ctq6Pdf(ipart,x*nb_hadron,xmu)
               pdg2pdf = get_ion_pdf(pdflast(-7,ireuse), ipart, nb_proton(beamid), nb_neutron(beamid))
            endif 
         else
            if(iabs(ipart).ge.1.and.iabs(ipart).le.2)
     $           ipart=sign(3-iabs(ipart),ipart)
            pdg2pdf=Ctq6Pdf(ipart,x,xmu)
            pdflast(iporg,ireuse)=pdg2pdf
         endif
      else
         call pftopdg(ih,x*nb_hadron,xmu,pdflast(-7,ireuse))
         pdg2pdf = get_ion_pdf(pdflast(-7, ireuse), iporg, nb_proton(beamid),
     $                         nb_neutron(beamid))
      endif      

      return
      end

      logical function cut_bw(p)
c*****************************************************************************
c     Approximates matrix element by propagators
c*****************************************************************************
      implicit none
c
c     Constants
c     
      include 'genps.inc'
      include 'maxconfigs.inc'
      include 'nexternal.inc'
      double precision   zero
      parameter (zero = 0d0)
      include 'run.inc'
c
c     Arguments
c
      double precision p(0:3,nexternal)
c
c     Local
c
      double precision xp(0:3,-nexternal:nexternal)
      double precision mpole(-nexternal:0),shat,tsgn
      integer i,j,iconfig,iproc

      double precision prmass(-nexternal:0,lmaxconfigs)
      double precision prwidth(-nexternal:0,lmaxconfigs)
      double precision prwidth_tmp(-nexternal:0,lmaxconfigs)
      integer pow(-nexternal:0,lmaxconfigs)
      logical first_time, onshell
      double precision xmass
      integer nbw

      integer ida(2),idenpart
c
c     Global
c
      include 'maxamps.inc'
      integer iforest(2,-max_branch:-1,lmaxconfigs)
      common/to_forest/ iforest
      integer sprop(maxsproc,-max_branch:-1,lmaxconfigs)
      integer tprid(-max_branch:-1,lmaxconfigs)
      common/to_sprop/sprop,tprid
      integer            mapconfig(0:lmaxconfigs), this_config
      common/to_mconfigs/mapconfig, this_config

      integer        lbw(0:nexternal)  !Use of B.W.
      common /to_BW/ lbw

      logical             OnBW(-nexternal:0)     !Set if event is on B.W.
      common/to_BWEvents/ OnBW
      
      include 'coupl.inc'

      integer idup(nexternal,maxproc,maxsproc)
      integer mothup(2,nexternal)
      integer icolup(2,nexternal,maxflow,maxsproc)
      include 'leshouche.inc'

      integer gForceBW(-max_branch:-1,lmaxconfigs)  ! Forced BW
      include 'decayBW.inc'
c
c     External
c
      double precision dot

      save prmass,prwidth,pow,prwidth_tmp
      data first_time /.true./
c-----
c  Begin Code
c-----      
      cut_bw = .false.    !Default is we passed the cut
      iconfig = this_config

      if (first_time) then
         include 'props.inc'
         nbw = 0
         do i=-1,-(nexternal-3),-1
            if (iforest(1,i,iconfig) .eq. 1 .or. prwidth(i,iconfig).le.0) then
              cycle
            endif
            nbw=nbw+1
            if (lbw(nbw) .eq. 1) then
               write(*,*) 'Requiring BW ',i,nbw
            elseif(lbw(nbw) .eq. 2) then
               write(*,*) 'Excluding BW ',i,nbw
            else
               write(*,*) 'No cut BW ',i,nbw
            endif
         enddo
         first_time=.false.
      endif

      do i=1,nexternal
         mpole(-i)=0d0
         do j=0,3
            xp(j,i)=p(j,i)
         enddo
      enddo
      nbw = 0
      tsgn    = +1d0
c     Find non-zero process number
      do iproc=1,maxsproc
         if(sprop(iproc,-1,iconfig).ne.0) goto 10
      enddo
 10   continue
c     If no non-zero sprop, set iproc to 1
      if(iproc.gt.maxsproc) iproc=1
c     Start loop over propagators
      do i=-1,-(nexternal-3),-1
         onbw(i) = .false.
         if (iforest(1,i,iconfig) .eq. 1) tsgn=-1d0
         do j=0,3
            xp(j,i) = xp(j,iforest(1,i,iconfig))
     $           +tsgn*xp(j,iforest(2,i,iconfig))
         enddo
         if (tsgn .lt. 0d0) cycle
         if (prwidth(i,iconfig) .gt. 0d0 ) then !This is B.W.
            nbw=nbw+1
c            write(*,*) 'Checking BW',nbw
            xmass = sqrt(dot(xp(0,i),xp(0,i)))
c            write(*,*) 'xmass',xmass,prmass(i,iconfig)
c
c           Here we set if the BW is "on-shell" for LesHouches
c            
            prwidth_tmp(i,iconfig) = max(prwidth(i,iconfig), prmass(i,iconfig)*small_width_treatment)
 
            onshell = (abs(xmass - prmass(i,iconfig)) .lt.
     $           bwcutoff*prwidth_tmp(i,iconfig).and.
     $           (prwidth_tmp(i,iconfig)/prmass(i,iconfig).lt.0.1d0.or.
     $            gForceBW(i,iconfig).eq.1))
            if(onshell)then
c     Remove on-shell forbidden s-channels (gForceBW=2) (JA 2/10/11)
              if(gForceBW(i,iconfig).eq.2) then
                 cut_bw = .true.
                 return               
              endif
c           Only allow OnBW if no "decay" to identical particle
              OnBW(i) = .true.
              idenpart=0
              do j=1,2
                ida(j)=iforest(j,i,iconfig)
                if(ida(j).lt.0) then
                   if(sprop(iproc,i,iconfig).eq.sprop(iproc,ida(j),iconfig))
     $                  idenpart=ida(j)
                elseif (ida(j).gt.0) then
                   if(sprop(iproc,i,iconfig).eq.IDUP(ida(j),1,iproc))
     $                  idenpart=ida(j)
                endif
              enddo
c           Always remove if daughter final-state
              if(idenpart.gt.0) then
                 OnBW(i)=.false.
c           Else remove if daughter forced to be onshell
              elseif(idenpart.lt.0)then
                 if(gForceBW(idenpart, iconfig).eq.1) then
                    OnBW(i)=.false.
c           Else remove daughter if forced to be onshell
                 elseif(gForceBW(i, iconfig).eq.1) then
                    OnBW(idenpart)=.false.
c           Else remove either this resonance or daughter, which is closer to mass shell
                 elseif(abs(xmass-prmass(i,iconfig)).gt.
     $                   abs(sqrt(dot(xp(0,idenpart),xp(0,idenpart)))-
     $                   prmass(i,iconfig))) then
                    OnBW(i)=.false.
c           Else remove OnBW for daughter
                 else
                    OnBW(idenpart)=.false.
                 endif
              endif
            else if (gForceBW(i, iconfig).eq.1) then ! .not. onshell
c             Check if we are supposed to cut forced bw (JA 4/8/11)
              cut_bw = .true.
c              write(*,*) 'cut_bw: ',i,gForceBW(i,iconfig),OnBW(i),cut_bw
              return
            endif
c
c     Here we set onshell for phase space integration (JA 4/8/11)
c     For decay-chain syntax use BWcutoff here too (22/12/14)
            if (gForceBW(i, iconfig).eq.1) then
               onshell = (abs(xmass - prmass(i,iconfig)) .lt.
     $           bwcutoff*prwidth_tmp(i,iconfig))
            else
               onshell = (abs(xmass - prmass(i,iconfig)) .lt.
     $           5d0*prwidth_tmp(i,iconfig))
            endif

            if (onshell .and. (lbw(nbw).eq. 2) .or.
     $          .not. onshell .and. (lbw(nbw).eq. 1)) then
               cut_bw=.true.
c               write(*,*) 'cut_bw: ',nbw,xmass,onshell,lbw(nbw),cut_bw
            endif
         endif
c         write(*,*) 'final cut_bw: ',nbw,lbw(nbw),xmass,onshell,OnBW(i),cut_bw
      enddo
      end


      subroutine set_peaks
c*****************************************************************************
c     Attempts to determine peaks for this configuration
c*****************************************************************************
      implicit none
c
c     Constants
c     
      include 'genps.inc'
      include 'maxconfigs.inc'
      include 'nexternal.inc'
      include 'maxamps.inc'
      double precision   zero
      parameter (zero = 0d0)
c
c     Arguments
c
c
c     Local
c
      double precision  xm(-nexternal:nexternal)
      double precision  xe(-nexternal:nexternal)
      double precision bwcut_for_PS(-nexternal:0)
      double precision tsgn, xo, a
      double precision x1,x2,xk(nexternal)
      double precision dr,mtot,etot,xqfact
      double precision spmass
      integer i, iconfig, l1, l2, j, nt, nbw, iproc, k
      integer iden_part(-nexternal+1:nexternal)

      double precision prmass(-nexternal:0,lmaxconfigs)
      double precision prwidth(-nexternal:0,lmaxconfigs)
      double precision prwidth_tmp(-nexternal:0,lmaxconfigs)
      integer pow(-nexternal:0,lmaxconfigs)

      integer idup(nexternal,maxproc,maxsproc)
      integer mothup(2,nexternal)
      integer icolup(2,nexternal,maxflow,maxsproc)
      include 'leshouche.inc'

      integer gForceBW(-max_branch:-1,lmaxconfigs)  ! Forced BW
      include 'decayBW.inc'

c
c     Global
c
      double precision Smin
      common/to_smin/ Smin

      integer iforest(2,-max_branch:-1,lmaxconfigs)
      common/to_forest/ iforest

      integer sprop(maxsproc,-max_branch:-1,lmaxconfigs)
      integer tprid(-max_branch:-1,lmaxconfigs)
      common/to_sprop/sprop,tprid

      integer            mapconfig(0:lmaxconfigs), this_config
      common/to_mconfigs/mapconfig, this_config

      real*8         emass(nexternal)
      common/to_mass/emass

      include 'run.inc'

      double precision etmin(nincoming+1:nexternal),etamax(nincoming+1:nexternal)
      double precision emin(nincoming+1:nexternal)
      double precision                    r2min(nincoming+1:nexternal,nincoming+1:nexternal)
      double precision s_min(nexternal,nexternal)
      common/to_cuts/  etmin, emin, etamax, r2min, s_min

      double precision xqcutij(nexternal,nexternal),xqcuti(nexternal)
      common/to_xqcuts/xqcutij,xqcuti

      double precision      spole(maxinvar),swidth(maxinvar),bwjac
      common/to_brietwigner/spole          ,swidth          ,bwjac

      integer        lbw(0:nexternal)  !Use of B.W.
      common /to_BW/ lbw

      double precision stot,m1,m2
      common/to_stot/stot,m1,m2

      include 'coupl.inc'
      include 'cuts.inc'
C
C     SPECIAL CUTS
C
      LOGICAL  IS_A_J(NEXTERNAL),IS_A_L(NEXTERNAL)
      LOGICAL  IS_A_B(NEXTERNAL),IS_A_A(NEXTERNAL),IS_A_ONIUM(NEXTERNAL)
      LOGICAL  IS_A_NU(NEXTERNAL),IS_HEAVY(NEXTERNAL), DO_CUTS(NEXTERNAL)
      COMMON /TO_SPECISA/IS_A_J,IS_A_A,IS_A_L,IS_A_B,IS_A_NU,IS_HEAVY,
     . IS_A_ONIUM,DO_CUTS
      integer njet



c
c     External
c

c-----
c  Begin Code
c-----     
      iconfig = this_config
c     needs to be initialise to avoid segfault
      do i = -nexternal,-1
         prwidth(i,iconfig) = 0
         prmass(i,iconfig) =0
      enddo 
      include 'props.inc'
c      etmin = 10
      nt = 0
      do i = -nexternal,-1
         prwidth_tmp(i,iconfig) = max(prwidth(i,iconfig), prmass(i,iconfig)*small_width_treatment)
      enddo


      mtot = 0d0
      etot = 0d0   !Total energy needed
      spmass = 0d0 !Keep track of BW masses for shat
      xqfact=1d0
      if(ickkw.eq.2.or.ktscheme.eq.2) xqfact=0.3d0
      do i=nincoming+1,nexternal  !assumes 2 incoming
         xm(i)=emass(i)
c-fax
         xe(i)=max(emass(i),max(etmin(i),0d0))
         xe(i)=max(xe(i),max(emin(i),0d0))
c-JA 1/2009: Set grid also based on xqcut
         xe(i)=max(xe(i),xqfact*xqcuti(i))
         xk(i)= 0d0
         etot = etot+xe(i)
         mtot=mtot+xm(i)         
      enddo
      spmass=mtot
      tsgn    = +1d0
c     Reset variables
      nbw = 0
      do i=1,nexternal-2
         spole(i)=0
         swidth(i)=0
      enddo
c     Find non-zero process number
      do iproc=1,maxsproc
         if(sprop(iproc,-1,iconfig).ne.0) goto 10
      enddo
 10   continue
c     If no non-zero sprop, set iproc to 1
      if(iproc.ge.maxsproc.and.sprop(maxsproc,-1,iconfig).eq.0)
     $     iproc=1

c     Look for identical particles to map radiation processes
      call idenparts(iden_part, iforest(1,-max_branch,iconfig),
     $     sprop(1,-max_branch,iconfig), gForceBW(-max_branch,iconfig),
     $     prwidth_tmp(-nexternal,iconfig))

c     Start loop over propagators
      do i=-1,-(nexternal-3),-1
         if (iforest(1,i,iconfig) .eq. 1) tsgn=-1d0
         if (tsgn .eq. 1d0) then                         !s channel
            xm(i) = xm(iforest(1,i,iconfig))+xm(iforest(2,i,iconfig))
            xe(i) = xe(iforest(1,i,iconfig))+xe(iforest(2,i,iconfig))
            mtot = mtot - xm(i)
            etot = etot - xe(i)
            if (iforest(1,i,iconfig) .gt. 0
     &           .and. iforest(2,i,iconfig) .gt. 0) then
c-JA 1/2009: Set deltaR cuts here together with s_min cuts
              l1 = iforest(1,i,iconfig)
              l2 = iforest(2,i,iconfig)
              xm(i)=max(xm(i),sqrt(max(s_min(l1,l2),0d0)))
              dr = max(r2min(l1,l2)*dabs(r2min(l1,l2)),0d0)*0.8d0
              xm(i)=max(xm(i),
     &           sqrt(max(etmin(l2),0d0)*max(etmin(l1),0d0)*dr))
c-JA 1/2009: Set grid also based on xqcut
              xm(i)=max(xm(i),max(xqcutij(l1,l2),0d0))
            endif
c            write(*,*) 'iconfig,i',iconfig,i
c            write(*,*) prwidth_tmp(i,iconfig),prmass(i,iconfig)
            if (prwidth_tmp(i,iconfig) .gt. 0 ) then
               nbw=nbw+1
c              JA 6/8/2011 Set xe(i) for resonances
               if (gforcebw(i,iconfig).eq.1) then
                  xm(i) = max(xm(i), prmass(i,iconfig)-bwcutoff*prwidth_tmp(i,iconfig))
                  bwcut_for_PS(i) = bwcutoff
               else if (lbw(nbw).eq.1) then
                  xm(i) = max(xm(i), prmass(i,iconfig)-5d0*prwidth_tmp(i,iconfig))
                  bwcut_for_PS(i) = 5d0
               else
                  bwcut_for_PS(i) = 5d0
               endif
            endif
            xe(i)=max(xe(i),xm(i))
c     Check for impossible onshell configurations
c     Either: required onshell and daughter masses too large
c     Or: forced and daughter masses too large
c     Or: required offshell and forced
            if(prwidth_tmp(i,iconfig) .gt. 0.and.
     $         (lbw(nbw).eq.1.and.
     $          (prmass(i,iconfig)+bwcut_for_PS(i)*prwidth_tmp(i,iconfig).lt.xm(i)
     $           .or.prmass(i,iconfig)-bwcut_for_PS(i)*prwidth_tmp(i,iconfig).gt.dsqrt(stot))
     $          .or.gforcebw(i,iconfig).eq.1.and.
     $              prmass(i,iconfig)+bwcutoff*prwidth_tmp(i,iconfig).lt.xm(i)
     $          .or.lbw(nbw).eq.2.and.gforcebw(i,iconfig).eq.1))
     $        then
c     Write results.dat and quit
               call write_null_results()
               stop
            endif
            if (prwidth_tmp(i,iconfig) .gt. 0 .and. lbw(nbw) .le. 1) then         !B.W.
               if (i .eq. -(nexternal-(nincoming+1))) then  !This is s-hat
                  j = 3*(nexternal-2)-4+1    !set i to ndim+1
c-----
c tjs 11/2008 if require BW then force even if worried about energy
c JA 8/2011 don't use BW if mass is > CM energy
c----
                  if(prmass(i,iconfig).ge.xm(i).and.iden_part(i).eq.0.and.
     $                 prmass(i,iconfig).lt.sqrt(stot)
     $                 .or. lbw(nbw).eq.1) then
                     write(*,*) 'Setting PDF BW',j,nbw,prmass(i,iconfig)
                     spole(j)=prmass(i,iconfig)*prmass(i,iconfig)/stot
                     swidth(j) = prwidth(i,iconfig)*prmass(i,iconfig)/stot ! keep the real width here (important for the jacobian)
                  endif
               else if((prmass(i,iconfig)+bwcut_for_PS(i)*prwidth_tmp(i,iconfig)).ge.xm(i)
     $                  .and. iden_part(i).eq.0 .or. lbw(nbw).eq.1) then
c              JA 02/13 Only allow BW if xm below M+5*Gamma
                  write(*,*) 'Setting BW',i,nbw,prmass(i,iconfig)
                  spole(-i)=prmass(i,iconfig)*prmass(i,iconfig)/stot
                  swidth(-i) = prwidth(i,iconfig)*prmass(i,iconfig)/stot ! keep the real width here (important for the jacobian)
               endif
c     JA 4/1/2011 Set grid in case there is no BW (radiation process)
               if (swidth(-i) .eq. 0d0 .and.
     $              i.ne.-(nexternal-(nincoming+1)))then
                  a=prmass(i,iconfig)**2/stot
                  xo = min(xm(i)**2/stot, 1-1d-8)
                  if (xo.eq.0d0) xo=MIN(10d0/stot, stot/50d0, 0.5)
                  call setgrid(-i,xo,a,1)
               endif
c     Set spmass for BWs
               if (swidth(-i) .ne. 0d0)
     $              spmass=spmass-xm(i) +
     $              max(xm(i),prmass(i,iconfig)-bwcut_for_PS(i)*prwidth_tmp(i,iconfig))
            else                                  !1/x^pow
              a=prmass(i,iconfig)**2/stot
c     JA 4/1/2011 always set grid
              xo = min(xm(i)**2/stot, 1-1d-8)

c     OM 7/27/2013 use MMJJ in order to set the mass in a appropriate way
              if (xo.eq.0d0.and.MMJJ.gt.0d0) then
                 njet = 0
                 do k =1,2
                    if (iforest(k,i,iconfig).gt.0)then
                      if (is_a_j(iforest(k,i,iconfig))) njet = njet + 1
                    endif
                 enddo
                 if (njet.eq.1) then
                    xo = (MMJJ/1d2)**2/stot
                 else if (njet.eq.2) then
                    xo = (MMJJ * 0.8)**2/stot
                 endif
              endif
              if (xo.eq.0d0) xo=MIN(10d0/stot, stot/50d0, 0.5)
c              if (prwidth_tmp(i, iconfig) .eq. 0d0.or.iden_part(i).gt.0) then 
              call setgrid(-i,xo,a,1)
c              else 
c                 write(*,*) 'Using flat grid for BW',i,nbw,
c     $                prmass(i,iconfig)
c              endif
            endif
            etot = etot+xe(i)
            mtot=mtot+xm(i)
c            write(*,*) 'New mtot',i,mtot,xm(i)
         else                                        !t channel
c
c     Check closest to p1
c
            nt = nt+1
            l2 = iforest(2,i,iconfig) !need dr cut
            x1 = 0            
c-fax
c-JA 1/2009: Set grid also based on xqcut
            if (l2 .gt. 0) x1 = max(etmin(l2),max(xqfact*xqcuti(l2),0d0))
            x1 = max(x1, xe(l2)/1d0)
            if (nt .gt. 1) x1 = max(x1,xk(nt-1))
            xk(nt)=x1
c            write(*,*) 'Using 1',l2,x1

c
c     Check closest to p2
c
            j = i-1
            l2 = iforest(2,j,iconfig)
            x2 = 0
c-JA 1/2009: Set grid also based on xqcut
            if (l2 .gt. 0) x2 = max(etmin(l2),max(xqfact*xqcuti(l2),0d0))
c            if (l2 .gt. 0) x2 = max(etmin(l2),0d0)
            x2 = max(x2, xe(l2)/1d0)
c            if (nt .gt. 1) x2 = max(x2,xk(nt-1))
            
c            write(*,*) 'Using 2',l2,x2

            xo = min(x1,x2)

c           Use 1/10000 of sqrt(s) as minimum, to always get integration
            xo = xo*xo/stot
            if (xo.eq.0d0)then
               xo=1/10000d0
               write(*,*) 'Warning: No cutoff for shat integral found'
               write(*,*) '         Minimum set to ', xo
            endif
            a=-prmass(i,iconfig)**2/stot
c            call setgrid(-i,xo,a,pow(i,iconfig))

c               write(*,*) 'Enter minimum for ',-i, xo
c               read(*,*) xo
             if (i .ne. -1 .or. .true.) call setgrid(-i,xo,a,1)
         endif
      enddo
c     Perform setting for shat (PDF BW or 1/s)
      if (abs(lpp(1)) .ge. 1 .or. abs(lpp(2)) .ge. 1) then
c     Set minimum based on: 1) required energy 2) resonances 3) 1/10000 of sqrt(s)
         i = max(1,3*(nexternal-2) - 4 + 1)
         xo = max(min(etot**2/stot, 1d0-1d-8),1d0/stot)
c        Take into account special cuts
c        already done in smin
c     Include mass scale from BWs
         xo = max(xo, spmass**2/stot)
         if (swidth(i).eq.0.and.xo.eq.1d0/stot) then
            write(*,*) 'Warning: No minimum found for integration'
            write(*,*) '         Setting minimum to ',1d0/stot
         endif
c-----------------------
c     tjs  4/29/2008 use analytic transform for s-hat
c-----------------------
         if (swidth(i) .eq. 0d0) then
            if (xo.lt.smin/stot)then
                xo = 1d0*smin/stot
            endif
            swidth(i) = xo
            spole(i)= -2.0d0    ! 1/s pole
            write(*,*) "Transforming s_hat 1/s ",i,xo, smin, stot
         else
            write(*,*) "Transforming s_hat BW ",spole(i), max(swidth(i), spole(i)*small_width_treatment)
         endif
      endif

      i=-8
c      write(*,*) 'Enter minimum for ',-i, xo
c      read(*,*) xo      
c      if (xo .gt. 0)      call setgrid(-i,xo,a,1)

      i=-10
c      write(*,*) 'Enter minimum for ',-i, xo
c      read(*,*) xo      
c      if (xo .gt. 0) call setgrid(-i,xo,a,1)

      end

      subroutine write_null_results()
      implicit none

      write(*,*),'Impossible BW configuration'
      open(unit=66,file='results.dat',status='unknown')
      write(66,'(3e12.5,2i9,i5,i9,4e10.3)')0.,0.,0.,0,0,1,0,0.,0.,0.,0.
      write(66,'(i4,5e15.5)') 1,0.,0.,0.,0.,0.
      close(66)
      end

      logical FUNCTION dummy_cuts(P)
C**************************************************************************
C     INPUT:
C            P(0:3,1)           MOMENTUM OF INCOMING PARTON
C            P(0:3,2)           MOMENTUM OF INCOMING PARTON
C            P(0:3,3)           MOMENTUM OF ...
C            ALL MOMENTA ARE IN THE REST FRAME!!
C            COMMON/JETCUTS/   CUTS ON JETS
C     OUTPUT:
C            TRUE IF EVENTS PASSES ALL CUTS LISTED
C**************************************************************************
      IMPLICIT NONE
c
c     Constants
c
      include 'genps.inc'
      include 'nexternal.inc'
C
C     ARGUMENTS
C
      REAL*8 P(0:3,nexternal)
C
C     PARAMETERS
C
      real*8 PI
      parameter( PI = 3.14159265358979323846d0 )
c
c     particle identification
c
      LOGICAL  IS_A_J(NEXTERNAL),IS_A_L(NEXTERNAL)
      LOGICAL  IS_A_B(NEXTERNAL),IS_A_A(NEXTERNAL),IS_A_ONIUM(NEXTERNAL)
      LOGICAL  IS_A_NU(NEXTERNAL),IS_HEAVY(NEXTERNAL)
      logical  do_cuts(nexternal)
      COMMON /TO_SPECISA/IS_A_J,IS_A_A,IS_A_L,IS_A_B,IS_A_NU,IS_HEAVY,
     . IS_A_ONIUM, do_cuts

      dummy_cuts=.true.

      return
      end

      subroutine get_dummy_x1(sjac, X1, R, pbeam1, pbeam2, stot, shat)
      implicit none
      include 'maxparticles.inc'
      include 'run.inc'
c      include 'genps.inc'
      double precision sjac ! jacobian. should be updated not reinit
      double precision X1   ! bjorken X. output
      double precision R    ! random value after grid transfrormation. between 0 and 1
      double precision pbeam1(0:3) ! momentum of the first beam (input and/or output)
      double precision pbeam2(0:3) ! momentum of the second beam (input and/or output)
      double precision stot        ! total energy  (input and /or output)
      double precision shat        ! output

c     global variable to set (or not)
      double precision cm_rap
      logical set_cm_rap
      common/to_cm_rap/set_cm_rap,cm_rap
      
      set_cm_rap=.false. ! then cm_rap will be set as .5d0*dlog(xbk(1)*ebeam(1)/(xbk(2)*ebeam(2)))
                         ! ebeam(1) and ebeam(2) are defined here thanks to 'run.inc'
      shat = x1*ebeam(1)*ebeam(2)
      return 
      end

      subroutine get_dummy_x1_x2(sjac, X, R, pbeam1, pbeam2, stot,shat)
      implicit none
      include 'maxparticles.inc'
      include 'run.inc'
c      include 'genps.inc'
      double precision sjac ! jacobian. should be updated not reinit
      double precision X(2)   ! bjorken X. output
      double precision R(2)    ! random value after grid transfrormation. between 0 and 1
      double precision pbeam1(0:3) ! momentum of the first beam
      double precision pbeam2(0:3) ! momentum of the second beam
      double precision stot        ! total energy
      double precision shat        ! output

c     global variable to set (or not)
      double precision cm_rap
      logical set_cm_rap
      common/to_cm_rap/set_cm_rap,cm_rap
      
      set_cm_rap=.false. ! then cm_rap will be set as .5d0*dlog(xbk(1)*ebeam(1)/(xbk(2)*ebeam(2)))
                         ! ebeam(1) and ebeam(2) are defined here thanks to 'run.inc'
      shat = x(1)*x(2)*ebeam(1)*ebeam(2)
      return 
      end


      logical  function dummy_boostframe()
      implicit none
c
c      
      dummy_boostframe = .false.
      return
      end
      

      Subroutine transpole(pole1,width1,x1,y,jac)
c**********************************************************************
c     This routine transfers evenly spaced x values between 0 and 1
c     to y values with a pole at y=pole with width width and returns
c     the appropriate jacobian for this.  If x<del or x>1-del, uses
c     a linear transformation.  This ensures ability to cover entire 
c     region, even away from B.W.
c
c     If pole<0 then assumes have sqrt(1d0/(x^2+a^2)) type pole
c     If pole<0 then assumes have x/(x^2+a^2) type pole
c
c**********************************************************************
      implicit none
c
c     Constants
c
      double precision del
      parameter       (del=1d-22)          !Must agree with del in untranspole
c
c     Arguments
c
      double precision pole,width,y,jac
      double precision x1

c
c     Local
c
      double precision z,zmin,zmax,xmin,xmax,ez
      double precision pole1,width1,x,xc
      double precision a,b
c
c     small width treatment
c
      double precision small_width_treatment
      common/narrow_width/small_width_treatment
c-----
c  Begin Code
c-----
      pole=pole1
      width=width1

      x = x1
      if (pole .gt. 0d0) then
         if (width.lt.pole*small_width_treatment)then
            width = pole * small_width_treatment
            jac = jac * width/width1
         endif

         zmin = atan((-pole)/width)/width
         zmax = atan((1d0-pole)/width)/width
         if (x .gt. del .and. x .lt. 1d0-del) then
            z = zmin+(zmax-zmin)*x
            y = pole+width*tan(width*z)
            jac = jac *(width/cos(width*z))**2*(zmax-zmin)
         elseif (x .lt. del) then
            xmin = 0d0
            z    = zmin+(zmax-zmin)*del
            xmax = pole+width*tan(width*z)
            y = xmin+x*(xmax-xmin)/del
            jac = jac*(xmax-xmin)/del
         else
            xmax = 1d0
            z    = zmin+(zmax-zmin)*(1d0-del)
            xmin = pole+width*tan(width*z)
            y = xmin+(x+del-1d0)*(xmax-xmin)/del
            jac = jac*(xmax-xmin)/del
         endif
      elseif(pole .gt. -1d0) then       !1/sqrt(x^2+width^2) t-channel
         if (x .gt. .5d0) then          !Don't do anything here t>0
            y=x
         else
            zmin = log(2d0*width)       !2*width is because x->1-2*x
            zmax = log(1d0+sqrt(1d0+4d0*width*width))
            x=1d0-x*2d0
            z = zmin+(zmax-zmin)*x
            ez = exp(z)
            y = (1d0-.5d0*(ez-4d0*width*width/ez))/2d0
            jac = jac *(zmax-zmin)*.5d0*(ez+4d0*width*width/ez)
c            x = .5d0*(1d0-x)
         endif
c-------
c    tjs 3/5/2011  Perform 1/x transformation  using y=xo^(1-x)
c-------
      elseif(pole .eq. -15d0 .and. width .gt. 0d0) then !1/x   limit of width         
c         if (x .lt. width) then      !No transformation below cutoff
         xc = width
         xc = 1d0/(1d0-log(width))
         if (x .le. xc) then      !No transformation below cutoff
            y=x*width/xc
            jac = jac * width / xc
         else
            z = (x-xc)/(1d0-xc)
            y=width**(1d0-z)
            jac = jac * y * (-log(width))/(1d0-xc)
c            write(*,*) "trans",x,y,z
         endif
c         write(*,*) 'Transpole called',x,y
         return
      elseif(pole .ge. -2d0 .and. width .gt. 0d0) then !1/x^2   limit of width
         if (x .lt. width) then      !No transformation below cutoff
            y=x
         else
c---------
c   tjs 5/1/2008  modified for any y=x^-n transformation       
c-----------
            z = 1d0 - x + width
            b = ( 1d0-width) / (width**(pole+1d0) - 1d0)
            a = width - b
            y = a + b * z**(pole+1)
            jac = jac * abs((pole+1d0) * b * z**(pole))
c            write(*,*) "pre-trans",x,y
c            call untranspole(pole,width,x,y,jac)
c            write(*,*) "post-trans",x,y
c-----uncomment for 1/x^2 tjs -------
c            x = 1d0-x+width
c            y=width/x
c            jac = jac*width/(x*x)
c------------------------------------
            

c            write(*,*) 'trans',x,width/(x*x)
         endif

      elseif(pole .gt. -1d99) then       !1/sqrt(x^2+width^2) s-channel
         zmin = log(width)
         zmax = log(1d0+sqrt(1d0+width*width))
         if (x .gt. del .and. x .lt. 1d0-del) then
            z = zmin+(zmax-zmin)*x
            ez = exp(z)
            y = .5d0*(ez-width*width/ez)
            jac = jac *(zmax-zmin)*.5d0*(ez+width*width/ez)
         elseif (x .le. del) then
            xmin = 0d0
            z    = zmin+(zmax-zmin)*del
            ez   = exp(z)
            xmax = .5d0*(ez-width*width/ez)
            y = xmin+x*(xmax-xmin)/del
            jac = jac*(xmax-xmin)/del
         else
            xmax = 1d0
            z    = zmin+(zmax-zmin)*(1d0-del)
            ez   = exp(z)
            xmin = .5d0*(ez-width*width/ez)
            y = xmin+(x+del-1d0)*(xmax-xmin)/del
            jac = jac*(xmax-xmin)/del
         endif
      elseif(pole .gt. -8d99) then
         zmin = .5d0*log(width*width)
         zmax = .5d0*log(1d0+width*width)
         if (x .gt. del .and. x .lt. 1d0-del) then
            z = zmin+(zmax-zmin)*x
            ez = exp(2d0*z)
            y = sqrt(ez-width*width)
            jac = jac *(zmax-zmin)*ez/sqrt(ez-width*width)
         elseif (x .lt. del) then
            xmin = 0d0
            z    = zmin+(zmax-zmin)*del
            xmax = sqrt(exp(2d0*z)-width*width)
            y = xmin+x*(xmax-xmin)/del
            jac = jac*(xmax-xmin)/del
         else
            xmax = 1d0
            z    = zmin+(zmax-zmin)*(1d0-del)
            xmin = sqrt(exp(2d0*z)-width*width)
            y = xmin+(x+del-1d0)*(xmax-xmin)/del
            jac = jac*(xmax-xmin)/del
         endif
      endif
      end

      Subroutine untranspole(pole1,width1,x,y1,jac)
c**********************************************************************
c     This routine transfers takes values of y for a given pole and
c     width, and returns the value of x (which an evenly placed
c     random number) would have been used to get that value of y.
c     it also returns the jacobian associated with this choice.
c**********************************************************************
      implicit none
c
c     Constants
c
      double precision del
      parameter       (del=1d-22)          !Must agree with del in untranspole
c
c     Arguments
c
      double precision pole1,width1,y1,jac
      real*8 x
c
c     small width treatment
c
      double precision small_width_treatment
      common/narrow_width/small_width_treatment
c
c     Local
c
      double precision z,zmin,zmax,xmin,xmax,ez
      double precision pole,width,y,xc
      double precision a,b
      double precision xgmin,xgmax       ! these should be identical 
      parameter (xgmin=-1d0, xgmax=1d0)  ! to the ones in genps.inc
c-----
c  Begin Code
c-----
      pole=pole1
      width=width1
      y = y1
      if (pole .gt. 0d0) then                   !BW 
         if (width.lt.pole*small_width_treatment)then
            width = pole * small_width_treatment
            jac = jac * width/width1
         endif
         zmin = atan((-pole)/width)/width
         zmax = atan((1d0-pole)/width)/width
         z = atan((y-pole)/width)/width
         x = (z-zmin)/(zmax-zmin)
         if (x .le. del) then
            xmin = 0d0
            z    = zmin+(zmax-zmin)*del
            xmax = pole+width*tan(width*z)
            if(xmin.lt.xmax) then
               x = (y-xmin)*del/(xmax-xmin)
            else
               x=xmin
            endif
            jac = jac*(xmax-xmin)/del
         elseif (x .ge. 1d0-del) then
            xmax = 1d0
            z    = zmin+(zmax-zmin)*(1d0-del)
            xmin = pole+width*tan(width*z)
            if(xmin.lt.xmax) then
               x = (y-xmin)*del/(xmax-xmin)-del+1d0
            else
               x=xmin
            endif
            jac = jac*(xmax-xmin)/del
c RF (2014/07/07): code is not protected against this special case. In this case,
c simply set x to 1 and the jac to zero so that this PS point will not
c contribute (but you do get the correct xbin_min and xbin_max in
c sample_get_x)
            if (y.eq.xgmax .and. xmin.ge.xgmax) then
               x=1d0
               jac=0d0
            endif
         else
            jac = jac *(width/cos(width*z))**2*(zmax-zmin)
         endif
c-------
c    tjs 3/5/2011  Perform 1/x transformation  using y=xo^(1-x)
c-------
      elseif(pole .eq. -15d0 .and. width .gt. 0d0) then !1/x   limit of width
         xc = 1d0/(1d0-log(width))
c         xc = width
         if (y .le. width) then      !No transformation below cutoff
            x = y*xc/width
         else
            z = 1d0-log(y)/log(width)
            x = z*(1d0-xc) + xc
c            write(*,*) "untrans",x,y,z
         endif
         return
      elseif(pole .gt. -1d0) then !1/sqrt((.5-x)^2+width^2)  t-channel
         if (y .gt. .5d0) then
            x=y
         else
            zmin = log(width*2d0)
            zmax = log(1d0+sqrt(1d0+4d0*width*width))
            y = (1d0-2d0*y)
            z = log(y+sqrt(y*y+4d0*width*width))
            x = (z - zmin)/(zmax-zmin)
            x = .5d0*(1d0-x)
            ez = exp(z)
            jac = jac *(zmax-zmin)*.5d0*(ez+4d0*width*width/ez)
            y = (1d0-y)/2d0
         endif

      elseif(pole .gt. -5d0 .and. width .gt. 0d0) then !1/x^2   limit of width
         if (y .lt. width) then      !No transformation below cutoff
            x=y
         else
c---------
c   tjs 5/1/2008  modified for any y=x^-n transformation       
c-----------
            b = ( 1d0-width) / (width**(pole+1d0) - 1d0)
            a = width - b
            z = ((y-a)/b)**(1d0/(pole+1)) 
            x = 1d0 - z + width
            jac = jac * abs((pole+1d0) * b * z**(pole))

c-------------------
c Uncomment below for y=1/x^2
c-------------------
c            x=width/y
c            write(*,*) 'untr',x,width/(x*x)
c            jac = jac*width/(x*x)
c            x = 1d0-x+width
         endif

      elseif(pole .gt. -5d99) then !1/sqrt(x^2+width^2)  s-channel
         zmin = log(width)
         zmax = log(1d0+sqrt(1d0+width*width))
         if (pole .gt. -1d0 .and. y .lt. -pole) y=-pole-y
         z = log(y+sqrt(y*y+width*width))
         x = (z - zmin)/(zmax-zmin)
         if (x .gt. del .and. x .lt. 1d0-del) then
            ez = exp(z)
            jac = jac *(zmax-zmin)*.5d0*(ez+width*width/ez)
         elseif (x .lt. del) then
            xmin = 0d0
            z    = zmin+(zmax-zmin)*del
            ez   = exp(z)
            xmax = .5d0*(ez-width*width/ez)
c            y = xmin+x*(xmax-xmin)/del
            if(xmin.lt.xmax) then
               x = (y-xmin)*del/(xmax-xmin)
            else
               x=xmin
            endif
            jac = jac*(xmax-xmin)/del
         else
            xmax = 1d0
            z    = zmin+(zmax-zmin)*(1d0-del)
            ez   = exp(z)
            xmin = .5d0*(ez-width*width/ez)
c            y = xmin+(x+del-1d0)*(xmax-xmin)/del
            x = (y-xmin)*del/(xmax-xmin)-del+1d0
            jac = jac*(xmax-xmin)/del
         endif
      endif
      end

C     This File is Automatically generated by ALOHA 
C     The process calculated in this file is: 
C     Gamma(-1,2,-2)*Gamma(-1,4,-3)*ProjM(-3,3)*ProjM(-2,1)
C     
      SUBROUTINE FFFF18_4(F1, F2, F3, COUP, M4, W4,F4)
      IMPLICIT NONE
      COMPLEX*16 CI
      PARAMETER (CI=(0D0,1D0))
      COMPLEX*16 COUP
      COMPLEX*16 F1(*)
      COMPLEX*16 F2(*)
      COMPLEX*16 F3(*)
      COMPLEX*16 F4(6)
      REAL*8 M4
      REAL*8 P4(0:3)
      REAL*8 W4
      COMPLEX*16 DENOM
      F4(1) = +F1(1)+F2(1)+F3(1)
      F4(2) = +F1(2)+F2(2)+F3(2)
      P4(0) = -DBLE(F4(1))
      P4(1) = -DBLE(F4(2))
      P4(2) = -DIMAG(F4(2))
      P4(3) = -DIMAG(F4(1))
      DENOM = COUP/(P4(0)**2-P4(1)**2-P4(2)**2-P4(3)**2 - M4 * (M4 -CI
     $ * W4))
      F4(3)= DENOM*2D0 * CI*(F2(5)*(F1(3)*F3(4)*(-P4(1)+CI*(P4(2)))
     $ +F1(4)*F3(3)*(P4(1)-CI*(P4(2))))+F2(6)*(F1(3)*F3(4)*(-P4(0)
     $ +P4(3))+F1(4)*F3(3)*(P4(0)-P4(3))))
      F4(4)= DENOM*2D0 * CI*(F2(5)*(F1(3)*F3(4)*(P4(0)+P4(3))-F1(4)
     $ *F3(3)*(P4(0)+P4(3)))+F2(6)*(F1(3)*F3(4)*(P4(1)+CI*(P4(2)))
     $ -F1(4)*F3(3)*(P4(1)+CI*(P4(2)))))
      F4(5)= DENOM*2D0 * CI * F2(6)*M4*(-F1(3)*F3(4)+F1(4)*F3(3))
      F4(6)= DENOM*2D0 * CI * F2(5)*M4*(F1(3)*F3(4)-F1(4)*F3(3))
      END


C     This File is Automatically generated by ALOHA 
C     The process calculated in this file is: 
C     Gamma(-1,2,-2)*Gamma(-1,4,-3)*ProjM(-3,3)*ProjM(-2,1)
C     
      SUBROUTINE FFFF18_24_28_29_4(F1, F2, F3, COUP1, COUP2, COUP3,
     $  COUP4, M4, W4,F4)
      IMPLICIT NONE
      COMPLEX*16 CI
      PARAMETER (CI=(0D0,1D0))
      COMPLEX*16 COUP1
      COMPLEX*16 COUP2
      COMPLEX*16 COUP3
      COMPLEX*16 COUP4
      COMPLEX*16 F1(*)
      COMPLEX*16 F2(*)
      COMPLEX*16 F3(*)
      COMPLEX*16 F4(6)
      COMPLEX*16 FTMP(6)
      REAL*8 M4
      REAL*8 P4(0:3)
      REAL*8 W4
      COMPLEX*16 DENOM
      INTEGER*4 I
      CALL FFFF18_4(F1,F2,F3,COUP1,M4,W4,F4)
      CALL FFFF24_4(F1,F2,F3,COUP2,M4,W4,FTMP)
      DO I = 3, 6
        F4(I) = F4(I) + FTMP(I)
      ENDDO
      CALL FFFF28_4(F1,F2,F3,COUP3,M4,W4,FTMP)
      DO I = 3, 6
        F4(I) = F4(I) + FTMP(I)
      ENDDO
      CALL FFFF29_4(F1,F2,F3,COUP4,M4,W4,FTMP)
      DO I = 3, 6
        F4(I) = F4(I) + FTMP(I)
      ENDDO
      END


C     This File is Automatically generated by ALOHA 
C     The process calculated in this file is: 
C     Gamma(-1,2,-2)*Gamma(-1,4,-3)*ProjM(-3,3)*ProjM(-2,1)
C     
      SUBROUTINE FFFF18_28_4(F1, F2, F3, COUP1, COUP2, M4, W4,F4)
      IMPLICIT NONE
      COMPLEX*16 CI
      PARAMETER (CI=(0D0,1D0))
      COMPLEX*16 COUP1
      COMPLEX*16 COUP2
      COMPLEX*16 COUP3
      COMPLEX*16 COUP4
      COMPLEX*16 F1(*)
      COMPLEX*16 F2(*)
      COMPLEX*16 F3(*)
      COMPLEX*16 F4(6)
      COMPLEX*16 FTMP(6)
      REAL*8 M4
      REAL*8 P4(0:3)
      REAL*8 W4
      COMPLEX*16 DENOM
      INTEGER*4 I
      CALL FFFF18_4(F1,F2,F3,COUP1,M4,W4,F4)
      CALL FFFF28_4(F1,F2,F3,COUP2,M4,W4,FTMP)
      DO I = 3, 6
        F4(I) = F4(I) + FTMP(I)
      ENDDO
      END

C     This File is Automatically generated by ALOHA 
C     The process calculated in this file is: 
C     Gamma(-1,2,-2)*Gamma(-1,4,-3)*ProjM(-3,3)*ProjM(-2,1)
C     
      SUBROUTINE FFFF18_3(F1, F2, F4, COUP, M3, W3,F3)
      IMPLICIT NONE
      COMPLEX*16 CI
      PARAMETER (CI=(0D0,1D0))
      COMPLEX*16 COUP
      COMPLEX*16 F1(*)
      COMPLEX*16 F2(*)
      COMPLEX*16 F3(6)
      COMPLEX*16 F4(*)
      REAL*8 M3
      REAL*8 P3(0:3)
      REAL*8 W3
      COMPLEX*16 DENOM
      F3(1) = +F1(1)+F2(1)+F4(1)
      F3(2) = +F1(2)+F2(2)+F4(2)
      P3(0) = -DBLE(F3(1))
      P3(1) = -DBLE(F3(2))
      P3(2) = -DIMAG(F3(2))
      P3(3) = -DIMAG(F3(1))
      DENOM = COUP/(P3(0)**2-P3(1)**2-P3(2)**2-P3(3)**2 - M3 * (M3 -CI
     $ * W3))
      F3(3)= DENOM*2D0 * CI * F1(4)*M3*(-F4(6)*F2(5)+F4(5)*F2(6))
      F3(4)= DENOM*2D0 * CI * F1(3)*M3*(F4(6)*F2(5)-F4(5)*F2(6))
      F3(5)= DENOM*(-2D0 * CI)*(F1(3)*(F2(5)*-F4(6)*(P3(1)+CI*(P3(2)))
     $ +F2(6)*F4(5)*(P3(1)+CI*(P3(2))))+F1(4)*(F2(5)*F4(6)*(-P3(0)
     $ +P3(3))+F2(6)*F4(5)*(P3(0)-P3(3))))
      F3(6)= DENOM*(-2D0 * CI)*(F1(3)*(F2(5)*F4(6)*(P3(0)+P3(3))-F2(6)
     $ *F4(5)*(P3(0)+P3(3)))+F1(4)*(F2(5)*F4(6)*(P3(1)-CI*(P3(2)))
     $ +F2(6)*F4(5)*(-P3(1)+CI*(P3(2)))))
      END


C     This File is Automatically generated by ALOHA 
C     The process calculated in this file is: 
C     Gamma(-1,2,-2)*Gamma(-1,4,-3)*ProjM(-3,3)*ProjM(-2,1)
C     
      SUBROUTINE FFFF18_28_3(F1, F2, F4, COUP1, COUP2, M3, W3,F3)
      IMPLICIT NONE
      COMPLEX*16 CI
      PARAMETER (CI=(0D0,1D0))
      COMPLEX*16 COUP1
      COMPLEX*16 COUP2
      COMPLEX*16 F1(*)
      COMPLEX*16 F2(*)
      COMPLEX*16 F3(6)
      COMPLEX*16 F4(*)
      COMPLEX*16 FTMP(6)
      REAL*8 M3
      REAL*8 P3(0:3)
      REAL*8 W3
      COMPLEX*16 DENOM
      INTEGER*4 I
      CALL FFFF18_3(F1,F2,F4,COUP1,M3,W3,F3)
      CALL FFFF28_3(F1,F2,F4,COUP2,M3,W3,FTMP)
      DO I = 3, 6
        F3(I) = F3(I) + FTMP(I)
      ENDDO
      END


C     This File is Automatically generated by ALOHA 
C     The process calculated in this file is: 
C     Gamma(-1,2,-2)*Gamma(-1,4,-3)*ProjM(-3,3)*ProjM(-2,1)
C     
      SUBROUTINE FFFF18_24_28_29_3(F1, F2, F4, COUP1, COUP2, COUP3,
     $  COUP4, M3, W3,F3)
      IMPLICIT NONE
      COMPLEX*16 CI
      PARAMETER (CI=(0D0,1D0))
      COMPLEX*16 COUP1
      COMPLEX*16 COUP2
      COMPLEX*16 COUP3
      COMPLEX*16 COUP4
      COMPLEX*16 F1(*)
      COMPLEX*16 F2(*)
      COMPLEX*16 F3(6)
      COMPLEX*16 F4(*)
      COMPLEX*16 FTMP(6)
      REAL*8 M3
      REAL*8 P3(0:3)
      REAL*8 W3
      COMPLEX*16 DENOM
      INTEGER*4 I
      CALL FFFF18_3(F1,F2,F4,COUP1,M3,W3,F3)
      CALL FFFF24_3(F1,F2,F4,COUP2,M3,W3,FTMP)
      DO I = 3, 6
        F3(I) = F3(I) + FTMP(I)
      ENDDO
      CALL FFFF28_3(F1,F2,F4,COUP3,M3,W3,FTMP)
      DO I = 3, 6
        F3(I) = F3(I) + FTMP(I)
      ENDDO
      CALL FFFF29_3(F1,F2,F4,COUP4,M3,W3,FTMP)
      DO I = 3, 6
        F3(I) = F3(I) + FTMP(I)
      ENDDO
      END

      DOUBLE PRECISION FUNCTION DSIG(PP,WGT,IMODE)
C     ****************************************************
C     
C     Generated by MadGraph5_aMC@NLO v. 2.8.2, 2020-10-30
C     By the MadGraph5_aMC@NLO Development Team
C     Visit launchpad.net/madgraph5 and amcatnlo.web.cern.ch
C     
C     Process: g u > t t~ g u NP<=2 QCD<=4 QED=0 @2
C     Process: g c > t t~ g c NP<=2 QCD<=4 QED=0 @2
C     Process: g d > t t~ g d NP<=2 QCD<=4 QED=0 @2
C     Process: g s > t t~ g s NP<=2 QCD<=4 QED=0 @2
C     Process: g u~ > t t~ g u~ NP<=2 QCD<=4 QED=0 @2
C     Process: g c~ > t t~ g c~ NP<=2 QCD<=4 QED=0 @2
C     Process: g d~ > t t~ g d~ NP<=2 QCD<=4 QED=0 @2
C     Process: g s~ > t t~ g s~ NP<=2 QCD<=4 QED=0 @2
C     Process: g b > t t~ g b NP<=2 QCD<=4 QED=0 @2
C     Process: g b~ > t t~ g b~ NP<=2 QCD<=4 QED=0 @2
C     
C     RETURNS DIFFERENTIAL CROSS SECTION 
C     FOR MULTIPLE PROCESSES IN PROCESS GROUP
C     Input:
C     pp    4 momentum of external particles
C     wgt   weight from Monte Carlo
C     imode 0 run, 1 init, 2 reweight,
C     3 finalize, 4 only PDFs
C     Output:
C     Amplitude squared and summed
C     ****************************************************
      USE DISCRETESAMPLER
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INCLUDE 'genps.inc'
      INCLUDE 'maxconfigs.inc'
      INCLUDE 'nexternal.inc'
      INCLUDE 'maxamps.inc'
      REAL*8     PI
      PARAMETER (PI=3.1415926D0)
C     
C     ARGUMENTS 
C     
      DOUBLE PRECISION PP(0:3,NEXTERNAL), WGT
      INTEGER IMODE
C     
C     LOCAL VARIABLES 
C     
      INTEGER LMAPPED
      INTEGER I,J,K,LUN,ICONF,IMIRROR,NPROC
      SAVE NPROC
      INTEGER SYMCONF(0:LMAXCONFIGS)
      SAVE SYMCONF
      DOUBLE PRECISION SUMPROB,TOTWGT,R,XDUM
      INTEGER CONFSUB(MAXSPROC,LMAXCONFIGS)
      INCLUDE 'config_subproc_map.inc'
      INTEGER PERMS(NEXTERNAL,LMAXCONFIGS)
      INCLUDE 'symperms.inc'
      LOGICAL MIRRORPROCS(MAXSPROC)
      INCLUDE 'mirrorprocs.inc'
C     SELPROC is vector of selection weights for the subprocesses
C     SUMWGT is vector of total weight for the subprocesses
C     NUMEVTS is vector of event calls for the subprocesses
      DOUBLE PRECISION SELPROC(2, MAXSPROC,LMAXCONFIGS)
      DOUBLE PRECISION SUMWGT(2, MAXSPROC,LMAXCONFIGS)
      INTEGER NUMEVTS(2, MAXSPROC,LMAXCONFIGS)
      INTEGER LARGEDIM
      PARAMETER (LARGEDIM=2*MAXSPROC*LMAXCONFIGS)
      DATA SELPROC/LARGEDIM*0D0/
      DATA SUMWGT/LARGEDIM*0D0/
      DATA NUMEVTS/LARGEDIM*0/
      SAVE SELPROC,SUMWGT,NUMEVTS
      REAL*8 MC_GROUPED_PROC_JACOBIAN
      INTEGER GROUPED_MC_GRID_STATUS
C     
C     EXTERNAL FUNCTIONS
C     
      INTEGER NEXTUNOPEN
      DOUBLE PRECISION DSIGPROC
      EXTERNAL NEXTUNOPEN,DSIGPROC
C     
C     GLOBAL VARIABLES
C     
      INTEGER NB_SPIN_STATE(2)
      DATA  NB_SPIN_STATE /2,2/
      COMMON /NB_HEL_STATE/ NB_SPIN_STATE

      INCLUDE 'coupl.inc'
      INCLUDE 'run.inc'
C     ICONFIG has this config number
      INTEGER MAPCONFIG(0:LMAXCONFIGS), ICONFIG
      COMMON/TO_MCONFIGS/MAPCONFIG, ICONFIG
C     IPROC has the present process number
      INTEGER IPROC
      COMMON/TO_MIRROR/IMIRROR, IPROC
C     CM_RAP has parton-parton system rapidity
      DOUBLE PRECISION CM_RAP
      LOGICAL SET_CM_RAP
      COMMON/TO_CM_RAP/SET_CM_RAP,CM_RAP
C     Keep track of whether cuts already calculated for this event
      LOGICAL CUTSDONE,CUTSPASSED
      COMMON/TO_CUTSDONE/CUTSDONE,CUTSPASSED
C     To be able to control when the matrix<i> subroutine can add
C      entries to the grid for the MC over helicity configuration
      LOGICAL ALLOW_HELICITY_GRID_ENTRIES
      DATA ALLOW_HELICITY_GRID_ENTRIES/.TRUE./
      COMMON/TO_ALLOW_HELICITY_GRID_ENTRIES/ALLOW_HELICITY_GRID_ENTRIES
C     To limit the number of calls to switchmom, use in DSIGPROC the
C      cached variable last_iconfig. It is in this subroutine as well
C      so that we can set it to -1 to ignore caching (to prevent
C      undesired effect if this subroutine is called from elsewhere
C      and to 0 to reset the cache.
      INTEGER LAST_ICONF
      DATA LAST_ICONF/-1/
      COMMON/TO_LAST_ICONF/LAST_ICONF

C     ----------
C     BEGIN CODE
C     ----------
      DSIG=0D0

C     Make sure cuts are evaluated for first subprocess
      CUTSDONE=.FALSE.
      CUTSPASSED=.FALSE.

      IF(IMODE.EQ.1)THEN
C       Set up process information from file symfact
        LUN=NEXTUNOPEN()
        IPROC=1
        SYMCONF(IPROC)=ICONFIG
        OPEN(UNIT=LUN,FILE='../symfact.dat',STATUS='OLD',ERR=20)
        DO WHILE(.TRUE.)
          READ(LUN,*,ERR=10,END=10) XDUM, ICONF
          IF(ICONF.EQ.-MAPCONFIG(ICONFIG))THEN
            IPROC=IPROC+1
            SYMCONF(IPROC)=INT(XDUM)
          ENDIF
        ENDDO
 10     SYMCONF(0)=IPROC
        CLOSE(LUN)
        RETURN
 20     SYMCONF(0)=IPROC
        WRITE(*,*)'Error opening symfact.dat. No permutations used.'
        RETURN
      ELSE IF(IMODE.EQ.2)THEN
C       Output weights and number of events
        SUMPROB=0D0
        DO J=1,SYMCONF(0)
          DO I=1,MAXSPROC
            DO K=1,2
              SUMPROB=SUMPROB+SUMWGT(K,I,J)
            ENDDO
          ENDDO
        ENDDO
        WRITE(*,*)'Relative summed weights:'
        IF (SUMPROB.NE.0D0)THEN
          DO J=1,SYMCONF(0)
            WRITE(*,'(16E12.4)')((SUMWGT(K,I,J)/SUMPROB,K=1,2),I=1
     $       ,MAXSPROC)
          ENDDO
        ENDIF
        SUMPROB=0D0
        DO J=1,SYMCONF(0)
          DO I=1,MAXSPROC
            DO K=1,2
              SUMPROB=SUMPROB+NUMEVTS(K,I,J)
            ENDDO
          ENDDO
        ENDDO
        WRITE(*,*)'Relative number of events:'
        IF (SUMPROB.NE.0D0)THEN
          DO J=1,SYMCONF(0)
            WRITE(*,'(16E12.4)')((NUMEVTS(K,I,J)/SUMPROB,K=1,2),I=1
     $       ,MAXSPROC)
          ENDDO
        ENDIF
        WRITE(*,*)'Events:'
        DO J=1,SYMCONF(0)
          WRITE(*,'(16I12)')((NUMEVTS(K,I,J),K=1,2),I=1,MAXSPROC)
        ENDDO
C       Reset weights and number of events
        DO J=1,SYMCONF(0)
          DO I=1,MAXSPROC
            DO K=1,2
              NUMEVTS(K,I,J)=0
              SUMWGT(K,I,J)=0D0
            ENDDO
          ENDDO
        ENDDO
        RETURN
      ELSE IF(IMODE.EQ.3)THEN
C       No finalize needed
        RETURN
      ENDIF

C     IMODE.EQ.0, regular run mode
      IF(MC_GROUPED_SUBPROC.AND.DS_GET_DIM_STATUS('grouped_processes')
     $ .EQ.-1) THEN
        CALL DS_REGISTER_DIMENSION('grouped_processes', 0)
        CALL DS_SET_MIN_POINTS(10,'grouped_processes')
        DO J=1,SYMCONF(0)
          DO IPROC=1,MAXSPROC
            IF(CONFSUB(IPROC,SYMCONF(J)).NE.0) THEN
              DO IMIRROR=1,2
                IF(IMIRROR.EQ.1.OR.MIRRORPROCS(IPROC))THEN
                  CALL MAP_3_TO_1(J,IPROC,IMIRROR,MAXSPROC,2,LMAPPED)
                  CALL DS_ADD_BIN('grouped_processes',LMAPPED)
                ENDIF
              ENDDO
            ENDIF
          ENDDO
        ENDDO
      ENDIF
      IF(MC_GROUPED_SUBPROC.AND.DS_DIM_INDEX(RUN_GRID,
     $  'PDF_convolution',.TRUE.).EQ.-1) THEN
        CALL DS_REGISTER_DIMENSION('PDF_convolution', 0,
     $    ALL_GRIDS=.FALSE.)
      ENDIF

C     Select among the subprocesses based on PDF weight
      SUMPROB=0D0
C     Turn caching on in dsigproc to avoid too many calls to switchmom
      LAST_ICONF=0
      DO J=1,SYMCONF(0)
        DO IPROC=1,MAXSPROC
          IF(CONFSUB(IPROC,SYMCONF(J)).NE.0) THEN
            DO IMIRROR=1,2
              IF(IMIRROR.EQ.1.OR.MIRRORPROCS(IPROC))THEN
C               Calculate PDF weight for all subprocesses
                SELPROC(IMIRROR,IPROC,J)=DSIGPROC(PP,J,IPROC,IMIRROR
     $           ,SYMCONF,CONFSUB,1D0,4)
                IF(MC_GROUPED_SUBPROC) THEN
                  CALL MAP_3_TO_1(J,IPROC,IMIRROR,MAXSPROC,2,LMAPPED)
                  CALL DS_ADD_ENTRY('PDF_convolution',LMAPPED
     $             ,SELPROC(IMIRROR,IPROC,J),.TRUE.)
                ENDIF
                SUMPROB=SUMPROB+SELPROC(IMIRROR,IPROC,J)
                IF(IMIRROR.EQ.2)THEN
C                 Need to flip back x values
                  XDUM=XBK(1)
                  XBK(1)=XBK(2)
                  XBK(2)=XDUM
                  CM_RAP=-CM_RAP
                ENDIF
              ENDIF
            ENDDO
          ENDIF
        ENDDO
      ENDDO
C     Turn caching in dsigproc back off to avoid side effects.
      LAST_ICONF=-1

C     Cannot make a selection with all PDFs to zero, so we return now
      IF(SUMPROB.EQ.0.0D0) THEN
        RETURN
      ENDIF

C     Perform the selection
      CALL RANMAR(R)

C     It is important to cache the status before adding any entries to
C      this grid in this
C     routine since it might change it
      GROUPED_MC_GRID_STATUS = DS_GET_DIM_STATUS('grouped_processes')

      IF (MC_GROUPED_SUBPROC.AND.GROUPED_MC_GRID_STATUS.EQ.0) THEN
C       We must initialize the grid and probe all channels
        SUMPROB=0.0D0
C       Turn caching on in dsigproc to avoid too many calls to
C        switchmom
        LAST_ICONF=0
        DO J=1,SYMCONF(0)
          DO I=1,MAXSPROC
            IF(CONFSUB(I,SYMCONF(J)).NE.0) THEN
              DO K=1,2
                IF(K.EQ.1.OR.MIRRORPROCS(I))THEN
                  IPROC=I
                  ICONF=J
                  IMIRROR=K
C                 The IMODE=5 computes the matrix_element only,
C                  without PDF convolution 
                  DSIG=DSIGPROC(PP,ICONF,IPROC,IMIRROR,SYMCONF,CONFSUB
     $             ,WGT,5)
                  CALL MAP_3_TO_1(J,I,K,MAXSPROC,2,LMAPPED)
                  IF (SELPROC(K,I,J).NE.0.0D0) THEN
                    CALL DS_ADD_ENTRY('grouped_processes',LMAPPED,DSIG)
                  ENDIF
                  IF(K.EQ.2)THEN
C                   Need to flip back x values
                    XDUM=XBK(1)
                    XBK(1)=XBK(2)
                    XBK(2)=XDUM
                    CM_RAP=-CM_RAP
                  ENDIF
                  SELPROC(K,I,J) = DABS(DSIG*SELPROC(K,I,J))
                  SUMPROB = SUMPROB + SELPROC(K,I,J)
                ENDIF
              ENDDO
            ENDIF
          ENDDO
        ENDDO
C       Turn caching in dsigproc back off to avoid side effects.
        LAST_ICONF=-1
C       If these additional entries were enough to initialize the
C        gird, then update it
C       To do this check we must *not* used the cached varianble
C        grouped_MC_grid_status
        IF(DS_GET_DIM_STATUS('grouped_processes').GE.1) THEN
          CALL DS_UPDATE_GRID('grouped_processes')
          CALL RESET_CUMULATIVE_VARIABLE()
        ENDIF
      ENDIF

C     If we are still initializing the grid or simply not using one at
C      all, then we pick a point based on PDF only.
      IF (.NOT.MC_GROUPED_SUBPROC.OR.GROUPED_MC_GRID_STATUS.EQ.0) THEN
        R=R*SUMPROB
        ICONF=0
        IPROC=0
        TOTWGT=0D0
        DO J=1,SYMCONF(0)
          DO I=1,MAXSPROC
            IF(CONFSUB(I,SYMCONF(J)).NE.0) THEN
              DO K=1,2
                TOTWGT=TOTWGT+SELPROC(K,I,J)
                IF(R.LT.TOTWGT)THEN
                  IPROC=I
                  ICONF=J
                  IMIRROR=K
                  GOTO 50
                ENDIF
              ENDDO
            ENDIF
          ENDDO
        ENDDO
 50     CONTINUE

        IF(IPROC.EQ.0) RETURN

C       Update weigth w.r.t SELPROC normalized to selection probability

        WGT=WGT*(SUMPROB/SELPROC(IMIRROR,IPROC,ICONF))

      ELSE
C       We are using the grouped_processes grid and it is initialized.
        CALL DS_GET_POINT('grouped_processes',R,LMAPPED
     $   ,MC_GROUPED_PROC_JACOBIAN,'norm',(/'PDF_convolution'/))
        WGT=WGT*MC_GROUPED_PROC_JACOBIAN
        CALL MAP_1_TO_3(LMAPPED,MAXSPROC,2,ICONF,IPROC,IMIRROR)
      ENDIF

C     Redo clustering to ensure consistent with final IPROC
      CUTSDONE=.FALSE.

      IF(GROUPED_MC_GRID_STATUS.EQ.0) THEN
C       If we were in the initialization phase of the grid for MC over
C        grouped processes, we must instruct the matrix<i> subroutine
C        not to add again an entry in the grid for this PS point at
C        the call DSIGPROC just below.
        ALLOW_HELICITY_GRID_ENTRIES = .FALSE.
      ENDIF
C     Call DSIGPROC to calculate sigma for process
      DSIG=DSIGPROC(PP,ICONF,IPROC,IMIRROR,SYMCONF,CONFSUB,WGT,IMODE)
C     Reset ALLOW_HELICITY_GRID_ENTRIES
      ALLOW_HELICITY_GRID_ENTRIES = .TRUE.

C     Below is how one would go about adding each point to the
C      grouped_processes grid
C     However, keeping only the initialization grid is better because'
C     //' in that case all grouped ME's
C     were computed with the same kinematics. For this reason, the
C      code below remains commented.
C     IF(grouped_MC_grid_status.ge.1) then
C     call map_3_to_1(ICONF,IPROC,IMIRROR,MAXSPROC,2,Lmapped)
C     call DS_add_entry('grouped_processes',Lmapped,(DSIG/SELPROC(IMIRR
C     OR,IPROC,ICONF)))
C     ENDIF

      IF(DSIG.GT.0D0)THEN
C       Update summed weight and number of events
        SUMWGT(IMIRROR,IPROC,ICONF)=SUMWGT(IMIRROR,IPROC,ICONF)
     $   +DABS(DSIG*WGT)
        NUMEVTS(IMIRROR,IPROC,ICONF)=NUMEVTS(IMIRROR,IPROC,ICONF)+1
      ENDIF

      RETURN
      END

      FUNCTION DSIGPROC(PP,ICONF,IPROC,IMIRROR,SYMCONF,CONFSUB,WGT
     $ ,IMODE)
C     ****************************************************
C     RETURNS DIFFERENTIAL CROSS SECTION 
C     FOR A PROCESS
C     Input:
C     pp    4 momentum of external particles
C     wgt   weight from Monte Carlo
C     imode 0 run, 1 init, 2 reweight, 3 finalize
C     Output:
C     Amplitude squared and summed
C     ****************************************************

      IMPLICIT NONE

      INCLUDE 'genps.inc'
      INCLUDE 'maxconfigs.inc'
      INCLUDE 'nexternal.inc'
      INCLUDE 'maxamps.inc'
      INCLUDE 'coupl.inc'
      INCLUDE 'run.inc'
C     
C     ARGUMENTS 
C     
      DOUBLE PRECISION DSIGPROC
      DOUBLE PRECISION PP(0:3,NEXTERNAL), WGT
      INTEGER ICONF,IPROC,IMIRROR,IMODE
      INTEGER SYMCONF(0:LMAXCONFIGS)
      INTEGER CONFSUB(MAXSPROC,LMAXCONFIGS)
C     
C     GLOBAL VARIABLES
C     
C     SUBDIAG is vector of diagram numbers for this config
C     IB gives which beam is which (for mirror processes)
      INTEGER SUBDIAG(MAXSPROC),IB(2)
      COMMON/TO_SUB_DIAG/SUBDIAG,IB
C     ICONFIG has this config number
      INTEGER MAPCONFIG(0:LMAXCONFIGS), ICONFIG
      COMMON/TO_MCONFIGS/MAPCONFIG, ICONFIG
C     CM_RAP has parton-parton system rapidity
      DOUBLE PRECISION CM_RAP
      LOGICAL SET_CM_RAP
      COMMON/TO_CM_RAP/SET_CM_RAP,CM_RAP
C     To limit the number of calls to switchmom, use in DSIGPROC the
C      cached variable last_iconfig. When set to -1, it ignores
C      caching (to prevent undesired effect if this subroutine is
C      called from elsewhere) and when set to 0, it resets the cache.
      INTEGER LAST_ICONF
      DATA LAST_ICONF/-1/
      COMMON/TO_LAST_ICONF/LAST_ICONF
C     
C     EXTERNAL FUNCTIONS
C     
      DOUBLE PRECISION DSIG1,DSIG2,DSIG3,DSIG4,DSIG5,DSIG6,DSIG7,DSIG8
      LOGICAL PASSCUTS
C     
C     LOCAL VARIABLES 
C     
      DOUBLE PRECISION P1(0:3,NEXTERNAL),XDUM
      INTEGER I,J,K,JC(NEXTERNAL)
      INTEGER PERMS(NEXTERNAL,LMAXCONFIGS)
      INCLUDE 'symperms.inc'
      SAVE P1,JC

      IF (LAST_ICONF.EQ.-1.OR.LAST_ICONF.NE.ICONF) THEN

        ICONFIG=SYMCONF(ICONF)
        DO I=1,MAXSPROC
          SUBDIAG(I) = CONFSUB(I,SYMCONF(ICONF))
        ENDDO

C       Set momenta according to this permutation
        CALL SWITCHMOM(PP,P1,PERMS(1,MAPCONFIG(ICONFIG)),JC,NEXTERNAL)

        IF (LAST_ICONF.NE.-1) THEN
          LAST_ICONF = ICONF
        ENDIF
      ENDIF

      IB(1)=1
      IB(2)=2

      IF(IMIRROR.EQ.2)THEN
C       Flip momenta (rotate around x axis)
        DO I=1,NEXTERNAL
          P1(2,I)=-P1(2,I)
          P1(3,I)=-P1(3,I)
        ENDDO
C       Flip beam identity
        IB(1)=2
        IB(2)=1
C       Flip x values (to get boost right)
        XDUM=XBK(1)
        XBK(1)=XBK(2)
        XBK(2)=XDUM
C       Flip CM_RAP (to get rapidity right)
        CM_RAP=-CM_RAP
      ENDIF

      DSIGPROC=0D0

      IF (PASSCUTS(P1)) THEN
        IF (IMODE.EQ.0D0.AND.NB_PASS_CUTS.LT.2**12)THEN
          NB_PASS_CUTS = NB_PASS_CUTS + 1
        ENDIF
        IF(IPROC.EQ.1) DSIGPROC=DSIG1(P1,WGT,IMODE)  ! g u > t t~ g u
        IF(IPROC.EQ.2) DSIGPROC=DSIG2(P1,WGT,IMODE)  ! g c > t t~ g c
        IF(IPROC.EQ.3) DSIGPROC=DSIG3(P1,WGT,IMODE)  ! g d > t t~ g d
        IF(IPROC.EQ.4) DSIGPROC=DSIG4(P1,WGT,IMODE)  ! g u~ > t t~ g u~
        IF(IPROC.EQ.5) DSIGPROC=DSIG5(P1,WGT,IMODE)  ! g c~ > t t~ g c~
        IF(IPROC.EQ.6) DSIGPROC=DSIG6(P1,WGT,IMODE)  ! g d~ > t t~ g d~
        IF(IPROC.EQ.7) DSIGPROC=DSIG7(P1,WGT,IMODE)  ! g b > t t~ g b
        IF(IPROC.EQ.8) DSIGPROC=DSIG8(P1,WGT,IMODE)  ! g b~ > t t~ g b~
      ENDIF

      IF (LAST_ICONF.NE.-1.AND.IMIRROR.EQ.2) THEN
C       Flip back local momenta P1 if cached
        DO I=1,NEXTERNAL
          P1(2,I)=-P1(2,I)
          P1(3,I)=-P1(3,I)
        ENDDO
      ENDIF

      RETURN

      END

C     -----------------------------------------
C     Subroutine to map three positive integers
C     I, J and K with upper bounds J_bound and
C     K_bound to a one_dimensional
C     index L
C     -----------------------------------------

      SUBROUTINE MAP_3_TO_1(I,J,K,J_BOUND,K_BOUND,L)
      IMPLICIT NONE
      INTEGER, INTENT(IN)  :: I,J,K,J_BOUND,K_BOUND
      INTEGER, INTENT(OUT) :: L

      L = I*(J_BOUND*(K_BOUND+1)+K_BOUND+1)+J*(K_BOUND+1)+K

      END SUBROUTINE MAP_3_TO_1

C     -----------------------------------------
C     Subroutine to map back the positive 
C     integer L to the three integers 
C     I, J and K with upper bounds
C     J_bound and K_bound.
C     -----------------------------------------

      SUBROUTINE MAP_1_TO_3(L,J_BOUND,K_BOUND,I,J,K)
      IMPLICIT NONE
      INTEGER, INTENT(OUT)  :: I,J,K
      INTEGER, INTENT(IN)   :: L, J_BOUND, K_BOUND
      INTEGER               :: L_RUN

      L_RUN = L
      I = L_RUN/(J_BOUND*(K_BOUND+1)+K_BOUND+1)
      L_RUN = L_RUN - I*((J_BOUND*(K_BOUND+1)+K_BOUND+1))
      J = L_RUN/(K_BOUND+1)
      L_RUN = L_RUN - J*(K_BOUND+1)
      K  = L_RUN

      END SUBROUTINE MAP_1_TO_3


C     
C     Functionality to handling grid
C     

      SUBROUTINE WRITE_GOOD_HEL(STREAM_ID)
      IMPLICIT NONE
      INTEGER STREAM_ID
      INTEGER                 NCOMB
      PARAMETER (             NCOMB=64)
      LOGICAL GOODHEL(NCOMB, 2)
      INTEGER NTRY(2)
      COMMON/BLOCK_GOODHEL/NTRY,GOODHEL
      WRITE(STREAM_ID,*) GOODHEL
      RETURN
      END


      SUBROUTINE READ_GOOD_HEL(STREAM_ID)
      IMPLICIT NONE
      INCLUDE 'genps.inc'
      INTEGER STREAM_ID
      INTEGER                 NCOMB
      PARAMETER (             NCOMB=64)
      LOGICAL GOODHEL(NCOMB, 2)
      INTEGER NTRY(2)
      COMMON/BLOCK_GOODHEL/NTRY,GOODHEL
      READ(STREAM_ID,*) GOODHEL
      NTRY(1) = MAXTRIES + 1
      NTRY(2) = MAXTRIES + 1
      RETURN
      END

      SUBROUTINE INIT_GOOD_HEL()
      IMPLICIT NONE
      INTEGER                 NCOMB
      PARAMETER (             NCOMB=64)
      LOGICAL GOODHEL(NCOMB, 2)
      INTEGER NTRY(2)
      INTEGER I

      DO I=1,NCOMB
        GOODHEL(I,1) = .FALSE.
        GOODHEL(I,2) = .FALSE.
      ENDDO
      NTRY(1) = 0
      NTRY(2) = 0
      END

      INTEGER FUNCTION GET_MAXSPROC()
      IMPLICIT NONE
      INCLUDE 'maxamps.inc'

      GET_MAXSPROC = MAXSPROC
      RETURN
      END

      program symmetry
c*****************************************************************************
c     Given identical particles, and the configurations. This program identifies
c     identical configurations and specifies which ones can be skipped
c*****************************************************************************
      implicit none
c
c     Constants
c
      include 'genps.inc'
      include 'maxconfigs.inc'
      include 'run_config.inc'
      include 'maxamps.inc'
      include 'nexternal.inc'
      include 'cuts.inc'
      include '../../Source/run.inc'
      
      double precision ZERO
      parameter       (ZERO = 0d0)
      integer   maxswitch
      parameter(maxswitch=99)
      integer lun
      parameter (lun=28)
c
c     Local
c
      integer mapconfig(0:lmaxconfigs)
      integer use_config(0:lmaxconfigs)
      integer i,j, npara, nhel_survey
      double precision xdum
      double precision prmass(-max_branch:-1,lmaxconfigs)   !Propagotor mass
      double precision prwidth(-max_branch:-1,lmaxconfigs)  !Propagotor width
      integer pow(-max_branch:-1,lmaxconfigs)
      character*20 param(maxpara),value(maxpara)
      double precision pmass(nexternal)   !External particle mass
      double precision pi1(0:3),pi2(0:3),m1,m2
c
c     Global
c
      include 'coupl.inc'
      logical gridpack
      common/to_gridpack/gridpack
      double precision stot
      common/to_stot/stot
c
c     DATA
c
      integer iforest(2,-max_branch:-1,lmaxconfigs)
      integer sprop(maxsproc,-max_branch:-1,lmaxconfigs)
      integer tprid(-max_branch:-1,lmaxconfigs)
      include 'configs.inc'
      data use_config/0,lmaxconfigs*0/

c
c    needed for the run_card handling
c
      logical gridrun
      integer iseed,lhaid
      character*100 pdlabel
      double precision sf1,sf2,pb1,pb2,d
c-----
c  Begin Code
c-----

c      write(*,*) 'Enter compression (0=none, 1=sym, 2=BW, 3=full)'
c      read(*,*) icomp
c      if (icomp .gt. 3 .or. icomp .lt. 0) icomp=0
c      if (icomp .eq. 0) then
c         write(*,*) 'No compression, summing every diagram and ',
c     $        'every B.W.'
c      elseif (icomp .eq. 1) then
c         write(*,*) 'Using symmetry but summing every B.W. '
c      elseif (icomp .eq. 2) then
c         write(*,*) 'Assuming B.W. but summing every diagram. '
c      elseif (icomp .eq. 3) then
c         write(*,*) 'Full compression. Using symmetry and assuming B.W.'
c      else
c         write(*,*) 'Unknown compression',icomp
c         stop
c      endif

      include '../../Source/run_card.inc'
c      call load_para(npara,param,value)
c      call get_logical(npara,param,value," gridpack ",gridpack,.false.)
c      call get_real(npara,param,value," bwcutoff ",bwcutoff,5d0)
c      call get_real(npara,param,value," ebeam1 ",ebeam(1),0d0)
c      call get_real(npara,param,value," ebeam2 ",ebeam(2),0d0)
c      call get_integer(npara,param,value," lpp1 ",lpp(1),0)
c      call get_integer(npara,param,value," lpp2 ",lpp(2),0)

      call setpara('param_card.dat' )   !Sets up couplings and masses
      include 'pmass.inc'

c     Set stot
      if (nincoming.eq.1) then
         stot=pmass(1)**2
      else
         m1=pmass(1)
         m2=pmass(2)
         if (abs(lpp(1)) .eq. 1 .or. abs(lpp(1)) .eq. 2) m1 = 0.938d0
         if (abs(lpp(2)) .eq. 1 .or. abs(lpp(2)) .eq. 2) m2 = 0.938d0
         if (abs(lpp(1)) .eq. 3) m1 = 0.000511d0
         if (abs(lpp(2)) .eq. 3) m2 = 0.000511d0
         if (mass_ion(1).ge.0d0) m1 = mass_ion(1)
         if (mass_ion(2).ge.0d0) m2 = mass_ion(2)
         if(ebeam(1).lt.m1.and.lpp(1).ne.9) ebeam(1)=m1
         if(ebeam(2).lt.m2.and.lpp(2).ne.9) ebeam(2)=m2
         pi1(0)=ebeam(1)
         pi1(3)=sqrt(max(ebeam(1)**2-m1**2,0d0))
         pi2(0)=ebeam(2)
         pi2(3)=-sqrt(max(ebeam(2)**2-m2**2,0d0))
         stot=m1**2+m2**2+2*(pi1(0)*pi2(0)-pi1(3)*pi2(3))
      endif

c      call printout
      include 'props.inc'

c
c     Start reading use_config from symfact.dat written by MG5
c
      open(unit=25, file='symfact_orig.dat', status='old')
      i=0
      do j=1,mapconfig(0)
         do while(i.lt.mapconfig(j))
            read(25,*) xdum, use_config(j)
            i=int(xdum)
         enddo
      enddo
      close(25)

      call write_bash(mapconfig,use_config,prwidth,icomp,iforest,sprop)
      end


      subroutine write_bash(mapconfig,use_config, prwidth, jcomp,iforest,
     $     sprop)
c***************************************************************************
c     Writes out bash commands to run integration over all of the various
c     configurations, but only for "non-identical" configurations.
c     Also labels multiplication factor for each used configuration
c***************************************************************************
      implicit none
c
c     Constants
c
      include 'genps.inc'
      include 'maxconfigs.inc'
      include 'nexternal.inc'
      include 'run_config.inc'
      include 'maxamps.inc'
      integer    imax,   ibase
      parameter (imax=max_branch-1, ibase=3)
c
c     Arguments
c
      integer mapconfig(0:lmaxconfigs),use_config(0:lmaxconfigs)
      double precision prwidth(-max_branch:-1,lmaxconfigs)  !Propagotor width
      integer iforest(2,-max_branch:-1,lmaxconfigs)
      integer sprop(maxsproc,-max_branch:-1,lmaxconfigs)
      integer jcomp

c
c     local
c
      integer i, j, nbw, ic, icode
      integer ncode, nconf, nsym
      double precision dconfig
      character*20 formstr,formstr2,filename
      integer iarray(imax)
      logical lconflict(-max_branch:nexternal)
      logical done,file_exists
      logical failConfig
      external failConfig
      integer gForceBW(-max_branch:-1,lmaxconfigs)  ! Forced BW
      include 'decayBW.inc'

c-----
c  Begin Code
c-----
c     First open symfact file
      open (unit=27, file = 'symfact.dat', status='unknown')
c
c     VA 15/05/2015 It was +3, leading to symfact.dat lines like these
c     112-100
c     So I add here a safety margin 10.
      nsym=int(dlog10(dble(mapconfig(0))))+13

      ic = 0      
c     ncode is number of digits needed for the code
      ncode=int(dlog10(3d0)*(max_particles-3))+1
      do i=1,mapconfig(0)
         if (use_config(i) .gt. 0) then
            call bw_conflict(i,iforest(1,-max_branch,i),lconflict,
     $           sprop(1,-max_branch,i), gForceBW(-max_branch,i))
            nbw=0               !Look for B.W. resonances
            if (jcomp .eq. 0 .or. jcomp .eq. 1 .or. .true.) then
               do j=1,imax
                  iarray(j)=0   !Assume no cuts on BW
               enddo
               do j=1,nexternal-3
c                  write(*,*) 'Width',prwidth(-j,i),j,ic                 
                  if (prwidth(-j,i) .gt. 0d0 .and. iforest(1,-j,i).ne.1) then
                     nbw=nbw+1
c                     write(*,*) 'Got bw',-nbw,j
c                    JA 4/8/11 don't treat forced BW differently
                     if(lconflict(-j)) then
c                        write(*,*) 'Got conflict ',-nbw,j
                        iarray(nbw)=1 !Cuts on BW
c                        if (nbw .gt. imax) then
c                           write(*,*) 'Too many BW w conflicts',nbw,imax
c                        endif
                     endif
                  endif
               enddo
            endif
c            do j=1,2**nbw
            done = .false.
            do while (.not. done)
               call enCode(icode,iarray,ibase,imax)
               if(failConfig(i,iarray,iforest(1,-max_branch,i),
     $           sprop(1,-max_branch,i),gForceBW(-max_branch,i))) then 
                  goto 100
               endif
               ic=ic+1
               nconf=int(dlog10(dble(mapconfig(i))))+1
c               write(*,*) 'mapping',ic,mapconfig(i),icode               
               if (icode .eq. 0) then
c                 Create format string based on number of digits
                  write(formstr,'(a,i1,a)') '(I',nconf,'$)'
                  write(*,formstr) mapconfig(i)
c                 Write symmetry factors
                  write(formstr2,'(a,i2,a)') '(2i',nsym,')'
                  write(27,formstr2) mapconfig(i),use_config(i)
               else
c                 Create format string based on number of digits
                  dconfig=mapconfig(i)+icode*1d0/10**ncode
                  if(nconf+ncode+1.lt.10) then
                     write(formstr,'(a,i1,a,i1,a)') '(F',nconf+ncode+1,
     $                    '.',ncode,'$)'
                  else
                     write(formstr,'(a,i2,a,i1,a)') '(F',nconf+ncode+1,
     $                    '.',ncode,'$)'
                  endif
                  write(*,formstr) dconfig
c                 Write symmetry factors
                  nconf=int(dlog10(dble(mapconfig(i))))+1
                  if(nconf+ncode+1.lt.10) then
                     write(formstr2,'(a,i1,a,i1,a,i2,a)') '(F',nconf+ncode+1,
     $                    '.',ncode,',i',nsym,')'
                  else
                     write(formstr2,'(a,i2,a,i1,a,i2,a)') '(F',nconf+ncode+1,
     $                    '.',ncode,',i',nsym,')'
                  endif
                  dconfig=mapconfig(i)+icode*1d0/10**ncode
                  write(27,formstr2) dconfig,use_config(i)
               endif
               write(*,'(a$)') ' '
 100           call bw_increment_array(iarray,imax,ibase,done)
            enddo
         else
            write(formstr2,'(a,i2,a)') '(2i',nsym,')'
            write(27,formstr2) mapconfig(i),use_config(i)
         endif
      enddo
      close(27)
      if(ic.eq.0) then
c        Stop generation with error message
         filename='../../error'
         INQUIRE(FILE="../../RunWeb", EXIST=file_exists)
         if(.not.file_exists) filename = '../' // filename
         open(unit=26,file=filename,status='unknown')
         write(26,*)'No Phase Space. Please check particle masses.'
c         write(*,*)'Error: No valid channels found. ',
c     $        'Please check particle masses.'
      endif
      end


      subroutine BW_Conflict(iconfig,itree,lconflict,sprop,forcebw)
c***************************************************************************
c     Determines which BW conflict
c***************************************************************************
      implicit none
c
c     Constants
c
      include 'genps.inc'
      include 'maxconfigs.inc'
      include 'maxamps.inc'
      include 'nexternal.inc'
      double precision zero
      parameter       (zero=0d0)
c      include 'run_config.inc'
c
c     Arguments
c
      integer itree(2,-max_branch:-1),iconfig
      logical lconflict(-max_branch:nexternal)
      integer sprop(maxsproc,-max_branch:-1)  ! Propagator id
      integer forcebw(-max_branch:-1) ! Forced BW, for identical particle conflicts
c
c     local
c
      integer i,j,it
      integer iden_part(-nexternal+1:nexternal)
      double precision prwidth(-nexternal:0,lmaxconfigs)  !Propagator width
      double precision prmass(-nexternal:0,lmaxconfigs)   !Propagator mass
      double precision pow(-nexternal:0,lmaxconfigs)    !Not used, in props.inc
      double precision xmass(-max_branch:nexternal)
      double precision pmass(nexternal)   !External particle mass
      integer idup(nexternal,maxproc,maxsproc)
      integer mothup(2,nexternal)
      integer icolup(2,nexternal,maxflow,maxsproc)
      integer ipdg(-nexternal+1:nexternal)
      double precision mtot
      include 'leshouche.inc'
c
c     Global
c
      include 'coupl.inc'                     !Mass and width info
      double precision stot
      common/to_stot/stot

c-----
c  Begin Code
c-----
      include 'props.inc'   !Propagator mass and width information prmass,prwidth
      include 'pmass.inc'   !External particle masses
c      write(*,*) 'Checking for BW in config number ',iconfig
c
c     Reset variables
c      
      do i=1,nexternal
         xmass(i) = pmass(i)
      enddo
      do i=1,nexternal-1
         lconflict(-i) = .false.
      enddo
c     Initialize mtot (needed final-state phase space)
      mtot=0
      do i=nincoming+1,nexternal
          mtot=mtot+xmass(i)
      enddo

c
c     Start by keeping track of identical particles. Only view the outermost
c     identical particle as a BW, unless it is a required BW
c     
      call idenparts(iden_part,itree,sprop,forcebw,
     $               prwidth(-nexternal,iconfig))
c
c     Now determine which propagators are part of the same 
c     chain and could potentially conflict
c
      i=1
      do while (i .lt. nexternal-2 .and. itree(1,-i) .ne. 1)
         xmass(-i) = xmass(itree(1,-i))+xmass(itree(2,-i))
         mtot=mtot-xmass(-i)
         if (prwidth(-i,iconfig) .gt. 0d0) then
            if (xmass(-i) .gt. prmass(-i,iconfig) .and.
     $           iden_part(-i).eq.0) then !Can't be on shell, and not radiation
               lconflict(-i)=.true.
c               write(*,*) "Found Conflict", iconfig,i,
c     $              prmass(-i,iconfig),xmass(-i)
            endif
         endif
         if (iden_part(-i).eq.0) then
            xmass(-i) = max(xmass(-i),prmass(-i,iconfig)+3d0*prwidth(-i,iconfig))        
         endif
         mtot=mtot+xmass(-i)
         i=i+1
      enddo
c
c     Mark all daughters of conflicted BW as conflicting
c
      do j=i,1,-1
         if (lconflict(-j)) then 
            lconflict(itree(1,-j)) = .true.
            lconflict(itree(2,-j)) = .true.
c            write(*,*) 'Adding conflict ',itree(1,-j),itree(2,-j)
         endif
      enddo
c
c     If not enough energy, mark all BWs as conflicting
c
      if(stot.lt.mtot**2)then
c         write(*,*) 'Not enough energy, set all BWs as conflicting'
         do j=i,1,-1
            lconflict(-j) = .true.
         enddo
      endif
c
c     Only include BW props as conflicting, but not if radiation
c
      do j=i,1,-1
         if (lconflict(-j)) then 
            if (prwidth(-j,iconfig) .le. 0 .or. iden_part(-j).gt.0) then 
               lconflict(-j) = .false.
c               write(*,*) 'No conflict BW',iconfig,j
               continue
c            else
c               write(*,*) 'Conflicting BW',iconfig,j
            endif
         endif
      enddo                  

      end

      function failConfig(iconfig,iarray,itree,sprop,forcebw)
c***************************************************************************
c     Determines if the configuration allows integration based on
c     mass relations
c***************************************************************************
      implicit none
c
c     Constants
c
      include 'genps.inc'
      include 'maxconfigs.inc'
      include 'maxamps.inc'
      include 'nexternal.inc'
      double precision zero
      parameter       (zero=0d0)
      integer    imax
      parameter (imax=max_branch-1)
c
c     Arguments
c
      logical failConfig
      integer iconfig,iarray(imax),itree(2,-max_branch:-1)
      logical lconflict(-max_branch:nexternal)
      integer sprop(maxsproc,-max_branch:-1)  ! Propagator id
      integer forcebw(-max_branch:-1) ! Forced BW, for identical particle conflicts
c
c     local
c
      integer i,j,nbw
      double precision prwidth(-nexternal:0,lmaxconfigs)  !Propagator width
      double precision prmass(-nexternal:0,lmaxconfigs)   !Propagator mass
      double precision pow(-nexternal:0,lmaxconfigs)    !Not used, in props.inc
      double precision xmass(-max_branch:nexternal)
      double precision xwidth(-max_branch:nexternal)
      double precision pmass(nexternal)   !External particle mass
      double precision mtot
      integer idup(nexternal,maxproc,maxsproc)
      integer mothup(2,nexternal)
      integer icolup(2,nexternal,maxflow,maxsproc)
      include 'leshouche.inc'
c
c     Global
c
      double precision bwcutoff
      common/to_bwcutoff/bwcutoff
      double precision stot
      common/to_stot/stot
      include 'coupl.inc'                     !Mass and width info

c-----
c  Begin Code
c-----
      include 'props.inc'   !Propagator mass and width information prmass,prwidth
      include 'pmass.inc'   !External particle masses
c
c     Reset variables
c      
      do i=1,nexternal
         xmass(i) = pmass(i)
         xwidth(i) = 0
      enddo
      do i=1,nexternal-1
         lconflict(-i) = .false.
      enddo
c     Initialize mtot (needed final-state phase space)
      mtot=0
      do i=nincoming+1,nexternal
          mtot=mtot+xmass(i)
      enddo

c     By default pass
      failConfig=.false.

c
c     Go through
c
      nbw=0
      i=1
      do while (i .lt. nexternal-2 .and. itree(1,-i) .ne. 1)
         xmass(-i) = xmass(itree(1,-i))+xmass(itree(2,-i))
         mtot=mtot-xmass(-i)
         xwidth(-i)=prwidth(-i,iconfig)
         if (xwidth(-i) .gt. 0d0) then
            nbw=nbw+1
            if(forcebw(-i) .eq. 1) then
c               if (iarray(nbw) .ne. 1) then
c                  write(*,*) "fail due to iarray", iarray(nbw)
c                  failConfig=.true.
c                  return
c               endif
               if(xmass(-i).gt.prmass(-i,iconfig)+bwcutoff*xwidth(-i)) then
                  failConfig=.true.
                  return
               else
                  xmass(-i)=max(xmass(-i),prmass(-i,iconfig)-
     $                 bwcutoff*xwidth(-i))
               endif
            else if (iarray(nbw) .eq. 1) then
               if(xmass(-i).gt.prmass(-i,iconfig)+5d0*xwidth(-i)) then
                  failConfig=.true.
                  return
               else
                  xmass(-i)=max(xmass(-i),prmass(-i,iconfig)-5d0*xwidth(-i))
               endif

            endif
         endif
         mtot=mtot+xmass(-i)
         i=i+1
      enddo

c     Fail if too small phase space
      if (stot.lt.mtot**2) then
         failConfig=.true.
      endif

      return
      end

      subroutine bw_increment_array(iarray,imax,ibase,done)
c************************************************************************
c     Increments iarray     
c************************************************************************
      implicit none
c
c     Arguments
c
      integer imax          !Input, number of elements in iarray
      integer ibase         !Base for incrementing, 0 is skipped
      integer iarray(imax)  !Output:Array of values being incremented
      logical done          !Output:Set when no more incrementing

c
c     Global
c
      include 'genps.inc'
      include 'nexternal.inc'

c
c     Local
c
      integer i,j
      logical found
c-----
c  Begin Code
c-----
      found = .false.
      i = 1
      do while (i .le. imax .and. .not. found)
         if (iarray(i) .eq. 0) then    !don't increment this
            i=i+1
         elseif (iarray(i) .lt. ibase-1) then
            found = .true.
            iarray(i)=iarray(i)+1
         else
            iarray(i)=1
            i=i+1
         endif
      enddo
      done = .not. found
      end

      subroutine store_events(grid)
c**********************************************************************
c     Dummy routine
c**********************************************************************
      integer grid
      end

      double precision function dsig(pp,wgt,imode)
c**********************************************************************
c     Dummy routine
c**********************************************************************
      integer pp,wgt,imode
      dsig=0d0
      return
      end

      subroutine clear_events()
c**********************************************************************
c     Dummy routine
c**********************************************************************
      end

      integer function n_unwgted()
c**********************************************************************
c     Dummy routine
c**********************************************************************
      n_unwgted = 1
      end

      subroutine load_gridpack_para(npara,param,value)
c----------------------------------------------------------------------
c Read the params from the run_card.dat file
c----------------------------------------------------------------------
      implicit none
c
c     arguments
c
      character*20 param(*),value(*)
      integer npara
c
c     local
c
      logical fopened,done
      integer iunit
      character*20 ctemp
      integer k,i,l1,l2,iproc
      character*132 buff
      data iunit/21/
c
c     global
c
      integer ngroup
      common/to_group/ngroup
c
c----------
c     start
c----------
      npara=0
      param(1)=' '
      value(1)=' '
c
c     open file
c
      call open_file(iunit,'grid_card.dat',fopened)
      if(fopened) then
c
c     first look for process-specific parameters
c
      done=.false.
      do while(.not.done)
         read(iunit,'(a132)',end=30,err=30) buff
         if(buff(1:1).ne.'#' .and. index(buff,"=").gt.0
     $        .and. index(buff,"@").gt.0) then
            l1=index(buff,"@")
            l2=index(buff,"!")
            if(l2.eq.0) l2=l1+20  !maybe there is no comment...
            read(buff(l1+1:l2),*,err=21) iproc
            if(iproc.ne.ngroup) cycle

            l1=index(buff,"=")
            l2=index(buff,"@")
            if(l2-l1.lt.0) cycle
            npara=npara+1
c
             value(npara)=buff(1:l1-1)
             ctemp=value(npara)
             call case_trap2(ctemp)
             value(npara)=ctemp
c
             param(npara)=" "//buff(l1+1:l2-1)
             ctemp=param(npara)
             call case_trap2(ctemp)
             param(npara)=ctemp
c
 21          cycle
         endif
       enddo
 30   rewind(iunit)
c
c     read in values
c
      done=.false.
      do while(.not.done)
         read(iunit,'(a132)',end=99,err=99) buff
         if(buff(1:1).ne.'#' .and. index(buff,"=").gt.0
     $        .and. index(buff,"@").le.0) then
            l1=index(buff,"=")
            l2=index(buff,"!")
            if(l2.eq.0) l2=l1+20  !maybe there is no comment...
            if(l2-l1.lt.0) cycle
            npara=npara+1
c
             value(npara)=buff(1:l1-1)
             ctemp=value(npara)
             call case_trap2(ctemp)
             value(npara)=ctemp
c
             param(npara)=" "//buff(l1+1:l2-1)
c             write (*,*) param(npara),l1,l2
             ctemp=param(npara)
             call case_trap2(ctemp)
             param(npara)=ctemp
c             write(*,*) "New param:",param(npara)," = ", value(npara)
c
         endif
      enddo
 99   close(iunit)
      endif

      return
      end


      subroutine load_para(npara,param,value)
c----------------------------------------------------------------------
c Read the params from the run_card.dat file
c---------------------------------------------------------------------- 
      implicit none
c
c     arguments
c     
      character*20 param(*),value(*)
      integer npara
c
c     local
c
      logical fopened,done
      integer iunit
      character*20 ctemp
      integer k,i,l1,l2,iproc
      character*132 buff
      data iunit/21/
c
c     global
c
      integer ngroup
      common/to_group/ngroup
c
c----------
c     start
c----------
c
c     read the run_card.dat
c
      npara=0
      param(1)=' '
      value(1)=' '
c
c     open file
c
      call open_file(iunit,'run_card.dat',fopened)
      if(.not.fopened) then
         write(*,*) 'Error: File run_card.dat not found'
         stop
      else
c
c     first look for process-specific parameters
c
      done=.false.
      do while(.not.done)  
         read(iunit,'(a132)',end=20,err=20) buff
         if(buff(1:1).ne.'#' .and. index(buff,"=").gt.0
     $        .and. index(buff,"@").gt.0) then
            l1=index(buff,"@")
            l2=index(buff,"!")
            if(l2.eq.0) l2=l1+20  !maybe there is no comment...
            read(buff(l1+1:l2),*,err=11) iproc
            if(iproc.ne.ngroup) cycle

            l1=index(buff,"=")
            l2=index(buff,"@")
            if(l2-l1.lt.0) cycle
            npara=npara+1
c
             value(npara)=buff(1:l1-1)
             ctemp=value(npara)
             call case_trap2(ctemp)
             value(npara)=ctemp
c
             param(npara)=" "//buff(l1+1:l2-1)
             ctemp=param(npara)
             call case_trap2(ctemp)
             param(npara)=ctemp
c
 11          cycle
         endif
      enddo
 20   rewind(iunit)
c
c     read in values
c
      done=.false.
      do while(.not.done)  
         read(iunit,'(a132)',end=96,err=96) buff
         if(buff(1:1).ne.'#' .and. index(buff,"=").gt.0
     $        .and. index(buff,"@").le.0) then
            l1=index(buff,"=")
            l2=index(buff,"!")
            if(l2.eq.0) l2=l1+20  !maybe there is no comment...
            if(l2-l1.lt.0) cycle
            npara=npara+1
c
             value(npara)=buff(1:l1-1)
             ctemp=value(npara)
             call case_trap2(ctemp)
             value(npara)=ctemp
c
             param(npara)=" "//buff(l1+1:l2-1)
             ctemp=param(npara)
             call case_trap2(ctemp)
             param(npara)=ctemp
c
         endif
      enddo
 96   close(iunit)
      endif
c
c     open file
c
c
c     tjs modified 11-16-07 to include grid_card.dat
c
      call open_file(iunit,'grid_card.dat',fopened)
      if(fopened) then
c
c     first look for process-specific parameters
c
      done=.false.
      do while(.not.done)  
         read(iunit,'(a132)',end=30,err=30) buff
         if(buff(1:1).ne.'#' .and. index(buff,"=").gt.0
     $        .and. index(buff,"@").gt.0) then
            l1=index(buff,"@")
            l2=index(buff,"!")
            if(l2.eq.0) l2=l1+20  !maybe there is no comment...
            read(buff(l1+1:l2),*,err=21) iproc
            if(iproc.ne.ngroup) cycle

            l1=index(buff,"=")
            l2=index(buff,"@")
            if(l2-l1.lt.0) cycle
            npara=npara+1
c
             value(npara)=buff(1:l1-1)
             ctemp=value(npara)
             call case_trap2(ctemp)
             value(npara)=ctemp
c
             param(npara)=" "//buff(l1+1:l2-1)
             ctemp=param(npara)
             call case_trap2(ctemp)
             param(npara)=ctemp
c
 21          cycle
         endif
       enddo
 30   rewind(iunit)
c
c     read in values
c
      done=.false.
      do while(.not.done)  
         read(iunit,'(a132)',end=99,err=99) buff
         if(buff(1:1).ne.'#' .and. index(buff,"=").gt.0
     $        .and. index(buff,"@").le.0) then
            l1=index(buff,"=")
            l2=index(buff,"!")
            if(l2.eq.0) l2=l1+20  !maybe there is no comment...
            if(l2-l1.lt.0) cycle
            npara=npara+1
c
             value(npara)=buff(1:l1-1)
             ctemp=value(npara)
             call case_trap2(ctemp)
             value(npara)=ctemp
c
             param(npara)=" "//buff(l1+1:l2-1)
c             write (*,*) param(npara),l1,l2
             ctemp=param(npara)
             call case_trap2(ctemp)
             param(npara)=ctemp
c             write(*,*) "New param:",param(npara)," = ", value(npara)
c
         endif
      enddo
 99   close(iunit)
      endif

      return
      end



      subroutine get_real(npara,param,value,name,var,def_value)
c----------------------------------------------------------------------------------
c     finds the parameter named "name" in param and associate to "value" in value 
c----------------------------------------------------------------------------------
      implicit none

c
c     arguments
c
      integer npara
      character*20 param(*),value(*)
      character*(*)  name
      real*8 var,def_value
      character*20 c_param,c_name
c
c     local
c
      logical found
      integer i
c
c     start
c
      i=1
      found=.false.
      do while(.not.found.and.i.le.npara)
          call firststring(c_param,param(i))
          call firststring(c_name,name)
         found = (c_param .eq. c_name)
         if (found) read(value(i),*) var
c         if (found) write (*,*) name,var
         i=i+1
      enddo
      if (.not.found) then
         write (*,*) "Warning: parameter ",name," not found"
         write (*,*) "         setting it to default value ",def_value
         var=def_value
      endif
      return

      end
c

      subroutine get_integer(npara,param,value,name,var,def_value)
c----------------------------------------------------------------------------------
c     finds the parameter named "name" in param and associate to "value" in value 
c----------------------------------------------------------------------------------
      implicit none
c
c     arguments
c
      integer npara
      character*20 param(*),value(*)
      character*(*)  name
      integer var,def_value
      character*20 c_param,c_name
c
c     local
c
      logical found
      integer i
c
c     start
c
      i=1
      found=.false.
      do while(.not.found.and.i.le.npara)
         call firststring(c_param,param(i))
          call firststring(c_name,name)
         found = (c_param .eq. c_name)
         if (found) read(value(i),*) var
c         if (found) write (*,*) name,var
         i=i+1
      enddo
      if (.not.found) then
         write (*,*) "Warning: parameter ",name," not found"
         write (*,*) "         setting it to default value ",def_value
         var=def_value
      endif
      return

      end
c
      subroutine get_int8(npara,param,value,name,var,def_value)
c----------------------------------------------------------------------------------
c     finds the parameter named "name" in param and associate to "value" in value 
c----------------------------------------------------------------------------------
      implicit none
c
c     arguments
c
      integer npara
      character*20 param(*),value(*)
      character*(*)  name
      integer def_value
      integer*8 var
      character*20 c_param,c_name
c
c     local
c
      logical found
      integer i
c
c     start
c
      i=1
      found=.false.
      do while(.not.found.and.i.le.npara)
         call firststring(c_param,param(i))
          call firststring(c_name,name)
         found = (c_param .eq. c_name)
         if (found) read(value(i),*) var
c         if (found) write (*,*) name,var
         i=i+1
      enddo
      if (.not.found) then
         write (*,*) "Warning: parameter ",name," not found"
         write (*,*) "         setting it to default value ",def_value
         var=def_value
      endif
      return

      end
c
      subroutine get_string(npara,param,value,name,var,def_value)
c----------------------------------------------------------------------------------
c     finds the parameter named "name" in param and associate to "value" in value 
c----------------------------------------------------------------------------------
      implicit none

c
c     arguments
c
      integer npara
      character*20 param(*),value(*)
      character*(*)  name
      character*(*)  var,def_value
      character*20 c_param,c_name
c
c     local
c
      logical found
      integer i
c
c     start
c
      i=1
      found=.false.
      do while(.not.found.and.i.le.npara)
         call firststring(c_param,param(i))
          call firststring(c_name,name)
         found = (c_param .eq. c_name)
         if (found) read(value(i),*) var
c         if (found) write (*,*) name,var
         i=i+1
      enddo
      if (.not.found) then
         write (*,*) "Warning: parameter ",name," not found"
         write (*,*) "         setting it to default value ",def_value
         var=def_value
      endif
      return

      end
c
      subroutine get_logical(npara,param,value,name,var,def_value)
c----------------------------------------------------------------------------------
c     finds the parameter named "name" in param and associate to "value" in value 
c----------------------------------------------------------------------------------
      implicit none

c
c     arguments
c
      integer npara
      character*20 param(*),value(*)
      character*(*)  name
      logical  var,def_value
      character*20 c_param,c_name
c
c     local
c
      logical found
      integer i
c
c     start
c
      i=1
      found=.false.
      do while(.not.found.and.i.le.npara)
         call firststring(c_param,param(i))
          call firststring(c_name,name)
         found = (c_param .eq. c_name)
         if (found) read(value(i),*) var
c         if (found) write (*,*) name,var
         i=i+1
      enddo
      if (.not.found) then
         write (*,*) "Warning: parameter ",name," not found"
         write (*,*) "         setting it to default value ",def_value
         var=def_value
      endif
      return

      end
c



      subroutine case_trap2(name)
c**********************************************************    
c change the string to lowercase if the input is not
c**********************************************************
      implicit none
c
c     ARGUMENT
c      
      character*20 name
c
c     LOCAL
c
      integer i,k

      do i=1,20
         k=ichar(name(i:i))
         if(k.ge.65.and.k.le.90) then  !upper case A-Z
            k=ichar(name(i:i))+32   
            name(i:i)=char(k)        
         endif
      enddo

      return
      end

c +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c ++
c ++ firststring -> return the first "word" of string 
c ++ & remove whitespaces around
c ++ Needed to correct a bug in "get_" routines
c ++ Michel Herquet - CP3 - 05-04-2006
c ++
c +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      subroutine firststring(first,string)

      implicit none
      character*(*) string
      character*20 first
      character*20 temp

      temp=string
      do while(temp(1:1) .eq. ' ') 
	temp=temp(2:len(temp))
      end do
      first=temp(1:index(temp,' ')-1)

      end

      subroutine crossp(p1,p2,p)
c**************************************************************************
c     input:
c            p1, p2    vectors to cross
c**************************************************************************
      implicit none
      real*8 p1(0:3), p2(0:3), p(0:3)

      p(0)=0d0
      p(1)=p1(2)*p2(3)-p1(3)*p2(2)
      p(2)=p1(3)*p2(1)-p1(1)*p2(3)
      p(3)=p1(1)*p2(2)-p1(2)*p2(1)

      return 
      end


      subroutine rotate(p1,p2,n,nn2,ct,st,d)
c**************************************************************************
c     input:
c            p1        vector to be rotated
c            n         vector perpendicular to plane of rotation
c            nn2       squared norm of n to improve numerics
c            ct, st    cos/sin theta of rotation in plane 
c            d         direction: 1 there / -1 back
c     output:
c            p2        p1 rotated using defined rotation
c**************************************************************************
      implicit none
      real*8 p1(0:3), p2(0:3), n(0:3), at(0:3), ap(0:3), cr(0:3)
      double precision nn2, ct, st, na, nn
      integer d, i

      if (nn2.eq.0d0) then
         do i=0,3
            p2(i)=p1(i)
         enddo   
         return
      endif
      nn=dsqrt(nn2)
      na=(n(1)*p1(1)+n(2)*p1(2)+n(3)*p1(3))/nn2
      do i=1,3
         at(i)=n(i)*na
         ap(i)=p1(i)-at(i)
      enddo
c      write(*,*)'nn2 ',nn2,' ',nn,' ',na
c      write(*,*)'ap ',ap(1),',',ap(2),',',ap(3)
c      write(*,*)'at ',at(1),',',at(2),',',at(3)
      p2(0)=p1(0)
      call crossp(n,ap,cr)
c      write(*,*)'cr ',cr(1),',',cr(2),',',cr(3)
      do i=1,3
         if (d.ge.0) then
            p2(i)=at(i)+ct*ap(i)+st/nn*cr(i)
         else 
            p2(i)=at(i)+ct*ap(i)-st/nn*cr(i)
         endif
      enddo
      
      return 
      end


      subroutine constr(p1,p2,n,nn2,ct,st)
c**************************************************************************
c     input:
c            p1, p2    p1 rotated onto p2 defines plane of rotation
c     output:
c            n         vector perpendicular to plane of rotation
c            nn2       squared norm of n to improve numerics
c            ct, st    cos/sin theta of rotation in plane 
c**************************************************************************
      implicit none
      real*8 p1(0:3), p2(0:3), n(0:3), tr(0:3)
      double precision nn2, ct, st, mct

      ct=p1(1)*p2(1)+p1(2)*p2(2)+p1(3)*p2(3)
      ct=ct/dsqrt(p1(1)**2+p1(2)**2+p1(3)**2)
      ct=ct/dsqrt(p2(1)**2+p2(2)**2+p2(3)**2)
      mct=ct
c     catch bad numerics
      if (mct-1d0>0d0) mct=0d0
      st=dsqrt(1d0-mct*mct)

      call crossp(p1,p2,n)
      nn2=n(1)**2+n(2)**2+n(3)**2
c     don't rotate if nothing to rotate
      if (nn2.le.1d-34) then
         nn2=0d0
         return
      endif

c     check rotation
c      call rotate(p1(0),tr(0),n(0),nn2,ct,st,1)
c      write(*,*)'p1 (',p1(0),',',p1(1),',',p1(2),',',p1(3),')'
c      write(*,*)'p2 (',p2(0),',',p2(1),',',p2(2),',',p2(3),')'
c      write(*,*)'nn (',n(0),',',n(1),',',n(2),',',n(3),')'
c      write(*,*)'nn (',n(0),',',n(1),',',n(2),',',n(3),')'
c      write(*,*)'nn2 = ',nn2,', ct = ',ct,', st = ',st
c      write(*,*)'tr (',tr(0),',',tr(1),',',tr(2),',',tr(3),')'
      
      return 
      end


      Subroutine mapids(ids,id)
c**************************************************************************
c     input:
c            ids       array of particle ids
c            id        compressed particle id
c**************************************************************************
      implicit none
      include 'nexternal.inc'
      integer i, id, ids(nexternal)
      
      id=0
      do i=1,nexternal
         if (ids(i).ne.0) then
            id=id+ishft(1,i)
         endif
      enddo
c      write(*,*) 'cluster.f: compressed code is ',id

      return
      end


      subroutine mapid(id,ids)
c**************************************************************************
c     input:
c            id        compressed particle id
c            ids       array of particle ids
c**************************************************************************
      implicit none
      include 'nexternal.inc'
      integer i, icd, id, ids(nexternal)
      
      icd=id
      do i=1,nexternal
         ids(i)=0
         if (btest(id,i)) then
            ids(i)=1
         endif
c         write(*,*) 'cluster.f: uncompressed code ',i,' is ',ids(i)
      enddo

      return
      end


      integer function combid(i,j)
c**************************************************************************
c     input:
c            i,j       legs to combine
c     output:
c            index of combined leg
c**************************************************************************
      implicit none
      include 'nexternal.inc'
      integer i, j

c      combid=min(i+j,ishft(1,nexternal+1)-2-i-j)
      combid = i+j
     
      return
      end


      subroutine filprp(iproc,ignum,idij)
c**************************************************************************
c     Include graph ignum in list for propagator idij
c**************************************************************************
      implicit none
      include 'nexternal.inc'
      include 'maxamps.inc'
      include 'cluster.inc'
      include 'message.inc'
      integer ignum, idij, iproc, i

      if(idij.gt.n_max_cl) return
      do i=1,id_cl(iproc,idij,0)
         if (id_cl(iproc,idij,i).eq.ignum) return
      enddo
      id_cl(iproc,idij,0)=id_cl(iproc,idij,0)+1
      id_cl(iproc,idij,id_cl(iproc,idij,0))=ignum
      if(btest(mlevel,5))
     $     write(*,*)'Adding graph ',ignum,' to prop ',idij,' for proc ',iproc
      return
      end

      logical function filgrp(ignum,ipnum,ipids)
c**************************************************************************
c     input:
c            ignum      number of graph to be analysed
c            ipnum      number of level to be analysed, 
c                       starting with nexternal
c            ipids      particle number, iforest number, 
c                       daughter1, daughter2
c     output:
c            true if no errors
c**************************************************************************
      implicit none
      include 'genps.inc'
      include 'maxconfigs.inc'
      include 'nexternal.inc'
      include 'maxamps.inc'
      include 'cluster.inc'
      include 'coupl.inc'
      include 'message.inc'
      integer ignum, ipnum, ipids(nexternal,4,2:nexternal)
C $B$ IFOREST $B$ !this is a tag for MadWeight
      integer i, iforest(2,-max_branch:-1,lmaxconfigs)
      common/to_forest/iforest
      integer sprop(maxsproc,-max_branch:-1,lmaxconfigs)
      integer tprid(-max_branch:-1,lmaxconfigs)
      common/to_sprop/sprop,tprid
C $E$ IFOREST $E$ !this is a tag for MadWeight
      INTEGER    n_max_cl_cg
      PARAMETER (n_max_cl_cg=n_max_cl*n_max_cg)
      data resmap/n_max_cl_cg*.false./

      Integer j, k, l, icmp(2), iproc

      double precision ZERO
      parameter (ZERO=0d0)
      double precision prmass(-nexternal:0,lmaxconfigs)
      double precision prwidth(-nexternal:0,lmaxconfigs)
      integer pow(-nexternal:0,lmaxconfigs)
      logical first_time
      save prmass,prwidth,pow
      INTEGER CONFSUB(MAXSPROC,LMAXCONFIGS)
      INCLUDE 'config_subproc_map.inc'
      data first_time /.true./

      integer combid
      logical isjet
      external combid,isjet

      if (first_time) then
         include 'props.inc'
         first_time=.false.
      endif

      if(btest(mlevel,4))
     $     write(*,*) 'graph,level: ',ignum,ipnum

      filgrp=.false.
C   Follow diagram tree down to last clustering
      do i=1,ipnum
         do j=i+1,ipnum
            if(btest(mlevel,4))
     $           write(*,*)'at ids   (',ipids(i,1,ipnum),',',ipids(i,2,ipnum),'), (',
     $           ipids(j,1,ipnum),',',ipids(j,2,ipnum),'), ',i,j
            do k=-nexternal+1,-1
               if ((iforest(1,k,ignum).eq.ipids(i,2,ipnum).and.
     &              iforest(2,k,ignum).eq.ipids(j,2,ipnum)).or.
     &             (iforest(2,k,ignum).eq.ipids(i,2,ipnum).and.
     &              iforest(1,k,ignum).eq.ipids(j,2,ipnum))) then
c                 Add the combined propagator
                  icmp(1)=combid(ipids(i,1,ipnum),ipids(j,1,ipnum))
c                 Add also the same propagator but from the other direction
                  icmp(2)=ishft(1,nexternal)-1-icmp(1)
c     Set pdg code for propagator
                  do l=1,2
                     do iproc=1,maxsproc
                     if(confsub(iproc,ignum).eq.0) cycle
                     if(sprop(iproc,k,ignum).ne.0)then
                        ipdgcl(icmp(l),ignum,iproc)=sprop(iproc,k,ignum)
                     else if(tprid(k,ignum).ne.0)then
                        ipdgcl(icmp(l),ignum,iproc)=tprid(k,ignum)
                     else if(ipnum.eq.3)then
                        ipdgcl(icmp(l),ignum,iproc)=ipdgcl(2,ignum,iproc)
                     else
                        ipdgcl(icmp(l),ignum,iproc)=0
                     endif
                     if(btest(mlevel,4))
     $                    write(*,*) 'add table entry for (',ipids(i,1,ipnum),
     &                    ',',ipids(j,1,ipnum),',',icmp(l),')',
     $                    'proc: ',iproc,
     $                    ', pdg: ',ipdgcl(icmp(l),ignum,iproc)
                     call filprp(iproc,ignum,icmp(l))
c               Insert graph in list of propagators
                     if(prwidth(k,ignum).gt.ZERO) then
                     if(btest(mlevel,4))
     $                       write(*,*)'Adding resonance ',ignum,icmp(l)
                        resmap(icmp(l),ignum)=.true.
                     endif
                  enddo
                  enddo
c     proceed w/ next table, since there is no possibility,
c     to combine the same particle in another way in this graph
                  ipids(i,1,ipnum-1)=icmp(1)
                  ipids(i,2,ipnum-1)=k
                  ipids(i,3,ipnum-1)=i
                  ipids(i,4,ipnum-1)=j
                  ipnum=ipnum-1
                  do l=1,j-1
                    if(l.eq.i) cycle
                    ipids(l,1,ipnum)=ipids(l,1,ipnum+1)
                    ipids(l,2,ipnum)=ipids(l,2,ipnum+1)
                    ipids(l,3,ipnum)=l
                    ipids(l,4,ipnum)=0
                  enddo
                  do l=j,ipnum
                     ipids(l,1,ipnum)=ipids(l+1,1,ipnum+1)
                     ipids(l,2,ipnum)=ipids(l+1,2,ipnum+1)
                     ipids(l,3,ipnum)=l+1
                     ipids(l,4,ipnum)=0
                  enddo
                  if(ipnum.eq.2)then
c                 Done with this diagram
                     return
                  else
                     filgrp=.true.
                     return
                  endif
               endif
            enddo
         enddo
      enddo
      return
      end


      logical function filmap()
c**************************************************************************
c     output:
c            true if no errors
c**************************************************************************
      implicit none
      include 'genps.inc'
      include 'maxconfigs.inc'
      include 'nexternal.inc'
      include 'maxamps.inc'
      include 'cluster.inc'
      include 'message.inc'
C $B$ IFOREST $B$ !this is a tag for MadWeight
      integer mapconfig(0:lmaxconfigs), this_config
      common/to_mconfigs/mapconfig, this_config
C $E$ IFOREST $E$ !this is a tag for MadWeight
      integer i, j, inpids, iproc, ipids(nexternal,4,2:nexternal)
      integer start_config,end_config
      integer idup(nexternal,maxproc,maxsproc)
      integer mothup(2,nexternal)
      integer icolup(2,nexternal,maxflow,maxsproc)
      include 'leshouche.inc'
      integer nqcd(lmaxconfigs)
      include 'config_nqcd.inc'
      
      logical filgrp
      external filgrp

      start_config=1
      end_config=mapconfig(0)
      do iproc=1,maxsproc
         do i=1,n_max_cl
            id_cl(iproc,i,0)=0
         enddo
      enddo
      do i=start_config,end_config
         if(nqcd(this_config).ne.nqcd(i)) then
            if(btest(mlevel,3))
     $           write(*,*) 'Skipping config ',i,' since nqcd: ',
     $           nqcd(this_config),nqcd(i)
            cycle
         endif
c         write (*,*) ' at graph ',i
         do j=1,nexternal
            ipids(j,1,nexternal)=ishft(1,j-1)
            ipids(j,2,nexternal)=j
            ipids(j,3,nexternal)=0
            ipids(j,4,nexternal)=0
            do iproc=1,maxsproc
               ipdgcl(ipids(j,1,nexternal),i,iproc)=idup(j,1,iproc)
            enddo
         enddo
         inpids=nexternal
         if(btest(mlevel,3))
     $        write(*,*) 'Inserting graph ',i
 10      if (filgrp(i,inpids,ipids)) goto 10
      enddo
      filmap=.true.
      return
      end


      subroutine checkbw(nbw,ibwlist,isbw)
c**************************************************************************
c      Checks if any resonances are on the BW for this configuration
c**************************************************************************
      implicit none
      include 'genps.inc'
      include 'maxconfigs.inc'
      include 'nexternal.inc'
C $B$ NGRAPHS $E$ !this is a tag for MadWeight

c     ibwlist has ijid, propid
      integer nbw,ibwlist(2,nexternal)
      logical isbw(*)

      logical             OnBW(-nexternal:0)     !Set if event is on B.W.
      common/to_BWEvents/ OnBW
      integer            mapconfig(0:lmaxconfigs), this_config
      common/to_mconfigs/mapconfig, this_config
C $B$ IFOREST $B$ !this is a tag for MadWeight
      integer i, iforest(2,-max_branch:-1,lmaxconfigs)
      common/to_forest/ iforest
C $E$ IFOREST $E$ !this is a tag for MadWeight
C $B$ DECAYBW $E$ !this is a tag for MadWeight

      integer icl(-(nexternal-3):nexternal)

      nbw=0
      do i=1,nexternal
        icl(i)=ishft(1,i-1)
      enddo
      do i=-1,-(nexternal-3),-1
        icl(i)=icl(iforest(1,i,this_config))+
     $     icl(iforest(2,i,this_config))
        isbw(icl(i))=.false.
C $B$ ONBW $B$ !this is a tag for MadWeight
        if(OnBW(i))then
C $E$ ONBW $E$ !this is a tag for MadWeight
          nbw=nbw+1
          ibwlist(1,nbw)=icl(i)
          ibwlist(2,nbw)=i
          isbw(icl(i))=.true.
c          print *,'Added BW for resonance ',i,icl(i),this_config
        endif
      enddo
      
      end

      logical function findmt(idij,icgs)
c**************************************************************************
c     input:
c            idij, icgs
c     output:
c            true if tree structure identified
c**************************************************************************
      implicit none
      include 'nexternal.inc'
      include 'maxamps.inc'
      include 'cluster.inc'
      include 'message.inc'
      include 'genps.inc'
      include 'run.inc'
      include 'maxconfigs.inc'

      integer idij,icgs(0:n_max_cg)
      logical foundbw
      integer i, ii, j, jj, il, igsbk(0:n_max_cg)

c     IPROC has the present process number
      INTEGER IMIRROR,IPROC
      COMMON/TO_MIRROR/IMIRROR, IPROC
C     ICONFIG has this config number
      INTEGER MAPCONFIG(0:LMAXCONFIGS), ICONFIG
      COMMON/TO_MCONFIGS/MAPCONFIG, ICONFIG

      findmt=.false.
c     if first clustering, set possible graphs
      if (icgs(0).eq.0) then
         ii=0
         do i=1,id_cl(iproc,idij,0)
c        if chcluster, allow only this config
           if(chcluster)then
              if(id_cl(iproc,idij,i).ne.iconfig) cycle
           endif
c        check if we have constraint from onshell resonances
           foundbw=.true.
           do j=1,nbw
             if(resmap(ibwlist(1,j),id_cl(iproc,idij,i)))then
               cycle
             endif
             foundbw=.false.
 10        enddo
           if((nbw.eq.0.or.foundbw))then
              ii=ii+1
              icgs(ii)=id_cl(iproc,idij,i)
           endif
         enddo
         icgs(0)=ii
         if (icgs(0).gt.0)then
           findmt=.true.
         endif
         if (btest(mlevel,5))
     $        write (*,*)'findmt: ',findmt,' IPROC=',IPROC,' icgs(0)=',icgs(0),
     $        ' icgs = ',(icgs(i),i=1,icgs(0))
         return
      else
c     Check for common graphs
         j=1
         ii=0
         do i=1,icgs(0)
            if(j.le.id_cl(iproc,idij,0).and.icgs(i).eq.id_cl(iproc,idij,j))then
               ii=ii+1
               icgs(ii)=id_cl(iproc,idij,j)
               j=j+1
            else if(j.le.id_cl(iproc,idij,0).and.icgs(i).gt.id_cl(iproc,idij,j)) then
               do while(icgs(i).gt.id_cl(iproc,idij,j).and.j.le.id_cl(iproc,idij,0))
                  j=j+1
               enddo
               if(j.le.id_cl(iproc,idij,0).and.icgs(i).eq.id_cl(iproc,idij,j))then
                  ii=ii+1
                  icgs(ii)=id_cl(iproc,idij,j)
               endif
            endif
         enddo
         icgs(0)=ii
         findmt=(icgs(0).gt.0)
         return
      endif
      end


      logical function cluster(p)
c**************************************************************************
c     input:
c            p(0:3,i)           momentum of i'th parton
c     output:
c            true if tree structure identified
c**************************************************************************
      implicit none
      include 'genps.inc'
      include 'run.inc'
      include 'nexternal.inc'
      include 'maxamps.inc'
      include 'cluster.inc'
      include 'message.inc'
      include 'maxconfigs.inc'

      real*8 p(0:3,nexternal), pcmsp(0:3), p1(0:3)
      real*8 pi(0:3), nr(0:3), pz(0:3)
      integer i, j, k, n, idi, idj, idij, icgs(0:n_max_cg)
      integer nleft, iwin, jwin, iwinp, imap(nexternal,2) 
      double precision nn2,ct,st
      double precision minpt2ij,pt2ij(n_max_cl),zij(n_max_cl)

      integer mapconfig(0:lmaxconfigs), this_config
      common/to_mconfigs/mapconfig, this_config

      data (pz(i),i=0,3)/1d0,0d0,0d0,1d0/

      integer combid
      logical findmt
      external findmt
      double precision dj, pydj, djb, pyjb, dot, SumDot, zclus
      external dj, pydj, djb, pyjb, dot, SumDot, zclus, combid
      integer next4
      parameter(next4=4*nexternal)
      data icluster/next4*0/

      if (btest(mlevel,1))
     $   write (*,*)'New event'

      cluster=.false.
      clustered=.false.
      do i=0,3
        pcmsp(i)=0
      enddo
c     Check if any resonances are on the BW, store results in to_checkbw
      call checkbw(nbw,ibwlist,isbw)
      if(btest(mlevel,4).and.nbw.gt.0)
     $     write(*,*) 'Found BWs: ',(ibwlist(1,i),i=1,nbw)

c     initialize index map
      do i=1,nexternal
         imap(i,1)=i
         imap(i,2)=ishft(1,i-1)
         mt2ij(i)=0
      enddo   
      mt2last=0
      minpt2ij=1.0d37
      do i=1,nexternal
c     initialize momenta
         idi=ishft(1,i-1)
         do j=0,3
            pcl(j,idi)=p(j,i)
         enddo
c     give mass to external particles
         pcl(4,idi)=dot(p(0,i),p(0,i))
c     never combine the two beams
         if (i.gt.2) then
c     fill combine table, first pass, determine all ptij
            do j=1,i-1
               idj=ishft(1,j-1)
               if (btest(mlevel,4))
     $              write (*,*)'i = ',i,'(',idi,'), j = ',j,'(',idj,')'
c     cluster only combinable legs (acc. to diagrams)
               icgs(0)=0
               idij=combid(idi,idj)
               pt2ij(idij)=1.0d37
               if (findmt(idij,icgs)) then
                  if (btest(mlevel,4)) then
                     write(*,*)'diagrams: ',(icgs(k),k=1,icgs(0))
                  endif
                  if (j.ne.1.and.j.ne.2) then
c     final state clustering                     
                     if(isbw(idij))then
                       pt2ij(idij)=SumDot(pcl(0,idi),pcl(0,idj),1d0)
                       if (btest(mlevel,4))
     $                    write(*,*)'Mother ',idij,' has ptij ',
     $                    sqrt(pt2ij(idij))
                     else
                       if(ktscheme.eq.2)then
                         pt2ij(idij)=pydj(pcl(0,idi),pcl(0,idj))
                       else
                         pt2ij(idij)=dj(pcl(0,idi),pcl(0,idj))
                       endif
                     endif
                     zij(idij)=0d0
                  else
c     initial state clustering, only if hadronic collision
c     check whether 2->(n-1) process w/ cms energy > 0 remains
                     iwinp=imap(3-j,2);
                     if(ickkw.eq.2.or.ktscheme.eq.2)then
                        pt2ij(idij)=pyjb(pcl(0,idi),
     $                    pcl(0,idj),pcl(0,iwinp),zij(idij))
                        zij(idij)=0d0
                     else
                        pt2ij(idij)=djb(pcl(0,idi))
                        zij(idij)=zclus(pcl(0,idi),pcl(0,idj),pcl(0,iwinp))
                     endif
c     prefer clustering when outgoing in direction of incoming
                     if(sign(1d0,pcl(3,idi)).ne.sign(1d0,pcl(3,idj)))
     $                    pt2ij(idij)=pt2ij(idij)*(1d0+1d-6)
                  endif
                  if (btest(mlevel,4)) then
                     write(*,*)'         ',idi,'&',idj,' part ',iwinp,
     &                              ' -> ',idij,' pt2ij = ',pt2ij(idij)
                     if(j.eq.1.or.j.eq.2)then
                       write(*,*)'     cf. djb: ',djb(pcl(0,idi))
                     endif
                  endif
c     Check if smallest pt2 ("winner")
                  if (pt2ij(idij).lt.minpt2ij) then
                     iwin=j
                     jwin=i
                     minpt2ij=pt2ij(idij)
                  endif                 
               endif
            enddo
         endif
      enddo
c     Take care of special 2 -> 1 case
      if (nexternal.eq.3.and.nincoming.eq.2) then
         n=1
c     Make sure that initial-state particles are daughters
         idacl(n,1)=imap(1,2)
         idacl(n,2)=imap(2,2)
         imocl(n)=imap(3,2)
         pt2ijcl(n)=pcl(4,imocl(n))
         zcl(n)=0.
c        Set info for LH clustering output
         icluster(1,n)=1
         icluster(2,n)=3
         icluster(3,n)=2
         igraphs(0)=1
         igraphs(1)=this_config
         cluster=.true.
         clustered=.true.
         return
      endif
c     initialize graph storage
      igraphs(0)=0
      nleft=nexternal
c     cluster 
      do n=1,nexternal-2
c     combine winner
         imocl(n)=imap(iwin,2)+imap(jwin,2)
         idacl(n,1)=imap(iwin,2)
         idacl(n,2)=imap(jwin,2)
         pt2ijcl(n)=minpt2ij
         zcl(n)=zij(imocl(n))
         if (btest(mlevel,2)) then
            write(*,*)'winner ',n,': ',idacl(n,1),'&',idacl(n,2),
     &           ' -> ',minpt2ij,', z = ',zcl(n)
         endif
c        Set info for LH clustering output
         icluster(1,n)=imap(iwin,1)
         icluster(2,n)=imap(jwin,1)
         icluster(3,n)=0
         icluster(4,n)=0
         if (isbw(imocl(n))) then
            do i=1,nbw
               if(ibwlist(1,i).eq.imocl(n))then
                  icluster(4,n)=ibwlist(2,i)
                  exit
               endif
            enddo
         endif
c     Reset igraphs with new mother
         if (.not.findmt(imocl(n),igraphs)) then
            write(*,*) 'cluster.f: Error. Invalid combination.' 
            return
         endif
         if (btest(mlevel,4)) then
            write(*,*)'graphs: ',(igraphs(k),k=1,igraphs(0))
         endif
         if (iwin.lt.3) then
c     is clustering
c     Set mt2ij to m^2+pt^2 
            mt2ij(n)=djb(pcl(0,idacl(n,2)))
            if (btest(mlevel,1)) then
               write(*,*)'mtij(',n,') for ',idacl(n,2),' is ',sqrt(mt2ij(n)),
     $              ' (cf ',sqrt(pt2ijcl(n)),')'
            endif
            iwinp=imap(3-iwin,2);
c        Set partner info for LH clustering output
            icluster(3,n)=imap(3-iwin,1)
            do i=0,3
               pcl(i,imocl(n))=pcl(i,idacl(n,1))-pcl(i,idacl(n,2))
c            enddo
c     set incoming particle on-shell
c            pcl(0,imocl(n))=sqrt(pcl(1,imocl(n))**2+
c     $         pcl(2,imocl(n))**2+pcl(3,imocl(n))**2)
c            do i=0,3
               pcmsp(i)=-pcl(i,imocl(n))-pcl(i,iwinp)
            enddo
            pcmsp(0)=-pcmsp(0)
            pcl(4,imocl(n))=0
            if(pcl(4,idacl(n,1)).gt.0.or.pcl(4,idacl(n,2)).gt.0.and..not.
     $         (pcl(4,idacl(n,1)).gt.0.and.pcl(4,idacl(n,2)).gt.0))
     $         pcl(4,imocl(n))=max(pcl(4,idacl(n,1)),pcl(4,idacl(n,2)))

c       Don't boost if boost vector too lightlike or last vertex 
            if (pcmsp(0)**2-pcmsp(1)**2-pcmsp(2)**2-pcmsp(3)**2.gt.100d0.and.
     $           nleft.gt.4) then
               call boostx(pcl(0,imocl(n)),pcmsp(0),p1(0))
               call constr(p1(0),pz(0),nr(0),nn2,ct,st)
               do j=1,nleft
                  call boostx(pcl(0,imap(j,2)),pcmsp(0),p1(0))
                  call rotate(p1(0),pi(0),nr(0),nn2,ct,st,1)
                  do k=0,3
                     pcl(k,imap(j,2))=pi(k)
                  enddo
               enddo
               call boostx(pcl(0,imocl(n)),pcmsp(0),p1(0))
               call rotate(p1(0),pi(0),nr(0),nn2,ct,st,1)
               do k=0,3
                  pcl(k,imocl(n))=pi(k)
               enddo
            endif
         else
c     fs clustering
           do i=0,3
             pcl(i,imocl(n))=pcl(i,idacl(n,1))+pcl(i,idacl(n,2))
           enddo
           pcl(4,imocl(n))=0
           if(pcl(4,idacl(n,1)).gt.0.or.pcl(4,idacl(n,2)).gt.0.and..not.
     $        (pcl(4,idacl(n,1)).gt.0.and.pcl(4,idacl(n,2)).gt.0))
     $        pcl(4,imocl(n))=max(pcl(4,idacl(n,1)),pcl(4,idacl(n,2)))
           if(isbw(imocl(n)))then
             pcl(4,imocl(n))=pt2ijcl(n)
             if (btest(mlevel,4))
     $          write(*,*) 'Mother ',imocl(n),' has mass**2 ',
     $          pcl(4,imocl(n))
           endif
         endif
         
         nleft=nleft-1
c     create new imap
         imap(iwin,2)=imocl(n)
         do i=jwin,nleft
            imap(i,1)=imap(i+1,1)
            imap(i,2)=imap(i+1,2)
         enddo
         if (nleft.le.3) then
c           If last clustering is FS, store also average transverse mass
c           of the particles combined (for use if QCD vertex, e.g. tt~ or qq~)
            if(iwin.gt.2)then
               mt2last=sqrt(djb(pcl(0,idacl(n,1)))*djb(pcl(0,idacl(n,2))))
               if (btest(mlevel,3)) then
                  write(*,*)'Set mt2last to ',mt2last
               endif              
c         Boost and rotate back to get m_T for final particle
               if (pcmsp(0)**2-pcmsp(1)**2-pcmsp(2)**2-pcmsp(3)**2.gt.100d0) then
                  call rotate(pcl(0,imap(3,2)),p1(0),nr(0),nn2,ct,st,-1)
                  do k=1,3
                     pcmsp(k)=-pcmsp(k)
                  enddo
                  call boostx(p1(0),pcmsp(0),pcl(0,imap(3,2)))
               endif
            endif
c         Make sure that initial-state particle is always among daughters
            idacl(n+1,1)=imap(1,2)
            idacl(n+1,2)=imap(2,2)
            imocl(n+1)=imap(3,2)
c            if(pcl(0,imocl(n)).gt.0d0)then
            pt2ijcl(n+1)=djb(pcl(0,imap(3,2)))
c        Set info for LH clustering output
            icluster(1,n+1)=1
            icluster(2,n+1)=3
            icluster(3,n+1)=2
            icluster(4,n+1)=0
            if (btest(mlevel,3)) then
              write(*,*) 'Last vertex is ',imap(1,2),imap(2,2),imap(3,2)
              write(*,*) '            -> ',pt2ijcl(n+1),sqrt(pt2ijcl(n+1))
            endif
c     If present channel among graphs, use only this channel
c     This is important when we have mixed QED-QCD
            do i=1,igraphs(0)
               if (igraphs(i).eq.this_config) then
                  igraphs(0)=1
                  igraphs(1)=this_config
                  exit
               endif
            enddo
c            if(pt2ijcl(n).gt. pt2ijcl(n+1))then
c              pt2ijcl(n+1)=pt2ijcl(n)
c              if (btest(mlevel,3)) then
c                write(*,*)'Reset scale for vertex ',n+1,' to ',pt2ijcl(n+1)
c              endif              
c            endif
            zcl(n+1)=1
c            else
c              pt2ijcl(n+1)=pt2ijcl(n)
c            endif
c           Pick out the found graphs
c            print *,'Clustering succeeded, found graph ',igscl(1)
            cluster=.true.
            clustered=.true.
            return
         endif
c     calculate new ptij
c            write(*,*)'is case'
c     recalculate all in is case due to rotation & boost
         minpt2ij=1.0d37
            do i=1,nleft
               idi=imap(i,2)
c     never combine the two beams
               if (i.gt.2) then
c     determine all ptij
                  do j=1,i-1
                     idj=imap(j,2)
                     if (btest(mlevel,4))
     $                    write (*,*)'i = ',i,'(',idi,'), j = ',j,'(',idj,')'
c     Reset diagram list icgs
                     do k=0,igraphs(0)
                        icgs(k)=igraphs(k)
                     enddo
                     if (btest(mlevel,4))
     $                    write (*,*)'Reset diagrams to: ',(icgs(k),k=1,icgs(0))
c     cluster only combinable legs (acc. to diagrams)
                     idij=combid(idi,idj)
c                     write (*,*) 'RECALC !!! ',idij
                     pt2ij(idij)=1.0d37
                     if (findmt(idij,icgs)) then
                        if (btest(mlevel,4)) then
                           write(*,*)'diagrams: ',(icgs(k),k=1,icgs(0))
                       endif
                        if (j.ne.1.and.j.ne.2) then
c     final state clustering                     
                           if(isbw(idij))then
                             pt2ij(idij)=SumDot(pcl(0,idi),pcl(0,idj),1d0)
                             if (btest(mlevel,4))
     $                          write(*,*) 'Mother ',idij,' has ptij ',
     $                          sqrt(pt2ij(idij))
                           else
                             if(ktscheme.eq.2)then
                               pt2ij(idij)=pydj(pcl(0,idi),pcl(0,idj))
                             else
                               pt2ij(idij)=dj(pcl(0,idi),pcl(0,idj))
                             endif
                           endif
                           zij(idij)=0d0
                        else
c     initial state clustering, only if hadronic collision
c     check whether 2->(n-1) process w/ cms energy > 0 remains
                          iwinp=imap(3-j,2);
                          if(ickkw.eq.2.or.ktscheme.eq.2)then
                             pt2ij(idij)=pyjb(pcl(0,idi),
     $                            pcl(0,idj),pcl(0,iwinp),zij(idij))
                          else
                             pt2ij(idij)=djb(pcl(0,idi))
                             zij(idij)=zclus(pcl(0,idi),pcl(0,idj),pcl(0,iwinp))
                          endif
c                 prefer clustering when outgoing in direction of incoming
                          if(sign(1d0,pcl(3,idi)).ne.sign(1d0,pcl(3,idj)))
     $                         pt2ij(idij)=pt2ij(idij)*(1d0+1d-6)
                        endif
                        if (btest(mlevel,4)) then
                          write(*,*)'         ',idi,'&',idj,' part ',iwinp,' -> ',idij,
     &                       ' pt2ij = ',pt2ij(idij)
                           if(j.eq.1.or.j.eq.2)then
                             write(*,*)'     cf. djb: ',djb(pcl(0,idi))
                           endif
                        endif
                        if (pt2ij(idij).lt.minpt2ij) then
                           iwin=j
                           jwin=i
                           minpt2ij=pt2ij(idij)
                        endif                 
                     endif
                  enddo
               endif
            enddo
      enddo

      return
      end

c     for cross-checking change in this file. 
c     here is a minimal list of process that we have to 
c     test
c    
c     SM
c     ----
c     p p > t t~ (up to 2jet)
c     p p > w+ (up to 3 jet)
c     p p > j j w+ (ordering seems important) 
c     p p > z t t~ j j  (no MLM needed)
c
c
c     HEFT
c     ----
c     p p > h j b b~
c     q q > a a g q q
c     g g > h g q q

      double precision function gamma(q0)
c**************************************************
c   calculates the branching probability
c**************************************************
      implicit none
      include 'nexternal.inc'
      include 'message.inc'
      include 'maxamps.inc'
      include 'cluster.inc'
      include 'sudakov.inc'
      include 'maxparticles.inc'
      include 'run.inc'
      integer i
      double precision q0, val, add, add2
      double precision qr,lf
      double precision alphas
      external alphas
      double precision pi
      parameter (pi=3.141592654d0)

      gamma=0.0d0

      if (Q1<m_qmass(iipdg)) return
      m_lastas=Alphas(alpsfact*q0)
      val=2d0*m_colfac(iipdg)*m_lastas/PI/q0
c   if (m_mode & bpm::power_corrs) then
      qr=q0/Q1
      if(m_pca(iipdg,iimode).eq.0)then
        lf=log(1d0/qr-1d0)
      else 
        lf=log(1d0/qr)
      endif
      val=val*(m_dlog(iipdg)*(1d0+m_kfac*m_lastas/(2d0*PI))*lf+m_slog(iipdg)
     $   +qr*(m_power(iipdg,1,iimode)+qr*(m_power(iipdg,2,iimode)
     $   +qr*m_power(iipdg,3,iimode))))
c   else
c   val=val*m_dlog*(1d0+m_kfac*m_lastas/(2d0*PI))*log(Q1/q0)+m_slog;
c   endif
      if(m_qmass(iipdg).gt.0d0)then
        val=val+m_colfac(iipdg)*m_lastas/PI/q0*(0.5-q0/m_qmass(iipdg)*
     $     atan(m_qmass(iipdg)/q0)-
     $     (1.0-0.5*(q0/m_qmass(iipdg))**2)*log(1.0+(m_qmass(iipdg)/q0)**2))
      endif
      val=max(val,0d0)
      if (iipdg.eq.21) then
        add=0d0
        do i=-6,-1
          if(m_qmass(abs(i)).gt.0d0)then
            add2=m_colfac(i)*m_lastas/PI/q0/
     $         (1.0+(m_qmass(abs(i))/q0)**2)*
     $         (1.0-1.0/3.0/(1.0+(m_qmass(abs(i))/q0)**2))
          else
            add2=2d0*m_colfac(i)*m_lastas/PI/q0*(m_slog(i)
     $         +qr*(m_power(i,1,iimode)+qr*(m_power(i,2,iimode)
     $         +qr*m_power(i,3,iimode))))
          endif
          add=add+max(add2,0d0)
        enddo
        val=val+add
      endif
      
      gamma = max(val,0d0)

      if (btest(mlevel,6)) then
        write(*,*)'       \\Delta^I_{',iipdg,'}(',
     &     q0,',',q1,') -> ',gamma
        write(*,*) val,m_lastas,m_dlog(iipdg),m_slog(iipdg)
        write(*,*) m_power(iipdg,1,iimode),m_power(iipdg,2,iimode),m_power(iipdg,3,iimode)
      endif

      return
      end

      double precision function sud(q0,Q11,ipdg,imode)
c**************************************************
c   actually calculates is sudakov weight
c**************************************************
      implicit none
      include 'message.inc'
      include 'nexternal.inc'
      include 'maxamps.inc'
      include 'cluster.inc'      
      integer ipdg,imode
      double precision q0, Q11
      double precision gamma,DGAUSS
      external gamma,DGAUSS
      double precision eps
      parameter (eps=1d-5)
      
      sud=0.0d0

      Q1=Q11
      iipdg=iabs(ipdg)
      iimode=imode

      sud=exp(-DGAUSS(gamma,q0,Q1,eps))

      if (btest(mlevel,6)) then
        write(*,*)'       \\Delta^',imode,'_{',ipdg,'}(',
     &     2*log10(q0/q1),') -> ',sud
      endif

      return
      end

      double precision function sudwgt(q0,q1,q2,ipdg,imode)
c**************************************************
c   calculates is sudakov weight
c**************************************************
      implicit none
      include 'message.inc'
      integer ipdg,imode
      double precision q0, q1, q2
      double precision sud
      external sud
      
      sudwgt=1.0d0

      if(q2.le.q1)then
         if(q2.lt.q1.and.btest(mlevel,4))
     $        write(*,*)'Warning! q2 < q1 in sudwgt. Return 1.'
         return
      endif

      sudwgt=sud(q0,q2,ipdg,imode)/sud(q0,q1,ipdg,imode)

      if (btest(mlevel,5)) then
        write(*,*)'       \\Delta^',imode,'_{',ipdg,'}(',
     &     q0,',',q1,',',q2,') -> ',sudwgt
      endif

      return
      end

      logical function isqcd(ipdg)
c**************************************************
c   determines whether particle is qcd particle
c**************************************************
      implicit none
      integer ipdg, irfl
      integer get_color

      isqcd=(iabs(get_color(ipdg)).gt.1)

      return
      end

      logical function is_octet(ipdg)
c**************************************************
c   determines whether particle is a QCD octet
c**************************************************
      implicit none
      integer ipdg, irfl
      integer get_color

      is_octet=(iabs(get_color(ipdg)).eq.8)

      return
      end

      logical function isjet(ipdg)
c**************************************************
c   determines whether particle is qcd jet particle
c**************************************************
      implicit none

      include 'cuts.inc'

      integer ipdg, irfl

      isjet=.true.

      irfl=abs(ipdg)
      if (irfl.gt.maxjetflavor.and.irfl.ne.21) isjet=.false.
c      write(*,*)'isjet? pdg = ',ipdg,' -> ',irfl,' -> ',isjet

      return
      end

      logical function isparton(ipdg)
c**************************************************
c   determines whether particle is qcd jet particle
c**************************************************
      implicit none

      include 'cuts.inc'
      include 'genps.inc'
      include 'run.inc'

      integer ipdg, irfl

      isparton=.true.

      irfl=abs(ipdg)
      if (irfl.gt.max(asrwgtflavor,maxjetflavor).and.irfl.ne.21)
     $     isparton=.false.
c      write(*,*)'isparton? pdg = ',ipdg,' -> ',irfl,' -> ',isparton

      return
      end


      subroutine ipartupdate(p,imo,ida1,ida2,ipdg,ipart)
c**************************************************
c   Traces particle lines according to CKKW rules
c**************************************************
c     ipart gives the external particle number corresponding to the present
c     quark or gluon line.
c     For t-channel lines, ipart(1) contains the connected beam.
c     For s-channel lines, it depends if it is quark or gluon line:
c     For quark lines, ipart(2) is 0 and ipart(1) connects to the corresponding
c     final-state quark. For gluons, if it splits into two gluons,
c     it connects to the hardest gluon. If it splits into qqbar, it ipart(1) is
c     the hardest and ipart(2) is the softest.
      implicit none

      include 'ncombs.inc'
      include 'nexternal.inc'
      include 'message.inc'

      double precision p(0:3,nexternal)
      integer imo,ida1,ida2,i,idmo,idda1,idda2
      integer ipdg(n_max_cl),ipart(2,n_max_cl)
      logical isjet
      external isjet
      integer iddgluon, iddother, idgluon, idother
      logical isqcd
      external isqcd
      integer get_color
      external get_color 

      idmo=ipdg(imo)
      idda1=ipdg(ida1)
      idda2=ipdg(ida2)

      if (btest(mlevel,4)) then
        write(*,*) 'updating ipart for: ',ida1,ida2,' -> ',imo
      endif

      if (btest(mlevel,4)) then
         write(*,*) ' daughters: ',(ipart(i,ida1),i=1,2),(ipart(i,ida2),i=1,2)
      endif

c     IS clustering - just transmit info on incoming line
      if((ipart(1,ida1).ge.1.and.ipart(1,ida1).le.2).or.
     $   (ipart(1,ida2).ge.1.and.ipart(1,ida2).le.2))then
         ipart(2,imo)=0
         if(ipart(1,ida1).le.2.and.ipart(1,ida2).le.2)then
c           This is last clustering - keep mother ipart
            ipart(1,imo)=ipart(1,imo)
         elseif(ipart(1,ida2).ge.1.and.ipart(1,ida2).le.2)then
            ipart(1,imo)=ipart(1,ida2)        
c           Transmit jet PDG code
            if(isjet(idmo)) then
               if(idda1.lt.21.and.isjet(idda1).and.
     $              (idda2.eq.21.or.idda2.eq.22))
     $              ipdg(imo)=-idda1
               if(idda2.lt.21.and.isjet(idda2).and.
     $              (idda1.eq.21.or.idda1.eq.22))
     $              ipdg(imo)=idda2
            endif
         elseif(ipart(1,ida1).ge.1.and.ipart(1,ida1).le.2)then
            ipart(1,imo)=ipart(1,ida1)
c           Transmit jet PDG code
            if(isjet(idmo)) then
               if(idda2.lt.21.and.isjet(idda2).and.
     $            (idda1.eq.21.or.idda1.eq.22))
     $              ipdg(imo)=-idda2
               if(idda1.lt.21.and.isjet(idda1).and.
     $            (idda2.eq.21.or.idda2.eq.22))
     $              ipdg(imo)=idda1
            endif
         endif
         if (btest(mlevel,4))
     $        write(*,*) ' -> ',(ipart(i,imo),i=1,2),
     $        ' (',ipdg(imo),')'
         return
      endif        
c     FS clustering
c     Transmit parton PDG code for parton vertex
      if(isjet(idmo)) then
         if(idda1.lt.21.and.isjet(idda1).and.
     $        (idda2.eq.21.or.idda2.eq.22))
     $        ipdg(imo)=idda1
         if(idda2.lt.21.and.isjet(idda2).and.
     $        (idda1.eq.21.or.idda1.eq.22))
     $        ipdg(imo)=idda2
         idmo=ipdg(imo)
      endif

      if(idmo.eq.21.and.idda1.eq.21.and.idda2.eq.21)then
c     gluon -> 2 gluon splitting: Choose hardest gluon
        if(p(1,ipart(1,ida1))**2+p(2,ipart(1,ida1))**2.gt.
     $     p(1,ipart(1,ida2))**2+p(2,ipart(1,ida2))**2) then
          ipart(1,imo)=ipart(1,ida1)
          ipart(2,imo)=ipart(2,ida1)
        else
          ipart(1,imo)=ipart(1,ida2)
          ipart(2,imo)=ipart(2,ida2)
        endif
      else if(idmo.eq.21.and. abs(idda1).le.6 .and.
     $        abs(idda2).le.6) then
c     gluon -> quark anti-quark: use both, but take hardest as 1
        if(p(1,ipart(1,ida1))**2+p(2,ipart(1,ida1))**2.gt.
     $     p(1,ipart(1,ida2))**2+p(2,ipart(1,ida2))**2) then
          ipart(1,imo)=ipart(1,ida1)
          ipart(2,imo)=ipart(1,ida2)
        else
          ipart(1,imo)=ipart(1,ida2)
          ipart(2,imo)=ipart(1,ida1)
        endif
      else if (get_color(idmo).eq.8.and.iabs(get_color(idda1)).eq.3.and.
     $         iabs(get_color(idda2)).eq.3) then
c     gluon' -> quark' anti-quark': use both, but take hardest as 1
        if(p(1,ipart(1,ida1))**2+p(2,ipart(1,ida1))**2.gt.
     $     p(1,ipart(1,ida2))**2+p(2,ipart(1,ida2))**2) then
          ipart(1,imo)=ipart(1,ida1)
          ipart(2,imo)=ipart(1,ida2)
        else
          ipart(1,imo)=ipart(1,ida2)
          ipart(2,imo)=ipart(1,ida1)
        endif
      else if(idmo.eq.21.and.(idda1.eq.21.or.idda2.eq.21))then
         if(idda1.eq.21) then
            iddgluon = idda1
            idgluon = ida1
            iddother = idda2
            idother = ida2
         else
            iddgluon = idda2
            iddother = idda1
            idgluon = ida2
            idother = ida1
         endif
         if (isqcd(iddother))then
c        gluon -> gluon + scalar octet Choose hardest one
            if(p(1,ipart(1,ida1))**2+p(2,ipart(1,ida1))**2.gt.
     $         p(1,ipart(1,ida2))**2+p(2,ipart(1,ida2))**2) then
               ipart(1,imo)=ipart(1,ida1)
               ipart(2,imo)=ipart(2,ida1)
            else
               ipart(1,imo)=ipart(1,ida2)
               ipart(2,imo)=ipart(2,ida2)
            endif
         else
c        gluon -> gluon + Higgs use the gluon one
               ipart(1,imo)=ipart(1,idgluon)
               ipart(2,imo)=ipart(2,idgluon)
         endif
      else if(idmo.eq.21) then
c     gluon > octet octet Choose hardest one
            if(p(1,ipart(1,ida1))**2+p(2,ipart(1,ida1))**2.gt.
     $         p(1,ipart(1,ida2))**2+p(2,ipart(1,ida2))**2) then
               ipart(1,imo)=ipart(1,ida1)
               ipart(2,imo)=ipart(2,ida1)
            else
               ipart(1,imo)=ipart(1,ida2)
               ipart(2,imo)=ipart(2,ida2)
            endif
      else if(idmo.eq.idda1.or.idmo.eq.idda1+sign(1,idda2))then
c     quark -> quark-gluon or quark-Z or quark-h or quark-W
        ipart(1,imo)=ipart(1,ida1)
        ipart(2,imo)=0
      else if(idmo.eq.idda2.or.idmo.eq.idda2+sign(1,idda1))then
c     quark -> gluon-quark or Z-quark or h-quark or W-quark
        ipart(1,imo)=ipart(1,ida2)
        ipart(2,imo)=0
      else if(iabs(get_color(idmo)).eq.3.and.iabs(get_color(idda1)).eq.3.and.get_color(idda2).eq.1) then
c       exotic q > q' Scalar         
        ipart(1,imo)=ipart(1,ida1)
        ipart(2,imo)=0
      else if(iabs(get_color(idmo)).eq.3.and.iabs(get_color(idda2)).eq.3.and.get_color(idda1).eq.1) then
c       exotic q > Scalar q'
        ipart(1,imo)=ipart(1,ida2)
        ipart(2,imo)=0
      else if(iabs(get_color(idmo)).eq.3.and.iabs(get_color(idda2)).eq.8.and.iabs(get_color(idda1)).eq.3) then
c       exotic q >  q' gluon
        ipart(1,imo)=ipart(1,ida2)
        ipart(2,imo)=0
      else if(iabs(get_color(idmo)).eq.3.and.iabs(get_color(idda2)).eq.3.and.get_color(idda1).eq.8) then
c       exotic q > gluon q'
        ipart(1,imo)=ipart(1,ida1)
        ipart(2,imo)=0
      else if (get_color(idmo).eq.1.or.get_color(idmo).eq.2.or.get_color(idda1).eq.2.or.get_color(idda2).eq.2) then
c     Color singlet
         ipart(1,imo)=ipart(1,ida1)
         ipart(2,imo)=ipart(1,ida2)
      else if (abs(get_color(idmo)).eq.3.and.abs(get_color(idda1)).eq.3.and.abs(get_color(idda2)).eq.3)then
c     EPSILON^IJK color structure -- handle it as photon emission --
         ipart(1,imo)=ipart(1,ida1)
         ipart(2,imo)=0
      else if (abs(get_color(idmo)).eq.6.and.abs(get_color(idda1)).eq.3.and.abs(get_color(idda2)).eq.3)then
c     sextet -> (anti-)quark (anti-)quark': use both, but take hardest as 1
        if(p(1,ipart(1,ida1))**2+p(2,ipart(1,ida1))**2.gt.
     $     p(1,ipart(1,ida2))**2+p(2,ipart(1,ida2))**2) then
          ipart(1,imo)=ipart(1,ida1)
          ipart(2,imo)=ipart(1,ida2)
        else
          ipart(1,imo)=ipart(1,ida2)
          ipart(2,imo)=ipart(1,ida1)
        endif
      else if (abs(get_color(idmo)).eq.8.and.abs(get_color(idda1)).eq.1.and.abs(get_color(idda2)).eq.8)then
         ipart(1,imo)=ipart(1,ida2)
         ipart(2,imo)=ipart(2,ida2)
      else if (abs(get_color(idmo)).eq.8.and.abs(get_color(idda1)).eq.8.and.abs(get_color(idda2)).eq.1)then
         ipart(1,imo)=ipart(1,ida1)
         ipart(2,imo)=ipart(2,ida1)
      else
         write(*,*) idmo,'>', idda1, idda2, 'color', get_color(idmo),'>', get_color(idda1), get_color(idda2)
         write(*,*) "failed for ipartupdate. Please retry without MLM/default dynamical scale"
         stop 3
      endif
      
      if (btest(mlevel,4)) then
        write(*,*) 'XY -> ',(ipart(i,imo),i=1,2),' (',ipdg(imo),')'
      endif

      return
      end
      
      logical function isjetvx(imo,ida1,ida2,ipdg,ipart,islast)
c***************************************************
c   Checks if a qcd vertex generates a jet
c***************************************************
      implicit none

      include 'ncombs.inc'
      include 'nexternal.inc'

      integer imo,ida1,ida2,idmo,idda1,idda2,i
      integer ipdg(n_max_cl),ipart(2,n_max_cl)
      logical isqcd,isjet,islast
      external isqcd,isjet

      idmo=ipdg(imo)
      idda1=ipdg(ida1)
      idda2=ipdg(ida2)
c     Check QCD vertex
      if(islast.or..not.isqcd(idmo).or..not.isqcd(idda1).or.
     &     .not.isqcd(idda2)) then
         isjetvx = .false.
         return
      endif

c     IS clustering
      if((ipart(1,ida1).ge.1.and.ipart(1,ida1).le.2).or.
     $   (ipart(1,ida2).ge.1.and.ipart(1,ida2).le.2))then
c     Check if ida1 is outgoing parton or ida2 is outgoing parton
         if(ipart(1,ida2).ge.1.and.ipart(1,ida2).le.2.and.isjet(idda1).or.
     $        ipart(1,ida1).ge.1.and.ipart(1,ida1).le.2.and.isjet(idda2))then
           isjetvx=.true.
        else
           isjetvx=.false.
        endif
        return
      endif        

c     FS clustering
      if((isjet(idda1).and.(isjet(idmo).or.idmo.eq.idda2)).or.
     $   (isjet(idda2).and.(isjet(idmo).or.idmo.eq.idda1))) then
         isjetvx=.true.
      else
         isjetvx=.false.
      endif
      return
      end

      logical function ispartonvx(imo,ida1,ida2,ipdg,ipart,islast)
c***************************************************
c   Checks if a qcd vertex generates a jet
c***************************************************
      implicit none

      include 'ncombs.inc'
      include 'nexternal.inc'

      integer imo,ida1,ida2,idmo,idda1,idda2,i
      integer ipdg(n_max_cl),ipart(2,n_max_cl)
      logical isqcd,isparton,islast
      external isqcd,isparton

      idmo=ipdg(imo)
      idda1=ipdg(ida1)
      idda2=ipdg(ida2)

c     Check QCD vertex
      if(.not.isqcd(idmo).or..not.isqcd(idda1).or.
     &     .not.isqcd(idda2)) then
         ispartonvx = .false.
         return
      endif

c     IS clustering
      if((ipart(1,ida1).ge.1.and.ipart(1,ida1).le.2).or.
     $   (ipart(1,ida2).ge.1.and.ipart(1,ida2).le.2))then
c     Check if ida1 is outgoing parton or ida2 is outgoing parton
         if(.not.islast.and.ipart(1,ida2).ge.1.and.ipart(1,ida2).le.2.and.isparton(idda1).or.
     $        ipart(1,ida1).ge.1.and.ipart(1,ida1).le.2.and.isparton(idda2))then
           ispartonvx=.true.
        else
           ispartonvx=.false.
        endif
        return
      endif        

c     FS clustering
      if(isparton(idda1).or.isparton(idda2))then
         ispartonvx=.true.
      else
         ispartonvx=.false.
      endif
      
      return
      end

      integer function ifsno(n,ipart)
c***************************************************
c   Returns the FS particle number corresponding to 
c   clustering number n (=ishft(ifsno) if FS)
c***************************************************
      implicit none
      
      include 'ncombs.inc'
      include 'nexternal.inc'
      integer n,ipart(2,n_max_cl)
      integer i
      ifsno=0
      if(ipart(1,n).gt.2.and.n.eq.ishft(1,ipart(1,n)-1))
     $     ifsno=ipart(1,n)
      return
      end

      logical function setclscales(p, keepq2bck)
c**************************************************
c     Calculate dynamic scales based on clustering
c     Also perform xqcut and xmtc cuts
c     keepq2bck allow to not reset the parameter q2bck
c**************************************************
      implicit none

      logical keepq2bck
      include 'message.inc'
      include 'genps.inc'
      include 'maxconfigs.inc'
      include 'nexternal.inc'
      include 'maxamps.inc'
      include 'cluster.inc'
      include 'run.inc'
      include 'coupl.inc'
      include 'run_config.inc'
C   
C   ARGUMENTS 
C   
      DOUBLE PRECISION P(0:3,NEXTERNAL)
C   global variables
C     Present process number
      INTEGER IMIRROR,IPROC
      COMMON/TO_MIRROR/IMIRROR, IPROC
C     ICONFIG has this config number
      INTEGER MAPCONFIG(0:LMAXCONFIGS), ICONFIG
      COMMON/TO_MCONFIGS/MAPCONFIG, ICONFIG
c     Common block for reweighting info
c     q2bck holds the central q2fact scales
      integer jlast(2)
      integer njetstore(lmaxconfigs),iqjetstore(nexternal-2,lmaxconfigs)
      real*8 q2bck(2)
      integer njets,iqjets(nexternal)
      common /to_rw/jlast,njetstore,iqjetstore,njets,iqjets,q2bck
      data njetstore/lmaxconfigs*-1/
      real*8 xptj,xptb,xpta,xptl,xmtc
      real*8 xetamin,xqcut,deltaeta
      common /to_specxpt/xptj,xptb,xpta,xptl,xmtc,xetamin,xqcut,deltaeta
      double precision stot,m1,m2
      common/to_stot/stot,m1,m2

C   local variables
      integer i, j, idi, idj, k,m
      integer get_color
      real*8 PI
      parameter( PI = 3.14159265358979323846d0 )
      integer iforest(2,-max_branch:-1,lmaxconfigs)
      double precision asref, pt2prev(n_max_cl),pt2min
      integer n, ibeam(2), iqcd(0:2)
      integer idfl, idmap(-nexternal:nexternal)
      integer ipart(2,n_max_cl)
      double precision xnow(2),etot
      integer jfirst(2),jcentral(2),nwarning
      logical qcdline(2),partonline(2)
      logical failed,first
      data first/.true./
      data nwarning/0/
      integer nqcd(lmaxconfigs)
      include 'config_nqcd.inc'

c     Variables for keeping track of jets
      logical goodjet(n_max_cl)
      integer fsnum(2),ida(2),imo,jcode
      logical chclusold,fail,increasecode
      save chclusold
      integer tmpindex
      integer pdgm, pdgid1, pdgid2

      logical isqcd,isjet,isparton,cluster,isjetvx,is_octet
      integer ifsno
      double precision alphas
      external isqcd, isjet, isparton, cluster, isjetvx, alphas, ifsno
      external is_octet
      setclscales=.true.

      if(ickkw.le.0.and.xqcut.le.0d0.and.q2fact(1).gt.0.and.scale.gt.0) then
         if(use_syst)then
            s_scale=scale
            n_qcd=nqcd(iconfig)
            n_alpsem=0
            do i=1,2
               n_pdfrw(i)=0
            enddo
            s_rwfact=1d0
         endif
      return
      endif
c   
c   Cluster the configuration
c   
      
c     First time, cluster according to this config and store jets
c     (following times, only accept configurations if the same partons
c      are flagged as jets)
      chclusold=chcluster
      if(njetstore(iconfig).eq.-1)then
         chcluster=.true.
      endif
 100  clustered = cluster(p(0,1))
      if(.not.clustered) then
         open(unit=26,file='../../../error',status='unknown',err=999)
         write(26,*) 'Error: Clustering failed in cluster.f.'
         write(*,*) 'Error: Clustering failed in cluster.f.'
         stop
 999     write(*,*) 'error'
         setclscales=.false.
         clustered = .false.
         return
      endif
c     Reset chcluster to run_card value
      chcluster=chclusold

      if (btest(mlevel,1)) then
        write(*,*)'setclscales: identified tree {'
        do i=1,nexternal-2
          write(*,*)'  ',i,': ',idacl(i,1),'(',ipdgcl(idacl(i,1),igraphs(1),iproc),')',
     $       '&',idacl(i,2),'(',ipdgcl(idacl(i,2),igraphs(1),iproc),')',
     $       ' -> ',imocl(i),'(',ipdgcl(imocl(i),igraphs(1),iproc),')',
     $       ', ptij = ',dsqrt(pt2ijcl(i))
          write(*,*)'   icluster(',i,')=',(icluster(j,i),j=1,4)
        enddo
        write(*,*)'  process: ',iproc
        write(*,*)'  graphs (',igraphs(0),'):',(igraphs(i),i=1,igraphs(0))
        write(*,*)'}'
        write(*,*)'iconfig is ',iconfig
      endif

C   If we have fixed factorization scale, for ickkw>0 means central
C   scale, i.e. last two scales (ren. scale for these vertices are
C   anyway already set by "scale" above)
      if (first) then
            q2bck(1)=q2fact(1)
            q2bck(2)=q2fact(2)
            first=.false.
      else if(ickkw.gt.0) then
         if(fixed_fac_scale) then
            q2fact(1)=q2bck(1)
            q2fact(2)=q2bck(2)
         endif
      endif

c   Preparing graph particle information (ipart, needed to keep track of
c   external particle clustering scales)

c   ipart gives the external particle number corresponding to the present
c   quark or gluon line. 
c   For t-channel lines, ipart(1) contains the connected beam. 
c   For s-channel lines, it depends if it is quark or gluon line:
c   For quark lines, ipart(2) is 0 and ipart(1) connects to the corresponding
c   final-state quark. For gluons, if it splits into two gluons, 
c   it connects to the hardest gluon. If it splits into qqbar, it ipart(1) is
c   the hardest and ipart(2) is the softest.

      do i=1,nexternal
         ipart(1,ishft(1,i-1))=i
         ipart(2,ishft(1,i-1))=0
      enddo
      do n=1,nexternal-3
        call ipartupdate(p,imocl(n),idacl(n,1),idacl(n,2),
     $       ipdgcl(1,igraphs(1),iproc),ipart)
      enddo

c     Prepare beam related variables for scale and jet determination
      do i=1,2
         ibeam(i)=ishft(1,i-1)
c        jfirst is first parton splitting on this side
         jfirst(i)=0
c        jlast is last parton on this side This means
c        the last cluster which is still QCD.
         jlast(i)=0
c        jcentral is the central scale vertex on this side. i.e it stops
c        when the T channel particles is not colored anymore.
         jcentral(i)=0
c        qcdline gives whether this IS line is QCD
         qcdline(i)=isqcd(ipdgcl(ibeam(i),igraphs(1),iproc))
c        partonline gives whether this IS line is parton (start out true for any QCD)
         partonline(i)=qcdline(i)
c        goodjet gives whether this cluster line is considered a jet
c        i.e. if all related/previous clustering are jet
         goodjet(ibeam(i))=partonline(i)
      enddo

      do i=3,nexternal
         j=ishft(1,i-1)
         goodjet(j)=isjet(ipdgcl(j,igraphs(1),iproc))
      enddo

c     Go through clusterings and set factorization scale points for use in dsig
c     as well as which FS particles count as jets (from jet vertices)
      do i=1,nexternal
         iqjets(i)=0
      enddo
      if (nexternal.eq.3) goto 10
c     jcode helps keep track of how many QCD/non-QCD flips we have gone through
      jcode=1
c     increasecode gives whether we should increase jcode at next vertex
      increasecode=.false.
      do n=1,nexternal-2
c         write(*,*) 'QCD jet status (before n= ',n,'):',(iqjets(i),i=3,nexternal)
        do i=1,2 ! index of the child in the interaction
          do j=1,2 ! j index of the beam
            if(idacl(n,i).eq.ibeam(j))then
c             IS clustering
              ibeam(j)=imocl(n)
c             Determine which are beam particles based on n
              if(n.lt.nexternal-2) then
                 ida(i)=idacl(n,i)
                 ida(3-i)=idacl(n,3-i)
                 imo=imocl(n)
              else
                 ida(i)=idacl(n,i)
                 ida(3-i)=imocl(n)
                 imo=idacl(n,3-i)
              endif
c             
              if(partonline(j))then
c             If jfirst not set, set it
                 if(jfirst(j).eq.0) jfirst(j)=n
c             Stop fact scale where parton line stops
                 jlast(j)=n
                 partonline(j)=goodjet(ida(3-i)).and.
     $                isjet(ipdgcl(imo,igraphs(1),iproc))
              else if (jfirst(j).eq.0) then
                 jfirst(j) = n
                 goodjet(imo)=.false.
              else
                 goodjet(imo)=.false.
              endif
c             If not jet vertex, increase jcode. This is needed
c             e.g. in VBF if we pass over to the other side and hit
c             parton vertices again.
              if(.not.goodjet(ida(3-i)).or.
     $             .not.isjet(ipdgcl(ida(i),igraphs(1),iproc)).or.
     $             .not.isjet(ipdgcl(imo,igraphs(1),iproc))) then
                  jcode=jcode+1
                  increasecode=.true.
               else if(increasecode) then
                  jcode=jcode+1
                  increasecode=.false.
               endif
c             Consider t-channel jet radiations as jets only if
c             FS line is a jet line
              if(goodjet(ida(3-i))) then
                 if(partonline(j).or.
     $ ipdgcl(ida(3-i),igraphs(1),iproc).eq.21)then
c                   Need to include gluon to avoid soft singularity
                    iqjets(ipart(1,ida(3-i)))=1 ! 1 means for sure jet
                 else
                    iqjets(ipart(1,ida(3-i)))=jcode ! jcode means possible jet
                 endif
              endif
c             Trace QCD line through event
              if(qcdline(j))then
                 jcentral(j)=n
                 qcdline(j)=isqcd(ipdgcl(imo,igraphs(1),iproc))
              endif
            endif
          enddo
        enddo
        if (imocl(n).ne.ibeam(1).and.imocl(n).ne.ibeam(2)) then
c          FS clustering
c          Check QCD jet, take care so not a decay
           if(.not.isjetvx(imocl(n),idacl(n,1),idacl(n,2),
     $        ipdgcl(1,igraphs(1),iproc),ipart,n.eq.nexternal-2)) then
              pdgm   = ipdgcl(imocl(n),igraphs(1),iproc)
              pdgid1 = ipdgcl(idacl(n,1),igraphs(1),iproc)
              pdgid2 = ipdgcl(idacl(n,2),igraphs(1),iproc)
              if (isqcd(pdgm).and.isqcd(pdgid1).and.isqcd(pdgid2))then
                  continue
c          Remove non-gluon jets that lead up to non-jet vertices
           elseif(ipart(1,imocl(n)).gt.2)then ! ipart(1) set and not IS line
c          The ishft gives the FS particle corresponding to imocl
              if(.not.is_octet(ipdgcl(ishft(1,ipart(1,imocl(n))-1),igraphs(1),iproc)))then
                 ! split case for q a > q and for g > g h (with the gluon splitting into quark)
                 ! also check for case of three scalar interaction (then do nothing)
                 if (.not.isqcd(pdgm).and..not.isqcd(pdgid1).and..not.isqcd(pdgid2)) then
                    ! this is to avoid to do weird stuff for w+ w- z (or h h h) 
                    ! this fix an issue for qq_zttxqq G1594.08
                     continue
                 elseif (ipart(2,imocl(n)).eq.0) then ! q a > q case
                       iqjets(ipart(1,imocl(n)))=0
                 else ! octet. want to be sure that both are tagged as jet before removing one
                    ! this prevent that both are removed in case of g > g h , g > q1 q2, q1 > a q1.
                    ! at least one of the two should be kept as jet
                    ! introduce for q q > a a g q q in heft
                    if (iqjets(ipart(1,imocl(n))).gt.0.and.iqjets(ipart(2,imocl(n))).gt.0)then
                       iqjets(ipart(1,imocl(n)))=0
                    endif
                 endif
              else if (is_octet(ipdgcl(imocl(n),igraphs(1),iproc)))then
c                special case for g > g h remove also the hardest gluon
                 iqjets(ipart(1,imocl(n)))=0
              endif
           endif
           if(ipart(2,imocl(n)).gt.2)then ! ipart(1) set and not IS line
c             The ishft gives the FS particle corresponding to imocl
              if(.not.is_octet(ipdgcl(ishft(1,ipart(2,imocl(n))-1),igraphs(1),iproc)).and.
     $                                   .not.is_octet(ipdgcl(imocl(n),igraphs(1),iproc))) then
c                 The second condition is to prevent the case of ggh where the gluon split in quark later.
c                 The first quark is already remove so we shouldn't remove this one. introduce for gg_hgqq (in heft)      
              iqjets(ipart(2,imocl(n)))=0
              endif
           endif
c          Set goodjet to false for mother
              goodjet(imocl(n))=.false.
              cycle
           endif

c          This is a jet vertex, so set jet flag for final-state jets
c          ifsno gives leg number if daughter is FS particle, otherwise 0
           fsnum(1)=ifsno(idacl(n,1),ipart)
           if(isjet(ipdgcl(idacl(n,1),igraphs(1),iproc)).and.
     $          fsnum(1).gt.0) then
              iqjets(fsnum(1))=1
           endif
           fsnum(1)=ifsno(idacl(n,2),ipart)
           if(isjet(ipdgcl(idacl(n,2),igraphs(1),iproc)).and.
     $          fsnum(1).gt.0) then
              iqjets(fsnum(1))=1
           endif
c          Flag mother as good jet if PDG is jet and both daughters are jets
           goodjet(imocl(n))=
     $          (isjet(ipdgcl(imocl(n),igraphs(1),iproc)).and.
     $          goodjet(idacl(n,1)).and.goodjet(idacl(n,2)))
            
c       check case with g > g g
c       where the hardest gluon is not goodjet but the other is.
c       in that case change ipart(1,) of the mother gluon
c             pure QCD jet
c             need to take care of the following case:
c                                      tttttttttt
c                      gggggggggggggggg  
c             ggggggggg                tttttttttt 
c                      gggggggg
c                        
c             in that case the up gluon can be tag as the hardest one
c             but this one is also lead to no QCD one.
c             so in that case we have to change ipart(1) to the sofest gluon
           pdgm   = ipdgcl(imocl(n),igraphs(1),iproc)
           pdgid1 = ipdgcl(idacl(n,1),igraphs(1),iproc)
           pdgid2 = ipdgcl(idacl(n,2),igraphs(1),iproc)
           if (is_octet(pdgm).and.is_octet(pdgid1).and.is_octet(pdgid2))then
c              write(*,*) 'pure QCD vertex (2)'
c              write(*,*) pdgm , '>', pdgid1,' ', pdgid2
c              write(*,*) 'ipart', ipart(1,imocl(n)), ipart(2,imocl(n))
c              write(*,*) 'id', imocl(n), idacl(n,1),idacl(n,2)
c              write(*,*) 'ipart',ipart(1,imocl(n)),'/', ipart(2,imocl(n)), ipart(1,idacl(n,1)),'/', ipart(2,idacl(n,1)),
c     $             ipart(1,idacl(n,2)),'/', ipart(2,idacl(n,2))
c              write(*,*) 'googjet', goodjet(idacl(n,1)),goodjet(idacl(n,2))
              if (ipart(1,imocl(n)).eq.ipart(1, idacl(n,1))) then
                  if (.not.goodjet(idacl(n,1)).and.goodjet(idacl(n,2))) then
c                     write(*,*) 'ggg with hard jet set a QED the second jet lead to', ipart(1,idacl(n,2)), ipart(2,idacl(n,2))
                     do m =n_max_cl,n,-1
                        if(ipart(1,m).eq.ipart(1,imocl(n)).and.ipart(2,m).eq.ipart(2,imocl(n)))then
                           ipart(1,m) = ipart(1,idacl(n,2))
                           ipart(2,m) = ipart(2,idacl(n,2))
                        endif
                     enddo
                  endif
               else
                  if (.not.goodjet(idacl(n,2)).and.goodjet(idacl(n,1))) then
c                     write(*,*) 'ggg with hard jet set a QED the second jet lead to', ipart(1,idacl(n,1)), ipart(2,idacl(n,1))
                     do m =n_max_cl,n,-1
                        if(ipart(1,m).eq.ipart(1,imocl(n)).and.ipart(2,m).eq.ipart(2,imocl(n)))then
                           ipart(1,m) = ipart(1,idacl(n,1))
                           ipart(2,m) = ipart(2,idacl(n,1))
                        endif
                     enddo
                  endif
               endif
            endif



       endif
      enddo

      if (btest(mlevel,4))then
         write(*,*) 'QCD jet status (before): ',(iqjets(i),i=3,nexternal)
      endif
c     Emissions with code 1 are always jets
c     Now take care of possible jets (i.e., with code > 1)
      if(.not. partonline(1).or..not.partonline(2))then
c       First reduce jcode by one if one remaining partonline
c       (in that case accept all jets with final jcode)
        if(partonline(1).or.partonline(2)) jcode=jcode-1
c       There parton emissions with code <= jcode are not jets
         do i=3,nexternal
            if(iqjets(i).gt.1.and.iqjets(i).le.jcode)then
               iqjets(i)=0
            endif
         enddo
      endif

 10   if(jfirst(1).le.0) jfirst(1)=jlast(1)
      if(jfirst(2).le.0) jfirst(2)=jlast(2)

      if (btest(mlevel,3))
     $     write(*,*) 'jfirst is ',jfirst(1),jfirst(2),
     $     ' jlast is ',jlast(1),jlast(2),
     $     ' and jcentral is ',jcentral(1),jcentral(2)

      if (btest(mlevel,3)) then
         write(*,'(a$)') 'QCD jets (final): '
         do i=3,nexternal
            if(iqjets(i).gt.0) write(*,'(i3$)') i
         enddo
         write(*,*)
      endif
      if(njetstore(iconfig).eq.-1) then
c     Store external jet numbers if first time
         njets=0
         do i=3,nexternal
            if(iqjets(i).gt.0)then
               njets=njets+1
               iqjetstore(njets,iconfig)=i
            endif
         enddo
         njetstore(iconfig)=njets
        if (btest(mlevel,4))
     $       write(*,*) 'Storing jets: ',(iqjetstore(i,iconfig),i=1,njets)
c     Recluster without requiring chcluster
         goto 100
      else
c     Otherwise, check that we have the right jets
c     if not, recluster according to iconfig
         fail=.false.
         njets=0
         do i=1,nexternal
            if(iqjets(i).gt.0)then
               njets=njets+1
c               if (iqjetstore(njets,iconfig).ne.i) fail=.true.
            endif
         enddo
         if(njets.ne.njetstore(iconfig)) fail=.true.
         if (fail) then
            if (igraphs(1).eq.iconfig) then
               open(unit=26,file='../../../error',status='unknown',err=999)
               write(*,*) 'Error: Failed despite same graph: ',iconfig
               write(*,*) 'Have jets (>0)',(iqjets(i),i=1,nexternal)
               write(*,*) 'Should be ',
     $              (iqjetstore(i,iconfig),i=1,njetstore(iconfig))
               write(26,*) 'Error: Failed despite same graph: ',iconfig,
     $              '. Have jets (>0)',(iqjets(i),i=1,nexternal),
     $              ', should be ',
     $              (iqjetstore(i,iconfig),i=1,njetstore(iconfig))
               stop 4
            endif
            if (btest(mlevel,3))
     $           write(*,*) 'Bad clustering, jets fail. Reclustering ',
     $           iconfig
            chcluster=.true.
            goto 100
         endif
      endif
      
c     If last clustering is s-channel QCD (e.g. ttbar) use mt2last instead
c     (i.e. geom. average of transverse mass of t and t~)
        if(mt2last.gt.4d0 .and. nexternal.gt.3) then
           if(jlast(1).eq.nexternal-2.and.jlast(2).eq.nexternal-2.and.
     $        isqcd(ipdgcl(idacl(nexternal-3,1),igraphs(1),iproc)).and.
     $        isqcd(ipdgcl(idacl(nexternal-3,2),igraphs(1),iproc)).and.
     $        isqcd(ipdgcl(imocl(nexternal-3),igraphs(1),iproc)))then
              mt2ij(nexternal-2)=mt2last
              mt2ij(nexternal-3)=mt2last
              if (btest(mlevel,3)) then
                 write(*,*)' setclscales: set last vertices to mtlast: ',sqrt(mt2last)
              endif
           endif
        endif

c     Set central scale to mT2
      if(jcentral(1).gt.0) then
         if(mt2ij(jcentral(1)).gt.0d0)
     $        pt2ijcl(jcentral(1))=mt2ij(jcentral(1))
      endif
      if(jcentral(2).gt.0)then
         if(mt2ij(jcentral(2)).gt.0d0)
     $     pt2ijcl(jcentral(2))=mt2ij(jcentral(2))
      endif
      if(btest(mlevel,4))then
         write(*,*) 'jlast, jcentral: ',(jlast(i),i=1,2),(jcentral(i),i=1,2)
         if(jlast(1).gt.0) write(*,*)'pt(jlast 1): ', sqrt(pt2ijcl(jlast(1)))
         if(jlast(2).gt.0) write(*,*)'pt(jlast 2): ', sqrt(pt2ijcl(jlast(2)))
         if(jcentral(1).gt.0) write(*,*)'pt(jcentral 1): ', sqrt(pt2ijcl(jcentral(1)))
         if(jcentral(2).gt.0) write(*,*)'pt(jcentral 2): ', sqrt(pt2ijcl(jcentral(2)))
      endif
c     Check xqcut for vertices with jet daughters only
      ibeam(1)=ishft(1,0)
      ibeam(2)=ishft(1,1)
      if(xqcut.gt.0) then
         do n=1,nexternal-3
c        Check if any of vertex daughters among jets
            do i=1,2
c              ifsno gives leg number if daughter is FS particle, otherwise 0
               fsnum(1)=ifsno(idacl(n,i),ipart)
               if(fsnum(1).gt.0)then
                  if(iqjets(fsnum(1)).gt.0)then
c                    Daughter among jets - check xqcut
                     if(sqrt(pt2ijcl(n)).lt.xqcut)then
                        if (btest(mlevel,3))
     $                       write(*,*) 'Failed xqcut: ',n,
     $                       ipdgcl(idacl(n,1),igraphs(1),iproc),
     $                       ipdgcl(idacl(n,2),igraphs(1),iproc),
     $                       sqrt(pt2ijcl(n))
                        setclscales=.false.
                        clustered = .false.
                        return
                     endif
                  endif
               endif
            enddo
         enddo
      endif
c     JA: Check xmtc cut for central process
      if(xmtc**2.gt.0) then
         if(jcentral(1).gt.0.and.pt2ijcl(jcentral(1)).lt.xmtc**2
     $      .or.jcentral(2).gt.0.and.pt2ijcl(jcentral(2)).lt.xmtc**2)then
            setclscales=.false.
            clustered = .false.
            if(btest(mlevel,3)) write(*,*)'Failed xmtc cut ',
     $           sqrt(pt2ijcl(jcentral(1))),sqrt(pt2ijcl(jcentral(1))),
     $           ' < ',xmtc
            return
         endif
      endif
      
      if(ickkw.eq.0.and.(fixed_fac_scale.or.q2fact(1).gt.0).and.
     $     (fixed_ren_scale.or.scale.gt.0)) return

c     Ensure that last scales are at least as big as first scales
      if(jlast(1).gt.0)
     $     pt2ijcl(jlast(1))=max(pt2ijcl(jlast(1)),pt2ijcl(jfirst(1)))
      if(jlast(2).gt.0)
     $     pt2ijcl(jlast(2))=max(pt2ijcl(jlast(2)),pt2ijcl(jfirst(2)))

      if(ickkw.gt.0.and.q2fact(1).gt.0) then
c     Use the fixed or previously set scale for central scale
         if(jcentral(1).gt.0) pt2ijcl(jcentral(1))=q2fact(1)
         if(jcentral(2).gt.0.and.jcentral(2).ne.jcentral(1))
     $        pt2ijcl(jcentral(2))=q2fact(2)
      endif

      if(nexternal.eq.3.and.nincoming.eq.2.and.q2fact(1).eq.0) then
         q2fact(1)=pt2ijcl(nexternal-2)
         q2fact(2)=pt2ijcl(nexternal-2)
      endif

      if(q2fact(1).eq.0d0) then
c     Use the geom. average of central scale and first non-radiation vertex
         if(jlast(1).gt.0) q2fact(1)=sqrt(pt2ijcl(jlast(1))*pt2ijcl(jcentral(1)))
         if(jlast(2).gt.0) q2fact(2)=sqrt(pt2ijcl(jlast(2))*pt2ijcl(jcentral(2)))
         if(jcentral(1).gt.0.and.jcentral(1).eq.jcentral(2))then
c     We have a qcd line going through the whole event, use single scale
            q2fact(1)=max(q2fact(1),q2fact(2))
            q2fact(2)=q2fact(1)
         endif
      endif
      if(.not. fixed_fac_scale) then
         q2fact(1)=scalefact**2*q2fact(1)
         q2fact(2)=scalefact**2*q2fact(2)
         if (.not.keepq2bck)then
            q2bck(1)=q2fact(1)
            q2bck(2)=q2fact(2)
         endif
         if (btest(mlevel,3))
     $      write(*,*) 'Set central fact scales to ',sqrt(q2bck(1)),sqrt(q2bck(2))
      endif
         
c     Set renormalization scale to geom. aver. of relevant scales
      if(scale.eq.0d0) then
         if(jlast(1).gt.0.and.jlast(2).gt.0)then
c           Use geom. average of last and central scales
            scale=(pt2ijcl(jlast(1))*pt2ijcl(jcentral(1))*
     $             pt2ijcl(jlast(2))*pt2ijcl(jcentral(2)))**0.125
         elseif(jlast(1).gt.0)then
c           Use geom. average of last and central scale
            scale=(pt2ijcl(jlast(1))*pt2ijcl(jcentral(1)))**0.25
         elseif(jlast(2).gt.0)then
c           Use geom. average of last and central scale
            scale=(pt2ijcl(jlast(2))*pt2ijcl(jcentral(2)))**0.25
         elseif(jcentral(1).gt.0.and.jcentral(2).gt.0) then
c           Use geom. average of central scales
            scale=(pt2ijcl(jcentral(1))*pt2ijcl(jcentral(2)))**0.25d0
         elseif(jcentral(1).gt.0) then
            scale=sqrt(pt2ijcl(jcentral(1)))
         elseif(jcentral(2).gt.0) then
            scale=sqrt(pt2ijcl(jcentral(2)))
         else
            scale=sqrt(pt2ijcl(nexternal-2))
         endif
         scale=scalefact*scale
         if(scale.gt.0)
     $        G = SQRT(4d0*PI*ALPHAS(scale))
      endif
      if (btest(mlevel,3))
     $     write(*,*) 'Set ren scale to ',scale


c     Take care of case when jcentral are zero
      if(jcentral(1).eq.0.and.jcentral(2).eq.0)then
         if(q2fact(1).gt.0)then
            pt2ijcl(nexternal-2)=q2fact(1)
            if(nexternal.gt.3) pt2ijcl(nexternal-3)=q2fact(1)
         else
            q2fact(1)=scalefact**2*pt2ijcl(nexternal-2)
            q2fact(2)=scalefact**2*q2fact(1)
         endif
      elseif(jcentral(1).eq.0)then
            q2fact(1) = scalefact**2*pt2ijcl(jfirst(1))
      elseif(jcentral(2).eq.0)then
            q2fact(2) = scalefact**2*pt2ijcl(jfirst(2))
      elseif(ickkw.eq.2.or.(pdfwgt.and.ickkw.gt.0))then
c     Total pdf weight is f1(x1,pt2E)*fj(x1*z,Q)/fj(x1*z,pt2E)
c     f1(x1,pt2E) is given by DSIG, just need to set scale.
c     Use the minimum scale found for fact scale in ME
         if(jlast(1).gt.0.and.jfirst(1).le.jlast(1))
     $        q2fact(1)=scalefact**2*min(pt2ijcl(jfirst(1)),q2fact(1))
         if(jlast(2).gt.0.and.jfirst(2).le.jlast(2))
     $        q2fact(2)=scalefact**2*min(pt2ijcl(jfirst(2)),q2fact(2))
      endif

c     Check that factorization scale is >= 2 GeV
      if(lpp(1).ne.0.and.q2fact(1).lt.4d0.or.
     $   lpp(2).ne.0.and.q2fact(2).lt.4d0)then
         if(nwarning.le.10) then
             nwarning=nwarning+1
             write(*,*) 'Warning: Too low fact scales: ',
     $            sqrt(q2fact(1)), sqrt(q2fact(2))
          endif
         if(nwarning.eq.11) then
             nwarning=nwarning+1
             write(*,*) 'No more warnings written out this run.'
          endif
         setclscales=.false.
         clustered = .false.
         return
      endif

      if (btest(mlevel,3))
     $     write(*,*) 'Set fact scales to ',sqrt(q2fact(1)),sqrt(q2fact(2))

c
c     Store jet info for matching
c
      etot=sqrt(stot)
      do i=1,nexternal
         ptclus(i)=0d0
      enddo

      do n=1,nexternal-2
         if(n.lt.nexternal-2) then
            ida(1)=idacl(n,1)
            ida(2)=idacl(n,2)
            imo=imocl(n)
         else
            ida(1)=idacl(n,1)
            ida(2)=imocl(n)
            imo=idacl(n,2)
         endif
         do i=1,2
            do j=1,2
c              First adjust goodjet based on iqjets
               if(goodjet(ida(i)).and.ipart(j,ida(i)).gt.2)then
                  if(iqjets(ipart(j,ida(i))).eq.0) goodjet(ida(i))=.false.
               endif
c              Now reset ptclus if jet vertex
               if(ipart(j,ida(i)).gt.2) then
                  if(isjetvx(imocl(n),idacl(n,1),idacl(n,2),
     $               ipdgcl(1,igraphs(1),iproc),ipart,n.eq.nexternal-2)
     $              .and.goodjet(ida(i))) then
                     ptclus(ipart(j,ida(i)))=
     $                    max(ptclus(ipart(j,ida(i))),dsqrt(pt2ijcl(n)))
                  else if(ptclus(ipart(j,ida(i))).eq.0d0) then
                     ptclus(ipart(j,ida(i)))=etot
                  endif
                  if (btest(mlevel,3))
     $                 write(*,*) 'Set ptclus for ',ipart(j,ida(i)),
     $                 ' to ', ptclus(ipart(j,ida(i))),ida(i),goodjet(ida(i))
               endif
            enddo
         enddo
      enddo
c
c     Store information for systematics studies
c

      if(use_syst)then
         s_scale=scale
         n_qcd=nqcd(igraphs(1))
         n_alpsem=0
         do i=1,2
            n_pdfrw(i)=0
         enddo
         s_rwfact=1d0
      endif
      return
      end

      double precision function custom_bias(p, original_weight, numproc)
c***********************************************************
c     Returns a bias weight as instructed by the bias module
c***********************************************************
      implicit none

      include 'nexternal.inc'
      include 'maxparticles.inc'
      include 'run_config.inc'
      include 'lhe_event_infos.inc'
      include 'run.inc'

      DOUBLE PRECISION P(0:3,NEXTERNAL)
      integer numproc

      double precision original_weight

      double precision bias_weight
      logical is_bias_dummy, requires_full_event_info
      common/bias/bias_weight,is_bias_dummy,requires_full_event_info

      
C     If the bias module necessitates the full event information
C     then we must call write_leshouches here already so as to set it.
C     The weight specified at this stage is irrelevant since we
C     use do_write_events set to .False.
      AlreadySetInBiasModule = .False.      
      if (requires_full_event_info) then
        call write_leshouche(p,-1.0d0,numproc,.False.)
C     Write the event in the string evt_record, part of the
C     lhe_event_info common block
        event_record(:) = ''
        call write_event_to_stream(event_record,pb(0,1),1.0d0,npart,
     &      jpart(1,1),ngroup,sscale,aaqcd,aaqed,buff,use_syst,
     &      s_buff, nclus, buffclus)
        AlreadySetInBiasModule = .True. 
      else
        AlreadySetInBiasModule = .False.
      endif
C     Apply the bias weight. The default run_card entry 'None' for the 
c     'bias_weight' option will implement a constant bias_weight of 1.0 below.
      call bias_wgt(p, original_weight, bias_weight)
      custom_bias = bias_weight

      end

      double precision function rewgt(p)
c**************************************************
c   reweight the hard me according to ckkw
c   employing the information in common/cl_val/
c**************************************************
      implicit none

      include 'message.inc'
      include 'genps.inc'
      include 'maxconfigs.inc'
      include 'nexternal.inc'
      include 'maxamps.inc'
      include 'cluster.inc'
      include 'run.inc'
      include 'coupl.inc'
      include 'run_config.inc'
C   
C   ARGUMENTS 
C   
      DOUBLE PRECISION P(0:3,NEXTERNAL)

C
C   global variables
C     Present process number
      INTEGER IMIRROR,IPROC
      COMMON/TO_MIRROR/IMIRROR, IPROC
      integer              IPSEL
      COMMON /SubProc/ IPSEL
      INTEGER SUBDIAG(MAXSPROC),IB(2)
      COMMON/TO_SUB_DIAG/SUBDIAG,IB
      data IB/1,2/
C     ICONFIG has this config number
      INTEGER MCONFIG(0:LMAXCONFIGS), ICONFIG
      COMMON/TO_MCONFIGS/MCONFIG, ICONFIG
c     Common block for reweighting info
c     q2bck holds the central q2fact scales
      integer jlast(2)
      integer njetstore(lmaxconfigs),iqjetstore(nexternal-2,lmaxconfigs)
      real*8 q2bck(2)
      integer njets,iqjets(nexternal)
      common /to_rw/jlast,njetstore,iqjetstore,njets,iqjets,q2bck
      integer idup(nexternal,maxproc,maxsproc)
      integer mothup(2,nexternal)
      integer icolup(2,nexternal,maxflow,maxsproc)
      include 'leshouche.inc'

C   local variables
      integer i, j, idi, idj
      real*8 PI
      parameter( PI = 3.14159265358979323846d0 )

      logical setclscales
      integer mapconfig(0:lmaxconfigs), this_config
      integer iforest(2,-max_branch:-1,lmaxconfigs)
      integer sprop(maxsproc,-max_branch:-1,lmaxconfigs)
      integer tprid(-max_branch:-1,lmaxconfigs)
      include 'configs.inc'
      real*8 xptj,xptb,xpta,xptl,xmtc
      real*8 xetamin,xqcut,deltaeta
      common /to_specxpt/xptj,xptb,xpta,xptl,xmtc,xetamin,xqcut,deltaeta
      double precision asref, pt2prev(n_max_cl),pt2pdf(n_max_cl),pt2min
      integer n, ibeam(2), iqcd(0:2)!, ilast(0:nexternal)
      integer idfl, idmap(-nexternal:nexternal)
c     ipart gives external particle number chain
      integer ipart(2,n_max_cl)
      double precision xnow(2)
      double precision xtarget,tmp,pdfj1,pdfj2,q2now
      integer iseed,np
      data iseed/0/
      logical isvx
      logical goodjet(n_max_cl)

      logical isqcd,isjet,isparton,isjetvx,ispartonvx
      double precision alphas,getissud,pdg2pdf, sudwgt
      real xran1
      external isqcd,isjet,isparton,ispartonvx
      external alphas, isjetvx, getissud, pdg2pdf, xran1,  sudwgt

      rewgt=1.0d0
      clustered=.false.

      if(ickkw.le.0.and..not.use_syst) return

c   Set mimimum kt scale, depending on highest mult or not
      if(hmult.or.ickkw.eq.1)then
        pt2min=0
      else
        pt2min=xqcut**2
      endif
      if (btest(mlevel,3))
     $     write(*,*) 'pt2min set to ',pt2min

c   Since we use pdf reweighting, need to know particle identities
      if (btest(mlevel,1)) then
         write(*,*) 'Set process number ',ipsel
      endif

      if (use_syst.and.igraphs(1).eq.0) igraphs(1) = iconfig ! happens if use_syst=T BUT fix scale
c     Set incoming particle identities
      ipdgcl(1,igraphs(1),iproc)=idup(1,ipsel,iproc)
      ipdgcl(2,igraphs(1),iproc)=idup(2,ipsel,iproc)
      if (btest(mlevel,2)) then
         write(*,*) 'Set particle identities: ',
     $        1,ipdgcl(1,igraphs(1),iproc),
     $        ' and ',
     $        2,ipdgcl(2,igraphs(1),iproc)

      endif
      

      if(ickkw.le.0)then
c     Store pdf information for systematics studies (initial)
         if(use_syst)then
            do j=1,2
                n_pdfrw(j)=1
                i_pdgpdf(1,j)=ipdgcl(j,igraphs(1),iproc)
                s_xpdf(1,j)=xbk(ib(j))
                s_qpdf(1,j)=sqrt(q2fact(j))
            enddo
           endif
         asref=0 ! usefull for syscalc
         goto 100
      endif


      if(.not.setclscales(p,.true.)) then ! assign the correct id information.(preserve q2bck)
         write(*,*) "Fail to cluster the events from the rewgt function"
         stop 1
c        rewgt = 0d0
        return
      endif


c     Store pdf information for systematics studies (initial)
c     need to be done after      setclscales since that one clean the syscalc value
      if(use_syst)then
         do j=1,2
            n_pdfrw(j)=1
            i_pdgpdf(1,j)=ipdgcl(j,igraphs(1),iproc)
            s_xpdf(1,j)=xbk(ib(j))
            s_qpdf(1,j)=sqrt(q2fact(j))
         enddo
      endif

c   Preparing graph particle information (ipart, needed to keep track of
c   external particle clustering scales)
      do i=1,nexternal
c        ilast(i)=ishft(1,i)
         pt2prev(ishft(1,i-1))=0d0
         if (ickkw.eq.2) then
            if(pt2min.gt.0)then
               pt2prev(ishft(1,i-1))=
     $              max(pt2min,p(0,i)**2-p(1,i)**2-p(2,i)**2-p(3,i)**2)
            endif
            pt2pdf(ishft(1,i-1))=pt2prev(ishft(1,i-1))
         else if(pdfwgt.and.ickkw.gt.0) then
            pt2pdf(ishft(1,i-1))=0d0
         endif
         ipart(1,ishft(1,i-1))=i
         ipart(2,ishft(1,i-1))=0
         if (btest(mlevel,4))
     $        write(*,*) 'Set ipart for ',ishft(1,i-1),' to ',
     $        ipart(1,ishft(1,i-1)),ipart(2,ishft(1,i-1))
      enddo
c      ilast(0)=nexternal
      ibeam(1)=ishft(1,0)
      ibeam(2)=ishft(1,1)
      if (btest(mlevel,1)) then
        write(*,*)'rewgt: identified tree {'
        do i=1,nexternal-2
          write(*,*)'  ',i,': ',idacl(i,1),'(',ipdgcl(idacl(i,1),igraphs(1),iproc),')',
     $       '&',idacl(i,2),'(',ipdgcl(idacl(i,2),igraphs(1),iproc),')',
     $       ' -> ',imocl(i),'(',ipdgcl(imocl(i),igraphs(1),iproc),')',
     $       ', ptij = ',dsqrt(pt2ijcl(i))
        enddo
        write(*,*)'  graphs (',igraphs(0),'):',(igraphs(i),i=1,igraphs(0))
        write(*,*)'}'
      endif
c     Set x values for the two sides, for IS Sudakovs
      do i=1,2
        xnow(i)=xbk(ib(i))
      enddo
      if(btest(mlevel,3))then
        write(*,*) 'Set x values to ',xnow(1),xnow(2)
      endif

c     Prepare for resetting q2fact based on PDF reweighting
      if(ickkw.eq.2)then
         q2fact(1)=0d0
         q2fact(2)=0d0
      endif

c     Prepare checking for parton vertices
      do i=1,nexternal
         j=ishft(1,i-1)
c        Set jet identities according to chosen subprocess
         if(isjet(idup(i,ipsel,iproc)))
     $        ipdgcl(j,igraphs(1),iproc)=idup(i,ipsel,iproc)
         if (btest(mlevel,2))
     $        write(*,*) 'Set particle identities: ',
     $        i,ipdgcl(j,igraphs(1),iproc)
         if(i.le.2)then
            goodjet(j)=isparton(ipdgcl(j,igraphs(1),iproc))
         elseif(iqjets(i).gt.0) then
            goodjet(j)=.true.
         elseif(isparton(ipdgcl(j,igraphs(1),iproc)).and.
     $          .not.isjet(ipdgcl(j,igraphs(1),iproc))) then
            goodjet(j)=.true.            
         else
            goodjet(j)=.false.
         endif
      if(btest(mlevel,4)) print *,'Set goodjet ',j,goodjet(j)
      enddo
c   
c   Set strong coupling used
c   
      asref=G**2/(4d0*PI)

c   Perform alpha_s reweighting based on type of vertex
      do n=1,nexternal-2
c       scale for alpha_s reweighting
        q2now=pt2ijcl(n)
        if(n.eq.nexternal-2) then
           q2now = scale**2
        endif
        if (btest(mlevel,3)) then
          write(*,*)'  ',n,': ',idacl(n,1),'(',ipdgcl(idacl(n,1),igraphs(1),iproc),
     &       ')&',idacl(n,2),'(',ipdgcl(idacl(n,2),igraphs(1),iproc),
     &       ') -> ',imocl(n),'(',ipdgcl(imocl(n),igraphs(1),iproc),
     &       '), ptij = ',dsqrt(q2now) 
        endif
c   Update particle tree map
        call ipartupdate(p,imocl(n),idacl(n,1),idacl(n,2),
     $       ipdgcl(1,igraphs(1),iproc),ipart)
c     perform alpha_s reweighting only for vertices where a parton is produced
c     and not for the last clustering (use non-fixed ren. scale for these)
        if (n.lt.nexternal-2)then
c          Use goodjet to trace allowed parton lines.
c          For ISR, allow only splittings where all particles are along
c          good parton lines; for FSR, just require one FS particle to be good
           goodjet(imocl(n))=isparton(ipdgcl(imocl(n),igraphs(1),iproc))
     $          .and.goodjet(idacl(n,1)).and.goodjet(idacl(n,2))
           if(btest(mlevel,4))
     $          write(*,*)'Set goodjet ',imocl(n),' to ',goodjet(imocl(n))
           if(ipart(1,imocl(n)).le.2.and.goodjet(imocl(n)).or.  ! ISR
     $        ipart(1,imocl(n)).gt.2.and.                       ! FSR
     $          ispartonvx(imocl(n),idacl(n,1),idacl(n,2),
     $          ipdgcl(1,igraphs(1),iproc),ipart,.false.).and.
     $        (goodjet(idacl(n,1)).or.goodjet(idacl(n,2)))) then
c       alpha_s weight
              rewgt=rewgt*alphas(alpsfact*sqrt(q2now))/asref
c             Store information for systematics studies
              if(use_syst)then
                 n_alpsem=n_alpsem+1
                 s_qalps(n_alpsem)=sqrt(q2now)
              endif
              if (btest(mlevel,3)) then
                 write(*,*)' reweight vertex: ',ipdgcl(imocl(n),igraphs(1),iproc),
     $                ipdgcl(idacl(n,1),igraphs(1),iproc),ipdgcl(idacl(n,2),igraphs(1),iproc)
                 write(*,*)'       as: ',alphas(alpsfact*dsqrt(q2now)),
     &                '/',asref,' -> ',alphas(alpsfact*dsqrt(q2now))/asref
                 write(*,*)' and G=',SQRT(4d0*PI*ALPHAS(scale))
              endif
           endif
        endif
        if(ickkw.eq.2.or.(pdfwgt.and.ickkw.gt.0)) then
c       Perform PDF and, if ickkw=2, Sudakov reweighting
          isvx=.false.
          do i=1,2
c         write(*,*)'weight ',idacl(n,i),', ptij=',pt2prev(idacl(n,i))
            if (isqcd(ipdgcl(idacl(n,i),igraphs(1),iproc))) then
               if(ickkw.eq.2.and.pt2min.eq.0d0) then
                  pt2min=pt2ijcl(n)
                  if (btest(mlevel,3))
     $                 write(*,*) 'pt2min set to ',pt2min
               endif
               if(ickkw.eq.2.and.pt2prev(idacl(n,i)).eq.0d0)
     $              pt2prev(idacl(n,i))=
     $              max(pt2min,p(0,i)**2-p(1,i)**2-p(2,i)**2-p(3,i)**2)
               do j=1,2
                  if (isparton(ipdgcl(idacl(n,i),igraphs(1),iproc)).and
     $                 .idacl(n,i).eq.ibeam(j)) then
c               is sudakov weight - calculate only once for each parton
c               line where parton line ends with change of parton id or
c               non-radiation vertex
                     isvx=.true.
                     ibeam(j)=imocl(n)
c                    Perform Sudakov reweighting if ickkw=2
                     if(ickkw.eq.2.and.(ipdgcl(idacl(n,i),igraphs(1),iproc).ne.
     $                    ipdgcl(imocl(n),igraphs(1),iproc).or.
     $                    .not.isjetvx(imocl(n),idacl(n,1),idacl(n,2),
     $                    ipdgcl(1,igraphs(1),iproc),ipart,n.eq.nexternal-2)).and.
     $                    pt2prev(idacl(n,i)).lt.pt2ijcl(n))then
                        tmp=min(1d0,max(getissud(ibeam(j),ipdgcl(idacl(n,i),
     $                       igraphs(1),iproc),xnow(j),xnow(3-j),pt2ijcl(n)),1d-20)/
     $                       max(getissud(ibeam(j),ipdgcl(idacl(n,i),
     $                       igraphs(1),iproc),xnow(j),xnow(3-j),pt2prev(idacl(n,i))),1d-20))
                        rewgt=rewgt*tmp
                        pt2prev(imocl(n))=pt2ijcl(n)
                        if (btest(mlevel,3)) then
                           write(*,*)' reweight line: ',ipdgcl(idacl(n,i),igraphs(1),iproc), idacl(n,i)
                           write(*,*)'     pt2prev, pt2new, x1, x2: ',pt2prev(idacl(n,i)),pt2ijcl(n),xnow(j),xnow(3-j)
                           write(*,*)'           Sud: ',tmp
                           write(*,*)'        -> rewgt: ',rewgt
                        endif
                     else if(ickkw.eq.2) then
                        pt2prev(imocl(n))=pt2prev(idacl(n,i))
                     endif
c                 End Sudakov reweighting when we reach a non-radiation vertex
                     if(ickkw.eq.2.and..not.
     $                    ispartonvx(imocl(n),idacl(n,1),idacl(n,2),
     $                    ipdgcl(1,igraphs(1),iproc),ipart,n.eq.nexternal-2)) then
                        pt2prev(imocl(n))=1d30
                        if (btest(mlevel,3)) then
                          write(*,*)' rewgt: ending reweighting for vx ',
     $                          idacl(n,1),idacl(n,2),imocl(n),
     $                          ' with ids ',ipdgcl(idacl(n,1),igraphs(1),iproc),
     $                          ipdgcl(idacl(n,2),igraphs(1),iproc),ipdgcl(imocl(n),igraphs(1),iproc)
                        endif
                     endif
c               PDF reweighting
c               Total pdf weight is f1(x1,pt2E)*fj(x1*z,Q)/fj(x1*z,pt2E)
c               f1(x1,pt2E) is given by DSIG, already set scale for that
                     if (zcl(n).gt.0d0.and.zcl(n).lt.1d0) then
                        xnow(j)=xnow(j)*zcl(n)
                     endif
c                    PDF scale
                     q2now=min(pt2ijcl(n), q2bck(j))
c                    Set PDF scale to central factorization scale
c                    if non-radiating vertex or last 2->2
                     if(n.eq.jlast(j)) then
                        q2now=q2bck(j)
                     endif
                     if (btest(mlevel,3))
     $                    write(*,*)' set q2now for pdf to ',sqrt(q2now)
                     if(q2fact(j).eq.0d0.and.ickkw.eq.2)then
                        q2fact(j)=pt2min ! Starting scale for PS
                        pt2pdf(imocl(n))=q2now
                        if (btest(mlevel,3))
     $                       write(*,*)' set fact scale ',j,
     $                          ' for PS scale to: ',sqrt(q2fact(j))
                     else if(pt2pdf(idacl(n,i)).eq.0d0)then
                        pt2pdf(imocl(n))=q2now
                        if (btest(mlevel,3))
     $                       write(*,*)' set pt2pdf for ',imocl(n),
     $                          ' to: ',sqrt(pt2pdf(imocl(n)))
                     else if(pt2pdf(idacl(n,i)).lt.q2now.and.
     $                       n.le.jlast(j))then
                        pdfj1=pdg2pdf(abs(lpp(IB(j))),ipdgcl(idacl(n,i),
     $                       igraphs(1),iproc)*sign(1,lpp(IB(j))), IB(j),
     $                       xnow(j),sqrt(q2now))
                        pdfj2=pdg2pdf(abs(lpp(IB(j))),ipdgcl(idacl(n,i), 
     $                       igraphs(1),iproc)*sign(1,lpp(IB(j))), IB(j),
     $                       xnow(j),sqrt(pt2pdf(idacl(n,i))))
                        if(pdfj2.lt.1d-10)then
c                          Scale too low for heavy quark
                           rewgt=0d0
                           if (btest(mlevel,3))
     $                        write(*,*) 'Too low scale for quark pdf: ',
     $                        sqrt(pt2pdf(idacl(n,i))),pdfj2,pdfj1
                           return
                        endif
                        rewgt=rewgt*pdfj1/pdfj2
c     Store information for systematics studies
                        if(use_syst)then
                           n_pdfrw(j)=n_pdfrw(j)+1
                           i_pdgpdf(n_pdfrw(j),j)=ipdgcl(idacl(n,i),igraphs(1),iproc)
                           if (zcl(n).gt.0d0.and.zcl(n).lt.1d0) then
                              s_xpdf(n_pdfrw(j),j)=xnow(j)/zcl(n)
                           else
                              s_xpdf(n_pdfrw(j),j)=xnow(j) 
                           endif
                           s_qpdf(n_pdfrw(j),j)=sqrt(q2now)
                        endif
                        if (btest(mlevel,3)) then
                           write(*,*)' reweight ',n,i,ipdgcl(idacl(n,i),igraphs(1),iproc),' by pdfs: '
                           write(*,*)'     x, ptprev, ptnew: ',xnow(j),
     $                          sqrt(pt2pdf(idacl(n,i))),sqrt(q2now)
                           write(*,*)'           PDF: ',pdfj1,' / ',pdfj2
                           write(*,*)'        -> rewgt: ',rewgt
c                           write(*,*)'  (compare for glue: ',
c     $                          pdg2pdf(lpp(j),21,1,xbk(j),sqrt(pt2pdf(idacl(n,i)))),' / ',
c     $                          pdg2pdf(lpp(j),21,1,xbk(j),sqrt(pt2ijcl(n)))
c                           write(*,*)'       = ',pdg2pdf(ibeam(j),21,xbk(j),sqrt(pt2pdf(idacl(n,i))))/
c     $                          pdg2pdf(lpp(j),21,1,xbk(j),sqrt(pt2ijcl(n)))
c                           write(*,*)'       -> ',pdg2pdf(ibeam(j),21,xbk(j),sqrt(pt2pdf(idacl(n,i))))/
c     $                          pdg2pdf(lpp(j),21,1,xbk(j),sqrt(pt2ijcl(n)))*rewgt,' )'
                        endif
c                       Set scale for mother as this scale
                        pt2pdf(imocl(n))=q2now                           
                     else if(pt2pdf(idacl(n,i)).ge.q2now) then
c                    If no reweighting, just copy daughter scale for mother
                        pt2pdf(imocl(n))=pt2pdf(idacl(n,i))
                     endif
                     goto 10
                  endif
               enddo
c           fs sudakov weight
               if(ickkw.eq.2.and.pt2prev(idacl(n,i)).lt.pt2ijcl(n).and.
     $              (isvx.or.ipdgcl(idacl(n,i),igraphs(1),iproc).ne.ipdgcl(imocl(n),igraphs(1),iproc).or.
     $              (ipdgcl(idacl(n,i),igraphs(1),iproc).ne.
     $              ipdgcl(idacl(n,3-i),igraphs(1),iproc).and.
     $              pt2prev(idacl(n,i)).gt.pt2prev(idacl(n,3-i))))) then
                  tmp=sudwgt(sqrt(pt2min),sqrt(pt2prev(idacl(n,i))),
     &                 dsqrt(pt2ijcl(n)),ipdgcl(idacl(n,i),igraphs(1),iproc),1)
                  rewgt=rewgt*tmp
                  if (btest(mlevel,3)) then
                     write(*,*)' reweight fs line: ',ipdgcl(idacl(n,i),igraphs(1),iproc), idacl(n,i)
                     write(*,*)'     pt2prev, pt2new: ',pt2prev(idacl(n,i)),pt2ijcl(n)
                     write(*,*)'           Sud: ',tmp
                     write(*,*)'        -> rewgt: ',rewgt
                  endif
                  pt2prev(imocl(n))=pt2ijcl(n)
               else
                  pt2prev(imocl(n))=pt2prev(idacl(n,i))
               endif 
            endif
 10         continue
          enddo
          if (ickkw.eq.2.and.n.eq.nexternal-2.and.isqcd(ipdgcl(imocl(n),igraphs(1),iproc)).and.
     $         pt2prev(imocl(n)).lt.pt2ijcl(n)) then
             tmp=sudwgt(sqrt(pt2min),sqrt(pt2prev(imocl(n))),
     &            dsqrt(pt2ijcl(n)),ipdgcl(imocl(n),igraphs(1),iproc),1)
             rewgt=rewgt*tmp
             if (btest(mlevel,3)) then
                write(*,*)' reweight last fs line: ',ipdgcl(imocl(n),igraphs(1),iproc), imocl(n)
                write(*,*)'     pt2prev, pt2new: ',pt2prev(imocl(n)),pt2ijcl(n)
                write(*,*)'           Sud: ',tmp
                write(*,*)'        -> rewgt: ',rewgt
             endif
          endif
        endif
      enddo

      if(ickkw.eq.2.and.lpp(1).eq.0.and.lpp(2).eq.0)then
         q2fact(1)=pt2min
         q2fact(2)=q2fact(1)
      else if (ickkw.gt.0.and.pdfwgt) then
         q2fact(1)=q2bck(1)
         q2fact(2)=q2bck(2)         
         if (btest(mlevel,3))
     $        write(*,*)' set fact scales for PS to ',
     $        sqrt(q2fact(1)),sqrt(q2fact(2))
      else if (abs(lpp(1)).ge.2.and.abs(lpp(1)).le.4) then
         q2fact(1)=q2bck(1)
      else if (abs(lpp(2)).ge.2.or.abs(lpp(2)).le.4) then
         q2fact(2)=q2bck(2)
      endif

      if (btest(mlevel,3)) then
        write(*,*)'} ->  w = ',rewgt
      endif

 100  continue

c     Set reweight factor for systematics studies
      if(use_syst)then
         s_rwfact = rewgt
         
c     Need to multiply by: initial PDF, alpha_s^n_qcd to get
c     factor in front of matrix element
         do i=1,2
            if (lpp(IB(i)).ne.0) then
                s_rwfact=s_rwfact*pdg2pdf(abs(lpp(IB(i))),
     $           i_pdgpdf(1,i)*sign(1,lpp(IB(i))),IB(i),
     $           s_xpdf(1,i),s_qpdf(1,i))
            endif
         enddo
         if (asref.gt.0d0.and.n_qcd.le.nexternal)then
            s_rwfact=s_rwfact*asref**n_qcd
c         else
c            s_rwfact=0d0
         endif
      endif

      return
      end
      

      subroutine basecode_test
      implicit none
      integer imax
      parameter (imax = 8)
      integer icode,iarray(imax),ibase,i,j
      logical done

      ibase = 3
c      do i=0,ibase**3-1
c         call decode(i,iarray,ibase,imax)
c         call encode(icode,iarray,ibase,imax)
c         write(*,*) i,icode,"=",(iarray(j),j=1,imax)
c      enddo
      icode = 0
      call decode(icode,iarray,ibase,imax)
      iarray(2)=1
      iarray(4)=1
      iarray(5)=1
      iarray(7)=1
      done = .false.
      write(*,*) (iarray(j),j=1,imax)
      do while (.not. done)
         write(*,*) (iarray(j),j=1,imax)
         call increment_array(iarray,imax,ibase,done)
      enddo
      end
      

      subroutine EnCode(icode,iarray,ibase,imax)
c******************************************************************************
c     Turns array of integers (iarray) values range (0,ibase-1) into a single
c     integer icode. icode = Sum[ iarray(k) * ibase^k]
c******************************************************************************
      implicit none
c
c     Arguments
c
      integer imax           !Number of integers to encode
      integer icode          !Output encoded value of iarray
      integer iarray(imax)   !Input values to be encoded
      integer ibase          !Base for encoding

c
c     Local
c     
      integer i
c-----
c  Begin Code
c-----
      icode = 0
      do i = 1, imax
         if (iarray(i) .ge. 0 .and. iarray(i) .lt. ibase) then 
            icode = icode + iarray(i)*ibase**(i-1)
         else
            write(*,*) 'Error invalid number to be encoded',i,iarray(i)
         endif
      enddo
      end

      subroutine DeCode(icode,iarray,ibase,imax)
c******************************************************************************
c     Decodes icode, into base integers used to create it.
c     integer icode. icode = Sum[ iarray(k) * ibase^k]
c******************************************************************************
      implicit none
c
c     Arguments
c
      integer imax           !Number of integers to encode
      integer icode          !Input encoded value of iarray
      integer iarray(imax)   !Output decoded values icode
      integer ibase          !Base for encoding

c
c     Local
c     
      integer i, jcode
c-----
c  Begin Code
c-----
      jcode = icode          !create copy for use
      do i =  imax, 1, -1
         iarray(i) = 0
         do while (jcode .ge. ibase**(i-1) .and. iarray(i) .lt. ibase)
            jcode = jcode-ibase**(i-1)
            iarray(i)=iarray(i)+1
         enddo
      enddo
      end

      subroutine increment_array(iarray,imax,ibase,done)
c************************************************************************
c     Increments iarray     
c************************************************************************
      implicit none
c
c     Arguments
c
      integer imax          !Input, number of elements in iarray
      integer ibase         !Base for incrementing, 0 is skipped
      integer iarray(imax)  !Output:Array of values being incremented
      logical done          !Output:Set when no more incrementing
c
c     Local
c
      integer i,j
      logical found
c-----
c  Begin Code
c-----
      found = .false.
      i = 1
      do while (i .le. imax .and. .not. found)
         if (iarray(i) .eq. 0) then    !don't increment this
            i=i+1
         elseif (iarray(i) .lt. ibase-1) then
            found = .true.
            iarray(i)=iarray(i)+1
         else
            iarray(i)=1
            i=i+1
         endif
      enddo
      done = .not. found
      end

C...GETISSUD performs an interpolation/extrapolation in 3 dimensions by
C...fitting quadratic splines using 4 points in each dimension
      double precision function getissud(ibeam,kfl,x1,x2,pt2)
      implicit none

      include 'sudgrid.inc'

c   Arguments
      integer ibeam,kfl
      double precision x1,x2,pt2
c   Storing values for the interpolation
      double precision smallgrid(4,4),minigrid(4) ! pt2,x1
c   Local variables
      integer ipt2,ix1,ix2,ilo,ihi,i,j,k,kkfl,ipoints
      double precision pt2i,x2i,x1i,minpoint,maxpoint,x(3)
      integer nerr
      data nerr/0/

      getissud=0

      x(1)=log(x2)
      x(2)=x1
      x(3)=log(pt2)

      kkfl=kfl
      if(ibeam.lt.0) kkfl=-kkfl
      if(kkfl.lt.-2) kkfl=iabs(kfl)
      if(iabs(kkfl).eq.21) kkfl=0
      if(kkfl.eq.5) then
        ipoints=2
      else
        ipoints=1
      endif        
      if(kkfl.gt.5) then
        if(nerr.lt.10)
     $     write(*,*)'GETISSUD Warning: flavor ',kfl,' not supported'
        nerr=nerr+1
        getissud=1
        return
      endif

      if(x(1).lt.points(1,ipoints).or.
     $   x(1).gt.points(nx2,ipoints).and.nerr.lt.10)
     $   then
        write(*,*) 'GETISSUD Warning: extrapolation in x2: ',x2
        nerr=nerr+1
      endif

      if(x(2).lt.points(nx2+1,ipoints).or.
     $   x(2).gt.points(nx2+nx1,ipoints)
     $   .and.nerr.lt.10) then
        write(*,*) 'GETISSUD Warning: extrapolation in x1: ',x1
        nerr=nerr+1
      endif

      if(kkfl.eq.5.and.pt2.lt.22.3109)then
        getissud=1d0
        return
      endif

      if(kkfl.eq.5.and.x1.gt.0.6)then
        getissud=0d0
        return
      endif

      if(x(3).lt.points(nx2+nx1+1,ipoints)) then
        write(*,*) 'GETISSUD Error! pt2 = ',exp(x(3)),' < ',
     $     exp(points(nx2+nx1+1,ipoints)),' = min(pt2). Not allowed!'
        write(*,*) 'You need to regenerate grid with new pt2min.'
        stop
      endif

      if(x(3).lt.points(nx2+nx1+1,ipoints).or.
     $   x(3).gt.points(nx2+nx1+npt2,ipoints)
     $   .and.nerr.lt.10) then
        write(*,*) 'GETISSUD Warning: extrapolation in pt2: ',pt2
        nerr=nerr+1
      endif


c   Find nearest points by binary method
c   x2
      ilo=1
      ihi=nx2
      do while(ihi.gt.ilo+1)
        ix2=ilo+(ihi-ilo)/2
        if(x(1).gt.points(ix2,ipoints))then
          ilo=ix2
        else
          ihi=ix2
        endif
      enddo
      if(x(1).lt.points(ix2,ipoints))
     $   ix2=ix2-1
      ix2=max(2,min(ix2,nx2-2))

c      print *,'x2: ',ix2,x(1),(points(i,ipoints),i=ix2-1,ix2+2)

c   x1
      ilo=1
      ihi=nx1
      do while(ihi.gt.ilo+1)
        ix1=ilo+(ihi-ilo)/2
        if(x(2).gt.points(nx2+ix1,ipoints))then
          ilo=ix1
        else
          ihi=ix1
        endif
      enddo
      if(x(2).lt.points(nx2+ix1,ipoints))
     $   ix1=ix1-1
      ix1=max(2,min(ix1,nx1-2))

      do while(kkfl.eq.5.and.
     $   points(nx2+ix1+2,ipoints).gt.0.6)
        ix1=ix1-1
      enddo

c      print *,'x1: ',ix1,x(2),(points(nx2+i,ipoints),i=ix1-1,ix1+2)

c   pt2
      ilo=1
      ihi=npt2
      do while(ihi.gt.ilo+1)
        ipt2=ilo+(ihi-ilo)/2
        if(x(3).gt.points(nx2+nx1+ipt2,ipoints))then
          ilo=ipt2
        else
          ihi=ipt2
        endif
      enddo
      if(x(3).lt.points(nx2+nx1+ipt2,ipoints))
     $   ipt2=ipt2-1
      ipt2=max(2,min(ipt2,npt2-2))

      do while(kkfl.eq.5.and.
     $   exp(points(nx2+nx1+ipt2-1,ipoints)).lt.22.3109)
        ipt2=ipt2+1
      enddo
c      print *,'pt2: ',ipt2,x(3),(points(nx2+nx1+i,ipoints),i=ipt2-1,ipt2+2)
c      print *,'pt: ',ipt2,exp(x(3)/2),
c     $   (exp(points(nx2+nx1+i,ipoints)/2),i=ipt2-1,ipt2+2)

C   Now perform inter-/extra-polation

C   Start with x2, which should have the flattest distribution
C   Calculate sud(x2,ax1,apt2) for the 4x4 apt2 and ax1
C   Then continue with pt2 and calculate sud(x2,ax1,pt2)
C   for the 4 ax1
C   Finally calculate sud(x2,x1,pt2)

      do i=1,4
        do j=1,4
c          print *,'x1,pt:',points(nx2+ix1-2+i,ipoints),
c     $       exp(points(nx2+nx1+ipt2-2+j,ipoints)/2)
          call splint2(sudgrid(ix2-1,ix1-2+i,ipt2-2+j,kkfl),
     $       points(ix2-1,ipoints),4,x(1),smallgrid(j,i))
          smallgrid(j,i)=max(0d0,min(1d0,smallgrid(j,i)))
        enddo
      enddo

      do i=1,4
        call splint2(smallgrid(1,i),
     $     points(nx2+nx1+ipt2-1,ipoints),4,x(3),minigrid(i))
          minigrid(i)=max(0d0,min(1d0,minigrid(i)))
      enddo

      call splint2(minigrid,
     $   points(nx2+ix1-1,ipoints),4,x(2),getissud)
      getissud=max(0d0,min(1d0,getissud))
      
c      print *,'Result: ',getissud

      return
      end


      subroutine splint2(ypoints,xpoints,npoints,x,ans)
      implicit none

C   arguments
      integer npoints
      double precision ypoints(npoints),xpoints(npoints)
      double precision x,ans
C   local variables
      double precision a0,a1,a2,sd
      integer ifail,i

      CALL DLSQP2(npoints,xpoints,ypoints,a0,a1,a2,sd,ifail)

c      print *,'Point, interpolation:'
c      do i=1,npoints
c        print *,exp(xpoints(i)),ypoints(i),
c     $     a0+a1*xpoints(i)+a2*xpoints(i)**2
c      enddo

      ans=a0+a1*x+a2*x**2
c      print *,x,ans

      return
      end

*
* $Id: mtlprt.f,v 1.1 2009/07/30 22:46:16 madgraph Exp $
*
* $Log: mtlprt.f,v $
* Revision 1.1  2009/07/30 22:46:16  madgraph
* JA: Implemented CKKW-style matching with Pythia pT-ordered showers
*
* Revision 1.1.1.1  1996/04/01 15:02:52  mclareni
* Mathlib gen
*
*
      SUBROUTINE MTLPRT(NAME,ERC,TEXT)
      CHARACTER*(*) NAME,ERC,TEXT
      LOGICAL LMF,LRF

      IF(ERC(5:6).NE.'.0') THEN
        CALL MTLMTR(ERC,MLG,LMF,LRF)
      ELSE
        LMF=.TRUE.
        LRF=.FALSE.
      ENDIF
      IF(LMF) THEN
        LT=LENOCC(TEXT)
        IF(MLG .LT. 1) WRITE(  *,100) ERC(1:4),NAME,ERC,TEXT(1:LT)
        IF(MLG .GE. 1) WRITE(MLG,100) ERC(1:4),NAME,ERC,TEXT(1:LT)
      ENDIF
      IF(.NOT.LRF) CALL ABEND
      RETURN
100   FORMAT(7X,'***** CERN ',A,1X,A,' ERROR ',A,': ',A)
      END

      function xran1(idum)
      dimension r(97)
      parameter (m1=259200,ia1=7141,ic1=54773,rm1=3.8580247e-6)
      parameter (m2=134456,ia2=8121,ic2=28411,rm2=7.4373773e-6)
      parameter (m3=243000,ia3=4561,ic3=51349)
      data iff /0/
      save r, ix1,ix2,ix3
      if (idum.lt.0.or.iff.eq.0) then
        iff=1
        ix1=mod(ic1-idum,m1)
        ix1=mod(ia1*ix1+ic1,m1)
        ix2=mod(ix1,m2)
        ix1=mod(ia1*ix1+ic1,m1)
        ix3=mod(ix1,m3)
        do 11 j=1,97
          ix1=mod(ia1*ix1+ic1,m1)
          ix2=mod(ia2*ix2+ic2,m2)
          r(j)=(float(ix1)+float(ix2)*rm2)*rm1
11      continue
        idum=1
      endif
      ix1=mod(ia1*ix1+ic1,m1)
      ix2=mod(ia2*ix2+ic2,m2)
      ix3=mod(ia3*ix3+ic3,m3)
      j=1+(97*ix3)/m3
      if(j.gt.97.or.j.lt.1)then
         write(*,*) 'j is bad in ran1.f',j, 97d0*ix3/m3
         STOP
      endif
      xran1=r(j)
      r(j)=(float(ix1)+float(ix2)*rm2)*rm1
      return
      end

      module StringCast

        integer max_length
        parameter (max_length = 300)

        interface toStr
          module procedure toStr_int
          module procedure toStr_real 
          module procedure toStr_real_with_ndig
          module procedure toStr_real_with_format
          module procedure toStr_char_array
        end interface toStr

        contains

!       This removes all blank character at the head of the size 100
!       charachter array and places them at the end.
        function trim_ahead(input)
          character(max_length)      :: input
          character(max_length)      :: trim_ahead
          integer                    :: i
          integer                    :: first_char_index
          
          first_char_index = max_length
          do i=1,max_length
            if (input(i:i).ne.' ') then
              first_char_index = i
              EXIT 
            endif
          enddo
          
          do i=first_char_index,max_length
            trim_ahead((i-first_char_index+1):(i-first_char_index+1))=
     &                                                       input(i:i)
          enddo
          do i=(max_length-first_char_index+2),max_length
            trim_ahead(i:i)=' '
          enddo
        end function trim_ahead

!       Just to cast the max_width parameter to a string for formatting
        function get_width()
          character(max_length)        :: get_width 
          write(get_width,'(i20.20)') max_length
        end function get_width

        function toStr_char_array(input)
          character, dimension(:), intent(in) :: input
          character(max_length)               :: toStr_char_array
          integer i
          do i=1,max_length
            if (i.le.size(input)) then
               toStr_char_array(i:i)=input(i)
            else
               toStr_char_array(i:i)=' '
            endif
          enddo
        end function toStr_char_array

        function toStr_int(input)
          integer, intent(in)        :: input
          character(max_length)      :: toStr_int
          character(max_length)      :: tmp, tmp2
          integer                    :: i
          
          write(tmp,'(i'//get_width()//')') input
          toStr_int = trim_ahead(tmp)

        end function toStr_int

        function toStr_real(input)
          real*8, intent(in)           :: input
          character(max_length)        :: toStr_real

          toStr_real = toStr_real_with_ndig(input,16)
        end function toStr_real

!       The width will be automatically replaced, so leav it to 'w'
!       in the format specifier.
!       Example of call:  toStr_real_with_format(1.223204d0,'Fw.4') 
        function toStr_real_with_format(input, chosen_format)
          real*8, intent(in)            :: input
          character(len=*), intent(in)  :: chosen_format 
          character(max_length)         :: toStr_real_with_format
          character(max_length)         :: format_spec
          integer :: i, w_index
          
          w_index = -1
          do i=1,len(chosen_format)
           if (chosen_format(i:i).eq.'w') then
             w_index = i
             exit
           endif
          enddo
          if (w_index.eq.-1.or.w_index.eq.1) then
            write(toStr_real_with_format,'('//chosen_format//')') input 
          else
            write(toStr_real_with_format,'('//chosen_format(1:i-1)//
     &    TRIM(toStr(max_length))//chosen_format(i+1:len(chosen_format))
     &                                                      //')') input
          endif
          toStr_real_with_format = trim_ahead(toStr_real_with_format)
        end function toStr_real_with_format

        function toStr_real_with_ndig(input, n_digits)
          real*8, intent(in)         :: input
          integer, intent(in)        :: n_digits
          character(max_length)      :: toStr_real_with_ndig
          character(max_length)      :: format_spec
          
          format_spec = '(F'//TRIM(toStr(max_length))//'.'//
     &                               TRIM(toStr(n_digits))//')'

          write(toStr_real_with_ndig,format_spec) input 
          toStr_real_with_ndig = trim_ahead(toStr_real_with_ndig)
        end function toStr_real_with_ndig

      end module StringCast

      subroutine pftopdglha(ih,x,q,pdf)
c***************************************************************************
c     Wrapper for calling the pdf from lhapdf
c***************************************************************************
      implicit none
c
c     Arguments
c
      DOUBLE  PRECISION x,q,pdf(-7:7)
      DOUBLE  PRECISION f(-6:6)
      INTEGER IH,I
      double precision  photon
      LOGICAL has_photon
      double precision epa_electron,epa_proton
C
C     Include
C
      include 'pdf.inc'
C      
      if(abs(ih).eq.1) then
         pdf(-7)=0d0
         if(has_photon())then
             call evolvePDFphoton(x, q, f, photon)
             pdf(7)= photon/x
         else
             pdf(7) = 0d0
             call evolvePDF(x, q, f)
         endif
         do i=-6,6
            pdf(i)=f(i)/x
         enddo
      elseif(ih .eq. 2) then  !from a proton without breaking
          pdf(7) = epa_proton(x, q * q)
      else
         write (*,*) 'beam type not supported in lhadpf'
         stop 1
      endif

      return	
      end
  

*
* $Id: dlsqp2.f,v 1.1 2009/07/30 22:46:16 madgraph Exp $
*
* $Log: dlsqp2.f,v $
* Revision 1.1  2009/07/30 22:46:16  madgraph
* JA: Implemented CKKW-style matching with Pythia pT-ordered showers
*
* Revision 1.1.1.1  1996/04/01 15:02:24  mclareni
* Mathlib gen
*
*
      SUBROUTINE DLSQP2(N,X,Y,A0,A1,A2,SD,IFAIL)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
 
      DIMENSION X(*),Y(*)
 
      PARAMETER (R0 = 0)
 
      A0=0
      A1=0
      A2=0
      SD=0
      IF(N .LE. 2) THEN
       IFAIL=1
      ELSE
       FN=N
       XM=0
       DO 1 K = 1,N
       XM=XM+X(K)
    1  CONTINUE
       XM=XM/FN
       SX=0
       SXX=0
       SXXX=0
       SXXXX=0
       SY=0
       SYY=0
       SXY=0
       SXXY=0
       DO 2 K = 1,N
       XK=X(K)-XM
       YK=Y(K)
       XK2=XK**2
       SX=SX+XK
       SXX=SXX+XK2
       SXXX=SXXX+XK2*XK
       SXXXX=SXXXX+XK2**2
       SY=SY+YK
       SYY=SYY+YK**2
       SXY=SXY+XK*YK
       SXXY=SXXY+XK2*YK
    2  CONTINUE
       DET=(FN*SXXXX-SXX**2)*SXX-FN*SXXX**2
       IF(DET .GT. 0) THEN
        A2=(SXX*(FN*SXXY-SXX*SY)-FN*SXXX*SXY)/DET
        A1=(SXY-SXXX*A2)/SXX
        A0=(SY-SXX*A2)/FN
        IFAIL=0
       ELSE
        IFAIL=-1
       ENDIF
      ENDIF
      IF(IFAIL .EQ. 0 .AND. N .GT. 3)
     1   SD=SQRT(MAX(R0,SYY-A0*SY-A1*SXY-A2*SXXY)/(N-3))
      A0=A0+XM*(XM*A2-A1)
      A1=A1-2*XM*A2
      RETURN
      END

      DOUBLE PRECISION FUNCTION DSIG46(PP,WGT,IMODE)
C     ****************************************************
C     
C     Generated by MadGraph5_aMC@NLO v. 2.8.2, 2020-10-30
C     By the MadGraph5_aMC@NLO Development Team
C     Visit launchpad.net/madgraph5 and amcatnlo.web.cern.ch
C     
C     Process: d d~ > t t~ c c~ NP<=2 QCD<=4 QED=0 @2
C     Process: s s~ > t t~ c c~ NP<=2 QCD<=4 QED=0 @2
C     
C     RETURNS DIFFERENTIAL CROSS SECTION
C     Input:
C     pp    4 momentum of external particles
C     wgt   weight from Monte Carlo
C     imode 0 run, 1 init, 2 reweight, 
C     3 finalize, 4 only PDFs,
C     5 squared amplitude only (never
C     generate events)
C     Output:
C     Amplitude squared and summed
C     ****************************************************
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INCLUDE 'genps.inc'
      INCLUDE 'nexternal.inc'
      INCLUDE 'maxconfigs.inc'
      INCLUDE 'maxamps.inc'
      DOUBLE PRECISION       CONV
      PARAMETER (CONV=389379.66*1000)  !CONV TO PICOBARNS
      REAL*8     PI
      PARAMETER (PI=3.1415926D0)
C     
C     ARGUMENTS 
C     
      DOUBLE PRECISION PP(0:3,NEXTERNAL), WGT
      INTEGER IMODE
C     
C     LOCAL VARIABLES 
C     
      INTEGER I,ITYPE,LP,IPROC
      DOUBLE PRECISION D1,S1
      DOUBLE PRECISION SX2,DX2
      DOUBLE PRECISION XPQ(-7:7),PD(0:MAXPROC)
      DOUBLE PRECISION DSIGUU,R,RCONF
      INTEGER LUN,ICONF,IFACT,NFACT
      DATA NFACT/1/
      SAVE NFACT
C     
C     EXTERNAL FUNCTIONS
C     
      LOGICAL PASSCUTS
      DOUBLE PRECISION ALPHAS2,REWGT,PDG2PDF,CUSTOM_BIAS
      INTEGER NEXTUNOPEN
C     
C     GLOBAL VARIABLES
C     
      INTEGER          IPSEL
      COMMON /SUBPROC/ IPSEL
C     MINCFIG has this config number
      INTEGER           MINCFIG, MAXCFIG
      COMMON/TO_CONFIGS/MINCFIG, MAXCFIG
      INTEGER MAPCONFIG(0:LMAXCONFIGS), ICONFIG
      COMMON/TO_MCONFIGS/MAPCONFIG, ICONFIG
C     Keep track of whether cuts already calculated for this event
      LOGICAL CUTSDONE,CUTSPASSED
      COMMON/TO_CUTSDONE/CUTSDONE,CUTSPASSED

      INTEGER SUBDIAG(MAXSPROC),IB(2)
      COMMON/TO_SUB_DIAG/SUBDIAG,IB
      INCLUDE 'coupl.inc'
      INCLUDE 'run.inc'
C     
C     local
C     
      DOUBLE PRECISION P1(0:3, NEXTERNAL)

C     
C     DATA
C     
      DATA D1,S1/2*1D0/
      DATA SX2,DX2/2*1D0/
C     ----------
C     BEGIN CODE
C     ----------
      DSIG46=0D0

      IF(IMODE.EQ.1)THEN
C       Set up process information from file symfact
        LUN=NEXTUNOPEN()
        NFACT=1
        OPEN(UNIT=LUN,FILE='../symfact.dat',STATUS='OLD',ERR=20)
        DO WHILE(.TRUE.)
          READ(LUN,*,ERR=10,END=10) RCONF, IFACT
          ICONF=INT(RCONF)
          IF(ICONF.EQ.MAPCONFIG(MINCFIG))THEN
            NFACT=IFACT
          ENDIF
        ENDDO
 10     CLOSE(LUN)
        RETURN
 20     WRITE(*,*)'Error opening symfact.dat. No symmetry factor used.'
        RETURN
      ENDIF
C     Continue only if IMODE is 0, 4 or 5
      IF(IMODE.NE.0.AND.IMODE.NE.4.AND.IMODE.NE.5) RETURN


      IF (ABS(LPP(IB(1))).GE.1) THEN
        LP=SIGN(1,LPP(IB(1)))
        D1=PDG2PDF(ABS(LPP(IB(1))),1*LP, 1,XBK(IB(1)),DSQRT(Q2FACT(1)))
        S1=PDG2PDF(ABS(LPP(IB(1))),3*LP, 1,XBK(IB(1)),DSQRT(Q2FACT(1)))
      ENDIF
      IF (ABS(LPP(IB(2))).GE.1) THEN
        LP=SIGN(1,LPP(IB(2)))
        SX2=PDG2PDF(ABS(LPP(IB(2))),-3*LP, 1,XBK(IB(2)),DSQRT(Q2FACT(2)
     $   ))
        DX2=PDG2PDF(ABS(LPP(IB(2))),-1*LP, 1,XBK(IB(2)),DSQRT(Q2FACT(2)
     $   ))
      ENDIF
      PD(0) = 0D0
      IPROC = 0
      IPROC=IPROC+1  ! d d~ > t t~ c c~
      PD(IPROC)=D1*DX2
      PD(0)=PD(0)+DABS(PD(IPROC))
      IPROC=IPROC+1  ! s s~ > t t~ c c~
      PD(IPROC)=S1*SX2
      PD(0)=PD(0)+DABS(PD(IPROC))
      IF (IMODE.EQ.4)THEN
        DSIG46 = PD(0)
        RETURN
      ENDIF
      IF(FRAME_ID.NE.6)THEN
        CALL BOOST_TO_FRAME(PP, FRAME_ID, P1)
      ELSE
        P1 = PP
      ENDIF
      CALL SMATRIX46(P1,DSIGUU)
      IF (IMODE.EQ.5) THEN
        IF (DSIGUU.LT.1D199) THEN
          DSIG46 = DSIGUU*CONV
        ELSE
          DSIG46 = 0.0D0
        ENDIF
        RETURN
      ENDIF
C     Select a flavor combination (need to do here for right sign)
      CALL RANMAR(R)
      IPSEL=0
      DO WHILE (R.GE.0D0 .AND. IPSEL.LT.IPROC)
        IPSEL=IPSEL+1
        R=R-DABS(PD(IPSEL))/PD(0)
      ENDDO

      DSIGUU=DSIGUU*REWGT(PP)

C     Apply the bias weight specified in the run card (default is 1.0)
      DSIGUU=DSIGUU*CUSTOM_BIAS(PP,DSIGUU,46)

      DSIGUU=DSIGUU*NFACT

      IF (DSIGUU.LT.1D199) THEN
C       Set sign of dsig based on sign of PDF and matrix element
        DSIG46=DSIGN(PD(0)*CONV*DSIGUU,DSIGUU*PD(IPSEL))
      ELSE
        WRITE(*,*) 'Error in matrix element'
        DSIGUU=0D0
        DSIG46=0D0
      ENDIF
C     Generate events only if IMODE is 0.
      IF(IMODE.EQ.0.AND.DABS(DSIG46).GT.0D0)THEN
C       Call UNWGT to unweight and store events
        CALL UNWGT(PP,DSIG46*WGT,46)
      ENDIF

      END
C     
C     Functionality to handling grid
C     

C     This File is Automatically generated by ALOHA 
C     The process calculated in this file is: 
C     Gamma(-1,2,-3)*Gamma(-1,4,-2)*ProjM(-2,1)*ProjP(-3,3)
C     
      SUBROUTINE FFFF27_0(F1, F2, F3, F4, COUP,VERTEX)
      IMPLICIT NONE
      COMPLEX*16 CI
      PARAMETER (CI=(0D0,1D0))
      COMPLEX*16 COUP
      COMPLEX*16 F1(*)
      COMPLEX*16 F2(*)
      COMPLEX*16 F3(*)
      COMPLEX*16 F4(*)
      COMPLEX*16 TMP12
      COMPLEX*16 VERTEX
      TMP12 = (F1(3)*F2(3)*(F4(5)*F3(5)+F4(6)*F3(6))+F1(4)*F2(4)*(F4(5)
     $ *F3(5)+F4(6)*F3(6)))
      VERTEX = COUP*(-2D0 * CI * TMP12)
      END

      subroutine pdfwrap
      implicit none
C
C     INCLUDE
C
      include 'pdf.inc'
      include '../alfas.inc'

c-------------------
c     START THE CODE
c-------------------      

      nloop=2 ! NLO running unless set otherwise

C
c  MRST2002
c  1     NLO   0.1197    0.00949 
c  2     NNLO  0.1154    0.00685
C  
c      if     (pdlabel .eq. 'mrs02nl') then
c      asmz=0.1197d0 
c      elseif     (pdlabel .eq. 'mrs02nn') then
c      asmz=0.1154d0
C
c  MRST2001
c  1     alf119  central gluon, a_s       323      0.119    0.00927  
c  2     alf117  lower a_s                290      0.117    0.00953  
c  3     alf121  higher a_s               362      0.121    0.00889  
c  4     j121    better fit to jet data   353      0.121    0.00826  
C
c      elseif     (pdlabel .eq. 'mrs0119') then
c      asmz=0.119d0
c      elseif     (pdlabel .eq. 'mrs0117') then
c      asmz=0.117d0
c      elseif     (pdlabel .eq. 'mrs0121') then
c      asmz=0.121d0
c      elseif     (pdlabel .eq. 'mrs01_j') then
c      asmz=0.121d0
C
C MRS99
C  1     COR01  central gluon, a_s    300      0.1175   0.00537  C
C  2     COR02  higher gluon          300      0.1175   0.00497  C
C  3     COR03  lower gluon           300      0.1175   0.00398  C
C  4     COR04  lower a_s             229      0.1125   0.00585  C
C  5     COR05  higher a_s            383      0.1225   0.00384  C
C  6     COR06  quarks up             303.3    0.1178   0.00497  C
C  7     COR07  quarks down           290.3    0.1171   0.00593  C
C  8     COR08  strange up            300      0.1175   0.00524  C
C  9     COR09  strange down          300      0.1175   0.00524  C
C  10    C0R10  charm up              300      0.1175   0.00525  C
C  11    COR11  charm down            300      0.1175   0.00524  C
C  12    COR12  larger d/u            300      0.1175   0.00515  C
C
c      elseif     (pdlabel .eq. 'mrs99_1') then
c      asmz=0.1175d0
c      elseif (pdlabel .eq. 'mrs99_2') then
c      asmz=0.1175d0
c      elseif (pdlabel .eq. 'mrs99_3') then
c      asmz=0.1175d0
c      elseif (pdlabel .eq. 'mrs99_4') then
c      asmz=0.1125d0
c      elseif (pdlabel .eq. 'mrs99_5') then
c      asmz=0.1225d0
c      elseif (pdlabel .eq. 'mrs99_6') then
c      asmz=0.1178d0
c      elseif (pdlabel .eq. 'mrs99_7') then
c      asmz=0.1171d0
c      elseif (pdlabel .eq. 'mrs99_8') then
c      asmz=0.1175d0
c      elseif (pdlabel .eq. 'mrs99_9') then
c      asmz=0.1175d0
c      elseif (pdlabel .eq. 'mrs9910') then
c      asmz=0.1175d0
c      elseif (pdlabel .eq. 'mrs9911') then
c      asmz=0.1175d0
c      elseif (pdlabel .eq. 'mrs9912') then
c      asmz=0.1175d0
C
C MRS98
C    ft08a  central gluon, a_s  300      0.1175   0.00561  
C    ft09a  higher gluon        300      0.1175   0.00510  
C    ft11a  lower gluon         300      0.1175   0.00408  
C    ft24a  lower a_s           229      0.1125   0.00586  
C    ft23a  higher a_s          383      0.1225   0.00410  
C
c      elseif (pdlabel .eq. 'mrs98z1') then
c      asmz=0.1175d0
c      elseif (pdlabel .eq. 'mrs98z2') then
c      asmz=0.1175d0
c      elseif (pdlabel .eq. 'mrs98z3') then
c      asmz=0.1175d0
c      elseif (pdlabel .eq. 'mrs98z4') then
c      asmz=0.1125d0
c      elseif (pdlabel .eq. 'mrs98z5') then
c      asmz=0.1225d0
c      elseif (pdlabel .eq. 'mrs98ht') then
c-- real value
c      asmz=0.1170d0
c-- modified - DEBUG
c      asmz=0.1175d0
c      write(6,*) 'alpha_s(MZ) for mrs98ht has been modified from'
c      write(6,*) 'the inherent 0.1170 to a new value of 0.1175'    
C
C  MRS98LO
C    lo05a  central gluon, a_s  174      0.1250   0.01518  
C    lo09a  higher gluon        174      0.1250   0.01616  
C    lo10a  lower gluon         174      0.1250   0.01533  
C    lo01a  lower a_s           136      0.1200   0.01652  
C    lo07a  higher a_s          216      0.1300   0.01522  
C
c      elseif (pdlabel .eq. 'mrs98l1') then
c      asmz=0.125d0
c      nloop=1
c      elseif (pdlabel .eq. 'mrs98l2') then
c      asmz=0.125d0
c      nloop=1
c      elseif (pdlabel .eq. 'mrs98l3') then
c      asmz=0.125d0
c      nloop=1
c      elseif (pdlabel .eq. 'mrs98l4') then
c      asmz=0.120d0
c      nloop=1
c      elseif (pdlabel .eq. 'mrs98l5') then
c      asmz=0.130d0
c      nloop=1
C
C CTEQ4
C   1      CTEQ4M   Standard MSbar scheme   0.116        1.6      cteq4m.tbl
C   2      CTEQ4D   Standard DIS scheme     0.116        1.6      cteq4d.tbl
C   3      CTEQ4L   Leading Order           0.116        1.6      cteq4l.tbl
C   4      CTEQ4A1  Alpha_s series          0.110        1.6      cteq4a1.tbl
C   5      CTEQ4A2  Alpha_s series          0.113        1.6      cteq4a2.tbl
C   6      CTEQ4A3  same as CTEQ4M          0.116        1.6      cteq4m.tbl
C   7      CTEQ4A4  Alpha_s series          0.119        1.6      cteq4a4.tbl
C   8      CTEQ4A5  Alpha_s series          0.122        1.6      cteq4a5.tbl
C   9      CTEQ4HJ  High Jet                0.116        1.6      cteq4hj.tbl
C   10     CTEQ4LQ  Low Q0                  0.114        0.7      cteq4lq.tbl
C
c      elseif (pdlabel .eq. 'cteq3_m') then
c      asmz=0.112d0
c      elseif (pdlabel .eq. 'cteq3_l') then
c---??????
c      asmz=0.112d0
c      nloop=1
c      elseif (pdlabel .eq. 'cteq3_d') then
c---??????
c      asmz=0.112d0
c      elseif (pdlabel .eq. 'cteq4_m') then
c      asmz=0.116d0
c      elseif (pdlabel .eq. 'cteq4_d') then
c      asmz=0.116d0
c      elseif (pdlabel .eq. 'cteq4_l') then 
c      asmz=0.132d0
c      nloop=1
c      elseif (pdlabel .eq. 'cteq4a1') then
c      asmz=0.110d0
c      elseif (pdlabel .eq. 'cteq4a2') then
c      asmz=0.113d0
c      elseif (pdlabel .eq. 'cteq4a3') then
c      asmz=0.116d0
c      elseif (pdlabel .eq. 'cteq4a4') then
c      asmz=0.119d0
c      elseif (pdlabel .eq. 'cteq4a5') then
c      asmz=0.122d0
c      elseif (pdlabel .eq. 'cteq4hj') then
c      asmz=0.116d0
c      elseif (pdlabel .eq. 'cteq4lq') then
c      asmz=0.114d0
C
C ---------------------------------------------------------------------------
C  Iset   PDF        Description       Alpha_s(Mz)  Lam4  Lam5   Table_File
C ---------------------------------------------------------------------------
C   1    CTEQ5M   Standard MSbar scheme   0.118     326   226    cteq5m.tbl
C   2    CTEQ5D   Standard DIS scheme     0.118     326   226    cteq5d.tbl
C   3    CTEQ5L   Leading Order           0.127     192   146    cteq5l.tbl
C   4    CTEQ5HJ  Large-x gluon enhanced  0.118     326   226    cteq5hj.tbl
C   5    CTEQ5HQ  Heavy Quark             0.118     326   226    cteq5hq.tbl
C   6    CTEQ5F3  Nf=3 FixedFlavorNumber  0.106     (Lam3=395)   cteq5f3.tbl
C   7    CTEQ5F4  Nf=4 FixedFlavorNumber  0.112     309   XXX    cteq5f4.tbl
C         --------------------------------------------------------
C   8    CTEQ5M1  Improved CTEQ5M         0.118     326   226    cteq5m1.tbl
C   9    CTEQ5HQ1 Improved CTEQ5HQ        0.118     326   226    ctq5hq1.tbl
C ---------------------------------------------------------------------------
C
c      elseif (pdlabel .eq. 'cteq5_m') then
c      Call SetCtq5(1)
c      asmz=0.118d0
c      elseif (pdlabel .eq. 'cteq5_d') then
c      Call SetCtq5(2)
c      asmz=0.118d0
c      elseif (pdlabel .eq. 'cteq5_l') then
c      Call SetCtq5(3)
c      asmz=0.127d0
c      nloop=1
c      elseif (pdlabel .eq. 'cteq5l1') then
c      asmz=0.127d0
c      nloop=1
c      elseif (pdlabel .eq. 'cteq5hj') then
c      Call SetCtq5(4)
c      asmz=0.118d0
c      elseif (pdlabel .eq. 'cteq5hq') then
c      Call SetCtq5(5)
c      asmz=0.118d0
c      elseif (pdlabel .eq. 'cteq5f3') then
c      Call SetCtq5(6)
c      asmz=0.106d0
c      elseif (pdlabel .eq. 'cteq5f4') then
c      Call SetCtq5(7)
c      asmz=0.112d0
c      elseif (pdlabel .eq. 'cteq5m1') then
c      Call SetCtq5(8)
c      asmz=0.118d0
c      elseif (pdlabel .eq. 'ctq5hq1') then
c      Call SetCtq5(9)
c      asmz=0.118d0
C
C   1    CTEQ6M   Standard MSbar scheme   0.118     326   226    cteq6m.tbl
C   2    CTEQ6D   Standard DIS scheme     0.118     326   226    cteq6d.tbl
C   3    CTEQ6L   Leading Order           0.118**   326** 226    cteq6l.tbl
C   4    CTEQ6L1  Leading Order           0.130**   215** 165    cteq6l1.tbl
C
C Note:CTEQ6L1 uses the LO running alpha_s 
C
      if (pdlabel .eq. 'cteq6_m') then
      asmz=0.118d0
      Call SetCtq6(1)
      elseif (pdlabel .eq. 'cteq6_d') then
      asmz=0.118d0
      Call SetCtq6(2)
      elseif (pdlabel .eq. 'cteq6_l') then
      asmz=0.118d0
      Call SetCtq6(3)
      elseif (pdlabel .eq. 'cteq6l1') then
      asmz=0.130d0
      nloop=1
      Call SetCtq6(4)


c---------------------------------------------------------------

C
C NNPDF2.3 sets
C   1      NNPDF2.3QED LO  QCD+QED  alphas(MZ) = 0.119       NNPDF23_lo_as_0119_qed_mem0.grid 
C   2      NNPDF2.3QED LO  QCD+QED  alphas(MZ) = 0.130       NNPDF23_lo_as_0130_qed_mem0.grid 
C   3      NNPDF2.3QED NLO  QCD+QED  alphas(MZ) = 0.119       NNPDF23_nlo_as_0130_qed_mc_mem0.grid  -- Positive Definite set
C
      elseif (pdlabel .eq. 'nn23lo') then
      call NNPDFDriver('NNPDF23_lo_as_0119_qed_mem0.grid')      
      call NNinitPDF(0)
      asmz=0.119d0

      elseif (pdlabel .eq. 'nn23lo1') then
      call NNPDFDriver('NNPDF23_lo_as_0130_qed_mem0.grid')      
      call NNinitPDF(0)
      asmz=0.130d0

      elseif (pdlabel .eq. 'nn23nlo') then
      call NNPDFDriver('NNPDF23nlo_as_0119_qed_mem0.grid')      
      call NNinitPDF(0)
      asmz=0.119d0

c---------------------------------------------------------------
c---------------------------------------------------------------


      else
          write(6,*) 'Unimplemented distribution= ',pdlabel
          write(6,*) 'Implemented are: ',
     . 'cteq6_m,','cteq6_d,','cteq6_l,','cteq6l1,',
     . 'nn23lo,','nn23lo1,','nn23nlo,'
c
c     make madgraph to stop evaluating
      stop 1
c	   write(6,*) 'Setting it to default cteq6l1'
c       pdlabel='cteq6l1'
c       asmz=0.130d0
c       nloop=1
c       Call SetCtq6(4)
      endif      
      return
      end
 

#!/bin/bash

if [[ "$2" == "" ]];then
    echo "Error: Need run prefix and path to MadAnalysis"
    exit
fi

if [[ "$3" != "" ]];then
    MAdir=$3
else
    MAdir=../../../../MadAnalysis
fi

if [[ ! -e `which root` ]];then
    if [[ ! -e "$ROOTSYS/bin/root" ]];then
        echo "Error: root executable not found"
        exit
    fi
    export PATH=$ROOTSYS/bin:$PATH
fi

if [[ ! -e events.tree || ! -e xsecs.tree ]];then
    echo "No events.tree or xsecs.tree files found"
    exit
fi

echo Creating matching plots
root -q -b -l ../bin/internal/create_matching_plots.C &> /dev/null
mv pythia.root $1/$2_pythia.root

dir=../HTML/$1/plots_pythia_$2

if [[ ! -d  $dir ]];then
  mkdir $dir
fi
for i in DJR*.eps; do mv $i $dir/${i%.*}.ps;done

cd $dir

if [[ ! -d $MAdir ]];then exit; fi

for file in DJR?.ps ; do
  echo ">> Converting file $file" >> log.convert
  $MAdir/epstosmth --gsopt='-r60x60 -dGraphicsAlphaBits=4' --gsdev=jpeg $file
done

#!/bin/bash

# For support of LHAPATH in cluster mode
if [ $CLUSTER_LHAPATH ]; then
  export LHAPATH=$CLUSTER_LHAPATH;
fi

if [[ -e MadLoop5_resources.tar.gz && ! -e MadLoop5_resources ]]; then
tar -xzf MadLoop5_resources.tar.gz
fi
keeplog=%(keeplog)s
if [ "$keeplog" = true ] ; then
    k=%(name)s_app.log
else
    k=/dev/null
fi
script=%(script_name)s                         

grid_directory=%(base_directory)s
j=%(directory)s
     if [[ ! -e $j ]]; then
          mkdir $j
          if [[ -e $grid_directory/ftn26 ]];then
             cp $grid_directory/ftn26 $j/ftn25
          fi 
          if [[ ! -e ../../SubProcesses ]];then
          	 if [[ -e ftn26 ]]; then
          	 	cp ./ftn26 $j/ftn25
          	 fi
          fi	
     fi
     cd $j
     if [ "$keeplog" = true ] ; then
	 rm -f $k
     fi
     rm -f moffset.dat >& /dev/null
      echo   %(offset)s  > moffset.dat
     if  [[ -e ftn26 ]]; then
          cp ftn26 ftn25
     fi
     # create the input file
         echo "    %(nevents)s       %(maxiter)s       %(miniter)s" >& input_sg.txt
         echo "    %(precision)s" >> input_sg.txt
     if [[ ! -e ftn25 ]]; then
         echo "2" >> input_sg.txt   # grid refinement
         echo "1" >> input_sg.txt   # suppress amplitude

     else
         echo "%(grid_refinment)s" >> input_sg.txt
         echo "1" >> input_sg.txt
     fi
     echo "%(nhel)s" >> input_sg.txt
     echo "%(channel)s" >> input_sg.txt

     # run the executable. The loop is design to avoid
     # filesystem problem (executable not found)
     for((try=1;try<=16;try+=1)); 
     do
	 if [ "$keeplog" = true ] ; then
             %(Ppath)s/madevent 2>&1 >> $k <input_sg.txt | tee -a $k;
	     status_code=${PIPESTATUS[0]};
             if [ -s $k ]
             then
		 break
             else
		 echo $try > fail.log 
             fi
	 else
	     %(Ppath)s/madevent 2>&1 >> log.txt <input_sg.txt | tee -a log.txt;
	     status_code=${PIPESTATUS[0]};
	     if [ -s log.txt ]
             then
		 rm log.txt
                 break
             else
                  echo $try > fail.log
             fi
	 fi
     done
     if [[ $status_code -ne 0 ]]; then 
	 rm results.dat
	 echo "ERROR DETECTED"
	 echo "end-code not correct $status_code" > results.dat
     fi     
     if [[ -e ftn26 ]]; then
         cp ftn26 ftn25
     fi

     if [ "$keeplog" = true ] ; then
	 echo "" >> $k; echo "ls status:" >> $k; ls >> $k	 
     else
	 rm ftn26 &> /dev/null
     fi





     cd ../

#!/bin/bash

# For support of LHAPATH in cluster mode
if [ $CLUSTER_LHAPATH ]; then
  export LHAPATH=$CLUSTER_LHAPATH;
fi
if [[ -e MadLoop5_resources.tar.gz && ! -e MadLoop5_resources ]]; then
tar -xzf MadLoop5_resources.tar.gz
fi
k=run1_app.log
script=refine_splitted.sh
# Argument
# 1st argument the Directory name
grid_directory=$1;
# 2st argument Directory where to find the grid input
base_directory=$2; 
# 3st argument the offset
offset=$3;


# prepare the directory where to run
if [[ ! -e $grid_directory ]]; then
    # Do not exists     
    mkdir $grid_directory;
else
   rm -rf $grid_directory/$k;
   rm -rf $grid_directory/input_app.txt;
   rm -rf $grid_directory/ftn25;
   rm -rf $grid_directory/ftn26;
fi
# handle input file
if [[ -e $base_directory ]]; then
    cp $base_directory/ftn26 $grid_directory/ftn25;
    cp $base_directory/input_app.txt $grid_directory/input_app.txt;
elif [[ -e ./ftn26 ]]; then
    cp ./ftn26 $grid_directory/ftn25;
    cp ./input_app.txt $grid_directory/input_app.txt;
else
    exit 1;
fi

# Move to the running directory
cd $grid_directory;

# Put the correct offset
rm -f moffset.dat >& /dev/null;
echo   $offset > moffset.dat;

# run the executable. The loop is design to avoid
# filesystem problem (executable not found)
for((try=1;try<=16;try+=1)); 
do
    ../madevent 2>&1 >> $k <input_app.txt | tee -a $k;
    status_code=${PIPESTATUS[0]};
    if [ -s $k ]
    then
        break
    else
        echo $try > fail.log 
    fi
done
echo "" >> $k; echo "ls status:" >> $k; ls >> $k
# Perform some cleaning to keep less file on disk/transfer less file.
subdir=${grid_directory##*_}
if [[ $subdir -ne 1 &&  -s results.dat && $MG5DEBUG != true ]]; then
	 rm -f ftn25 &> /dev/null
         rm -f ftn26 &> /dev/null
	 rm -f log.txt &> /dev/null
         rm -f *.log &> /dev/null
	 rm -f moffset.dat &> /dev/null
	 rm -f fail.log &> /dev/null
fi
if [[ $status_code -ne 0 ]]; then 
	 rm results.dat
	 echo "ERROR DETECTED"
	 echo "end code not correct $status_code" > results.dat
fi

cd ../

#!/bin/bash

#############################################################################
#                                                                          ##
#                    MadGraph/MadEvent                                     ##
#                                                                          ##
# FILE : run.sh                                                            ##
# VERSION : 1.0                                                            ##
# DATE : 29 January 2008                                                   ##
# AUTHOR : Michel Herquet (UCL-CP3)                                        ##
#                                                                          ##
# DESCRIPTION : script to save command line param in a grid card and       ##
#   call gridrun                                                           ##
# USAGE : run [num_events] [iseed]                                         ##
#############################################################################

if [[ -d ./madevent ]]; then
    DIR='./madevent'
else
    # find the path to the gridpack (https://stackoverflow.com/questions/59895/getting-the-source-directory-of-a-bash-script-from-within)
    SOURCE="${BASH_SOURCE[0]}"
    while [ -h "$SOURCE" ]; do # resolve $SOURCE until the file is no longer a symlink
	DIR="$( cd -P "$( dirname "$SOURCE" )" && pwd )"
	SOURCE="$(readlink "$SOURCE")"
	[[ $SOURCE != /* ]] && SOURCE="$DIR/$SOURCE" # if $SOURCE was a relative symlink, we need to resolve it relative to the path where the symlink file was located
    done
    DIR="$( cd -P "$( dirname "$SOURCE" )" && pwd )/madevent"
fi

# For Linux
export LD_LIBRARY_PATH=${LD_LIBRARY_PATH}:${PWD}/madevent/lib:${PWD}/HELAS/lib
# For Mac OS X
export DYLD_LIBRARY_PATH=${DYLD_LIBRARY_PATH}:${PWD}/madevent/lib:${PWD}/HELAS/lib


if [[  ($1 != "") && ("$2" != "") && ("$3" == "") ]]; then
   num_events=$1
   seed=$2
   gran=1
elif [[  ($1 != "") && ("$2" != "") && ("$3" != "") ]]; then
   num_events=$1
   seed=$2
   gran=$3
else
   echo "Warning: input is not correct. script requires two arguments: NB_EVENT SEED"
fi

echo "Now generating $num_events events with random seed $seed and granularity $gran"

############    RUN THE PYTHON CODE #####################
${DIR}/bin/gridrun $num_events $seed $gran
########################################################

###########    POSTPROCESSING      #####################

if [[ -e ${DIR}/Events/GridRun_${seed}/unweighted_events.lhe.gz ]]; then
    mv ${DIR}/Events/GridRun_${seed}/unweighted_events.lhe.gz events.lhe.gz
else
    mv ./Events/GridRun_${seed}/unweighted_events.lhe.gz events.lhe.gz
    rm -rf Events Cards P* *.dat randinit &> /dev/null
fi
echo "write ./events.lhe.gz"
exit

#!/bin/bash

# For support of LHAPATH in cluster mode
if [ $CLUSTER_LHAPATH ]; then 
  export LHAPATH=$CLUSTER_LHAPATH;
fi

if [[ -e MadLoop5_resources.tar.gz && ! -e MadLoop5_resources ]]; then
tar -xzf MadLoop5_resources.tar.gz;
fi

k=run1_app.log;
script=ajob1;                      
offset=$1;
shift;
subdir=$offset;
for i in $@ ; do
     j=G$i;
     if [[ $offset == *.* ]];then
	 subdir=${offset%.*};
	 offset=${offset##*.};
	 j=G${i}_${subdir};     
     elif [[ $offset -gt 0 ]]; then
	 j=G${i}_${subdir};
     fi
     if [[ ! -e $j ]]; then
         mkdir $j;
     fi
     cd $j;
     if [[ $offset -eq 0 ]]; then
	 rm -f ftn25 ftn26 ftn99;
	 rm -f $k;
     else
	 echo   "$offset"  > moffset.dat;
     fi
     if [[ $offset -eq $subdir ]]; then
	 rm -f ftn25 ftn26 ftn99;
	 rm -f $k;
     else
        if [[ -e ../ftn25 ]]; then
	    cp ../ftn25 .;
	fi
     fi
     if [[ ! -e input_app.txt  ]]; then
	 cat ../input_app.txt >& input_app.txt;
     fi
     echo $i >> input_app.txt;

     for((try=1;try<=10;try+=1)); 
     do
     ../madevent 2>&1 >> $k <input_app.txt | tee -a $k;
     status_code=${PIPESTATUS[0]};
     if [ -s $k ]
     then
         break;
     else
     sleep 1;
     fi
     done
#     rm -f ftn25 ftn99
#     rm -f ftn26
     echo "" >> $k; echo "ls status:" >> $k; ls >> $k;
     cp $k log.txt;
# Perform some cleaning to keep less file on disk/transfer less file.
     if [[ $subdir -ne 1 &&  -s results.dat && $MG5DEBUG -ne true ]]; then
	 rm -f ftn25 &> /dev/null
         rm -f ftn26 &> /dev/null
	 rm -f log.txt &> /dev/null
         rm -f *.log &> /dev/null
	 rm -f moffset.dat &> /dev/null
     fi
     if [[ $status_code -ne 0 ]]; then 
	 rm results.dat
	 echo "ERROR DETECTED"
	 echo "end code not correct $status_code" > results.dat
     fi
     cd ../;

 
done;

# Cleaning 
